! Copyright (c) 2012, Minoru Otani <minoru.otani@aist.go.jp>
! 
! Permission is hereby granted, free of charge, to any person 
! obtaining a copy of this software and associated documentation 
! files (the "Software"), to deal in the Software without restriction, 
! including without limitation the rights to use, copy, modify, merge, 
! publish, distribute, sublicense, and/or sell copies of the Software, 
! and to permit persons to whom the Software is furnished to do so, 
! subject to the following conditions:
 
! The above copyright notice and this permission notice shall be 
! included in all copies or substantial portions of the Software.
 
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
! EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
! OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
! NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
! HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
! WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
! DEALINGS IN THE SOFTWARE.
module m_deb
implicit none
!  ideb( 1)  ! print out bare coulomb term
!  ideb( 2)  ! print charge density
!  ideb( 3)  ! print hartree term
!  ideb( 4)  ! print ion local part
!  ideb( 5)  ! print hartree & ion local part
!  ideb( 6)  ! print classical potential
!  ideb( 7)  ! print hartree & ion local & exc
!  ideb(40)  ! print chrge & hartree & ion local & hartree+ion local
integer,private ::idebug &          ! Total debug swith
                 ,ideb(50)
contains
subroutine esm_deb_initialize(idebug_in)
implicit none
integer,intent(in) ::idebug_in
ideb=0
idebug=idebug_in
if(idebug==0)then
  !no debug print
elseif(idebug==1)then
  ideb( 2)=1  ! print charge density
  ideb( 3)=1  ! print hartree term
  ideb( 4)=1  ! print ion local part
  ideb( 5)=1  ! print hartree & ion local part
  ideb(40)=1  ! print chrge & hartree & ion local & hartree+ion local
elseif(idebug==2)then
  ideb( 2)=1  ! print charge density
  ideb( 3)=1  ! print hartree & ion local part
elseif(idebug==3)then
  ideb( 4)=1  ! print hartree & ion local part
elseif(idebug==4)then
  ideb( 2)=1  ! print charge density
  ideb( 3)=1  ! print hartree term
  ideb( 4)=1  ! print ion local part
  ideb( 5)=1  ! print hartree & ion local part
elseif(idebug==5)then
  ideb( 7)=1  ! print hartree & ion local part
endif
end subroutine esm_deb_initialize

subroutine esm_get_debug_info(ideb_out)
implicit none
integer,intent(out) ::ideb_out(50)
ideb_out=ideb
end subroutine esm_get_debug_info
end module m_deb
