!
! Copyright (c) 2012-2013 Yoshihide Yoshimoto
!
module pfft3d_const
  integer,parameter:: nfmax = 30

  integer,parameter:: nthread = 8
  integer,parameter:: blksz = 12288
end module pfft3d_const

module pfft3d_subr
  use pfft3d_const
  interface
     subroutine fftrd2(nvk,np,w,x,y)
       implicit none
       integer,intent(in):: nvk,np
       real(kind=8),intent(in):: x(2,nvk,np,2)
       real(kind=8),intent(out):: y(2,nvk,2,np)
       real(kind=8),intent(in):: w(2,np)
     end subroutine fftrd2
     !
     subroutine bftrd2(nvk,np,w,x,y)
       implicit none
       integer,intent(in):: nvk,np
       real(kind=8),intent(in):: x(2,nvk,np,2)
       real(kind=8),intent(out):: y(2,nvk,2,np)
       real(kind=8),intent(in):: w(2,np)
     end subroutine bftrd2
     
     subroutine fftrd3(nvk,np,w,x,y)
       implicit none
       integer,intent(in):: nvk,np
       real(kind=8),intent(in):: x(2,nvk,np,3)
       real(kind=8),intent(out):: y(2,nvk,3,np)
       real(kind=8),intent(in):: w(2,2*np)
     end subroutine fftrd3

     subroutine bftrd3(nvk,np,w,x,y)
       implicit none
       integer,intent(in):: nvk,np
       real(kind=8),intent(in):: x(2,nvk,np,3)
       real(kind=8),intent(out):: y(2,nvk,3,np)
       real(kind=8),intent(in):: w(2,2*np)
     end subroutine bftrd3

     subroutine fftrd4(nvk,np,w,x,y)
       implicit none
       integer,intent(in):: nvk,np
       real(kind=8),intent(in):: x(2,nvk,np,4)
       real(kind=8),intent(out):: y(2,nvk,4,np)
       real(kind=8),intent(in):: w(2,3*np)
     end subroutine fftrd4
     !
     subroutine bftrd4(nvk,np,w,x,y)
       implicit none
       integer,intent(in):: nvk,np
       real(kind=8),intent(in):: x(2,nvk,np,4)
       real(kind=8),intent(out):: y(2,nvk,4,np)
       real(kind=8),intent(in):: w(2,3*np)
     end subroutine bftrd4
     
     subroutine fftrd5(nvk,np,w,x,y)
       implicit none
       integer,intent(in):: nvk,np
       real(kind=8),intent(in):: x(2,nvk,np,5)
       real(kind=8),intent(out):: y(2,nvk,5,np)
       real(kind=8),intent(in):: w(2,4*np)
     end subroutine fftrd5
     !
     subroutine bftrd5(nvk,np,w,x,y)
       implicit none
       integer,intent(in):: nvk,np
       real(kind=8),intent(in):: x(2,nvk,np,5)
       real(kind=8),intent(out):: y(2,nvk,5,np)
       real(kind=8),intent(in):: w(2,4*np)
     end subroutine bftrd5

     subroutine fftrd6(nvk,np,w,x,y)
       implicit none
       integer,intent(in):: nvk,np
       real(kind=8),intent(in):: x(2,nvk,np,6)
       real(kind=8),intent(out):: y(2,nvk,6,np)
       real(kind=8),intent(in):: w(2,5*np)
     end subroutine fftrd6
     
     subroutine bftrd6(nvk,np,w,x,y)
       implicit none
       integer,intent(in):: nvk,np
       real(kind=8),intent(in):: x(2,nvk,np,6)
       real(kind=8),intent(out):: y(2,nvk,6,np)
       real(kind=8),intent(in):: w(2,5*np)
     end subroutine bftrd6

     subroutine fft_tpb(lxy,bxy,exy,lz,src,dst)
       implicit none
       integer,intent(in):: lxy,bxy,exy,lz
       real(kind=8),intent(in):: src(2,lxy,lz)
       real(kind=8),intent(out):: dst(2,lz,exy-bxy+1)
     end subroutine fft_tpb
     
     subroutine fft_tpbs(lxy,bxy,exy,lz,src,dst,scl)
       implicit none
       integer,intent(in):: lxy,bxy,exy,lz
       real(kind=8),intent(in):: src(2,lxy,lz),scl
       real(kind=8),intent(out):: dst(2,lz,exy-bxy+1)
     end subroutine fft_tpbs
     
     subroutine fftrd8(nvk,np,w,x,y)
       implicit none
       integer,intent(in):: nvk,np
       real(kind=8),intent(in):: x(2,nvk,np,8)
       real(kind=8),intent(out):: y(2,nvk,8,np)
       real(kind=8),intent(in):: w(2,7*np)
     end subroutine fftrd8
     
     subroutine bftrd8(nvk,np,w,x,y)
       implicit none
       integer,intent(in):: nvk,np
       real(kind=8),intent(in):: x(2,nvk,np,8)
       real(kind=8),intent(out):: y(2,nvk,8,np)
       real(kind=8),intent(in):: w(2,7*np)
     end subroutine bftrd8
  end interface
contains
  !
  subroutine fftib(n,nf,fac,w,lx,lyz,d,e,ix)
    implicit none
    integer,intent(in):: n,lx,lyz
    integer,intent(in):: nf,fac(nfmax)
    real(kind=8),intent(in):: w(2,n)
    real(kind=8),dimension(2,lx,lyz):: d,e
    integer:: ix
    !
    integer:: iw,nvk,np,uif,if,iv
    !
    uif = mod(nf,2)
    do iv=1,lyz
       iw = 1
       nvk = 1
       np = n/fac(1)
       do if = 1,nf-uif,2
          select case (fac(if))
          case (2)
             call fftrd2(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (3)
             call fftrd3(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (4)
             call fftrd4(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (5)
             call fftrd5(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (6)
             call fftrd6(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (8)
             call fftrd8(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case default
             write(6,*)'unsupported factor'
             stop
          end select
          iw=iw+np*(fac(if)-1)
          nvk=nvk*fac(if)
          np=np/fac(if+1)
          select case (fac(if+1))
          case (2)
             call fftrd2(nvk,np,w(1,iw),e(1,1,iv),d(1,1,iv))
          case (3)
             call fftrd3(nvk,np,w(1,iw),e(1,1,iv),d(1,1,iv))
          case (4)
             call fftrd4(nvk,np,w(1,iw),e(1,1,iv),d(1,1,iv))
          case (5)
             call fftrd5(nvk,np,w(1,iw),e(1,1,iv),d(1,1,iv))
          case (6)
             call fftrd6(nvk,np,w(1,iw),e(1,1,iv),d(1,1,iv))
          case (8)
             call fftrd8(nvk,np,w(1,iw),e(1,1,iv),d(1,1,iv))
          case default
             write(6,*)'unsupported factor'
             stop
          end select
          iw=iw+np*(fac(if+1)-1)
          nvk=nvk*fac(if+1)
          if (if+2 .le. nf) then
             np=np/fac(if+2)
          end if
       end do
       if (uif .eq. 1) then
          select case (fac(nf))
          case (2)
             call fftrd2(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (3)
             call fftrd3(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (4)
             call fftrd4(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (5)
             call fftrd5(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (6)
             call fftrd6(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (8)
             call fftrd8(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case default
             write(6,*)'unsupported factor'
             stop
          end select
       end if
    end do
    if (uif .eq. 1) then
       ix = - ix
    end if

    return
  end subroutine fftib
  !
  subroutine bftib(n,nf,fac,w,lx,lyz,d,e,ix)
    implicit none
    integer,intent(in):: n,lx,lyz
    integer,intent(in):: nf,fac(nfmax)
    real(kind=8),intent(in):: w(2,n)
    real(kind=8),dimension(2,lx,lyz):: d,e
    integer:: ix
    !
    integer:: iw,nvk,np,uif,if,iv
    !
    uif = mod(nf,2)
    do iv=1,lyz
       iw = 1
       nvk = 1
       np = n/fac(1)
       do if = 1,nf-uif,2
          select case (fac(if))
          case (2)
             call bftrd2(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (3)
             call bftrd3(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (4)
             call bftrd4(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (5)
             call bftrd5(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (6)
             call bftrd6(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (8)
             call bftrd8(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case default
             write(6,*)'unsupported factor'
             stop
          end select
          iw=iw+np*(fac(if)-1)
          nvk=nvk*fac(if)
          np=np/fac(if+1)
          select case(fac(if+1))
          case (2)
             call bftrd2(nvk,np,w(1,iw),e(1,1,iv),d(1,1,iv))
          case (3)
             call bftrd3(nvk,np,w(1,iw),e(1,1,iv),d(1,1,iv))
          case (4)
             call bftrd4(nvk,np,w(1,iw),e(1,1,iv),d(1,1,iv))
          case (5)
             call bftrd5(nvk,np,w(1,iw),e(1,1,iv),d(1,1,iv))
          case (6)
             call bftrd6(nvk,np,w(1,iw),e(1,1,iv),d(1,1,iv))
          case (8)
             call bftrd8(nvk,np,w(1,iw),e(1,1,iv),d(1,1,iv))
          case default
             write(6,*)'unsupported factor'
             stop
          end select
          iw=iw+np*(fac(if+1)-1)
          nvk=nvk*fac(if+1)
          if (if+2 .le. nf) then
             np=np/fac(if+2)
          end if
       end do
       if (uif .eq. 1) then
          select case (fac(nf))
          case (2)
             call bftrd2(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (3)
             call bftrd3(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (4)
             call bftrd4(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (5)
             call bftrd5(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (6)
             call bftrd6(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case (8)
             call bftrd8(nvk,np,w(1,iw),d(1,1,iv),e(1,1,iv))
          case default
             write(6,*)'unsupported factor'
             stop
          end select
       end if
    end do
    if (uif .eq. 1) then
       ix = - ix
    end if

    return
  end subroutine bftib
  
  subroutine fft_cpb(lxy,bxy,exy,lz,src,dst)
    implicit none
    integer,intent(in):: lxy,bxy,exy,lz
    real(kind=8),intent(in):: src(2*lz,exy-bxy+1)
    real(kind=8),intent(out):: dst(2*lz,lxy)
    integer:: i,j
    !
!ocl nounroll
    do i=bxy,exy
       do j=1,2*lz
          dst(j,i) = src(j,i-bxy+1)
       end do
    end do
    return
  end subroutine fft_cpb
  !
end module pfft3d_subr
