!
! Copyright (c) 2000-2013 Yoshihide Yoshimoto
!
program testio
  use mpi
  implicit none

  integer:: m
  real(kind=8),allocatable:: a(:)
  character(len=256):: ifname

  integer:: ierr
  real(kind=8):: wt0,wt1,wtick
  integer:: comm,myrank,nproc
  real(kind=8):: nop

  call MPI_INIT(ierr)
  comm = MPI_COMM_WORLD
  call MPI_COMM_RANK(comm,myrank,ierr)
  call MPI_COMM_SIZE(comm,nproc,ierr)

  if (myrank .eq. 0) then
     read(5,*) m, ifname
     open(10, file=ifname, status='unknown', action='write', &
          form='unformatted')
     allocate(a(m))
     a = 0.0d0
     write(10) a
     close(10)
     deallocate(a)
  end if
  call MPI_BCAST(m,1,MPI_INTEGER,0,comm,ierr)
  call MPI_BCAST(ifname,256,MPI_CHAR,0,comm,ierr)

  allocate(a(m))

  wtick = MPI_WTICK()
  if (myrank .eq. 0) then
     write(6,*) 'wtick = ', wtick
  end if

  open(10, file=ifname, status='old', action='read', form='unformatted')

  call MPI_BARRIER(comm,ierr)

  wt0 = MPI_WTIME()

  read(10) a

  call MPI_BARRIER(comm,ierr)
  wt1 = MPI_WTIME()

  if (myrank .eq. 0) then
     write(6,*) 'number of MPI proc. = ', nproc
     write(6,*) 'elapsed time per iter = ', (wt1-wt0)
     nop = 8.0d0*m
     write(6,*) nop/(wt1-wt0)*1.0d-6, ' MB/s'
  end if

  call MPI_FINALIZE(ierr)
  stop
end program testio

