! $Id: eval-force.F90,v 1.2 2011/12/10 08:11:38 yosimoto Exp $

#define USE_FORCE_MODULE use dftd2

#define SUBR_FORCE fdftd2

program testforce
  USE_FORCE_MODULE
  use util
  use bsplpot
  implicit none
  integer,parameter:: nsi = 30, nn = 100
  real(kind=8):: aa(3,3) = (/ 10.0d0, 10.0d0,  0.0d0, &
                              10.0d0,  0.0d0, 10.0d0, &
                               0.0d0, 10.0d0, 10.0d0 /)
  real(kind=8):: bb(3,3),aai(3,3)
  real(kind=8):: asi(3,nsi), rcforce(3,nsi), reng, rseng(6)
  real(kind=8):: tforce(3),teng,tseng(6)
  real(kind=8):: tasi(3,nsi),tcforce(3,nsi),taa(3,3), scf(3,3)
  integer:: i,j,k

  integer:: istate = 456214531

  integer,parameter:: nkd = 2, xctp = 1
  integer:: kd(nsi)
  type (bspot_for_atm):: bspots(nkd)
  real(kind=8),parameter:: fdelta = 0.0001d0
  real(kind=8):: dtf, dts

  real(kind=8),parameter:: tpi = 2.0d0*3.14159265358979323846d0

  call recp_uvec(aa,bb)
  aai = transpose(bb)/tpi
  write(6,*) 'aai'
  write(6,*) aai
  kd(:15) = 1
  kd(16:) = 2
  bspots(1)%zn = 2 ! He
  bspots(2)%zn = 10 ! Ne

  do i=1, nn
     
     do j=1,nsi
        do k=1,3
           asi(k,j) = ran0(istate)
        end do
     end do

     call SUBR_FORCE(xctp,nkd,bspots,aa,nsi,kd,asi,reng,rseng,rcforce)

     dtf = 0.0d0
     do j=1,nsi
        do k=1,3
           tasi(:,:) = asi(:,:)
           tasi(:,j) = tasi(:,j) + fdelta*aai(:,k)

           call SUBR_FORCE(xctp,nkd,bspots,aa,nsi,kd,tasi,teng,tseng,tcforce)

           tforce(k) = -(teng - reng)/fdelta
        end do
        dtf = dtf + ( (tforce(1) - rcforce(1,j))**2 &
             + (tforce(2) - rcforce(2,j))**2 &
             + (tforce(3) - rcforce(3,j))**2 ) / &
             ( rcforce(1,j)**2 + rcforce(2,j)**2 + rcforce(3,j)**2 )
     end do
     dtf = sqrt(dtf/nsi)

     dts = 0.0d0
     tasi(:,:) = asi(:,:)

     scf = 0.0d0
     scf(1,1) = 1.0d0/(1.0d0 + fdelta)
     scf(2,2) = 1.0d0
     scf(3,3) = 1.0d0
     taa = matmul(scf,aa(:,:))
     call SUBR_FORCE(xctp,nkd,bspots,taa,nsi,kd,tasi,teng,tseng,tcforce)
     dts = dts + abs( (teng - reng)/fdelta - rseng(1) )  / abs((rseng(1)))

     scf = 0.0d0
     scf(1,1) = 1.0d0
     scf(2,2) = 1.0d0/(1.0d0 + fdelta)
     scf(3,3) = 1.0d0
     taa = matmul(scf,aa(:,:))
     call SUBR_FORCE(xctp,nkd,bspots,taa,nsi,kd,tasi,teng,tseng,tcforce)
     dts = dts + abs( (teng - reng)/fdelta - rseng(2) ) / abs((rseng(2)))

     scf = 0.0d0
     scf(1,1) = 1.0d0
     scf(2,2) = 1.0d0
     scf(3,3) = 1.0d0/(1.0d0 + fdelta)
     taa = matmul(scf,aa(:,:))
     call SUBR_FORCE(xctp,nkd,bspots,taa,nsi,kd,tasi,teng,tseng,tcforce)
     dts = dts + abs( (teng - reng)/fdelta - rseng(3) ) / abs((rseng(3)))

     scf = 0.0d0
     scf(1,1) = 1.0d0
     scf(2,2) = 1.0d0
     scf(3,3) = 1.0d0
     scf(2,3) = - fdelta
     scf(3,2) = - fdelta
     taa = matmul(scf,aa(:,:))
     call SUBR_FORCE(xctp,nkd,bspots,taa,nsi,kd,tasi,teng,tseng,tcforce)
     dts = dts + abs( (teng - reng)/fdelta - rseng(4) )  / abs((rseng(4)))

     scf = 0.0d0
     scf(1,1) = 1.0d0
     scf(2,2) = 1.0d0
     scf(3,3) = 1.0d0
     scf(3,1) = - fdelta
     scf(1,3) = - fdelta
     taa = matmul(scf,aa(:,:))
     call SUBR_FORCE(xctp,nkd,bspots,taa,nsi,kd,tasi,teng,tseng,tcforce)
     dts = dts + abs( (teng - reng)/fdelta - rseng(5) ) / abs((rseng(5)))

     scf = 0.0d0
     scf(1,1) = 1.0d0
     scf(2,2) = 1.0d0
     scf(3,3) = 1.0d0
     scf(1,2) = - fdelta
     scf(2,1) = - fdelta
     taa = matmul(scf,aa(:,:))
     call SUBR_FORCE(xctp,nkd,bspots,taa,nsi,kd,tasi,teng,tseng,tcforce)
     dts = dts + abs( (teng - reng)/fdelta - rseng(6) ) / abs((rseng(6)))

     write(6,'(9(1x,e18.11))') reng, rseng, dtf, dts/6
  end do

  stop
end program
