!
! Copyright (c) 2016,2017 Yoshihide Yoshimoto
!
module uspp_getqy
contains
  subroutine getqy_two_x(qy,ik3,gk,nl,nkc,mll3)
    implicit none
    integer,intent(in):: ik3,nl,nkc
    integer,intent(out):: mll3
    real(kind=8),intent(in):: gk(4,nkc)
    complex(kind=8):: qy(nkc,nl)
    !
    real(kind=8),parameter:: eps = 1.0d-12
    real(kind=8),parameter:: sq2 = sqrt(2.0d0), &
         sq3 = sqrt(3.0d0), sq5 = sqrt(5.0d0), &
         sq6 = sqrt(6.0d0), sq7 = sqrt(7.0d0), &
         sq8 = sqrt(8.0d0), sq10 = sqrt(10.0d0), &
         sq14 = sqrt(14.0d0), &
         sq15 = sqrt(15.0d0), sq21 = sqrt(21.0d0), &
         sq30 = sqrt(30.0d0), sq35 = sqrt(35.0d0), &
         sq42 = sqrt(42.0d0), sq105 = sqrt(105.0d0), &
         sq210 = sqrt(210.0d0)
    !
    integer:: k3
    integer:: ig,ist
    real(kind=8):: x,y,z,r
    complex(kind=8):: iypx, iymx
    !     
    k3 = abs(ik3)
    !
    ! FOR G=0
    if (gk(4,1).lt.eps) then
       qy(1,1:nl) = 0
       select case(k3)
       case (2)
          qy(1,1) = 1
       case (9)
          qy(1,1) = -1.0d0/3.0d0
       case (13)
          qy(1,1) = -sq2/sq3
       case (19)
          qy(1,1) = -sq2/3.0d0
       case (20)
          qy(1,1) = 1/sq3
       case (24)
          qy(1,1) = sq2/3.0d0
       case (27)
          qy(1,1) = 2/3.0d0
       case (32)
          qy(1,1) = sq2/sq3
       case (35)
          qy(1,1) = 1/sq3
       case (54)
          qy(1,1) = -sq3/5.0d0
       case (65)
          qy(1,1) = (-2)/5.0d0
       case (77)
          qy(1,1) = -sq3/5.0d0
       case (87)
          qy(1,1) = -2/sq5
       case (101)
          qy(1,1) = (-2.0d0)*sq3/5.0d0
       case (104)
          qy(1,1) = 1/sq5
       case (114)
          qy(1,1) = sq2/5.0d0
       case (116)
          qy(1,1) = -sq6/5.0d0
       case (119)
          qy(1,1) = 2.0d0*sq2/5.0d0
       case (130)
          qy(1,1) = sq6/5.0d0
       case (132)
          qy(1,1) = -sq2/5.0d0
       case (135)
          qy(1,1) = 3/5.0d0
       case (147)
          qy(1,1) = 2.0d0*sq3/5.0d0
       case (152)
          qy(1,1) = 2.0d0*sq2/5.0d0
       case (165)
          qy(1,1) = 2/sq5
       case (170)
          qy(1,1) = 1/sq5
       case (209)
          qy(1,1) = -sq5/7.0d0
       case (230)
          qy(1,1) = (-2.0d0)*sq2/7.0d0
       case (252)
          qy(1,1) = (-3)/7.0d0
       case (275)
          qy(1,1) = (-2.0d0)*sq2/7.0d0
       case (299)
          qy(1,1) = -sq5/7.0d0
       case (319)
          qy(1,1) = -sq6/sq7
       case (345)
          qy(1,1) = -sq30/7.0d0
       case (350)
          qy(1,1) = 1/sq7
       case (370)
          qy(1,1) = sq2/7.0d0
       case (372)
          qy(1,1) = (-2.0d0)*sq5/7.0d0
       case (377)
          qy(1,1) = 2.0d0*sq3/7.0d0
       case (398)
          qy(1,1) = sq6/7.0d0
       case (400)
          qy(1,1) = (-2.0d0)*sq3/7.0d0
       case (405)
          qy(1,1) = sq15/7.0d0
       case (427)
          qy(1,1) = 2.0d0*sq3/7.0d0
       case (429)
          qy(1,1) = -sq6/7.0d0
       case (434)
          qy(1,1) = 4/7.0d0
       case (457)
          qy(1,1) = 2.0d0*sq5/7.0d0
       case (459)
          qy(1,1) = -sq2/7.0d0
       case (464)
          qy(1,1) = sq15/7.0d0
       case (488)
          qy(1,1) = sq30/7.0d0
       case (495)
          qy(1,1) = 2.0d0*sq3/7.0d0
       case (520)
          qy(1,1) = sq6/sq7
       case (527)
          qy(1,1) = 1/sq7
       end select
       ist=2
    else
       ist=1
    end if

    select case(k3)
    case (1)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (2)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1
       end do
    case (3)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (4)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx
       end do
    case (5)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = z
       end do
    case (6)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -(iypx-iymx)*z
       end do
    case (7)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -z
       end do
    case (8)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx
       end do
    case (9)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -1.0d0/3.0d0
          qy(ig,2) = -(3*z**2-3*iymx**2-1)/3.0d0
       end do
    case (10)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (iypx-iymx)*z
       end do
    case (11)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (12)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx*sq3/sq2
       end do
    case (13)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq2/sq3
          qy(ig,2) = (3*z**2-1)/sq6
       end do
    case (14)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx*sq3*z/sq2
       end do
    case (15)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (16)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx/sq2
       end do
    case (17)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq2*z
       end do
    case (18)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (iypx+2*iymx)*z/sq2
       end do
    case (19)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq2/3.0d0
          qy(ig,2) = -(6*z**2+3*iypx**2-2)/sq2/3.0d0
       end do
    case (20)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1/sq3
          qy(ig,2) = -(3*z**2-1)/sq3/2.0d0
       end do
    case (21)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (iypx-iymx)*z
       end do
    case (22)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq2*z
       end do
    case (23)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx/sq2
       end do
    case (24)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq2/3.0d0
          qy(ig,2) = (6*z**2+3*iymx**2-2)/sq2/3.0d0
       end do
    case (25)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -(2*iypx+iymx)*z/sq2
       end do
    case (26)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx*sq3*z
       end do
    case (27)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2/3.0d0
          qy(ig,2) = (12*z**2-3*iymx**2-4)/6.0d0
       end do
    case (28)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -(iypx-iymx)*z
       end do
    case (29)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx*sq3/sq2
       end do
    case (30)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (31)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx*sq3*z/sq2
       end do
    case (32)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq2/sq3
          qy(ig,2) = -(3*z**2-1)/sq6
       end do
    case (33)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx**2/2.0d0
       end do
    case (34)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx*sq3*z
       end do
    case (35)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1/sq3
          qy(ig,2) = -(3*z**2-1)/sq3/2.0d0
       end do
    case (36)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (37)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx**2*sq6/2.0d0
       end do
    case (38)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3*iypx*z/sq6
       end do
    case (39)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq6*z/5.0d0
          qy(ig,2) = 3.0d0*sq2*z*(5*z**2-5*iypx**2-3)/(10.0d0*sq3)
       end do
    case (40)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx*sq3/sq2/5.0d0
          qy(ig,2) = -iypx*sq3*(5*z**2-5*iypx**2-1)/sq2/5.0d0
       end do
    case (41)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*iypx/5.0d0
          qy(ig,2) = 3.0d0*iypx*(5*z**2-1)/10.0d0
       end do
    case (42)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq3*z/5.0d0
          qy(ig,2) = -sq3*z*(5*z**2+10*iypx**2-3)/10.0d0
       end do
    case (43)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx*sq3/5.0d0
          qy(ig,2) = iypx*sq3*(10*z**2+5*iypx**2-2)/10.0d0
       end do
    case (44)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iypx**2*z/2.0d0
       end do
    case (45)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-6.0d0)*(iypx-iymx)*z/7.0d0
          qy(ig,3) = 3.0d0*(iypx-iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (46)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -3*iypx*z/sq2
       end do
    case (47)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (3*z**2-1)/sq2
       end do
    case (48)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -(3*iypx+2*iymx)/sq2/5.0d0
          qy(ig,2) = (-3.0d0)*(iypx-iymx)*(5*z**2-1)/(5.0d0*sq2)
       end do
    case (49)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq2*z/5.0d0
          qy(ig,2) = (-3.0d0)*z*(5*z**2-5*iypx**2-3)/(5.0d0*sq2)
       end do
    case (50)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*sq3*z/5.0d0
          qy(ig,2) = 3.0d0*sq3*z*(5*z**2-3)/10.0d0
       end do
    case (51)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -(3*iypx-iymx)/5.0d0
          qy(ig,2) = (-3.0d0)*(2*iypx+iymx)*(5*z**2-1)/10.0d0
       end do
    case (52)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 4.0d0*z/5.0d0
          qy(ig,2) = 3.0d0*z*(10*z**2+5*iypx**2-6)/10.0d0
       end do
    case (53)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx*sq3/5.0d0
          qy(ig,2) = (-3.0d0)*iypx*sq3*(5*z**2-1)/10.0d0
       end do
    case (54)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq3/5.0d0
          qy(ig,2) = -sq3*(3*z**2-4*iymx**2-1)/14.0d0
          qy(ig,3) = 3.0d0*sq3*(35*z**4-35*iymx**2*z**2-30*z**2+5*iymx**2+3)/70.0d0
       end do
    case (55)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*(iypx-iymx)*z/7.0d0
          qy(ig,3) = (-9.0d0)*(iypx-iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (56)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -(3*z**2-1)/sq2
       end do
    case (57)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3*iymx*z/sq2
       end do
    case (58)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq2*z/5.0d0
          qy(ig,2) = (-3.0d0)*z*(5*z**2-5*iymx**2-3)/(5.0d0*sq2)
       end do
    case (59)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -(2*iypx+3*iymx)/sq2/5.0d0
          qy(ig,2) = 3.0d0*(iypx-iymx)*(5*z**2-1)/(5.0d0*sq2)
       end do
    case (60)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx*sq3/5.0d0
          qy(ig,2) = 3.0d0*iymx*sq3*(5*z**2-1)/10.0d0
       end do
    case (61)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-4.0d0)*z/5.0d0
          qy(ig,2) = (-3.0d0)*z*(10*z**2+5*iymx**2-6)/10.0d0
       end do
    case (62)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -(iypx-3*iymx)/5.0d0
          qy(ig,2) = 3.0d0*(iypx+2*iymx)*(5*z**2-1)/10.0d0
       end do
    case (63)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*sq3*z/5.0d0
          qy(ig,2) = (-3.0d0)*sq3*z*(5*z**2-3)/10.0d0
       end do
    case (64)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx*sq3*z/7.0d0
          qy(ig,3) = 3.0d0*iymx*sq3*z*(7*z**2-7*iymx**2-3)/14.0d0
       end do
    case (65)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2)/5.0d0
          qy(ig,2) = -(12*z**2-9*iymx**2-4)/14.0d0
          qy(ig,3) = (-9.0d0)*(35*z**4-35*iymx**2*z**2-30*z**2+5*iymx**2+3)/70.0d0
       end do
    case (66)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*(iypx-iymx)*z/7.0d0
          qy(ig,3) = 9.0d0*(iypx-iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (67)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -3*iymx*z/sq6
       end do
    case (68)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3*iymx**2/sq6
       end do
    case (69)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx/(5.0d0*sq6)
          qy(ig,2) = -iymx*sq6*(5*z**2-5*iymx**2-1)/10.0d0
       end do
    case (70)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq6*z/5.0d0
          qy(ig,2) = 3.0d0*z*(5*z**2-5*iymx**2-3)/(5.0d0*sq6)
       end do
    case (71)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx**2*z/2.0d0
       end do
    case (72)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx*sq3/5.0d0
          qy(ig,2) = -iymx*sq3*(10*z**2+5*iymx**2-2)/10.0d0
       end do
    case (73)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq3*z/5.0d0
          qy(ig,2) = sq3*z*(5*z**2+10*iymx**2-3)/10.0d0
       end do
    case (74)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*iymx/5.0d0
          qy(ig,2) = (-3.0d0)*iymx*(5*z**2-1)/10.0d0
       end do
    case (75)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx**2/14.0d0
          qy(ig,3) = 3.0d0*iymx**2*(7*z**2-7*iymx**2-1)/14.0d0
       end do
    case (76)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx*sq3*z/7.0d0
          qy(ig,3) = (-3.0d0)*iymx*sq3*z*(7*z**2-7*iymx**2-3)/14.0d0
       end do
    case (77)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq3/5.0d0
          qy(ig,2) = -sq3*(3*z**2-4*iymx**2-1)/14.0d0
          qy(ig,3) = 3.0d0*sq3*(35*z**4-35*iymx**2*z**2-30*z**2+5*iymx**2+3)/70.0d0
       end do
    case (78)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 6.0d0*(iypx-iymx)*z/7.0d0
          qy(ig,3) = (-3.0d0)*(iypx-iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (79)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (80)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx**2*sq30/4.0d0
       end do
    case (81)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx*sq30/5.0d0
          qy(ig,2) = iypx*sq30*(5*z**2-1)/20.0d0
       end do
    case (82)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-15.0d0)*iypx**2*z/(2.0d0*sq30)
       end do
    case (83)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (84)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx*sq15/5.0d0
          qy(ig,2) = -iypx*sq15*(5*z**2-1)/20.0d0
       end do
    case (85)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq15*z/2.0d0
       end do
    case (86)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iypx**3*sq5/4.0d0
       end do
    case (87)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -2/sq5
          qy(ig,2) = 2.0d0*sq5*(3*z**2-1)/7.0d0
          qy(ig,3) = (-3.0d0)*(35*z**4-30*z**2+3)/(28.0d0*sq5)
       end do
    case (88)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iypx*sq15*z/7.0d0
          qy(ig,3) = 3.0d0*iypx*sq15*z*(7*z**2-3)/28.0d0
       end do
    case (89)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq15/7.0d0
          qy(ig,3) = (-3.0d0)*iypx**2*sq15*(7*z**2-1)/28.0d0
       end do
    case (90)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iypx**3*sq5*z/4.0d0
       end do
    case (91)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
       end do
    case (92)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx**2*sq6/4.0d0
       end do
    case (93)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx*sq6*z
       end do
    case (94)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq6*z/5.0d0
          qy(ig,2) = 3.0d0*z*(20*z**2+5*iypx**2-12)/(10.0d0*sq6)
       end do
    case (95)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx*sq6/5.0d0
          qy(ig,2) = -iypx*sq6*(20*z**2+5*iypx**2-4)/20.0d0
       end do
    case (96)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx/5.0d0
          qy(ig,2) = (-3.0d0)*iypx*(5*z**2-1)/20.0d0
       end do
    case (97)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*sq3*z/5.0d0
          qy(ig,2) = -sq3*z*(10*z**2-5*iypx**2-6)/10.0d0
       end do
    case (98)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*iypx*sq3/5.0d0
          qy(ig,2) = iypx*sq3*(40*z**2-5*iypx**2-8)/20.0d0
       end do
    case (99)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -3*iypx**2*z
       end do
    case (100)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*(iypx+4*iymx)*z/7.0d0
          qy(ig,3) = (-3.0d0)*(iypx+4*iymx)*z*(7*z**2-3)/28.0d0
       end do
    case (101)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq3/5.0d0
          qy(ig,2) = -sq3*(3*z**2+iypx**2-1)/7.0d0
          qy(ig,3) = 3.0d0*sq3*(140*z**4+35*iypx**2*z**2-120*z**2-5*iypx**2+12)/140.0d0
       end do
    case (102)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*iypx*sq3*z/7.0d0
          qy(ig,3) = (-3.0d0)*iypx*sq3*z*(28*z**2+7*iypx**2-12)/28.0d0
       end do
    case (103)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iypx**2/7.0d0
          qy(ig,3) = 3.0d0*iypx**2*(28*z**2+7*iypx**2-4)/28.0d0
       end do
    case (104)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1/sq5
          qy(ig,2) = -sq5*(3*z**2-1)/7.0d0
          qy(ig,3) = 3.0d0*(35*z**4-30*z**2+3)/(56.0d0*sq5)
       end do
    case (105)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 6.0d0*(iypx-iymx)*z/7.0d0
          qy(ig,3) = (-3.0d0)*(iypx-iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (106)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx*sq3*z
       end do
    case (107)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq3*(3*z**2-1)/2.0d0
       end do
    case (108)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (iypx-iymx)*sq3/5.0d0
          qy(ig,2) = (2*iypx+3*iymx)*sq3*(5*z**2-1)/10.0d0
       end do
    case (109)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq3*z/5.0d0
          qy(ig,2) = -sq3*z*(15*z**2+10*iypx**2-9)/10.0d0
       end do
    case (110)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*sq2*z/5.0d0
          qy(ig,2) = (-3.0d0)*z*(5*z**2-3)/(5.0d0*sq2)
       end do
    case (111)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (2*iypx+iymx)*sq3/sq2/5.0d0
          qy(ig,2) = (4*iypx-3*iymx)*sq3*(5*z**2-1)/sq2/10.0d0
       end do
    case (112)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*sq6*z/5.0d0
          qy(ig,2) = sq3*z*(15*z**2-5*iypx**2-9)/sq2/5.0d0
       end do
    case (113)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx/(5.0d0*sq2)
          qy(ig,2) = (-9.0d0)*iypx*(5*z**2-1)/(10.0d0*sq2)
       end do
    case (114)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq2/5.0d0
          qy(ig,2) = (3*z**2+6*iymx**2-1)/sq2/7.0d0
          qy(ig,3) = (-3.0d0)*(70*z**4+105*iymx**2*z**2-60*z**2-15*iymx**2+6)/(70.0d0*sq2)
       end do
    case (115)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (2*iypx+3*iymx)*sq3*z/sq2/7.0d0
          qy(ig,3) = 3.0d0*(2*iypx+3*iymx)*sq3*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (116)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq6/5.0d0
          qy(ig,2) = -sq3*(6*z**2+3*iypx**2-2)/sq2/7.0d0
          qy(ig,3) = (-3.0d0)*sq3*(105*z**4+70*iypx**2*z**2-90*z**2-10*iypx**2+9)/(70.0d0*sq2)
       end do
    case (117)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iypx*z/(7.0d0*sq2)
          qy(ig,3) = 3.0d0*iypx*z*(21*z**2+14*iypx**2-9)/(14.0d0*sq2)
       end do
    case (118)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx*sq10*z/7.0d0
          qy(ig,3) = 3.0d0*iymx*sq10*z*(7*z**2-3)/28.0d0
       end do
    case (119)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*sq2/5.0d0
          qy(ig,2) = (6*z**2-3*iymx**2-2)/sq2/7.0d0
          qy(ig,3) = (-3.0d0)*(280*z**4-105*iymx**2*z**2-240*z**2+15*iymx**2+24)/(140.0d0*sq2)
       end do
    case (120)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*(iypx-iymx)*z/7.0d0
          qy(ig,3) = 9.0d0*(iypx-iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (121)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq3*(3*z**2-1)/2.0d0
       end do
    case (122)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx*sq3*z
       end do
    case (123)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*sq3*z/5.0d0
          qy(ig,2) = sq3*z*(15*z**2+10*iymx**2-9)/10.0d0
       end do
    case (124)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (iypx-iymx)*sq3/5.0d0
          qy(ig,2) = -(3*iypx+2*iymx)*sq3*(5*z**2-1)/10.0d0
       end do
    case (125)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx/(5.0d0*sq2)
          qy(ig,2) = (-9.0d0)*iymx*(5*z**2-1)/(10.0d0*sq2)
       end do
    case (126)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*sq6*z/5.0d0
          qy(ig,2) = sq2*sq3*z*(15*z**2-5*iymx**2-9)/10.0d0
       end do
    case (127)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (iypx+2*iymx)*sq3/sq2/5.0d0
          qy(ig,2) = -(3*iypx-4*iymx)*sq3*(5*z**2-1)/sq2/10.0d0
       end do
    case (128)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*sq2*z/5.0d0
          qy(ig,2) = (-3.0d0)*z*(5*z**2-3)/(5.0d0*sq2)
       end do
    case (129)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx*z/(7.0d0*sq2)
          qy(ig,3) = (-3.0d0)*iymx*z*(21*z**2+14*iymx**2-9)/(14.0d0*sq2)
       end do
    case (130)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq6/5.0d0
          qy(ig,2) = sq3*(6*z**2+3*iymx**2-2)/sq2/7.0d0
          qy(ig,3) = 3.0d0*sq3*(105*z**4+70*iymx**2*z**2-90*z**2-10*iymx**2+9)/(70.0d0*sq2)
       end do
    case (131)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*(3*iypx+2*iymx)*z/(7.0d0*sq6)
          qy(ig,3) = (-3.0d0)*(3*iypx+2*iymx)*sq6*z*(7*z**2-3)/28.0d0
       end do
    case (132)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq2/5.0d0
          qy(ig,2) = -(3*z**2+6*iypx**2-1)/sq2/7.0d0
          qy(ig,3) = 3.0d0*(70*z**4+105*iypx**2*z**2-60*z**2-15*iypx**2+6)/(70.0d0*sq2)
       end do
    case (133)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx**2*sq10/14.0d0
          qy(ig,3) = 9.0d0*iymx**2*sq10*(7*z**2-1)/56.0d0
       end do
    case (134)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx*sq2*z/7.0d0
          qy(ig,3) = (-3.0d0)*iymx*z*(42*z**2-7*iymx**2-18)/(14.0d0*sq2)
       end do
    case (135)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3/5.0d0
          qy(ig,2) = 3.0d0*(3*z**2-iymx**2-1)/7.0d0
          qy(ig,3) = 3.0d0*(315*z**4-140*iymx**2*z**2-270*z**2+20*iymx**2+27)/140.0d0
       end do
    case (136)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*(iypx-iymx)*z/7.0d0
          qy(ig,3) = (-9.0d0)*(iypx-iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (137)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx*sq6*z
       end do
    case (138)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx**2/(2.0d0*sq6)
       end do
    case (139)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx*sq6/5.0d0
          qy(ig,2) = iymx*sq6*(20*z**2+5*iymx**2-4)/20.0d0
       end do
    case (140)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*sq6*z/5.0d0
          qy(ig,2) = (-3.0d0)*z*(20*z**2+5*iymx**2-12)/(10.0d0*sq6)
       end do
    case (141)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -3*iymx**2*z
       end do
    case (142)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*iymx*sq3/5.0d0
          qy(ig,2) = iymx*sq3*(40*z**2-5*iymx**2-8)/20.0d0
       end do
    case (143)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*sq3*z/5.0d0
          qy(ig,2) = -sq3*z*(10*z**2-5*iymx**2-6)/10.0d0
       end do
    case (144)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx/5.0d0
          qy(ig,2) = (-3.0d0)*iymx*(5*z**2-1)/20.0d0
       end do
    case (145)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx**2/7.0d0
          qy(ig,3) = (-3.0d0)*iymx**2*(28*z**2+7*iymx**2-4)/28.0d0
       end do
    case (146)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 2.0d0*iymx*sq3*z/7.0d0
          qy(ig,3) = 3.0d0*iymx*sq3*z*(28*z**2+7*iymx**2-12)/28.0d0
       end do
    case (147)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*sq3/5.0d0
          qy(ig,2) = sq3*(3*z**2+iymx**2-1)/7.0d0
          qy(ig,3) = (-3.0d0)*sq3*(140*z**4+35*iymx**2*z**2-120*z**2-5*iymx**2+12)/140.0d0
       end do
    case (148)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*(4*iypx+iymx)*z/7.0d0
          qy(ig,3) = 3.0d0*(4*iypx+iymx)*z*(7*z**2-3)/28.0d0
       end do
    case (149)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iymx**3*sq5*z/2.0d0
       end do
    case (150)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-6.0d0)*iymx**2/7.0d0
          qy(ig,3) = (-3.0d0)*iymx**2*(112*z**2-7*iymx**2-16)/56.0d0
       end do
    case (151)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx*sq2*z/7.0d0
          qy(ig,3) = 3.0d0*iymx*z*(42*z**2-7*iymx**2-18)/(14.0d0*sq2)
       end do
    case (152)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*sq2/5.0d0
          qy(ig,2) = (6*z**2-3*iymx**2-2)/sq2/7.0d0
          qy(ig,3) = (-3.0d0)*(280*z**4-105*iymx**2*z**2-240*z**2+15*iymx**2+24)/(140.0d0*sq2)
       end do
    case (153)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-6.0d0)*(iypx-iymx)*z/7.0d0
          qy(ig,3) = 3.0d0*(iypx-iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (154)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx**2*sq5/(2.0d0*sq6)
       end do
    case (155)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (156)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx**2*sq5*z/(2.0d0*sq6)
       end do
    case (157)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx*sq6/sq5
          qy(ig,2) = -iymx*sq6*(5*z**2-1)/sq5/4.0d0
       end do
    case (158)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx**3*sq5/4.0d0
       end do
    case (159)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq15*z/2.0d0
       end do
    case (160)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3*iymx/sq15
          qy(ig,2) = (-3.0d0)*iymx*(5*z**2-1)/(4.0d0*sq15)
       end do
    case (161)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (162)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iymx**3*sq5*z/4.0d0
       end do
    case (163)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq15/7.0d0
          qy(ig,3) = 3.0d0*iymx**2*sq15*(7*z**2-1)/28.0d0
       end do
    case (164)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx*sq15*z/7.0d0
          qy(ig,3) = (-3.0d0)*iymx*sq15*z*(7*z**2-3)/28.0d0
       end do
    case (165)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2/sq5
          qy(ig,2) = (-2.0d0)*sq5*(3*z**2-1)/7.0d0
          qy(ig,3) = 3.0d0*(35*z**4-30*z**2+3)/(28.0d0*sq5)
       end do
    case (166)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iymx**4/8.0d0
       end do
    case (167)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iymx**3*sq5*z/2.0d0
       end do
    case (168)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx**2*sq5/(7.0d0*sq2)
          qy(ig,3) = 9.0d0*iymx**2*sq5*(7*z**2-1)/(28.0d0*sq2)
       end do
    case (169)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx*sq10*z/7.0d0
          qy(ig,3) = (-3.0d0)*iymx*sq5*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (170)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1/sq5
          qy(ig,2) = -sq5*(3*z**2-1)/7.0d0
          qy(ig,3) = 3.0d0*(35*z**4-30*z**2+3)/(56.0d0*sq5)
       end do
    case (171)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
       end do
    case (172)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx**3*sq5/(2.0d0*sq6)
       end do
    case (173)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx**2*sq30*z/4.0d0
       end do
    case (174)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx*sq30*z/7.0d0
          qy(ig,2) = 3.0d0*iypx*sq5*z*(7*z**2-7*iypx**2-3)/(14.0d0*sq6)
       end do
    case (175)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx**2*sq30/28.0d0
          qy(ig,2) = -iypx**2*sq30*(7*z**2-7*iypx**2-1)/28.0d0
       end do
    case (176)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iypx**2*sq5/14.0d0
          qy(ig,2) = 3.0d0*iypx**2*sq5*(7*z**2-1)/28.0d0
       end do
    case (177)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx*sq15*z/7.0d0
          qy(ig,2) = -iypx*sq15*z*(7*z**2+14*iypx**2-3)/28.0d0
       end do
    case (178)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx**2*sq15/14.0d0
          qy(ig,2) = iypx**2*sq15*(14*z**2+7*iypx**2-2)/28.0d0
       end do
    case (179)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iypx**3*sq5*z/4.0d0
       end do
    case (180)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*z/(7.0d0*sq5)
          qy(ig,2) = z*(20*z**2-15*iypx**2-12)/sq5/6.0d0
          qy(ig,3) = -sq5*z*(63*z**4-63*iypx**2*z**2-70*z**2+21*iypx**2+15)/84.0d0
       end do
    case (181)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx*sq3/(7.0d0*sq5)
          qy(ig,2) = -iypx*sq3*(15*z**2-10*iypx**2-3)/sq5/12.0d0
          qy(ig,3) = iypx*sq15*(63*z**4-63*iypx**2*z**2-42*z**2+7*iypx**2+3)/84.0d0
       end do
    case (182)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = -iypx**2*sq15*z*(3*z**2-3*iypx**2-1)/4.0d0
       end do
    case (183)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3*sq5/12.0d0
          qy(ig,3) = iypx**3*sq5*(9*z**2-9*iypx**2-1)/12.0d0
       end do
    case (184)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iypx/7.0d0
          qy(ig,2) = iypx*(5*z**2-1)/2.0d0
          qy(ig,3) = (-5.0d0)*iypx*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (185)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*z/(7.0d0*sq5)
          qy(ig,2) = -z*(5*z**2+15*iypx**2-3)/sq5/3.0d0
          qy(ig,3) = sq5*z*(63*z**4+252*iypx**2*z**2-70*z**2-84*iypx**2+15)/168.0d0
       end do
    case (186)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx*sq2/(7.0d0*sq5)
          qy(ig,2) = iypx*(5*z**2+5*iypx**2-1)/sq10/2.0d0
          qy(ig,3) = -iypx*sq10*(42*z**4+63*iypx**2*z**2-28*z**2-7*iypx**2+2)/56.0d0
       end do
    case (187)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iypx**2*sq2*z*(3*z**2+2*iypx**2-1)/(8.0d0*sq5)
       end do
    case (188)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**3*sq5/6.0d0
          qy(ig,3) = -iypx**3*sq5*(36*z**2+9*iypx**2-4)/24.0d0
       end do
    case (189)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iypx**4*z/8.0d0
       end do
    case (190)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*(iypx-iymx)*z/7.0d0
          qy(ig,3) = 45.0d0*(iypx-iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = (-5.0d0)*(iypx-iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (191)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-5.0d0)*iypx**2*sq6*z/4.0d0
       end do
    case (192)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx*sq3*(5*z**2-1)/sq2/2.0d0
       end do
    case (193)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq6*(12*z**2+5*iypx**2-4)/28.0d0
          qy(ig,2) = sq3*(35*z**4-35*iypx**2*z**2-30*z**2+5*iypx**2+3)/sq2/14.0d0
       end do
    case (194)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*iypx*sq6*z/7.0d0
          qy(ig,2) = (-5.0d0)*iypx*sq3*z*(7*z**2-7*iypx**2-3)/(14.0d0*sq2)
       end do
    case (195)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-15.0d0)*iypx*z/7.0d0
          qy(ig,2) = 15.0d0*iypx*z*(7*z**2-3)/28.0d0
       end do
    case (196)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq3*(6*z**2-5*iypx**2-2)/14.0d0
          qy(ig,2) = -sq3*(35*z**4+70*iypx**2*z**2-30*z**2-10*iypx**2+3)/28.0d0
       end do
    case (197)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 4.0d0*iypx*sq3*z/7.0d0
          qy(ig,2) = 5.0d0*iypx*sq3*z*(14*z**2+7*iypx**2-6)/28.0d0
       end do
    case (198)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx**2/14.0d0
          qy(ig,2) = (-15.0d0)*iypx**2*(7*z**2-1)/28.0d0
       end do
    case (199)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*(5*iypx+2*iymx)/35.0d0
          qy(ig,2) = -(5*iypx-8*iymx)*(5*z**2-1)/20.0d0
          qy(ig,3) = 5.0d0*(iypx-iymx)*(21*z**4-14*z**2+1)/28.0d0
       end do
    case (200)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-12.0d0)*sq3*z/35.0d0
          qy(ig,2) = -z*(5*z**2-3)/sq3/5.0d0
          qy(ig,3) = 5.0d0*z*(63*z**4-63*iypx**2*z**2-70*z**2+21*iypx**2+15)/(28.0d0*sq3)
       end do
    case (201)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*iypx*sq3/35.0d0
          qy(ig,2) = -iypx*(30*z**2-25*iypx**2-6)/sq3/20.0d0
          qy(ig,3) = (-5.0d0)*iypx*(63*z**4-63*iypx**2*z**2-42*z**2+7*iypx**2+3)/(28.0d0*sq3)
       end do
    case (202)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*z/2.0d0
          qy(ig,3) = 5.0d0*iypx**2*z*(3*z**2-3*iypx**2-1)/4.0d0
       end do
    case (203)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*sq5*z/7.0d0
          qy(ig,2) = sq5*z*(5*z**2-3)/3.0d0
          qy(ig,3) = (-5.0d0)*sq5*z*(63*z**4-70*z**2+15)/168.0d0
       end do
    case (204)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*(10*iypx-iymx)/35.0d0
          qy(ig,2) = -(5*iypx+2*iymx)*(5*z**2-1)/10.0d0
          qy(ig,3) = 5.0d0*(4*iypx+iymx)*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (205)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 12.0d0*sq2*z/35.0d0
          qy(ig,2) = sq2*z*(5*z**2-3)/15.0d0
          qy(ig,3) = (-5.0d0)*z*(126*z**4+189*iypx**2*z**2-140*z**2-63*iypx**2+30)/(84.0d0*sq2)
       end do
    case (206)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*iypx*sq2/35.0d0
          qy(ig,2) = iypx*(45*z**2+25*iypx**2-9)/sq2/30.0d0
          qy(ig,3) = 5.0d0*iypx*(189*z**4+126*iypx**2*z**2-126*z**2-14*iypx**2+9)/(84.0d0*sq2)
       end do
    case (207)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**2*z
          qy(ig,3) = (-5.0d0)*iypx**2*z*(12*z**2+3*iypx**2-4)/8.0d0
       end do
    case (208)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**3*sq5/6.0d0
          qy(ig,3) = 5.0d0*iypx**3*sq5*(3*z-1)*(3*z+1)/24.0d0
       end do
    case (209)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq5/7.0d0
          qy(ig,2) = iymx**2*sq5/7.0d0
          qy(ig,3) = 3.0d0*sq5*(245*z**4-252*iymx**2*z**2-210*z**2+36*iymx**2+21)/616.0d0
          qy(ig,4) = (-5.0d0)*sq5*(231*z**6-231*iymx**2*z**4-315*z**4+126*iymx**2*z**2+105*z**2-7*iymx**2-5)/616.0d0
       end do
    case (210)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*(iypx-iymx)*z/7.0d0
          qy(ig,3) = (-30.0d0)*(iypx-iymx)*z*(7*z**2-3)/77.0d0
          qy(ig,4) = 25.0d0*(iypx-iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (211)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx*sq3*(5*z**2-1)/2.0d0
       end do
    case (212)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq3*z*(5*z**2-3)/2.0d0
       end do
    case (213)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -(4*iypx+3*iymx)*sq3*z/7.0d0
          qy(ig,2) = (-5.0d0)*(iypx-iymx)*sq3*z*(7*z**2-3)/14.0d0
       end do
    case (214)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq3*(9*z**2+2*iypx**2-3)/14.0d0
          qy(ig,2) = -sq3*(35*z**4-35*iypx**2*z**2-30*z**2+5*iypx**2+3)/14.0d0
       end do
    case (215)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*sq2*(3*z**2-1)/7.0d0
          qy(ig,2) = 3.0d0*(35*z**4-30*z**2+3)/(14.0d0*sq2)
       end do
    case (216)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -(8*iypx-3*iymx)*sq3*z/sq2/7.0d0
          qy(ig,2) = (-5.0d0)*(2*iypx+iymx)*sq3*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (217)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq3*(9*z**2-iypx**2-3)/sq2/7.0d0
          qy(ig,2) = sq3*(70*z**4+35*iypx**2*z**2-60*z**2-5*iypx**2+6)/sq2/14.0d0
       end do
    case (218)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*iypx*z/(7.0d0*sq2)
          qy(ig,2) = (-15.0d0)*iypx*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (219)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-12.0d0)*sq2*z/35.0d0
          qy(ig,2) = -sq2*z*(5*z**2-15*iymx**2-3)/15.0d0
          qy(ig,3) = 5.0d0*z*(63*z**4-63*iymx**2*z**2-70*z**2+21*iymx**2+15)/(42.0d0*sq2)
       end do
    case (220)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*(4*iypx+3*iymx)*sq3/(35.0d0*sq2)
          qy(ig,2) = -(2*iypx-iymx)*sq3*(5*z**2-1)/sq2/10.0d0
          qy(ig,3) = (-5.0d0)*(iypx-iymx)*sq3*(21*z**4-14*z**2+1)/(14.0d0*sq2)
       end do
    case (221)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*sq6*z/35.0d0
          qy(ig,2) = -z*(20*z**2-15*iypx**2-12)/sq6/5.0d0
          qy(ig,3) = (-5.0d0)*sq2*z*(63*z**4-63*iypx**2*z**2-70*z**2+21*iypx**2+15)/(28.0d0*sq3)
       end do
    case (222)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iypx/(35.0d0*sq2)
          qy(ig,2) = iypx*(15*z**2+20*iypx**2-3)/sq2/30.0d0
          qy(ig,3) = 5.0d0*iypx*(63*z**4-63*iypx**2*z**2-42*z**2+7*iypx**2+3)/(42.0d0*sq2)
       end do
    case (223)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx*sq10/35.0d0
          qy(ig,2) = 2*iymx*(5*z**2-1)/sq10
          qy(ig,3) = (-5.0d0)*iymx*sq10*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (224)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-24.0d0)*sq2*z/35.0d0
          qy(ig,2) = -z*(20*z**2+15*iymx**2-12)/sq2/15.0d0
          qy(ig,3) = 5.0d0*z*(252*z**4+63*iymx**2*z**2-280*z**2-21*iymx**2+60)/(84.0d0*sq2)
       end do
    case (225)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*(2*iypx-iymx)/35.0d0
          qy(ig,2) = -(3*iypx+iymx)*(5*z**2-1)/10.0d0
          qy(ig,3) = (-5.0d0)*(3*iypx+2*iymx)*(21*z**4-14*z**2+1)/28.0d0
       end do
    case (226)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 27.0d0*z/35.0d0
          qy(ig,2) = z*(10*z**2+5*iypx**2-6)/5.0d0
          qy(ig,3) = 5.0d0*z*(63*z**4+42*iypx**2*z**2-70*z**2-14*iypx**2+15)/28.0d0
       end do
    case (227)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*iypx*sq2/35.0d0
          qy(ig,2) = -iypx*(15*z**2-5*iypx**2-3)/sq2/15.0d0
          qy(ig,3) = (-5.0d0)*iypx*(252*z**4+63*iypx**2*z**2-168*z**2-7*iypx**2+12)/(84.0d0*sq2)
       end do
    case (228)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**2*sq5*z/sq2
          qy(ig,3) = 5.0d0*iypx**2*sq5*z*(3*z**2-1)/(4.0d0*sq2)
       end do
    case (229)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx*sq10*z/7.0d0
          qy(ig,3) = 3.0d0*iymx*sq10*z*(56*z**2-63*iymx**2-24)/308.0d0
          qy(ig,4) = (-5.0d0)*iymx*sq10*z*(33*z**4-33*iymx**2*z**2-30*z**2+9*iymx**2+5)/88.0d0
       end do
    case (230)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq2/7.0d0
          qy(ig,2) = -(6*z**2-5*iymx**2-2)/sq2/7.0d0
          qy(ig,3) = (-3.0d0)*(70*z**4-105*iymx**2*z**2-60*z**2+15*iymx**2+6)/(308.0d0*sq2)
          qy(ig,4) = 25.0d0*(231*z**6-231*iymx**2*z**4-315*z**4+126*iymx**2*z**2+105*z**2-7*iymx**2-5)/(308.0d0*sq2)
       end do
    case (231)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*(iypx-iymx)*z/7.0d0
          qy(ig,3) = (-45.0d0)*(iypx-iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = (-25.0d0)*(iypx-iymx)*z*(33*z**4-30*z**2+5)/44.0d0
       end do
    case (232)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq3*z*(5*z**2-3)/2.0d0
       end do
    case (233)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx*sq3*(5*z**2-1)/2.0d0
       end do
    case (234)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq3*(9*z**2+2*iymx**2-3)/14.0d0
          qy(ig,2) = -sq3*(35*z**4-35*iymx**2*z**2-30*z**2+5*iymx**2+3)/14.0d0
       end do
    case (235)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -(3*iypx+4*iymx)*sq3*z/7.0d0
          qy(ig,2) = 5.0d0*(iypx-iymx)*sq3*z*(7*z**2-3)/14.0d0
       end do
    case (236)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iymx*z/(7.0d0*sq2)
          qy(ig,2) = 15.0d0*iymx*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (237)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq3*(9*z**2-iymx**2-3)/sq2/7.0d0
          qy(ig,2) = -sq3*(70*z**4+35*iymx**2*z**2-60*z**2-5*iymx**2+6)/sq2/14.0d0
       end do
    case (238)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -(3*iypx-8*iymx)*sq3*z/sq2/7.0d0
          qy(ig,2) = 5.0d0*(iypx+2*iymx)*sq3*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (239)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*sq2*(3*z**2-1)/7.0d0
          qy(ig,2) = (-3.0d0)*(35*z**4-30*z**2+3)/(14.0d0*sq2)
       end do
    case (240)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iymx/(35.0d0*sq2)
          qy(ig,2) = iymx*(15*z**2+20*iymx**2-3)/sq2/30.0d0
          qy(ig,3) = 5.0d0*iymx*(63*z**4-63*iymx**2*z**2-42*z**2+7*iymx**2+3)/(42.0d0*sq2)
       end do
    case (241)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*sq6*z/35.0d0
          qy(ig,2) = -z*(20*z**2-15*iymx**2-12)/sq6/5.0d0
          qy(ig,3) = (-5.0d0)*sq2*z*(63*z**4-63*iymx**2*z**2-70*z**2+21*iymx**2+15)/(28.0d0*sq3)
       end do
    case (242)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*(3*iypx+4*iymx)/(35.0d0*sq6)
          qy(ig,2) = (iypx-2*iymx)*sq3*(5*z**2-1)/sq2/10.0d0
          qy(ig,3) = 5.0d0*(iypx-iymx)*sq3*(21*z**4-14*z**2+1)/(14.0d0*sq2)
       end do
    case (243)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-12.0d0)*sq2*z/35.0d0
          qy(ig,2) = -sq2*z*(5*z**2-15*iypx**2-3)/15.0d0
          qy(ig,3) = 5.0d0*z*(63*z**4-63*iypx**2*z**2-70*z**2+21*iypx**2+15)/(42.0d0*sq2)
       end do
    case (244)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq10*z/2.0d0
          qy(ig,3) = (-5.0d0)*iymx**2*sq10*z*(3*z**2-1)/8.0d0
       end do
    case (245)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iymx*sq2/35.0d0
          qy(ig,2) = iymx*(15*z**2-5*iymx**2-3)/sq2/15.0d0
          qy(ig,3) = 5.0d0*iymx*(252*z**4+63*iymx**2*z**2-168*z**2-7*iymx**2+12)/(84.0d0*sq2)
       end do
    case (246)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-27.0d0)*z/35.0d0
          qy(ig,2) = -z*(10*z**2+5*iymx**2-6)/5.0d0
          qy(ig,3) = (-5.0d0)*z*(63*z**4+42*iymx**2*z**2-70*z**2-14*iymx**2+15)/28.0d0
       end do
    case (247)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*(iypx-2*iymx)/35.0d0
          qy(ig,2) = (iypx+3*iymx)*(5*z**2-1)/10.0d0
          qy(ig,3) = 5.0d0*(2*iypx+3*iymx)*(21*z**4-14*z**2+1)/28.0d0
       end do
    case (248)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 24.0d0*sq2*z/35.0d0
          qy(ig,2) = z*(20*z**2+15*iypx**2-12)/sq2/15.0d0
          qy(ig,3) = (-5.0d0)*z*(252*z**4+63*iypx**2*z**2-280*z**2-21*iypx**2+60)/(84.0d0*sq2)
       end do
    case (249)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*iypx/(7.0d0*sq10)
          qy(ig,2) = -2*iypx*(5*z**2-1)/sq10
          qy(ig,3) = 5.0d0*iypx*sq5*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (250)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq10/14.0d0
          qy(ig,3) = 9.0d0*iymx**2*sq10*(7*z**2-14*iymx**2-1)/616.0d0
          qy(ig,4) = (-5.0d0)*iymx**2*sq10*(33*z**4-33*iymx**2*z**2-18*z**2+3*iymx**2+1)/88.0d0
       end do
    case (251)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx*sq2*z/7.0d0
          qy(ig,3) = 15.0d0*iymx*z*(21*z**2-14*iymx**2-9)/(154.0d0*sq2)
          qy(ig,4) = 25.0d0*iymx*z*(33*z**4-33*iymx**2*z**2-30*z**2+9*iymx**2+5)/(44.0d0*sq2)
       end do
    case (252)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3)/7.0d0
          qy(ig,2) = (-2.0d0)*(3*z**2-2*iymx**2-1)/7.0d0
          qy(ig,3) = (-3.0d0)*(315*z**4-280*iymx**2*z**2-270*z**2+40*iymx**2+27)/308.0d0
          qy(ig,4) = (-25.0d0)*(231*z**6-231*iymx**2*z**4-315*z**4+126*iymx**2*z**2+105*z**2-7*iymx**2-5)/308.0d0
       end do
    case (253)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 2.0d0*(iypx-iymx)*z/7.0d0
          qy(ig,3) = 45.0d0*(iypx-iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = 25.0d0*(iypx-iymx)*z*(33*z**4-30*z**2+5)/44.0d0
       end do
    case (254)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx*sq3*(5*z**2-1)/sq2/2.0d0
       end do
    case (255)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 15.0d0*iymx**2*z/(2.0d0*sq6)
       end do
    case (256)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*iymx*sq6*z/7.0d0
          qy(ig,2) = (-15.0d0)*iymx*sq2*z*(7*z**2-7*iymx**2-3)/(28.0d0*sq3)
       end do
    case (257)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq6*(12*z**2+5*iymx**2-4)/28.0d0
          qy(ig,2) = 3.0d0*sq2*(35*z**4-35*iymx**2*z**2-30*z**2+5*iymx**2+3)/(28.0d0*sq3)
       end do
    case (258)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx**2/14.0d0
          qy(ig,2) = 15.0d0*iymx**2*(7*z**2-1)/28.0d0
       end do
    case (259)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-4.0d0)*iymx*sq3*z/7.0d0
          qy(ig,2) = (-5.0d0)*iymx*sq3*z*(14*z**2+7*iymx**2-6)/28.0d0
       end do
    case (260)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq3*(6*z**2-5*iymx**2-2)/14.0d0
          qy(ig,2) = sq3*(35*z**4+70*iymx**2*z**2-30*z**2-10*iymx**2+3)/28.0d0
       end do
    case (261)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 15.0d0*iymx*z/7.0d0
          qy(ig,2) = (-15.0d0)*iymx*z*(7*z**2-3)/28.0d0
       end do
    case (262)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*z/2.0d0
          qy(ig,3) = 5.0d0*iymx**2*z*(3*z**2-3*iymx**2-1)/4.0d0
       end do
    case (263)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*iymx*sq3/35.0d0
          qy(ig,2) = -iymx*(30*z**2-25*iymx**2-6)/sq3/20.0d0
          qy(ig,3) = (-5.0d0)*iymx*(63*z**4-63*iymx**2*z**2-42*z**2+7*iymx**2+3)/(28.0d0*sq3)
       end do
    case (264)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-12.0d0)*sq3*z/35.0d0
          qy(ig,2) = -z*(5*z**2-3)/sq3/5.0d0
          qy(ig,3) = 5.0d0*z*(63*z**4-63*iymx**2*z**2-70*z**2+21*iymx**2+15)/(28.0d0*sq3)
       end do
    case (265)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*(2*iypx+5*iymx)/35.0d0
          qy(ig,2) = (8*iypx-5*iymx)*(5*z**2-1)/20.0d0
          qy(ig,3) = (-5.0d0)*(iypx-iymx)*(21*z**4-14*z**2+1)/28.0d0
       end do
    case (266)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3*sq5/6.0d0
          qy(ig,3) = (-5.0d0)*iymx**3*sq5*(3*z-1)*(3*z+1)/24.0d0
       end do
    case (267)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*z
          qy(ig,3) = 5.0d0*iymx**2*z*(12*z**2+3*iymx**2-4)/8.0d0
       end do
    case (268)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iymx*sq2/35.0d0
          qy(ig,2) = -iymx*(45*z**2+25*iymx**2-9)/sq2/30.0d0
          qy(ig,3) = (-5.0d0)*iymx*(189*z**4+126*iymx**2*z**2-126*z**2-14*iymx**2+9)/(84.0d0*sq2)
       end do
    case (269)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-12.0d0)*sq2*z/35.0d0
          qy(ig,2) = -sq2*z*(5*z**2-3)/15.0d0
          qy(ig,3) = 5.0d0*z*(126*z**4+189*iymx**2*z**2-140*z**2-63*iymx**2+30)/(84.0d0*sq2)
       end do
    case (270)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*(iypx-10*iymx)/35.0d0
          qy(ig,2) = (2*iypx+5*iymx)*(5*z**2-1)/10.0d0
          qy(ig,3) = (-5.0d0)*(iypx+4*iymx)*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (271)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*sq5*z/7.0d0
          qy(ig,2) = -sq5*z*(5*z**2-3)/3.0d0
          qy(ig,3) = 5.0d0*sq5*z*(63*z**4-70*z**2+15)/168.0d0
       end do
    case (272)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iymx**3*sq5*z/22.0d0
          qy(ig,4) = (-15.0d0)*iymx**3*sq5*z*(11*z**2-11*iymx**2-3)/88.0d0
       end do
    case (273)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 2.0d0*iymx**2/7.0d0
          qy(ig,3) = 15.0d0*iymx**2*(56*z**2-35*iymx**2-8)/616.0d0
          qy(ig,4) = 25.0d0*iymx**2*(33*z**4-33*iymx**2*z**2-18*z**2+3*iymx**2+1)/88.0d0
       end do
    case (274)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx*sq2*z/7.0d0
          qy(ig,3) = (-15.0d0)*iymx*z*(21*z**2-14*iymx**2-9)/(154.0d0*sq2)
          qy(ig,4) = (-25.0d0)*iymx*z*(33*z**4-33*iymx**2*z**2-30*z**2+9*iymx**2+5)/(44.0d0*sq2)
       end do
    case (275)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq2/7.0d0
          qy(ig,2) = -(6*z**2-5*iymx**2-2)/sq2/7.0d0
          qy(ig,3) = (-3.0d0)*(70*z**4-105*iymx**2*z**2-60*z**2+15*iymx**2+6)/(308.0d0*sq2)
          qy(ig,4) = 25.0d0*(231*z**6-231*iymx**2*z**4-315*z**4+126*iymx**2*z**2+105*z**2-7*iymx**2-5)/(308.0d0*sq2)
       end do
    case (276)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*(iypx-iymx)*z/7.0d0
          qy(ig,3) = 30.0d0*(iypx-iymx)*z*(7*z**2-3)/77.0d0
          qy(ig,4) = (-25.0d0)*(iypx-iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (277)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-15.0d0)*iymx**2*z/(2.0d0*sq30)
       end do
    case (278)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx**3*sq5/(2.0d0*sq6)
       end do
    case (279)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx**2*sq30/28.0d0
          qy(ig,2) = (-5.0d0)*iymx**2*sq6*(7*z**2-7*iymx**2-1)/(28.0d0*sq5)
       end do
    case (280)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx*sq30*z/7.0d0
          qy(ig,2) = 3.0d0*iymx*sq5*z*(7*z**2-7*iymx**2-3)/(14.0d0*sq6)
       end do
    case (281)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx**3*sq5*z/4.0d0
       end do
    case (282)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx**2*sq15/14.0d0
          qy(ig,2) = -iymx**2*sq15*(14*z**2+7*iymx**2-2)/28.0d0
       end do
    case (283)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx*sq15*z/7.0d0
          qy(ig,2) = iymx*sq15*z*(7*z**2+14*iymx**2-3)/28.0d0
       end do
    case (284)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*iymx**2*sq5/14.0d0
          qy(ig,2) = (-3.0d0)*iymx**2*sq5*(7*z**2-1)/28.0d0
       end do
    case (285)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3*sq5/12.0d0
          qy(ig,3) = iymx**3*sq5*(9*z**2-9*iymx**2-1)/12.0d0
       end do
    case (286)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = -iymx**2*sq15*z*(3*z**2-3*iymx**2-1)/4.0d0
       end do
    case (287)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx*sq3/(7.0d0*sq5)
          qy(ig,2) = -iymx*(15*z**2-10*iymx**2-3)/sq15/4.0d0
          qy(ig,3) = iymx*sq5*(63*z**4-63*iymx**2*z**2-42*z**2+7*iymx**2+3)/sq3/28.0d0
       end do
    case (288)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*z/(7.0d0*sq5)
          qy(ig,2) = z*(20*z**2-15*iymx**2-12)/sq5/6.0d0
          qy(ig,3) = -sq5*z*(63*z**4-63*iymx**2*z**2-70*z**2+21*iymx**2+15)/84.0d0
       end do
    case (289)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iymx**4*z/8.0d0
       end do
    case (290)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3*sq5/6.0d0
          qy(ig,3) = iymx**3*sq5*(36*z**2+9*iymx**2-4)/24.0d0
       end do
    case (291)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iymx**2*z*(3*z**2+2*iymx**2-1)/(4.0d0*sq10)
       end do
    case (292)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx*sq2/(7.0d0*sq5)
          qy(ig,2) = -iymx*sq2*(5*z**2+5*iymx**2-1)/sq5/4.0d0
          qy(ig,3) = 5.0d0*iymx*sq2*(42*z**4+63*iymx**2*z**2-28*z**2-7*iymx**2+2)/(56.0d0*sq5)
       end do
    case (293)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*z/(7.0d0*sq5)
          qy(ig,2) = z*(5*z**2+15*iymx**2-3)/sq5/3.0d0
          qy(ig,3) = -sq5*z*(63*z**4+252*iymx**2*z**2-70*z**2-84*iymx**2+15)/168.0d0
       end do
    case (294)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*iymx/7.0d0
          qy(ig,2) = -iymx*(5*z**2-1)/2.0d0
          qy(ig,3) = 5.0d0*iymx*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (295)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iymx**4/88.0d0
          qy(ig,4) = (-15.0d0)*iymx**4*(11*z**2-11*iymx**2-1)/88.0d0
       end do
    case (296)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iymx**3*sq5*z/22.0d0
          qy(ig,4) = 15.0d0*iymx**3*sq5*z*(11*z**2-11*iymx**2-3)/88.0d0
       end do
    case (297)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq10/14.0d0
          qy(ig,3) = 45.0d0*iymx**2*(7*z**2-14*iymx**2-1)/(308.0d0*sq10)
          qy(ig,4) = (-5.0d0)*iymx**2*sq2*sq5*(33*z**4-33*iymx**2*z**2-18*z**2+3*iymx**2+1)/88.0d0
       end do
    case (298)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx*sq10*z/7.0d0
          qy(ig,3) = (-3.0d0)*iymx*sq5*z*(56*z**2-63*iymx**2-24)/(154.0d0*sq2)
          qy(ig,4) = 5.0d0*iymx*sq2*sq5*z*(33*z**4-33*iymx**2*z**2-30*z**2+9*iymx**2+5)/88.0d0
       end do
    case (299)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq5/7.0d0
          qy(ig,2) = iymx**2*sq5/7.0d0
          qy(ig,3) = 3.0d0*sq5*(245*z**4-252*iymx**2*z**2-210*z**2+36*iymx**2+21)/616.0d0
          qy(ig,4) = (-5.0d0)*sq5*(231*z**6-231*iymx**2*z**4-315*z**4+126*iymx**2*z**2+105*z**2-7*iymx**2-5)/616.0d0
       end do
    case (300)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*(iypx-iymx)*z/7.0d0
          qy(ig,3) = (-45.0d0)*(iypx-iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = 5.0d0*(iypx-iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (301)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (302)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx**3*sq35/4.0d0
       end do
    case (303)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx**2*sq35/14.0d0
          qy(ig,2) = iypx**2*sq35*(7*z**2-1)/28.0d0
       end do
    case (304)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**3*sq35*z/4.0d0
       end do
    case (305)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (306)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx**2*sq35/(14.0d0*sq2)
          qy(ig,2) = -iypx**2*sq35*(7*z**2-1)/sq2/28.0d0
       end do
    case (307)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3*sq35*z/sq2/2.0d0
       end do
    case (308)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**4*sq105/sq2/4.0d0
       end do
    case (309)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx*sq42/(7.0d0*sq5)
          qy(ig,2) = iypx*sq42*(5*z**2-1)/sq5/6.0d0
          qy(ig,3) = -iypx*sq35*(21*z**4-14*z**2+1)/sq6/28.0d0
       end do
    case (310)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**2*sq35*z/sq2/2.0d0
          qy(ig,3) = iypx**2*sq35*z*(3*z**2-1)/sq2/4.0d0
       end do
    case (311)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3*sq35/sq2/6.0d0
          qy(ig,3) = -iypx**3*sq35*(3*z-1)*(3*z+1)/sq2/12.0d0
       end do
    case (312)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iypx**4*sq35*z/(4.0d0*sq6)
       end do
    case (313)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
       end do
    case (314)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx*sq42/(14.0d0*sq5)
          qy(ig,2) = -iypx*sq42*(5*z**2-1)/sq5/12.0d0
          qy(ig,3) = iypx*sq35*(21*z**4-14*z**2+1)/sq6/56.0d0
       end do
    case (315)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq105*z/6.0d0
          qy(ig,3) = -iypx**2*sq105*z*(3*z**2-1)/12.0d0
       end do
    case (316)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**3*sq35/sq3/4.0d0
          qy(ig,3) = iypx**3*sq35*(3*z-1)*(3*z+1)/sq3/8.0d0
       end do
    case (317)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iypx**4*sq35*z/(2.0d0*sq6)
       end do
    case (318)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iypx**5*sq7/(8.0d0*sq6)
       end do
    case (319)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq6/sq7
          qy(ig,2) = 5*(3*z**2-1)/sq42
          qy(ig,3) = (-9.0d0)*sq6*(35*z**4-30*z**2+3)/(88.0d0*sq7)
          qy(ig,4) = 5.0d0*(231*z**6-315*z**4+105*z**2-5)/(88.0d0*sq42)
       end do
    case (320)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*iypx*sq30*z/(6.0d0*sq7)
          qy(ig,3) = 15.0d0*iypx*sq30*z*(7*z**2-3)/(44.0d0*sq7)
          qy(ig,4) = (-5.0d0)*iypx*sq210*z*(33*z**4-30*z**2+5)/528.0d0
       end do
    case (321)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq15/sq7/3.0d0
          qy(ig,3) = (-9.0d0)*iypx**2*sq15*(7*z**2-1)/(22.0d0*sq7)
          qy(ig,4) = 5.0d0*iypx**2*sq105*(33*z**4-18*z**2+1)/264.0d0
       end do
    case (322)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 9.0d0*iypx**3*sq105*z/44.0d0
          qy(ig,4) = (-5.0d0)*iypx**3*sq105*z*(11*z**2-3)/88.0d0
       end do
    case (323)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iypx**4*sq105/(44.0d0*sq2)
          qy(ig,4) = 5.0d0*iypx**4*sq105*(11*z**2-1)/(88.0d0*sq2)
       end do
    case (324)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = (-15.0d0)*iypx**5*sq7*z/(8.0d0*sq6)
       end do
    case (325)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 0
       end do
    case (326)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx**3*sq5/4.0d0
       end do
    case (327)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx**2*sq5*z/2.0d0
       end do
    case (328)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*iypx*sq5*z/7.0d0
          qy(ig,2) = iypx*sq5*z*(42*z**2+7*iypx**2-18)/28.0d0
       end do
    case (329)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx**2*sq5/14.0d0
          qy(ig,2) = -iypx**2*sq5*(42*z**2+7*iypx**2-6)/28.0d0
       end do
    case (330)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx**2*sq15/(14.0d0*sq2)
          qy(ig,2) = -iypx**2*sq15*(7*z**2-1)/sq2/28.0d0
       end do
    case (331)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx*sq10*z/7.0d0
          qy(ig,2) = -iypx*sq5*z*(21*z**2-7*iypx**2-9)/sq2/14.0d0
       end do
    case (332)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx**2*sq5/(7.0d0*sq2)
          qy(ig,2) = iypx**2*sq5*(84*z**2-7*iypx**2-12)/sq2/28.0d0
       end do
    case (333)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iypx**3*sq15*z/(2.0d0*sq2)
       end do
    case (334)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*sq6*z/(7.0d0*sq5)
          qy(ig,2) = sq3*z*(40*z**2+5*iypx**2-24)/sq10/6.0d0
          qy(ig,3) = -sq10*z*(126*z**4+21*iypx**2*z**2-140*z**2-7*iypx**2+30)/sq3/56.0d0
       end do
    case (335)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iypx*sq2/(7.0d0*sq5)
          qy(ig,2) = -iypx*sq2*(45*z**2+5*iypx**2-9)/sq5/12.0d0
          qy(ig,3) = iypx*sq5*(378*z**4+63*iypx**2*z**2-252*z**2-7*iypx**2+18)/sq2/84.0d0
       end do
    case (336)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iypx**2*sq2*z*(6*z**2+iypx**2-2)/(8.0d0*sq5)
       end do
    case (337)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3*sq30/12.0d0
          qy(ig,3) = 5.0d0*iypx**3*(18*z**2+3*iypx**2-2)/(4.0d0*sq30)
       end do
    case (338)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx*sq6/14.0d0
          qy(ig,2) = -iypx*(5*z**2-1)/sq6/2.0d0
          qy(ig,3) = 5.0d0*iypx*(21*z**4-14*z**2+1)/(56.0d0*sq6)
       end do
    case (339)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*sq6*z/(7.0d0*sq5)
          qy(ig,2) = -sq3*z*(10*z**2-5*iypx**2-6)/sq10/3.0d0
          qy(ig,3) = sq10*z*(63*z**4-42*iypx**2*z**2-70*z**2+14*iypx**2+15)/sq3/56.0d0
       end do
    case (340)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*iypx*sq3/(7.0d0*sq5)
          qy(ig,2) = iypx*(30*z**2-5*iypx**2-6)/sq15/4.0d0
          qy(ig,3) = -iypx*sq5*(252*z**4-63*iypx**2*z**2-168*z**2+7*iypx**2+12)/sq3/56.0d0
       end do
    case (341)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = iypx**2*sq15*z*(9*z**2-iypx**2-3)/4.0d0
       end do
    case (342)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**3*sq30/6.0d0
          qy(ig,3) = (-5.0d0)*iypx**3*(72*z**2-3*iypx**2-8)/(8.0d0*sq30)
       end do
    case (343)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iypx**4*sq6*z/8.0d0
       end do
    case (344)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*(iypx+6*iymx)*z/(7.0d0*sq6)
          qy(ig,3) = (-15.0d0)*(iypx+6*iymx)*sq6*z*(7*z**2-3)/308.0d0
          qy(ig,4) = 5.0d0*(iypx+6*iymx)*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
       end do
    case (345)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq30/7.0d0
          qy(ig,2) = -iypx**2*sq5/sq6/7.0d0
          qy(ig,3) = 3.0d0*sq15*(245*z**4+42*iypx**2*z**2-210*z**2-6*iypx**2+21)/(308.0d0*sq2)
          qy(ig,4) = (-5.0d0)*sq5*(1386*z**6+231*iypx**2*z**4-1890*z**4-126*iypx**2*z**2+630*z**2+7*iypx**2-30)/(616.0d0*sq6)
       end do
    case (346)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*iypx*sq15*z/7.0d0
          qy(ig,3) = (-3.0d0)*iypx*sq15*z*(112*z**2+21*iypx**2-48)/308.0d0
          qy(ig,4) = 5.0d0*iypx*sq15*z*(66*z**4+11*iypx**2*z**2-60*z**2-3*iypx**2+10)/88.0d0
       end do
    case (347)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq15/7.0d0
          qy(ig,3) = 3.0d0*iypx**2*sq15*(21*z**2+7*iypx**2-3)/308.0d0
          qy(ig,4) = (-5.0d0)*iypx**2*sq15*(66*z**4+11*iypx**2*z**2-36*z**2-iypx**2+2)/88.0d0
       end do
    case (348)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iypx**3*sq15*z/(11.0d0*sq2)
          qy(ig,4) = 5.0d0*iypx**3*sq10*sq3*z*(66*z**2+11*iypx**2-18)/176.0d0
       end do
    case (349)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iypx**4*sq6/88.0d0
          qy(ig,4) = (-5.0d0)*iypx**4*sq6*(66*z**2+11*iypx**2-6)/176.0d0
       end do
    case (350)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1/sq7
          qy(ig,2) = (-5.0d0)*(3*z**2-1)/(6.0d0*sq7)
          qy(ig,3) = 9.0d0*(35*z**4-30*z**2+3)/(88.0d0*sq7)
          qy(ig,4) = (-5.0d0)*(231*z**6-315*z**4+105*z**2-5)/(528.0d0*sq7)
       end do
    case (351)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*(iypx-iymx)*z/7.0d0
          qy(ig,3) = (-45.0d0)*(iypx-iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = 5.0d0*(iypx-iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (352)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx**2*sq15*z/2.0d0
       end do
    case (353)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx*sq15*(5*z**2-1)/4.0d0
       end do
    case (354)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq15*(6*z**2-iypx**2-2)/14.0d0
          qy(ig,2) = sq15*(35*z**4+14*iypx**2*z**2-30*z**2-2*iypx**2+3)/28.0d0
       end do
    case (355)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*iypx*sq15*z/7.0d0
          qy(ig,2) = -iypx*sq15*z*(35*z**2+14*iypx**2-15)/28.0d0
       end do
    case (356)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx*sq10*z/7.0d0
          qy(ig,2) = (-3.0d0)*iypx*sq10*z*(7*z**2-3)/28.0d0
       end do
    case (357)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq15*(3*z**2+iypx**2-1)/sq2/7.0d0
          qy(ig,2) = -sq15*(35*z**4-28*iypx**2*z**2-30*z**2+4*iypx**2+3)/sq2/28.0d0
       end do
    case (358)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*iypx*sq30*z/7.0d0
          qy(ig,2) = iypx*sq15*z*(35*z**2-7*iypx**2-15)/sq2/14.0d0
       end do
    case (359)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx**2*sq5/(14.0d0*sq2)
          qy(ig,2) = (-15.0d0)*iypx**2*sq5*(7*z**2-1)/(28.0d0*sq2)
       end do
    case (360)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*(iypx-iymx)*sq2/(7.0d0*sq5)
          qy(ig,2) = (iypx+4*iymx)*(5*z**2-1)/sq10/2.0d0
          qy(ig,3) = -(2*iypx+5*iymx)*sq10*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (361)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*sq30*z/35.0d0
          qy(ig,2) = -z*(5*z**2-3)/sq30
          qy(ig,3) = sq5*sq6*z*(315*z**4+126*iypx**2*z**2-350*z**2-42*iypx**2+75)/168.0d0
       end do
    case (362)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx*sq6/(7.0d0*sq5)
          qy(ig,2) = -iypx*sq2*(15*z**2+5*iypx**2-3)/sq15/4.0d0
          qy(ig,3) = -iypx*sq10*(315*z**4+126*iypx**2*z**2-210*z**2-14*iypx**2+15)/sq3/56.0d0
       end do
    case (363)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq5*z/sq2/2.0d0
          qy(ig,3) = iypx**2*sq5*z*(15*z**2+6*iypx**2-5)/sq2/4.0d0
       end do
    case (364)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*sq2*z/7.0d0
          qy(ig,2) = -sq2*z*(5*z**2-3)/3.0d0
          qy(ig,3) = 5.0d0*z*(63*z**4-70*z**2+15)/(84.0d0*sq2)
       end do
    case (365)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*(4*iypx+iymx)*sq5/(35.0d0*sq2)
          qy(ig,2) = (iypx-iymx)*(5*z**2-1)/sq10
          qy(ig,3) = -(8*iypx-5*iymx)*sq10*(21*z**4-14*z**2+1)/112.0d0
       end do
    case (366)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 12.0d0*z/(7.0d0*sq5)
          qy(ig,2) = z*(5*z**2-3)/sq5/3.0d0
          qy(ig,3) = -sq5*z*(315*z**4-189*iypx**2*z**2-350*z**2+63*iypx**2+75)/84.0d0
       end do
    case (367)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*iypx/(7.0d0*sq5)
          qy(ig,2) = iypx*(45*z**2-10*iypx**2-9)/sq5/12.0d0
          qy(ig,3) = iypx*sq5*(945*z**4-252*iypx**2*z**2-630*z**2+28*iypx**2+45)/168.0d0
       end do
    case (368)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**2*sq5*z/sq2
          qy(ig,3) = -iypx**2*sq5*z*(30*z**2-3*iypx**2-10)/sq2/4.0d0
       end do
    case (369)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*iypx**3/(6.0d0*sq2)
          qy(ig,3) = 25.0d0*iypx**3*(3*z-1)*(3*z+1)/(24.0d0*sq2)
       end do
    case (370)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq2/7.0d0
          qy(ig,2) = 5.0d0*iymx**2/(7.0d0*sq2)
          qy(ig,3) = (-3.0d0)*(245*z**4+630*iymx**2*z**2-210*z**2-90*iymx**2+21)/(308.0d0*sq2)
          qy(ig,4) = 5.0d0*(462*z**6+1155*iymx**2*z**4-630*z**4-630*iymx**2*z**2+210*z**2+35*iymx**2-10)/(616.0d0*sq2)
       end do
    case (371)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (2*iypx+5*iymx)*sq10*z/14.0d0
          qy(ig,3) = 3.0d0*(2*iypx+5*iymx)*sq10*z*(7*z**2-3)/77.0d0
          qy(ig,4) = (-5.0d0)*(2*iypx+5*iymx)*sq10*z*(33*z**4-30*z**2+5)/176.0d0
       end do
    case (372)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq5/7.0d0
          qy(ig,2) = -sq5*(3*z**2+iypx**2-1)/7.0d0
          qy(ig,3) = (-3.0d0)*sq5*(35*z**4+21*iypx**2*z**2-30*z**2-3*iypx**2+3)/308.0d0
          qy(ig,4) = 5.0d0*sq5*(1155*z**6+462*iypx**2*z**4-1575*z**4-252*iypx**2*z**2+525*z**2+14*iypx**2-25)/616.0d0
       end do
    case (373)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx*sq5*z/7.0d0
          qy(ig,3) = (-3.0d0)*iypx*sq5*z*(105*z**2+28*iypx**2-45)/308.0d0
          qy(ig,4) = (-5.0d0)*iypx*sq5*z*(165*z**4+66*iypx**2*z**2-150*z**2-18*iypx**2+25)/88.0d0
       end do
    case (374)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq10/7.0d0
          qy(ig,3) = 15.0d0*iypx**2*sq5*(28*z**2+7*iypx**2-4)/(308.0d0*sq2)
          qy(ig,4) = 5.0d0*iypx**2*sq5*(165*z**4+66*iypx**2*z**2-90*z**2-6*iypx**2+5)/(88.0d0*sq2)
       end do
    case (375)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iypx**3*z/(22.0d0*sq2)
          qy(ig,4) = (-15.0d0)*iypx**3*z*(55*z**2+22*iypx**2-15)/(88.0d0*sq2)
       end do
    case (376)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -5*iymx*z/sq21
          qy(ig,3) = 15.0d0*iymx*sq3*z*(7*z**2-3)/(22.0d0*sq7)
          qy(ig,4) = (-5.0d0)*iymx*sq21*z*(33*z**4-30*z**2+5)/264.0d0
       end do
    case (377)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*sq3/7.0d0
          qy(ig,2) = (-5.0d0)*iymx**2/(14.0d0*sq3)
          qy(ig,3) = (-3.0d0)*sq3*(245*z**4-105*iymx**2*z**2-210*z**2+15*iymx**2+21)/308.0d0
          qy(ig,4) = 5.0d0*(2772*z**6-1155*iymx**2*z**4-3780*z**4+630*iymx**2*z**2+1260*z**2-35*iymx**2-60)/(1232.0d0*sq3)
       end do
    case (378)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*(iypx-iymx)*z/7.0d0
          qy(ig,3) = 30.0d0*(iypx-iymx)*z*(7*z**2-3)/77.0d0
          qy(ig,4) = (-25.0d0)*(iypx-iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (379)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx*(5*z**2-1)/4.0d0
       end do
    case (380)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = z*(5*z**2-3)
       end do
    case (381)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*(iypx-iymx)*z/7.0d0
          qy(ig,2) = 5.0d0*(3*iypx+4*iymx)*z*(7*z**2-3)/28.0d0
       end do
    case (382)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*(6*z**2-iypx**2-2)/14.0d0
          qy(ig,2) = -(140*z**4+105*iypx**2*z**2-120*z**2-15*iypx**2+12)/28.0d0
       end do
    case (383)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*sq3*(3*z**2-1)/(7.0d0*sq2)
          qy(ig,2) = (-3.0d0)*sq3*(35*z**4-30*z**2+3)/(28.0d0*sq2)
       end do
    case (384)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*(2*iypx+iymx)*sq2*z/7.0d0
          qy(ig,2) = 5.0d0*(3*iypx-2*iymx)*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (385)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*(12*z**2+iypx**2-4)/(14.0d0*sq2)
          qy(ig,2) = (280*z**4-105*iypx**2*z**2-240*z**2+15*iypx**2+24)/sq2/28.0d0
       end do
    case (386)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx*sq6*z/7.0d0
          qy(ig,2) = (-5.0d0)*iypx*sq3*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (387)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*sq6*z/35.0d0
          qy(ig,2) = z*(5*z**2+20*iymx**2-3)/sq6/5.0d0
          qy(ig,3) = (-5.0d0)*z*(63*z**4+84*iymx**2*z**2-70*z**2-28*iymx**2+15)/(28.0d0*sq6)
       end do
    case (388)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*(iypx-iymx)*sq2/35.0d0
          qy(ig,2) = (3*iypx+2*iymx)*(5*z**2-1)/sq2/10.0d0
          qy(ig,3) = 5.0d0*(3*iypx+4*iymx)*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (389)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-18.0d0)*sq2*z/35.0d0
          qy(ig,2) = -z*(80*z**2+45*iypx**2-48)/sq2/30.0d0
          qy(ig,3) = (-5.0d0)*z*(252*z**4+189*iypx**2*z**2-280*z**2-63*iypx**2+60)/(84.0d0*sq2)
       end do
    case (390)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx*sq6/35.0d0
          qy(ig,2) = iypx*(5*z**2-5*iypx**2-1)/sq6/5.0d0
          qy(ig,3) = 5.0d0*iypx*(84*z**4+63*iypx**2*z**2-56*z**2-7*iypx**2+4)/(28.0d0*sq6)
       end do
    case (391)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx*sq30/70.0d0
          qy(ig,2) = -iymx*sq30*(5*z**2-1)/10.0d0
          qy(ig,3) = 5.0d0*iymx*sq30*(21*z**4-14*z**2+1)/112.0d0
       end do
    case (392)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 12.0d0*sq6*z/35.0d0
          qy(ig,2) = sq2*z*(5*z**2-5*iymx**2-3)/sq3/5.0d0
          qy(ig,3) = (-5.0d0)*z*(63*z**4-21*iymx**2*z**2-70*z**2+7*iymx**2+15)/(14.0d0*sq6)
       end do
    case (393)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*(3*iypx+2*iymx)*sq3/35.0d0
          qy(ig,2) = (9*iypx-4*iymx)*(5*z**2-1)/sq3/20.0d0
          qy(ig,3) = 5.0d0*(9*iypx-8*iymx)*(21*z**4-14*z**2+1)/(56.0d0*sq3)
       end do
    case (394)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 18.0d0*sq3*z/35.0d0
          qy(ig,2) = z*(40*z**2-15*iypx**2-24)/sq3/10.0d0
          qy(ig,3) = 5.0d0*z*(126*z**4-63*iypx**2*z**2-140*z**2+21*iypx**2+30)/(28.0d0*sq3)
       end do
    case (395)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*iypx*sq6/35.0d0
          qy(ig,2) = -iypx*(20*z**2+5*iypx**2-4)/sq6/10.0d0
          qy(ig,3) = (-5.0d0)*iypx*(336*z**4-63*iypx**2*z**2-224*z**2+7*iypx**2+16)/(56.0d0*sq6)
       end do
    case (396)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -2*iypx**2*sq5*z/sq6
          qy(ig,3) = 5.0d0*iypx**2*sq5*z*(3*z**2-1)/(2.0d0*sq6)
       end do
    case (397)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx*sq30*z/14.0d0
          qy(ig,3) = (-3.0d0)*iymx*sq30*z*(14*z**2+21*iymx**2-6)/154.0d0
          qy(ig,4) = 5.0d0*iymx*sq30*z*(33*z**4+44*iymx**2*z**2-30*z**2-12*iymx**2+5)/176.0d0
       end do
    case (398)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq6/7.0d0
          qy(ig,2) = sq3*(9*z**2+10*iymx**2-3)/sq2/21.0d0
          qy(ig,3) = 3.0d0*sq3*(35*z**4+70*iymx**2*z**2-30*z**2-10*iymx**2+3)/(308.0d0*sq2)
          qy(ig,4) = (-25.0d0)*sq2*(693*z**6+924*iymx**2*z**4-945*z**4-504*iymx**2*z**2+315*z**2+28*iymx**2-15)/(1232.0d0*sq3)
       end do
    case (399)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (3*iypx+4*iymx)*z/sq3/7.0d0
          qy(ig,3) = 15.0d0*(3*iypx+4*iymx)*sq3*z*(7*z**2-3)/308.0d0
          qy(ig,4) = 25.0d0*(3*iypx+4*iymx)*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
       end do
    case (400)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq3/7.0d0
          qy(ig,2) = (-2.0d0)*(6*z**2+3*iypx**2-2)/(7.0d0*sq3)
          qy(ig,3) = (-3.0d0)*sq3*(105*z**4+70*iypx**2*z**2-90*z**2-10*iypx**2+9)/154.0d0
          qy(ig,4) = (-25.0d0)*(924*z**6+693*iypx**2*z**4-1260*z**4-378*iypx**2*z**2+420*z**2+21*iypx**2-20)/(616.0d0*sq3)
       end do
    case (401)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 2.0d0*iypx*sq2*z/(7.0d0*sq3)
          qy(ig,3) = 15.0d0*iypx*sq3*z*(14*z**2+7*iypx**2-6)/(154.0d0*sq2)
          qy(ig,4) = 25.0d0*iypx*sq2*z*(132*z**4+99*iypx**2*z**2-120*z**2-27*iypx**2+20)/(176.0d0*sq3)
       end do
    case (402)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 10.0d0*iypx**2/(7.0d0*sq30)
          qy(ig,3) = 45.0d0*iypx**2*sq2*(14*z**2+21*iypx**2-2)/(616.0d0*sq15)
          qy(ig,4) = (-5.0d0)*iypx**2*sq15*(132*z**4+99*iypx**2*z**2-72*z**2-9*iypx**2+4)/(264.0d0*sq2)
       end do
    case (403)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq5/sq7/2.0d0
          qy(ig,3) = 27.0d0*iymx**2*sq5*(7*z**2-1)/(44.0d0*sq7)
          qy(ig,4) = (-5.0d0)*iymx**2*sq35*(33*z**4-18*z**2+1)/176.0d0
       end do
    case (404)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx*sq5*z/7.0d0
          qy(ig,3) = (-9.0d0)*iymx*sq5*z*(28*z**2-7*iymx**2-12)/154.0d0
          qy(ig,4) = 5.0d0*iymx*sq5*z*(99*z**4-22*iymx**2*z**2-90*z**2+6*iymx**2+15)/88.0d0
       end do
    case (405)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq15/7.0d0
          qy(ig,2) = sq15*(9*z**2-4*iymx**2-3)/42.0d0
          qy(ig,3) = 3.0d0*sq15*(35*z**4-28*iymx**2*z**2-30*z**2+4*iymx**2+3)/616.0d0
          qy(ig,4) = (-5.0d0)*sq15*(3465*z**6-1848*iymx**2*z**4-4725*z**4+1008*iymx**2*z**2+1575*z**2-56*iymx**2-75)/3696.0d0
       end do
    case (406)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 2.0d0*(iypx-iymx)*z/7.0d0
          qy(ig,3) = 45.0d0*(iypx-iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = 25.0d0*(iypx-iymx)*z*(33*z**4-30*z**2+5)/44.0d0
       end do
    case (407)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = z*(5*z**2-3)
       end do
    case (408)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx*(5*z**2-1)/4.0d0
       end do
    case (409)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*(6*z**2-iymx**2-2)/14.0d0
          qy(ig,2) = (140*z**4+105*iymx**2*z**2-120*z**2-15*iymx**2+12)/28.0d0
       end do
    case (410)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*(iypx-iymx)*z/7.0d0
          qy(ig,2) = (-5.0d0)*(4*iypx+3*iymx)*z*(7*z**2-3)/28.0d0
       end do
    case (411)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx*sq6*z/7.0d0
          qy(ig,2) = (-5.0d0)*iymx*sq3*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (412)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*(12*z**2+iymx**2-4)/(14.0d0*sq2)
          qy(ig,2) = (280*z**4-105*iymx**2*z**2-240*z**2+15*iymx**2+24)/sq2/28.0d0
       end do
    case (413)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*(iypx+2*iymx)*sq2*z/7.0d0
          qy(ig,2) = (-5.0d0)*(2*iypx-3*iymx)*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (414)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*sq3*(3*z**2-1)/(7.0d0*sq2)
          qy(ig,2) = (-3.0d0)*sq3*(35*z**4-30*z**2+3)/(28.0d0*sq2)
       end do
    case (415)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx*sq6/35.0d0
          qy(ig,2) = -iymx*(5*z**2-5*iymx**2-1)/sq6/5.0d0
          qy(ig,3) = (-5.0d0)*iymx*(84*z**4+63*iymx**2*z**2-56*z**2-7*iymx**2+4)/(28.0d0*sq6)
       end do
    case (416)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 18.0d0*sq2*z/35.0d0
          qy(ig,2) = z*(80*z**2+45*iymx**2-48)/sq2/30.0d0
          qy(ig,3) = 5.0d0*z*(252*z**4+189*iymx**2*z**2-280*z**2-63*iymx**2+60)/(84.0d0*sq2)
       end do
    case (417)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*(iypx-iymx)*sq2/35.0d0
          qy(ig,2) = -(2*iypx+3*iymx)*(5*z**2-1)/sq2/10.0d0
          qy(ig,3) = (-5.0d0)*(4*iypx+3*iymx)*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (418)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*sq6*z/35.0d0
          qy(ig,2) = -z*(5*z**2+20*iypx**2-3)/sq6/5.0d0
          qy(ig,3) = 5.0d0*z*(63*z**4+84*iypx**2*z**2-70*z**2-28*iypx**2+15)/(28.0d0*sq6)
       end do
    case (419)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -10*iymx**2*z/sq30
          qy(ig,3) = 5.0d0*iymx**2*sq30*z*(3*z**2-1)/12.0d0
       end do
    case (420)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*iymx*sq6/35.0d0
          qy(ig,2) = -iymx*(20*z**2+5*iymx**2-4)/sq6/10.0d0
          qy(ig,3) = (-5.0d0)*iymx*(336*z**4-63*iymx**2*z**2-224*z**2+7*iymx**2+16)/(56.0d0*sq6)
       end do
    case (421)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 18.0d0*sq3*z/35.0d0
          qy(ig,2) = z*(40*z**2-15*iymx**2-24)/sq3/10.0d0
          qy(ig,3) = 5.0d0*z*(126*z**4-63*iymx**2*z**2-140*z**2+21*iymx**2+30)/(28.0d0*sq3)
       end do
    case (422)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*(2*iypx+3*iymx)*sq3/35.0d0
          qy(ig,2) = -(4*iypx-9*iymx)*(5*z**2-1)/sq3/20.0d0
          qy(ig,3) = (-5.0d0)*(8*iypx-9*iymx)*(21*z**4-14*z**2+1)/(56.0d0*sq3)
       end do
    case (423)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 12.0d0*sq6*z/35.0d0
          qy(ig,2) = 2.0d0*z*(5*z**2-5*iypx**2-3)/(5.0d0*sq6)
          qy(ig,3) = (-5.0d0)*z*(63*z**4-21*iypx**2*z**2-70*z**2+7*iypx**2+15)/(14.0d0*sq6)
       end do
    case (424)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*iypx/(7.0d0*sq30)
          qy(ig,2) = -iypx*sq6*(5*z**2-1)/sq5/2.0d0
          qy(ig,3) = 15.0d0*iypx*sq5*(21*z**4-14*z**2+1)/(56.0d0*sq6)
       end do
    case (425)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq30/21.0d0
          qy(ig,3) = (-3.0d0)*iymx**2*sq30*(14*z**2+21*iymx**2-2)/616.0d0
          qy(ig,4) = 5.0d0*iymx**2*sq30*(132*z**4+99*iymx**2*z**2-72*z**2-9*iymx**2+4)/528.0d0
       end do
    case (426)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*iymx*sq6*z/21.0d0
          qy(ig,3) = (-15.0d0)*iymx*sq3*z*(14*z**2+7*iymx**2-6)/(154.0d0*sq2)
          qy(ig,4) = (-25.0d0)*iymx*z*(132*z**4+99*iymx**2*z**2-120*z**2-27*iymx**2+20)/(88.0d0*sq6)
       end do
    case (427)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*sq3/7.0d0
          qy(ig,2) = 2.0d0*(6*z**2+3*iymx**2-2)/(7.0d0*sq3)
          qy(ig,3) = 3.0d0*sq3*(105*z**4+70*iymx**2*z**2-90*z**2-10*iymx**2+9)/154.0d0
          qy(ig,4) = 25.0d0*(924*z**6+693*iymx**2*z**4-1260*z**4-378*iymx**2*z**2+420*z**2+21*iymx**2-20)/(616.0d0*sq3)
       end do
    case (428)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -(4*iypx+3*iymx)*z/sq3/7.0d0
          qy(ig,3) = (-15.0d0)*(4*iypx+3*iymx)*sq3*z*(7*z**2-3)/308.0d0
          qy(ig,4) = (-25.0d0)*(4*iypx+3*iymx)*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
       end do
    case (429)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq6/7.0d0
          qy(ig,2) = -sq2*(9*z**2+10*iypx**2-3)/sq3/14.0d0
          qy(ig,3) = (-3.0d0)*sq2*sq3*(35*z**4+70*iypx**2*z**2-30*z**2-10*iypx**2+3)/616.0d0
          qy(ig,4) = 25.0d0*sq2*(693*z**6+924*iypx**2*z**4-945*z**4-504*iypx**2*z**2+315*z**2+28*iypx**2-15)/(1232.0d0*sq3)
       end do
    case (430)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 15.0d0*iypx*z/(7.0d0*sq30)
          qy(ig,3) = 3.0d0*iypx*sq30*z*(14*z**2+21*iypx**2-6)/154.0d0
          qy(ig,4) = (-5.0d0)*iypx*sq30*z*(33*z**4+44*iypx**2*z**2-30*z**2-12*iypx**2+5)/176.0d0
       end do
    case (431)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 9.0d0*iymx**3*sq35*z/22.0d0
          qy(ig,4) = (-5.0d0)*iymx**3*sq35*z*(11*z**2-3)/44.0d0
       end do
    case (432)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*iymx**2*sq5/7.0d0
          qy(ig,3) = (-9.0d0)*iymx**2*sq5*(28*z**2-7*iymx**2-4)/616.0d0
          qy(ig,4) = 5.0d0*iymx**2*sq5*(264*z**4-33*iymx**2*z**2-144*z**2+3*iymx**2+8)/176.0d0
       end do
    case (433)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*iymx*sq15*z/21.0d0
          qy(ig,3) = (-3.0d0)*iymx*sq15*z*(35*z**2-7*iymx**2-15)/154.0d0
          qy(ig,4) = (-5.0d0)*iymx*sq15*z*(330*z**4-99*iymx**2*z**2-300*z**2+27*iymx**2+50)/264.0d0
       end do
    case (434)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 4/7.0d0
          qy(ig,2) = (24*z**2-9*iymx**2-8)/21.0d0
          qy(ig,3) = 9.0d0*(70*z**4-35*iymx**2*z**2-60*z**2+5*iymx**2+6)/154.0d0
          qy(ig,4) = 25.0d0*(3696*z**6-2079*iymx**2*z**4-5040*z**4+1134*iymx**2*z**2+1680*z**2-63*iymx**2-80)/3696.0d0
       end do
    case (435)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*(iypx-iymx)*z/7.0d0
          qy(ig,3) = (-45.0d0)*(iypx-iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = (-25.0d0)*(iypx-iymx)*z*(33*z**4-30*z**2+5)/44.0d0
       end do
    case (436)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx*sq15*(5*z**2-1)/4.0d0
       end do
    case (437)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx**2*sq15*z/2.0d0
       end do
    case (438)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*iymx*sq15*z/7.0d0
          qy(ig,2) = iymx*sq15*z*(35*z**2+14*iymx**2-15)/28.0d0
       end do
    case (439)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq15*(6*z**2-iymx**2-2)/14.0d0
          qy(ig,2) = -sq15*(35*z**4+14*iymx**2*z**2-30*z**2-2*iymx**2+3)/28.0d0
       end do
    case (440)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx**2*sq5/(14.0d0*sq2)
          qy(ig,2) = (-15.0d0)*iymx**2*sq5*(7*z**2-1)/(28.0d0*sq2)
       end do
    case (441)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*iymx*sq30*z/7.0d0
          qy(ig,2) = iymx*sq15*z*(35*z**2-7*iymx**2-15)/sq2/14.0d0
       end do
    case (442)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq15*(3*z**2+iymx**2-1)/sq2/7.0d0
          qy(ig,2) = -sq15*(35*z**4-28*iymx**2*z**2-30*z**2+4*iymx**2+3)/sq2/28.0d0
       end do
    case (443)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx*sq10*z/7.0d0
          qy(ig,2) = (-15.0d0)*iymx*z*(7*z**2-3)/(14.0d0*sq10)
       end do
    case (444)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq5*z/sq2/2.0d0
          qy(ig,3) = -iymx**2*sq5*z*(15*z**2+6*iymx**2-5)/sq2/4.0d0
       end do
    case (445)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx*sq6/(7.0d0*sq5)
          qy(ig,2) = iymx*sq2*(15*z**2+5*iymx**2-3)/sq15/4.0d0
          qy(ig,3) = iymx*sq10*(315*z**4+126*iymx**2*z**2-210*z**2-14*iymx**2+15)/sq3/56.0d0
       end do
    case (446)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*sq6*z/(7.0d0*sq5)
          qy(ig,2) = z*(5*z**2-3)/sq30
          qy(ig,3) = -sq5*sq6*z*(315*z**4+126*iymx**2*z**2-350*z**2-42*iymx**2+75)/168.0d0
       end do
    case (447)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*(iypx-iymx)*sq5/(35.0d0*sq2)
          qy(ig,2) = -(4*iypx+iymx)*(5*z**2-1)/sq10/2.0d0
          qy(ig,3) = (5*iypx+2*iymx)*sq2*sq5*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (448)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*iymx**3/(6.0d0*sq2)
          qy(ig,3) = 25.0d0*iymx**3*(3*z-1)*(3*z+1)/(24.0d0*sq2)
       end do
    case (449)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq5*z/sq2
          qy(ig,3) = -iymx**2*sq5*z*(30*z**2-3*iymx**2-10)/sq2/4.0d0
       end do
    case (450)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*iymx/(7.0d0*sq5)
          qy(ig,2) = iymx*(45*z**2-10*iymx**2-9)/sq5/12.0d0
          qy(ig,3) = iymx*sq5*(945*z**4-252*iymx**2*z**2-630*z**2+28*iymx**2+45)/168.0d0
       end do
    case (451)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 12.0d0*z/(7.0d0*sq5)
          qy(ig,2) = z*(5*z**2-3)/sq5/3.0d0
          qy(ig,3) = -sq5*z*(315*z**4-189*iymx**2*z**2-350*z**2+63*iymx**2+75)/84.0d0
       end do
    case (452)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*(iypx+4*iymx)*sq5/(35.0d0*sq2)
          qy(ig,2) = -(iypx-iymx)*(5*z**2-1)/sq10
          qy(ig,3) = (5*iypx-8*iymx)*sq2*sq5*(21*z**4-14*z**2+1)/112.0d0
       end do
    case (453)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*sq2*z/7.0d0
          qy(ig,2) = -sq2*z*(5*z**2-3)/3.0d0
          qy(ig,3) = 5.0d0*z*(63*z**4-70*z**2+15)/(84.0d0*sq2)
       end do
    case (454)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iymx**3*z/(22.0d0*sq2)
          qy(ig,4) = 15.0d0*iymx**3*z*(55*z**2+22*iymx**2-15)/(88.0d0*sq2)
       end do
    case (455)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq10/7.0d0
          qy(ig,3) = (-15.0d0)*iymx**2*sq5*(28*z**2+7*iymx**2-4)/(308.0d0*sq2)
          qy(ig,4) = (-5.0d0)*iymx**2*sq5*(165*z**4+66*iymx**2*z**2-90*z**2-6*iymx**2+5)/(88.0d0*sq2)
       end do
    case (456)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx*sq5*z/7.0d0
          qy(ig,3) = 3.0d0*iymx*sq5*z*(105*z**2+28*iymx**2-45)/308.0d0
          qy(ig,4) = 5.0d0*iymx*sq5*z*(165*z**4+66*iymx**2*z**2-150*z**2-18*iymx**2+25)/88.0d0
       end do
    case (457)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*sq5/7.0d0
          qy(ig,2) = sq5*(3*z**2+iymx**2-1)/7.0d0
          qy(ig,3) = 3.0d0*sq5*(35*z**4+21*iymx**2*z**2-30*z**2-3*iymx**2+3)/308.0d0
          qy(ig,4) = (-5.0d0)*sq5*(1155*z**6+462*iymx**2*z**4-1575*z**4-252*iymx**2*z**2+525*z**2+14*iymx**2-25)/616.0d0
       end do
    case (458)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*(5*iypx+2*iymx)*z/(7.0d0*sq10)
          qy(ig,3) = (-3.0d0)*(5*iypx+2*iymx)*sq10*z*(7*z**2-3)/77.0d0
          qy(ig,4) = 25.0d0*(5*iypx+2*iymx)*z*(33*z**4-30*z**2+5)/(88.0d0*sq10)
       end do
    case (459)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq2/7.0d0
          qy(ig,2) = (-5.0d0)*iypx**2/(7.0d0*sq2)
          qy(ig,3) = 3.0d0*(245*z**4+630*iypx**2*z**2-210*z**2-90*iypx**2+21)/(308.0d0*sq2)
          qy(ig,4) = (-5.0d0)*(462*z**6+1155*iypx**2*z**4-630*z**4-630*iypx**2*z**2+210*z**2+35*iypx**2-10)/(616.0d0*sq2)
       end do
    case (460)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iymx**4*sq21/88.0d0
          qy(ig,4) = (-25.0d0)*iymx**4*sq21*(11*z**2-1)/176.0d0
       end do
    case (461)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iymx**3*sq3*z/22.0d0
          qy(ig,4) = 5.0d0*iymx**3*sq3*z*(165*z**2-11*iymx**2-45)/88.0d0
       end do
    case (462)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*iymx**2/7.0d0
          qy(ig,3) = (-15.0d0)*iymx**2*(70*z**2-7*iymx**2-10)/308.0d0
          qy(ig,4) = (-5.0d0)*iymx**2*(825*z**4-132*iymx**2*z**2-450*z**2+12*iymx**2+25)/176.0d0
       end do
    case (463)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 2.0d0*iymx*sq5*z/(7.0d0*sq3)
          qy(ig,3) = 3.0d0*iymx*sq15*z*(35*z**2-7*iymx**2-15)/154.0d0
          qy(ig,4) = 5.0d0*iymx*sq5*z*(330*z**4-99*iymx**2*z**2-300*z**2+27*iymx**2+50)/(88.0d0*sq3)
       end do
    case (464)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq15/7.0d0
          qy(ig,2) = sq15*(9*z**2-4*iymx**2-3)/42.0d0
          qy(ig,3) = 3.0d0*sq15*(35*z**4-28*iymx**2*z**2-30*z**2+4*iymx**2+3)/616.0d0
          qy(ig,4) = (-25.0d0)*(3465*z**6-1848*iymx**2*z**4-4725*z**4+1008*iymx**2*z**2+1575*z**2-56*iymx**2-75)/(1232.0d0*sq15)
       end do
    case (465)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*(iypx-iymx)*z/7.0d0
          qy(ig,3) = (-30.0d0)*(iypx-iymx)*z*(7*z**2-3)/77.0d0
          qy(ig,4) = 25.0d0*(iypx-iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (466)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx**2*sq5*z/2.0d0
       end do
    case (467)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx**3*sq5/4.0d0
       end do
    case (468)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx**2*sq5/14.0d0
          qy(ig,2) = iymx**2*sq5*(42*z**2+7*iymx**2-6)/28.0d0
       end do
    case (469)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*iymx*sq5*z/7.0d0
          qy(ig,2) = -iymx*sq5*z*(42*z**2+7*iymx**2-18)/28.0d0
       end do
    case (470)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-15.0d0)*iymx**3*sq3*z/(2.0d0*sq10)
       end do
    case (471)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx**2*sq5/(7.0d0*sq2)
          qy(ig,2) = iymx**2*sq5*(84*z**2-7*iymx**2-12)/sq2/28.0d0
       end do
    case (472)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx*sq10*z/7.0d0
          qy(ig,2) = (-5.0d0)*iymx*sq2*z*(21*z**2-7*iymx**2-9)/(28.0d0*sq5)
       end do
    case (473)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx**2*sq15/(14.0d0*sq2)
          qy(ig,2) = -iymx**2*sq15*(7*z**2-1)/sq2/28.0d0
       end do
    case (474)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**3*sq15/sq2/6.0d0
          qy(ig,3) = -iymx**3*sq15*(18*z**2+3*iymx**2-2)/sq2/12.0d0
       end do
    case (475)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iymx**2*sq2*z*(6*z**2+iymx**2-2)/(8.0d0*sq5)
       end do
    case (476)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 18.0d0*iymx/(7.0d0*sq10)
          qy(ig,2) = iymx*sq2*(45*z**2+5*iymx**2-9)/sq5/12.0d0
          qy(ig,3) = (-5.0d0)*iymx*sq2*(378*z**4+63*iymx**2*z**2-252*z**2-7*iymx**2+18)/(168.0d0*sq5)
       end do
    case (477)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 36.0d0*z/(7.0d0*sq30)
          qy(ig,2) = -sq5*z*(40*z**2+5*iymx**2-24)/sq6/10.0d0
          qy(ig,3) = sq5*z*(126*z**4+21*iymx**2*z**2-140*z**2-7*iymx**2+30)/sq6/28.0d0
       end do
    case (478)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iymx**4*sq6*z/8.0d0
       end do
    case (479)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**3*sq15/sq2/3.0d0
          qy(ig,3) = -iymx**3*sq15*sq2*(72*z**2-3*iymx**2-8)/48.0d0
       end do
    case (480)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = iymx**2*sq15*z*(9*z**2-iymx**2-3)/4.0d0
       end do
    case (481)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 18.0d0*iymx/(7.0d0*sq15)
          qy(ig,2) = iymx*sq3*(30*z**2-5*iymx**2-6)/sq5/12.0d0
          qy(ig,3) = -iymx*sq5*(252*z**4-63*iymx**2*z**2-168*z**2+7*iymx**2+12)/sq3/56.0d0
       end do
    case (482)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 18.0d0*z/(7.0d0*sq30)
          qy(ig,2) = -sq6*z*(10*z**2-5*iymx**2-6)/sq5/6.0d0
          qy(ig,3) = sq5*z*(63*z**4-42*iymx**2*z**2-70*z**2+14*iymx**2+15)/sq6/28.0d0
       end do
    case (483)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*iymx/(7.0d0*sq6)
          qy(ig,2) = -iymx*(5*z**2-1)/sq6/2.0d0
          qy(ig,3) = 5.0d0*iymx*(21*z**4-14*z**2+1)/(56.0d0*sq6)
       end do
    case (484)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iymx**4*sq6/88.0d0
          qy(ig,4) = 15.0d0*iymx**4*(66*z**2+11*iymx**2-6)/(88.0d0*sq6)
       end do
    case (485)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iymx**3*sq3*z/(11.0d0*sq10)
          qy(ig,4) = (-25.0d0)*iymx**3*sq3*z*(66*z**2+11*iymx**2-18)/(88.0d0*sq10)
       end do
    case (486)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq15/7.0d0
          qy(ig,3) = (-3.0d0)*iymx**2*sq15*(21*z**2+7*iymx**2-3)/308.0d0
          qy(ig,4) = 5.0d0*iymx**2*sq15*(66*z**4+11*iymx**2*z**2-36*z**2-iymx**2+2)/88.0d0
       end do
    case (487)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 2.0d0*iymx*sq15*z/7.0d0
          qy(ig,3) = 3.0d0*iymx*sq15*z*(112*z**2+21*iymx**2-48)/308.0d0
          qy(ig,4) = (-5.0d0)*iymx*sq15*z*(66*z**4+11*iymx**2*z**2-60*z**2-3*iymx**2+10)/88.0d0
       end do
    case (488)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq30/7.0d0
          qy(ig,2) = iymx**2*sq5/sq6/7.0d0
          qy(ig,3) = (-3.0d0)*sq15*(245*z**4+42*iymx**2*z**2-210*z**2-6*iymx**2+21)/(308.0d0*sq2)
          qy(ig,4) = 5.0d0*sq5*(1386*z**6+231*iymx**2*z**4-1890*z**4-126*iymx**2*z**2+630*z**2+7*iymx**2-30)/(616.0d0*sq6)
       end do
    case (489)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*(6*iypx+iymx)*z/(7.0d0*sq6)
          qy(ig,3) = 15.0d0*(6*iypx+iymx)*sq6*z*(7*z**2-3)/308.0d0
          qy(ig,4) = (-5.0d0)*(6*iypx+iymx)*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
       end do
    case (490)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = (-15.0d0)*iymx**5*sq7*z/8.0d0
       end do
    case (491)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 45.0d0*iymx**4/44.0d0
          qy(ig,4) = 5.0d0*iymx**4*(396*z**2-11*iymx**2-36)/176.0d0
       end do
    case (492)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iymx**3*sq3*z/22.0d0
          qy(ig,4) = (-5.0d0)*iymx**3*sq3*z*(165*z**2-11*iymx**2-45)/88.0d0
       end do
    case (493)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*iymx**2*sq5/7.0d0
          qy(ig,3) = (-9.0d0)*iymx**2*sq5*(28*z**2-7*iymx**2-4)/616.0d0
          qy(ig,4) = 5.0d0*iymx**2*sq5*(264*z**4-33*iymx**2*z**2-144*z**2+3*iymx**2+8)/176.0d0
       end do
    case (494)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx*sq5*z/7.0d0
          qy(ig,3) = 9.0d0*iymx*sq5*z*(28*z**2-7*iymx**2-12)/154.0d0
          qy(ig,4) = (-5.0d0)*iymx*sq5*z*(99*z**4-22*iymx**2*z**2-90*z**2+6*iymx**2+15)/88.0d0
       end do
    case (495)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*sq3/7.0d0
          qy(ig,2) = (-5.0d0)*iymx**2/(14.0d0*sq3)
          qy(ig,3) = (-3.0d0)*sq3*(245*z**4-105*iymx**2*z**2-210*z**2+15*iymx**2+21)/308.0d0
          qy(ig,4) = 5.0d0*(2772*z**6-1155*iymx**2*z**4-3780*z**4+630*iymx**2*z**2+1260*z**2-35*iymx**2-60)/(1232.0d0*sq3)
       end do
    case (496)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*(iypx-iymx)*z/7.0d0
          qy(ig,3) = 45.0d0*(iypx-iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = (-5.0d0)*(iypx-iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (497)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx**3*sq35/4.0d0
       end do
    case (498)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (499)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3*sq35*z/4.0d0
       end do
    case (500)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx**2*sq5/(2.0d0*sq7)
          qy(ig,2) = -iymx**2*sq5*(7*z**2-1)/sq7/4.0d0
       end do
    case (501)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**4*sq105/sq2/4.0d0
       end do
    case (502)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3*sq35*z/sq2/2.0d0
       end do
    case (503)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx**2*sq5/(2.0d0*sq14)
          qy(ig,2) = -iymx**2*sq5*(7*z**2-1)/sq14/4.0d0
       end do
    case (504)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (505)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = -iymx**4*sq105*z/sq2/4.0d0
       end do
    case (506)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**3*sq35/sq2/6.0d0
          qy(ig,3) = iymx**3*sq35*(3*z-1)*(3*z+1)/sq2/12.0d0
       end do
    case (507)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq35*z/sq2/2.0d0
          qy(ig,3) = -iymx**2*sq35*z*(3*z**2-1)/sq2/4.0d0
       end do
    case (508)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3*iymx*sq6/sq35
          qy(ig,2) = -iymx*sq7*(5*z**2-1)/sq30
          qy(ig,3) = iymx*sq5*(21*z**4-14*z**2+1)/sq42/4.0d0
       end do
    case (509)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 5.0d0*iymx**5*sq42/16.0d0
       end do
    case (510)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = -iymx**4*sq105*z/sq2/2.0d0
       end do
    case (511)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**3*sq35/sq3/4.0d0
          qy(ig,3) = iymx**3*sq35*(3*z-1)*(3*z+1)/sq3/8.0d0
       end do
    case (512)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq35*z/sq3/2.0d0
          qy(ig,3) = -iymx**2*sq35*z*(3*z**2-1)/sq3/4.0d0
       end do
    case (513)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9*iymx/sq210
          qy(ig,2) = -iymx*sq7*(5*z**2-1)/sq30/2.0d0
          qy(ig,3) = iymx*sq5*(21*z**4-14*z**2+1)/sq42/8.0d0
       end do
    case (514)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
       end do
    case (515)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 5.0d0*iymx**5*sq42*z/16.0d0
       end do
    case (516)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iymx**4*sq105/(44.0d0*sq2)
          qy(ig,4) = (-5.0d0)*iymx**4*sq105*(11*z**2-1)/(88.0d0*sq2)
       end do
    case (517)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-9.0d0)*iymx**3*sq105*z/44.0d0
          qy(ig,4) = 5.0d0*iymx**3*sq105*z*(11*z**2-3)/88.0d0
       end do
    case (518)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq5/sq21
          qy(ig,3) = 9.0d0*iymx**2*sq15*(7*z**2-1)/(22.0d0*sq7)
          qy(ig,4) = (-5.0d0)*iymx**2*sq35*(33*z**4-18*z**2+1)/(88.0d0*sq3)
       end do
    case (519)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 25*iymx*z/sq210
          qy(ig,3) = (-15.0d0)*iymx*sq30*z*(7*z**2-3)/(44.0d0*sq7)
          qy(ig,4) = 25.0d0*iymx*sq7*z*(33*z**4-30*z**2+5)/(88.0d0*sq30)
       end do
    case (520)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq6/sq7
          qy(ig,2) = -5*(3*z**2-1)/sq42
          qy(ig,3) = 9.0d0*sq6*(35*z**4-30*z**2+3)/(88.0d0*sq7)
          qy(ig,4) = (-5.0d0)*(231*z**6-315*z**4+105*z**2-5)/(88.0d0*sq42)
       end do
    case (521)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = (-35.0d0)*iymx**6/16.0d0
       end do
    case (522)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 15.0d0*iymx**5*sq7*z/8.0d0
       end do
    case (523)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iymx**4*sq21/88.0d0
          qy(ig,4) = (-25.0d0)*iymx**4*sq21*(11*z**2-1)/176.0d0
       end do
    case (524)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-9.0d0)*iymx**3*sq35*z/22.0d0
          qy(ig,4) = 5.0d0*iymx**3*sq35*z*(11*z**2-3)/44.0d0
       end do
    case (525)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq5/sq7/2.0d0
          qy(ig,3) = 27.0d0*iymx**2*sq5*(7*z**2-1)/(44.0d0*sq7)
          qy(ig,4) = (-5.0d0)*iymx**2*sq35*(33*z**4-18*z**2+1)/176.0d0
       end do
    case (526)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5*iymx*z/sq21
          qy(ig,3) = (-45.0d0)*iymx*z*(7*z**2-3)/(22.0d0*sq21)
          qy(ig,4) = 5.0d0*iymx*sq7*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
       end do
    case (527)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1/sq7
          qy(ig,2) = (-5.0d0)*(3*z**2-1)/(6.0d0*sq7)
          qy(ig,3) = 9.0d0*(35*z**4-30*z**2+3)/(88.0d0*sq7)
          qy(ig,4) = (-5.0d0)*(231*z**6-315*z**4+105*z**2-5)/(528.0d0*sq7)
       end do
    case (528)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 0
       end do
    case default
       write(6,*) 'getqy_two_x() invalid k3 = ', k3
       stop
    end select

    if (ik3.lt.0) then
       qy = conjg(qy)
    end if
    return
  end subroutine getqy_two_x

  subroutine getqy_two_y(qy,ik3,gk,nl,nkc,mll3)
    implicit none
    integer,intent(in):: ik3,nl,nkc
    integer,intent(out):: mll3
    real(kind=8),intent(in):: gk(4,nkc)
    complex(kind=8):: qy(nkc,nl)
    !
    real(kind=8),parameter:: eps = 1.0d-12
    real(kind=8),parameter:: sq2 = sqrt(2.0d0), &
         sq3 = sqrt(3.0d0), sq5 = sqrt(5.0d0), &
         sq6 = sqrt(6.0d0), sq7 = sqrt(7.0d0), &
         sq8 = sqrt(8.0d0), sq10 = sqrt(10.0d0), &
         sq14 = sqrt(14.0d0), &
         sq15 = sqrt(15.0d0), sq21 = sqrt(21.0d0), &
         sq30 = sqrt(30.0d0), sq35 = sqrt(35.0d0), &
         sq42 = sqrt(42.0d0), sq105 = sqrt(105.0d0), &
         sq210 = sqrt(210.0d0)
    complex(kind=8),parameter:: ci = (0.0d0,1.0d0)
    !
    integer:: k3
    integer:: ig,ist
    real(kind=8):: x,y,z,r
    complex(kind=8):: iypx, iymx
    !     
    k3 = abs(ik3)
    !
    ! FOR G=0
    if (gk(4,1).lt.eps) then
       qy(1,1:nl) = 0
       select case(k3)
       case (2)
          qy(1,1) = -ci
       case (9)
          qy(1,1) = ci/3.0d0
       case (13)
          qy(1,1) = -ci*sq2/sq3
       case (19)
          qy(1,1) = -ci*sq2/3.0d0
       case (20)
          qy(1,1) = -ci/sq3
       case (24)
          qy(1,1) = -ci*sq2/3.0d0
       case (27)
          qy(1,1) = (-2.0d0)*ci/3.0d0
       case (32)
          qy(1,1) = -ci*sq2/sq3
       case (35)
          qy(1,1) = -ci/sq3
       case (54)
          qy(1,1) = ci*sq3/5.0d0
       case (65)
          qy(1,1) = 2.0d0*ci/5.0d0
       case (77)
          qy(1,1) = ci*sq3/5.0d0
       case (87)
          qy(1,1) = -2*ci/sq5
       case (101)
          qy(1,1) = (-2.0d0)*ci*sq3/5.0d0
       case (104)
          qy(1,1) = -ci/sq5
       case (114)
          qy(1,1) = -ci*sq2/5.0d0
       case (116)
          qy(1,1) = -ci*sq6/5.0d0
       case (119)
          qy(1,1) = (-2.0d0)*ci*sq2/5.0d0
       case (130)
          qy(1,1) = -ci*sq6/5.0d0
       case (132)
          qy(1,1) = -ci*sq2/5.0d0
       case (135)
          qy(1,1) = (-3.0d0)*ci/5.0d0
       case (147)
          qy(1,1) = (-2.0d0)*ci*sq3/5.0d0
       case (152)
          qy(1,1) = (-2.0d0)*ci*sq2/5.0d0
       case (165)
          qy(1,1) = -2*ci/sq5
       case (170)
          qy(1,1) = -ci/sq5
       case (209)
          qy(1,1) = ci*sq5/7.0d0
       case (230)
          qy(1,1) = 2.0d0*ci*sq2/7.0d0
       case (252)
          qy(1,1) = 3.0d0*ci/7.0d0
       case (275)
          qy(1,1) = 2.0d0*ci*sq2/7.0d0
       case (299)
          qy(1,1) = ci*sq5/7.0d0
       case (319)
          qy(1,1) = -ci*sq6/sq7
       case (345)
          qy(1,1) = -ci*sq30/7.0d0
       case (350)
          qy(1,1) = -ci/sq7
       case (370)
          qy(1,1) = -ci*sq2/7.0d0
       case (372)
          qy(1,1) = (-2.0d0)*ci*sq5/7.0d0
       case (377)
          qy(1,1) = (-2.0d0)*ci*sq3/7.0d0
       case (398)
          qy(1,1) = -ci*sq6/7.0d0
       case (400)
          qy(1,1) = (-2.0d0)*ci*sq3/7.0d0
       case (405)
          qy(1,1) = -ci*sq15/7.0d0
       case (427)
          qy(1,1) = (-2.0d0)*ci*sq3/7.0d0
       case (429)
          qy(1,1) = -ci*sq6/7.0d0
       case (434)
          qy(1,1) = (-4.0d0)*ci/7.0d0
       case (457)
          qy(1,1) = (-2.0d0)*ci*sq5/7.0d0
       case (459)
          qy(1,1) = -ci*sq2/7.0d0
       case (464)
          qy(1,1) = -ci*sq15/7.0d0
       case (488)
          qy(1,1) = -ci*sq30/7.0d0
       case (495)
          qy(1,1) = (-2.0d0)*ci*sq3/7.0d0
       case (520)
          qy(1,1) = -ci*sq6/sq7
       case (527)
          qy(1,1) = -ci/sq7
       end select
       ist=2
    else
       ist=1
    end if

    select case(k3)
    case (1)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (2)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci
       end do
    case (3)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (4)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iypx
       end do
    case (5)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*z
       end do
    case (6)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*(iypx+iymx)*z
       end do
    case (7)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*z
       end do
    case (8)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iymx
       end do
    case (9)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci/3.0d0
          qy(ig,2) = ci*(3*z**2+3*iymx**2-1)/3.0d0
       end do
    case (10)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*(iypx+iymx)*z
       end do
    case (11)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (12)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iypx*sq3/sq2
       end do
    case (13)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq2/sq3
          qy(ig,2) = ci*(3*z**2-1)/sq6
       end do
    case (14)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iypx*sq3*z/sq2
       end do
    case (15)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (16)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iypx/sq2
       end do
    case (17)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq2*z
       end do
    case (18)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*(iypx-2*iymx)*z/sq2
       end do
    case (19)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq2/3.0d0
          qy(ig,2) = -ci*(6*z**2-3*iypx**2-2)/sq2/3.0d0
       end do
    case (20)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci/sq3
          qy(ig,2) = ci*(3*z**2-1)/sq3/2.0d0
       end do
    case (21)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*(iypx+iymx)*z
       end do
    case (22)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq2*z
       end do
    case (23)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iymx/sq2
       end do
    case (24)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq2/3.0d0
          qy(ig,2) = -ci*(6*z**2-3*iymx**2-2)/sq2/3.0d0
       end do
    case (25)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*(2*iypx-iymx)*z/sq2
       end do
    case (26)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx*sq3*z
       end do
    case (27)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci/3.0d0
          qy(ig,2) = -ci*(12*z**2+3*iymx**2-4)/6.0d0
       end do
    case (28)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*(iypx+iymx)*z
       end do
    case (29)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iymx*sq3/sq2
       end do
    case (30)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (31)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx*sq3*z/sq2
       end do
    case (32)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq2/sq3
          qy(ig,2) = ci*(3*z**2-1)/sq6
       end do
    case (33)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*ci*iymx**2/2.0d0
       end do
    case (34)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx*sq3*z
       end do
    case (35)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci/sq3
          qy(ig,2) = ci*(3*z**2-1)/sq3/2.0d0
       end do
    case (36)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (37)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iypx**2*sq6/2.0d0
       end do
    case (38)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3*ci*iypx*z/sq6
       end do
    case (39)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq6*z/5.0d0
          qy(ig,2) = 3.0d0*ci*sq2*z*(5*z**2+5*iypx**2-3)/(10.0d0*sq3)
       end do
    case (40)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iypx*sq3/sq2/5.0d0
          qy(ig,2) = -ci*iypx*sq3*(5*z**2+5*iypx**2-1)/sq2/5.0d0
       end do
    case (41)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*ci*iypx/5.0d0
          qy(ig,2) = (-3.0d0)*ci*iypx*(5*z**2-1)/10.0d0
       end do
    case (42)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq3*z/5.0d0
          qy(ig,2) = -ci*sq3*z*(5*z**2-10*iypx**2-3)/10.0d0
       end do
    case (43)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iypx*sq3/5.0d0
          qy(ig,2) = ci*iypx*sq3*(10*z**2-5*iypx**2-2)/10.0d0
       end do
    case (44)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*iypx**2*z/2.0d0
       end do
    case (45)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 6.0d0*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = (-3.0d0)*ci*(iypx+iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (46)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3*ci*iypx*z/sq2
       end do
    case (47)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*(3*z**2-1)/sq2
       end do
    case (48)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*(3*iypx-2*iymx)/sq2/5.0d0
          qy(ig,2) = 3.0d0*ci*(iypx+iymx)*(5*z**2-1)/(5.0d0*sq2)
       end do
    case (49)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq2*z/5.0d0
          qy(ig,2) = (-3.0d0)*ci*z*(5*z**2+5*iypx**2-3)/(5.0d0*sq2)
       end do
    case (50)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*sq3*z/5.0d0
          qy(ig,2) = (-3.0d0)*ci*sq3*z*(5*z**2-3)/10.0d0
       end do
    case (51)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*(3*iypx+iymx)/5.0d0
          qy(ig,2) = 3.0d0*ci*(2*iypx-iymx)*(5*z**2-1)/10.0d0
       end do
    case (52)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 4.0d0*ci*z/5.0d0
          qy(ig,2) = 3.0d0*ci*z*(10*z**2-5*iypx**2-6)/10.0d0
       end do
    case (53)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iypx*sq3/5.0d0
          qy(ig,2) = (-3.0d0)*ci*iypx*sq3*(5*z**2-1)/10.0d0
       end do
    case (54)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq3/5.0d0
          qy(ig,2) = ci*sq3*(3*z**2+4*iymx**2-1)/14.0d0
          qy(ig,3) = (-3.0d0)*ci*sq3*(35*z**4+35*iymx**2*z**2-30*z**2-5*iymx**2+3)/70.0d0
       end do
    case (55)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = 9.0d0*ci*(iypx+iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (56)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*(3*z**2-1)/sq2
       end do
    case (57)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3*ci*iymx*z/sq2
       end do
    case (58)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*ci*sq2*z/5.0d0
          qy(ig,2) = 3.0d0*ci*z*(5*z**2+5*iymx**2-3)/(5.0d0*sq2)
       end do
    case (59)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*(2*iypx-3*iymx)/sq2/5.0d0
          qy(ig,2) = (-3.0d0)*ci*(iypx+iymx)*(5*z**2-1)/(5.0d0*sq2)
       end do
    case (60)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iymx*sq3/5.0d0
          qy(ig,2) = (-3.0d0)*ci*iymx*sq3*(5*z**2-1)/10.0d0
       end do
    case (61)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 4.0d0*ci*z/5.0d0
          qy(ig,2) = 3.0d0*ci*z*(10*z**2-5*iymx**2-6)/10.0d0
       end do
    case (62)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*(iypx+3*iymx)/5.0d0
          qy(ig,2) = (-3.0d0)*ci*(iypx-2*iymx)*(5*z**2-1)/10.0d0
       end do
    case (63)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*sq3*z/5.0d0
          qy(ig,2) = (-3.0d0)*ci*sq3*z*(5*z**2-3)/10.0d0
       end do
    case (64)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx*sq3*z/7.0d0
          qy(ig,3) = (-3.0d0)*ci*iymx*sq3*z*(7*z**2+7*iymx**2-3)/14.0d0
       end do
    case (65)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*ci/5.0d0
          qy(ig,2) = ci*(12*z**2+9*iymx**2-4)/14.0d0
          qy(ig,3) = 9.0d0*ci*(35*z**4+35*iymx**2*z**2-30*z**2-5*iymx**2+3)/70.0d0
       end do
    case (66)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = (-9.0d0)*ci*(iypx+iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (67)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3*ci*iymx*z/sq6
       end do
    case (68)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3*ci*iymx**2/sq6
       end do
    case (69)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iymx/(5.0d0*sq6)
          qy(ig,2) = ci*iymx*sq6*(5*z**2+5*iymx**2-1)/10.0d0
       end do
    case (70)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq6*z/5.0d0
          qy(ig,2) = (-3.0d0)*ci*z*(5*z**2+5*iymx**2-3)/(5.0d0*sq6)
       end do
    case (71)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*iymx**2*z/2.0d0
       end do
    case (72)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iymx*sq3/5.0d0
          qy(ig,2) = ci*iymx*sq3*(10*z**2-5*iymx**2-2)/10.0d0
       end do
    case (73)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq3*z/5.0d0
          qy(ig,2) = -ci*sq3*z*(5*z**2-10*iymx**2-3)/10.0d0
       end do
    case (74)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*ci*iymx/5.0d0
          qy(ig,2) = (-3.0d0)*ci*iymx*(5*z**2-1)/10.0d0
       end do
    case (75)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*iymx**2/14.0d0
          qy(ig,3) = (-3.0d0)*ci*iymx**2*(7*z**2+7*iymx**2-1)/14.0d0
       end do
    case (76)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx*sq3*z/7.0d0
          qy(ig,3) = 3.0d0*ci*iymx*sq3*z*(7*z**2+7*iymx**2-3)/14.0d0
       end do
    case (77)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq3/5.0d0
          qy(ig,2) = ci*sq3*(3*z**2+4*iymx**2-1)/14.0d0
          qy(ig,3) = (-3.0d0)*ci*sq3*(35*z**4+35*iymx**2*z**2-30*z**2-5*iymx**2+3)/70.0d0
       end do
    case (78)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-6.0d0)*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = 3.0d0*ci*(iypx+iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (79)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (80)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iypx**2*sq30/4.0d0
       end do
    case (81)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iypx*sq30/5.0d0
          qy(ig,2) = ci*iypx*sq30*(5*z**2-1)/20.0d0
       end do
    case (82)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-15.0d0)*ci*iypx**2*z/(2.0d0*sq30)
       end do
    case (83)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (84)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iypx*sq15/5.0d0
          qy(ig,2) = -ci*iypx*sq15*(5*z**2-1)/20.0d0
       end do
    case (85)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iypx**2*sq15*z/2.0d0
       end do
    case (86)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*iypx**3*sq5/4.0d0
       end do
    case (87)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -2*ci/sq5
          qy(ig,2) = 2.0d0*ci*sq5*(3*z**2-1)/7.0d0
          qy(ig,3) = (-3.0d0)*ci*(35*z**4-30*z**2+3)/(28.0d0*sq5)
       end do
    case (88)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*iypx*sq15*z/7.0d0
          qy(ig,3) = 3.0d0*ci*iypx*sq15*z*(7*z**2-3)/28.0d0
       end do
    case (89)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iypx**2*sq15/7.0d0
          qy(ig,3) = (-3.0d0)*ci*iypx**2*sq15*(7*z**2-1)/28.0d0
       end do
    case (90)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*ci*iypx**3*sq5*z/4.0d0
       end do
    case (91)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
       end do
    case (92)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iypx**2*sq6/4.0d0
       end do
    case (93)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iypx*sq6*z
       end do
    case (94)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq6*z/5.0d0
          qy(ig,2) = 3.0d0*ci*z*(20*z**2-5*iypx**2-12)/(10.0d0*sq6)
       end do
    case (95)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iypx*sq6/5.0d0
          qy(ig,2) = -ci*iypx*sq6*(20*z**2-5*iypx**2-4)/20.0d0
       end do
    case (96)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iypx/5.0d0
          qy(ig,2) = 3.0d0*ci*iypx*(5*z**2-1)/20.0d0
       end do
    case (97)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*ci*sq3*z/5.0d0
          qy(ig,2) = -ci*sq3*z*(10*z**2+5*iypx**2-6)/10.0d0
       end do
    case (98)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*ci*iypx*sq3/5.0d0
          qy(ig,2) = ci*iypx*sq3*(40*z**2+5*iypx**2-8)/20.0d0
       end do
    case (99)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -3*ci*iypx**2*z
       end do
    case (100)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*(iypx-4*iymx)*z/7.0d0
          qy(ig,3) = 3.0d0*ci*(iypx-4*iymx)*z*(7*z**2-3)/28.0d0
       end do
    case (101)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq3/5.0d0
          qy(ig,2) = -ci*sq3*(3*z**2-iypx**2-1)/7.0d0
          qy(ig,3) = 3.0d0*ci*sq3*(140*z**4-35*iypx**2*z**2-120*z**2+5*iypx**2+12)/140.0d0
       end do
    case (102)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*ci*iypx*sq3*z/7.0d0
          qy(ig,3) = (-3.0d0)*ci*iypx*sq3*z*(28*z**2-7*iypx**2-12)/28.0d0
       end do
    case (103)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*ci*iypx**2/7.0d0
          qy(ig,3) = 3.0d0*ci*iypx**2*(28*z**2-7*iypx**2-4)/28.0d0
       end do
    case (104)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci/sq5
          qy(ig,2) = ci*sq5*(3*z**2-1)/7.0d0
          qy(ig,3) = (-3.0d0)*ci*(35*z**4-30*z**2+3)/(56.0d0*sq5)
       end do
    case (105)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-6.0d0)*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = 3.0d0*ci*(iypx+iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (106)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iypx*sq3*z
       end do
    case (107)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq3*(3*z**2-1)/2.0d0
       end do
    case (108)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*(iypx+iymx)*sq3/5.0d0
          qy(ig,2) = -ci*(2*iypx-3*iymx)*sq3*(5*z**2-1)/10.0d0
       end do
    case (109)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq3*z/5.0d0
          qy(ig,2) = -ci*sq3*z*(15*z**2-10*iypx**2-9)/10.0d0
       end do
    case (110)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*sq2*z/5.0d0
          qy(ig,2) = 3.0d0*ci*z*(5*z**2-3)/(5.0d0*sq2)
       end do
    case (111)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*(2*iypx-iymx)*sq3/sq2/5.0d0
          qy(ig,2) = -ci*(4*iypx+3*iymx)*sq3*(5*z**2-1)/sq2/10.0d0
       end do
    case (112)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*ci*sq6*z/5.0d0
          qy(ig,2) = ci*sq3*z*(15*z**2+5*iypx**2-9)/sq2/5.0d0
       end do
    case (113)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iypx/(5.0d0*sq2)
          qy(ig,2) = (-9.0d0)*ci*iypx*(5*z**2-1)/(10.0d0*sq2)
       end do
    case (114)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq2/5.0d0
          qy(ig,2) = -ci*(3*z**2-6*iymx**2-1)/sq2/7.0d0
          qy(ig,3) = 3.0d0*ci*(70*z**4-105*iymx**2*z**2-60*z**2+15*iymx**2+6)/(70.0d0*sq2)
       end do
    case (115)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*(2*iypx-3*iymx)*sq3*z/sq2/7.0d0
          qy(ig,3) = (-3.0d0)*ci*(2*iypx-3*iymx)*sq3*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (116)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq6/5.0d0
          qy(ig,2) = -ci*sq3*(6*z**2-3*iypx**2-2)/sq2/7.0d0
          qy(ig,3) = (-3.0d0)*ci*sq3*(105*z**4-70*iypx**2*z**2-90*z**2+10*iypx**2+9)/(70.0d0*sq2)
       end do
    case (117)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*ci*iypx*z/(7.0d0*sq2)
          qy(ig,3) = 3.0d0*ci*iypx*z*(21*z**2-14*iypx**2-9)/(14.0d0*sq2)
       end do
    case (118)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*ci*iymx*sq10*z/7.0d0
          qy(ig,3) = (-3.0d0)*ci*iymx*sq10*z*(7*z**2-3)/28.0d0
       end do
    case (119)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq2/5.0d0
          qy(ig,2) = -ci*(6*z**2+3*iymx**2-2)/sq2/7.0d0
          qy(ig,3) = 3.0d0*ci*(280*z**4+105*iymx**2*z**2-240*z**2-15*iymx**2+24)/(140.0d0*sq2)
       end do
    case (120)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = (-9.0d0)*ci*(iypx+iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (121)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq3*(3*z**2-1)/2.0d0
       end do
    case (122)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iymx*sq3*z
       end do
    case (123)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq3*z/5.0d0
          qy(ig,2) = -ci*sq3*z*(15*z**2-10*iymx**2-9)/10.0d0
       end do
    case (124)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*(iypx+iymx)*sq3/5.0d0
          qy(ig,2) = ci*(3*iypx-2*iymx)*sq3*(5*z**2-1)/10.0d0
       end do
    case (125)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iymx/(5.0d0*sq2)
          qy(ig,2) = 9.0d0*ci*iymx*(5*z**2-1)/(10.0d0*sq2)
       end do
    case (126)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq6*z/5.0d0
          qy(ig,2) = -ci*sq2*sq3*z*(15*z**2+5*iymx**2-9)/10.0d0
       end do
    case (127)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*(iypx-2*iymx)*sq3/sq2/5.0d0
          qy(ig,2) = ci*(3*iypx+4*iymx)*sq3*(5*z**2-1)/sq2/10.0d0
       end do
    case (128)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*sq2*z/5.0d0
          qy(ig,2) = (-3.0d0)*ci*z*(5*z**2-3)/(5.0d0*sq2)
       end do
    case (129)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*ci*iymx*z/(7.0d0*sq2)
          qy(ig,3) = 3.0d0*ci*iymx*z*(21*z**2-14*iymx**2-9)/(14.0d0*sq2)
       end do
    case (130)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq6/5.0d0
          qy(ig,2) = -ci*sq3*(6*z**2-3*iymx**2-2)/sq2/7.0d0
          qy(ig,3) = (-3.0d0)*ci*sq3*(105*z**4-70*iymx**2*z**2-90*z**2+10*iymx**2+9)/(70.0d0*sq2)
       end do
    case (131)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*ci*(3*iypx-2*iymx)*z/(7.0d0*sq6)
          qy(ig,3) = 3.0d0*ci*(3*iypx-2*iymx)*sq6*z*(7*z**2-3)/28.0d0
       end do
    case (132)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq2/5.0d0
          qy(ig,2) = -ci*(3*z**2-6*iypx**2-1)/sq2/7.0d0
          qy(ig,3) = 3.0d0*ci*(70*z**4-105*iypx**2*z**2-60*z**2+15*iypx**2+6)/(70.0d0*sq2)
       end do
    case (133)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*ci*iymx**2*sq10/14.0d0
          qy(ig,3) = (-9.0d0)*ci*iymx**2*sq10*(7*z**2-1)/56.0d0
       end do
    case (134)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*ci*iymx*sq2*z/7.0d0
          qy(ig,3) = 3.0d0*ci*iymx*z*(42*z**2+7*iymx**2-18)/(14.0d0*sq2)
       end do
    case (135)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci/5.0d0
          qy(ig,2) = (-3.0d0)*ci*(3*z**2+iymx**2-1)/7.0d0
          qy(ig,3) = (-3.0d0)*ci*(315*z**4+140*iymx**2*z**2-270*z**2-20*iymx**2+27)/140.0d0
       end do
    case (136)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = 9.0d0*ci*(iypx+iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (137)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iymx*sq6*z
       end do
    case (138)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iymx**2/(2.0d0*sq6)
       end do
    case (139)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iymx*sq6/5.0d0
          qy(ig,2) = -ci*iymx*sq6*(20*z**2-5*iymx**2-4)/20.0d0
       end do
    case (140)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq6*z/5.0d0
          qy(ig,2) = 3.0d0*ci*z*(20*z**2-5*iymx**2-12)/(10.0d0*sq6)
       end do
    case (141)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3*ci*iymx**2*z
       end do
    case (142)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*iymx*sq3/5.0d0
          qy(ig,2) = -ci*iymx*sq3*(40*z**2+5*iymx**2-8)/20.0d0
       end do
    case (143)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq3*z/5.0d0
          qy(ig,2) = ci*sq3*z*(10*z**2+5*iymx**2-6)/10.0d0
       end do
    case (144)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iymx/5.0d0
          qy(ig,2) = (-3.0d0)*ci*iymx*(5*z**2-1)/20.0d0
       end do
    case (145)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*ci*iymx**2/7.0d0
          qy(ig,3) = 3.0d0*ci*iymx**2*(28*z**2-7*iymx**2-4)/28.0d0
       end do
    case (146)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*ci*iymx*sq3*z/7.0d0
          qy(ig,3) = (-3.0d0)*ci*iymx*sq3*z*(28*z**2-7*iymx**2-12)/28.0d0
       end do
    case (147)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq3/5.0d0
          qy(ig,2) = -ci*sq3*(3*z**2-iymx**2-1)/7.0d0
          qy(ig,3) = 3.0d0*ci*sq3*(140*z**4-35*iymx**2*z**2-120*z**2+5*iymx**2+12)/140.0d0
       end do
    case (148)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*ci*(4*iypx-iymx)*z/7.0d0
          qy(ig,3) = (-3.0d0)*ci*(4*iypx-iymx)*z*(7*z**2-3)/28.0d0
       end do
    case (149)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*ci*iymx**3*sq5*z/2.0d0
       end do
    case (150)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 6.0d0*ci*iymx**2/7.0d0
          qy(ig,3) = 3.0d0*ci*iymx**2*(112*z**2+7*iymx**2-16)/56.0d0
       end do
    case (151)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*iymx*sq2*z/7.0d0
          qy(ig,3) = (-3.0d0)*ci*iymx*z*(42*z**2+7*iymx**2-18)/(14.0d0*sq2)
       end do
    case (152)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq2/5.0d0
          qy(ig,2) = -ci*(6*z**2+3*iymx**2-2)/sq2/7.0d0
          qy(ig,3) = 3.0d0*ci*(280*z**4+105*iymx**2*z**2-240*z**2-15*iymx**2+24)/(140.0d0*sq2)
       end do
    case (153)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 6.0d0*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = (-3.0d0)*ci*(iypx+iymx)*z*(7*z**2-3)/14.0d0
       end do
    case (154)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iymx**2*sq5/(2.0d0*sq6)
       end do
    case (155)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (156)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*iymx**2*sq5*z/(2.0d0*sq6)
       end do
    case (157)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iymx*sq6/sq5
          qy(ig,2) = ci*iymx*sq6*(5*z**2-1)/sq5/4.0d0
       end do
    case (158)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*ci*iymx**3*sq5/4.0d0
       end do
    case (159)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx**2*sq15*z/2.0d0
       end do
    case (160)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -3*ci*iymx/sq15
          qy(ig,2) = 3.0d0*ci*iymx*(5*z**2-1)/(4.0d0*sq15)
       end do
    case (161)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (162)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*ci*iymx**3*sq5*z/4.0d0
       end do
    case (163)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx**2*sq15/7.0d0
          qy(ig,3) = (-3.0d0)*ci*iymx**2*sq15*(7*z**2-1)/28.0d0
       end do
    case (164)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*iymx*sq15*z/7.0d0
          qy(ig,3) = 3.0d0*ci*iymx*sq15*z*(7*z**2-3)/28.0d0
       end do
    case (165)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -2*ci/sq5
          qy(ig,2) = 2.0d0*ci*sq5*(3*z**2-1)/7.0d0
          qy(ig,3) = (-3.0d0)*ci*(35*z**4-30*z**2+3)/(28.0d0*sq5)
       end do
    case (166)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*ci*iymx**4/8.0d0
       end do
    case (167)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*ci*iymx**3*sq5*z/2.0d0
       end do
    case (168)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*ci*iymx**2*sq5/(7.0d0*sq2)
          qy(ig,3) = (-9.0d0)*ci*iymx**2*sq5*(7*z**2-1)/(28.0d0*sq2)
       end do
    case (169)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*iymx*sq10*z/7.0d0
          qy(ig,3) = 3.0d0*ci*iymx*sq5*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (170)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci/sq5
          qy(ig,2) = ci*sq5*(3*z**2-1)/7.0d0
          qy(ig,3) = (-3.0d0)*ci*(35*z**4-30*z**2+3)/(56.0d0*sq5)
       end do
    case (171)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
       end do
    case (172)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iypx**3*sq5/(2.0d0*sq6)
       end do
    case (173)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iypx**2*sq30*z/4.0d0
       end do
    case (174)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iypx*sq30*z/7.0d0
          qy(ig,2) = 3.0d0*ci*iypx*sq5*z*(7*z**2+7*iypx**2-3)/(14.0d0*sq6)
       end do
    case (175)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iypx**2*sq30/28.0d0
          qy(ig,2) = -ci*iypx**2*sq30*(7*z**2+7*iypx**2-1)/28.0d0
       end do
    case (176)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*iypx**2*sq5/14.0d0
          qy(ig,2) = (-3.0d0)*ci*iypx**2*sq5*(7*z**2-1)/28.0d0
       end do
    case (177)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iypx*sq15*z/7.0d0
          qy(ig,2) = -ci*iypx*sq15*z*(7*z**2-14*iypx**2-3)/28.0d0
       end do
    case (178)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iypx**2*sq15/14.0d0
          qy(ig,2) = ci*iypx**2*sq15*(14*z**2-7*iypx**2-2)/28.0d0
       end do
    case (179)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*iypx**3*sq5*z/4.0d0
       end do
    case (180)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*ci*z/(7.0d0*sq5)
          qy(ig,2) = ci*z*(20*z**2+15*iypx**2-12)/sq5/6.0d0
          qy(ig,3) = -ci*sq5*z*(63*z**4+63*iypx**2*z**2-70*z**2-21*iypx**2+15)/84.0d0
       end do
    case (181)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iypx*sq3/(7.0d0*sq5)
          qy(ig,2) = -ci*iypx*sq3*(15*z**2+10*iypx**2-3)/sq5/12.0d0
          qy(ig,3) = ci*iypx*sq15*(63*z**4+63*iypx**2*z**2-42*z**2-7*iypx**2+3)/84.0d0
       end do
    case (182)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = -ci*iypx**2*sq15*z*(3*z**2+3*iypx**2-1)/4.0d0
       end do
    case (183)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iypx**3*sq5/12.0d0
          qy(ig,3) = ci*iypx**3*sq5*(9*z**2+9*iypx**2-1)/12.0d0
       end do
    case (184)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*iypx/7.0d0
          qy(ig,2) = -ci*iypx*(5*z**2-1)/2.0d0
          qy(ig,3) = 5.0d0*ci*iypx*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (185)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*z/(7.0d0*sq5)
          qy(ig,2) = -ci*z*(5*z**2-15*iypx**2-3)/sq5/3.0d0
          qy(ig,3) = ci*sq5*z*(63*z**4-252*iypx**2*z**2-70*z**2+84*iypx**2+15)/168.0d0
       end do
    case (186)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iypx*sq2/(7.0d0*sq5)
          qy(ig,2) = ci*iypx*(5*z**2-5*iypx**2-1)/sq10/2.0d0
          qy(ig,3) = -ci*iypx*sq10*(42*z**4-63*iypx**2*z**2-28*z**2+7*iypx**2+2)/56.0d0
       end do
    case (187)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*ci*iypx**2*sq2*z*(3*z**2-2*iypx**2-1)/(8.0d0*sq5)
       end do
    case (188)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iypx**3*sq5/6.0d0
          qy(ig,3) = -ci*iypx**3*sq5*(36*z**2-9*iypx**2-4)/24.0d0
       end do
    case (189)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*ci*iypx**4*z/8.0d0
       end do
    case (190)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = (-45.0d0)*ci*(iypx+iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = 5.0d0*ci*(iypx+iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (191)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 5.0d0*ci*iypx**2*sq6*z/4.0d0
       end do
    case (192)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iypx*sq3*(5*z**2-1)/sq2/2.0d0
       end do
    case (193)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq6*(12*z**2-5*iypx**2-4)/28.0d0
          qy(ig,2) = ci*sq3*(35*z**4+35*iypx**2*z**2-30*z**2-5*iypx**2+3)/sq2/14.0d0
       end do
    case (194)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*iypx*sq6*z/7.0d0
          qy(ig,2) = (-5.0d0)*ci*iypx*sq3*z*(7*z**2+7*iypx**2-3)/(14.0d0*sq2)
       end do
    case (195)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 15.0d0*ci*iypx*z/7.0d0
          qy(ig,2) = (-15.0d0)*ci*iypx*z*(7*z**2-3)/28.0d0
       end do
    case (196)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq3*(6*z**2+5*iypx**2-2)/14.0d0
          qy(ig,2) = -ci*sq3*(35*z**4-70*iypx**2*z**2-30*z**2+10*iypx**2+3)/28.0d0
       end do
    case (197)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 4.0d0*ci*iypx*sq3*z/7.0d0
          qy(ig,2) = 5.0d0*ci*iypx*sq3*z*(14*z**2-7*iypx**2-6)/28.0d0
       end do
    case (198)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iypx**2/14.0d0
          qy(ig,2) = (-15.0d0)*ci*iypx**2*(7*z**2-1)/28.0d0
       end do
    case (199)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*(5*iypx-2*iymx)/35.0d0
          qy(ig,2) = ci*(5*iypx+8*iymx)*(5*z**2-1)/20.0d0
          qy(ig,3) = (-5.0d0)*ci*(iypx+iymx)*(21*z**4-14*z**2+1)/28.0d0
       end do
    case (200)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-12.0d0)*ci*sq3*z/35.0d0
          qy(ig,2) = -ci*z*(5*z**2-3)/sq3/5.0d0
          qy(ig,3) = 5.0d0*ci*z*(63*z**4+63*iypx**2*z**2-70*z**2-21*iypx**2+15)/(28.0d0*sq3)
       end do
    case (201)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*ci*iypx*sq3/35.0d0
          qy(ig,2) = -ci*iypx*(30*z**2+25*iypx**2-6)/sq3/20.0d0
          qy(ig,3) = (-5.0d0)*ci*iypx*(63*z**4+63*iypx**2*z**2-42*z**2-7*iypx**2+3)/(28.0d0*sq3)
       end do
    case (202)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iypx**2*z/2.0d0
          qy(ig,3) = 5.0d0*ci*iypx**2*z*(3*z**2+3*iypx**2-1)/4.0d0
       end do
    case (203)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*sq5*z/7.0d0
          qy(ig,2) = -ci*sq5*z*(5*z**2-3)/3.0d0
          qy(ig,3) = 5.0d0*ci*sq5*z*(63*z**4-70*z**2+15)/168.0d0
       end do
    case (204)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*(10*iypx+iymx)/35.0d0
          qy(ig,2) = ci*(5*iypx-2*iymx)*(5*z**2-1)/10.0d0
          qy(ig,3) = (-5.0d0)*ci*(4*iypx-iymx)*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (205)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 12.0d0*ci*sq2*z/35.0d0
          qy(ig,2) = ci*sq2*z*(5*z**2-3)/15.0d0
          qy(ig,3) = (-5.0d0)*ci*z*(126*z**4-189*iypx**2*z**2-140*z**2+63*iypx**2+30)/(84.0d0*sq2)
       end do
    case (206)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*iypx*sq2/35.0d0
          qy(ig,2) = ci*iypx*(45*z**2-25*iypx**2-9)/sq2/30.0d0
          qy(ig,3) = 5.0d0*ci*iypx*(189*z**4-126*iypx**2*z**2-126*z**2+14*iypx**2+9)/(84.0d0*sq2)
       end do
    case (207)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iypx**2*z
          qy(ig,3) = (-5.0d0)*ci*iypx**2*z*(12*z**2-3*iypx**2-4)/8.0d0
       end do
    case (208)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iypx**3*sq5/6.0d0
          qy(ig,3) = 5.0d0*ci*iypx**3*sq5*(3*z-1)*(3*z+1)/24.0d0
       end do
    case (209)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq5/7.0d0
          qy(ig,2) = ci*iymx**2*sq5/7.0d0
          qy(ig,3) = (-3.0d0)*ci*sq5*(245*z**4+252*iymx**2*z**2-210*z**2-36*iymx**2+21)/616.0d0
          qy(ig,4) = 5.0d0*ci*sq5*(231*z**6+231*iymx**2*z**4-315*z**4-126*iymx**2*z**2+105*z**2+7*iymx**2-5)/616.0d0
       end do
    case (210)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = 30.0d0*ci*(iypx+iymx)*z*(7*z**2-3)/77.0d0
          qy(ig,4) = (-25.0d0)*ci*(iypx+iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (211)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iypx*sq3*(5*z**2-1)/2.0d0
       end do
    case (212)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq3*z*(5*z**2-3)/2.0d0
       end do
    case (213)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*(4*iypx-3*iymx)*sq3*z/7.0d0
          qy(ig,2) = 5.0d0*ci*(iypx+iymx)*sq3*z*(7*z**2-3)/14.0d0
       end do
    case (214)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq3*(9*z**2-2*iypx**2-3)/14.0d0
          qy(ig,2) = -ci*sq3*(35*z**4+35*iypx**2*z**2-30*z**2-5*iypx**2+3)/14.0d0
       end do
    case (215)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*sq2*(3*z**2-1)/7.0d0
          qy(ig,2) = (-3.0d0)*ci*(35*z**4-30*z**2+3)/(14.0d0*sq2)
       end do
    case (216)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*(8*iypx+3*iymx)*sq3*z/sq2/7.0d0
          qy(ig,2) = 5.0d0*ci*(2*iypx-iymx)*sq3*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (217)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq3*(9*z**2+iypx**2-3)/sq2/7.0d0
          qy(ig,2) = ci*sq3*(70*z**4-35*iypx**2*z**2-60*z**2+5*iypx**2+6)/sq2/14.0d0
       end do
    case (218)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*iypx*z/(7.0d0*sq2)
          qy(ig,2) = (-15.0d0)*ci*iypx*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (219)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 12.0d0*ci*sq2*z/35.0d0
          qy(ig,2) = ci*sq2*z*(5*z**2+15*iymx**2-3)/15.0d0
          qy(ig,3) = (-5.0d0)*ci*z*(63*z**4+63*iymx**2*z**2-70*z**2-21*iymx**2+15)/(42.0d0*sq2)
       end do
    case (220)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*(4*iypx-3*iymx)*sq3/(35.0d0*sq2)
          qy(ig,2) = ci*(2*iypx+iymx)*sq3*(5*z**2-1)/sq2/10.0d0
          qy(ig,3) = 5.0d0*ci*(iypx+iymx)*sq3*(21*z**4-14*z**2+1)/(14.0d0*sq2)
       end do
    case (221)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*ci*sq6*z/35.0d0
          qy(ig,2) = -ci*z*(20*z**2+15*iypx**2-12)/sq6/5.0d0
          qy(ig,3) = (-5.0d0)*ci*sq2*z*(63*z**4+63*iypx**2*z**2-70*z**2-21*iypx**2+15)/(28.0d0*sq3)
       end do
    case (222)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*ci*iypx/(35.0d0*sq2)
          qy(ig,2) = ci*iypx*(15*z**2-20*iypx**2-3)/sq2/30.0d0
          qy(ig,3) = 5.0d0*ci*iypx*(63*z**4+63*iypx**2*z**2-42*z**2-7*iypx**2+3)/(42.0d0*sq2)
       end do
    case (223)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iymx*sq10/35.0d0
          qy(ig,2) = -2*ci*iymx*(5*z**2-1)/sq10
          qy(ig,3) = 5.0d0*ci*iymx*sq10*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (224)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 24.0d0*ci*sq2*z/35.0d0
          qy(ig,2) = ci*z*(20*z**2-15*iymx**2-12)/sq2/15.0d0
          qy(ig,3) = (-5.0d0)*ci*z*(252*z**4-63*iymx**2*z**2-280*z**2+21*iymx**2+60)/(84.0d0*sq2)
       end do
    case (225)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*(2*iypx+iymx)/35.0d0
          qy(ig,2) = ci*(3*iypx-iymx)*(5*z**2-1)/10.0d0
          qy(ig,3) = 5.0d0*ci*(3*iypx-2*iymx)*(21*z**4-14*z**2+1)/28.0d0
       end do
    case (226)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 27.0d0*ci*z/35.0d0
          qy(ig,2) = ci*z*(10*z**2-5*iypx**2-6)/5.0d0
          qy(ig,3) = 5.0d0*ci*z*(63*z**4-42*iypx**2*z**2-70*z**2+14*iypx**2+15)/28.0d0
       end do
    case (227)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*iypx*sq2/35.0d0
          qy(ig,2) = -ci*iypx*(15*z**2+5*iypx**2-3)/sq2/15.0d0
          qy(ig,3) = (-5.0d0)*ci*iypx*(252*z**4-63*iypx**2*z**2-168*z**2+7*iypx**2+12)/(84.0d0*sq2)
       end do
    case (228)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iypx**2*sq5*z/sq2
          qy(ig,3) = 5.0d0*ci*iypx**2*sq5*z*(3*z**2-1)/(4.0d0*sq2)
       end do
    case (229)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx*sq10*z/7.0d0
          qy(ig,3) = (-3.0d0)*ci*iymx*sq10*z*(56*z**2+63*iymx**2-24)/308.0d0
          qy(ig,4) = 5.0d0*ci*iymx*sq10*z*(33*z**4+33*iymx**2*z**2-30*z**2-9*iymx**2+5)/88.0d0
       end do
    case (230)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*ci*sq2/7.0d0
          qy(ig,2) = ci*(6*z**2+5*iymx**2-2)/sq2/7.0d0
          qy(ig,3) = 3.0d0*ci*(70*z**4+105*iymx**2*z**2-60*z**2-15*iymx**2+6)/(308.0d0*sq2)
          qy(ig,4) = (-25.0d0)*ci*(231*z**6+231*iymx**2*z**4-315*z**4-126*iymx**2*z**2+105*z**2+7*iymx**2-5)/(308.0d0*sq2)
       end do
    case (231)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 2.0d0*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = 45.0d0*ci*(iypx+iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = 25.0d0*ci*(iypx+iymx)*z*(33*z**4-30*z**2+5)/44.0d0
       end do
    case (232)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq3*z*(5*z**2-3)/2.0d0
       end do
    case (233)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iymx*sq3*(5*z**2-1)/2.0d0
       end do
    case (234)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq3*(9*z**2-2*iymx**2-3)/14.0d0
          qy(ig,2) = ci*sq3*(35*z**4+35*iymx**2*z**2-30*z**2-5*iymx**2+3)/14.0d0
       end do
    case (235)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*(3*iypx-4*iymx)*sq3*z/7.0d0
          qy(ig,2) = (-5.0d0)*ci*(iypx+iymx)*sq3*z*(7*z**2-3)/14.0d0
       end do
    case (236)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*iymx*z/(7.0d0*sq2)
          qy(ig,2) = (-15.0d0)*ci*iymx*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (237)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq3*(9*z**2+iymx**2-3)/sq2/7.0d0
          qy(ig,2) = ci*sq3*(70*z**4-35*iymx**2*z**2-60*z**2+5*iymx**2+6)/sq2/14.0d0
       end do
    case (238)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*(3*iypx+8*iymx)*sq3*z/sq2/7.0d0
          qy(ig,2) = (-5.0d0)*ci*(iypx-2*iymx)*sq3*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (239)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*sq2*(3*z**2-1)/7.0d0
          qy(ig,2) = (-3.0d0)*ci*(35*z**4-30*z**2+3)/(14.0d0*sq2)
       end do
    case (240)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*iymx/(35.0d0*sq2)
          qy(ig,2) = -ci*iymx*(15*z**2-20*iymx**2-3)/sq2/30.0d0
          qy(ig,3) = (-5.0d0)*ci*iymx*(63*z**4+63*iymx**2*z**2-42*z**2-7*iymx**2+3)/(42.0d0*sq2)
       end do
    case (241)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*sq6*z/35.0d0
          qy(ig,2) = ci*z*(20*z**2+15*iymx**2-12)/sq6/5.0d0
          qy(ig,3) = 5.0d0*ci*sq2*z*(63*z**4+63*iymx**2*z**2-70*z**2-21*iymx**2+15)/(28.0d0*sq3)
       end do
    case (242)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*(3*iypx-4*iymx)/(35.0d0*sq6)
          qy(ig,2) = -ci*(iypx+2*iymx)*sq3*(5*z**2-1)/sq2/10.0d0
          qy(ig,3) = (-5.0d0)*ci*(iypx+iymx)*sq3*(21*z**4-14*z**2+1)/(14.0d0*sq2)
       end do
    case (243)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-12.0d0)*ci*sq2*z/35.0d0
          qy(ig,2) = -ci*sq2*z*(5*z**2+15*iypx**2-3)/15.0d0
          qy(ig,3) = 5.0d0*ci*z*(63*z**4+63*iypx**2*z**2-70*z**2-21*iypx**2+15)/(42.0d0*sq2)
       end do
    case (244)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx**2*sq10*z/2.0d0
          qy(ig,3) = 5.0d0*ci*iymx**2*sq10*z*(3*z**2-1)/8.0d0
       end do
    case (245)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*iymx*sq2/35.0d0
          qy(ig,2) = -ci*iymx*(15*z**2+5*iymx**2-3)/sq2/15.0d0
          qy(ig,3) = (-5.0d0)*ci*iymx*(252*z**4-63*iymx**2*z**2-168*z**2+7*iymx**2+12)/(84.0d0*sq2)
       end do
    case (246)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 27.0d0*ci*z/35.0d0
          qy(ig,2) = ci*z*(10*z**2-5*iymx**2-6)/5.0d0
          qy(ig,3) = 5.0d0*ci*z*(63*z**4-42*iymx**2*z**2-70*z**2+14*iymx**2+15)/28.0d0
       end do
    case (247)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*(iypx+2*iymx)/35.0d0
          qy(ig,2) = -ci*(iypx-3*iymx)*(5*z**2-1)/10.0d0
          qy(ig,3) = (-5.0d0)*ci*(2*iypx-3*iymx)*(21*z**4-14*z**2+1)/28.0d0
       end do
    case (248)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 24.0d0*ci*sq2*z/35.0d0
          qy(ig,2) = ci*z*(20*z**2-15*iypx**2-12)/sq2/15.0d0
          qy(ig,3) = (-5.0d0)*ci*z*(252*z**4-63*iypx**2*z**2-280*z**2+21*iypx**2+60)/(84.0d0*sq2)
       end do
    case (249)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*ci*iypx/(7.0d0*sq10)
          qy(ig,2) = -2*ci*iypx*(5*z**2-1)/sq10
          qy(ig,3) = 5.0d0*ci*iypx*sq5*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (250)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx**2*sq10/14.0d0
          qy(ig,3) = (-9.0d0)*ci*iymx**2*sq10*(7*z**2+14*iymx**2-1)/616.0d0
          qy(ig,4) = 5.0d0*ci*iymx**2*sq10*(33*z**4+33*iymx**2*z**2-18*z**2-3*iymx**2+1)/88.0d0
       end do
    case (251)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx*sq2*z/7.0d0
          qy(ig,3) = (-15.0d0)*ci*iymx*z*(21*z**2+14*iymx**2-9)/(154.0d0*sq2)
          qy(ig,4) = (-25.0d0)*ci*iymx*z*(33*z**4+33*iymx**2*z**2-30*z**2-9*iymx**2+5)/(44.0d0*sq2)
       end do
    case (252)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci/7.0d0
          qy(ig,2) = 2.0d0*ci*(3*z**2+2*iymx**2-1)/7.0d0
          qy(ig,3) = 3.0d0*ci*(315*z**4+280*iymx**2*z**2-270*z**2-40*iymx**2+27)/308.0d0
          qy(ig,4) = 25.0d0*ci*(231*z**6+231*iymx**2*z**4-315*z**4-126*iymx**2*z**2+105*z**2+7*iymx**2-5)/308.0d0
       end do
    case (253)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = (-45.0d0)*ci*(iypx+iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = (-25.0d0)*ci*(iypx+iymx)*z*(33*z**4-30*z**2+5)/44.0d0
       end do
    case (254)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iymx*sq3*(5*z**2-1)/sq2/2.0d0
       end do
    case (255)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 15.0d0*ci*iymx**2*z/(2.0d0*sq6)
       end do
    case (256)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*ci*iymx*sq6*z/7.0d0
          qy(ig,2) = 15.0d0*ci*iymx*sq2*z*(7*z**2+7*iymx**2-3)/(28.0d0*sq3)
       end do
    case (257)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq6*(12*z**2-5*iymx**2-4)/28.0d0
          qy(ig,2) = (-3.0d0)*ci*sq2*(35*z**4+35*iymx**2*z**2-30*z**2-5*iymx**2+3)/(28.0d0*sq3)
       end do
    case (258)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iymx**2/14.0d0
          qy(ig,2) = (-15.0d0)*ci*iymx**2*(7*z**2-1)/28.0d0
       end do
    case (259)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 4.0d0*ci*iymx*sq3*z/7.0d0
          qy(ig,2) = 5.0d0*ci*iymx*sq3*z*(14*z**2-7*iymx**2-6)/28.0d0
       end do
    case (260)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq3*(6*z**2+5*iymx**2-2)/14.0d0
          qy(ig,2) = -ci*sq3*(35*z**4-70*iymx**2*z**2-30*z**2+10*iymx**2+3)/28.0d0
       end do
    case (261)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 15.0d0*ci*iymx*z/7.0d0
          qy(ig,2) = (-15.0d0)*ci*iymx*z*(7*z**2-3)/28.0d0
       end do
    case (262)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx**2*z/2.0d0
          qy(ig,3) = (-5.0d0)*ci*iymx**2*z*(3*z**2+3*iymx**2-1)/4.0d0
       end do
    case (263)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*ci*iymx*sq3/35.0d0
          qy(ig,2) = ci*iymx*(30*z**2+25*iymx**2-6)/sq3/20.0d0
          qy(ig,3) = 5.0d0*ci*iymx*(63*z**4+63*iymx**2*z**2-42*z**2-7*iymx**2+3)/(28.0d0*sq3)
       end do
    case (264)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 12.0d0*ci*sq3*z/35.0d0
          qy(ig,2) = ci*z*(5*z**2-3)/sq3/5.0d0
          qy(ig,3) = (-5.0d0)*ci*z*(63*z**4+63*iymx**2*z**2-70*z**2-21*iymx**2+15)/(28.0d0*sq3)
       end do
    case (265)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*(2*iypx-5*iymx)/35.0d0
          qy(ig,2) = -ci*(8*iypx+5*iymx)*(5*z**2-1)/20.0d0
          qy(ig,3) = 5.0d0*ci*(iypx+iymx)*(21*z**4-14*z**2+1)/28.0d0
       end do
    case (266)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx**3*sq5/6.0d0
          qy(ig,3) = 5.0d0*ci*iymx**3*sq5*(3*z-1)*(3*z+1)/24.0d0
       end do
    case (267)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx**2*z
          qy(ig,3) = (-5.0d0)*ci*iymx**2*z*(12*z**2-3*iymx**2-4)/8.0d0
       end do
    case (268)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*iymx*sq2/35.0d0
          qy(ig,2) = ci*iymx*(45*z**2-25*iymx**2-9)/sq2/30.0d0
          qy(ig,3) = 5.0d0*ci*iymx*(189*z**4-126*iymx**2*z**2-126*z**2+14*iymx**2+9)/(84.0d0*sq2)
       end do
    case (269)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 12.0d0*ci*sq2*z/35.0d0
          qy(ig,2) = ci*sq2*z*(5*z**2-3)/15.0d0
          qy(ig,3) = (-5.0d0)*ci*z*(126*z**4-189*iymx**2*z**2-140*z**2+63*iymx**2+30)/(84.0d0*sq2)
       end do
    case (270)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*(iypx+10*iymx)/35.0d0
          qy(ig,2) = -ci*(2*iypx-5*iymx)*(5*z**2-1)/10.0d0
          qy(ig,3) = 5.0d0*ci*(iypx-4*iymx)*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (271)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*sq5*z/7.0d0
          qy(ig,2) = -ci*sq5*z*(5*z**2-3)/3.0d0
          qy(ig,3) = 5.0d0*ci*sq5*z*(63*z**4-70*z**2+15)/168.0d0
       end do
    case (272)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*ci*iymx**3*sq5*z/22.0d0
          qy(ig,4) = 15.0d0*ci*iymx**3*sq5*z*(11*z**2+11*iymx**2-3)/88.0d0
       end do
    case (273)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*ci*iymx**2/7.0d0
          qy(ig,3) = (-15.0d0)*ci*iymx**2*(56*z**2+35*iymx**2-8)/616.0d0
          qy(ig,4) = (-25.0d0)*ci*iymx**2*(33*z**4+33*iymx**2*z**2-18*z**2-3*iymx**2+1)/88.0d0
       end do
    case (274)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx*sq2*z/7.0d0
          qy(ig,3) = 15.0d0*ci*iymx*z*(21*z**2+14*iymx**2-9)/(154.0d0*sq2)
          qy(ig,4) = 25.0d0*ci*iymx*z*(33*z**4+33*iymx**2*z**2-30*z**2-9*iymx**2+5)/(44.0d0*sq2)
       end do
    case (275)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*ci*sq2/7.0d0
          qy(ig,2) = ci*(6*z**2+5*iymx**2-2)/sq2/7.0d0
          qy(ig,3) = 3.0d0*ci*(70*z**4+105*iymx**2*z**2-60*z**2-15*iymx**2+6)/(308.0d0*sq2)
          qy(ig,4) = (-25.0d0)*ci*(231*z**6+231*iymx**2*z**4-315*z**4-126*iymx**2*z**2+105*z**2+7*iymx**2-5)/(308.0d0*sq2)
       end do
    case (276)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = (-30.0d0)*ci*(iypx+iymx)*z*(7*z**2-3)/77.0d0
          qy(ig,4) = 25.0d0*ci*(iypx+iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (277)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 15.0d0*ci*iymx**2*z/(2.0d0*sq30)
       end do
    case (278)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iymx**3*sq5/(2.0d0*sq6)
       end do
    case (279)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iymx**2*sq30/28.0d0
          qy(ig,2) = 5.0d0*ci*iymx**2*sq6*(7*z**2+7*iymx**2-1)/(28.0d0*sq5)
       end do
    case (280)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iymx*sq30*z/7.0d0
          qy(ig,2) = (-3.0d0)*ci*iymx*sq5*z*(7*z**2+7*iymx**2-3)/(14.0d0*sq6)
       end do
    case (281)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*iymx**3*sq5*z/4.0d0
       end do
    case (282)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iymx**2*sq15/14.0d0
          qy(ig,2) = ci*iymx**2*sq15*(14*z**2-7*iymx**2-2)/28.0d0
       end do
    case (283)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iymx*sq15*z/7.0d0
          qy(ig,2) = -ci*iymx*sq15*z*(7*z**2-14*iymx**2-3)/28.0d0
       end do
    case (284)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*iymx**2*sq5/14.0d0
          qy(ig,2) = (-3.0d0)*ci*iymx**2*sq5*(7*z**2-1)/28.0d0
       end do
    case (285)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx**3*sq5/12.0d0
          qy(ig,3) = -ci*iymx**3*sq5*(9*z**2+9*iymx**2-1)/12.0d0
       end do
    case (286)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = ci*iymx**2*sq15*z*(3*z**2+3*iymx**2-1)/4.0d0
       end do
    case (287)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iymx*sq3/(7.0d0*sq5)
          qy(ig,2) = ci*iymx*(15*z**2+10*iymx**2-3)/sq15/4.0d0
          qy(ig,3) = -ci*iymx*sq5*(63*z**4+63*iymx**2*z**2-42*z**2-7*iymx**2+3)/sq3/28.0d0
       end do
    case (288)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*ci*z/(7.0d0*sq5)
          qy(ig,2) = -ci*z*(20*z**2+15*iymx**2-12)/sq5/6.0d0
          qy(ig,3) = ci*sq5*z*(63*z**4+63*iymx**2*z**2-70*z**2-21*iymx**2+15)/84.0d0
       end do
    case (289)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*ci*iymx**4*z/8.0d0
       end do
    case (290)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx**3*sq5/6.0d0
          qy(ig,3) = -ci*iymx**3*sq5*(36*z**2-9*iymx**2-4)/24.0d0
       end do
    case (291)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*ci*iymx**2*z*(3*z**2-2*iymx**2-1)/(4.0d0*sq10)
       end do
    case (292)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iymx*sq2/(7.0d0*sq5)
          qy(ig,2) = ci*iymx*sq2*(5*z**2-5*iymx**2-1)/sq5/4.0d0
          qy(ig,3) = (-5.0d0)*ci*iymx*sq2*(42*z**4-63*iymx**2*z**2-28*z**2+7*iymx**2+2)/(56.0d0*sq5)
       end do
    case (293)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*z/(7.0d0*sq5)
          qy(ig,2) = -ci*z*(5*z**2-15*iymx**2-3)/sq5/3.0d0
          qy(ig,3) = ci*sq5*z*(63*z**4-252*iymx**2*z**2-70*z**2+84*iymx**2+15)/168.0d0
       end do
    case (294)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*iymx/7.0d0
          qy(ig,2) = -ci*iymx*(5*z**2-1)/2.0d0
          qy(ig,3) = 5.0d0*ci*iymx*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (295)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*ci*iymx**4/88.0d0
          qy(ig,4) = 15.0d0*ci*iymx**4*(11*z**2+11*iymx**2-1)/88.0d0
       end do
    case (296)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*ci*iymx**3*sq5*z/22.0d0
          qy(ig,4) = (-15.0d0)*ci*iymx**3*sq5*z*(11*z**2+11*iymx**2-3)/88.0d0
       end do
    case (297)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx**2*sq10/14.0d0
          qy(ig,3) = (-45.0d0)*ci*iymx**2*(7*z**2+14*iymx**2-1)/(308.0d0*sq10)
          qy(ig,4) = 5.0d0*ci*iymx**2*sq2*sq5*(33*z**4+33*iymx**2*z**2-18*z**2-3*iymx**2+1)/88.0d0
       end do
    case (298)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx*sq10*z/7.0d0
          qy(ig,3) = 3.0d0*ci*iymx*sq5*z*(56*z**2+63*iymx**2-24)/(154.0d0*sq2)
          qy(ig,4) = (-5.0d0)*ci*iymx*sq2*sq5*z*(33*z**4+33*iymx**2*z**2-30*z**2-9*iymx**2+5)/88.0d0
       end do
    case (299)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq5/7.0d0
          qy(ig,2) = ci*iymx**2*sq5/7.0d0
          qy(ig,3) = (-3.0d0)*ci*sq5*(245*z**4+252*iymx**2*z**2-210*z**2-36*iymx**2+21)/616.0d0
          qy(ig,4) = 5.0d0*ci*sq5*(231*z**6+231*iymx**2*z**4-315*z**4-126*iymx**2*z**2+105*z**2+7*iymx**2-5)/616.0d0
       end do
    case (300)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = 45.0d0*ci*(iypx+iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = (-5.0d0)*ci*(iypx+iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (301)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (302)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iypx**3*sq35/4.0d0
       end do
    case (303)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iypx**2*sq35/14.0d0
          qy(ig,2) = ci*iypx**2*sq35*(7*z**2-1)/28.0d0
       end do
    case (304)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iypx**3*sq35*z/4.0d0
       end do
    case (305)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (306)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iypx**2*sq35/(14.0d0*sq2)
          qy(ig,2) = -ci*iypx**2*sq35*(7*z**2-1)/sq2/28.0d0
       end do
    case (307)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iypx**3*sq35*z/sq2/2.0d0
       end do
    case (308)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iypx**4*sq105/sq2/4.0d0
       end do
    case (309)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iypx*sq42/(7.0d0*sq5)
          qy(ig,2) = ci*iypx*sq42*(5*z**2-1)/sq5/6.0d0
          qy(ig,3) = -ci*iypx*sq35*(21*z**4-14*z**2+1)/sq6/28.0d0
       end do
    case (310)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iypx**2*sq35*z/sq2/2.0d0
          qy(ig,3) = ci*iypx**2*sq35*z*(3*z**2-1)/sq2/4.0d0
       end do
    case (311)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iypx**3*sq35/sq2/6.0d0
          qy(ig,3) = -ci*iypx**3*sq35*(3*z-1)*(3*z+1)/sq2/12.0d0
       end do
    case (312)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*ci*iypx**4*sq35*z/(4.0d0*sq6)
       end do
    case (313)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
       end do
    case (314)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iypx*sq42/(14.0d0*sq5)
          qy(ig,2) = -ci*iypx*sq42*(5*z**2-1)/sq5/12.0d0
          qy(ig,3) = ci*iypx*sq35*(21*z**4-14*z**2+1)/sq6/56.0d0
       end do
    case (315)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iypx**2*sq105*z/6.0d0
          qy(ig,3) = -ci*iypx**2*sq105*z*(3*z**2-1)/12.0d0
       end do
    case (316)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iypx**3*sq35/sq3/4.0d0
          qy(ig,3) = ci*iypx**3*sq35*(3*z-1)*(3*z+1)/sq3/8.0d0
       end do
    case (317)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*ci*iypx**4*sq35*z/(2.0d0*sq6)
       end do
    case (318)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*ci*iypx**5*sq7/(8.0d0*sq6)
       end do
    case (319)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq6/sq7
          qy(ig,2) = 5*ci*(3*z**2-1)/sq42
          qy(ig,3) = (-9.0d0)*ci*sq6*(35*z**4-30*z**2+3)/(88.0d0*sq7)
          qy(ig,4) = 5.0d0*ci*(231*z**6-315*z**4+105*z**2-5)/(88.0d0*sq42)
       end do
    case (320)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*ci*iypx*sq30*z/(6.0d0*sq7)
          qy(ig,3) = 15.0d0*ci*iypx*sq30*z*(7*z**2-3)/(44.0d0*sq7)
          qy(ig,4) = (-5.0d0)*ci*iypx*sq210*z*(33*z**4-30*z**2+5)/528.0d0
       end do
    case (321)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iypx**2*sq15/sq7/3.0d0
          qy(ig,3) = (-9.0d0)*ci*iypx**2*sq15*(7*z**2-1)/(22.0d0*sq7)
          qy(ig,4) = 5.0d0*ci*iypx**2*sq105*(33*z**4-18*z**2+1)/264.0d0
       end do
    case (322)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 9.0d0*ci*iypx**3*sq105*z/44.0d0
          qy(ig,4) = (-5.0d0)*ci*iypx**3*sq105*z*(11*z**2-3)/88.0d0
       end do
    case (323)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*ci*iypx**4*sq105/(44.0d0*sq2)
          qy(ig,4) = 5.0d0*ci*iypx**4*sq105*(11*z**2-1)/(88.0d0*sq2)
       end do
    case (324)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = (-15.0d0)*ci*iypx**5*sq7*z/(8.0d0*sq6)
       end do
    case (325)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 0
       end do
    case (326)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iypx**3*sq5/4.0d0
       end do
    case (327)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iypx**2*sq5*z/2.0d0
       end do
    case (328)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*ci*iypx*sq5*z/7.0d0
          qy(ig,2) = ci*iypx*sq5*z*(42*z**2-7*iypx**2-18)/28.0d0
       end do
    case (329)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iypx**2*sq5/14.0d0
          qy(ig,2) = -ci*iypx**2*sq5*(42*z**2-7*iypx**2-6)/28.0d0
       end do
    case (330)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iypx**2*sq15/(14.0d0*sq2)
          qy(ig,2) = ci*iypx**2*sq15*(7*z**2-1)/sq2/28.0d0
       end do
    case (331)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iypx*sq10*z/7.0d0
          qy(ig,2) = -ci*iypx*sq5*z*(21*z**2+7*iypx**2-9)/sq2/14.0d0
       end do
    case (332)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iypx**2*sq5/(7.0d0*sq2)
          qy(ig,2) = ci*iypx**2*sq5*(84*z**2+7*iypx**2-12)/sq2/28.0d0
       end do
    case (333)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*iypx**3*sq15*z/(2.0d0*sq2)
       end do
    case (334)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*ci*sq6*z/(7.0d0*sq5)
          qy(ig,2) = ci*sq3*z*(40*z**2-5*iypx**2-24)/sq10/6.0d0
          qy(ig,3) = -ci*sq10*z*(126*z**4-21*iypx**2*z**2-140*z**2+7*iypx**2+30)/sq3/56.0d0
       end do
    case (335)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*ci*iypx*sq2/(7.0d0*sq5)
          qy(ig,2) = -ci*iypx*sq2*(45*z**2-5*iypx**2-9)/sq5/12.0d0
          qy(ig,3) = ci*iypx*sq5*(378*z**4-63*iypx**2*z**2-252*z**2+7*iypx**2+18)/sq2/84.0d0
       end do
    case (336)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*ci*iypx**2*sq2*z*(6*z**2-iypx**2-2)/(8.0d0*sq5)
       end do
    case (337)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iypx**3*sq30/12.0d0
          qy(ig,3) = 5.0d0*ci*iypx**3*(18*z**2-3*iypx**2-2)/(4.0d0*sq30)
       end do
    case (338)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iypx*sq6/14.0d0
          qy(ig,2) = ci*iypx*(5*z**2-1)/sq6/2.0d0
          qy(ig,3) = (-5.0d0)*ci*iypx*(21*z**4-14*z**2+1)/(56.0d0*sq6)
       end do
    case (339)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*sq6*z/(7.0d0*sq5)
          qy(ig,2) = -ci*sq3*z*(10*z**2+5*iypx**2-6)/sq10/3.0d0
          qy(ig,3) = ci*sq10*z*(63*z**4+42*iypx**2*z**2-70*z**2-14*iypx**2+15)/sq3/56.0d0
       end do
    case (340)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*ci*iypx*sq3/(7.0d0*sq5)
          qy(ig,2) = ci*iypx*(30*z**2+5*iypx**2-6)/sq15/4.0d0
          qy(ig,3) = -ci*iypx*sq5*(252*z**4+63*iypx**2*z**2-168*z**2-7*iypx**2+12)/sq3/56.0d0
       end do
    case (341)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = ci*iypx**2*sq15*z*(9*z**2+iypx**2-3)/4.0d0
       end do
    case (342)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iypx**3*sq30/6.0d0
          qy(ig,3) = (-5.0d0)*ci*iypx**3*(72*z**2+3*iypx**2-8)/(8.0d0*sq30)
       end do
    case (343)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*ci*iypx**4*sq6*z/8.0d0
       end do
    case (344)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*ci*(iypx-6*iymx)*z/(7.0d0*sq6)
          qy(ig,3) = 15.0d0*ci*(iypx-6*iymx)*sq6*z*(7*z**2-3)/308.0d0
          qy(ig,4) = (-5.0d0)*ci*(iypx-6*iymx)*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
       end do
    case (345)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq30/7.0d0
          qy(ig,2) = ci*iypx**2*sq5/sq6/7.0d0
          qy(ig,3) = 3.0d0*ci*sq15*(245*z**4-42*iypx**2*z**2-210*z**2+6*iypx**2+21)/(308.0d0*sq2)
          qy(ig,4) = (-5.0d0)*ci*sq5*(1386*z**6-231*iypx**2*z**4-1890*z**4+126*iypx**2*z**2+630*z**2-7*iypx**2-30)/(616.0d0*sq6)
       end do
    case (346)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*ci*iypx*sq15*z/7.0d0
          qy(ig,3) = (-3.0d0)*ci*iypx*sq15*z*(112*z**2-21*iypx**2-48)/308.0d0
          qy(ig,4) = 5.0d0*ci*iypx*sq15*z*(66*z**4-11*iypx**2*z**2-60*z**2+3*iypx**2+10)/88.0d0
       end do
    case (347)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iypx**2*sq15/7.0d0
          qy(ig,3) = 3.0d0*ci*iypx**2*sq15*(21*z**2-7*iypx**2-3)/308.0d0
          qy(ig,4) = (-5.0d0)*ci*iypx**2*sq15*(66*z**4-11*iypx**2*z**2-36*z**2+iypx**2+2)/88.0d0
       end do
    case (348)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*ci*iypx**3*sq15*z/(11.0d0*sq2)
          qy(ig,4) = 5.0d0*ci*iypx**3*sq10*sq3*z*(66*z**2-11*iypx**2-18)/176.0d0
       end do
    case (349)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*ci*iypx**4*sq6/88.0d0
          qy(ig,4) = (-5.0d0)*ci*iypx**4*sq6*(66*z**2-11*iypx**2-6)/176.0d0
       end do
    case (350)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci/sq7
          qy(ig,2) = 5.0d0*ci*(3*z**2-1)/(6.0d0*sq7)
          qy(ig,3) = (-9.0d0)*ci*(35*z**4-30*z**2+3)/(88.0d0*sq7)
          qy(ig,4) = 5.0d0*ci*(231*z**6-315*z**4+105*z**2-5)/(528.0d0*sq7)
       end do
    case (351)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = 45.0d0*ci*(iypx+iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = (-5.0d0)*ci*(iypx+iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (352)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iypx**2*sq15*z/2.0d0
       end do
    case (353)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iypx*sq15*(5*z**2-1)/4.0d0
       end do
    case (354)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq15*(6*z**2+iypx**2-2)/14.0d0
          qy(ig,2) = ci*sq15*(35*z**4-14*iypx**2*z**2-30*z**2+2*iypx**2+3)/28.0d0
       end do
    case (355)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*iypx*sq15*z/7.0d0
          qy(ig,2) = -ci*iypx*sq15*z*(35*z**2-14*iypx**2-15)/28.0d0
       end do
    case (356)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iypx*sq10*z/7.0d0
          qy(ig,2) = 3.0d0*ci*iypx*sq10*z*(7*z**2-3)/28.0d0
       end do
    case (357)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*sq15*(3*z**2-iypx**2-1)/sq2/7.0d0
          qy(ig,2) = -ci*sq15*(35*z**4+28*iypx**2*z**2-30*z**2-4*iypx**2+3)/sq2/28.0d0
       end do
    case (358)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 2.0d0*ci*iypx*sq30*z/7.0d0
          qy(ig,2) = ci*iypx*sq15*z*(35*z**2+7*iypx**2-15)/sq2/14.0d0
       end do
    case (359)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iypx**2*sq5/(14.0d0*sq2)
          qy(ig,2) = (-15.0d0)*ci*iypx**2*sq5*(7*z**2-1)/(28.0d0*sq2)
       end do
    case (360)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*(iypx+iymx)*sq2/(7.0d0*sq5)
          qy(ig,2) = -ci*(iypx-4*iymx)*(5*z**2-1)/sq10/2.0d0
          qy(ig,3) = ci*(2*iypx-5*iymx)*sq10*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (361)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*ci*sq30*z/35.0d0
          qy(ig,2) = -ci*z*(5*z**2-3)/sq30
          qy(ig,3) = ci*sq5*sq6*z*(315*z**4-126*iypx**2*z**2-350*z**2+42*iypx**2+75)/168.0d0
       end do
    case (362)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iypx*sq6/(7.0d0*sq5)
          qy(ig,2) = -ci*iypx*sq2*(15*z**2-5*iypx**2-3)/sq15/4.0d0
          qy(ig,3) = -ci*iypx*sq10*(315*z**4-126*iypx**2*z**2-210*z**2+14*iypx**2+15)/sq3/56.0d0
       end do
    case (363)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iypx**2*sq5*z/sq2/2.0d0
          qy(ig,3) = ci*iypx**2*sq5*z*(15*z**2-6*iypx**2-5)/sq2/4.0d0
       end do
    case (364)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*sq2*z/7.0d0
          qy(ig,2) = ci*sq2*z*(5*z**2-3)/3.0d0
          qy(ig,3) = (-5.0d0)*ci*z*(63*z**4-70*z**2+15)/(84.0d0*sq2)
       end do
    case (365)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*(4*iypx-iymx)*sq5/(35.0d0*sq2)
          qy(ig,2) = -ci*(iypx+iymx)*(5*z**2-1)/sq10
          qy(ig,3) = ci*(8*iypx+5*iymx)*sq10*(21*z**4-14*z**2+1)/112.0d0
       end do
    case (366)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 12.0d0*ci*z/(7.0d0*sq5)
          qy(ig,2) = ci*z*(5*z**2-3)/sq5/3.0d0
          qy(ig,3) = -ci*sq5*z*(315*z**4+189*iypx**2*z**2-350*z**2-63*iypx**2+75)/84.0d0
       end do
    case (367)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*iypx/(7.0d0*sq5)
          qy(ig,2) = ci*iypx*(45*z**2+10*iypx**2-9)/sq5/12.0d0
          qy(ig,3) = ci*iypx*sq5*(945*z**4+252*iypx**2*z**2-630*z**2-28*iypx**2+45)/168.0d0
       end do
    case (368)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iypx**2*sq5*z/sq2
          qy(ig,3) = -ci*iypx**2*sq5*z*(30*z**2+3*iypx**2-10)/sq2/4.0d0
       end do
    case (369)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*ci*iypx**3/(6.0d0*sq2)
          qy(ig,3) = 25.0d0*ci*iypx**3*(3*z-1)*(3*z+1)/(24.0d0*sq2)
       end do
    case (370)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq2/7.0d0
          qy(ig,2) = 5.0d0*ci*iymx**2/(7.0d0*sq2)
          qy(ig,3) = 3.0d0*ci*(245*z**4-630*iymx**2*z**2-210*z**2+90*iymx**2+21)/(308.0d0*sq2)
          qy(ig,4) = (-5.0d0)*ci*(462*z**6-1155*iymx**2*z**4-630*z**4+630*iymx**2*z**2+210*z**2-35*iymx**2-10)/(616.0d0*sq2)
       end do
    case (371)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*(2*iypx-5*iymx)*sq10*z/14.0d0
          qy(ig,3) = (-3.0d0)*ci*(2*iypx-5*iymx)*sq10*z*(7*z**2-3)/77.0d0
          qy(ig,4) = 5.0d0*ci*(2*iypx-5*iymx)*sq10*z*(33*z**4-30*z**2+5)/176.0d0
       end do
    case (372)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq5/7.0d0
          qy(ig,2) = -ci*sq5*(3*z**2-iypx**2-1)/7.0d0
          qy(ig,3) = (-3.0d0)*ci*sq5*(35*z**4-21*iypx**2*z**2-30*z**2+3*iypx**2+3)/308.0d0
          qy(ig,4) = 5.0d0*ci*sq5*(1155*z**6-462*iypx**2*z**4-1575*z**4+252*iypx**2*z**2+525*z**2-14*iypx**2-25)/616.0d0
       end do
    case (373)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iypx*sq5*z/7.0d0
          qy(ig,3) = (-3.0d0)*ci*iypx*sq5*z*(105*z**2-28*iypx**2-45)/308.0d0
          qy(ig,4) = (-5.0d0)*ci*iypx*sq5*z*(165*z**4-66*iypx**2*z**2-150*z**2+18*iypx**2+25)/88.0d0
       end do
    case (374)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iypx**2*sq10/7.0d0
          qy(ig,3) = 15.0d0*ci*iypx**2*sq5*(28*z**2-7*iypx**2-4)/(308.0d0*sq2)
          qy(ig,4) = 5.0d0*ci*iypx**2*sq5*(165*z**4-66*iypx**2*z**2-90*z**2+6*iypx**2+5)/(88.0d0*sq2)
       end do
    case (375)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*ci*iypx**3*z/(22.0d0*sq2)
          qy(ig,4) = (-15.0d0)*ci*iypx**3*z*(55*z**2-22*iypx**2-15)/(88.0d0*sq2)
       end do
    case (376)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5*ci*iymx*z/sq21
          qy(ig,3) = (-15.0d0)*ci*iymx*sq3*z*(7*z**2-3)/(22.0d0*sq7)
          qy(ig,4) = 5.0d0*ci*iymx*sq21*z*(33*z**4-30*z**2+5)/264.0d0
       end do
    case (377)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq3/7.0d0
          qy(ig,2) = (-5.0d0)*ci*iymx**2/(14.0d0*sq3)
          qy(ig,3) = 3.0d0*ci*sq3*(245*z**4+105*iymx**2*z**2-210*z**2-15*iymx**2+21)/308.0d0
          qy(ig,4) = (-5.0d0)*ci*(2772*z**6+1155*iymx**2*z**4-3780*z**4-630*iymx**2*z**2+1260*z**2+35*iymx**2-60)/(1232.0d0*sq3)
       end do
    case (378)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = (-30.0d0)*ci*(iypx+iymx)*z*(7*z**2-3)/77.0d0
          qy(ig,4) = 25.0d0*ci*(iypx+iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (379)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iypx*(5*z**2-1)/4.0d0
       end do
    case (380)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*z*(5*z**2-3)
       end do
    case (381)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*ci*(iypx+iymx)*z/7.0d0
          qy(ig,2) = (-5.0d0)*ci*(3*iypx-4*iymx)*z*(7*z**2-3)/28.0d0
       end do
    case (382)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*(6*z**2+iypx**2-2)/14.0d0
          qy(ig,2) = -ci*(140*z**4-105*iypx**2*z**2-120*z**2+15*iypx**2+12)/28.0d0
       end do
    case (383)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*sq3*(3*z**2-1)/(7.0d0*sq2)
          qy(ig,2) = 3.0d0*ci*sq3*(35*z**4-30*z**2+3)/(28.0d0*sq2)
       end do
    case (384)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*(2*iypx-iymx)*sq2*z/7.0d0
          qy(ig,2) = (-5.0d0)*ci*(3*iypx+2*iymx)*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (385)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*(12*z**2-iypx**2-4)/(14.0d0*sq2)
          qy(ig,2) = ci*(280*z**4+105*iypx**2*z**2-240*z**2-15*iypx**2+24)/sq2/28.0d0
       end do
    case (386)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iypx*sq6*z/7.0d0
          qy(ig,2) = (-5.0d0)*ci*iypx*sq3*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (387)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*ci*sq6*z/35.0d0
          qy(ig,2) = -ci*z*(5*z**2-20*iymx**2-3)/sq6/5.0d0
          qy(ig,3) = 5.0d0*ci*z*(63*z**4-84*iymx**2*z**2-70*z**2+28*iymx**2+15)/(28.0d0*sq6)
       end do
    case (388)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*ci*(iypx+iymx)*sq2/35.0d0
          qy(ig,2) = -ci*(3*iypx-2*iymx)*(5*z**2-1)/sq2/10.0d0
          qy(ig,3) = (-5.0d0)*ci*(3*iypx-4*iymx)*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (389)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-18.0d0)*ci*sq2*z/35.0d0
          qy(ig,2) = -ci*z*(80*z**2-45*iypx**2-48)/sq2/30.0d0
          qy(ig,3) = (-5.0d0)*ci*z*(252*z**4-189*iypx**2*z**2-280*z**2+63*iypx**2+60)/(84.0d0*sq2)
       end do
    case (390)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iypx*sq6/35.0d0
          qy(ig,2) = ci*iypx*(5*z**2+5*iypx**2-1)/sq6/5.0d0
          qy(ig,3) = 5.0d0*ci*iypx*(84*z**4-63*iypx**2*z**2-56*z**2+7*iypx**2+4)/(28.0d0*sq6)
       end do
    case (391)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iymx*sq30/70.0d0
          qy(ig,2) = ci*iymx*sq30*(5*z**2-1)/10.0d0
          qy(ig,3) = (-5.0d0)*ci*iymx*sq30*(21*z**4-14*z**2+1)/112.0d0
       end do
    case (392)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-12.0d0)*ci*sq6*z/35.0d0
          qy(ig,2) = -ci*sq2*z*(5*z**2+5*iymx**2-3)/sq3/5.0d0
          qy(ig,3) = 5.0d0*ci*z*(63*z**4+21*iymx**2*z**2-70*z**2-7*iymx**2+15)/(14.0d0*sq6)
       end do
    case (393)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*(3*iypx-2*iymx)*sq3/35.0d0
          qy(ig,2) = -ci*(9*iypx+4*iymx)*(5*z**2-1)/sq3/20.0d0
          qy(ig,3) = (-5.0d0)*ci*(9*iypx+8*iymx)*(21*z**4-14*z**2+1)/(56.0d0*sq3)
       end do
    case (394)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 18.0d0*ci*sq3*z/35.0d0
          qy(ig,2) = ci*z*(40*z**2+15*iypx**2-24)/sq3/10.0d0
          qy(ig,3) = 5.0d0*ci*z*(126*z**4+63*iypx**2*z**2-140*z**2-21*iypx**2+30)/(28.0d0*sq3)
       end do
    case (395)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*ci*iypx*sq6/35.0d0
          qy(ig,2) = -ci*iypx*(20*z**2-5*iypx**2-4)/sq6/10.0d0
          qy(ig,3) = (-5.0d0)*ci*iypx*(336*z**4+63*iypx**2*z**2-224*z**2-7*iypx**2+16)/(56.0d0*sq6)
       end do
    case (396)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -2*ci*iypx**2*sq5*z/sq6
          qy(ig,3) = 5.0d0*ci*iypx**2*sq5*z*(3*z**2-1)/(2.0d0*sq6)
       end do
    case (397)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx*sq30*z/14.0d0
          qy(ig,3) = 3.0d0*ci*iymx*sq30*z*(14*z**2-21*iymx**2-6)/154.0d0
          qy(ig,4) = (-5.0d0)*ci*iymx*sq30*z*(33*z**4-44*iymx**2*z**2-30*z**2+12*iymx**2+5)/176.0d0
       end do
    case (398)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq6/7.0d0
          qy(ig,2) = -ci*sq3*(9*z**2-10*iymx**2-3)/sq2/21.0d0
          qy(ig,3) = (-3.0d0)*ci*sq3*(35*z**4-70*iymx**2*z**2-30*z**2+10*iymx**2+3)/(308.0d0*sq2)
          qy(ig,4) = 25.0d0*ci*sq2*(693*z**6-924*iymx**2*z**4-945*z**4+504*iymx**2*z**2+315*z**2-28*iymx**2-15)/(1232.0d0*sq3)
       end do
    case (399)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*(3*iypx-4*iymx)*z/sq3/7.0d0
          qy(ig,3) = (-15.0d0)*ci*(3*iypx-4*iymx)*sq3*z*(7*z**2-3)/308.0d0
          qy(ig,4) = (-25.0d0)*ci*(3*iypx-4*iymx)*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
       end do
    case (400)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq3/7.0d0
          qy(ig,2) = (-2.0d0)*ci*(6*z**2-3*iypx**2-2)/(7.0d0*sq3)
          qy(ig,3) = (-3.0d0)*ci*sq3*(105*z**4-70*iypx**2*z**2-90*z**2+10*iypx**2+9)/154.0d0
          qy(ig,4) = (-25.0d0)*ci*(924*z**6-693*iypx**2*z**4-1260*z**4+378*iypx**2*z**2+420*z**2-21*iypx**2-20)/(616.0d0*sq3)
       end do
    case (401)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 2.0d0*ci*iypx*sq2*z/(7.0d0*sq3)
          qy(ig,3) = 15.0d0*ci*iypx*sq3*z*(14*z**2-7*iypx**2-6)/(154.0d0*sq2)
          qy(ig,4) = 25.0d0*ci*iypx*sq2*z*(132*z**4-99*iypx**2*z**2-120*z**2+27*iypx**2+20)/(176.0d0*sq3)
       end do
    case (402)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 10.0d0*ci*iypx**2/(7.0d0*sq30)
          qy(ig,3) = 45.0d0*ci*iypx**2*sq2*(14*z**2-21*iypx**2-2)/(616.0d0*sq15)
          qy(ig,4) = (-5.0d0)*ci*iypx**2*sq15*(132*z**4-99*iypx**2*z**2-72*z**2+9*iypx**2+4)/(264.0d0*sq2)
       end do
    case (403)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx**2*sq5/sq7/2.0d0
          qy(ig,3) = (-27.0d0)*ci*iymx**2*sq5*(7*z**2-1)/(44.0d0*sq7)
          qy(ig,4) = 5.0d0*ci*iymx**2*sq35*(33*z**4-18*z**2+1)/176.0d0
       end do
    case (404)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*ci*iymx*sq5*z/7.0d0
          qy(ig,3) = 9.0d0*ci*iymx*sq5*z*(28*z**2+7*iymx**2-12)/154.0d0
          qy(ig,4) = (-5.0d0)*ci*iymx*sq5*z*(99*z**4+22*iymx**2*z**2-90*z**2-6*iymx**2+15)/88.0d0
       end do
    case (405)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq15/7.0d0
          qy(ig,2) = -ci*sq15*(9*z**2+4*iymx**2-3)/42.0d0
          qy(ig,3) = (-3.0d0)*ci*sq15*(35*z**4+28*iymx**2*z**2-30*z**2-4*iymx**2+3)/616.0d0
          qy(ig,4) = 5.0d0*ci*sq15*(3465*z**6+1848*iymx**2*z**4-4725*z**4-1008*iymx**2*z**2+1575*z**2+56*iymx**2-75)/3696.0d0
       end do
    case (406)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = (-45.0d0)*ci*(iypx+iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = (-25.0d0)*ci*(iypx+iymx)*z*(33*z**4-30*z**2+5)/44.0d0
       end do
    case (407)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*z*(5*z**2-3)
       end do
    case (408)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iymx*(5*z**2-1)/4.0d0
       end do
    case (409)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*(6*z**2+iymx**2-2)/14.0d0
          qy(ig,2) = -ci*(140*z**4-105*iymx**2*z**2-120*z**2+15*iymx**2+12)/28.0d0
       end do
    case (410)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*ci*(iypx+iymx)*z/7.0d0
          qy(ig,2) = 5.0d0*ci*(4*iypx-3*iymx)*z*(7*z**2-3)/28.0d0
       end do
    case (411)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iymx*sq6*z/7.0d0
          qy(ig,2) = 5.0d0*ci*iymx*sq3*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (412)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*(12*z**2-iymx**2-4)/(14.0d0*sq2)
          qy(ig,2) = -ci*(280*z**4+105*iymx**2*z**2-240*z**2-15*iymx**2+24)/sq2/28.0d0
       end do
    case (413)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*(iypx-2*iymx)*sq2*z/7.0d0
          qy(ig,2) = 5.0d0*ci*(2*iypx+3*iymx)*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (414)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*sq3*(3*z**2-1)/(7.0d0*sq2)
          qy(ig,2) = (-3.0d0)*ci*sq3*(35*z**4-30*z**2+3)/(28.0d0*sq2)
       end do
    case (415)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iymx*sq6/35.0d0
          qy(ig,2) = ci*iymx*(5*z**2+5*iymx**2-1)/sq6/5.0d0
          qy(ig,3) = 5.0d0*ci*iymx*(84*z**4-63*iymx**2*z**2-56*z**2+7*iymx**2+4)/(28.0d0*sq6)
       end do
    case (416)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-18.0d0)*ci*sq2*z/35.0d0
          qy(ig,2) = -ci*z*(80*z**2-45*iymx**2-48)/sq2/30.0d0
          qy(ig,3) = (-5.0d0)*ci*z*(252*z**4-189*iymx**2*z**2-280*z**2+63*iymx**2+60)/(84.0d0*sq2)
       end do
    case (417)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*ci*(iypx+iymx)*sq2/35.0d0
          qy(ig,2) = ci*(2*iypx-3*iymx)*(5*z**2-1)/sq2/10.0d0
          qy(ig,3) = 5.0d0*ci*(4*iypx-3*iymx)*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (418)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*ci*sq6*z/35.0d0
          qy(ig,2) = -ci*z*(5*z**2-20*iypx**2-3)/sq6/5.0d0
          qy(ig,3) = 5.0d0*ci*z*(63*z**4-84*iypx**2*z**2-70*z**2+28*iypx**2+15)/(28.0d0*sq6)
       end do
    case (419)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 10*ci*iymx**2*z/sq30
          qy(ig,3) = (-5.0d0)*ci*iymx**2*sq30*z*(3*z**2-1)/12.0d0
       end do
    case (420)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*ci*iymx*sq6/35.0d0
          qy(ig,2) = ci*iymx*(20*z**2-5*iymx**2-4)/sq6/10.0d0
          qy(ig,3) = 5.0d0*ci*iymx*(336*z**4+63*iymx**2*z**2-224*z**2-7*iymx**2+16)/(56.0d0*sq6)
       end do
    case (421)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-18.0d0)*ci*sq3*z/35.0d0
          qy(ig,2) = -ci*z*(40*z**2+15*iymx**2-24)/sq3/10.0d0
          qy(ig,3) = (-5.0d0)*ci*z*(126*z**4+63*iymx**2*z**2-140*z**2-21*iymx**2+30)/(28.0d0*sq3)
       end do
    case (422)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*(2*iypx-3*iymx)*sq3/35.0d0
          qy(ig,2) = ci*(4*iypx+9*iymx)*(5*z**2-1)/sq3/20.0d0
          qy(ig,3) = 5.0d0*ci*(8*iypx+9*iymx)*(21*z**4-14*z**2+1)/(56.0d0*sq3)
       end do
    case (423)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 12.0d0*ci*sq6*z/35.0d0
          qy(ig,2) = 2.0d0*ci*z*(5*z**2+5*iypx**2-3)/(5.0d0*sq6)
          qy(ig,3) = (-5.0d0)*ci*z*(63*z**4+21*iypx**2*z**2-70*z**2-7*iypx**2+15)/(14.0d0*sq6)
       end do
    case (424)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*iypx/(7.0d0*sq30)
          qy(ig,2) = -ci*iypx*sq6*(5*z**2-1)/sq5/2.0d0
          qy(ig,3) = 15.0d0*ci*iypx*sq5*(21*z**4-14*z**2+1)/(56.0d0*sq6)
       end do
    case (425)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx**2*sq30/21.0d0
          qy(ig,3) = 3.0d0*ci*iymx**2*sq30*(14*z**2-21*iymx**2-2)/616.0d0
          qy(ig,4) = (-5.0d0)*ci*iymx**2*sq30*(132*z**4-99*iymx**2*z**2-72*z**2+9*iymx**2+4)/528.0d0
       end do
    case (426)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 2.0d0*ci*iymx*sq6*z/21.0d0
          qy(ig,3) = 15.0d0*ci*iymx*sq3*z*(14*z**2-7*iymx**2-6)/(154.0d0*sq2)
          qy(ig,4) = 25.0d0*ci*iymx*z*(132*z**4-99*iymx**2*z**2-120*z**2+27*iymx**2+20)/(88.0d0*sq6)
       end do
    case (427)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq3/7.0d0
          qy(ig,2) = (-2.0d0)*ci*(6*z**2-3*iymx**2-2)/(7.0d0*sq3)
          qy(ig,3) = (-3.0d0)*ci*sq3*(105*z**4-70*iymx**2*z**2-90*z**2+10*iymx**2+9)/154.0d0
          qy(ig,4) = (-25.0d0)*ci*(924*z**6-693*iymx**2*z**4-1260*z**4+378*iymx**2*z**2+420*z**2-21*iymx**2-20)/(616.0d0*sq3)
       end do
    case (428)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*(4*iypx-3*iymx)*z/sq3/7.0d0
          qy(ig,3) = 15.0d0*ci*(4*iypx-3*iymx)*sq3*z*(7*z**2-3)/308.0d0
          qy(ig,4) = 25.0d0*ci*(4*iypx-3*iymx)*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
       end do
    case (429)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq6/7.0d0
          qy(ig,2) = -ci*sq2*(9*z**2-10*iypx**2-3)/sq3/14.0d0
          qy(ig,3) = (-3.0d0)*ci*sq2*sq3*(35*z**4-70*iypx**2*z**2-30*z**2+10*iypx**2+3)/616.0d0
          qy(ig,4) = 25.0d0*ci*sq2*(693*z**6-924*iypx**2*z**4-945*z**4+504*iypx**2*z**2+315*z**2-28*iypx**2-15)/(1232.0d0*sq3)
       end do
    case (430)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 15.0d0*ci*iypx*z/(7.0d0*sq30)
          qy(ig,3) = 3.0d0*ci*iypx*sq30*z*(14*z**2-21*iypx**2-6)/154.0d0
          qy(ig,4) = (-5.0d0)*ci*iypx*sq30*z*(33*z**4-44*iypx**2*z**2-30*z**2+12*iypx**2+5)/176.0d0
       end do
    case (431)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-9.0d0)*ci*iymx**3*sq35*z/22.0d0
          qy(ig,4) = 5.0d0*ci*iymx**3*sq35*z*(11*z**2-3)/44.0d0
       end do
    case (432)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 2.0d0*ci*iymx**2*sq5/7.0d0
          qy(ig,3) = 9.0d0*ci*iymx**2*sq5*(28*z**2+7*iymx**2-4)/616.0d0
          qy(ig,4) = (-5.0d0)*ci*iymx**2*sq5*(264*z**4+33*iymx**2*z**2-144*z**2-3*iymx**2+8)/176.0d0
       end do
    case (433)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 2.0d0*ci*iymx*sq15*z/21.0d0
          qy(ig,3) = 3.0d0*ci*iymx*sq15*z*(35*z**2+7*iymx**2-15)/154.0d0
          qy(ig,4) = 5.0d0*ci*iymx*sq15*z*(330*z**4+99*iymx**2*z**2-300*z**2-27*iymx**2+50)/264.0d0
       end do
    case (434)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-4.0d0)*ci/7.0d0
          qy(ig,2) = -ci*(24*z**2+9*iymx**2-8)/21.0d0
          qy(ig,3) = (-9.0d0)*ci*(70*z**4+35*iymx**2*z**2-60*z**2-5*iymx**2+6)/154.0d0
          qy(ig,4) = (-25.0d0)*ci*(3696*z**6+2079*iymx**2*z**4-5040*z**4-1134*iymx**2*z**2+1680*z**2+63*iymx**2-80)/3696.0d0
       end do
    case (435)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 2.0d0*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = 45.0d0*ci*(iypx+iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = 25.0d0*ci*(iypx+iymx)*z*(33*z**4-30*z**2+5)/44.0d0
       end do
    case (436)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iymx*sq15*(5*z**2-1)/4.0d0
       end do
    case (437)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iymx**2*sq15*z/2.0d0
       end do
    case (438)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*iymx*sq15*z/7.0d0
          qy(ig,2) = -ci*iymx*sq15*z*(35*z**2-14*iymx**2-15)/28.0d0
       end do
    case (439)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq15*(6*z**2+iymx**2-2)/14.0d0
          qy(ig,2) = ci*sq15*(35*z**4-14*iymx**2*z**2-30*z**2+2*iymx**2+3)/28.0d0
       end do
    case (440)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iymx**2*sq5/(14.0d0*sq2)
          qy(ig,2) = 15.0d0*ci*iymx**2*sq5*(7*z**2-1)/(28.0d0*sq2)
       end do
    case (441)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*iymx*sq30*z/7.0d0
          qy(ig,2) = -ci*iymx*sq15*z*(35*z**2+7*iymx**2-15)/sq2/14.0d0
       end do
    case (442)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq15*(3*z**2-iymx**2-1)/sq2/7.0d0
          qy(ig,2) = ci*sq15*(35*z**4+28*iymx**2*z**2-30*z**2-4*iymx**2+3)/sq2/28.0d0
       end do
    case (443)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iymx*sq10*z/7.0d0
          qy(ig,2) = (-15.0d0)*ci*iymx*z*(7*z**2-3)/(14.0d0*sq10)
       end do
    case (444)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx**2*sq5*z/sq2/2.0d0
          qy(ig,3) = ci*iymx**2*sq5*z*(15*z**2-6*iymx**2-5)/sq2/4.0d0
       end do
    case (445)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iymx*sq6/(7.0d0*sq5)
          qy(ig,2) = -ci*iymx*sq2*(15*z**2-5*iymx**2-3)/sq15/4.0d0
          qy(ig,3) = -ci*iymx*sq10*(315*z**4-126*iymx**2*z**2-210*z**2+14*iymx**2+15)/sq3/56.0d0
       end do
    case (446)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*ci*sq6*z/(7.0d0*sq5)
          qy(ig,2) = -ci*z*(5*z**2-3)/sq30
          qy(ig,3) = ci*sq5*sq6*z*(315*z**4-126*iymx**2*z**2-350*z**2+42*iymx**2+75)/168.0d0
       end do
    case (447)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*ci*(iypx+iymx)*sq5/(35.0d0*sq2)
          qy(ig,2) = ci*(4*iypx-iymx)*(5*z**2-1)/sq10/2.0d0
          qy(ig,3) = -ci*(5*iypx-2*iymx)*sq2*sq5*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (448)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*ci*iymx**3/(6.0d0*sq2)
          qy(ig,3) = (-25.0d0)*ci*iymx**3*(3*z-1)*(3*z+1)/(24.0d0*sq2)
       end do
    case (449)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx**2*sq5*z/sq2
          qy(ig,3) = ci*iymx**2*sq5*z*(30*z**2+3*iymx**2-10)/sq2/4.0d0
       end do
    case (450)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*ci*iymx/(7.0d0*sq5)
          qy(ig,2) = -ci*iymx*(45*z**2+10*iymx**2-9)/sq5/12.0d0
          qy(ig,3) = -ci*iymx*sq5*(945*z**4+252*iymx**2*z**2-630*z**2-28*iymx**2+45)/168.0d0
       end do
    case (451)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-12.0d0)*ci*z/(7.0d0*sq5)
          qy(ig,2) = -ci*z*(5*z**2-3)/sq5/3.0d0
          qy(ig,3) = ci*sq5*z*(315*z**4+189*iymx**2*z**2-350*z**2-63*iymx**2+75)/84.0d0
       end do
    case (452)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*(iypx-4*iymx)*sq5/(35.0d0*sq2)
          qy(ig,2) = ci*(iypx+iymx)*(5*z**2-1)/sq10
          qy(ig,3) = -ci*(5*iypx+8*iymx)*sq2*sq5*(21*z**4-14*z**2+1)/112.0d0
       end do
    case (453)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*sq2*z/7.0d0
          qy(ig,2) = -ci*sq2*z*(5*z**2-3)/3.0d0
          qy(ig,3) = 5.0d0*ci*z*(63*z**4-70*z**2+15)/(84.0d0*sq2)
       end do
    case (454)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*ci*iymx**3*z/(22.0d0*sq2)
          qy(ig,4) = (-15.0d0)*ci*iymx**3*z*(55*z**2-22*iymx**2-15)/(88.0d0*sq2)
       end do
    case (455)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx**2*sq10/7.0d0
          qy(ig,3) = 15.0d0*ci*iymx**2*sq5*(28*z**2-7*iymx**2-4)/(308.0d0*sq2)
          qy(ig,4) = 5.0d0*ci*iymx**2*sq5*(165*z**4-66*iymx**2*z**2-90*z**2+6*iymx**2+5)/(88.0d0*sq2)
       end do
    case (456)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx*sq5*z/7.0d0
          qy(ig,3) = (-3.0d0)*ci*iymx*sq5*z*(105*z**2-28*iymx**2-45)/308.0d0
          qy(ig,4) = (-5.0d0)*ci*iymx*sq5*z*(165*z**4-66*iymx**2*z**2-150*z**2+18*iymx**2+25)/88.0d0
       end do
    case (457)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq5/7.0d0
          qy(ig,2) = -ci*sq5*(3*z**2-iymx**2-1)/7.0d0
          qy(ig,3) = (-3.0d0)*ci*sq5*(35*z**4-21*iymx**2*z**2-30*z**2+3*iymx**2+3)/308.0d0
          qy(ig,4) = 5.0d0*ci*sq5*(1155*z**6-462*iymx**2*z**4-1575*z**4+252*iymx**2*z**2+525*z**2-14*iymx**2-25)/616.0d0
       end do
    case (458)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*ci*(5*iypx-2*iymx)*z/(7.0d0*sq10)
          qy(ig,3) = 3.0d0*ci*(5*iypx-2*iymx)*sq10*z*(7*z**2-3)/77.0d0
          qy(ig,4) = (-25.0d0)*ci*(5*iypx-2*iymx)*z*(33*z**4-30*z**2+5)/(88.0d0*sq10)
       end do
    case (459)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq2/7.0d0
          qy(ig,2) = 5.0d0*ci*iypx**2/(7.0d0*sq2)
          qy(ig,3) = 3.0d0*ci*(245*z**4-630*iypx**2*z**2-210*z**2+90*iypx**2+21)/(308.0d0*sq2)
          qy(ig,4) = (-5.0d0)*ci*(462*z**6-1155*iypx**2*z**4-630*z**4+630*iypx**2*z**2+210*z**2-35*iypx**2-10)/(616.0d0*sq2)
       end do
    case (460)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*ci*iymx**4*sq21/88.0d0
          qy(ig,4) = 25.0d0*ci*iymx**4*sq21*(11*z**2-1)/176.0d0
       end do
    case (461)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*ci*iymx**3*sq3*z/22.0d0
          qy(ig,4) = (-5.0d0)*ci*iymx**3*sq3*z*(165*z**2+11*iymx**2-45)/88.0d0
       end do
    case (462)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*ci*iymx**2/7.0d0
          qy(ig,3) = 15.0d0*ci*iymx**2*(70*z**2+7*iymx**2-10)/308.0d0
          qy(ig,4) = 5.0d0*ci*iymx**2*(825*z**4+132*iymx**2*z**2-450*z**2-12*iymx**2+25)/176.0d0
       end do
    case (463)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*ci*iymx*sq5*z/(7.0d0*sq3)
          qy(ig,3) = (-3.0d0)*ci*iymx*sq15*z*(35*z**2+7*iymx**2-15)/154.0d0
          qy(ig,4) = (-5.0d0)*ci*iymx*sq5*z*(330*z**4+99*iymx**2*z**2-300*z**2-27*iymx**2+50)/(88.0d0*sq3)
       end do
    case (464)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq15/7.0d0
          qy(ig,2) = -ci*sq15*(9*z**2+4*iymx**2-3)/42.0d0
          qy(ig,3) = (-3.0d0)*ci*sq15*(35*z**4+28*iymx**2*z**2-30*z**2-4*iymx**2+3)/616.0d0
          qy(ig,4) = 25.0d0*ci*(3465*z**6+1848*iymx**2*z**4-4725*z**4-1008*iymx**2*z**2+1575*z**2+56*iymx**2-75)/(1232.0d0*sq15)
       end do
    case (465)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = 30.0d0*ci*(iypx+iymx)*z*(7*z**2-3)/77.0d0
          qy(ig,4) = (-25.0d0)*ci*(iypx+iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (466)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iymx**2*sq5*z/2.0d0
       end do
    case (467)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = ci*iymx**3*sq5/4.0d0
       end do
    case (468)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iymx**2*sq5/14.0d0
          qy(ig,2) = -ci*iymx**2*sq5*(42*z**2-7*iymx**2-6)/28.0d0
       end do
    case (469)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*ci*iymx*sq5*z/7.0d0
          qy(ig,2) = ci*iymx*sq5*z*(42*z**2-7*iymx**2-18)/28.0d0
       end do
    case (470)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 15.0d0*ci*iymx**3*sq3*z/(2.0d0*sq10)
       end do
    case (471)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iymx**2*sq5/(7.0d0*sq2)
          qy(ig,2) = -ci*iymx**2*sq5*(84*z**2+7*iymx**2-12)/sq2/28.0d0
       end do
    case (472)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iymx*sq10*z/7.0d0
          qy(ig,2) = 5.0d0*ci*iymx*sq2*z*(21*z**2+7*iymx**2-9)/(28.0d0*sq5)
       end do
    case (473)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*ci*iymx**2*sq15/(14.0d0*sq2)
          qy(ig,2) = -ci*iymx**2*sq15*(7*z**2-1)/sq2/28.0d0
       end do
    case (474)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx**3*sq15/sq2/6.0d0
          qy(ig,3) = ci*iymx**3*sq15*(18*z**2-3*iymx**2-2)/sq2/12.0d0
       end do
    case (475)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*ci*iymx**2*sq2*z*(6*z**2-iymx**2-2)/(8.0d0*sq5)
       end do
    case (476)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-18.0d0)*ci*iymx/(7.0d0*sq10)
          qy(ig,2) = -ci*iymx*sq2*(45*z**2-5*iymx**2-9)/sq5/12.0d0
          qy(ig,3) = 5.0d0*ci*iymx*sq2*(378*z**4-63*iymx**2*z**2-252*z**2+7*iymx**2+18)/(168.0d0*sq5)
       end do
    case (477)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-36.0d0)*ci*z/(7.0d0*sq30)
          qy(ig,2) = ci*sq5*z*(40*z**2-5*iymx**2-24)/sq6/10.0d0
          qy(ig,3) = -ci*sq5*z*(126*z**4-21*iymx**2*z**2-140*z**2+7*iymx**2+30)/sq6/28.0d0
       end do
    case (478)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*ci*iymx**4*sq6*z/8.0d0
       end do
    case (479)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx**3*sq15/sq2/3.0d0
          qy(ig,3) = ci*iymx**3*sq15*sq2*(72*z**2+3*iymx**2-8)/48.0d0
       end do
    case (480)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = -ci*iymx**2*sq15*z*(9*z**2+iymx**2-3)/4.0d0
       end do
    case (481)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-18.0d0)*ci*iymx/(7.0d0*sq15)
          qy(ig,2) = -ci*iymx*sq3*(30*z**2+5*iymx**2-6)/sq5/12.0d0
          qy(ig,3) = ci*iymx*sq5*(252*z**4+63*iymx**2*z**2-168*z**2-7*iymx**2+12)/sq3/56.0d0
       end do
    case (482)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-18.0d0)*ci*z/(7.0d0*sq30)
          qy(ig,2) = ci*sq6*z*(10*z**2+5*iymx**2-6)/sq5/6.0d0
          qy(ig,3) = -ci*sq5*z*(63*z**4+42*iymx**2*z**2-70*z**2-14*iymx**2+15)/sq6/28.0d0
       end do
    case (483)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*ci*iymx/(7.0d0*sq6)
          qy(ig,2) = -ci*iymx*(5*z**2-1)/sq6/2.0d0
          qy(ig,3) = 5.0d0*ci*iymx*(21*z**4-14*z**2+1)/(56.0d0*sq6)
       end do
    case (484)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*ci*iymx**4*sq6/88.0d0
          qy(ig,4) = (-15.0d0)*ci*iymx**4*(66*z**2-11*iymx**2-6)/(88.0d0*sq6)
       end do
    case (485)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*ci*iymx**3*sq3*z/(11.0d0*sq10)
          qy(ig,4) = 25.0d0*ci*iymx**3*sq3*z*(66*z**2-11*iymx**2-18)/(88.0d0*sq10)
       end do
    case (486)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx**2*sq15/7.0d0
          qy(ig,3) = 3.0d0*ci*iymx**2*sq15*(21*z**2-7*iymx**2-3)/308.0d0
          qy(ig,4) = (-5.0d0)*ci*iymx**2*sq15*(66*z**4-11*iymx**2*z**2-36*z**2+iymx**2+2)/88.0d0
       end do
    case (487)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-2.0d0)*ci*iymx*sq15*z/7.0d0
          qy(ig,3) = (-3.0d0)*ci*iymx*sq15*z*(112*z**2-21*iymx**2-48)/308.0d0
          qy(ig,4) = 5.0d0*ci*iymx*sq15*z*(66*z**4-11*iymx**2*z**2-60*z**2+3*iymx**2+10)/88.0d0
       end do
    case (488)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq30/7.0d0
          qy(ig,2) = ci*iymx**2*sq5/sq6/7.0d0
          qy(ig,3) = 3.0d0*ci*sq15*(245*z**4-42*iymx**2*z**2-210*z**2+6*iymx**2+21)/(308.0d0*sq2)
          qy(ig,4) = (-5.0d0)*ci*sq5*(1386*z**6-231*iymx**2*z**4-1890*z**4+126*iymx**2*z**2+630*z**2-7*iymx**2-30)/(616.0d0*sq6)
       end do
    case (489)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*ci*(6*iypx-iymx)*z/(7.0d0*sq6)
          qy(ig,3) = (-15.0d0)*ci*(6*iypx-iymx)*sq6*z*(7*z**2-3)/308.0d0
          qy(ig,4) = 5.0d0*ci*(6*iypx-iymx)*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
       end do
    case (490)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 15.0d0*ci*iymx**5*sq7*z/8.0d0
       end do
    case (491)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-45.0d0)*ci*iymx**4/44.0d0
          qy(ig,4) = (-5.0d0)*ci*iymx**4*(396*z**2+11*iymx**2-36)/176.0d0
       end do
    case (492)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*ci*iymx**3*sq3*z/22.0d0
          qy(ig,4) = 5.0d0*ci*iymx**3*sq3*z*(165*z**2+11*iymx**2-45)/88.0d0
       end do
    case (493)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 2.0d0*ci*iymx**2*sq5/7.0d0
          qy(ig,3) = 9.0d0*ci*iymx**2*sq5*(28*z**2+7*iymx**2-4)/616.0d0
          qy(ig,4) = (-5.0d0)*ci*iymx**2*sq5*(264*z**4+33*iymx**2*z**2-144*z**2-3*iymx**2+8)/176.0d0
       end do
    case (494)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*ci*iymx*sq5*z/7.0d0
          qy(ig,3) = (-9.0d0)*ci*iymx*sq5*z*(28*z**2+7*iymx**2-12)/154.0d0
          qy(ig,4) = 5.0d0*ci*iymx*sq5*z*(99*z**4+22*iymx**2*z**2-90*z**2-6*iymx**2+15)/88.0d0
       end do
    case (495)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*ci*sq3/7.0d0
          qy(ig,2) = (-5.0d0)*ci*iymx**2/(14.0d0*sq3)
          qy(ig,3) = 3.0d0*ci*sq3*(245*z**4+105*iymx**2*z**2-210*z**2-15*iymx**2+21)/308.0d0
          qy(ig,4) = (-5.0d0)*ci*(2772*z**6+1155*iymx**2*z**4-3780*z**4-630*iymx**2*z**2+1260*z**2+35*iymx**2-60)/(1232.0d0*sq3)
       end do
    case (496)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*ci*(iypx+iymx)*z/7.0d0
          qy(ig,3) = (-45.0d0)*ci*(iypx+iymx)*z*(7*z**2-3)/154.0d0
          qy(ig,4) = 5.0d0*ci*(iypx+iymx)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (497)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*iymx**3*sq35/4.0d0
       end do
    case (498)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (499)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx**3*sq35*z/4.0d0
       end do
    case (500)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iymx**2*sq5/(2.0d0*sq7)
          qy(ig,2) = ci*iymx**2*sq5*(7*z**2-1)/sq7/4.0d0
       end do
    case (501)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx**4*sq105/sq2/4.0d0
       end do
    case (502)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx**3*sq35*z/sq2/2.0d0
       end do
    case (503)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*ci*iymx**2*sq5/(2.0d0*sq14)
          qy(ig,2) = ci*iymx**2*sq5*(7*z**2-1)/sq14/4.0d0
       end do
    case (504)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (505)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = ci*iymx**4*sq105*z/sq2/4.0d0
       end do
    case (506)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx**3*sq35/sq2/6.0d0
          qy(ig,3) = -ci*iymx**3*sq35*(3*z-1)*(3*z+1)/sq2/12.0d0
       end do
    case (507)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx**2*sq35*z/sq2/2.0d0
          qy(ig,3) = ci*iymx**2*sq35*z*(3*z**2-1)/sq2/4.0d0
       end do
    case (508)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -3*ci*iymx*sq6/sq35
          qy(ig,2) = ci*iymx*sq7*(5*z**2-1)/sq30
          qy(ig,3) = -ci*iymx*sq5*(21*z**4-14*z**2+1)/sq42/4.0d0
       end do
    case (509)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-5.0d0)*ci*iymx**5*sq42/16.0d0
       end do
    case (510)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = ci*iymx**4*sq105*z/sq2/2.0d0
       end do
    case (511)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx**3*sq35/sq3/4.0d0
          qy(ig,3) = -ci*iymx**3*sq35*(3*z-1)*(3*z+1)/sq3/8.0d0
       end do
    case (512)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -ci*iymx**2*sq35*z/sq3/2.0d0
          qy(ig,3) = ci*iymx**2*sq35*z*(3*z**2-1)/sq3/4.0d0
       end do
    case (513)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -9*ci*iymx/sq210
          qy(ig,2) = ci*iymx*sq7*(5*z**2-1)/sq30/2.0d0
          qy(ig,3) = -ci*iymx*sq5*(21*z**4-14*z**2+1)/sq42/8.0d0
       end do
    case (514)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
       end do
    case (515)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = (-5.0d0)*ci*iymx**5*sq42*z/16.0d0
       end do
    case (516)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*ci*iymx**4*sq105/(44.0d0*sq2)
          qy(ig,4) = 5.0d0*ci*iymx**4*sq105*(11*z**2-1)/(88.0d0*sq2)
       end do
    case (517)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 9.0d0*ci*iymx**3*sq105*z/44.0d0
          qy(ig,4) = (-5.0d0)*ci*iymx**3*sq105*z*(11*z**2-3)/88.0d0
       end do
    case (518)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx**2*sq5/sq21
          qy(ig,3) = (-9.0d0)*ci*iymx**2*sq15*(7*z**2-1)/(22.0d0*sq7)
          qy(ig,4) = 5.0d0*ci*iymx**2*sq35*(33*z**4-18*z**2+1)/(88.0d0*sq3)
       end do
    case (519)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -25*ci*iymx*z/sq210
          qy(ig,3) = 15.0d0*ci*iymx*sq30*z*(7*z**2-3)/(44.0d0*sq7)
          qy(ig,4) = (-25.0d0)*ci*iymx*sq7*z*(33*z**4-30*z**2+5)/(88.0d0*sq30)
       end do
    case (520)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci*sq6/sq7
          qy(ig,2) = 5*ci*(3*z**2-1)/sq42
          qy(ig,3) = (-9.0d0)*ci*sq6*(35*z**4-30*z**2+3)/(88.0d0*sq7)
          qy(ig,4) = 5.0d0*ci*(231*z**6-315*z**4+105*z**2-5)/(88.0d0*sq42)
       end do
    case (521)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 35.0d0*ci*iymx**6/16.0d0
       end do
    case (522)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = (-15.0d0)*ci*iymx**5*sq7*z/8.0d0
       end do
    case (523)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*ci*iymx**4*sq21/88.0d0
          qy(ig,4) = 25.0d0*ci*iymx**4*sq21*(11*z**2-1)/176.0d0
       end do
    case (524)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 9.0d0*ci*iymx**3*sq35*z/22.0d0
          qy(ig,4) = (-5.0d0)*ci*iymx**3*sq35*z*(11*z**2-3)/44.0d0
       end do
    case (525)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = ci*iymx**2*sq5/sq7/2.0d0
          qy(ig,3) = (-27.0d0)*ci*iymx**2*sq5*(7*z**2-1)/(44.0d0*sq7)
          qy(ig,4) = 5.0d0*ci*iymx**2*sq35*(33*z**4-18*z**2+1)/176.0d0
       end do
    case (526)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -5*ci*iymx*z/sq21
          qy(ig,3) = 45.0d0*ci*iymx*z*(7*z**2-3)/(22.0d0*sq21)
          qy(ig,4) = (-5.0d0)*ci*iymx*sq7*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
       end do
    case (527)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -ci/sq7
          qy(ig,2) = 5.0d0*ci*(3*z**2-1)/(6.0d0*sq7)
          qy(ig,3) = (-9.0d0)*ci*(35*z**4-30*z**2+3)/(88.0d0*sq7)
          qy(ig,4) = 5.0d0*ci*(231*z**6-315*z**4+105*z**2-5)/(528.0d0*sq7)
       end do
    case (528)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 0
       end do
    case default
       write(6,*) 'getqy_two_y() invalid k3 = ', k3
       stop
    end select

    if (ik3.lt.0) then
       qy = conjg(qy)
    end if
    return
  end subroutine getqy_two_y

  subroutine getqy_two_z(qy,ik3,gk,nl,nkc,mll3)
    implicit none
    integer,intent(in):: ik3,nl,nkc
    integer,intent(out):: mll3
    real(kind=8),intent(in):: gk(4,nkc)
    complex(kind=8):: qy(nkc,nl)
    !
    real(kind=8),parameter:: eps = 1.0d-12
    real(kind=8),parameter:: sq2 = sqrt(2.0d0), &
         sq3 = sqrt(3.0d0), sq5 = sqrt(5.0d0), &
         sq6 = sqrt(6.0d0), sq7 = sqrt(7.0d0), &
         sq8 = sqrt(8.0d0), sq10 = sqrt(10.0d0), &
         sq14 = sqrt(14.0d0), &
         sq15 = sqrt(15.0d0), sq21 = sqrt(21.0d0), &
         sq30 = sqrt(30.0d0), sq35 = sqrt(35.0d0), &
         sq42 = sqrt(42.0d0), sq105 = sqrt(105.0d0), &
         sq210 = sqrt(210.0d0)
    !
    integer:: k3
    integer:: ig,ist
    real(kind=8):: x,y,z,r
    complex(kind=8):: iypx, iymx
    !     
    k3 = abs(ik3)
    !
    ! FOR G=0
    if (gk(4,1).lt.eps) then
       qy(1,1:nl) = 0
       select case(k3)
       case (1)
          qy(1,1) = -1
       case (3)
          qy(1,1) = 1
       case (6)
          qy(1,1) = 1.0d0/3.0d0
       case (10)
          qy(1,1) = -1.0d0/3.0d0
       case (15)
          qy(1,1) = -1
       case (18)
          qy(1,1) = (-2.0d0)*sq2/3.0d0
       case (21)
          qy(1,1) = -1.0d0/3.0d0
       case (25)
          qy(1,1) = (-2.0d0)*sq2/3.0d0
       case (28)
          qy(1,1) = 1.0d0/3.0d0
       case (36)
          qy(1,1) = 1
       case (45)
          qy(1,1) = 3/5.0d0
       case (55)
          qy(1,1) = 1.0d0/5.0d0
       case (66)
          qy(1,1) = -1.0d0/5.0d0
       case (78)
          qy(1,1) = (-3)/5.0d0
       case (91)
          qy(1,1) = -1
       case (100)
          qy(1,1) = (-4)/5.0d0
       case (105)
          qy(1,1) = (-3)/5.0d0
       case (115)
          qy(1,1) = (-2.0d0)*sq6/5.0d0
       case (120)
          qy(1,1) = -1.0d0/5.0d0
       case (131)
          qy(1,1) = (-2.0d0)*sq6/5.0d0
       case (136)
          qy(1,1) = 1.0d0/5.0d0
       case (148)
          qy(1,1) = (-4)/5.0d0
       case (153)
          qy(1,1) = 3/5.0d0
       case (171)
          qy(1,1) = 1
       case (190)
          qy(1,1) = 5/7.0d0
       case (210)
          qy(1,1) = 3/7.0d0
       case (231)
          qy(1,1) = 1.0d0/7.0d0
       case (253)
          qy(1,1) = -1.0d0/7.0d0
       case (276)
          qy(1,1) = (-3)/7.0d0
       case (300)
          qy(1,1) = (-5)/7.0d0
       case (325)
          qy(1,1) = -1
       case (344)
          qy(1,1) = (-2.0d0)*sq6/7.0d0
       case (351)
          qy(1,1) = (-5)/7.0d0
       case (371)
          qy(1,1) = (-2.0d0)*sq10/7.0d0
       case (378)
          qy(1,1) = (-3)/7.0d0
       case (399)
          qy(1,1) = (-4.0d0)*sq3/7.0d0
       case (406)
          qy(1,1) = -1.0d0/7.0d0
       case (428)
          qy(1,1) = (-4.0d0)*sq3/7.0d0
       case (435)
          qy(1,1) = 1.0d0/7.0d0
       case (458)
          qy(1,1) = (-2.0d0)*sq10/7.0d0
       case (465)
          qy(1,1) = 3/7.0d0
       case (489)
          qy(1,1) = (-2.0d0)*sq6/7.0d0
       case (496)
          qy(1,1) = 5/7.0d0
       case (528)
          qy(1,1) = 1
       end select
       ist=2
    else
       ist=1
    end if

    select case(k3)
    case (1)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -1
       end do
    case (2)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (3)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1
       end do
    case (4)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -z
       end do
    case (5)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx
       end do
    case (6)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1.0d0/3.0d0
          qy(ig,2) = (-2.0d0)*(3*z**2-1)/3.0d0
       end do
    case (7)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx
       end do
    case (8)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -z
       end do
    case (9)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -2*iymx*z
       end do
    case (10)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -1.0d0/3.0d0
          qy(ig,2) = 2.0d0*(3*z**2-1)/3.0d0
       end do
    case (11)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx*sq3/sq2
       end do
    case (12)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (13)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx*sq3*z/sq2
       end do
    case (14)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq3/sq2
       end do
    case (15)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -1
          qy(ig,2) = (3*z**2-1)/2.0d0
       end do
    case (16)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq2*z
       end do
    case (17)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx/sq2
       end do
    case (18)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq2/3.0d0
          qy(ig,2) = -(3*z**2-1)/sq2/3.0d0
       end do
    case (19)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx*z/sq2
       end do
    case (20)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx*sq3*z
       end do
    case (21)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -1.0d0/3.0d0
          qy(ig,2) = (-5.0d0)*(3*z**2-1)/6.0d0
       end do
    case (22)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx/sq2
       end do
    case (23)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq2*z
       end do
    case (24)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx*z/sq2
       end do
    case (25)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq2/3.0d0
          qy(ig,2) = -(3*z**2-1)/sq2/3.0d0
       end do
    case (26)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq3/2.0d0
       end do
    case (27)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -2*iymx*z
       end do
    case (28)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1.0d0/3.0d0
          qy(ig,2) = 5.0d0*(3*z**2-1)/6.0d0
       end do
    case (29)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (30)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx*sq3/sq2
       end do
    case (31)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq3/sq2
       end do
    case (32)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx*sq3*z/sq2
       end do
    case (33)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (34)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq3/2.0d0
       end do
    case (35)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx*sq3*z
       end do
    case (36)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1
          qy(ig,2) = -(3*z**2-1)/2.0d0
       end do
    case (37)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -3*iypx*z/sq6
       end do
    case (38)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx**2*sq6/2.0d0
       end do
    case (39)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx*sq3/(5.0d0*sq2)
          qy(ig,2) = -iypx*sq2*sq3*(5*z**2-1)/5.0d0
       end do
    case (40)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq2*sq3*z
       end do
    case (41)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*z/5.0d0
          qy(ig,2) = 3.0d0*z*(5*z**2-3)/10.0d0
       end do
    case (42)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx*sq3/5.0d0
          qy(ig,2) = -iypx*sq3*(5*z**2-1)/10.0d0
       end do
    case (43)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**2*sq3*z/2.0d0
       end do
    case (44)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iypx**3/2.0d0
       end do
    case (45)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3/5.0d0
          qy(ig,2) = (-9.0d0)*(3*z**2-1)/14.0d0
          qy(ig,3) = 3.0d0*(35*z**4-30*z**2+3)/35.0d0
       end do
    case (46)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -(3*z**2-1)/sq2
       end do
    case (47)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -3*iypx*z/sq2
       end do
    case (48)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq2*z/5.0d0
          qy(ig,2) = (-3.0d0)*sq2*z*(5*z**2-3)/5.0d0
       end do
    case (49)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx/sq2/5.0d0
          qy(ig,2) = 3.0d0*iypx*sq2*(5*z**2-1)/5.0d0
       end do
    case (50)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx*sq3/5.0d0
          qy(ig,2) = 3.0d0*iymx*sq3*(5*z**2-1)/10.0d0
       end do
    case (51)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-7.0d0)*z/5.0d0
          qy(ig,2) = (-3.0d0)*z*(5*z**2-3)/10.0d0
       end do
    case (52)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-4.0d0)*iypx/5.0d0
          qy(ig,2) = (-3.0d0)*iypx*(5*z**2-1)/10.0d0
       end do
    case (53)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iypx**2*sq3*z/2.0d0
       end do
    case (54)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*iymx*sq3*z/7.0d0
          qy(ig,3) = 3.0d0*iymx*sq3*z*(7*z**2-3)/7.0d0
       end do
    case (55)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1.0d0/5.0d0
          qy(ig,2) = -(3*z**2-1)/14.0d0
          qy(ig,3) = (-9.0d0)*(35*z**4-30*z**2+3)/35.0d0
       end do
    case (56)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -3*iymx*z/sq2
       end do
    case (57)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -(3*z**2-1)/sq2
       end do
    case (58)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx/sq2/5.0d0
          qy(ig,2) = (-3.0d0)*iymx*sq2*(5*z**2-1)/5.0d0
       end do
    case (59)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq2*z/5.0d0
          qy(ig,2) = 3.0d0*sq2*z*(5*z**2-3)/5.0d0
       end do
    case (60)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx**2*sq3*z/2.0d0
       end do
    case (61)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-4.0d0)*iymx/5.0d0
          qy(ig,2) = (-3.0d0)*iymx*(5*z**2-1)/10.0d0
       end do
    case (62)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-7.0d0)*z/5.0d0
          qy(ig,2) = (-3.0d0)*z*(5*z**2-3)/10.0d0
       end do
    case (63)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx*sq3/5.0d0
          qy(ig,2) = 3.0d0*iypx*sq3*(5*z**2-1)/10.0d0
       end do
    case (64)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq3/14.0d0
          qy(ig,3) = 3.0d0*iymx**2*sq3*(7*z**2-1)/7.0d0
       end do
    case (65)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-6.0d0)*iymx*z/7.0d0
          qy(ig,3) = (-9.0d0)*iymx*z*(7*z**2-3)/7.0d0
       end do
    case (66)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -1.0d0/5.0d0
          qy(ig,2) = (3*z**2-1)/14.0d0
          qy(ig,3) = 9.0d0*(35*z**4-30*z**2+3)/35.0d0
       end do
    case (67)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -3*iymx**2/sq6
       end do
    case (68)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -3*iymx*z/sq6
       end do
    case (69)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq6*z
       end do
    case (70)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iymx/(5.0d0*sq6)
          qy(ig,2) = iymx*sq6*(5*z**2-1)/5.0d0
       end do
    case (71)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx**3/2.0d0
       end do
    case (72)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq3*z/2.0d0
       end do
    case (73)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx*sq3/5.0d0
          qy(ig,2) = -iymx*sq3*(5*z**2-1)/10.0d0
       end do
    case (74)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*z/5.0d0
          qy(ig,2) = 3.0d0*z*(5*z**2-3)/10.0d0
       end do
    case (75)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3*iymx**3*z
       end do
    case (76)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq3/14.0d0
          qy(ig,3) = (-3.0d0)*iymx**2*sq3*(7*z**2-1)/7.0d0
       end do
    case (77)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*iymx*sq3*z/7.0d0
          qy(ig,3) = 3.0d0*iymx*sq3*z*(7*z**2-3)/7.0d0
       end do
    case (78)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3)/5.0d0
          qy(ig,2) = 9.0d0*(3*z**2-1)/14.0d0
          qy(ig,3) = (-3.0d0)*(35*z**4-30*z**2+3)/35.0d0
       end do
    case (79)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx**2*sq30/4.0d0
       end do
    case (80)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (81)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-15.0d0)*iypx**2*z/(2.0d0*sq30)
       end do
    case (82)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3*sq30/4.0d0
       end do
    case (83)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -3*iypx/sq5
          qy(ig,2) = 3.0d0*iypx*(5*z**2-1)/(4.0d0*sq5)
       end do
    case (84)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**2*sq15*z/2.0d0
       end do
    case (85)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3*sq15/4.0d0
       end do
    case (86)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (87)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iypx*sq5*z/7.0d0
          qy(ig,3) = 3.0d0*iypx*sq5*z*(7*z**2-3)/28.0d0
       end do
    case (88)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq15/7.0d0
          qy(ig,3) = (-3.0d0)*iypx**2*sq15*(7*z**2-1)/28.0d0
       end do
    case (89)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iypx**3*sq15*z/4.0d0
       end do
    case (90)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iypx**4*sq5/4.0d0
       end do
    case (91)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -1
          qy(ig,2) = 5.0d0*(3*z**2-1)/7.0d0
          qy(ig,3) = (-3.0d0)*(35*z**4-30*z**2+3)/56.0d0
       end do
    case (92)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx*sq6*z
       end do
    case (93)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx**2*sq6/4.0d0
       end do
    case (94)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*iypx*sq6/5.0d0
          qy(ig,2) = (-3.0d0)*iypx*sq6*(5*z**2-1)/20.0d0
       end do
    case (95)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 9.0d0*iypx**2*z/(2.0d0*sq6)
       end do
    case (96)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*z/5.0d0
          qy(ig,2) = 3.0d0*z*(5*z**2-3)/5.0d0
       end do
    case (97)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx*sq3/5.0d0
          qy(ig,2) = (-9.0d0)*iypx*sq3*(5*z**2-1)/20.0d0
       end do
    case (98)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iypx**2*sq3*z/2.0d0
       end do
    case (99)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iypx**3/4.0d0
       end do
    case (100)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-4)/5.0d0
          qy(ig,2) = (3*z**2-1)/7.0d0
          qy(ig,3) = 9.0d0*(35*z**4-30*z**2+3)/140.0d0
       end do
    case (101)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*iypx*sq3*z/7.0d0
          qy(ig,3) = (-9.0d0)*iypx*sq3*z*(7*z**2-3)/28.0d0
       end do
    case (102)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 4.0d0*iypx**2*sq3/7.0d0
          qy(ig,3) = 9.0d0*iypx**2*sq3*(7*z**2-1)/28.0d0
       end do
    case (103)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-9.0d0)*iypx**3*z/4.0d0
       end do
    case (104)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 6.0d0*iymx*sq5*z/7.0d0
          qy(ig,3) = (-3.0d0)*iymx*sq5*z*(7*z**2-3)/14.0d0
       end do
    case (105)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3)/5.0d0
          qy(ig,2) = (-3.0d0)*(3*z**2-1)/7.0d0
          qy(ig,3) = 51.0d0*(35*z**4-30*z**2+3)/280.0d0
       end do
    case (106)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq3*(3*z**2-1)/2.0d0
       end do
    case (107)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx*sq3*z
       end do
    case (108)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-4.0d0)*sq3*z/5.0d0
          qy(ig,2) = -sq3*z*(5*z**2-3)/10.0d0
       end do
    case (109)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*iypx*sq3/5.0d0
          qy(ig,2) = iypx*sq3*(5*z**2-1)/10.0d0
       end do
    case (110)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx/(5.0d0*sq2)
          qy(ig,2) = 9.0d0*iymx*(5*z**2-1)/(10.0d0*sq2)
       end do
    case (111)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq6*z/5.0d0
          qy(ig,2) = (-2.0d0)*sq6*z*(5*z**2-3)/5.0d0
       end do
    case (112)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx*sq3/sq2/5.0d0
          qy(ig,2) = 7.0d0*iypx*sq3*(5*z**2-1)/(10.0d0*sq2)
       end do
    case (113)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -3*iypx**2*z/sq2
       end do
    case (114)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 15.0d0*iymx*z/(7.0d0*sq2)
          qy(ig,3) = 3.0d0*iymx*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (115)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq6/5.0d0
          qy(ig,2) = (-3.0d0)*sq3*(3*z**2-1)/(7.0d0*sq2)
          qy(ig,3) = (-3.0d0)*sq3*(35*z**4-30*z**2+3)/(70.0d0*sq2)
       end do
    case (116)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iypx*z/(7.0d0*sq6)
          qy(ig,3) = 3.0d0*iypx*sq3*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (117)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 9.0d0*iypx**2/(7.0d0*sq2)
          qy(ig,3) = (-3.0d0)*iypx**2*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (118)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx**2*sq10/14.0d0
          qy(ig,3) = (-9.0d0)*iymx**2*sq10*(7*z**2-1)/56.0d0
       end do
    case (119)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iymx*z*(7*z**2-3)/(2.0d0*sq2)
       end do
    case (120)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -1.0d0/5.0d0
          qy(ig,2) = (-2.0d0)*(3*z**2-1)/7.0d0
          qy(ig,3) = (-39.0d0)*(35*z**4-30*z**2+3)/140.0d0
       end do
    case (121)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx*sq3*z
       end do
    case (122)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq3*(3*z**2-1)/2.0d0
       end do
    case (123)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*iymx*sq3/5.0d0
          qy(ig,2) = iymx*sq3*(5*z**2-1)/10.0d0
       end do
    case (124)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-4.0d0)*sq3*z/5.0d0
          qy(ig,2) = -sq3*z*(5*z**2-3)/10.0d0
       end do
    case (125)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3*iymx**2*z/sq2
       end do
    case (126)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx*sq3/sq2/5.0d0
          qy(ig,2) = (-7.0d0)*iymx*sq3*(5*z**2-1)/(10.0d0*sq2)
       end do
    case (127)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq6*z/5.0d0
          qy(ig,2) = 2.0d0*sq2*sq3*z*(5*z**2-3)/5.0d0
       end do
    case (128)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx/(5.0d0*sq2)
          qy(ig,2) = (-9.0d0)*iypx*(5*z**2-1)/(10.0d0*sq2)
       end do
    case (129)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 9.0d0*iymx**2/(7.0d0*sq2)
          qy(ig,3) = (-3.0d0)*iymx**2*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (130)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx*sq3*z/sq2/7.0d0
          qy(ig,3) = 3.0d0*iymx*sq3*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (131)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq6/5.0d0
          qy(ig,2) = (-3.0d0)*sq3*(3*z**2-1)/(7.0d0*sq2)
          qy(ig,3) = (-3.0d0)*sq3*(35*z**4-30*z**2+3)/(70.0d0*sq2)
       end do
    case (132)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 15.0d0*iypx*z/(7.0d0*sq2)
          qy(ig,3) = 3.0d0*iypx*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (133)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iymx**3*sq5*z/(2.0d0*sq2)
       end do
    case (134)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx**2/(7.0d0*sq2)
          qy(ig,3) = 33.0d0*iymx**2*(7*z**2-1)/(28.0d0*sq2)
       end do
    case (135)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-6.0d0)*iymx*z/7.0d0
          qy(ig,3) = (-9.0d0)*iymx*z*(7*z**2-3)/7.0d0
       end do
    case (136)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1.0d0/5.0d0
          qy(ig,2) = 2.0d0*(3*z**2-1)/7.0d0
          qy(ig,3) = 39.0d0*(35*z**4-30*z**2+3)/140.0d0
       end do
    case (137)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx**2/(2.0d0*sq6)
       end do
    case (138)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx*sq6*z
       end do
    case (139)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 9.0d0*iymx**2*z/(2.0d0*sq6)
       end do
    case (140)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*iymx*sq6/5.0d0
          qy(ig,2) = (-3.0d0)*iymx*sq6*(5*z**2-1)/20.0d0
       end do
    case (141)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx**3/4.0d0
       end do
    case (142)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx**2*sq3*z/2.0d0
       end do
    case (143)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx*sq3/5.0d0
          qy(ig,2) = 9.0d0*iymx*sq3*(5*z**2-1)/20.0d0
       end do
    case (144)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*z/5.0d0
          qy(ig,2) = (-3.0d0)*z*(5*z**2-3)/5.0d0
       end do
    case (145)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-9.0d0)*iymx**3*z/4.0d0
       end do
    case (146)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 4.0d0*iymx**2*sq3/7.0d0
          qy(ig,3) = 9.0d0*iymx**2*sq3*(7*z**2-1)/28.0d0
       end do
    case (147)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*iymx*sq3*z/7.0d0
          qy(ig,3) = (-9.0d0)*iymx*sq3*z*(7*z**2-3)/28.0d0
       end do
    case (148)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-4)/5.0d0
          qy(ig,2) = (3*z**2-1)/7.0d0
          qy(ig,3) = 9.0d0*(35*z**4-30*z**2+3)/140.0d0
       end do
    case (149)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iymx**4*sq5/8.0d0
       end do
    case (150)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3*iymx**3*z
       end do
    case (151)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx**2/(7.0d0*sq2)
          qy(ig,3) = (-33.0d0)*iymx**2*(7*z**2-1)/(28.0d0*sq2)
       end do
    case (152)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iymx*z*(7*z**2-3)/(2.0d0*sq2)
       end do
    case (153)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3/5.0d0
          qy(ig,2) = 3.0d0*(3*z**2-1)/7.0d0
          qy(ig,3) = (-51.0d0)*(35*z**4-30*z**2+3)/280.0d0
       end do
    case (154)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (155)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx**2*sq5/(2.0d0*sq6)
       end do
    case (156)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3*sq30/4.0d0
       end do
    case (157)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx**2*sq5*z/(2.0d0*sq6)
       end do
    case (158)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (159)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**3*sq15/4.0d0
       end do
    case (160)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq15*z/2.0d0
       end do
    case (161)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3*iymx/sq5
          qy(ig,2) = (-3.0d0)*iymx*(5*z**2-1)/(4.0d0*sq5)
       end do
    case (162)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iymx**4*sq5/4.0d0
       end do
    case (163)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iymx**3*sq15*z/4.0d0
       end do
    case (164)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq15/7.0d0
          qy(ig,3) = (-3.0d0)*iymx**2*sq15*(7*z**2-1)/28.0d0
       end do
    case (165)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx*sq5*z/7.0d0
          qy(ig,3) = 3.0d0*iymx*sq5*z*(7*z**2-3)/28.0d0
       end do
    case (166)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
       end do
    case (167)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iymx**4*sq5/8.0d0
       end do
    case (168)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iymx**3*sq10*z/4.0d0
       end do
    case (169)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx**2*sq5/(7.0d0*sq2)
          qy(ig,3) = 9.0d0*iymx**2*sq5*(7*z**2-1)/(28.0d0*sq2)
       end do
    case (170)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 6.0d0*iymx*sq5*z/7.0d0
          qy(ig,3) = (-3.0d0)*iymx*sq5*z*(7*z**2-3)/14.0d0
       end do
    case (171)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1
          qy(ig,2) = (-5.0d0)*(3*z**2-1)/7.0d0
          qy(ig,3) = 3.0d0*(35*z**4-30*z**2+3)/56.0d0
       end do
    case (172)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx**2*sq30*z/4.0d0
       end do
    case (173)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx**3*sq5/(2.0d0*sq6)
       end do
    case (174)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 5.0d0*iypx**2*sq5*sq6/28.0d0
          qy(ig,2) = -iypx**2*sq5*sq6*(7*z**2-1)/14.0d0
       end do
    case (175)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3*sq5*sq6*z/2.0d0
       end do
    case (176)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx*sq5*z/7.0d0
          qy(ig,2) = 3.0d0*iypx*sq5*z*(7*z**2-3)/28.0d0
       end do
    case (177)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*iypx**2*sq15/7.0d0
          qy(ig,2) = -iypx**2*sq15*(7*z**2-1)/28.0d0
       end do
    case (178)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**3*sq15*z/4.0d0
       end do
    case (179)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iypx**4*sq5/4.0d0
       end do
    case (180)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx*sq5/7.0d0
          qy(ig,2) = -iypx*sq5*(5*z**2-1)/4.0d0
          qy(ig,3) = iypx*sq5*(21*z**4-14*z**2+1)/14.0d0
       end do
    case (181)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq15*z/2.0d0
          qy(ig,3) = -iypx**2*sq15*z*(3*z**2-1)/2.0d0
       end do
    case (182)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**3*sq5/sq3/4.0d0
          qy(ig,3) = iypx**3*sq5*(3*z-1)*(3*z+1)/sq3/2.0d0
       end do
    case (183)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iypx**4*sq5*z/2.0d0
       end do
    case (184)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*z/7.0d0
          qy(ig,2) = z*(5*z**2-3)/3.0d0
          qy(ig,3) = (-5.0d0)*z*(63*z**4-70*z**2+15)/168.0d0
       end do
    case (185)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx*sq5/7.0d0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iypx*sq5*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (186)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**2*sq5*z/sq2
          qy(ig,3) = -iypx**2*sq5*z*(3*z**2-1)/sq2/4.0d0
       end do
    case (187)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3*sq2*sq5/3.0d0
          qy(ig,3) = -iypx**3*sq5*(3*z-1)*(3*z+1)/sq2/12.0d0
       end do
    case (188)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 9.0d0*iypx**4*sq5*z/8.0d0
       end do
    case (189)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iypx**5/8.0d0
       end do
    case (190)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 5/7.0d0
          qy(ig,2) = (-5.0d0)*(3*z**2-1)/7.0d0
          qy(ig,3) = 75.0d0*(35*z**4-30*z**2+3)/616.0d0
          qy(ig,4) = (-5.0d0)*(231*z**6-315*z**4+105*z**2-5)/308.0d0
       end do
    case (191)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx*sq3*(5*z**2-1)/sq2/2.0d0
       end do
    case (192)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-5.0d0)*iypx**2*sq6*z/4.0d0
       end do
    case (193)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx*sq6*z/7.0d0
          qy(ig,2) = (-5.0d0)*iypx*sq3*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (194)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx**2*sq3/(14.0d0*sq2)
          qy(ig,2) = 5.0d0*iypx**2*sq3*(7*z**2-1)/(7.0d0*sq2)
       end do
    case (195)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*(3*z**2-1)/7.0d0
          qy(ig,2) = 3.0d0*(35*z**4-30*z**2+3)/28.0d0
       end do
    case (196)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iypx*sq3*z/7.0d0
          qy(ig,2) = (-5.0d0)*iypx*sq3*z*(7*z**2-3)/28.0d0
       end do
    case (197)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx**2*sq3/7.0d0
          qy(ig,2) = (-5.0d0)*iypx**2*sq3*(7*z**2-1)/28.0d0
       end do
    case (198)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 15.0d0*iypx**3*z/4.0d0
       end do
    case (199)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 18.0d0*z/35.0d0
          qy(ig,2) = (-11.0d0)*z*(5*z**2-3)/15.0d0
          qy(ig,3) = 5.0d0*z*(63*z**4-70*z**2+15)/42.0d0
       end do
    case (200)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*iypx*sq3/35.0d0
          qy(ig,2) = 3.0d0*iypx*sq3*(5*z**2-1)/20.0d0
          qy(ig,3) = (-5.0d0)*iypx*sq3*(21*z**4-14*z**2+1)/14.0d0
       end do
    case (201)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq3*z/2.0d0
          qy(ig,3) = 5.0d0*iypx**2*sq3*z*(3*z**2-1)/2.0d0
       end do
    case (202)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**3/12.0d0
          qy(ig,3) = (-5.0d0)*iypx**3*(3*z-1)*(3*z+1)/6.0d0
       end do
    case (203)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx/(7.0d0*sq5)
          qy(ig,2) = iymx*(5*z**2-1)/sq5
          qy(ig,3) = (-5.0d0)*iymx*sq5*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (204)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-39.0d0)*z/35.0d0
          qy(ig,2) = z*(5*z**2-3)/5.0d0
          qy(ig,3) = 5.0d0*z*(63*z**4-70*z**2+15)/56.0d0
       end do
    case (205)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-24.0d0)*iypx*sq2/35.0d0
          qy(ig,2) = (-2.0d0)*iypx*sq2*(5*z**2-1)/5.0d0
          qy(ig,3) = (-5.0d0)*iypx*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (206)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*z/sq2
          qy(ig,3) = (-5.0d0)*iypx**2*z*(3*z**2-1)/(4.0d0*sq2)
       end do
    case (207)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3
          qy(ig,3) = 5.0d0*iypx**3*(3*z-1)*(3*z+1)/8.0d0
       end do
    case (208)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iypx**4*sq5*z/8.0d0
       end do
    case (209)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-4.0d0)*iymx*sq5*z/7.0d0
          qy(ig,3) = 57.0d0*iymx*sq5*z*(7*z**2-3)/154.0d0
          qy(ig,4) = (-5.0d0)*iymx*sq5*z*(33*z**4-30*z**2+5)/44.0d0
       end do
    case (210)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3/7.0d0
          qy(ig,2) = -(3*z**2-1)/7.0d0
          qy(ig,3) = (-111.0d0)*(35*z**4-30*z**2+3)/616.0d0
          qy(ig,4) = 25.0d0*(231*z**6-315*z**4+105*z**2-5)/308.0d0
       end do
    case (211)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq3*z*(5*z**2-3)/2.0d0
       end do
    case (212)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx*sq3*(5*z**2-1)/2.0d0
       end do
    case (213)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = sq3*(3*z**2-1)/14.0d0
          qy(ig,2) = -sq3*(35*z**4-30*z**2+3)/7.0d0
       end do
    case (214)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx*sq3*z/7.0d0
          qy(ig,2) = 5.0d0*iypx*sq3*z*(7*z**2-3)/7.0d0
       end do
    case (215)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iymx*z/(7.0d0*sq2)
          qy(ig,2) = 15.0d0*iymx*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (216)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-5.0d0)*sq3*(3*z**2-1)/(7.0d0*sq2)
          qy(ig,2) = -sq3*(35*z**4-30*z**2+3)/sq2/14.0d0
       end do
    case (217)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-11.0d0)*iypx*sq3*z/(7.0d0*sq2)
          qy(ig,2) = (-5.0d0)*iypx*sq3*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (218)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx**2/(7.0d0*sq2)
          qy(ig,2) = 15.0d0*iypx**2*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (219)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx/(35.0d0*sq2)
          qy(ig,2) = (-7.0d0)*iymx*(5*z**2-1)/(10.0d0*sq2)
          qy(ig,3) = 5.0d0*iymx*(21*z**4-14*z**2+1)/(7.0d0*sq2)
       end do
    case (220)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*sq6*z/35.0d0
          qy(ig,2) = -sq2*z*(5*z**2-3)/sq3/5.0d0
          qy(ig,3) = (-5.0d0)*z*(63*z**4-70*z**2+15)/(7.0d0*sq6)
       end do
    case (221)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*iypx/(35.0d0*sq6)
          qy(ig,2) = 3.0d0*iypx*sq3*(5*z**2-1)/(10.0d0*sq2)
          qy(ig,3) = 5.0d0*iypx*sq3*(21*z**4-14*z**2+1)/(7.0d0*sq2)
       end do
    case (222)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*z/sq2
          qy(ig,3) = -5*iypx**2*z*(3*z**2-1)/sq2
       end do
    case (223)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq10*z/2.0d0
          qy(ig,3) = (-5.0d0)*iymx**2*sq10*z*(3*z**2-1)/8.0d0
       end do
    case (224)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-12.0d0)*iymx*sq2/35.0d0
          qy(ig,2) = 3.0d0*iymx*(5*z**2-1)/(5.0d0*sq2)
          qy(ig,3) = 15.0d0*iymx*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (225)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-51.0d0)*z/35.0d0
          qy(ig,2) = (-8.0d0)*z*(5*z**2-3)/15.0d0
          qy(ig,3) = (-5.0d0)*z*(63*z**4-70*z**2+15)/84.0d0
       end do
    case (226)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-27.0d0)*iypx/35.0d0
          qy(ig,2) = -iypx*(5*z**2-1)/5.0d0
          qy(ig,3) = (-5.0d0)*iypx*(21*z**4-14*z**2+1)/28.0d0
       end do
    case (227)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3*iypx**2*z/sq2
          qy(ig,3) = 15.0d0*iypx**2*z*(3*z**2-1)/(4.0d0*sq2)
       end do
    case (228)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3*sq5/sq2/3.0d0
          qy(ig,3) = (-5.0d0)*iypx**3*sq5*(3*z-1)*(3*z+1)/(12.0d0*sq2)
       end do
    case (229)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq10/14.0d0
          qy(ig,3) = 117.0d0*iymx**2*sq5*(7*z**2-1)/(308.0d0*sq2)
          qy(ig,4) = (-5.0d0)*iymx**2*sq10*(33*z**4-18*z**2+1)/44.0d0
       end do
    case (230)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-4.0d0)*iymx*sq2*z/7.0d0
          qy(ig,3) = (-75.0d0)*iymx*z*(7*z**2-3)/(154.0d0*sq2)
          qy(ig,4) = 25.0d0*iymx*z*(33*z**4-30*z**2+5)/(22.0d0*sq2)
       end do
    case (231)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1.0d0/7.0d0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*(35*z**4-30*z**2+3)/44.0d0
          qy(ig,4) = (-25.0d0)*(231*z**6-315*z**4+105*z**2-5)/154.0d0
       end do
    case (232)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx*sq3*(5*z**2-1)/2.0d0
       end do
    case (233)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq3*z*(5*z**2-3)/2.0d0
       end do
    case (234)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx*sq3*z/7.0d0
          qy(ig,2) = (-5.0d0)*iymx*sq3*z*(7*z**2-3)/7.0d0
       end do
    case (235)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -sq3*(3*z**2-1)/14.0d0
          qy(ig,2) = sq3*(35*z**4-30*z**2+3)/7.0d0
       end do
    case (236)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx**2/(7.0d0*sq2)
          qy(ig,2) = 15.0d0*iymx**2*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (237)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-11.0d0)*iymx*sq3*z/(7.0d0*sq2)
          qy(ig,2) = (-5.0d0)*iymx*sq3*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (238)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-5.0d0)*sq3*(3*z**2-1)/(7.0d0*sq2)
          qy(ig,2) = -sq3*(35*z**4-30*z**2+3)/sq2/14.0d0
       end do
    case (239)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iypx*z/(7.0d0*sq2)
          qy(ig,2) = 15.0d0*iypx*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (240)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*z/sq2
          qy(ig,3) = 5*iymx**2*z*(3*z**2-1)/sq2
       end do
    case (241)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx*sq3/(35.0d0*sq2)
          qy(ig,2) = (-3.0d0)*iymx*sq3*(5*z**2-1)/(10.0d0*sq2)
          qy(ig,3) = (-5.0d0)*iymx*sq3*(21*z**4-14*z**2+1)/(7.0d0*sq2)
       end do
    case (242)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*sq6*z/35.0d0
          qy(ig,2) = sq2*z*(5*z**2-3)/sq3/5.0d0
          qy(ig,3) = 5.0d0*z*(63*z**4-70*z**2+15)/(7.0d0*sq6)
       end do
    case (243)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx/(35.0d0*sq2)
          qy(ig,2) = 7.0d0*iypx*(5*z**2-1)/(10.0d0*sq2)
          qy(ig,3) = (-5.0d0)*iypx*(21*z**4-14*z**2+1)/(7.0d0*sq2)
       end do
    case (244)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3*sq10/6.0d0
          qy(ig,3) = (-5.0d0)*iymx**3*sq10*(3*z-1)*(3*z+1)/24.0d0
       end do
    case (245)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3*iymx**2*z/sq2
          qy(ig,3) = 15.0d0*iymx**2*z*(3*z**2-1)/(4.0d0*sq2)
       end do
    case (246)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-27.0d0)*iymx/35.0d0
          qy(ig,2) = -iymx*(5*z**2-1)/5.0d0
          qy(ig,3) = (-5.0d0)*iymx*(21*z**4-14*z**2+1)/28.0d0
       end do
    case (247)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-51.0d0)*z/35.0d0
          qy(ig,2) = (-8.0d0)*z*(5*z**2-3)/15.0d0
          qy(ig,3) = (-5.0d0)*z*(63*z**4-70*z**2+15)/84.0d0
       end do
    case (248)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-12.0d0)*iypx*sq2/35.0d0
          qy(ig,2) = 3.0d0*iypx*(5*z**2-1)/(5.0d0*sq2)
          qy(ig,3) = 15.0d0*iypx*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (249)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq5*z/sq2
          qy(ig,3) = (-5.0d0)*iypx**2*sq5*z*(3*z**2-1)/(4.0d0*sq2)
       end do
    case (250)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 21.0d0*iymx**3*sq10*z/44.0d0
          qy(ig,4) = (-15.0d0)*iymx**3*sq10*z*(11*z**2-3)/44.0d0
       end do
    case (251)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2/sq2/7.0d0
          qy(ig,3) = 75.0d0*iymx**2*(7*z**2-1)/(308.0d0*sq2)
          qy(ig,4) = 25.0d0*iymx**2*(33*z**4-18*z**2+1)/(22.0d0*sq2)
       end do
    case (252)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-4.0d0)*iymx*z/7.0d0
          qy(ig,3) = (-45.0d0)*iymx*z*(7*z**2-3)/77.0d0
          qy(ig,4) = (-25.0d0)*iymx*z*(33*z**4-30*z**2+5)/22.0d0
       end do
    case (253)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -1.0d0/7.0d0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*(35*z**4-30*z**2+3)/44.0d0
          qy(ig,4) = 25.0d0*(231*z**6-315*z**4+105*z**2-5)/154.0d0
       end do
    case (254)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-15.0d0)*iymx**2*z/(2.0d0*sq6)
       end do
    case (255)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx*sq3*(5*z**2-1)/sq2/2.0d0
       end do
    case (256)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx**2*sq3/(14.0d0*sq2)
          qy(ig,2) = (-5.0d0)*iymx**2*sq3*(7*z**2-1)/(7.0d0*sq2)
       end do
    case (257)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx*sq6*z/7.0d0
          qy(ig,2) = 5.0d0*iymx*sq3*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (258)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 15.0d0*iymx**3*z/4.0d0
       end do
    case (259)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx**2*sq3/7.0d0
          qy(ig,2) = (-5.0d0)*iymx**2*sq3*(7*z**2-1)/28.0d0
       end do
    case (260)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iymx*sq3*z/7.0d0
          qy(ig,2) = (-5.0d0)*iymx*sq3*z*(7*z**2-3)/28.0d0
       end do
    case (261)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*(3*z**2-1)/7.0d0
          qy(ig,2) = 3.0d0*(35*z**4-30*z**2+3)/28.0d0
       end do
    case (262)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3/12.0d0
          qy(ig,3) = 5.0d0*iymx**3*(3*z-1)*(3*z+1)/6.0d0
       end do
    case (263)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq3*z/2.0d0
          qy(ig,3) = (-5.0d0)*iymx**2*sq3*z*(3*z**2-1)/2.0d0
       end do
    case (264)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iymx*sq3/35.0d0
          qy(ig,2) = (-3.0d0)*iymx*sq3*(5*z**2-1)/20.0d0
          qy(ig,3) = 5.0d0*iymx*sq3*(21*z**4-14*z**2+1)/14.0d0
       end do
    case (265)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-18.0d0)*z/35.0d0
          qy(ig,2) = 11.0d0*z*(5*z**2-3)/15.0d0
          qy(ig,3) = (-5.0d0)*z*(63*z**4-70*z**2+15)/42.0d0
       end do
    case (266)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iymx**4*sq5*z/8.0d0
       end do
    case (267)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3
          qy(ig,3) = 5.0d0*iymx**3*(3*z-1)*(3*z+1)/8.0d0
       end do
    case (268)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*z/sq2
          qy(ig,3) = (-5.0d0)*iymx**2*z*(3*z**2-1)/(4.0d0*sq2)
       end do
    case (269)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-24.0d0)*iymx*sq2/35.0d0
          qy(ig,2) = (-2.0d0)*iymx*sq2*(5*z**2-1)/5.0d0
          qy(ig,3) = (-5.0d0)*iymx*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (270)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-39.0d0)*z/35.0d0
          qy(ig,2) = z*(5*z**2-3)/5.0d0
          qy(ig,3) = 5.0d0*z*(63*z**4-70*z**2+15)/56.0d0
       end do
    case (271)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx/(7.0d0*sq5)
          qy(ig,2) = iypx*(5*z**2-1)/sq5
          qy(ig,3) = (-5.0d0)*iypx*sq5*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (272)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iymx**4*sq5/88.0d0
          qy(ig,4) = (-15.0d0)*iymx**4*sq5*(11*z**2-1)/44.0d0
       end do
    case (273)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iymx**3*z/11.0d0
          qy(ig,4) = 75.0d0*iymx**3*z*(11*z**2-3)/44.0d0
       end do
    case (274)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2/sq2/7.0d0
          qy(ig,3) = (-75.0d0)*iymx**2*(7*z**2-1)/(308.0d0*sq2)
          qy(ig,4) = (-25.0d0)*iymx**2*(33*z**4-18*z**2+1)/(22.0d0*sq2)
       end do
    case (275)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-4.0d0)*iymx*sq2*z/7.0d0
          qy(ig,3) = (-75.0d0)*iymx*z*(7*z**2-3)/(154.0d0*sq2)
          qy(ig,4) = 25.0d0*iymx*z*(33*z**4-30*z**2+5)/(22.0d0*sq2)
       end do
    case (276)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3)/7.0d0
          qy(ig,2) = (3*z**2-1)/7.0d0
          qy(ig,3) = 111.0d0*(35*z**4-30*z**2+3)/616.0d0
          qy(ig,4) = (-25.0d0)*(231*z**6-315*z**4+105*z**2-5)/308.0d0
       end do
    case (277)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx**3*sq5/(2.0d0*sq6)
       end do
    case (278)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-15.0d0)*iymx**2*z/(2.0d0*sq30)
       end do
    case (279)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**3*sq5*sq6*z/2.0d0
       end do
    case (280)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-5.0d0)*iymx**2*sq5*sq6/28.0d0
          qy(ig,2) = iymx**2*sq5*sq6*(7*z**2-1)/14.0d0
       end do
    case (281)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx**4*sq5/4.0d0
       end do
    case (282)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**3*sq15*z/4.0d0
       end do
    case (283)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*iymx**2*sq15/7.0d0
          qy(ig,2) = -iymx**2*sq15*(7*z**2-1)/28.0d0
       end do
    case (284)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx*sq5*z/7.0d0
          qy(ig,2) = 3.0d0*iymx*sq5*z*(7*z**2-3)/28.0d0
       end do
    case (285)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iymx**4*sq5*z/2.0d0
       end do
    case (286)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3*sq5/sq3/4.0d0
          qy(ig,3) = -iymx**3*sq5*(3*z-1)*(3*z+1)/sq3/2.0d0
       end do
    case (287)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq15*z/2.0d0
          qy(ig,3) = iymx**2*sq15*z*(3*z**2-1)/2.0d0
       end do
    case (288)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx*sq5/7.0d0
          qy(ig,2) = iymx*sq5*(5*z**2-1)/4.0d0
          qy(ig,3) = -iymx*sq5*(21*z**4-14*z**2+1)/14.0d0
       end do
    case (289)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iymx**5/8.0d0
       end do
    case (290)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 9.0d0*iymx**4*sq5*z/8.0d0
       end do
    case (291)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3*sq10/3.0d0
          qy(ig,3) = -iymx**3*sq5*(3*z-1)*(3*z+1)/sq2/12.0d0
       end do
    case (292)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq5*z/sq2
          qy(ig,3) = -iymx**2*sq5*z*(3*z**2-1)/sq2/4.0d0
       end do
    case (293)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx*sq5/7.0d0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iymx*sq5*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (294)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*z/7.0d0
          qy(ig,2) = z*(5*z**2-3)/3.0d0
          qy(ig,3) = (-5.0d0)*z*(63*z**4-70*z**2+15)/168.0d0
       end do
    case (295)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = (-15.0d0)*iymx**5*z/4.0d0
       end do
    case (296)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iymx**4*sq5/88.0d0
          qy(ig,4) = 15.0d0*iymx**4*sq5*(11*z**2-1)/44.0d0
       end do
    case (297)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 21.0d0*iymx**3*sq5*z/(22.0d0*sq2)
          qy(ig,4) = (-15.0d0)*iymx**3*sq5*z*(11*z**2-3)/(22.0d0*sq2)
       end do
    case (298)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq10/14.0d0
          qy(ig,3) = (-117.0d0)*iymx**2*sq5*(7*z**2-1)/(308.0d0*sq2)
          qy(ig,4) = 5.0d0*iymx**2*sq5*(33*z**4-18*z**2+1)/(22.0d0*sq2)
       end do
    case (299)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-4.0d0)*iymx*sq5*z/7.0d0
          qy(ig,3) = 57.0d0*iymx*sq5*z*(7*z**2-3)/154.0d0
          qy(ig,4) = (-5.0d0)*iymx*sq5*z*(33*z**4-30*z**2+5)/44.0d0
       end do
    case (300)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-5)/7.0d0
          qy(ig,2) = 5.0d0*(3*z**2-1)/7.0d0
          qy(ig,3) = (-75.0d0)*(35*z**4-30*z**2+3)/616.0d0
          qy(ig,4) = 5.0d0*(231*z**6-315*z**4+105*z**2-5)/308.0d0
       end do
    case (301)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx**3*sq35/4.0d0
       end do
    case (302)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (303)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**3*sq35*z/4.0d0
       end do
    case (304)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**4*sq35/4.0d0
       end do
    case (305)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx**2*sq105/(14.0d0*sq2)
          qy(ig,2) = iypx**2*sq105*(7*z**2-1)/sq2/28.0d0
       end do
    case (306)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**3*sq35*z/sq2/2.0d0
       end do
    case (307)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**4*sq35/sq2/4.0d0
       end do
    case (308)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (309)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**2*sq105*z/sq2/6.0d0
          qy(ig,3) = iypx**2*sq105*z*(3*z**2-1)/sq2/12.0d0
       end do
    case (310)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3*sq35/sq2/6.0d0
          qy(ig,3) = -iypx**3*sq35*(3*z-1)*(3*z+1)/sq2/12.0d0
       end do
    case (311)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iypx**4*sq35*z/(4.0d0*sq2)
       end do
    case (312)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iypx**5*sq35/(4.0d0*sq6)
       end do
    case (313)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx*sq6/(2.0d0*sq7)
          qy(ig,2) = iypx*sq7*(5*z**2-1)/sq6/2.0d0
          qy(ig,3) = (-5.0d0)*iypx*(21*z**4-14*z**2+1)/(8.0d0*sq42)
       end do
    case (314)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**2*sq105*z/sq2/3.0d0
          qy(ig,3) = iypx**2*sq105*z*(3*z**2-1)/sq2/6.0d0
       end do
    case (315)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3*sq35/sq3/4.0d0
          qy(ig,3) = -iypx**3*sq35*(3*z-1)*(3*z+1)/sq3/8.0d0
       end do
    case (316)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = iypx**4*sq105*z/4.0d0
       end do
    case (317)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iypx**5*sq35/(8.0d0*sq6)
       end do
    case (318)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
       end do
    case (319)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -5*iypx*z/sq42
          qy(ig,3) = 15.0d0*iypx*sq6*z*(7*z**2-3)/(44.0d0*sq7)
          qy(ig,4) = (-5.0d0)*iypx*sq42*z*(33*z**4-30*z**2+5)/528.0d0
       end do
    case (320)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq15/sq14/3.0d0
          qy(ig,3) = (-9.0d0)*iypx**2*sq15*(7*z**2-1)/(22.0d0*sq14)
          qy(ig,4) = 5.0d0*iypx**2*sq105*(33*z**4-18*z**2+1)/(264.0d0*sq2)
       end do
    case (321)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 9.0d0*iypx**3*sq105*z/44.0d0
          qy(ig,4) = (-5.0d0)*iypx**3*sq105*z*(11*z**2-3)/88.0d0
       end do
    case (322)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iypx**4*sq105/44.0d0
          qy(ig,4) = 5.0d0*iypx**4*sq105*(11*z**2-1)/88.0d0
       end do
    case (323)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = (-15.0d0)*iypx**5*sq35*z/(8.0d0*sq6)
       end do
    case (324)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 5.0d0*iypx**6*sq42/16.0d0
       end do
    case (325)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -1
          qy(ig,2) = 5.0d0*(3*z**2-1)/6.0d0
          qy(ig,3) = (-9.0d0)*(35*z**4-30*z**2+3)/88.0d0
          qy(ig,4) = 5.0d0*(231*z**6-315*z**4+105*z**2-5)/528.0d0
       end do
    case (326)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx**2*sq5*z/2.0d0
       end do
    case (327)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx**3*sq5/4.0d0
       end do
    case (328)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx**2*sq5/7.0d0
          qy(ig,2) = (-5.0d0)*iypx**2*sq5*(7*z**2-1)/28.0d0
       end do
    case (329)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*iypx**3*sq5*z/4.0d0
       end do
    case (330)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx*sq30*z/7.0d0
          qy(ig,2) = 3.0d0*iypx*sq15*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (331)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx**2*sq5/(14.0d0*sq2)
          qy(ig,2) = (-13.0d0)*iypx**2*sq5*(7*z**2-1)/(28.0d0*sq2)
       end do
    case (332)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3*sq10*z
       end do
    case (333)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**4*sq15/sq2/4.0d0
       end do
    case (334)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*iypx*sq6/(7.0d0*sq5)
          qy(ig,2) = -iypx*(5*z**2-1)/(sq10*sq3)/2.0d0
          qy(ig,3) = 5.0d0*iypx*sq10*(21*z**4-14*z**2+1)/(56.0d0*sq3)
       end do
    case (335)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**2*sq5*z/sq2/2.0d0
          qy(ig,3) = (-5.0d0)*iypx**2*sq5*z*(3*z**2-1)/(4.0d0*sq2)
       end do
    case (336)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3*sq2*sq5/3.0d0
          qy(ig,3) = 5.0d0*iypx**3*sq5*(3*z-1)*(3*z+1)/(12.0d0*sq2)
       end do
    case (337)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iypx**4*sq5*z/(4.0d0*sq6)
       end do
    case (338)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*sq6*z/7.0d0
          qy(ig,2) = sq6*z*(5*z**2-3)/3.0d0
          qy(ig,3) = (-5.0d0)*z*(63*z**4-70*z**2+15)/(28.0d0*sq6)
       end do
    case (339)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iypx*sq6/(14.0d0*sq5)
          qy(ig,2) = (-7.0d0)*iypx*(5*z**2-1)/(2.0d0*sq10*sq3)
          qy(ig,3) = 25.0d0*iypx*sq10*(21*z**4-14*z**2+1)/(112.0d0*sq3)
       end do
    case (340)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq15*z/6.0d0
          qy(ig,3) = (-5.0d0)*iypx**2*sq15*z*(3*z**2-1)/6.0d0
       end do
    case (341)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3*sq5/sq3/4.0d0
          qy(ig,3) = 5.0d0*iypx**3*sq5*(3*z-1)*(3*z+1)/(8.0d0*sq3)
       end do
    case (342)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iypx**4*sq5*z/(4.0d0*sq6)
       end do
    case (343)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iypx**5/(8.0d0*sq6)
       end do
    case (344)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq6/7.0d0
          qy(ig,2) = 5.0d0*(3*z**2-1)/(7.0d0*sq6)
          qy(ig,3) = 3.0d0*sq6*(35*z**4-30*z**2+3)/154.0d0
          qy(ig,4) = (-25.0d0)*(231*z**6-315*z**4+105*z**2-5)/(616.0d0*sq6)
       end do
    case (345)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-11.0d0)*iypx*sq30*z/42.0d0
          qy(ig,3) = (-9.0d0)*iypx*sq30*z*(7*z**2-3)/308.0d0
          qy(ig,4) = 25.0d0*iypx*sq15*z*(33*z**4-30*z**2+5)/(264.0d0*sq2)
       end do
    case (346)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 4.0d0*iypx**2*sq5/(7.0d0*sq3)
          qy(ig,3) = (-9.0d0)*iypx**2*sq15*(7*z**2-1)/308.0d0
          qy(ig,4) = (-25.0d0)*iypx**2*sq5*(33*z**4-18*z**2+1)/(88.0d0*sq3)
       end do
    case (347)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 21.0d0*iypx**3*sq15*z/44.0d0
          qy(ig,4) = 25.0d0*iypx**3*sq15*z*(11*z**2-3)/88.0d0
       end do
    case (348)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-9.0d0)*iypx**4*sq15/(22.0d0*sq2)
          qy(ig,4) = (-25.0d0)*iypx**4*sq15*(11*z**2-1)/(88.0d0*sq2)
       end do
    case (349)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 75.0d0*iypx**5*z/(8.0d0*sq6)
       end do
    case (350)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5*iymx*z/sq7
          qy(ig,3) = (-45.0d0)*iymx*z*(7*z**2-3)/(22.0d0*sq7)
          qy(ig,4) = 5.0d0*iymx*sq7*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (351)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-5)/7.0d0
          qy(ig,2) = (-5.0d0)*(3*z**2-1)/42.0d0
          qy(ig,3) = 135.0d0*(35*z**4-30*z**2+3)/616.0d0
          qy(ig,4) = (-185.0d0)*(231*z**6-315*z**4+105*z**2-5)/3696.0d0
       end do
    case (352)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx*sq15*(5*z**2-1)/4.0d0
       end do
    case (353)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx**2*sq15*z/2.0d0
       end do
    case (354)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-4.0d0)*iypx*sq15*z/7.0d0
          qy(ig,2) = (-3.0d0)*iypx*sq15*z*(7*z**2-3)/28.0d0
       end do
    case (355)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx**2*sq15/7.0d0
          qy(ig,2) = 3.0d0*iypx**2*sq15*(7*z**2-1)/28.0d0
       end do
    case (356)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*sq5*(3*z**2-1)/(7.0d0*sq2)
          qy(ig,2) = 3.0d0*sq5*(35*z**4-30*z**2+3)/(28.0d0*sq2)
       end do
    case (357)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iypx*sq30*z/7.0d0
          qy(ig,2) = (-3.0d0)*iypx*sq15*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (358)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iypx**2*sq15/sq2/14.0d0
          qy(ig,2) = 9.0d0*iypx**2*sq15*(7*z**2-1)/(28.0d0*sq2)
       end do
    case (359)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iypx**3*sq10*z/4.0d0
       end do
    case (360)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-12.0d0)*sq2*z/(7.0d0*sq5)
          qy(ig,2) = z*(5*z**2-3)/(sq2*sq5)
          qy(ig,3) = sq5*z*(63*z**4-70*z**2+15)/sq2/28.0d0
       end do
    case (361)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*iypx*sq6/(7.0d0*sq5)
          qy(ig,2) = -iypx*sq15*(5*z**2-1)/sq2/5.0d0
          qy(ig,3) = (-3.0d0)*iypx*sq15*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (362)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq15*z/sq2/2.0d0
          qy(ig,3) = 3.0d0*iypx**2*sq15*z*(3*z**2-1)/(4.0d0*sq2)
       end do
    case (363)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**3*sq5/sq2/2.0d0
          qy(ig,3) = -iypx**3*sq5*(3*z-1)*(3*z+1)/sq2/4.0d0
       end do
    case (364)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx/(7.0d0*sq2)
          qy(ig,2) = iymx*(5*z**2-1)/sq2
          qy(ig,3) = (-25.0d0)*iymx*(21*z**4-14*z**2+1)/(56.0d0*sq2)
       end do
    case (365)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*sq2*z/(7.0d0*sq5)
          qy(ig,2) = (-2.0d0)*sq2*z*(5*z**2-3)/(3.0d0*sq5)
          qy(ig,3) = 11.0d0*sq5*z*(63*z**4-70*z**2+15)/(84.0d0*sq2)
       end do
    case (366)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iypx/(7.0d0*sq5)
          qy(ig,2) = -iypx*(5*z**2-1)/sq5/4.0d0
          qy(ig,3) = (-19.0d0)*iypx*sq5*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (367)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx**2*sq5*z/2.0d0
          qy(ig,3) = 2*iypx**2*sq5*z*(3*z**2-1)
       end do
    case (368)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**3*sq5/sq2/6.0d0
          qy(ig,3) = (-13.0d0)*iypx**3*sq5*(3*z-1)*(3*z+1)/(24.0d0*sq2)
       end do
    case (369)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iypx**4*z/(4.0d0*sq2)
       end do
    case (370)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 15.0d0*iymx*z/(7.0d0*sq2)
          qy(ig,3) = (-15.0d0)*iymx*z*(7*z**2-3)/(77.0d0*sq2)
          qy(ig,4) = (-15.0d0)*iymx*z*(33*z**4-30*z**2+5)/(88.0d0*sq2)
       end do
    case (371)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq10/7.0d0
          qy(ig,2) = -sq5*(3*z**2-1)/sq2/7.0d0
          qy(ig,3) = 9.0d0*sq5*(35*z**4-30*z**2+3)/(154.0d0*sq2)
          qy(ig,4) = 15.0d0*sq5*(231*z**6-315*z**4+105*z**2-5)/(616.0d0*sq2)
       end do
    case (372)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iypx*sq5*z/7.0d0
          qy(ig,3) = (-93.0d0)*iypx*sq5*z*(7*z**2-3)/308.0d0
          qy(ig,4) = (-15.0d0)*iypx*sq5*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (373)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iypx**2*sq5/7.0d0
          qy(ig,3) = 69.0d0*iypx**2*sq5*(7*z**2-1)/308.0d0
          qy(ig,4) = 15.0d0*iypx**2*sq5*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (374)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-45.0d0)*iypx**3*z/(22.0d0*sq10)
          qy(ig,4) = (-45.0d0)*iypx**3*sq10*z*(11*z**2-3)/176.0d0
       end do
    case (375)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iypx**4/(11.0d0*sq2)
          qy(ig,4) = 45.0d0*iypx**4*(11*z**2-1)/(88.0d0*sq2)
       end do
    case (376)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*iymx**2/(2.0d0*sq21)
          qy(ig,3) = (-45.0d0)*iymx**2*sq3*(7*z**2-1)/(44.0d0*sq7)
          qy(ig,4) = 25.0d0*iymx**2*sq21*(33*z**4-18*z**2+1)/528.0d0
       end do
    case (377)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 10.0d0*iymx*z/(7.0d0*sq3)
          qy(ig,3) = 75.0d0*iymx*sq3*z*(7*z**2-3)/154.0d0
          qy(ig,4) = (-10.0d0)*iymx*z*(33*z**4-30*z**2+5)/(11.0d0*sq3)
       end do
    case (378)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3)/7.0d0
          qy(ig,2) = (-5.0d0)*(3*z**2-1)/14.0d0
          qy(ig,3) = (-57.0d0)*(35*z**4-30*z**2+3)/616.0d0
          qy(ig,4) = 145.0d0*(231*z**6-315*z**4+105*z**2-5)/1232.0d0
       end do
    case (379)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -z*(5*z**2-3)
       end do
    case (380)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx*(5*z**2-1)/4.0d0
       end do
    case (381)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*(3*z**2-1)/7.0d0
          qy(ig,2) = -(35*z**4-30*z**2+3)/28.0d0
       end do
    case (382)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-12.0d0)*iypx*z/7.0d0
          qy(ig,2) = 5.0d0*iypx*z*(7*z**2-3)/28.0d0
       end do
    case (383)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx*sq6*z/7.0d0
          qy(ig,2) = 5.0d0*iymx*sq3*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (384)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*(3*z**2-1)/(7.0d0*sq2)
          qy(ig,2) = (-11.0d0)*(35*z**4-30*z**2+3)/(28.0d0*sq2)
       end do
    case (385)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx*sq2*z/7.0d0
          qy(ig,2) = 25.0d0*iypx*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (386)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx**2*sq3/(14.0d0*sq2)
          qy(ig,2) = (-15.0d0)*iypx**2*sq3*(7*z**2-1)/(28.0d0*sq2)
       end do
    case (387)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*iymx*sq6/35.0d0
          qy(ig,2) = 7.0d0*iymx*(5*z**2-1)/(5.0d0*sq6)
          qy(ig,3) = 5.0d0*iymx*(21*z**4-14*z**2+1)/(28.0d0*sq6)
       end do
    case (388)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-36.0d0)*sq2*z/35.0d0
          qy(ig,2) = (-11.0d0)*z*(5*z**2-3)/(15.0d0*sq2)
          qy(ig,3) = (-5.0d0)*z*(63*z**4-70*z**2+15)/(84.0d0*sq2)
       end do
    case (389)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-18.0d0)*iypx*sq2/35.0d0
          qy(ig,2) = -iypx*(5*z**2-1)/sq2/10.0d0
          qy(ig,3) = 5.0d0*iypx*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (390)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 11.0d0*iypx**2*z/(2.0d0*sq2*sq3)
          qy(ig,3) = (-5.0d0)*iypx**2*z*(3*z**2-1)/(4.0d0*sq2*sq3)
       end do
    case (391)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 10*iymx**2*z/sq30
          qy(ig,3) = (-5.0d0)*iymx**2*sq30*z*(3*z**2-1)/12.0d0
       end do
    case (392)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-9.0d0)*iymx*sq6/70.0d0
          qy(ig,2) = -iymx*(5*z**2-1)/sq6/5.0d0
          qy(ig,3) = 95.0d0*iymx*(21*z**4-14*z**2+1)/(56.0d0*sq6)
       end do
    case (393)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*sq3*z/35.0d0
          qy(ig,2) = -sq3*z*(5*z**2-3)/5.0d0
          qy(ig,3) = (-5.0d0)*sq3*z*(63*z**4-70*z**2+15)/28.0d0
       end do
    case (394)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx*sq3/35.0d0
          qy(ig,2) = 13.0d0*iypx*(5*z**2-1)/(20.0d0*sq3)
          qy(ig,3) = 85.0d0*iypx*(21*z**4-14*z**2+1)/(56.0d0*sq3)
       end do
    case (395)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**2*z/(sq2*sq3)
          qy(ig,3) = -5*iypx**2*sq2*z*(3*z**2-1)/sq3
       end do
    case (396)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iypx**3*sq5/sq6/2.0d0
          qy(ig,3) = 5.0d0*iypx**3*sq5*(3*z-1)*(3*z+1)/(8.0d0*sq6)
       end do
    case (397)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*iymx**2*sq30/42.0d0
          qy(ig,3) = (-6.0d0)*iymx**2*sq30*(7*z**2-1)/77.0d0
          qy(ig,4) = (-5.0d0)*iymx**2*sq30*(33*z**4-18*z**2+1)/528.0d0
       end do
    case (398)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 19.0d0*iymx*z/(7.0d0*sq6)
          qy(ig,3) = 45.0d0*iymx*sq3*z*(7*z**2-3)/(77.0d0*sq2)
          qy(ig,4) = 25.0d0*iymx*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
       end do
    case (399)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-4.0d0)*sq3/7.0d0
          qy(ig,2) = -(3*z**2-1)/sq3
          qy(ig,3) = (-3.0d0)*sq3*(35*z**4-30*z**2+3)/44.0d0
          qy(ig,4) = (-25.0d0)*(231*z**6-315*z**4+105*z**2-5)/(616.0d0*sq3)
       end do
    case (400)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iypx*z/sq3/7.0d0
          qy(ig,3) = 15.0d0*iypx*sq3*z*(7*z**2-3)/308.0d0
          qy(ig,4) = 25.0d0*iypx*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
       end do
    case (401)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 16.0d0*iypx**2/(7.0d0*sq6)
          qy(ig,3) = 45.0d0*iypx**2*sq3*(7*z**2-1)/(154.0d0*sq2)
          qy(ig,4) = (-25.0d0)*iypx**2*(33*z**4-18*z**2+1)/(88.0d0*sq2*sq3)
       end do
    case (402)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-105.0d0)*iypx**3*sq3*z/(22.0d0*sq10)
          qy(ig,4) = 25.0d0*iypx**3*sq3*z*(11*z**2-3)/(88.0d0*sq10)
       end do
    case (403)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-9.0d0)*iymx**3*sq35*z/22.0d0
          qy(ig,4) = 5.0d0*iymx**3*sq35*z*(11*z**2-3)/44.0d0
       end do
    case (404)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx**2*sq5/14.0d0
          qy(ig,3) = 45.0d0*iymx**2*sq5*(7*z**2-1)/308.0d0
          qy(ig,4) = (-45.0d0)*iymx**2*sq5*(33*z**4-18*z**2+1)/176.0d0
       end do
    case (405)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx*sq15*z/21.0d0
          qy(ig,3) = 3.0d0*iymx*sq15*z*(7*z**2-3)/154.0d0
          qy(ig,4) = 65.0d0*iymx*sq15*z*(33*z**4-30*z**2+5)/264.0d0
       end do
    case (406)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -1.0d0/7.0d0
          qy(ig,2) = -(3*z**2-1)/6.0d0
          qy(ig,3) = (-9.0d0)*(35*z**4-30*z**2+3)/88.0d0
          qy(ig,4) = (-625.0d0)*(231*z**6-315*z**4+105*z**2-5)/3696.0d0
       end do
    case (407)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx*(5*z**2-1)/4.0d0
       end do
    case (408)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = z*(5*z**2-3)
       end do
    case (409)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-12.0d0)*iymx*z/7.0d0
          qy(ig,2) = 5.0d0*iymx*z*(7*z**2-3)/28.0d0
       end do
    case (410)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*(3*z**2-1)/7.0d0
          qy(ig,2) = -(35*z**4-30*z**2+3)/28.0d0
       end do
    case (411)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx**2*sq3/(14.0d0*sq2)
          qy(ig,2) = 15.0d0*iymx**2*sq3*(7*z**2-1)/(28.0d0*sq2)
       end do
    case (412)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx*sq2*z/7.0d0
          qy(ig,2) = (-25.0d0)*iymx*z*(7*z**2-3)/(14.0d0*sq2)
       end do
    case (413)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*(3*z**2-1)/(7.0d0*sq2)
          qy(ig,2) = 11.0d0*(35*z**4-30*z**2+3)/(28.0d0*sq2)
       end do
    case (414)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx*sq6*z/7.0d0
          qy(ig,2) = (-5.0d0)*iypx*sq3*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (415)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 11.0d0*iymx**2*z/(2.0d0*sq2*sq3)
          qy(ig,3) = (-5.0d0)*iymx**2*z*(3*z**2-1)/(4.0d0*sq2*sq3)
       end do
    case (416)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-18.0d0)*iymx*sq2/35.0d0
          qy(ig,2) = -iymx*(5*z**2-1)/sq2/10.0d0
          qy(ig,3) = 5.0d0*iymx*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (417)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-36.0d0)*sq2*z/35.0d0
          qy(ig,2) = (-11.0d0)*z*(5*z**2-3)/(15.0d0*sq2)
          qy(ig,3) = (-5.0d0)*z*(63*z**4-70*z**2+15)/(84.0d0*sq2)
       end do
    case (418)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*iypx*sq6/35.0d0
          qy(ig,2) = 7.0d0*iypx*(5*z**2-1)/(5.0d0*sq6)
          qy(ig,3) = 5.0d0*iypx*(21*z**4-14*z**2+1)/(28.0d0*sq6)
       end do
    case (419)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3*sq30/12.0d0
          qy(ig,3) = (-5.0d0)*iymx**3*sq30*(3*z-1)*(3*z+1)/48.0d0
       end do
    case (420)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*z/(sq2*sq3)
          qy(ig,3) = 5*iymx**2*sq2*z*(3*z**2-1)/sq3
       end do
    case (421)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx*sq3/35.0d0
          qy(ig,2) = (-13.0d0)*iymx*(5*z**2-1)/(20.0d0*sq3)
          qy(ig,3) = (-85.0d0)*iymx*(21*z**4-14*z**2+1)/(56.0d0*sq3)
       end do
    case (422)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 6.0d0*sq3*z/35.0d0
          qy(ig,2) = sq3*z*(5*z**2-3)/5.0d0
          qy(ig,3) = 5.0d0*sq3*z*(63*z**4-70*z**2+15)/28.0d0
       end do
    case (423)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 27.0d0*iypx/(35.0d0*sq6)
          qy(ig,2) = iypx*(5*z**2-1)/sq6/5.0d0
          qy(ig,3) = (-95.0d0)*iypx*(21*z**4-14*z**2+1)/(56.0d0*sq6)
       end do
    case (424)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -2*iypx**2*sq5*z/sq6
          qy(ig,3) = 5.0d0*iypx**2*sq5*z*(3*z**2-1)/(2.0d0*sq6)
       end do
    case (425)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-21.0d0)*iymx**3*sq30*z/44.0d0
          qy(ig,4) = 5.0d0*iymx**3*sq30*z*(11*z**2-3)/176.0d0
       end do
    case (426)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 8.0d0*iymx**2*sq6/21.0d0
          qy(ig,3) = 45.0d0*iymx**2*sq3*(7*z**2-1)/(154.0d0*sq2)
          qy(ig,4) = (-25.0d0)*iymx**2*(33*z**4-18*z**2+1)/(88.0d0*sq2*sq3)
       end do
    case (427)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx*z/sq3/7.0d0
          qy(ig,3) = 15.0d0*iymx*sq3*z*(7*z**2-3)/308.0d0
          qy(ig,4) = 25.0d0*iymx*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
       end do
    case (428)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-4.0d0)*sq3/7.0d0
          qy(ig,2) = -(3*z**2-1)/sq3
          qy(ig,3) = (-3.0d0)*sq3*(35*z**4-30*z**2+3)/44.0d0
          qy(ig,4) = (-25.0d0)*(231*z**6-315*z**4+105*z**2-5)/(616.0d0*sq3)
       end do
    case (429)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 19.0d0*iypx*z/(7.0d0*sq2*sq3)
          qy(ig,3) = 45.0d0*iypx*sq3*z*(7*z**2-3)/(77.0d0*sq2)
          qy(ig,4) = 25.0d0*iypx*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
       end do
    case (430)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*iypx**2*sq5/(7.0d0*sq6)
          qy(ig,3) = (-6.0d0)*iypx**2*sq30*(7*z**2-1)/77.0d0
          qy(ig,4) = (-5.0d0)*iypx**2*sq30*(33*z**4-18*z**2+1)/528.0d0
       end do
    case (431)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-9.0d0)*iymx**4*sq35/88.0d0
          qy(ig,4) = 15.0d0*iymx**4*sq35*(11*z**2-1)/176.0d0
       end do
    case (432)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = (-5.0d0)*iymx**3*sq5*z*(11*z**2-3)/8.0d0
       end do
    case (433)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq15/21.0d0
          qy(ig,3) = 6.0d0*iymx**2*sq15*(7*z**2-1)/77.0d0
          qy(ig,4) = 115.0d0*iymx**2*sq15*(33*z**4-18*z**2+1)/528.0d0
       end do
    case (434)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-4.0d0)*iymx*z/7.0d0
          qy(ig,3) = (-45.0d0)*iymx*z*(7*z**2-3)/77.0d0
          qy(ig,4) = (-25.0d0)*iymx*z*(33*z**4-30*z**2+5)/22.0d0
       end do
    case (435)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1.0d0/7.0d0
          qy(ig,2) = (3*z**2-1)/6.0d0
          qy(ig,3) = 9.0d0*(35*z**4-30*z**2+3)/88.0d0
          qy(ig,4) = 625.0d0*(231*z**6-315*z**4+105*z**2-5)/3696.0d0
       end do
    case (436)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx**2*sq15*z/2.0d0
       end do
    case (437)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx*sq15*(5*z**2-1)/4.0d0
       end do
    case (438)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx**2*sq15/7.0d0
          qy(ig,2) = 3.0d0*iymx**2*sq15*(7*z**2-1)/28.0d0
       end do
    case (439)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-4.0d0)*iymx*sq15*z/7.0d0
          qy(ig,2) = (-3.0d0)*iymx*sq15*z*(7*z**2-3)/28.0d0
       end do
    case (440)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 15.0d0*iymx**3*z/(2.0d0*sq10)
       end do
    case (441)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx**2*sq15/sq2/14.0d0
          qy(ig,2) = (-9.0d0)*iymx**2*sq15*(7*z**2-1)/(28.0d0*sq2)
       end do
    case (442)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx*sq30*z/7.0d0
          qy(ig,2) = 3.0d0*iymx*sq15*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (443)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*sq5*(3*z**2-1)/(7.0d0*sq2)
          qy(ig,2) = (-3.0d0)*sq5*(35*z**4-30*z**2+3)/(28.0d0*sq2)
       end do
    case (444)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3*sq5/sq2/2.0d0
          qy(ig,3) = -iymx**3*sq5*(3*z-1)*(3*z+1)/sq2/4.0d0
       end do
    case (445)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq15*z/sq2/2.0d0
          qy(ig,3) = 3.0d0*iymx**2*sq15*z*(3*z**2-1)/(4.0d0*sq2)
       end do
    case (446)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-6.0d0)*iymx*sq6/(7.0d0*sq5)
          qy(ig,2) = -iymx*sq3*(5*z**2-1)/sq10
          qy(ig,3) = (-3.0d0)*iymx*sq5*sq6*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (447)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-12.0d0)*sq2*z/(7.0d0*sq5)
          qy(ig,2) = z*(5*z**2-3)/(sq2*sq5)
          qy(ig,3) = sq5*z*(63*z**4-70*z**2+15)/sq2/28.0d0
       end do
    case (448)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iymx**4*z/(4.0d0*sq2)
       end do
    case (449)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3*sq5/sq2/6.0d0
          qy(ig,3) = 13.0d0*iymx**3*sq5*(3*z-1)*(3*z+1)/(24.0d0*sq2)
       end do
    case (450)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq5*z/2.0d0
          qy(ig,3) = -2*iymx**2*sq5*z*(3*z**2-1)
       end do
    case (451)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx/(7.0d0*sq5)
          qy(ig,2) = iymx*(5*z**2-1)/sq5/4.0d0
          qy(ig,3) = 19.0d0*iymx*sq5*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (452)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9.0d0*sq2*z/(7.0d0*sq5)
          qy(ig,2) = 2.0d0*sq2*z*(5*z**2-3)/(3.0d0*sq5)
          qy(ig,3) = (-11.0d0)*sq5*z*(63*z**4-70*z**2+15)/(84.0d0*sq2)
       end do
    case (453)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iypx/(7.0d0*sq2)
          qy(ig,2) = -iypx*(5*z**2-1)/sq2
          qy(ig,3) = 25.0d0*iypx*(21*z**4-14*z**2+1)/(56.0d0*sq2)
       end do
    case (454)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iymx**4/(11.0d0*sq2)
          qy(ig,4) = 45.0d0*iymx**4*(11*z**2-1)/(88.0d0*sq2)
       end do
    case (455)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-45.0d0)*iymx**3*z/(22.0d0*sq10)
          qy(ig,4) = (-45.0d0)*iymx**3*sq10*z*(11*z**2-3)/176.0d0
       end do
    case (456)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 3.0d0*iymx**2*sq5/7.0d0
          qy(ig,3) = 69.0d0*iymx**2*sq5*(7*z**2-1)/308.0d0
          qy(ig,4) = 15.0d0*iymx**2*sq5*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (457)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx*sq5*z/7.0d0
          qy(ig,3) = (-93.0d0)*iymx*sq5*z*(7*z**2-3)/308.0d0
          qy(ig,4) = (-15.0d0)*iymx*sq5*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (458)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq10/7.0d0
          qy(ig,2) = -sq5*(3*z**2-1)/sq2/7.0d0
          qy(ig,3) = 9.0d0*sq5*(35*z**4-30*z**2+3)/(154.0d0*sq2)
          qy(ig,4) = 15.0d0*sq5*(231*z**6-315*z**4+105*z**2-5)/(616.0d0*sq2)
       end do
    case (459)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 15.0d0*iypx*z/(7.0d0*sq2)
          qy(ig,3) = (-15.0d0)*iypx*z*(7*z**2-3)/(77.0d0*sq2)
          qy(ig,4) = (-15.0d0)*iypx*z*(33*z**4-30*z**2+5)/(88.0d0*sq2)
       end do
    case (460)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 5.0d0*iymx**5*sq21*z/8.0d0
       end do
    case (461)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-15.0d0)*iymx**4*sq3/88.0d0
          qy(ig,4) = (-85.0d0)*iymx**4*sq3*(11*z**2-1)/176.0d0
       end do
    case (462)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iymx**3*z/11.0d0
          qy(ig,4) = 75.0d0*iymx**3*z*(11*z**2-3)/44.0d0
       end do
    case (463)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq15/21.0d0
          qy(ig,3) = (-6.0d0)*iymx**2*sq15*(7*z**2-1)/77.0d0
          qy(ig,4) = (-575.0d0)*iymx**2*(33*z**4-18*z**2+1)/(176.0d0*sq15)
       end do
    case (464)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx*sq5*z/sq3/7.0d0
          qy(ig,3) = 3.0d0*iymx*sq15*z*(7*z**2-3)/154.0d0
          qy(ig,4) = 65.0d0*iymx*sq5*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
       end do
    case (465)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3/7.0d0
          qy(ig,2) = 5.0d0*(3*z**2-1)/14.0d0
          qy(ig,3) = 57.0d0*(35*z**4-30*z**2+3)/616.0d0
          qy(ig,4) = (-145.0d0)*(231*z**6-315*z**4+105*z**2-5)/1232.0d0
       end do
    case (466)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -iymx**3*sq5/4.0d0
       end do
    case (467)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx**2*sq5*z/2.0d0
       end do
    case (468)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5.0d0*iymx**3*sq5*z/4.0d0
       end do
    case (469)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-3.0d0)*iymx**2*sq5/7.0d0
          qy(ig,2) = (-5.0d0)*iymx**2*sq5*(7*z**2-1)/28.0d0
       end do
    case (470)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**4*sq15/sq2/4.0d0
       end do
    case (471)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**3*sq2*sq5*z
       end do
    case (472)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx**2*sq5/(14.0d0*sq2)
          qy(ig,2) = 13.0d0*iymx**2*sq5*(7*z**2-1)/(28.0d0*sq2)
       end do
    case (473)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx*sq30*z/7.0d0
          qy(ig,2) = (-15.0d0)*iymx*sq3*z*(7*z**2-3)/(14.0d0*sq10)
       end do
    case (474)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-5.0d0)*iymx**4*sq15*z/(4.0d0*sq2)
       end do
    case (475)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3*sq10/3.0d0
          qy(ig,3) = 5.0d0*iymx**3*sq5*(3*z-1)*(3*z+1)/(12.0d0*sq2)
       end do
    case (476)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq5*z/sq2/2.0d0
          qy(ig,3) = (-5.0d0)*iymx**2*sq5*z*(3*z**2-1)/(4.0d0*sq2)
       end do
    case (477)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = -6**(3.0d0/2.0d0)*iymx/sq5/7.0d0
          qy(ig,2) = -iymx*(5*z**2-1)/sq30/2.0d0
          qy(ig,3) = 5.0d0*iymx*sq5*(21*z**4-14*z**2+1)/(28.0d0*sq6)
       end do
    case (478)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-5.0d0)*iymx**5*sq6/16.0d0
       end do
    case (479)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 5.0d0*iymx**4*sq10*sq3*z/8.0d0
       end do
    case (480)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**3*sq5/sq3/4.0d0
          qy(ig,3) = (-5.0d0)*iymx**3*sq5*(3*z-1)*(3*z+1)/(8.0d0*sq3)
       end do
    case (481)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq5*z/sq3/2.0d0
          qy(ig,3) = 5.0d0*iymx**2*sq5*z*(3*z**2-1)/(2.0d0*sq3)
       end do
    case (482)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 27.0d0*iymx/(7.0d0*sq30)
          qy(ig,2) = 7.0d0*iymx*(5*z**2-1)/(2.0d0*sq30)
          qy(ig,3) = (-25.0d0)*iymx*sq5*(21*z**4-14*z**2+1)/(56.0d0*sq6)
       end do
    case (483)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*sq6*z/7.0d0
          qy(ig,2) = -2*z*(5*z**2-3)/sq6
          qy(ig,3) = 5.0d0*z*(63*z**4-70*z**2+15)/(28.0d0*sq6)
       end do
    case (484)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 25.0d0*iymx**5*sq6*z/16.0d0
       end do
    case (485)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-9.0d0)*iymx**4*sq10*sq3/44.0d0
          qy(ig,4) = (-25.0d0)*iymx**4*sq15*(11*z**2-1)/(88.0d0*sq2)
       end do
    case (486)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 21.0d0*iymx**3*sq15*z/44.0d0
          qy(ig,4) = 25.0d0*iymx**3*sq15*z*(11*z**2-3)/88.0d0
       end do
    case (487)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 4.0d0*iymx**2*sq5/(7.0d0*sq3)
          qy(ig,3) = (-9.0d0)*iymx**2*sq15*(7*z**2-1)/308.0d0
          qy(ig,4) = (-25.0d0)*iymx**2*sq5*(33*z**4-18*z**2+1)/(88.0d0*sq3)
       end do
    case (488)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-55.0d0)*iymx*z/(7.0d0*sq30)
          qy(ig,3) = (-9.0d0)*iymx*sq30*z*(7*z**2-3)/308.0d0
          qy(ig,4) = 25.0d0*iymx*sq10*z*(33*z**4-30*z**2+5)/(176.0d0*sq3)
       end do
    case (489)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = (-2.0d0)*sq6/7.0d0
          qy(ig,2) = 5.0d0*(3*z**2-1)/(7.0d0*sq6)
          qy(ig,3) = 3.0d0*sq6*(35*z**4-30*z**2+3)/154.0d0
          qy(ig,4) = (-25.0d0)*(231*z**6-315*z**4+105*z**2-5)/(616.0d0*sq6)
       end do
    case (490)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 5.0d0*iymx**6*sq7/16.0d0
       end do
    case (491)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = (-15.0d0)*iymx**5*z/4.0d0
       end do
    case (492)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 15.0d0*iymx**4*sq3/88.0d0
          qy(ig,4) = 85.0d0*iymx**4*sq3*(11*z**2-1)/176.0d0
       end do
    case (493)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = (-5.0d0)*iymx**3*sq5*z*(11*z**2-3)/8.0d0
       end do
    case (494)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-3.0d0)*iymx**2*sq5/14.0d0
          qy(ig,3) = (-45.0d0)*iymx**2*sq5*(7*z**2-1)/308.0d0
          qy(ig,4) = 45.0d0*iymx**2*sq5*(33*z**4-18*z**2+1)/176.0d0
       end do
    case (495)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 10.0d0*iymx*z/(7.0d0*sq3)
          qy(ig,3) = 75.0d0*iymx*sq3*z*(7*z**2-3)/154.0d0
          qy(ig,4) = (-10.0d0)*iymx*z*(33*z**4-30*z**2+5)/(11.0d0*sq3)
       end do
    case (496)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 5/7.0d0
          qy(ig,2) = 5.0d0*(3*z**2-1)/42.0d0
          qy(ig,3) = (-135.0d0)*(35*z**4-30*z**2+3)/616.0d0
          qy(ig,4) = 185.0d0*(231*z**6-315*z**4+105*z**2-5)/3696.0d0
       end do
    case (497)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
       end do
    case (498)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = iymx**3*sq35/4.0d0
       end do
    case (499)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**4*sq35/4.0d0
       end do
    case (500)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**3*sq35*z/4.0d0
       end do
    case (501)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
       end do
    case (502)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**4*sq35/sq2/4.0d0
       end do
    case (503)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3*sq35*z/sq2/2.0d0
       end do
    case (504)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 3.0d0*iymx**2*sq15/(2.0d0*sq14)
          qy(ig,2) = -iymx**2*sq15*(7*z**2-1)/sq14/4.0d0
       end do
    case (505)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = -iymx**5*sq210/8.0d0
       end do
    case (506)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 3.0d0*iymx**4*sq35*z/(4.0d0*sq2)
       end do
    case (507)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**3*sq35/sq2/6.0d0
          qy(ig,3) = -iymx**3*sq35*(3*z-1)*(3*z+1)/sq2/12.0d0
       end do
    case (508)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**2*sq35*z/sq6/2.0d0
          qy(ig,3) = iymx**2*sq35*z*(3*z**2-1)/sq6/4.0d0
       end do
    case (509)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
       end do
    case (510)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = iymx**5*sq210/16.0d0
       end do
    case (511)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = -iymx**4*sq105*z/4.0d0
       end do
    case (512)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -iymx**3*sq35/sq3/4.0d0
          qy(ig,3) = iymx**3*sq35*(3*z-1)*(3*z+1)/sq3/8.0d0
       end do
    case (513)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq35*z/sq6
          qy(ig,3) = -iymx**2*sq35*z*(3*z**2-1)/sq6/2.0d0
       end do
    case (514)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 9*iymx/sq42
          qy(ig,2) = -iymx*sq7*(5*z**2-1)/sq6/2.0d0
          qy(ig,3) = 5.0d0*iymx*(21*z**4-14*z**2+1)/(8.0d0*sq42)
       end do
    case (515)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 5.0d0*iymx**6*sq42/16.0d0
       end do
    case (516)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = (-5.0d0)*iymx**5*sq210*z/16.0d0
       end do
    case (517)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-3.0d0)*iymx**4*sq105/44.0d0
          qy(ig,4) = 5.0d0*iymx**4*sq105*(11*z**2-1)/88.0d0
       end do
    case (518)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 9.0d0*iymx**3*sq105*z/44.0d0
          qy(ig,4) = (-5.0d0)*iymx**3*sq105*z*(11*z**2-3)/88.0d0
       end do
    case (519)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = iymx**2*sq5/sq42
          qy(ig,3) = (-9.0d0)*iymx**2*sq15*(7*z**2-1)/(22.0d0*sq14)
          qy(ig,4) = 5.0d0*iymx**2*sq35*(33*z**4-18*z**2+1)/(88.0d0*sq6)
       end do
    case (520)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = -5*iymx*z/sq42
          qy(ig,3) = 15.0d0*iymx*sq6*z*(7*z**2-3)/(44.0d0*sq7)
          qy(ig,4) = (-5.0d0)*iymx*sq7*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
       end do
    case (521)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 0
       end do
    case (522)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = (-5.0d0)*iymx**6*sq7/16.0d0
       end do
    case (523)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 0
          qy(ig,4) = 5.0d0*iymx**5*sq21*z/8.0d0
       end do
    case (524)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = 9.0d0*iymx**4*sq35/88.0d0
          qy(ig,4) = (-15.0d0)*iymx**4*sq35*(11*z**2-1)/176.0d0
       end do
    case (525)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 0
          qy(ig,3) = (-9.0d0)*iymx**3*sq35*z/22.0d0
          qy(ig,4) = 5.0d0*iymx**3*sq35*z*(11*z**2-3)/44.0d0
       end do
    case (526)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = (-5.0d0)*iymx**2/(2.0d0*sq21)
          qy(ig,3) = 45.0d0*iymx**2*sq3*(7*z**2-1)/(44.0d0*sq7)
          qy(ig,4) = (-25.0d0)*iymx**2*sq7*(33*z**4-18*z**2+1)/(176.0d0*sq3)
       end do
    case (527)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 0
          qy(ig,2) = 5*iymx*z/sq7
          qy(ig,3) = (-45.0d0)*iymx*z*(7*z**2-3)/(22.0d0*sq7)
          qy(ig,4) = 5.0d0*iymx*sq7*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (528)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          qy(ig,1) = 1
          qy(ig,2) = (-5.0d0)*(3*z**2-1)/6.0d0
          qy(ig,3) = 9.0d0*(35*z**4-30*z**2+3)/88.0d0
          qy(ig,4) = (-5.0d0)*(231*z**6-315*z**4+105*z**2-5)/528.0d0
       end do
    case default
       write(6,*) 'getqy_two_z() invalid k3 = ', k3
       stop
    end select

    if (ik3.lt.0) then
       qy = conjg(qy)
    end if
    return
  end subroutine getqy_two_z

  subroutine getsqy_two_x(sqy,ik3,gk,nl,nkc,mll3)
    implicit none
    integer,intent(in):: ik3,nl,nkc
    integer,intent(out):: mll3
    real(kind=8),intent(in):: gk(4,nkc)
    complex(kind=8):: sqy(nkc,3,nl)
    !
    real(kind=8),parameter:: eps = 1.0d-12
    real(kind=8),parameter:: ci = (0.0d0, 1.0d0)
    real(kind=8),parameter:: sq2 = sqrt(2.0d0), &
         sq3 = sqrt(3.0d0), sq5 = sqrt(5.0d0), &
         sq6 = sqrt(6.0d0), sq7 = sqrt(7.0d0), &
         sq8 = sqrt(8.0d0), sq10 = sqrt(10.0d0), &
         sq14 = sqrt(14.0d0), &
         sq15 = sqrt(15.0d0), sq21 = sqrt(21.0d0), &
         sq30 = sqrt(30.0d0), sq35 = sqrt(35.0d0), &
         sq42 = sqrt(42.0d0), sq70 = sqrt(70.0d0), &
         sq105 = sqrt(105.0d0), sq210 = sqrt(210.0d0)
    !
    integer:: k3
    integer:: ig,ist
    real(kind=8):: x,y,z,r
    complex(kind=8):: iypx, iymx
    !     
    k3 = abs(ik3)
    !
    ! FOR G=0
    if (gk(4,1).lt.eps) then
       sqy(1,:,1:nl) = 0.0d0
       ist=2
    else
       ist=1
    end if

    select case(k3)
    case (1)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (2)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (3)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (4)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -1
          sqy(ig,2,1) = -ci
          sqy(ig,3,1) = 0
       end do
    case (5)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 1
       end do
    case (6)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -2*z
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -(iypx-iymx)
       end do
    case (7)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -1
       end do
    case (8)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -1
          sqy(ig,2,1) = ci
          sqy(ig,3,1) = 0
       end do
    case (9)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -2*iymx
          sqy(ig,2,2) = 2*ci*iymx
          sqy(ig,3,2) = -2*z
       end do
    case (10)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2*z
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = iypx-iymx
       end do
    case (11)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (12)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3/sq2
          sqy(ig,2,1) = ci*sq3/sq2
          sqy(ig,3,1) = 0
       end do
    case (13)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = sq6*z
       end do
    case (14)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*z/sq2
          sqy(ig,2,2) = -ci*sq3*z/sq2
          sqy(ig,3,2) = -iypx*sq3/sq2
       end do
    case (15)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (16)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 1/sq2
          sqy(ig,2,1) = ci/sq2
          sqy(ig,3,1) = 0
       end do
    case (17)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = sq2
       end do
    case (18)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -z/sq2
          sqy(ig,2,2) = 3*ci*z/sq2
          sqy(ig,3,2) = (iypx+2*iymx)/sq2
       end do
    case (19)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq2
          sqy(ig,2,2) = -ci*iypx*sq2
          sqy(ig,3,2) = -2*sq2*z
       end do
    case (20)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -sq3*z
       end do
    case (21)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2*z
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = iypx-iymx
       end do
    case (22)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = sq2
       end do
    case (23)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -1/sq2
          sqy(ig,2,1) = ci/sq2
          sqy(ig,3,1) = 0
       end do
    case (24)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq2
          sqy(ig,2,2) = ci*iymx*sq2
          sqy(ig,3,2) = 2*sq2*z
       end do
    case (25)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -z/sq2
          sqy(ig,2,2) = -3*ci*z/sq2
          sqy(ig,3,2) = -(2*iypx+iymx)/sq2
       end do
    case (26)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq3*z
          sqy(ig,2,2) = -ci*sq3*z
          sqy(ig,3,2) = -iymx*sq3
       end do
    case (27)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx
          sqy(ig,2,2) = -ci*iymx
          sqy(ig,3,2) = 4*z
       end do
    case (28)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -2*z
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -(iypx-iymx)
       end do
    case (29)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq3/sq2
          sqy(ig,2,1) = ci*sq3/sq2
          sqy(ig,3,1) = 0
       end do
    case (30)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (31)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*z/sq2
          sqy(ig,2,2) = ci*sq3*z/sq2
          sqy(ig,3,2) = iymx*sq3/sq2
       end do
    case (32)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -sq6*z
       end do
    case (33)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3*iymx
          sqy(ig,2,2) = -3*ci*iymx
          sqy(ig,3,2) = 0
       end do
    case (34)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*z
          sqy(ig,2,2) = ci*sq3*z
          sqy(ig,3,2) = iymx*sq3
       end do
    case (35)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -sq3*z
       end do
    case (36)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (37)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -iypx*sq6
          sqy(ig,2,1) = -ci*iypx*sq6
          sqy(ig,3,1) = 0
       end do
    case (38)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3*z/sq6
          sqy(ig,2,1) = 3*ci*z/sq6
          sqy(ig,3,1) = 3*iypx/sq6
       end do
    case (39)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -sq6/5.0d0
          sqy(ig,1,2) = -iypx*sq6*z
          sqy(ig,2,2) = -ci*iypx*sq6*z
          sqy(ig,3,2) = 3.0d0*sq2*(15*z**2-5*iypx**2-3)/(10.0d0*sq3)
       end do
    case (40)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq3/sq2/5.0d0
          sqy(ig,2,1) = -ci*sq3/sq2/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*(5*z**2-15*iypx**2-1)/sq2/5.0d0
          sqy(ig,2,2) = -ci*sq3*(5*z**2-15*iypx**2-1)/sq2/5.0d0
          sqy(ig,3,2) = -iypx*sq6*z
       end do
    case (41)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-6)/5.0d0
          sqy(ig,2,1) = (-6.0d0)*ci/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = 3.0d0*ci*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = 3*iypx*z
       end do
    case (42)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = sq3/5.0d0
          sqy(ig,1,2) = -2*iypx*sq3*z
          sqy(ig,2,2) = -2*ci*iypx*sq3*z
          sqy(ig,3,2) = -sq3*(15*z**2+10*iypx**2-3)/10.0d0
       end do
    case (43)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3/5.0d0
          sqy(ig,2,1) = ci*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq3*(10*z**2+15*iypx**2-2)/10.0d0
          sqy(ig,2,2) = ci*sq3*(10*z**2+15*iypx**2-2)/10.0d0
          sqy(ig,3,2) = 2*iypx*sq3*z
       end do
    case (44)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -3*iypx*z
          sqy(ig,2,2) = -3*ci*iypx*z
          sqy(ig,3,2) = (-3.0d0)*iypx**2/2.0d0
       end do
    case (45)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-12.0d0)*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-6.0d0)*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = 3.0d0*z*(7*z**2-3)/7.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 9.0d0*(iypx-iymx)*(7*z**2-1)/14.0d0
       end do
    case (46)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*z/sq2
          sqy(ig,2,1) = -3*ci*z/sq2
          sqy(ig,3,1) = -3*iypx/sq2
       end do
    case (47)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3*sq2*z
       end do
    case (48)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -1/sq2/5.0d0
          sqy(ig,2,1) = -ci/sq2
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*sq2*(5*z**2-1)/5.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -3*(iypx-iymx)*sq2*z
       end do
    case (49)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-2.0d0)*sq2/5.0d0
          sqy(ig,1,2) = 3*iypx*sq2*z
          sqy(ig,2,2) = 3*ci*iypx*sq2*z
          sqy(ig,3,2) = (-3.0d0)*(15*z**2-5*iypx**2-3)/(5.0d0*sq2)
       end do
    case (50)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-3.0d0)*sq3/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 9.0d0*sq3*(5*z**2-1)/10.0d0
       end do
    case (51)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-4)/5.0d0
          sqy(ig,2,1) = (-2.0d0)*ci/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = (-9.0d0)*ci*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -3*(2*iypx+iymx)*z
       end do
    case (52)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 4/5.0d0
          sqy(ig,1,2) = 3*iypx*z
          sqy(ig,2,2) = 3*ci*iypx*z
          sqy(ig,3,2) = 3.0d0*(30*z**2+5*iypx**2-6)/10.0d0
       end do
    case (53)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3/5.0d0
          sqy(ig,2,1) = ci*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*sq3*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq3*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -3*iypx*sq3*z
       end do
    case (54)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-4.0d0)*iymx*sq3/7.0d0
          sqy(ig,2,2) = 4.0d0*ci*iymx*sq3/7.0d0
          sqy(ig,3,2) = (-3.0d0)*sq3*z/7.0d0
          sqy(ig,1,3) = 3.0d0*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,3,3) = 3.0d0*sq3*z*(14*z**2-7*iymx**2-6)/7.0d0
       end do
    case (55)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-6.0d0)*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-3.0d0)*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = (-9.0d0)*z*(7*z**2-3)/7.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-27.0d0)*(iypx-iymx)*(7*z**2-1)/14.0d0
       end do
    case (56)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -3*sq2*z
       end do
    case (57)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*z/sq2
          sqy(ig,2,1) = 3*ci*z/sq2
          sqy(ig,3,1) = 3*iymx/sq2
       end do
    case (58)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-2.0d0)*sq2/5.0d0
          sqy(ig,1,2) = -3*iymx*sq2*z
          sqy(ig,2,2) = 3*ci*iymx*sq2*z
          sqy(ig,3,2) = (-3.0d0)*(15*z**2-5*iymx**2-3)/(5.0d0*sq2)
       end do
    case (59)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 1/sq2/5.0d0
          sqy(ig,2,1) = -ci/sq2
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*sq2*(5*z**2-1)/5.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 3*(iypx-iymx)*sq2*z
       end do
    case (60)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3/5.0d0
          sqy(ig,2,1) = -ci*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*sq3*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = 3.0d0*ci*sq3*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = 3*iymx*sq3*z
       end do
    case (61)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-4)/5.0d0
          sqy(ig,1,2) = 3*iymx*z
          sqy(ig,2,2) = -3*ci*iymx*z
          sqy(ig,3,2) = (-3.0d0)*(30*z**2+5*iymx**2-6)/10.0d0
       end do
    case (62)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-4)/5.0d0
          sqy(ig,2,1) = 2.0d0*ci/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = 9.0d0*ci*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = 3*(iypx+2*iymx)*z
       end do
    case (63)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*sq3/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-9.0d0)*sq3*(5*z**2-1)/10.0d0
       end do
    case (64)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*z/7.0d0
          sqy(ig,2,2) = ci*sq3*z/7.0d0
          sqy(ig,3,2) = iymx*sq3/7.0d0
          sqy(ig,1,3) = (-3.0d0)*sq3*z*(7*z**2-21*iymx**2-3)/14.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq3*z*(7*z**2-21*iymx**2-3)/14.0d0
          sqy(ig,3,3) = 3.0d0*iymx*sq3*(21*z**2-7*iymx**2-3)/14.0d0
       end do
    case (65)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*iymx/7.0d0
          sqy(ig,2,2) = 9.0d0*ci*iymx/7.0d0
          sqy(ig,3,2) = (-12.0d0)*z/7.0d0
          sqy(ig,1,3) = (-9.0d0)*iymx*(7*z**2-1)/7.0d0
          sqy(ig,2,3) = 9.0d0*ci*iymx*(7*z**2-1)/7.0d0
          sqy(ig,3,3) = (-9.0d0)*z*(14*z**2-7*iymx**2-6)/7.0d0
       end do
    case (66)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 6.0d0*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 3.0d0*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = 9.0d0*z*(7*z**2-3)/7.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 27.0d0*(iypx-iymx)*(7*z**2-1)/14.0d0
       end do
    case (67)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3*z/sq6
          sqy(ig,2,1) = -3*ci*z/sq6
          sqy(ig,3,1) = -3*iymx/sq6
       end do
    case (68)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -iymx*sq6
          sqy(ig,2,1) = ci*iymx*sq6
          sqy(ig,3,1) = 0
       end do
    case (69)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0/(5.0d0*sq6)
          sqy(ig,2,1) = (-3.0d0)*ci/(5.0d0*sq6)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq6*(5*z**2-15*iymx**2-1)/10.0d0
          sqy(ig,2,2) = -ci*sq6*(5*z**2-15*iymx**2-1)/10.0d0
          sqy(ig,3,2) = -iymx*sq6*z
       end do
    case (70)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -sq6/5.0d0
          sqy(ig,1,2) = iymx*sq6*z
          sqy(ig,2,2) = -ci*iymx*sq6*z
          sqy(ig,3,2) = 3.0d0*(15*z**2-5*iymx**2-3)/(5.0d0*sq6)
       end do
    case (71)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -3*iymx*z
          sqy(ig,2,2) = 3*ci*iymx*z
          sqy(ig,3,2) = 3.0d0*iymx**2/2.0d0
       end do
    case (72)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3/5.0d0
          sqy(ig,2,1) = -ci*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq3*(10*z**2+15*iymx**2-2)/10.0d0
          sqy(ig,2,2) = -ci*sq3*(10*z**2+15*iymx**2-2)/10.0d0
          sqy(ig,3,2) = -2*iymx*sq3*z
       end do
    case (73)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -sq3/5.0d0
          sqy(ig,1,2) = -2*iymx*sq3*z
          sqy(ig,2,2) = 2*ci*iymx*sq3*z
          sqy(ig,3,2) = sq3*(15*z**2+10*iymx**2-3)/10.0d0
       end do
    case (74)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-6)/5.0d0
          sqy(ig,2,1) = 6.0d0*ci/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -3*iymx*z
       end do
    case (75)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iymx/7.0d0
          sqy(ig,2,2) = 3.0d0*ci*iymx/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*iymx*(7*z**2-14*iymx**2-1)/7.0d0
          sqy(ig,2,3) = 3.0d0*ci*iymx*(7*z**2-14*iymx**2-1)/7.0d0
          sqy(ig,3,3) = 3*iymx**2*z
       end do
    case (76)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq3*z/7.0d0
          sqy(ig,2,2) = -ci*sq3*z/7.0d0
          sqy(ig,3,2) = -iymx*sq3/7.0d0
          sqy(ig,1,3) = 3.0d0*sq3*z*(7*z**2-21*iymx**2-3)/14.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*sq3*z*(7*z**2-21*iymx**2-3)/14.0d0
          sqy(ig,3,3) = (-3.0d0)*iymx*sq3*(21*z**2-7*iymx**2-3)/14.0d0
       end do
    case (77)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-4.0d0)*iymx*sq3/7.0d0
          sqy(ig,2,2) = 4.0d0*ci*iymx*sq3/7.0d0
          sqy(ig,3,2) = (-3.0d0)*sq3*z/7.0d0
          sqy(ig,1,3) = 3.0d0*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,3,3) = 3.0d0*sq3*z*(14*z**2-7*iymx**2-6)/7.0d0
       end do
    case (78)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 12.0d0*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 6.0d0*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = (-3.0d0)*z*(7*z**2-3)/7.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-9.0d0)*(iypx-iymx)*(7*z**2-1)/14.0d0
       end do
    case (79)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (80)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iypx*sq30/2.0d0
          sqy(ig,2,1) = ci*iypx*sq30/2.0d0
          sqy(ig,3,1) = 0
       end do
    case (81)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq30/5.0d0
          sqy(ig,2,1) = -ci*sq30/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq30*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = ci*sq30*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = iypx*sq30*z/2.0d0
       end do
    case (82)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -15*iypx*z/sq30
          sqy(ig,2,2) = -15*ci*iypx*z/sq30
          sqy(ig,3,2) = (-15.0d0)*iypx**2/(2.0d0*sq30)
       end do
    case (83)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (84)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq15/5.0d0
          sqy(ig,2,1) = ci*sq15/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq15*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = -ci*sq15*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = -iypx*sq15*z/2.0d0
       end do
    case (85)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq15*z
          sqy(ig,2,2) = ci*iypx*sq15*z
          sqy(ig,3,2) = iypx**2*sq15/2.0d0
       end do
    case (86)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*iypx**2*sq5/4.0d0
          sqy(ig,2,2) = (-9.0d0)*ci*iypx**2*sq5/4.0d0
          sqy(ig,3,2) = 0
       end do
    case (87)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 12.0d0*sq5*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-3.0d0)*sq5*z*(7*z**2-3)/7.0d0
       end do
    case (88)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*sq15*z/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq15*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*iypx*sq15/7.0d0
          sqy(ig,1,3) = 3.0d0*sq15*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq15*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = 9.0d0*iypx*sq15*(7*z**2-1)/28.0d0
       end do
    case (89)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*iypx*sq15/7.0d0
          sqy(ig,2,2) = 2.0d0*ci*iypx*sq15/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*iypx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iypx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,3,3) = (-3.0d0)*iypx**2*sq15*z/2.0d0
       end do
    case (90)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iypx**2*sq5*z/4.0d0
          sqy(ig,2,3) = 9.0d0*ci*iypx**2*sq5*z/4.0d0
          sqy(ig,3,3) = 3.0d0*iypx**3*sq5/4.0d0
       end do
    case (91)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
       end do
    case (92)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iypx*sq6/2.0d0
          sqy(ig,2,1) = ci*iypx*sq6/2.0d0
          sqy(ig,3,1) = 0
       end do
    case (93)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq6*z
          sqy(ig,2,1) = ci*sq6*z
          sqy(ig,3,1) = iypx*sq6
       end do
    case (94)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-2.0d0)*sq6/5.0d0
          sqy(ig,1,2) = 3*iypx*z/sq6
          sqy(ig,2,2) = 3*ci*iypx*z/sq6
          sqy(ig,3,2) = 3.0d0*(60*z**2+5*iypx**2-12)/(10.0d0*sq6)
       end do
    case (95)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq6/5.0d0
          sqy(ig,2,1) = -ci*sq6/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq6*(20*z**2+15*iypx**2-4)/20.0d0
          sqy(ig,2,2) = -ci*sq6*(20*z**2+15*iypx**2-4)/20.0d0
          sqy(ig,3,2) = -2*iypx*sq6*z
       end do
    case (96)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3/5.0d0
          sqy(ig,2,1) = 3.0d0*ci/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = (-3.0d0)*iypx*z/2.0d0
       end do
    case (97)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 2.0d0*sq3/5.0d0
          sqy(ig,1,2) = iypx*sq3*z
          sqy(ig,2,2) = ci*iypx*sq3*z
          sqy(ig,3,2) = -sq3*(30*z**2-5*iypx**2-6)/10.0d0
       end do
    case (98)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*sq3/5.0d0
          sqy(ig,2,1) = 2.0d0*ci*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq3*(40*z**2-15*iypx**2-8)/20.0d0
          sqy(ig,2,2) = ci*sq3*(40*z**2-15*iypx**2-8)/20.0d0
          sqy(ig,3,2) = 4*iypx*sq3*z
       end do
    case (99)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -6*iypx*z
          sqy(ig,2,2) = -6*ci*iypx*z
          sqy(ig,3,2) = -3*iypx**2
       end do
    case (100)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*z/7.0d0
          sqy(ig,2,2) = 15.0d0*ci*z/7.0d0
          sqy(ig,3,2) = 3.0d0*(iypx+4*iymx)/7.0d0
          sqy(ig,1,3) = 9.0d0*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = (-15.0d0)*ci*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = (-9.0d0)*(iypx+4*iymx)*(7*z**2-1)/28.0d0
       end do
    case (101)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*iypx*sq3/7.0d0
          sqy(ig,2,2) = (-2.0d0)*ci*iypx*sq3/7.0d0
          sqy(ig,3,2) = (-6.0d0)*sq3*z/7.0d0
          sqy(ig,1,3) = 3.0d0*iypx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,2,3) = 3.0d0*ci*iypx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,3,3) = 3.0d0*sq3*z*(56*z**2+7*iypx**2-24)/14.0d0
       end do
    case (102)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*sq3*z/7.0d0
          sqy(ig,2,2) = (-2.0d0)*ci*sq3*z/7.0d0
          sqy(ig,3,2) = (-2.0d0)*iypx*sq3/7.0d0
          sqy(ig,1,3) = (-3.0d0)*sq3*z*(28*z**2+21*iypx**2-12)/28.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*sq3*z*(28*z**2+21*iypx**2-12)/28.0d0
          sqy(ig,3,3) = (-3.0d0)*iypx*sq3*(84*z**2+7*iypx**2-12)/28.0d0
       end do
    case (103)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 6.0d0*iypx/7.0d0
          sqy(ig,2,2) = 6.0d0*ci*iypx/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*iypx*(14*z**2+7*iypx**2-2)/7.0d0
          sqy(ig,2,3) = 3.0d0*ci*iypx*(14*z**2+7*iypx**2-2)/7.0d0
          sqy(ig,3,3) = 6*iypx**2*z
       end do
    case (104)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-6.0d0)*sq5*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 3.0d0*sq5*z*(7*z**2-3)/14.0d0
       end do
    case (105)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 12.0d0*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 6.0d0*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = (-3.0d0)*z*(7*z**2-3)/7.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-9.0d0)*(iypx-iymx)*(7*z**2-1)/14.0d0
       end do
    case (106)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3*z
          sqy(ig,2,1) = ci*sq3*z
          sqy(ig,3,1) = iypx*sq3
       end do
    case (107)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3*sq3*z
       end do
    case (108)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*sq3/5.0d0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = ci*sq3*(5*z**2-1)/2.0d0
          sqy(ig,3,2) = (2*iypx+3*iymx)*sq3*z
       end do
    case (109)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-2.0d0)*sq3/5.0d0
          sqy(ig,1,2) = -2*iypx*sq3*z
          sqy(ig,2,2) = -2*ci*iypx*sq3*z
          sqy(ig,3,2) = -sq3*(45*z**2+10*iypx**2-9)/10.0d0
       end do
    case (110)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*sq2/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-9.0d0)*(5*z**2-1)/(5.0d0*sq2)
       end do
    case (111)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3/sq2/5.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq3/(5.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 7.0d0*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = ci*sq3*(5*z**2-1)/sq2/10.0d0
          sqy(ig,3,2) = (4*iypx-3*iymx)*sq3*z/sq2
       end do
    case (112)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 2.0d0*sq6/5.0d0
          sqy(ig,1,2) = -iypx*sq6*z
          sqy(ig,2,2) = -ci*iypx*sq6*z
          sqy(ig,3,2) = sq3*(45*z**2-5*iypx**2-9)/sq2/5.0d0
       end do
    case (113)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0/(5.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci/(5.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = (-9.0d0)*ci*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = -9*iypx*z/sq2
       end do
    case (114)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-6.0d0)*iymx*sq2/7.0d0
          sqy(ig,2,2) = 6.0d0*ci*iymx*sq2/7.0d0
          sqy(ig,3,2) = 3.0d0*sq2*z/7.0d0
          sqy(ig,1,3) = 9.0d0*iymx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,3) = (-9.0d0)*ci*iymx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,3) = (-3.0d0)*z*(28*z**2+21*iymx**2-12)/(7.0d0*sq2)
       end do
    case (115)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*z/sq2/7.0d0
          sqy(ig,2,2) = 5.0d0*ci*sq3*z/(7.0d0*sq2)
          sqy(ig,3,2) = (2*iypx+3*iymx)*sq3/sq2/7.0d0
          sqy(ig,1,3) = (-3.0d0)*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,3) = 15.0d0*ci*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,3) = 9.0d0*(2*iypx+3*iymx)*sq3*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (116)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iypx*sq6/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iypx*sq6/7.0d0
          sqy(ig,3,2) = (-6.0d0)*sq6*z/7.0d0
          sqy(ig,1,3) = (-3.0d0)*iypx*sq6*(7*z**2-1)/7.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iypx*sq6*(7*z**2-1)/7.0d0
          sqy(ig,3,3) = (-3.0d0)*sq6*z*(21*z**2+7*iypx**2-9)/7.0d0
       end do
    case (117)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*z/(7.0d0*sq2)
          sqy(ig,2,2) = 3.0d0*ci*z/(7.0d0*sq2)
          sqy(ig,3,2) = 3.0d0*iypx/(7.0d0*sq2)
          sqy(ig,1,3) = 9.0d0*z*(7*z**2+14*iypx**2-3)/(14.0d0*sq2)
          sqy(ig,2,3) = 9.0d0*ci*z*(7*z**2+14*iypx**2-3)/(14.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*iypx*(63*z**2+14*iypx**2-9)/(14.0d0*sq2)
       end do
    case (118)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*sq10*z/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq10*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*iymx*sq10/7.0d0
          sqy(ig,1,3) = (-3.0d0)*sq10*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq10*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = 9.0d0*iymx*sq10*(7*z**2-1)/28.0d0
       end do
    case (119)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iymx*sq2/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iymx*sq2/7.0d0
          sqy(ig,3,2) = 6.0d0*sq2*z/7.0d0
          sqy(ig,1,3) = (-9.0d0)*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,3) = 9.0d0*ci*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,3) = (-3.0d0)*z*(112*z**2-21*iymx**2-48)/(14.0d0*sq2)
       end do
    case (120)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 6.0d0*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 3.0d0*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = 9.0d0*z*(7*z**2-3)/7.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 27.0d0*(iypx-iymx)*(7*z**2-1)/14.0d0
       end do
    case (121)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3*sq3*z
       end do
    case (122)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq3*z
          sqy(ig,2,1) = ci*sq3*z
          sqy(ig,3,1) = iymx*sq3
       end do
    case (123)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 2.0d0*sq3/5.0d0
          sqy(ig,1,2) = -2*iymx*sq3*z
          sqy(ig,2,2) = 2*ci*iymx*sq3*z
          sqy(ig,3,2) = sq3*(45*z**2+10*iymx**2-9)/10.0d0
       end do
    case (124)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*sq3/5.0d0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = -ci*sq3*(5*z**2-1)/2.0d0
          sqy(ig,3,2) = -(3*iypx+2*iymx)*sq3*z
       end do
    case (125)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)/(5.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci/(5.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 9.0d0*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = (-9.0d0)*ci*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = -9*iymx*z/sq2
       end do
    case (126)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 2.0d0*sq6/5.0d0
          sqy(ig,1,2) = iymx*sq6*z
          sqy(ig,2,2) = -ci*iymx*sq6*z
          sqy(ig,3,2) = sq6*(45*z**2-5*iymx**2-9)/10.0d0
       end do
    case (127)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq3/sq2/5.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq3/(5.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-7.0d0)*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = ci*sq3*(5*z**2-1)/sq2/10.0d0
          sqy(ig,3,2) = -(3*iypx-4*iymx)*sq3*z/sq2
       end do
    case (128)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*sq2/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-9.0d0)*(5*z**2-1)/(5.0d0*sq2)
       end do
    case (129)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*z/(7.0d0*sq2)
          sqy(ig,2,2) = (-3.0d0)*ci*z/(7.0d0*sq2)
          sqy(ig,3,2) = (-3.0d0)*iymx/(7.0d0*sq2)
          sqy(ig,1,3) = 9.0d0*z*(7*z**2+14*iymx**2-3)/(14.0d0*sq2)
          sqy(ig,2,3) = (-9.0d0)*ci*z*(7*z**2+14*iymx**2-3)/(14.0d0*sq2)
          sqy(ig,3,3) = (-3.0d0)*iymx*(63*z**2+14*iymx**2-9)/(14.0d0*sq2)
       end do
    case (130)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iymx*sq6/7.0d0
          sqy(ig,2,2) = 3.0d0*ci*iymx*sq6/7.0d0
          sqy(ig,3,2) = 6.0d0*sq6*z/7.0d0
          sqy(ig,1,3) = (-3.0d0)*iymx*sq6*(7*z**2-1)/7.0d0
          sqy(ig,2,3) = 3.0d0*ci*iymx*sq6*(7*z**2-1)/7.0d0
          sqy(ig,3,3) = 3.0d0*sq6*z*(21*z**2+7*iymx**2-9)/7.0d0
       end do
    case (131)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*z/(7.0d0*sq6)
          sqy(ig,2,2) = (-15.0d0)*ci*z/(7.0d0*sq6)
          sqy(ig,3,2) = (-3.0d0)*(3*iypx+2*iymx)/(7.0d0*sq6)
          sqy(ig,1,3) = (-3.0d0)*sq6*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = (-15.0d0)*ci*sq6*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = (-9.0d0)*(3*iypx+2*iymx)*sq6*(7*z**2-1)/28.0d0
       end do
    case (132)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-6.0d0)*iypx*sq2/7.0d0
          sqy(ig,2,2) = (-6.0d0)*ci*iypx*sq2/7.0d0
          sqy(ig,3,2) = (-3.0d0)*sq2*z/7.0d0
          sqy(ig,1,3) = 9.0d0*iypx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,3) = 9.0d0*ci*iypx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*z*(28*z**2+21*iypx**2-12)/(7.0d0*sq2)
       end do
    case (133)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iymx*sq10/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iymx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*iymx*sq10*(7*z**2-1)/28.0d0
          sqy(ig,2,3) = 9.0d0*ci*iymx*sq10*(7*z**2-1)/28.0d0
          sqy(ig,3,3) = 9.0d0*iymx**2*sq10*z/4.0d0
       end do
    case (134)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*sq2*z/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq2*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*iymx*sq2/7.0d0
          sqy(ig,1,3) = 9.0d0*z*(14*z**2-7*iymx**2-6)/(14.0d0*sq2)
          sqy(ig,2,3) = (-9.0d0)*ci*z*(14*z**2-7*iymx**2-6)/(14.0d0*sq2)
          sqy(ig,3,3) = (-3.0d0)*iymx*(126*z**2-7*iymx**2-18)/(14.0d0*sq2)
       end do
    case (135)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 6.0d0*iymx/7.0d0
          sqy(ig,2,2) = (-6.0d0)*ci*iymx/7.0d0
          sqy(ig,3,2) = 18.0d0*z/7.0d0
          sqy(ig,1,3) = 6.0d0*iymx*(7*z**2-1)/7.0d0
          sqy(ig,2,3) = (-6.0d0)*ci*iymx*(7*z**2-1)/7.0d0
          sqy(ig,3,3) = 3.0d0*z*(63*z**2-14*iymx**2-27)/7.0d0
       end do
    case (136)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-6.0d0)*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-3.0d0)*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = (-9.0d0)*z*(7*z**2-3)/7.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-27.0d0)*(iypx-iymx)*(7*z**2-1)/14.0d0
       end do
    case (137)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq6*z
          sqy(ig,2,1) = ci*sq6*z
          sqy(ig,3,1) = iymx*sq6
       end do
    case (138)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*iymx/sq6
          sqy(ig,2,1) = 3*ci*iymx/sq6
          sqy(ig,3,1) = 0
       end do
    case (139)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq6/5.0d0
          sqy(ig,2,1) = ci*sq6/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq6*(20*z**2+15*iymx**2-4)/20.0d0
          sqy(ig,2,2) = ci*sq6*(20*z**2+15*iymx**2-4)/20.0d0
          sqy(ig,3,2) = 2*iymx*sq6*z
       end do
    case (140)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 2.0d0*sq6/5.0d0
          sqy(ig,1,2) = 3*iymx*z/sq6
          sqy(ig,2,2) = -3*ci*iymx*z/sq6
          sqy(ig,3,2) = (-3.0d0)*(60*z**2+5*iymx**2-12)/(10.0d0*sq6)
       end do
    case (141)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 6*iymx*z
          sqy(ig,2,2) = -6*ci*iymx*z
          sqy(ig,3,2) = -3*iymx**2
       end do
    case (142)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-2.0d0)*sq3/5.0d0
          sqy(ig,2,1) = 2.0d0*ci*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*(40*z**2-15*iymx**2-8)/20.0d0
          sqy(ig,2,2) = ci*sq3*(40*z**2-15*iymx**2-8)/20.0d0
          sqy(ig,3,2) = 4*iymx*sq3*z
       end do
    case (143)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 2.0d0*sq3/5.0d0
          sqy(ig,1,2) = -iymx*sq3*z
          sqy(ig,2,2) = ci*iymx*sq3*z
          sqy(ig,3,2) = -sq3*(30*z**2-5*iymx**2-6)/10.0d0
       end do
    case (144)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3)/5.0d0
          sqy(ig,2,1) = 3.0d0*ci/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = (-3.0d0)*iymx*z/2.0d0
       end do
    case (145)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 6.0d0*iymx/7.0d0
          sqy(ig,2,2) = (-6.0d0)*ci*iymx/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*iymx*(14*z**2+7*iymx**2-2)/7.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iymx*(14*z**2+7*iymx**2-2)/7.0d0
          sqy(ig,3,3) = -6*iymx**2*z
       end do
    case (146)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*sq3*z/7.0d0
          sqy(ig,2,2) = 2.0d0*ci*sq3*z/7.0d0
          sqy(ig,3,2) = 2.0d0*iymx*sq3/7.0d0
          sqy(ig,1,3) = (-3.0d0)*sq3*z*(28*z**2+21*iymx**2-12)/28.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq3*z*(28*z**2+21*iymx**2-12)/28.0d0
          sqy(ig,3,3) = 3.0d0*iymx*sq3*(84*z**2+7*iymx**2-12)/28.0d0
       end do
    case (147)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*iymx*sq3/7.0d0
          sqy(ig,2,2) = 2.0d0*ci*iymx*sq3/7.0d0
          sqy(ig,3,2) = 6.0d0*sq3*z/7.0d0
          sqy(ig,1,3) = 3.0d0*iymx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iymx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,3,3) = (-3.0d0)*sq3*z*(56*z**2+7*iymx**2-24)/14.0d0
       end do
    case (148)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*z/7.0d0
          sqy(ig,2,2) = (-15.0d0)*ci*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*(4*iypx+iymx)/7.0d0
          sqy(ig,1,3) = 9.0d0*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = 15.0d0*ci*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = 9.0d0*(4*iypx+iymx)*(7*z**2-1)/28.0d0
       end do
    case (149)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*iymx**2*sq5*z/2.0d0
          sqy(ig,2,3) = 9.0d0*ci*iymx**2*sq5*z/2.0d0
          sqy(ig,3,3) = 3.0d0*iymx**3*sq5/2.0d0
       end do
    case (150)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 12.0d0*iymx/7.0d0
          sqy(ig,2,2) = (-12.0d0)*ci*iymx/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*iymx*(56*z**2-7*iymx**2-8)/14.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iymx*(56*z**2-7*iymx**2-8)/14.0d0
          sqy(ig,3,3) = -12*iymx**2*z
       end do
    case (151)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*sq2*z/7.0d0
          sqy(ig,2,2) = 3.0d0*ci*sq2*z/7.0d0
          sqy(ig,3,2) = 3.0d0*iymx*sq2/7.0d0
          sqy(ig,1,3) = (-9.0d0)*z*(14*z**2-7*iymx**2-6)/(14.0d0*sq2)
          sqy(ig,2,3) = 9.0d0*ci*z*(14*z**2-7*iymx**2-6)/(14.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*iymx*(126*z**2-7*iymx**2-18)/(14.0d0*sq2)
       end do
    case (152)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iymx*sq2/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iymx*sq2/7.0d0
          sqy(ig,3,2) = 6.0d0*sq2*z/7.0d0
          sqy(ig,1,3) = (-9.0d0)*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,3) = 9.0d0*ci*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,3) = (-3.0d0)*z*(112*z**2-21*iymx**2-48)/(14.0d0*sq2)
       end do
    case (153)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-12.0d0)*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-6.0d0)*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = 3.0d0*z*(7*z**2-3)/7.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 9.0d0*(iypx-iymx)*(7*z**2-1)/14.0d0
       end do
    case (154)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*iymx*sq5/sq6
          sqy(ig,2,1) = 3*ci*iymx*sq5/sq6
          sqy(ig,3,1) = 0
       end do
    case (155)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (156)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -3*iymx*sq5*z/sq6
          sqy(ig,2,2) = 3*ci*iymx*sq5*z/sq6
          sqy(ig,3,2) = 3.0d0*iymx**2*sq5/(2.0d0*sq6)
       end do
    case (157)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq6/sq5
          sqy(ig,2,1) = ci*sq6/sq5
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq6*(5*z**2-1)/sq5/4.0d0
          sqy(ig,2,2) = -ci*sq6*(5*z**2-1)/sq5/4.0d0
          sqy(ig,3,2) = -iymx*sq30*z/2.0d0
       end do
    case (158)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 9.0d0*iymx**2*sq5/4.0d0
          sqy(ig,2,2) = (-9.0d0)*ci*iymx**2*sq5/4.0d0
          sqy(ig,3,2) = 0
       end do
    case (159)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq15*z
          sqy(ig,2,2) = ci*iymx*sq15*z
          sqy(ig,3,2) = iymx**2*sq15/2.0d0
       end do
    case (160)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3/sq15
          sqy(ig,2,1) = 3*ci/sq15
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*(5*z**2-1)/(4.0d0*sq15)
          sqy(ig,2,2) = (-3.0d0)*ci*(5*z**2-1)/(4.0d0*sq15)
          sqy(ig,3,2) = -iymx*sq15*z/2.0d0
       end do
    case (161)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (162)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iymx**2*sq5*z/4.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*iymx**2*sq5*z/4.0d0
          sqy(ig,3,3) = (-3.0d0)*iymx**3*sq5/4.0d0
       end do
    case (163)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*iymx*sq15/7.0d0
          sqy(ig,2,2) = (-2.0d0)*ci*iymx*sq15/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*iymx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,2,3) = 3.0d0*ci*iymx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,3,3) = 3.0d0*iymx**2*sq15*z/2.0d0
       end do
    case (164)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*sq15*z/7.0d0
          sqy(ig,2,2) = 3.0d0*ci*sq15*z/7.0d0
          sqy(ig,3,2) = 3.0d0*iymx*sq15/7.0d0
          sqy(ig,1,3) = 3.0d0*sq15*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*sq15*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = (-9.0d0)*iymx*sq15*(7*z**2-1)/28.0d0
       end do
    case (165)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-12.0d0)*sq5*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 3.0d0*sq5*z*(7*z**2-3)/7.0d0
       end do
    case (166)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*iymx**3/2.0d0
          sqy(ig,2,3) = 15.0d0*ci*iymx**3/2.0d0
          sqy(ig,3,3) = 0
       end do
    case (167)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iymx**2*sq5*z/2.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*iymx**2*sq5*z/2.0d0
          sqy(ig,3,3) = (-3.0d0)*iymx**3*sq5/2.0d0
       end do
    case (168)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iymx*sq10/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iymx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*iymx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,3) = 9.0d0*ci*iymx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,3) = 9.0d0*iymx**2*sq5*z/(2.0d0*sq2)
       end do
    case (169)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*sq10*z/7.0d0
          sqy(ig,2,2) = 3.0d0*ci*sq10*z/7.0d0
          sqy(ig,3,2) = 3.0d0*iymx*sq10/7.0d0
          sqy(ig,1,3) = 3.0d0*sq5*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,3) = (-3.0d0)*ci*sq5*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,3) = (-9.0d0)*iymx*sq5*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (170)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-6.0d0)*sq5*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 3.0d0*sq5*z*(7*z**2-3)/14.0d0
       end do
    case (171)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
       end do
    case (172)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*iypx**2*sq5/(2.0d0*sq6)
          sqy(ig,2,1) = (-9.0d0)*ci*iypx**2*sq5/(2.0d0*sq6)
          sqy(ig,3,1) = 0
       end do
    case (173)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iypx*sq30*z/2.0d0
          sqy(ig,2,1) = ci*iypx*sq30*z/2.0d0
          sqy(ig,3,1) = iypx**2*sq30/4.0d0
       end do
    case (174)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq30*z/7.0d0
          sqy(ig,2,1) = -ci*sq30*z/7.0d0
          sqy(ig,3,1) = -iypx*sq30/7.0d0
          sqy(ig,1,2) = 3.0d0*sq5*z*(7*z**2-21*iypx**2-3)/(14.0d0*sq6)
          sqy(ig,2,2) = 3.0d0*ci*sq5*z*(7*z**2-21*iypx**2-3)/(14.0d0*sq6)
          sqy(ig,3,2) = 3.0d0*iypx*sq5*(21*z**2-7*iypx**2-3)/(14.0d0*sq6)
       end do
    case (175)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -iypx*sq30/14.0d0
          sqy(ig,2,1) = -ci*iypx*sq30/14.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq30*(7*z**2-14*iypx**2-1)/14.0d0
          sqy(ig,2,2) = -ci*iypx*sq30*(7*z**2-14*iypx**2-1)/14.0d0
          sqy(ig,3,2) = -iypx**2*sq30*z/2.0d0
       end do
    case (176)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*iypx*sq5/7.0d0
          sqy(ig,2,1) = (-9.0d0)*ci*iypx*sq5/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iypx*sq5*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = 3.0d0*ci*iypx*sq5*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = 3.0d0*iypx**2*sq5*z/2.0d0
       end do
    case (177)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq15*z/7.0d0
          sqy(ig,2,1) = ci*sq15*z/7.0d0
          sqy(ig,3,1) = iypx*sq15/7.0d0
          sqy(ig,1,2) = -sq15*z*(7*z**2+42*iypx**2-3)/28.0d0
          sqy(ig,2,2) = -ci*sq15*z*(7*z**2+42*iypx**2-3)/28.0d0
          sqy(ig,3,2) = -iypx*sq15*(21*z**2+14*iypx**2-3)/28.0d0
       end do
    case (178)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iypx*sq15/7.0d0
          sqy(ig,2,1) = ci*iypx*sq15/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq15*(7*z**2+7*iypx**2-1)/7.0d0
          sqy(ig,2,2) = ci*iypx*sq15*(7*z**2+7*iypx**2-1)/7.0d0
          sqy(ig,3,2) = iypx**2*sq15*z
       end do
    case (179)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*iypx**2*sq5*z/4.0d0
          sqy(ig,2,2) = (-9.0d0)*ci*iypx**2*sq5*z/4.0d0
          sqy(ig,3,2) = (-3.0d0)*iypx**3*sq5/4.0d0
       end do
    case (180)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-6.0d0)/(7.0d0*sq5)
          sqy(ig,1,2) = -iypx*sq5*z
          sqy(ig,2,2) = -ci*iypx*sq5*z
          sqy(ig,3,2) = (20*z**2-5*iypx**2-4)/sq5/2.0d0
          sqy(ig,1,3) = iypx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = ci*iypx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = -sq5*(105*z**4-63*iypx**2*z**2-70*z**2+7*iypx**2+5)/28.0d0
       end do
    case (181)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq3/(7.0d0*sq5)
          sqy(ig,2,1) = (-3.0d0)*ci*sq3/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*(5*z**2-10*iypx**2-1)/sq5/4.0d0
          sqy(ig,2,2) = -ci*sq3*(5*z**2-10*iypx**2-1)/sq5/4.0d0
          sqy(ig,3,2) = -iypx*sq15*z/2.0d0
          sqy(ig,1,3) = sq15*(21*z**4-63*iypx**2*z**2-14*z**2+7*iypx**2+1)/28.0d0
          sqy(ig,2,3) = ci*sq15*(21*z**4-63*iypx**2*z**2-14*z**2+7*iypx**2+1)/28.0d0
          sqy(ig,3,3) = iypx*sq15*z*(6*z**2-3*iypx**2-2)/2.0d0
       end do
    case (182)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -iypx*sq15*z*(3*z**2-6*iypx**2-1)/2.0d0
          sqy(ig,2,3) = -ci*iypx*sq15*z*(3*z**2-6*iypx**2-1)/2.0d0
          sqy(ig,3,3) = -iypx**2*sq15*(9*z**2-3*iypx**2-1)/4.0d0
       end do
    case (183)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx**2*sq5/4.0d0
          sqy(ig,2,2) = ci*iypx**2*sq5/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = iypx**2*sq5*(9*z**2-15*iypx**2-1)/4.0d0
          sqy(ig,2,3) = ci*iypx**2*sq5*(9*z**2-15*iypx**2-1)/4.0d0
          sqy(ig,3,3) = 3.0d0*iypx**3*sq5*z/2.0d0
       end do
    case (184)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9)/7.0d0
          sqy(ig,2,1) = (-9.0d0)*ci/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2-1)/2.0d0
          sqy(ig,2,2) = ci*(5*z**2-1)/2.0d0
          sqy(ig,3,2) = 5*iypx*z
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = (-5.0d0)*iypx*z*(3*z**2-1)/2.0d0
       end do
    case (185)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0/(7.0d0*sq5)
          sqy(ig,1,2) = -2*iypx*sq5*z
          sqy(ig,2,2) = -2*ci*iypx*sq5*z
          sqy(ig,3,2) = -(5*z**2+5*iypx**2-1)/sq5
          sqy(ig,1,3) = iypx*sq5*z*(3*z**2-1)
          sqy(ig,2,3) = ci*iypx*sq5*z*(3*z**2-1)
          sqy(ig,3,3) = sq5*(105*z**4+252*iypx**2*z**2-70*z**2-28*iypx**2+5)/56.0d0
       end do
    case (186)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq2/(7.0d0*sq5)
          sqy(ig,2,1) = 3.0d0*ci*sq2/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2+15*iypx**2-1)/sq10/2.0d0
          sqy(ig,2,2) = ci*(5*z**2+15*iypx**2-1)/sq10/2.0d0
          sqy(ig,3,2) = iypx*sq5*z/sq2
          sqy(ig,1,3) = -sq10*(42*z**4+189*iypx**2*z**2-28*z**2-21*iypx**2+2)/56.0d0
          sqy(ig,2,3) = -ci*sq10*(42*z**4+189*iypx**2*z**2-28*z**2-21*iypx**2+2)/56.0d0
          sqy(ig,3,3) = -iypx*sq10*z*(12*z**2+9*iypx**2-4)/4.0d0
       end do
    case (187)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*iypx*sq5*z*(3*z**2+4*iypx**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = 3.0d0*ci*iypx*sq5*z*(3*z**2+4*iypx**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*iypx**2*sq5*(9*z**2+2*iypx**2-1)/(4.0d0*sq2)
       end do
    case (188)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx**2*sq5/2.0d0
          sqy(ig,2,2) = -ci*iypx**2*sq5/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -iypx**2*sq5*(36*z**2+15*iypx**2-4)/8.0d0
          sqy(ig,2,3) = -ci*iypx**2*sq5*(36*z**2+15*iypx**2-4)/8.0d0
          sqy(ig,3,3) = -3*iypx**3*sq5*z
       end do
    case (189)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*iypx**3*z/2.0d0
          sqy(ig,2,3) = 15.0d0*ci*iypx**3*z/2.0d0
          sqy(ig,3,3) = 15.0d0*iypx**4/8.0d0
       end do
    case (190)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-10.0d0)*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-5.0d0)*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = 45.0d0*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 135.0d0*(iypx-iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = (-5.0d0)*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-25.0d0)*(iypx-iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (191)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-5.0d0)*iypx*sq6*z/2.0d0
          sqy(ig,2,1) = (-5.0d0)*ci*iypx*sq6*z/2.0d0
          sqy(ig,3,1) = (-5.0d0)*iypx**2*sq6/4.0d0
       end do
    case (192)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3*(5*z**2-1)/sq2/2.0d0
          sqy(ig,2,1) = ci*sq3*(5*z**2-1)/sq2/2.0d0
          sqy(ig,3,1) = 5*iypx*sq3*z/sq2
       end do
    case (193)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-5.0d0)*iypx*sq6/14.0d0
          sqy(ig,2,1) = (-5.0d0)*ci*iypx*sq6/14.0d0
          sqy(ig,3,1) = (-6.0d0)*sq6*z/7.0d0
          sqy(ig,1,2) = (-5.0d0)*iypx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*ci*iypx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,2) = 5.0d0*sq3*z*(14*z**2-7*iypx**2-6)/(7.0d0*sq2)
       end do
    case (194)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-2.0d0)*sq6*z/7.0d0
          sqy(ig,2,1) = (-2.0d0)*ci*sq6*z/7.0d0
          sqy(ig,3,1) = (-2.0d0)*iypx*sq6/7.0d0
          sqy(ig,1,2) = (-5.0d0)*sq3*z*(7*z**2-21*iypx**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z*(7*z**2-21*iypx**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = (-5.0d0)*iypx*sq3*(21*z**2-7*iypx**2-3)/(14.0d0*sq2)
       end do
    case (195)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-15.0d0)*z/7.0d0
          sqy(ig,2,1) = (-15.0d0)*ci*z/7.0d0
          sqy(ig,3,1) = (-15.0d0)*iypx/7.0d0
          sqy(ig,1,2) = 15.0d0*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = 15.0d0*ci*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = 45.0d0*iypx*(7*z**2-1)/28.0d0
       end do
    case (196)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-5.0d0)*iypx*sq3/7.0d0
          sqy(ig,2,1) = (-5.0d0)*ci*iypx*sq3/7.0d0
          sqy(ig,3,1) = 6.0d0*sq3*z/7.0d0
          sqy(ig,1,2) = (-5.0d0)*iypx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*iypx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = (-5.0d0)*sq3*z*(7*z**2+7*iypx**2-3)/7.0d0
       end do
    case (197)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 4.0d0*sq3*z/7.0d0
          sqy(ig,2,1) = 4.0d0*ci*sq3*z/7.0d0
          sqy(ig,3,1) = 4.0d0*iypx*sq3/7.0d0
          sqy(ig,1,2) = 5.0d0*sq3*z*(14*z**2+21*iypx**2-6)/28.0d0
          sqy(ig,2,2) = 5.0d0*ci*sq3*z*(14*z**2+21*iypx**2-6)/28.0d0
          sqy(ig,3,2) = 5.0d0*iypx*sq3*(42*z**2+7*iypx**2-6)/28.0d0
       end do
    case (198)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iypx/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*iypx/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-15.0d0)*iypx*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = (-15.0d0)*ci*iypx*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = (-15.0d0)*iypx**2*z/2.0d0
       end do
    case (199)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9)/35.0d0
          sqy(ig,2,1) = (-3.0d0)*ci/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-13.0d0)*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = 3.0d0*ci*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = -(5*iypx-8*iymx)*z/2.0d0
          sqy(ig,1,3) = 5.0d0*(21*z**4-14*z**2+1)/14.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 5*(iypx-iymx)*z*(3*z**2-1)
       end do
    case (200)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-12.0d0)*sq3/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -sq3*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = (-5.0d0)*iypx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*iypx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = 5.0d0*sq3*(105*z**4-63*iypx**2*z**2-70*z**2+7*iypx**2+5)/28.0d0
       end do
    case (201)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-6.0d0)*sq3/35.0d0
          sqy(ig,2,1) = (-6.0d0)*ci*sq3/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*(10*z**2-25*iypx**2-2)/20.0d0
          sqy(ig,2,2) = -ci*sq3*(10*z**2-25*iypx**2-2)/20.0d0
          sqy(ig,3,2) = -iypx*sq3*z
          sqy(ig,1,3) = (-5.0d0)*sq3*(21*z**4-63*iypx**2*z**2-14*z**2+7*iypx**2+1)/28.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*sq3*(21*z**4-63*iypx**2*z**2-14*z**2+7*iypx**2+1)/28.0d0
          sqy(ig,3,3) = (-5.0d0)*iypx*sq3*z*(6*z**2-3*iypx**2-2)/2.0d0
       end do
    case (202)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*z
          sqy(ig,2,2) = ci*iypx*z
          sqy(ig,3,2) = iypx**2/2.0d0
          sqy(ig,1,3) = 5.0d0*iypx*z*(3*z**2-6*iypx**2-1)/2.0d0
          sqy(ig,2,3) = 5.0d0*ci*iypx*z*(3*z**2-6*iypx**2-1)/2.0d0
          sqy(ig,3,3) = 5.0d0*iypx**2*(9*z**2-3*iypx**2-1)/4.0d0
       end do
    case (203)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-3.0d0)*sq5/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = sq5*(5*z**2-1)
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-25.0d0)*sq5*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (204)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-33)/35.0d0
          sqy(ig,2,1) = (-27.0d0)*ci/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = (-7.0d0)*ci*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -(5*iypx+2*iymx)*z
          sqy(ig,1,3) = 15.0d0*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = 25.0d0*ci*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = 5.0d0*(4*iypx+iymx)*z*(3*z**2-1)/2.0d0
       end do
    case (205)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 12.0d0*sq2/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = sq2*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = (-15.0d0)*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*ci*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*(210*z**4+189*iypx**2*z**2-140*z**2-21*iypx**2+10)/(28.0d0*sq2)
       end do
    case (206)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*sq2/35.0d0
          sqy(ig,2,1) = 9.0d0*ci*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (15*z**2+25*iypx**2-3)/sq2/10.0d0
          sqy(ig,2,2) = ci*(15*z**2+25*iypx**2-3)/sq2/10.0d0
          sqy(ig,3,2) = 3*iypx*z/sq2
          sqy(ig,1,3) = 5.0d0*(63*z**4+126*iypx**2*z**2-42*z**2-14*iypx**2+3)/(28.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*ci*(63*z**4+126*iypx**2*z**2-42*z**2-14*iypx**2+3)/(28.0d0*sq2)
          sqy(ig,3,3) = 15*iypx*z*(3*z**2+iypx**2-1)/sq2
       end do
    case (207)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -2*iypx*z
          sqy(ig,2,2) = -2*ci*iypx*z
          sqy(ig,3,2) = -iypx**2
          sqy(ig,1,3) = (-5.0d0)*iypx*z*(6*z**2+3*iypx**2-2)/2.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*iypx*z*(6*z**2+3*iypx**2-2)/2.0d0
          sqy(ig,3,3) = (-5.0d0)*iypx**2*(36*z**2+3*iypx**2-4)/8.0d0
       end do
    case (208)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx**2*sq5/2.0d0
          sqy(ig,2,2) = -ci*iypx**2*sq5/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 5.0d0*iypx**2*sq5*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,2,3) = 5.0d0*ci*iypx**2*sq5*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,3,3) = 15.0d0*iypx**3*sq5*z/4.0d0
       end do
    case (209)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*iymx*sq5/7.0d0
          sqy(ig,2,2) = 2.0d0*ci*iymx*sq5/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 27.0d0*iymx*sq5*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = (-27.0d0)*ci*iymx*sq5*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = 3.0d0*sq5*z*(35*z**2-18*iymx**2-15)/22.0d0
          sqy(ig,1,4) = (-5.0d0)*iymx*sq5*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,2,4) = 5.0d0*ci*iymx*sq5*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,3,4) = (-15.0d0)*sq5*z*(33*z**4-22*iymx**2*z**2-30*z**2+6*iymx**2+5)/44.0d0
       end do
    case (210)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-10.0d0)*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-5.0d0)*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = (-60.0d0)*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-90.0d0)*(iypx-iymx)*(7*z**2-1)/77.0d0
          sqy(ig,1,4) = 25.0d0*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 125.0d0*(iypx-iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (211)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq3*(5*z**2-1)/2.0d0
          sqy(ig,2,1) = -ci*sq3*(5*z**2-1)/2.0d0
          sqy(ig,3,1) = -5*iypx*sq3*z
       end do
    case (212)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*sq3*(5*z**2-1)/2.0d0
       end do
    case (213)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq3*z/7.0d0
          sqy(ig,2,1) = -ci*sq3*z
          sqy(ig,3,1) = -(4*iypx+3*iymx)*sq3/7.0d0
          sqy(ig,1,2) = (-5.0d0)*sq3*z*(7*z**2-3)/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-15.0d0)*(iypx-iymx)*sq3*(7*z**2-1)/14.0d0
       end do
    case (214)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-2.0d0)*iypx*sq3/7.0d0
          sqy(ig,2,1) = (-2.0d0)*ci*iypx*sq3/7.0d0
          sqy(ig,3,1) = (-9.0d0)*sq3*z/7.0d0
          sqy(ig,1,2) = 5.0d0*iypx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = 5.0d0*ci*iypx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = (-5.0d0)*sq3*z*(14*z**2-7*iypx**2-6)/7.0d0
       end do
    case (215)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-18.0d0)*sq2*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 15.0d0*sq2*z*(7*z**2-3)/7.0d0
       end do
    case (216)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-11.0d0)*sq3*z/(7.0d0*sq2)
          sqy(ig,2,1) = (-5.0d0)*ci*sq3*z/(7.0d0*sq2)
          sqy(ig,3,1) = -(8*iypx-3*iymx)*sq3/sq2/7.0d0
          sqy(ig,1,2) = (-5.0d0)*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = (-15.0d0)*ci*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = (-15.0d0)*(2*iypx+iymx)*sq3*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (217)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -iypx*sq6/7.0d0
          sqy(ig,2,1) = -ci*iypx*sq6/7.0d0
          sqy(ig,3,1) = 9.0d0*sq6*z/7.0d0
          sqy(ig,1,2) = 5.0d0*iypx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,2) = 5.0d0*ci*iypx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,2) = 5.0d0*sq3*z*(28*z**2+7*iypx**2-12)/(7.0d0*sq2)
       end do
    case (218)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*z/(7.0d0*sq2)
          sqy(ig,2,1) = 9.0d0*ci*z/(7.0d0*sq2)
          sqy(ig,3,1) = 9.0d0*iypx/(7.0d0*sq2)
          sqy(ig,1,2) = (-15.0d0)*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = (-15.0d0)*ci*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = (-45.0d0)*iypx*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (219)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-12.0d0)*sq2/35.0d0
          sqy(ig,1,2) = -2*iymx*sq2*z
          sqy(ig,2,2) = 2*ci*iymx*sq2*z
          sqy(ig,3,2) = -sq2*(5*z**2-5*iymx**2-1)/5.0d0
          sqy(ig,1,3) = 5*iymx*z*(3*z**2-1)/sq2
          sqy(ig,2,3) = -5*ci*iymx*z*(3*z**2-1)/sq2
          sqy(ig,3,3) = 5.0d0*(105*z**4-63*iymx**2*z**2-70*z**2+7*iymx**2+5)/(14.0d0*sq2)
       end do
    case (220)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq3/(35.0d0*sq2)
          sqy(ig,2,1) = (-3.0d0)*ci*sq3/(5.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = -ci*sq3*(5*z**2-1)/sq2/10.0d0
          sqy(ig,3,2) = -(2*iypx-iymx)*sq3*z/sq2
          sqy(ig,1,3) = (-5.0d0)*sq3*(21*z**4-14*z**2+1)/(7.0d0*sq2)
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = -5*(iypx-iymx)*sq6*z*(3*z**2-1)
       end do
    case (221)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-9.0d0)*sq6/35.0d0
          sqy(ig,1,2) = iypx*sq6*z
          sqy(ig,2,2) = ci*iypx*sq6*z
          sqy(ig,3,2) = -sq3*(20*z**2-5*iypx**2-4)/sq2/5.0d0
          sqy(ig,1,3) = 5*iypx*sq3*z*(3*z**2-1)/sq2
          sqy(ig,2,3) = 5*ci*iypx*sq3*z*(3*z**2-1)/sq2
          sqy(ig,3,3) = (-5.0d0)*sq3*(105*z**4-63*iypx**2*z**2-70*z**2+7*iypx**2+5)/(14.0d0*sq2)
       end do
    case (222)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)/(35.0d0*sq2)
          sqy(ig,2,1) = (-9.0d0)*ci/(35.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2+20*iypx**2-1)/sq2/10.0d0
          sqy(ig,2,2) = ci*(5*z**2+20*iypx**2-1)/sq2/10.0d0
          sqy(ig,3,2) = iypx*z/sq2
          sqy(ig,1,3) = 5.0d0*(21*z**4-63*iypx**2*z**2-14*z**2+7*iypx**2+1)/(14.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*ci*(21*z**4-63*iypx**2*z**2-14*z**2+7*iypx**2+1)/(14.0d0*sq2)
          sqy(ig,3,3) = 5*iypx*z*(6*z**2-3*iypx**2-2)/sq2
       end do
    case (223)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq10/35.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*sq10/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -2*(5*z**2-1)/sq10
          sqy(ig,2,2) = 2*ci*(5*z**2-1)/sq10
          sqy(ig,3,2) = 2*iymx*sq10*z
          sqy(ig,1,3) = 5.0d0*sq10*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*sq10*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = (-5.0d0)*iymx*sq10*z*(3*z**2-1)/2.0d0
       end do
    case (224)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-24.0d0)*sq2/35.0d0
          sqy(ig,1,2) = iymx*sq2*z
          sqy(ig,2,2) = -ci*iymx*sq2*z
          sqy(ig,3,2) = -(20*z**2+5*iymx**2-4)/sq2/5.0d0
          sqy(ig,1,3) = (-5.0d0)*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*ci*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = 5.0d0*(420*z**4+63*iymx**2*z**2-280*z**2-7*iymx**2+20)/(28.0d0*sq2)
       end do
    case (225)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-27)/35.0d0
          sqy(ig,2,1) = (-9.0d0)*ci/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(5*z**2-1)/5.0d0
          sqy(ig,2,2) = (-2.0d0)*ci*(5*z**2-1)/5.0d0
          sqy(ig,3,2) = -(3*iypx+iymx)*z
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/28.0d0
          sqy(ig,2,3) = (-25.0d0)*ci*(21*z**4-14*z**2+1)/28.0d0
          sqy(ig,3,3) = -5*(3*iypx+2*iymx)*z*(3*z**2-1)
       end do
    case (226)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 27/35.0d0
          sqy(ig,1,2) = 2*iypx*z
          sqy(ig,2,2) = 2*ci*iypx*z
          sqy(ig,3,2) = (30*z**2+5*iypx**2-6)/5.0d0
          sqy(ig,1,3) = 5*iypx*z*(3*z**2-1)
          sqy(ig,2,3) = 5*ci*iypx*z*(3*z**2-1)
          sqy(ig,3,3) = 5.0d0*(315*z**4+126*iypx**2*z**2-210*z**2-14*iypx**2+15)/28.0d0
       end do
    case (227)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*sq2/35.0d0
          sqy(ig,2,1) = 9.0d0*ci*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(5*z**2-5*iypx**2-1)/sq2/5.0d0
          sqy(ig,2,2) = -ci*(5*z**2-5*iypx**2-1)/sq2/5.0d0
          sqy(ig,3,2) = -iypx*sq2*z
          sqy(ig,1,3) = (-5.0d0)*(84*z**4+63*iypx**2*z**2-56*z**2-7*iypx**2+4)/(28.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*ci*(84*z**4+63*iypx**2*z**2-56*z**2-7*iypx**2+4)/(28.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*iypx*z*(24*z**2+3*iypx**2-8)/(2.0d0*sq2)
       end do
    case (228)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq10*z
          sqy(ig,2,2) = -ci*iypx*sq10*z
          sqy(ig,3,2) = -iypx**2*sq5/sq2
          sqy(ig,1,3) = 5.0d0*iypx*sq5*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*ci*iypx*sq5*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = 5.0d0*iypx**2*sq5*(3*z-1)*(3*z+1)/(4.0d0*sq2)
       end do
    case (229)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq10*z/7.0d0
          sqy(ig,2,2) = ci*sq10*z/7.0d0
          sqy(ig,3,2) = iymx*sq10/7.0d0
          sqy(ig,1,3) = (-3.0d0)*sq10*z*(56*z**2-189*iymx**2-24)/308.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq10*z*(56*z**2-189*iymx**2-24)/308.0d0
          sqy(ig,3,3) = 9.0d0*iymx*sq10*(56*z**2-21*iymx**2-8)/308.0d0
          sqy(ig,1,4) = 5.0d0*sq10*z*(33*z**4-99*iymx**2*z**2-30*z**2+27*iymx**2+5)/88.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*sq10*z*(33*z**4-99*iymx**2*z**2-30*z**2+27*iymx**2+5)/88.0d0
          sqy(ig,3,4) = (-5.0d0)*iymx*sq10*(165*z**4-99*iymx**2*z**2-90*z**2+9*iymx**2+5)/88.0d0
       end do
    case (230)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*iymx*sq2/7.0d0
          sqy(ig,2,2) = 5.0d0*ci*iymx*sq2/7.0d0
          sqy(ig,3,2) = (-6.0d0)*sq2*z/7.0d0
          sqy(ig,1,3) = (-45.0d0)*iymx*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,2,3) = 45.0d0*ci*iymx*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,3,3) = (-15.0d0)*z*(28*z**2-21*iymx**2-12)/(154.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*iymx*(33*z**4-18*z**2+1)/(22.0d0*sq2)
          sqy(ig,2,4) = (-25.0d0)*ci*iymx*(33*z**4-18*z**2+1)/(22.0d0*sq2)
          sqy(ig,3,4) = 75.0d0*z*(33*z**4-22*iymx**2*z**2-30*z**2+6*iymx**2+5)/(22.0d0*sq2)
       end do
    case (231)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-4.0d0)*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-2.0d0)*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = (-45.0d0)*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-135.0d0)*(iypx-iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/22.0d0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-125.0d0)*(iypx-iymx)*(33*z**4-18*z**2+1)/44.0d0
       end do
    case (232)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-3.0d0)*sq3*(5*z**2-1)/2.0d0
       end do
    case (233)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq3*(5*z**2-1)/2.0d0
          sqy(ig,2,1) = ci*sq3*(5*z**2-1)/2.0d0
          sqy(ig,3,1) = 5*iymx*sq3*z
       end do
    case (234)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*iymx*sq3/7.0d0
          sqy(ig,2,1) = (-2.0d0)*ci*iymx*sq3/7.0d0
          sqy(ig,3,1) = (-9.0d0)*sq3*z/7.0d0
          sqy(ig,1,2) = (-5.0d0)*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = 5.0d0*ci*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = (-5.0d0)*sq3*z*(14*z**2-7*iymx**2-6)/7.0d0
       end do
    case (235)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3*z/7.0d0
          sqy(ig,2,1) = -ci*sq3*z
          sqy(ig,3,1) = -(3*iypx+4*iymx)*sq3/7.0d0
          sqy(ig,1,2) = 5.0d0*sq3*z*(7*z**2-3)/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 15.0d0*(iypx-iymx)*sq3*(7*z**2-1)/14.0d0
       end do
    case (236)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*z/(7.0d0*sq2)
          sqy(ig,2,1) = (-9.0d0)*ci*z/(7.0d0*sq2)
          sqy(ig,3,1) = (-9.0d0)*iymx/(7.0d0*sq2)
          sqy(ig,1,2) = (-15.0d0)*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = 15.0d0*ci*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = 45.0d0*iymx*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (237)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -iymx*sq6/7.0d0
          sqy(ig,2,1) = ci*iymx*sq6/7.0d0
          sqy(ig,3,1) = (-9.0d0)*sq6*z/7.0d0
          sqy(ig,1,2) = 5.0d0*iymx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*ci*iymx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,2) = (-5.0d0)*sq3*z*(28*z**2+7*iymx**2-12)/(7.0d0*sq2)
       end do
    case (238)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-11.0d0)*sq3*z/(7.0d0*sq2)
          sqy(ig,2,1) = 5.0d0*ci*sq3*z/(7.0d0*sq2)
          sqy(ig,3,1) = -(3*iypx-8*iymx)*sq3/sq2/7.0d0
          sqy(ig,1,2) = (-5.0d0)*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = 15.0d0*ci*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = 15.0d0*(iypx+2*iymx)*sq3*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (239)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 18.0d0*sq2*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-15.0d0)*sq2*z*(7*z**2-3)/7.0d0
       end do
    case (240)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0/(35.0d0*sq2)
          sqy(ig,2,1) = (-9.0d0)*ci/(35.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(5*z**2+20*iymx**2-1)/sq2/10.0d0
          sqy(ig,2,2) = ci*(5*z**2+20*iymx**2-1)/sq2/10.0d0
          sqy(ig,3,2) = iymx*z/sq2
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-63*iymx**2*z**2-14*z**2+7*iymx**2+1)/(14.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*ci*(21*z**4-63*iymx**2*z**2-14*z**2+7*iymx**2+1)/(14.0d0*sq2)
          sqy(ig,3,3) = 5*iymx*z*(6*z**2-3*iymx**2-2)/sq2
       end do
    case (241)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-9.0d0)*sq6/35.0d0
          sqy(ig,1,2) = -iymx*sq6*z
          sqy(ig,2,2) = ci*iymx*sq6*z
          sqy(ig,3,2) = -sq3*(20*z**2-5*iymx**2-4)/sq2/5.0d0
          sqy(ig,1,3) = -5*iymx*sq3*z*(3*z**2-1)/sq2
          sqy(ig,2,3) = 5*ci*iymx*sq3*z*(3*z**2-1)/sq2
          sqy(ig,3,3) = (-5.0d0)*sq3*(105*z**4-63*iymx**2*z**2-70*z**2+7*iymx**2+5)/(14.0d0*sq2)
       end do
    case (242)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0/(35.0d0*sq6)
          sqy(ig,2,1) = (-9.0d0)*ci/(5.0d0*sq6)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = -ci*sq3*(5*z**2-1)/sq2/10.0d0
          sqy(ig,3,2) = (iypx-2*iymx)*sq3*z/sq2
          sqy(ig,1,3) = 5.0d0*sq3*(21*z**4-14*z**2+1)/(7.0d0*sq2)
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 5*(iypx-iymx)*sq6*z*(3*z**2-1)
       end do
    case (243)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-12.0d0)*sq2/35.0d0
          sqy(ig,1,2) = 2*iypx*sq2*z
          sqy(ig,2,2) = 2*ci*iypx*sq2*z
          sqy(ig,3,2) = -sq2*(5*z**2-5*iypx**2-1)/5.0d0
          sqy(ig,1,3) = -5*iypx*z*(3*z**2-1)/sq2
          sqy(ig,2,3) = -5*ci*iypx*z*(3*z**2-1)/sq2
          sqy(ig,3,3) = 5.0d0*(105*z**4-63*iypx**2*z**2-70*z**2+7*iypx**2+5)/(14.0d0*sq2)
       end do
    case (244)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq10*z
          sqy(ig,2,2) = ci*iymx*sq10*z
          sqy(ig,3,2) = iymx**2*sq10/2.0d0
          sqy(ig,1,3) = 5.0d0*iymx*sq10*z*(3*z**2-1)/4.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*iymx*sq10*z*(3*z**2-1)/4.0d0
          sqy(ig,3,3) = (-5.0d0)*iymx**2*sq10*(3*z-1)*(3*z+1)/8.0d0
       end do
    case (245)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*sq2/35.0d0
          sqy(ig,2,1) = (-9.0d0)*ci*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(5*z**2-5*iymx**2-1)/sq2/5.0d0
          sqy(ig,2,2) = ci*(5*z**2-5*iymx**2-1)/sq2/5.0d0
          sqy(ig,3,2) = iymx*sq2*z
          sqy(ig,1,3) = (-5.0d0)*(84*z**4+63*iymx**2*z**2-56*z**2-7*iymx**2+4)/(28.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*ci*(84*z**4+63*iymx**2*z**2-56*z**2-7*iymx**2+4)/(28.0d0*sq2)
          sqy(ig,3,3) = 5.0d0*iymx*z*(24*z**2+3*iymx**2-8)/(2.0d0*sq2)
       end do
    case (246)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-27)/35.0d0
          sqy(ig,1,2) = 2*iymx*z
          sqy(ig,2,2) = -2*ci*iymx*z
          sqy(ig,3,2) = -(30*z**2+5*iymx**2-6)/5.0d0
          sqy(ig,1,3) = 5*iymx*z*(3*z**2-1)
          sqy(ig,2,3) = -5*ci*iymx*z*(3*z**2-1)
          sqy(ig,3,3) = (-5.0d0)*(315*z**4+126*iymx**2*z**2-210*z**2-14*iymx**2+15)/28.0d0
       end do
    case (247)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-27)/35.0d0
          sqy(ig,2,1) = 9.0d0*ci/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(5*z**2-1)/5.0d0
          sqy(ig,2,2) = 2.0d0*ci*(5*z**2-1)/5.0d0
          sqy(ig,3,2) = (iypx+3*iymx)*z
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/28.0d0
          sqy(ig,2,3) = 25.0d0*ci*(21*z**4-14*z**2+1)/28.0d0
          sqy(ig,3,3) = 5*(2*iypx+3*iymx)*z*(3*z**2-1)
       end do
    case (248)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 24.0d0*sq2/35.0d0
          sqy(ig,1,2) = iypx*sq2*z
          sqy(ig,2,2) = ci*iypx*sq2*z
          sqy(ig,3,2) = (20*z**2+5*iypx**2-4)/sq2/5.0d0
          sqy(ig,1,3) = (-5.0d0)*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*ci*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*(420*z**4+63*iypx**2*z**2-280*z**2-7*iypx**2+20)/(28.0d0*sq2)
       end do
    case (249)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0/(7.0d0*sq10)
          sqy(ig,2,1) = 6.0d0*ci/(7.0d0*sq10)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -2*(5*z**2-1)/sq10
          sqy(ig,2,2) = -2*ci*(5*z**2-1)/sq10
          sqy(ig,3,2) = -2*iypx*sq10*z
          sqy(ig,1,3) = 5.0d0*sq5*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*ci*sq5*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,3,3) = 5*iypx*sq5*z*(3*z**2-1)/sq2
       end do
    case (250)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq10/7.0d0
          sqy(ig,2,2) = ci*iymx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*iymx*sq10*(7*z**2-28*iymx**2-1)/308.0d0
          sqy(ig,2,3) = 9.0d0*ci*iymx*sq10*(7*z**2-28*iymx**2-1)/308.0d0
          sqy(ig,3,3) = 9.0d0*iymx**2*sq10*z/44.0d0
          sqy(ig,1,4) = 5.0d0*iymx*sq10*(33*z**4-66*iymx**2*z**2-18*z**2+6*iymx**2+1)/44.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*iymx*sq10*(33*z**4-66*iymx**2*z**2-18*z**2+6*iymx**2+1)/44.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**2*sq10*z*(22*z**2-11*iymx**2-6)/44.0d0
       end do
    case (251)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq2*z/7.0d0
          sqy(ig,2,2) = ci*sq2*z/7.0d0
          sqy(ig,3,2) = iymx*sq2/7.0d0
          sqy(ig,1,3) = (-45.0d0)*z*(7*z**2-14*iymx**2-3)/(154.0d0*sq2)
          sqy(ig,2,3) = 45.0d0*ci*z*(7*z**2-14*iymx**2-3)/(154.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*iymx*(63*z**2-14*iymx**2-9)/(154.0d0*sq2)
          sqy(ig,1,4) = (-25.0d0)*z*(33*z**4-99*iymx**2*z**2-30*z**2+27*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,2,4) = 25.0d0*ci*z*(33*z**4-99*iymx**2*z**2-30*z**2+27*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,3,4) = 25.0d0*iymx*(165*z**4-99*iymx**2*z**2-90*z**2+9*iymx**2+5)/(44.0d0*sq2)
       end do
    case (252)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-8.0d0)*iymx/7.0d0
          sqy(ig,2,2) = 8.0d0*ci*iymx/7.0d0
          sqy(ig,3,2) = (-12.0d0)*z/7.0d0
          sqy(ig,1,3) = (-60.0d0)*iymx*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = 60.0d0*ci*iymx*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = (-15.0d0)*z*(63*z**2-28*iymx**2-27)/77.0d0
          sqy(ig,1,4) = (-25.0d0)*iymx*(33*z**4-18*z**2+1)/22.0d0
          sqy(ig,2,4) = 25.0d0*ci*iymx*(33*z**4-18*z**2+1)/22.0d0
          sqy(ig,3,4) = (-75.0d0)*z*(33*z**4-22*iymx**2*z**2-30*z**2+6*iymx**2+5)/22.0d0
       end do
    case (253)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 2.0d0*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = 45.0d0*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 135.0d0*(iypx-iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 25.0d0*z*(33*z**4-30*z**2+5)/22.0d0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 125.0d0*(iypx-iymx)*(33*z**4-18*z**2+1)/44.0d0
       end do
    case (254)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3*(5*z**2-1)/sq2/2.0d0
          sqy(ig,2,1) = -ci*sq3*(5*z**2-1)/sq2/2.0d0
          sqy(ig,3,1) = -5*iymx*sq3*z/sq2
       end do
    case (255)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -15*iymx*z/sq6
          sqy(ig,2,1) = 15*ci*iymx*z/sq6
          sqy(ig,3,1) = 15.0d0*iymx**2/(2.0d0*sq6)
       end do
    case (256)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*sq6*z/7.0d0
          sqy(ig,2,1) = (-2.0d0)*ci*sq6*z/7.0d0
          sqy(ig,3,1) = (-2.0d0)*iymx*sq6/7.0d0
          sqy(ig,1,2) = 5.0d0*sq3*z*(7*z**2-21*iymx**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z*(7*z**2-21*iymx**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = (-5.0d0)*iymx*sq3*(21*z**2-7*iymx**2-3)/(14.0d0*sq2)
       end do
    case (257)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 5.0d0*iymx*sq6/14.0d0
          sqy(ig,2,1) = (-5.0d0)*ci*iymx*sq6/14.0d0
          sqy(ig,3,1) = (-6.0d0)*sq6*z/7.0d0
          sqy(ig,1,2) = 5.0d0*iymx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*ci*iymx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,2) = 5.0d0*sq3*z*(14*z**2-7*iymx**2-6)/(7.0d0*sq2)
       end do
    case (258)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iymx/7.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*iymx/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-15.0d0)*iymx*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = 15.0d0*ci*iymx*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = 15.0d0*iymx**2*z/2.0d0
       end do
    case (259)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 4.0d0*sq3*z/7.0d0
          sqy(ig,2,1) = (-4.0d0)*ci*sq3*z/7.0d0
          sqy(ig,3,1) = (-4.0d0)*iymx*sq3/7.0d0
          sqy(ig,1,2) = 5.0d0*sq3*z*(14*z**2+21*iymx**2-6)/28.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z*(14*z**2+21*iymx**2-6)/28.0d0
          sqy(ig,3,2) = (-5.0d0)*iymx*sq3*(42*z**2+7*iymx**2-6)/28.0d0
       end do
    case (260)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-5.0d0)*iymx*sq3/7.0d0
          sqy(ig,2,1) = 5.0d0*ci*iymx*sq3/7.0d0
          sqy(ig,3,1) = (-6.0d0)*sq3*z/7.0d0
          sqy(ig,1,2) = (-5.0d0)*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = 5.0d0*ci*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = 5.0d0*sq3*z*(7*z**2+7*iymx**2-3)/7.0d0
       end do
    case (261)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-15.0d0)*z/7.0d0
          sqy(ig,2,1) = 15.0d0*ci*z/7.0d0
          sqy(ig,3,1) = 15.0d0*iymx/7.0d0
          sqy(ig,1,2) = 15.0d0*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = (-15.0d0)*ci*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = (-45.0d0)*iymx*(7*z**2-1)/28.0d0
       end do
    case (262)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*z
          sqy(ig,2,2) = ci*iymx*z
          sqy(ig,3,2) = iymx**2/2.0d0
          sqy(ig,1,3) = (-5.0d0)*iymx*z*(3*z**2-6*iymx**2-1)/2.0d0
          sqy(ig,2,3) = 5.0d0*ci*iymx*z*(3*z**2-6*iymx**2-1)/2.0d0
          sqy(ig,3,3) = 5.0d0*iymx**2*(9*z**2-3*iymx**2-1)/4.0d0
       end do
    case (263)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*sq3/35.0d0
          sqy(ig,2,1) = (-6.0d0)*ci*sq3/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq3*(10*z**2-25*iymx**2-2)/20.0d0
          sqy(ig,2,2) = -ci*sq3*(10*z**2-25*iymx**2-2)/20.0d0
          sqy(ig,3,2) = -iymx*sq3*z
          sqy(ig,1,3) = 5.0d0*sq3*(21*z**4-63*iymx**2*z**2-14*z**2+7*iymx**2+1)/28.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*sq3*(21*z**4-63*iymx**2*z**2-14*z**2+7*iymx**2+1)/28.0d0
          sqy(ig,3,3) = (-5.0d0)*iymx*sq3*z*(6*z**2-3*iymx**2-2)/2.0d0
       end do
    case (264)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-12.0d0)*sq3/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -sq3*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = 5.0d0*iymx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*iymx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = 5.0d0*sq3*(105*z**4-63*iymx**2*z**2-70*z**2+7*iymx**2+5)/28.0d0
       end do
    case (265)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9/35.0d0
          sqy(ig,2,1) = (-3.0d0)*ci/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 13.0d0*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = 3.0d0*ci*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = (8*iypx-5*iymx)*z/2.0d0
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/14.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = -5*(iypx-iymx)*z*(3*z**2-1)
       end do
    case (266)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx**2*sq5/2.0d0
          sqy(ig,2,2) = ci*iymx**2*sq5/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 5.0d0*iymx**2*sq5*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*iymx**2*sq5*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,3,3) = (-15.0d0)*iymx**3*sq5*z/4.0d0
       end do
    case (267)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -2*iymx*z
          sqy(ig,2,2) = 2*ci*iymx*z
          sqy(ig,3,2) = iymx**2
          sqy(ig,1,3) = (-5.0d0)*iymx*z*(6*z**2+3*iymx**2-2)/2.0d0
          sqy(ig,2,3) = 5.0d0*ci*iymx*z*(6*z**2+3*iymx**2-2)/2.0d0
          sqy(ig,3,3) = 5.0d0*iymx**2*(36*z**2+3*iymx**2-4)/8.0d0
       end do
    case (268)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*sq2/35.0d0
          sqy(ig,2,1) = (-9.0d0)*ci*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (15*z**2+25*iymx**2-3)/sq2/10.0d0
          sqy(ig,2,2) = -ci*(15*z**2+25*iymx**2-3)/sq2/10.0d0
          sqy(ig,3,2) = -3*iymx*z/sq2
          sqy(ig,1,3) = 5.0d0*(63*z**4+126*iymx**2*z**2-42*z**2-14*iymx**2+3)/(28.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*ci*(63*z**4+126*iymx**2*z**2-42*z**2-14*iymx**2+3)/(28.0d0*sq2)
          sqy(ig,3,3) = -15*iymx*z*(3*z**2+iymx**2-1)/sq2
       end do
    case (269)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-12.0d0)*sq2/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -sq2*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = (-15.0d0)*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = 15.0d0*ci*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = 5.0d0*(210*z**4+189*iymx**2*z**2-140*z**2-21*iymx**2+10)/(28.0d0*sq2)
       end do
    case (270)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-33)/35.0d0
          sqy(ig,2,1) = 27.0d0*ci/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = 7.0d0*ci*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = (2*iypx+5*iymx)*z
          sqy(ig,1,3) = 15.0d0*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = (-25.0d0)*ci*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = (-5.0d0)*(iypx+4*iymx)*z*(3*z**2-1)/2.0d0
       end do
    case (271)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*sq5/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -sq5*(5*z**2-1)
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 25.0d0*sq5*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (272)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iymx**2*sq5*z/22.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*iymx**2*sq5*z/22.0d0
          sqy(ig,3,3) = (-3.0d0)*iymx**3*sq5/22.0d0
          sqy(ig,1,4) = 15.0d0*iymx**2*sq5*z*(33*z**2-55*iymx**2-9)/88.0d0
          sqy(ig,2,4) = (-15.0d0)*ci*iymx**2*sq5*z*(33*z**2-55*iymx**2-9)/88.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**3*sq5*(33*z**2-11*iymx**2-3)/88.0d0
       end do
    case (273)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-4.0d0)*iymx/7.0d0
          sqy(ig,2,2) = 4.0d0*ci*iymx/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*iymx*(28*z**2-35*iymx**2-4)/154.0d0
          sqy(ig,2,3) = 15.0d0*ci*iymx*(28*z**2-35*iymx**2-4)/154.0d0
          sqy(ig,3,3) = 30.0d0*iymx**2*z/11.0d0
          sqy(ig,1,4) = (-25.0d0)*iymx*(33*z**4-66*iymx**2*z**2-18*z**2+6*iymx**2+1)/44.0d0
          sqy(ig,2,4) = 25.0d0*ci*iymx*(33*z**4-66*iymx**2*z**2-18*z**2+6*iymx**2+1)/44.0d0
          sqy(ig,3,4) = 75.0d0*iymx**2*z*(22*z**2-11*iymx**2-6)/44.0d0
       end do
    case (274)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq2*z/7.0d0
          sqy(ig,2,2) = -ci*sq2*z/7.0d0
          sqy(ig,3,2) = -iymx*sq2/7.0d0
          sqy(ig,1,3) = 45.0d0*z*(7*z**2-14*iymx**2-3)/(154.0d0*sq2)
          sqy(ig,2,3) = (-45.0d0)*ci*z*(7*z**2-14*iymx**2-3)/(154.0d0*sq2)
          sqy(ig,3,3) = (-15.0d0)*iymx*(63*z**2-14*iymx**2-9)/(154.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*z*(33*z**4-99*iymx**2*z**2-30*z**2+27*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,2,4) = (-25.0d0)*ci*z*(33*z**4-99*iymx**2*z**2-30*z**2+27*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,3,4) = (-25.0d0)*iymx*(165*z**4-99*iymx**2*z**2-90*z**2+9*iymx**2+5)/(44.0d0*sq2)
       end do
    case (275)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*iymx*sq2/7.0d0
          sqy(ig,2,2) = 5.0d0*ci*iymx*sq2/7.0d0
          sqy(ig,3,2) = (-6.0d0)*sq2*z/7.0d0
          sqy(ig,1,3) = (-45.0d0)*iymx*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,2,3) = 45.0d0*ci*iymx*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,3,3) = (-15.0d0)*z*(28*z**2-21*iymx**2-12)/(154.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*iymx*(33*z**4-18*z**2+1)/(22.0d0*sq2)
          sqy(ig,2,4) = (-25.0d0)*ci*iymx*(33*z**4-18*z**2+1)/(22.0d0*sq2)
          sqy(ig,3,4) = 75.0d0*z*(33*z**4-22*iymx**2*z**2-30*z**2+6*iymx**2+5)/(22.0d0*sq2)
       end do
    case (276)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 10.0d0*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 5.0d0*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = 60.0d0*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 90.0d0*(iypx-iymx)*(7*z**2-1)/77.0d0
          sqy(ig,1,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-125.0d0)*(iypx-iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (277)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 15*iymx*z/sq30
          sqy(ig,2,1) = -15*ci*iymx*z/sq30
          sqy(ig,3,1) = (-15.0d0)*iymx**2/(2.0d0*sq30)
       end do
    case (278)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*iymx**2*sq5/(2.0d0*sq6)
          sqy(ig,2,1) = 9.0d0*ci*iymx**2*sq5/(2.0d0*sq6)
          sqy(ig,3,1) = 0
       end do
    case (279)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iymx*sq30/14.0d0
          sqy(ig,2,1) = -ci*iymx*sq30/14.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iymx*sq5*(7*z**2-14*iymx**2-1)/(7.0d0*sq6)
          sqy(ig,2,2) = (-3.0d0)*ci*iymx*sq5*(7*z**2-14*iymx**2-1)/(7.0d0*sq6)
          sqy(ig,3,2) = -15*iymx**2*z/sq30
       end do
    case (280)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq30*z/7.0d0
          sqy(ig,2,1) = -ci*sq30*z/7.0d0
          sqy(ig,3,1) = -iymx*sq30/7.0d0
          sqy(ig,1,2) = (-3.0d0)*sq5*z*(7*z**2-21*iymx**2-3)/(14.0d0*sq6)
          sqy(ig,2,2) = 3.0d0*ci*sq5*z*(7*z**2-21*iymx**2-3)/(14.0d0*sq6)
          sqy(ig,3,2) = 3.0d0*iymx*sq5*(21*z**2-7*iymx**2-3)/(14.0d0*sq6)
       end do
    case (281)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*iymx**2*sq5*z/4.0d0
          sqy(ig,2,2) = 9.0d0*ci*iymx**2*sq5*z/4.0d0
          sqy(ig,3,2) = 3.0d0*iymx**3*sq5/4.0d0
       end do
    case (282)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iymx*sq15/7.0d0
          sqy(ig,2,1) = -ci*iymx*sq15/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq15*(7*z**2+7*iymx**2-1)/7.0d0
          sqy(ig,2,2) = -ci*iymx*sq15*(7*z**2+7*iymx**2-1)/7.0d0
          sqy(ig,3,2) = -iymx**2*sq15*z
       end do
    case (283)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq15*z/7.0d0
          sqy(ig,2,1) = -ci*sq15*z/7.0d0
          sqy(ig,3,1) = -iymx*sq15/7.0d0
          sqy(ig,1,2) = -sq15*z*(7*z**2+42*iymx**2-3)/28.0d0
          sqy(ig,2,2) = ci*sq15*z*(7*z**2+42*iymx**2-3)/28.0d0
          sqy(ig,3,2) = iymx*sq15*(21*z**2+14*iymx**2-3)/28.0d0
       end do
    case (284)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*iymx*sq5/7.0d0
          sqy(ig,2,1) = 9.0d0*ci*iymx*sq5/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iymx*sq5*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iymx*sq5*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = (-3.0d0)*iymx**2*sq5*z/2.0d0
       end do
    case (285)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx**2*sq5/4.0d0
          sqy(ig,2,2) = ci*iymx**2*sq5/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -iymx**2*sq5*(9*z**2-15*iymx**2-1)/4.0d0
          sqy(ig,2,3) = ci*iymx**2*sq5*(9*z**2-15*iymx**2-1)/4.0d0
          sqy(ig,3,3) = 3.0d0*iymx**3*sq5*z/2.0d0
       end do
    case (286)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = iymx*sq15*z*(3*z**2-6*iymx**2-1)/2.0d0
          sqy(ig,2,3) = -ci*iymx*sq15*z*(3*z**2-6*iymx**2-1)/2.0d0
          sqy(ig,3,3) = -iymx**2*sq15*(9*z**2-3*iymx**2-1)/4.0d0
       end do
    case (287)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq3/(7.0d0*sq5)
          sqy(ig,2,1) = (-3.0d0)*ci*sq3/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq3*(5*z**2-10*iymx**2-1)/sq5/4.0d0
          sqy(ig,2,2) = -ci*sq3*(5*z**2-10*iymx**2-1)/sq5/4.0d0
          sqy(ig,3,2) = -iymx*sq15*z/2.0d0
          sqy(ig,1,3) = -sq15*(21*z**4-63*iymx**2*z**2-14*z**2+7*iymx**2+1)/28.0d0
          sqy(ig,2,3) = ci*sq15*(21*z**4-63*iymx**2*z**2-14*z**2+7*iymx**2+1)/28.0d0
          sqy(ig,3,3) = iymx*sq15*z*(6*z**2-3*iymx**2-2)/2.0d0
       end do
    case (288)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-6.0d0)/(7.0d0*sq5)
          sqy(ig,1,2) = iymx*sq5*z
          sqy(ig,2,2) = -ci*iymx*sq5*z
          sqy(ig,3,2) = (20*z**2-5*iymx**2-4)/sq5/2.0d0
          sqy(ig,1,3) = -iymx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = ci*iymx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = -sq5*(105*z**4-63*iymx**2*z**2-70*z**2+7*iymx**2+5)/28.0d0
       end do
    case (289)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*iymx**3*z/2.0d0
          sqy(ig,2,3) = (-15.0d0)*ci*iymx**3*z/2.0d0
          sqy(ig,3,3) = (-15.0d0)*iymx**4/8.0d0
       end do
    case (290)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx**2*sq5/2.0d0
          sqy(ig,2,2) = ci*iymx**2*sq5/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -iymx**2*sq5*(36*z**2+15*iymx**2-4)/8.0d0
          sqy(ig,2,3) = ci*iymx**2*sq5*(36*z**2+15*iymx**2-4)/8.0d0
          sqy(ig,3,3) = 3*iymx**3*sq5*z
       end do
    case (291)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*iymx*z*(3*z**2+4*iymx**2-1)/(2.0d0*sq10)
          sqy(ig,2,3) = (-15.0d0)*ci*iymx*z*(3*z**2+4*iymx**2-1)/(2.0d0*sq10)
          sqy(ig,3,3) = (-15.0d0)*iymx**2*(9*z**2+2*iymx**2-1)/(4.0d0*sq10)
       end do
    case (292)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq2/(7.0d0*sq5)
          sqy(ig,2,1) = (-3.0d0)*ci*sq2/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2+15*iymx**2-1)/sq10/2.0d0
          sqy(ig,2,2) = -ci*(5*z**2+15*iymx**2-1)/sq10/2.0d0
          sqy(ig,3,2) = -5*iymx*z/sq10
          sqy(ig,1,3) = -sq5*(42*z**4+189*iymx**2*z**2-28*z**2-21*iymx**2+2)/sq2/28.0d0
          sqy(ig,2,3) = ci*sq5*(42*z**4+189*iymx**2*z**2-28*z**2-21*iymx**2+2)/sq2/28.0d0
          sqy(ig,3,3) = iymx*sq5*z*(12*z**2+9*iymx**2-4)/sq2/2.0d0
       end do
    case (293)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-3.0d0)/(7.0d0*sq5)
          sqy(ig,1,2) = -2*iymx*sq5*z
          sqy(ig,2,2) = 2*ci*iymx*sq5*z
          sqy(ig,3,2) = (5*z**2+5*iymx**2-1)/sq5
          sqy(ig,1,3) = iymx*sq5*z*(3*z**2-1)
          sqy(ig,2,3) = -ci*iymx*sq5*z*(3*z**2-1)
          sqy(ig,3,3) = -sq5*(105*z**4+252*iymx**2*z**2-70*z**2-28*iymx**2+5)/56.0d0
       end do
    case (294)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9)/7.0d0
          sqy(ig,2,1) = 9.0d0*ci/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2-1)/2.0d0
          sqy(ig,2,2) = -ci*(5*z**2-1)/2.0d0
          sqy(ig,3,2) = -5*iymx*z
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = 5.0d0*ci*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = 5.0d0*iymx*z*(3*z**2-1)/2.0d0
       end do
    case (295)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*iymx**3/22.0d0
          sqy(ig,2,3) = (-15.0d0)*ci*iymx**3/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 15.0d0*iymx**3*(22*z**2-33*iymx**2-2)/44.0d0
          sqy(ig,2,4) = (-15.0d0)*ci*iymx**3*(22*z**2-33*iymx**2-2)/44.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**4*z/4.0d0
       end do
    case (296)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*iymx**2*sq5*z/22.0d0
          sqy(ig,2,3) = 9.0d0*ci*iymx**2*sq5*z/22.0d0
          sqy(ig,3,3) = 3.0d0*iymx**3*sq5/22.0d0
          sqy(ig,1,4) = (-15.0d0)*iymx**2*sq5*z*(33*z**2-55*iymx**2-9)/88.0d0
          sqy(ig,2,4) = 15.0d0*ci*iymx**2*sq5*z*(33*z**2-55*iymx**2-9)/88.0d0
          sqy(ig,3,4) = 15.0d0*iymx**3*sq5*(33*z**2-11*iymx**2-3)/88.0d0
       end do
    case (297)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq10/7.0d0
          sqy(ig,2,2) = ci*iymx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*iymx*(7*z**2-28*iymx**2-1)/(154.0d0*sq10)
          sqy(ig,2,3) = 45.0d0*ci*iymx*(7*z**2-28*iymx**2-1)/(154.0d0*sq10)
          sqy(ig,3,3) = 45.0d0*iymx**2*z/(22.0d0*sq10)
          sqy(ig,1,4) = 5.0d0*iymx*sq5*(33*z**4-66*iymx**2*z**2-18*z**2+6*iymx**2+1)/(22.0d0*sq2)
          sqy(ig,2,4) = (-5.0d0)*ci*iymx*sq5*(33*z**4-66*iymx**2*z**2-18*z**2+6*iymx**2+1)/(22.0d0*sq2)
          sqy(ig,3,4) = (-15.0d0)*iymx**2*sq5*z*(22*z**2-11*iymx**2-6)/(22.0d0*sq2)
       end do
    case (298)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq10*z/7.0d0
          sqy(ig,2,2) = -ci*sq10*z/7.0d0
          sqy(ig,3,2) = -iymx*sq10/7.0d0
          sqy(ig,1,3) = 3.0d0*sq5*z*(56*z**2-189*iymx**2-24)/(154.0d0*sq2)
          sqy(ig,2,3) = (-3.0d0)*ci*sq5*z*(56*z**2-189*iymx**2-24)/(154.0d0*sq2)
          sqy(ig,3,3) = (-9.0d0)*iymx*sq5*(56*z**2-21*iymx**2-8)/(154.0d0*sq2)
          sqy(ig,1,4) = (-5.0d0)*sq5*z*(33*z**4-99*iymx**2*z**2-30*z**2+27*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,2,4) = 5.0d0*ci*sq5*z*(33*z**4-99*iymx**2*z**2-30*z**2+27*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,3,4) = 5.0d0*iymx*sq5*(165*z**4-99*iymx**2*z**2-90*z**2+9*iymx**2+5)/(44.0d0*sq2)
       end do
    case (299)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*iymx*sq5/7.0d0
          sqy(ig,2,2) = 2.0d0*ci*iymx*sq5/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 27.0d0*iymx*sq5*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = (-27.0d0)*ci*iymx*sq5*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = 3.0d0*sq5*z*(35*z**2-18*iymx**2-15)/22.0d0
          sqy(ig,1,4) = (-5.0d0)*iymx*sq5*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,2,4) = 5.0d0*ci*iymx*sq5*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,3,4) = (-15.0d0)*sq5*z*(33*z**4-22*iymx**2*z**2-30*z**2+6*iymx**2+5)/44.0d0
       end do
    case (300)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 10.0d0*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 5.0d0*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = (-45.0d0)*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-135.0d0)*(iypx-iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 5.0d0*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 25.0d0*(iypx-iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (301)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (302)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iypx**2*sq35/4.0d0
          sqy(ig,2,1) = 3.0d0*ci*iypx**2*sq35/4.0d0
          sqy(ig,3,1) = 0
       end do
    case (303)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*iypx*sq35/7.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*iypx*sq35/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq35*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = ci*iypx*sq35*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = iypx**2*sq35*z/2.0d0
       end do
    case (304)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iypx**2*sq35*z/4.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iypx**2*sq35*z/4.0d0
          sqy(ig,3,2) = -iypx**3*sq35/4.0d0
       end do
    case (305)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (306)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iypx*sq35/(7.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci*iypx*sq35/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq35*(7*z**2-1)/sq2/14.0d0
          sqy(ig,2,2) = -ci*iypx*sq35*(7*z**2-1)/sq2/14.0d0
          sqy(ig,3,2) = -iypx**2*sq35*z/sq2/2.0d0
       end do
    case (307)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iypx**2*sq35*z/(2.0d0*sq2)
          sqy(ig,2,2) = 3.0d0*ci*iypx**2*sq35*z/(2.0d0*sq2)
          sqy(ig,3,2) = iypx**3*sq35/sq2/2.0d0
       end do
    case (308)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx**3*sq105/sq2
          sqy(ig,2,2) = -ci*iypx**3*sq105/sq2
          sqy(ig,3,2) = 0
       end do
    case (309)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq42/(7.0d0*sq5)
          sqy(ig,2,1) = (-3.0d0)*ci*sq42/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq42*(5*z**2-1)/sq5/6.0d0
          sqy(ig,2,2) = ci*sq42*(5*z**2-1)/sq5/6.0d0
          sqy(ig,3,2) = iypx*sq210*z/3.0d0
          sqy(ig,1,3) = -sq35*(21*z**4-14*z**2+1)/sq6/28.0d0
          sqy(ig,2,3) = -ci*sq35*(21*z**4-14*z**2+1)/sq6/28.0d0
          sqy(ig,3,3) = -iypx*sq35*z*(3*z**2-1)/sq6
       end do
    case (310)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq35*z/sq2
          sqy(ig,2,2) = -ci*iypx*sq35*z/sq2
          sqy(ig,3,2) = -iypx**2*sq35/sq2/2.0d0
          sqy(ig,1,3) = iypx*sq35*z*(3*z**2-1)/sq2/2.0d0
          sqy(ig,2,3) = ci*iypx*sq35*z*(3*z**2-1)/sq2/2.0d0
          sqy(ig,3,3) = iypx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
       end do
    case (311)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx**2*sq35/sq2/2.0d0
          sqy(ig,2,2) = ci*iypx**2*sq35/sq2/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -iypx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,2,3) = -ci*iypx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,3,3) = (-3.0d0)*iypx**3*sq35*z/(2.0d0*sq2)
       end do
    case (312)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3*iypx**3*sq35*z/sq6
          sqy(ig,2,3) = 3*ci*iypx**3*sq35*z/sq6
          sqy(ig,3,3) = 3.0d0*iypx**4*sq35/(4.0d0*sq6)
       end do
    case (313)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
       end do
    case (314)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq42/(14.0d0*sq5)
          sqy(ig,2,1) = 3.0d0*ci*sq42/(14.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq42*(5*z**2-1)/sq5/12.0d0
          sqy(ig,2,2) = -ci*sq42*(5*z**2-1)/sq5/12.0d0
          sqy(ig,3,2) = -iypx*sq210*z/6.0d0
          sqy(ig,1,3) = sq35*(21*z**4-14*z**2+1)/sq6/56.0d0
          sqy(ig,2,3) = ci*sq35*(21*z**4-14*z**2+1)/sq6/56.0d0
          sqy(ig,3,3) = iypx*sq35*z*(3*z**2-1)/sq6/2.0d0
       end do
    case (315)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq105*z/3.0d0
          sqy(ig,2,2) = ci*iypx*sq105*z/3.0d0
          sqy(ig,3,2) = iypx**2*sq105/6.0d0
          sqy(ig,1,3) = -iypx*sq105*z*(3*z**2-1)/6.0d0
          sqy(ig,2,3) = -ci*iypx*sq105*z*(3*z**2-1)/6.0d0
          sqy(ig,3,3) = -iypx**2*sq105*(3*z-1)*(3*z+1)/12.0d0
       end do
    case (316)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx**2*sq105/4.0d0
          sqy(ig,2,2) = -ci*iypx**2*sq105/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = iypx**2*sq105*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,2,3) = ci*iypx**2*sq105*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,3,3) = 3.0d0*iypx**3*sq105*z/4.0d0
       end do
    case (317)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -iypx**3*sq210*z
          sqy(ig,2,3) = -ci*iypx**3*sq210*z
          sqy(ig,3,3) = (-3.0d0)*iypx**4*sq35/(2.0d0*sq6)
       end do
    case (318)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 75.0d0*iypx**4*sq7/(8.0d0*sq6)
          sqy(ig,2,3) = 75.0d0*ci*iypx**4*sq7/(8.0d0*sq6)
          sqy(ig,3,3) = 0
       end do
    case (319)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 30*z/sq42
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-45.0d0)*sq6*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 105.0d0*z*(33*z**4-30*z**2+5)/(44.0d0*sq42)
       end do
    case (320)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*sq30*z/(6.0d0*sq7)
          sqy(ig,2,2) = (-5.0d0)*ci*sq30*z/(6.0d0*sq7)
          sqy(ig,3,2) = (-5.0d0)*iypx*sq30/(6.0d0*sq7)
          sqy(ig,1,3) = 15.0d0*sq30*z*(7*z**2-3)/(44.0d0*sq7)
          sqy(ig,2,3) = 15.0d0*ci*sq30*z*(7*z**2-3)/(44.0d0*sq7)
          sqy(ig,3,3) = 45.0d0*iypx*sq30*(7*z**2-1)/(44.0d0*sq7)
          sqy(ig,1,4) = (-5.0d0)*sq210*z*(33*z**4-30*z**2+5)/528.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*sq210*z*(33*z**4-30*z**2+5)/528.0d0
          sqy(ig,3,4) = (-25.0d0)*iypx*sq210*(33*z**4-18*z**2+1)/528.0d0
       end do
    case (321)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*iypx*sq15/(3.0d0*sq7)
          sqy(ig,2,2) = 2.0d0*ci*iypx*sq15/(3.0d0*sq7)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*iypx*sq15*(7*z**2-1)/(11.0d0*sq7)
          sqy(ig,2,3) = (-9.0d0)*ci*iypx*sq15*(7*z**2-1)/(11.0d0*sq7)
          sqy(ig,3,3) = (-9.0d0)*iypx**2*sq105*z/11.0d0
          sqy(ig,1,4) = 5.0d0*iypx*sq105*(33*z**4-18*z**2+1)/132.0d0
          sqy(ig,2,4) = 5.0d0*ci*iypx*sq105*(33*z**4-18*z**2+1)/132.0d0
          sqy(ig,3,4) = 5.0d0*iypx**2*sq105*z*(11*z**2-3)/22.0d0
       end do
    case (322)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 27.0d0*iypx**2*sq105*z/44.0d0
          sqy(ig,2,3) = 27.0d0*ci*iypx**2*sq105*z/44.0d0
          sqy(ig,3,3) = 9.0d0*iypx**3*sq105/44.0d0
          sqy(ig,1,4) = (-15.0d0)*iypx**2*sq105*z*(11*z**2-3)/88.0d0
          sqy(ig,2,4) = (-15.0d0)*ci*iypx**2*sq105*z*(11*z**2-3)/88.0d0
          sqy(ig,3,4) = (-15.0d0)*iypx**3*sq105*(11*z**2-1)/88.0d0
       end do
    case (323)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*iypx**3*sq105/(11.0d0*sq2)
          sqy(ig,2,3) = (-3.0d0)*ci*iypx**3*sq105/(11.0d0*sq2)
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 5.0d0*iypx**3*sq105*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,2,4) = 5.0d0*ci*iypx**3*sq105*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,3,4) = 5.0d0*iypx**4*sq105*z/(4.0d0*sq2)
       end do
    case (324)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-75.0d0)*iypx**4*sq7*z/(8.0d0*sq6)
          sqy(ig,2,4) = (-75.0d0)*ci*iypx**4*sq7*z/(8.0d0*sq6)
          sqy(ig,3,4) = (-15.0d0)*iypx**5*sq7/(8.0d0*sq6)
       end do
    case (325)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 0
       end do
    case (326)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iypx**2*sq5/4.0d0
          sqy(ig,2,1) = 3.0d0*ci*iypx**2*sq5/4.0d0
          sqy(ig,3,1) = 0
       end do
    case (327)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3*iypx*sq5*z
          sqy(ig,2,1) = 3*ci*iypx*sq5*z
          sqy(ig,3,1) = 3.0d0*iypx**2*sq5/2.0d0
       end do
    case (328)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-6.0d0)*sq5*z/7.0d0
          sqy(ig,2,1) = (-6.0d0)*ci*sq5*z/7.0d0
          sqy(ig,3,1) = (-6.0d0)*iypx*sq5/7.0d0
          sqy(ig,1,2) = 3.0d0*sq5*z*(14*z**2+7*iypx**2-6)/28.0d0
          sqy(ig,2,2) = 3.0d0*ci*sq5*z*(14*z**2+7*iypx**2-6)/28.0d0
          sqy(ig,3,2) = iypx*sq5*(126*z**2+7*iypx**2-18)/28.0d0
       end do
    case (329)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*iypx*sq5/7.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*iypx*sq5/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq5*(21*z**2+7*iypx**2-3)/7.0d0
          sqy(ig,2,2) = -ci*iypx*sq5*(21*z**2+7*iypx**2-3)/7.0d0
          sqy(ig,3,2) = -3*iypx**2*sq5*z
       end do
    case (330)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iypx*sq15/(7.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci*iypx*sq15/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq15*(7*z**2-1)/sq2/14.0d0
          sqy(ig,2,2) = -ci*iypx*sq15*(7*z**2-1)/sq2/14.0d0
          sqy(ig,3,2) = -iypx**2*sq15*z/sq2/2.0d0
       end do
    case (331)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq10*z/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq10*z/7.0d0
          sqy(ig,3,1) = 3.0d0*iypx*sq10/7.0d0
          sqy(ig,1,2) = (-3.0d0)*sq5*z*(7*z**2-7*iypx**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = (-3.0d0)*ci*sq5*z*(7*z**2-7*iypx**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = -iypx*sq5*(63*z**2-7*iypx**2-9)/sq2/14.0d0
       end do
    case (332)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iypx*sq10/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*iypx*sq10/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq5*(42*z**2-7*iypx**2-6)/sq2/7.0d0
          sqy(ig,2,2) = ci*iypx*sq5*(42*z**2-7*iypx**2-6)/sq2/7.0d0
          sqy(ig,3,2) = 3*iypx**2*sq10*z
       end do
    case (333)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*iypx**2*sq15*z/(2.0d0*sq2)
          sqy(ig,2,2) = (-9.0d0)*ci*iypx**2*sq15*z/(2.0d0*sq2)
          sqy(ig,3,2) = (-3.0d0)*iypx**3*sq15/(2.0d0*sq2)
       end do
    case (334)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-6.0d0)*sq6/(7.0d0*sq5)
          sqy(ig,1,2) = iypx*sq15*z/sq2/3.0d0
          sqy(ig,2,2) = ci*iypx*sq15*z/sq2/3.0d0
          sqy(ig,3,2) = sq3*(120*z**2+5*iypx**2-24)/sq10/6.0d0
          sqy(ig,1,3) = -iypx*sq10*z*(3*z**2-1)/sq3/4.0d0
          sqy(ig,2,3) = -ci*iypx*sq10*z*(3*z**2-1)/sq3/4.0d0
          sqy(ig,3,3) = -sq10*(630*z**4+63*iypx**2*z**2-420*z**2-7*iypx**2+30)/sq3/56.0d0
       end do
    case (335)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*sq2/(7.0d0*sq5)
          sqy(ig,2,1) = (-9.0d0)*ci*sq2/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(15*z**2+5*iypx**2-3)/sq10/2.0d0
          sqy(ig,2,2) = -ci*(15*z**2+5*iypx**2-3)/sq10/2.0d0
          sqy(ig,3,2) = -15*iypx*z/sq10
          sqy(ig,1,3) = sq5*(126*z**4+63*iypx**2*z**2-84*z**2-7*iypx**2+6)/sq2/28.0d0
          sqy(ig,2,3) = ci*sq5*(126*z**4+63*iypx**2*z**2-84*z**2-7*iypx**2+6)/sq2/28.0d0
          sqy(ig,3,3) = 3.0d0*iypx*sq5*z*(12*z**2+iypx**2-4)/(2.0d0*sq2)
       end do
    case (336)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -3*iypx*sq5*z*(3*z**2+iypx**2-1)/sq2
          sqy(ig,2,3) = -3*ci*iypx*sq5*z*(3*z**2+iypx**2-1)/sq2
          sqy(ig,3,3) = (-3.0d0)*iypx**2*sq5*(18*z**2+iypx**2-2)/(4.0d0*sq2)
       end do
    case (337)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx**2*sq30/4.0d0
          sqy(ig,2,2) = ci*iypx**2*sq30/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*iypx**2*(18*z**2+5*iypx**2-2)/(4.0d0*sq30)
          sqy(ig,2,3) = 15.0d0*ci*iypx**2*(18*z**2+5*iypx**2-2)/(4.0d0*sq30)
          sqy(ig,3,3) = 45*iypx**3*z/sq30
       end do
    case (338)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq6/14.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq6/14.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(5*z**2-1)/sq6/2.0d0
          sqy(ig,2,2) = -ci*(5*z**2-1)/sq6/2.0d0
          sqy(ig,3,2) = -5*iypx*z/sq6
          sqy(ig,1,3) = 5.0d0*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,2,3) = 5.0d0*ci*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,3,3) = 5.0d0*iypx*z*(3*z**2-1)/(2.0d0*sq6)
       end do
    case (339)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*sq6/(7.0d0*sq5)
          sqy(ig,1,2) = iypx*sq30*z/3.0d0
          sqy(ig,2,2) = ci*iypx*sq30*z/3.0d0
          sqy(ig,3,2) = -sq3*(30*z**2-5*iypx**2-6)/sq10/3.0d0
          sqy(ig,1,3) = -iypx*sq10*z*(3*z**2-1)/sq3/2.0d0
          sqy(ig,2,3) = -ci*iypx*sq10*z*(3*z**2-1)/sq3/2.0d0
          sqy(ig,3,3) = sq10*(315*z**4-126*iypx**2*z**2-210*z**2+14*iypx**2+15)/sq3/56.0d0
       end do
    case (340)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*sq3/(7.0d0*sq5)
          sqy(ig,2,1) = 6.0d0*ci*sq3/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq3*(10*z**2-5*iypx**2-2)/sq5/4.0d0
          sqy(ig,2,2) = ci*sq3*(10*z**2-5*iypx**2-2)/sq5/4.0d0
          sqy(ig,3,2) = iypx*sq15*z
          sqy(ig,1,3) = -sq15*(84*z**4-63*iypx**2*z**2-56*z**2+7*iypx**2+4)/56.0d0
          sqy(ig,2,3) = -ci*sq15*(84*z**4-63*iypx**2*z**2-56*z**2+7*iypx**2+4)/56.0d0
          sqy(ig,3,3) = -iypx*sq15*z*(24*z**2-3*iypx**2-8)/4.0d0
       end do
    case (341)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = iypx*sq15*z*(9*z**2-2*iypx**2-3)/2.0d0
          sqy(ig,2,3) = ci*iypx*sq15*z*(9*z**2-2*iypx**2-3)/2.0d0
          sqy(ig,3,3) = iypx**2*sq15*(27*z**2-iypx**2-3)/4.0d0
       end do
    case (342)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx**2*sq30/2.0d0
          sqy(ig,2,2) = -ci*iypx**2*sq30/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*iypx**2*(72*z**2-5*iypx**2-8)/(8.0d0*sq30)
          sqy(ig,2,3) = (-15.0d0)*ci*iypx**2*(72*z**2-5*iypx**2-8)/(8.0d0*sq30)
          sqy(ig,3,3) = -3*iypx**3*sq30*z
       end do
    case (343)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*iypx**3*sq6*z/2.0d0
          sqy(ig,2,3) = 15.0d0*ci*iypx**3*sq6*z/2.0d0
          sqy(ig,3,3) = 15.0d0*iypx**4*sq6/8.0d0
       end do
    case (344)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-25.0d0)*z/(7.0d0*sq6)
          sqy(ig,2,2) = 5*ci*z/sq6
          sqy(ig,3,2) = 5.0d0*(iypx+6*iymx)/(7.0d0*sq6)
          sqy(ig,1,3) = 75.0d0*sq6*z*(7*z**2-3)/308.0d0
          sqy(ig,2,3) = (-15.0d0)*ci*sq6*z*(7*z**2-3)/44.0d0
          sqy(ig,3,3) = (-45.0d0)*(iypx+6*iymx)*sq6*(7*z**2-1)/308.0d0
          sqy(ig,1,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
          sqy(ig,2,4) = 35.0d0*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
          sqy(ig,3,4) = 25.0d0*(iypx+6*iymx)*(33*z**4-18*z**2+1)/(88.0d0*sq6)
       end do
    case (345)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*iypx*sq5/(7.0d0*sq6)
          sqy(ig,2,2) = (-2.0d0)*ci*iypx*sq5/(7.0d0*sq6)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iypx*sq15*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = 9.0d0*ci*iypx*sq15*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*sq15*z*(35*z**2+3*iypx**2-15)/(11.0d0*sq2)
          sqy(ig,1,4) = (-5.0d0)*iypx*sq5*(33*z**4-18*z**2+1)/(44.0d0*sq6)
          sqy(ig,2,4) = (-5.0d0)*ci*iypx*sq5*(33*z**4-18*z**2+1)/(44.0d0*sq6)
          sqy(ig,3,4) = (-15.0d0)*sq5*z*(99*z**4+11*iypx**2*z**2-90*z**2-3*iypx**2+15)/(22.0d0*sq6)
       end do
    case (346)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*sq15*z/7.0d0
          sqy(ig,2,2) = (-2.0d0)*ci*sq15*z/7.0d0
          sqy(ig,3,2) = (-2.0d0)*iypx*sq15/7.0d0
          sqy(ig,1,3) = (-3.0d0)*sq15*z*(112*z**2+63*iypx**2-48)/308.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*sq15*z*(112*z**2+63*iypx**2-48)/308.0d0
          sqy(ig,3,3) = (-9.0d0)*iypx*sq15*(112*z**2+7*iypx**2-16)/308.0d0
          sqy(ig,1,4) = 5.0d0*sq15*z*(66*z**4+33*iypx**2*z**2-60*z**2-9*iypx**2+10)/88.0d0
          sqy(ig,2,4) = 5.0d0*ci*sq15*z*(66*z**4+33*iypx**2*z**2-60*z**2-9*iypx**2+10)/88.0d0
          sqy(ig,3,4) = 5.0d0*iypx*sq15*(330*z**4+33*iypx**2*z**2-180*z**2-3*iypx**2+10)/88.0d0
       end do
    case (347)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*iypx*sq15/7.0d0
          sqy(ig,2,2) = 2.0d0*ci*iypx*sq15/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*iypx*sq15*(21*z**2+14*iypx**2-3)/154.0d0
          sqy(ig,2,3) = 3.0d0*ci*iypx*sq15*(21*z**2+14*iypx**2-3)/154.0d0
          sqy(ig,3,3) = 9.0d0*iypx**2*sq15*z/22.0d0
          sqy(ig,1,4) = (-5.0d0)*iypx*sq15*(33*z**4+11*iypx**2*z**2-18*z**2-iypx**2+1)/22.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*iypx*sq15*(33*z**4+11*iypx**2*z**2-18*z**2-iypx**2+1)/22.0d0
          sqy(ig,3,4) = (-5.0d0)*iypx**2*sq15*z*(132*z**2+11*iypx**2-36)/44.0d0
       end do
    case (348)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iypx**2*sq15*z/(11.0d0*sq2)
          sqy(ig,2,3) = 9.0d0*ci*iypx**2*sq15*z/(11.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*iypx**3*sq15/(11.0d0*sq2)
          sqy(ig,1,4) = 15.0d0*iypx**2*sq5*z*(198*z**2+55*iypx**2-54)/(88.0d0*sq6)
          sqy(ig,2,4) = 15.0d0*ci*iypx**2*sq5*z*(198*z**2+55*iypx**2-54)/(88.0d0*sq6)
          sqy(ig,3,4) = 5.0d0*iypx**3*sq15*sq2*(198*z**2+11*iypx**2-18)/176.0d0
       end do
    case (349)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*iypx**3*sq6/22.0d0
          sqy(ig,2,3) = (-15.0d0)*ci*iypx**3*sq6/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-15.0d0)*iypx**3*sq6*(44*z**2+11*iypx**2-4)/88.0d0
          sqy(ig,2,4) = (-15.0d0)*ci*iypx**3*sq6*(44*z**2+11*iypx**2-4)/88.0d0
          sqy(ig,3,4) = (-15.0d0)*iypx**4*sq6*z/4.0d0
       end do
    case (350)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -5*z/sq7
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 45.0d0*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-5.0d0)*sq7*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (351)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 10.0d0*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 5.0d0*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = (-45.0d0)*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-135.0d0)*(iypx-iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 5.0d0*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 25.0d0*(iypx-iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (352)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iypx*sq15*z
          sqy(ig,2,1) = ci*iypx*sq15*z
          sqy(ig,3,1) = iypx**2*sq15/2.0d0
       end do
    case (353)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq15*(5*z**2-1)/4.0d0
          sqy(ig,2,1) = ci*sq15*(5*z**2-1)/4.0d0
          sqy(ig,3,1) = 5.0d0*iypx*sq15*z/2.0d0
       end do
    case (354)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iypx*sq15/7.0d0
          sqy(ig,2,1) = ci*iypx*sq15/7.0d0
          sqy(ig,3,1) = (-6.0d0)*sq15*z/7.0d0
          sqy(ig,1,2) = iypx*sq15*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = ci*iypx*sq15*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = sq15*z*(35*z**2+7*iypx**2-15)/7.0d0
       end do
    case (355)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-2.0d0)*sq15*z/7.0d0
          sqy(ig,2,1) = (-2.0d0)*ci*sq15*z/7.0d0
          sqy(ig,3,1) = (-2.0d0)*iypx*sq15/7.0d0
          sqy(ig,1,2) = -sq15*z*(35*z**2+42*iypx**2-15)/28.0d0
          sqy(ig,2,2) = -ci*sq15*z*(35*z**2+42*iypx**2-15)/28.0d0
          sqy(ig,3,2) = -iypx*sq15*(105*z**2+14*iypx**2-15)/28.0d0
       end do
    case (356)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq10*z/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq10*z/7.0d0
          sqy(ig,3,1) = 3.0d0*iypx*sq10/7.0d0
          sqy(ig,1,2) = (-3.0d0)*sq10*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq10*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = (-9.0d0)*iypx*sq10*(7*z**2-1)/28.0d0
       end do
    case (357)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iypx*sq30/7.0d0
          sqy(ig,2,1) = ci*iypx*sq30/7.0d0
          sqy(ig,3,1) = 3.0d0*sq30*z/7.0d0
          sqy(ig,1,2) = iypx*sq30*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = ci*iypx*sq30*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = -sq15*z*(35*z**2-14*iypx**2-15)/sq2/7.0d0
       end do
    case (358)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*sq30*z/7.0d0
          sqy(ig,2,1) = 2.0d0*ci*sq30*z/7.0d0
          sqy(ig,3,1) = 2.0d0*iypx*sq30/7.0d0
          sqy(ig,1,2) = sq15*z*(35*z**2-21*iypx**2-15)/sq2/14.0d0
          sqy(ig,2,2) = ci*sq15*z*(35*z**2-21*iypx**2-15)/sq2/14.0d0
          sqy(ig,3,2) = iypx*sq15*(105*z**2-7*iypx**2-15)/sq2/14.0d0
       end do
    case (359)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iypx*sq5/(7.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci*iypx*sq5/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-15.0d0)*iypx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,2) = (-15.0d0)*ci*iypx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,2) = (-15.0d0)*iypx**2*sq5*z/(2.0d0*sq2)
       end do
    case (360)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*sq2/(7.0d0*sq5)
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*(5*z**2-1)/(2.0d0*sq10)
          sqy(ig,2,2) = 5.0d0*ci*(5*z**2-1)/(2.0d0*sq10)
          sqy(ig,3,2) = (iypx+4*iymx)*sq10*z/2.0d0
          sqy(ig,1,3) = 3.0d0*sq10*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = -ci*sq10*(21*z**4-14*z**2+1)/8.0d0
          sqy(ig,3,3) = -(2*iypx+5*iymx)*sq10*z*(3*z**2-1)/2.0d0
       end do
    case (361)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-6.0d0)*sq30/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -sq6*(5*z**2-1)/sq5/2.0d0
          sqy(ig,1,3) = iypx*sq30*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = ci*iypx*sq30*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = sq30*(525*z**4+126*iypx**2*z**2-350*z**2-14*iypx**2+25)/56.0d0
       end do
    case (362)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq6/(7.0d0*sq5)
          sqy(ig,2,1) = (-3.0d0)*ci*sq6/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*(5*z**2+5*iypx**2-1)/sq10/2.0d0
          sqy(ig,2,2) = -ci*sq3*(5*z**2+5*iypx**2-1)/sq10/2.0d0
          sqy(ig,3,2) = -iypx*sq30*z/2.0d0
          sqy(ig,1,3) = -sq30*(105*z**4+126*iypx**2*z**2-70*z**2-14*iypx**2+5)/56.0d0
          sqy(ig,2,3) = -ci*sq30*(105*z**4+126*iypx**2*z**2-70*z**2-14*iypx**2+5)/56.0d0
          sqy(ig,3,3) = -iypx*sq30*z*(15*z**2+3*iypx**2-5)/2.0d0
       end do
    case (363)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq5*z/sq2
          sqy(ig,2,2) = ci*iypx*sq5*z/sq2
          sqy(ig,3,2) = iypx**2*sq5/sq2/2.0d0
          sqy(ig,1,3) = iypx*sq5*z*(15*z**2+12*iypx**2-5)/sq2/2.0d0
          sqy(ig,2,3) = ci*iypx*sq5*z*(15*z**2+12*iypx**2-5)/sq2/2.0d0
          sqy(ig,3,3) = iypx**2*sq5*(45*z**2+6*iypx**2-5)/sq2/4.0d0
       end do
    case (364)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*sq2/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -sq2*(5*z**2-1)
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 25.0d0*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (365)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0/(7.0d0*sq2*sq5)
          sqy(ig,2,1) = 3.0d0*ci*sq5/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2*(5*z**2-1)/sq10
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (iypx-iymx)*sq10*z
          sqy(ig,1,3) = (-13.0d0)*sq10*(21*z**4-14*z**2+1)/112.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*sq10*(21*z**4-14*z**2+1)/112.0d0
          sqy(ig,3,3) = -(8*iypx-5*iymx)*sq10*z*(3*z**2-1)/4.0d0
       end do
    case (366)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 12.0d0/(7.0d0*sq5)
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (5*z**2-1)/sq5
          sqy(ig,1,3) = 3.0d0*iypx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = 3.0d0*ci*iypx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = -sq5*(525*z**4-189*iypx**2*z**2-350*z**2+21*iypx**2+25)/28.0d0
       end do
    case (367)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0/(7.0d0*sq5)
          sqy(ig,2,1) = 9.0d0*ci/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (15*z**2-10*iypx**2-3)/sq5/4.0d0
          sqy(ig,2,2) = ci*(15*z**2-10*iypx**2-3)/sq5/4.0d0
          sqy(ig,3,2) = 3.0d0*iypx*sq5*z/2.0d0
          sqy(ig,1,3) = sq5*(315*z**4-252*iypx**2*z**2-210*z**2+28*iypx**2+15)/56.0d0
          sqy(ig,2,3) = ci*sq5*(315*z**4-252*iypx**2*z**2-210*z**2+28*iypx**2+15)/56.0d0
          sqy(ig,3,3) = 3.0d0*iypx*sq5*z*(15*z**2-2*iypx**2-5)/2.0d0
       end do
    case (368)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq10*z
          sqy(ig,2,2) = -ci*iypx*sq10*z
          sqy(ig,3,2) = -iypx**2*sq5/sq2
          sqy(ig,1,3) = -iypx*sq5*z*(15*z**2-3*iypx**2-5)/sq2
          sqy(ig,2,3) = -ci*iypx*sq5*z*(15*z**2-3*iypx**2-5)/sq2
          sqy(ig,3,3) = -iypx**2*sq5*(90*z**2-3*iypx**2-10)/sq2/4.0d0
       end do
    case (369)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*iypx**2/(2.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*ci*iypx**2/(2.0d0*sq2)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 25.0d0*iypx**2*(3*z-1)*(3*z+1)/(8.0d0*sq2)
          sqy(ig,2,3) = 25.0d0*ci*iypx**2*(3*z-1)*(3*z+1)/(8.0d0*sq2)
          sqy(ig,3,3) = 75.0d0*iypx**3*z/(4.0d0*sq2)
       end do
    case (370)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*iymx*sq2/7.0d0
          sqy(ig,2,2) = 5.0d0*ci*iymx*sq2/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 135.0d0*iymx*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = (-135.0d0)*ci*iymx*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = (-15.0d0)*z*(7*z**2+9*iymx**2-3)/(11.0d0*sq2)
          sqy(ig,1,4) = (-25.0d0)*iymx*(33*z**4-18*z**2+1)/(44.0d0*sq2)
          sqy(ig,2,4) = 25.0d0*ci*iymx*(33*z**4-18*z**2+1)/(44.0d0*sq2)
          sqy(ig,3,4) = 15.0d0*z*(33*z**4+55*iymx**2*z**2-30*z**2-15*iymx**2+5)/(22.0d0*sq2)
       end do
    case (371)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*sq10*z/14.0d0
          sqy(ig,2,2) = ci*sq10*z/2.0d0
          sqy(ig,3,2) = (2*iypx+5*iymx)*sq10/14.0d0
          sqy(ig,1,3) = (-9.0d0)*sq10*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq10*z*(7*z**2-3)/11.0d0
          sqy(ig,3,3) = 9.0d0*(2*iypx+5*iymx)*sq10*(7*z**2-1)/77.0d0
          sqy(ig,1,4) = 15.0d0*sq10*z*(33*z**4-30*z**2+5)/176.0d0
          sqy(ig,2,4) = (-35.0d0)*ci*sq10*z*(33*z**4-30*z**2+5)/176.0d0
          sqy(ig,3,4) = (-25.0d0)*(2*iypx+5*iymx)*sq10*(33*z**4-18*z**2+1)/176.0d0
       end do
    case (372)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*iypx*sq5/7.0d0
          sqy(ig,2,2) = (-2.0d0)*ci*iypx*sq5/7.0d0
          sqy(ig,3,2) = (-6.0d0)*sq5*z/7.0d0
          sqy(ig,1,3) = (-9.0d0)*iypx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*iypx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,3,3) = (-3.0d0)*sq5*z*(70*z**2+21*iypx**2-30)/154.0d0
          sqy(ig,1,4) = 5.0d0*iypx*sq5*(33*z**4-18*z**2+1)/22.0d0
          sqy(ig,2,4) = 5.0d0*ci*iypx*sq5*(33*z**4-18*z**2+1)/22.0d0
          sqy(ig,3,4) = 15.0d0*sq5*z*(165*z**4+44*iypx**2*z**2-150*z**2-12*iypx**2+25)/44.0d0
       end do
    case (373)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq5*z/7.0d0
          sqy(ig,2,2) = -ci*sq5*z/7.0d0
          sqy(ig,3,2) = -iypx*sq5/7.0d0
          sqy(ig,1,3) = (-9.0d0)*sq5*z*(35*z**2+28*iypx**2-15)/308.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*sq5*z*(35*z**2+28*iypx**2-15)/308.0d0
          sqy(ig,3,3) = (-3.0d0)*iypx*sq5*(315*z**2+28*iypx**2-45)/308.0d0
          sqy(ig,1,4) = (-5.0d0)*sq5*z*(165*z**4+198*iypx**2*z**2-150*z**2-54*iypx**2+25)/88.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*sq5*z*(165*z**4+198*iypx**2*z**2-150*z**2-54*iypx**2+25)/88.0d0
          sqy(ig,3,4) = (-5.0d0)*iypx*sq5*(825*z**4+198*iypx**2*z**2-450*z**2-18*iypx**2+25)/88.0d0
       end do
    case (374)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*iypx*sq10/7.0d0
          sqy(ig,2,2) = 2.0d0*ci*iypx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*iypx*sq5*(14*z**2+7*iypx**2-2)/(77.0d0*sq2)
          sqy(ig,2,3) = 15.0d0*ci*iypx*sq5*(14*z**2+7*iypx**2-2)/(77.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*iypx**2*sq10*z/11.0d0
          sqy(ig,1,4) = 5.0d0*iypx*sq5*(165*z**4+132*iypx**2*z**2-90*z**2-12*iypx**2+5)/(44.0d0*sq2)
          sqy(ig,2,4) = 5.0d0*ci*iypx*sq5*(165*z**4+132*iypx**2*z**2-90*z**2-12*iypx**2+5)/(44.0d0*sq2)
          sqy(ig,3,4) = 15.0d0*iypx**2*sq5*z*(55*z**2+11*iypx**2-15)/(22.0d0*sq2)
       end do
    case (375)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*iypx**2*z/(22.0d0*sq2)
          sqy(ig,2,3) = (-45.0d0)*ci*iypx**2*z/(22.0d0*sq2)
          sqy(ig,3,3) = (-15.0d0)*iypx**3/(22.0d0*sq2)
          sqy(ig,1,4) = (-75.0d0)*iypx**2*z*(33*z**2+22*iypx**2-9)/(88.0d0*sq2)
          sqy(ig,2,4) = (-75.0d0)*ci*iypx**2*z*(33*z**2+22*iypx**2-9)/(88.0d0*sq2)
          sqy(ig,3,4) = (-15.0d0)*iypx**3*(165*z**2+22*iypx**2-15)/(88.0d0*sq2)
       end do
    case (376)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5*z/sq21
          sqy(ig,2,2) = -5*ci*z/sq21
          sqy(ig,3,2) = -5*iymx/sq21
          sqy(ig,1,3) = (-15.0d0)*sq3*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,2,3) = 15.0d0*ci*sq3*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,3,3) = 45.0d0*iymx*sq3*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,1,4) = 5.0d0*sq21*z*(33*z**4-30*z**2+5)/264.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*sq21*z*(33*z**4-30*z**2+5)/264.0d0
          sqy(ig,3,4) = (-25.0d0)*iymx*sq21*(33*z**4-18*z**2+1)/264.0d0
       end do
    case (377)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5.0d0*iymx/(7.0d0*sq3)
          sqy(ig,2,2) = (-5.0d0)*ci*iymx/(7.0d0*sq3)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*iymx*sq3*(7*z**2-1)/154.0d0
          sqy(ig,2,3) = 45.0d0*ci*iymx*sq3*(7*z**2-1)/154.0d0
          sqy(ig,3,3) = (-15.0d0)*sq3*z*(14*z**2-3*iymx**2-6)/22.0d0
          sqy(ig,1,4) = 25.0d0*iymx*(33*z**4-18*z**2+1)/(88.0d0*sq3)
          sqy(ig,2,4) = (-25.0d0)*ci*iymx*(33*z**4-18*z**2+1)/(88.0d0*sq3)
          sqy(ig,3,4) = 5.0d0*sq3*z*(198*z**4-55*iymx**2*z**2-180*z**2+15*iymx**2+30)/44.0d0
       end do
    case (378)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 10.0d0*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 5.0d0*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = 60.0d0*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 90.0d0*(iypx-iymx)*(7*z**2-1)/77.0d0
          sqy(ig,1,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-125.0d0)*(iypx-iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (379)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*(5*z**2-1)/4.0d0
          sqy(ig,2,1) = 3.0d0*ci*(5*z**2-1)/4.0d0
          sqy(ig,3,1) = 15.0d0*iypx*z/2.0d0
       end do
    case (380)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3*(5*z**2-1)
       end do
    case (381)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 12.0d0*z/7.0d0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 6.0d0*(iypx-iymx)/7.0d0
          sqy(ig,1,2) = (-5.0d0)*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = 5.0d0*ci*z*(7*z**2-3)/4.0d0
          sqy(ig,3,2) = 15.0d0*(3*iypx+4*iymx)*(7*z**2-1)/28.0d0
       end do
    case (382)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iypx/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*iypx/7.0d0
          sqy(ig,3,1) = (-18.0d0)*z/7.0d0
          sqy(ig,1,2) = (-15.0d0)*iypx*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = (-15.0d0)*ci*iypx*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = (-5.0d0)*z*(56*z**2+21*iypx**2-24)/14.0d0
       end do
    case (383)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 9.0d0*sq6*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-15.0d0)*sq3*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (384)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq2*z/7.0d0
          sqy(ig,2,1) = 9.0d0*ci*sq2*z/7.0d0
          sqy(ig,3,1) = 3.0d0*(2*iypx+iymx)*sq2/7.0d0
          sqy(ig,1,2) = 25.0d0*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = 5.0d0*ci*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = 15.0d0*(3*iypx-2*iymx)*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (385)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iypx/(7.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci*iypx/(7.0d0*sq2)
          sqy(ig,3,1) = 18.0d0*sq2*z/7.0d0
          sqy(ig,1,2) = (-15.0d0)*iypx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,2) = (-15.0d0)*ci*iypx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,2) = 5.0d0*z*(112*z**2-21*iypx**2-48)/(14.0d0*sq2)
       end do
    case (386)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq6*z/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq6*z/7.0d0
          sqy(ig,3,1) = 3.0d0*iypx*sq6/7.0d0
          sqy(ig,1,2) = (-5.0d0)*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,3,2) = (-15.0d0)*iypx*sq3*(7*z**2-1)/(7.0d0*sq2)
       end do
    case (387)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 6.0d0*sq6/35.0d0
          sqy(ig,1,2) = -8*iymx*z/sq6
          sqy(ig,2,2) = 8*ci*iymx*z/sq6
          sqy(ig,3,2) = (15*z**2+20*iymx**2-3)/sq6/5.0d0
          sqy(ig,1,3) = 10*iymx*z*(3*z**2-1)/sq6
          sqy(ig,2,3) = -10*ci*iymx*z*(3*z**2-1)/sq6
          sqy(ig,3,3) = (-5.0d0)*(315*z**4+252*iymx**2*z**2-210*z**2-28*iymx**2+15)/(28.0d0*sq6)
       end do
    case (388)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 18.0d0*sq2/35.0d0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2-1)/sq2/10.0d0
          sqy(ig,2,2) = ci*(5*z**2-1)/sq2/2.0d0
          sqy(ig,3,2) = (3*iypx+2*iymx)*z/sq2
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*ci*(21*z**4-14*z**2+1)/(4.0d0*sq2)
          sqy(ig,3,3) = 5*(3*iypx+4*iymx)*z*(3*z**2-1)/sq2
       end do
    case (389)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-18.0d0)*sq2/35.0d0
          sqy(ig,1,2) = -3*iypx*z/sq2
          sqy(ig,2,2) = -3*ci*iypx*z/sq2
          sqy(ig,3,2) = -(80*z**2+15*iypx**2-16)/sq2/10.0d0
          sqy(ig,1,3) = (-15.0d0)*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*ci*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*(420*z**4+189*iypx**2*z**2-280*z**2-21*iypx**2+20)/(28.0d0*sq2)
       end do
    case (390)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq6/35.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*sq6/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2-15*iypx**2-1)/sq6/5.0d0
          sqy(ig,2,2) = ci*(5*z**2-15*iypx**2-1)/sq6/5.0d0
          sqy(ig,3,2) = 2*iypx*z/sq6
          sqy(ig,1,3) = 5.0d0*(84*z**4+189*iypx**2*z**2-56*z**2-21*iypx**2+4)/(28.0d0*sq6)
          sqy(ig,2,3) = 5.0d0*ci*(84*z**4+189*iypx**2*z**2-56*z**2-21*iypx**2+4)/(28.0d0*sq6)
          sqy(ig,3,3) = 5.0d0*iypx*z*(24*z**2+9*iypx**2-8)/(2.0d0*sq6)
       end do
    case (391)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq30/70.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq30/70.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq30*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = -ci*sq30*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -iymx*sq30*z
          sqy(ig,1,3) = (-5.0d0)*sq30*(21*z**4-14*z**2+1)/112.0d0
          sqy(ig,2,3) = 5.0d0*ci*sq30*(21*z**4-14*z**2+1)/112.0d0
          sqy(ig,3,3) = 5.0d0*iymx*sq30*z*(3*z**2-1)/4.0d0
       end do
    case (392)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 12.0d0*sq6/35.0d0
          sqy(ig,1,2) = 2.0d0*iymx*sq6*z/3.0d0
          sqy(ig,2,2) = (-2.0d0)*ci*iymx*sq6*z/3.0d0
          sqy(ig,3,2) = sq2*(15*z**2-5*iymx**2-3)/sq3/5.0d0
          sqy(ig,1,3) = -5*iymx*z*(3*z**2-1)/sq6
          sqy(ig,2,3) = 5*ci*iymx*z*(3*z**2-1)/sq6
          sqy(ig,3,3) = (-5.0d0)*(315*z**4-63*iymx**2*z**2-210*z**2+7*iymx**2+15)/(14.0d0*sq6)
       end do
    case (393)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq3/35.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq3/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 13.0d0*(5*z**2-1)/(20.0d0*sq3)
          sqy(ig,2,2) = ci*(5*z**2-1)/sq3/4.0d0
          sqy(ig,3,2) = (9*iypx-4*iymx)*z/sq3/2.0d0
          sqy(ig,1,3) = 85.0d0*(21*z**4-14*z**2+1)/(56.0d0*sq3)
          sqy(ig,2,3) = 5.0d0*ci*(21*z**4-14*z**2+1)/(56.0d0*sq3)
          sqy(ig,3,3) = 5.0d0*(9*iypx-8*iymx)*z*(3*z**2-1)/(2.0d0*sq3)
       end do
    case (394)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 18.0d0*sq3/35.0d0
          sqy(ig,1,2) = -iypx*sq3*z
          sqy(ig,2,2) = -ci*iypx*sq3*z
          sqy(ig,3,2) = sq3*(40*z**2-5*iypx**2-8)/10.0d0
          sqy(ig,1,3) = (-5.0d0)*iypx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*iypx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = 5.0d0*sq3*(210*z**4-63*iypx**2*z**2-140*z**2+7*iypx**2+10)/28.0d0
       end do
    case (395)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*sq6/35.0d0
          sqy(ig,2,1) = 6.0d0*ci*sq6/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(20*z**2+15*iypx**2-4)/sq6/10.0d0
          sqy(ig,2,2) = -ci*(20*z**2+15*iypx**2-4)/sq6/10.0d0
          sqy(ig,3,2) = -4*iypx*z/sq6
          sqy(ig,1,3) = (-5.0d0)*(336*z**4-189*iypx**2*z**2-224*z**2+21*iypx**2+16)/(56.0d0*sq6)
          sqy(ig,2,3) = (-5.0d0)*ci*(336*z**4-189*iypx**2*z**2-224*z**2+21*iypx**2+16)/(56.0d0*sq6)
          sqy(ig,3,3) = (-5.0d0)*iypx*z*(96*z**2-9*iypx**2-32)/(4.0d0*sq6)
       end do
    case (396)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -4*iypx*sq5*z/sq6
          sqy(ig,2,2) = -4*ci*iypx*sq5*z/sq6
          sqy(ig,3,2) = -2*iypx**2*sq5/sq6
          sqy(ig,1,3) = 5*iypx*sq5*z*(3*z**2-1)/sq6
          sqy(ig,2,3) = 5*ci*iypx*sq5*z*(3*z**2-1)/sq6
          sqy(ig,3,3) = 5.0d0*iypx**2*sq5*(3*z-1)*(3*z+1)/(2.0d0*sq6)
       end do
    case (397)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq30*z/14.0d0
          sqy(ig,2,2) = -ci*sq30*z/14.0d0
          sqy(ig,3,2) = -iymx*sq30/14.0d0
          sqy(ig,1,3) = 3.0d0*sq30*z*(14*z**2+63*iymx**2-6)/154.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*sq30*z*(14*z**2+63*iymx**2-6)/154.0d0
          sqy(ig,3,3) = (-9.0d0)*iymx*sq30*(14*z**2+7*iymx**2-2)/154.0d0
          sqy(ig,1,4) = (-5.0d0)*sq30*z*(33*z**4+132*iymx**2*z**2-30*z**2-36*iymx**2+5)/176.0d0
          sqy(ig,2,4) = 5.0d0*ci*sq30*z*(33*z**4+132*iymx**2*z**2-30*z**2-36*iymx**2+5)/176.0d0
          sqy(ig,3,4) = 5.0d0*iymx*sq30*(165*z**4+132*iymx**2*z**2-90*z**2-12*iymx**2+5)/176.0d0
       end do
    case (398)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-10.0d0)*iymx*sq6/21.0d0
          sqy(ig,2,2) = 10.0d0*ci*iymx*sq6/21.0d0
          sqy(ig,3,2) = 3.0d0*sq6*z/7.0d0
          sqy(ig,1,3) = (-15.0d0)*iymx*sq3*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = 15.0d0*ci*iymx*sq3*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*sq3*z*(7*z**2+7*iymx**2-3)/(77.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*iymx*(33*z**4-18*z**2+1)/(11.0d0*sq6)
          sqy(ig,2,4) = (-25.0d0)*ci*iymx*(33*z**4-18*z**2+1)/(11.0d0*sq6)
          sqy(ig,3,4) = (-25.0d0)*sq3*z*(99*z**4+88*iymx**2*z**2-90*z**2-24*iymx**2+15)/(44.0d0*sq2)
       end do
    case (399)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -z/sq3/7.0d0
          sqy(ig,2,2) = ci*z/sq3
          sqy(ig,3,2) = (3*iypx+4*iymx)/sq3/7.0d0
          sqy(ig,1,3) = (-15.0d0)*sq3*z*(7*z**2-3)/308.0d0
          sqy(ig,2,3) = 15.0d0*ci*sq3*z*(7*z**2-3)/44.0d0
          sqy(ig,3,3) = 45.0d0*(3*iypx+4*iymx)*sq3*(7*z**2-1)/308.0d0
          sqy(ig,1,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,2,4) = 175.0d0*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,3,4) = 125.0d0*(3*iypx+4*iymx)*(33*z**4-18*z**2+1)/(88.0d0*sq3)
       end do
    case (400)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-4.0d0)*iypx*sq3/7.0d0
          sqy(ig,2,2) = (-4.0d0)*ci*iypx*sq3/7.0d0
          sqy(ig,3,2) = (-8.0d0)*sq3*z/7.0d0
          sqy(ig,1,3) = (-30.0d0)*iypx*sq3*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = (-30.0d0)*ci*iypx*sq3*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = (-30.0d0)*sq3*z*(21*z**2+7*iypx**2-9)/77.0d0
          sqy(ig,1,4) = (-25.0d0)*iypx*sq3*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,2,4) = (-25.0d0)*ci*iypx*sq3*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,3,4) = (-25.0d0)*sq3*z*(66*z**4+33*iypx**2*z**2-60*z**2-9*iypx**2+10)/22.0d0
       end do
    case (401)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*sq2*z/(7.0d0*sq3)
          sqy(ig,2,2) = 2.0d0*ci*sq2*z/(7.0d0*sq3)
          sqy(ig,3,2) = 2.0d0*iypx*sq2/(7.0d0*sq3)
          sqy(ig,1,3) = 15.0d0*sq3*z*(14*z**2+21*iypx**2-6)/(154.0d0*sq2)
          sqy(ig,2,3) = 15.0d0*ci*sq3*z*(14*z**2+21*iypx**2-6)/(154.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*iypx*sq3*(42*z**2+7*iypx**2-6)/(154.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*z*(132*z**4+297*iypx**2*z**2-120*z**2-81*iypx**2+20)/(88.0d0*sq6)
          sqy(ig,2,4) = 25.0d0*ci*z*(132*z**4+297*iypx**2*z**2-120*z**2-81*iypx**2+20)/(88.0d0*sq6)
          sqy(ig,3,4) = 25.0d0*iypx*(660*z**4+297*iypx**2*z**2-360*z**2-27*iypx**2+20)/(88.0d0*sq6)
       end do
    case (402)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 20.0d0*iypx/(7.0d0*sq30)
          sqy(ig,2,2) = 20.0d0*ci*iypx/(7.0d0*sq30)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*iypx*sq15*(7*z**2+21*iypx**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = 3.0d0*ci*iypx*sq15*(7*z**2+21*iypx**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = 45.0d0*iypx**2*z/(11.0d0*sq30)
          sqy(ig,1,4) = (-5.0d0)*iypx*sq15*(66*z**4+99*iypx**2*z**2-36*z**2-9*iypx**2+2)/(66.0d0*sq2)
          sqy(ig,2,4) = (-5.0d0)*ci*iypx*sq15*(66*z**4+99*iypx**2*z**2-36*z**2-9*iypx**2+2)/(66.0d0*sq2)
          sqy(ig,3,4) = (-5.0d0)*iypx**2*sq15*z*(88*z**2+33*iypx**2-24)/(44.0d0*sq2)
       end do
    case (403)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq5/sq7
          sqy(ig,2,2) = -ci*iymx*sq5/sq7
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-27.0d0)*iymx*sq5*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,2,3) = 27.0d0*ci*iymx*sq5*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,3,3) = 27.0d0*iymx**2*sq35*z/22.0d0
          sqy(ig,1,4) = 5.0d0*iymx*sq35*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*iymx*sq35*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**2*sq35*z*(11*z**2-3)/44.0d0
       end do
    case (404)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*sq5*z/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq5*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*iymx*sq5/7.0d0
          sqy(ig,1,3) = 9.0d0*sq5*z*(28*z**2-21*iymx**2-12)/154.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*sq5*z*(28*z**2-21*iymx**2-12)/154.0d0
          sqy(ig,3,3) = (-9.0d0)*iymx*sq5*(84*z**2-7*iymx**2-12)/154.0d0
          sqy(ig,1,4) = (-15.0d0)*sq5*z*(33*z**4-22*iymx**2*z**2-30*z**2+6*iymx**2+5)/88.0d0
          sqy(ig,2,4) = 15.0d0*ci*sq5*z*(33*z**4-22*iymx**2*z**2-30*z**2+6*iymx**2+5)/88.0d0
          sqy(ig,3,4) = 15.0d0*iymx*sq5*(165*z**4-22*iymx**2*z**2-90*z**2+2*iymx**2+5)/88.0d0
       end do
    case (405)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*iymx*sq15/21.0d0
          sqy(ig,2,2) = (-4.0d0)*ci*iymx*sq15/21.0d0
          sqy(ig,3,2) = 3.0d0*sq15*z/7.0d0
          sqy(ig,1,3) = 3.0d0*iymx*sq15*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iymx*sq15*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = 3.0d0*sq15*z*(35*z**2-14*iymx**2-15)/154.0d0
          sqy(ig,1,4) = (-5.0d0)*iymx*sq15*(33*z**4-18*z**2+1)/33.0d0
          sqy(ig,2,4) = 5.0d0*ci*iymx*sq15*(33*z**4-18*z**2+1)/33.0d0
          sqy(ig,3,4) = (-5.0d0)*sq15*z*(495*z**4-176*iymx**2*z**2-450*z**2+48*iymx**2+75)/88.0d0
       end do
    case (406)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 2.0d0*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = 45.0d0*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 135.0d0*(iypx-iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 25.0d0*z*(33*z**4-30*z**2+5)/22.0d0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 125.0d0*(iypx-iymx)*(33*z**4-18*z**2+1)/44.0d0
       end do
    case (407)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3*(5*z**2-1)
       end do
    case (408)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*(5*z**2-1)/4.0d0
          sqy(ig,2,1) = 3.0d0*ci*(5*z**2-1)/4.0d0
          sqy(ig,3,1) = 15.0d0*iymx*z/2.0d0
       end do
    case (409)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iymx/7.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*iymx/7.0d0
          sqy(ig,3,1) = 18.0d0*z/7.0d0
          sqy(ig,1,2) = (-15.0d0)*iymx*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = 15.0d0*ci*iymx*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = 5.0d0*z*(56*z**2+21*iymx**2-24)/14.0d0
       end do
    case (410)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 12.0d0*z/7.0d0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 6.0d0*(iypx-iymx)/7.0d0
          sqy(ig,1,2) = (-5.0d0)*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*z*(7*z**2-3)/4.0d0
          sqy(ig,3,2) = (-15.0d0)*(4*iypx+3*iymx)*(7*z**2-1)/28.0d0
       end do
    case (411)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq6*z/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq6*z/7.0d0
          sqy(ig,3,1) = 3.0d0*iymx*sq6/7.0d0
          sqy(ig,1,2) = 5.0d0*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,3,2) = (-15.0d0)*iymx*sq3*(7*z**2-1)/(7.0d0*sq2)
       end do
    case (412)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*iymx/(7.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci*iymx/(7.0d0*sq2)
          sqy(ig,3,1) = 18.0d0*sq2*z/7.0d0
          sqy(ig,1,2) = 15.0d0*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,2) = (-15.0d0)*ci*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,2) = 5.0d0*z*(112*z**2-21*iymx**2-48)/(14.0d0*sq2)
       end do
    case (413)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq2*z/7.0d0
          sqy(ig,2,1) = 9.0d0*ci*sq2*z/7.0d0
          sqy(ig,3,1) = 3.0d0*(iypx+2*iymx)*sq2/7.0d0
          sqy(ig,1,2) = (-25.0d0)*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = 5.0d0*ci*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = (-15.0d0)*(2*iypx-3*iymx)*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (414)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 9.0d0*sq6*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-15.0d0)*sq3*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (415)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq6/35.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq6/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2-15*iymx**2-1)/sq6/5.0d0
          sqy(ig,2,2) = -ci*(5*z**2-15*iymx**2-1)/sq6/5.0d0
          sqy(ig,3,2) = -iymx*sq2*z/sq3
          sqy(ig,1,3) = 5.0d0*(84*z**4+189*iymx**2*z**2-56*z**2-21*iymx**2+4)/(28.0d0*sq6)
          sqy(ig,2,3) = (-5.0d0)*ci*(84*z**4+189*iymx**2*z**2-56*z**2-21*iymx**2+4)/(28.0d0*sq6)
          sqy(ig,3,3) = (-5.0d0)*iymx*z*(24*z**2+9*iymx**2-8)/(2.0d0*sq6)
       end do
    case (416)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 18.0d0*sq2/35.0d0
          sqy(ig,1,2) = -3*iymx*z/sq2
          sqy(ig,2,2) = 3*ci*iymx*z/sq2
          sqy(ig,3,2) = (80*z**2+15*iymx**2-16)/sq2/10.0d0
          sqy(ig,1,3) = (-15.0d0)*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = 15.0d0*ci*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = 5.0d0*(420*z**4+189*iymx**2*z**2-280*z**2-21*iymx**2+20)/(28.0d0*sq2)
       end do
    case (417)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 18.0d0*sq2/35.0d0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2-1)/sq2/10.0d0
          sqy(ig,2,2) = -ci*(5*z**2-1)/sq2/2.0d0
          sqy(ig,3,2) = -(2*iypx+3*iymx)*z/sq2
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*ci*(21*z**4-14*z**2+1)/(4.0d0*sq2)
          sqy(ig,3,3) = -5*(4*iypx+3*iymx)*z*(3*z**2-1)/sq2
       end do
    case (418)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-6.0d0)*sq6/35.0d0
          sqy(ig,1,2) = -8*iypx*z/sq6
          sqy(ig,2,2) = -8*ci*iypx*z/sq6
          sqy(ig,3,2) = -(15*z**2+20*iypx**2-3)/sq6/5.0d0
          sqy(ig,1,3) = 10*iypx*z*(3*z**2-1)/sq6
          sqy(ig,2,3) = 10*ci*iypx*z*(3*z**2-1)/sq6
          sqy(ig,3,3) = 5.0d0*(315*z**4+252*iypx**2*z**2-210*z**2-28*iypx**2+15)/(28.0d0*sq6)
       end do
    case (419)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 20*iymx*z/sq30
          sqy(ig,2,2) = -20*ci*iymx*z/sq30
          sqy(ig,3,2) = -10*iymx**2/sq30
          sqy(ig,1,3) = (-5.0d0)*iymx*sq30*z*(3*z**2-1)/6.0d0
          sqy(ig,2,3) = 5.0d0*ci*iymx*sq30*z*(3*z**2-1)/6.0d0
          sqy(ig,3,3) = 5.0d0*iymx**2*sq30*(3*z-1)*(3*z+1)/12.0d0
       end do
    case (420)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-6.0d0)*sq6/35.0d0
          sqy(ig,2,1) = 6.0d0*ci*sq6/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (20*z**2+15*iymx**2-4)/sq6/10.0d0
          sqy(ig,2,2) = -ci*(20*z**2+15*iymx**2-4)/sq6/10.0d0
          sqy(ig,3,2) = -4*iymx*z/sq6
          sqy(ig,1,3) = 5.0d0*(336*z**4-189*iymx**2*z**2-224*z**2+21*iymx**2+16)/(56.0d0*sq6)
          sqy(ig,2,3) = (-5.0d0)*ci*(336*z**4-189*iymx**2*z**2-224*z**2+21*iymx**2+16)/(56.0d0*sq6)
          sqy(ig,3,3) = (-5.0d0)*iymx*z*(96*z**2-9*iymx**2-32)/(4.0d0*sq6)
       end do
    case (421)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 18.0d0*sq3/35.0d0
          sqy(ig,1,2) = iymx*sq3*z
          sqy(ig,2,2) = -ci*iymx*sq3*z
          sqy(ig,3,2) = sq3*(40*z**2-5*iymx**2-8)/10.0d0
          sqy(ig,1,3) = 5.0d0*iymx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*iymx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = 5.0d0*sq3*(210*z**4-63*iymx**2*z**2-140*z**2+7*iymx**2+10)/28.0d0
       end do
    case (422)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq3/35.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq3/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-13.0d0)*(5*z**2-1)/(20.0d0*sq3)
          sqy(ig,2,2) = ci*(5*z**2-1)/sq3/4.0d0
          sqy(ig,3,2) = -(4*iypx-9*iymx)*z/sq3/2.0d0
          sqy(ig,1,3) = (-85.0d0)*(21*z**4-14*z**2+1)/(56.0d0*sq3)
          sqy(ig,2,3) = 5.0d0*ci*(21*z**4-14*z**2+1)/(56.0d0*sq3)
          sqy(ig,3,3) = (-5.0d0)*(8*iypx-9*iymx)*z*(3*z**2-1)/(2.0d0*sq3)
       end do
    case (423)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 12.0d0*sq6/35.0d0
          sqy(ig,1,2) = -4*iypx*z/sq6
          sqy(ig,2,2) = -4*ci*iypx*z/sq6
          sqy(ig,3,2) = 2.0d0*(15*z**2-5*iypx**2-3)/(5.0d0*sq6)
          sqy(ig,1,3) = 5*iypx*z*(3*z**2-1)/sq6
          sqy(ig,2,3) = 5*ci*iypx*z*(3*z**2-1)/sq6
          sqy(ig,3,3) = (-5.0d0)*(315*z**4-63*iypx**2*z**2-210*z**2+7*iypx**2+15)/(14.0d0*sq6)
       end do
    case (424)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0/(7.0d0*sq30)
          sqy(ig,2,1) = 9.0d0*ci/(7.0d0*sq30)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq6*(5*z**2-1)/sq5/2.0d0
          sqy(ig,2,2) = -ci*sq6*(5*z**2-1)/sq5/2.0d0
          sqy(ig,3,2) = -iypx*sq30*z
          sqy(ig,1,3) = 15.0d0*sq5*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,2,3) = 15.0d0*ci*sq5*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,3,3) = 15.0d0*iypx*sq5*z*(3*z**2-1)/(2.0d0*sq6)
       end do
    case (425)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*iymx*sq30/21.0d0
          sqy(ig,2,2) = (-2.0d0)*ci*iymx*sq30/21.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*iymx*sq30*(7*z**2+21*iymx**2-1)/154.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iymx*sq30*(7*z**2+21*iymx**2-1)/154.0d0
          sqy(ig,3,3) = (-3.0d0)*iymx**2*sq30*z/22.0d0
          sqy(ig,1,4) = (-5.0d0)*iymx*sq30*(66*z**4+99*iymx**2*z**2-36*z**2-9*iymx**2+2)/132.0d0
          sqy(ig,2,4) = 5.0d0*ci*iymx*sq30*(66*z**4+99*iymx**2*z**2-36*z**2-9*iymx**2+2)/132.0d0
          sqy(ig,3,4) = 5.0d0*iymx**2*sq30*z*(88*z**2+33*iymx**2-24)/88.0d0
       end do
    case (426)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*sq6*z/21.0d0
          sqy(ig,2,2) = (-2.0d0)*ci*sq6*z/21.0d0
          sqy(ig,3,2) = (-2.0d0)*iymx*sq6/21.0d0
          sqy(ig,1,3) = 15.0d0*sq3*z*(14*z**2+21*iymx**2-6)/(154.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*ci*sq3*z*(14*z**2+21*iymx**2-6)/(154.0d0*sq2)
          sqy(ig,3,3) = (-15.0d0)*iymx*sq3*(42*z**2+7*iymx**2-6)/(154.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*z*(132*z**4+297*iymx**2*z**2-120*z**2-81*iymx**2+20)/(88.0d0*sq6)
          sqy(ig,2,4) = (-25.0d0)*ci*z*(132*z**4+297*iymx**2*z**2-120*z**2-81*iymx**2+20)/(88.0d0*sq6)
          sqy(ig,3,4) = (-25.0d0)*iymx*(660*z**4+297*iymx**2*z**2-360*z**2-27*iymx**2+20)/(88.0d0*sq6)
       end do
    case (427)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-4.0d0)*iymx*sq3/7.0d0
          sqy(ig,2,2) = 4.0d0*ci*iymx*sq3/7.0d0
          sqy(ig,3,2) = 8.0d0*sq3*z/7.0d0
          sqy(ig,1,3) = (-30.0d0)*iymx*sq3*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = 30.0d0*ci*iymx*sq3*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = 30.0d0*sq3*z*(21*z**2+7*iymx**2-9)/77.0d0
          sqy(ig,1,4) = (-25.0d0)*iymx*sq3*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,2,4) = 25.0d0*ci*iymx*sq3*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,3,4) = 25.0d0*sq3*z*(66*z**4+33*iymx**2*z**2-60*z**2-9*iymx**2+10)/22.0d0
       end do
    case (428)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -z/sq3/7.0d0
          sqy(ig,2,2) = -ci*z/sq3
          sqy(ig,3,2) = -(4*iypx+3*iymx)/sq3/7.0d0
          sqy(ig,1,3) = (-15.0d0)*sq3*z*(7*z**2-3)/308.0d0
          sqy(ig,2,3) = (-15.0d0)*ci*sq3*z*(7*z**2-3)/44.0d0
          sqy(ig,3,3) = (-45.0d0)*(4*iypx+3*iymx)*sq3*(7*z**2-1)/308.0d0
          sqy(ig,1,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,2,4) = (-175.0d0)*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,3,4) = (-125.0d0)*(4*iypx+3*iymx)*(33*z**4-18*z**2+1)/(88.0d0*sq3)
       end do
    case (429)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-20.0d0)*iypx/(7.0d0*sq6)
          sqy(ig,2,2) = (-20.0d0)*ci*iypx/(7.0d0*sq6)
          sqy(ig,3,2) = (-3.0d0)*sq6*z/7.0d0
          sqy(ig,1,3) = (-15.0d0)*iypx*sq3*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*ci*iypx*sq3*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = (-15.0d0)*sq3*z*(7*z**2+7*iypx**2-3)/(77.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*iypx*(33*z**4-18*z**2+1)/(11.0d0*sq6)
          sqy(ig,2,4) = 25.0d0*ci*iypx*(33*z**4-18*z**2+1)/(11.0d0*sq6)
          sqy(ig,3,4) = 25.0d0*sq3*z*(99*z**4+88*iypx**2*z**2-90*z**2-24*iypx**2+15)/(44.0d0*sq2)
       end do
    case (430)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 15.0d0*z/(7.0d0*sq30)
          sqy(ig,2,2) = 15.0d0*ci*z/(7.0d0*sq30)
          sqy(ig,3,2) = 15.0d0*iypx/(7.0d0*sq30)
          sqy(ig,1,3) = 3.0d0*sq30*z*(14*z**2+63*iypx**2-6)/154.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq30*z*(14*z**2+63*iypx**2-6)/154.0d0
          sqy(ig,3,3) = 9.0d0*iypx*sq30*(14*z**2+7*iypx**2-2)/154.0d0
          sqy(ig,1,4) = (-5.0d0)*sq30*z*(33*z**4+132*iypx**2*z**2-30*z**2-36*iypx**2+5)/176.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*sq30*z*(33*z**4+132*iypx**2*z**2-30*z**2-36*iypx**2+5)/176.0d0
          sqy(ig,3,4) = (-5.0d0)*iypx*sq30*(165*z**4+132*iypx**2*z**2-90*z**2-12*iypx**2+5)/176.0d0
       end do
    case (431)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-27.0d0)*iymx**2*sq35*z/22.0d0
          sqy(ig,2,3) = 27.0d0*ci*iymx**2*sq35*z/22.0d0
          sqy(ig,3,3) = 9.0d0*iymx**3*sq35/22.0d0
          sqy(ig,1,4) = 15.0d0*iymx**2*sq35*z*(11*z**2-3)/44.0d0
          sqy(ig,2,4) = (-15.0d0)*ci*iymx**2*sq35*z*(11*z**2-3)/44.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**3*sq35*(11*z**2-1)/44.0d0
       end do
    case (432)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*iymx*sq5/7.0d0
          sqy(ig,2,2) = (-4.0d0)*ci*iymx*sq5/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iymx*sq5*(14*z**2-7*iymx**2-2)/154.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*iymx*sq5*(14*z**2-7*iymx**2-2)/154.0d0
          sqy(ig,3,3) = (-9.0d0)*iymx**2*sq5*z/11.0d0
          sqy(ig,1,4) = (-5.0d0)*iymx*sq5*(132*z**4-33*iymx**2*z**2-72*z**2+3*iymx**2+4)/44.0d0
          sqy(ig,2,4) = 5.0d0*ci*iymx*sq5*(132*z**4-33*iymx**2*z**2-72*z**2+3*iymx**2+4)/44.0d0
          sqy(ig,3,4) = 15.0d0*iymx**2*sq5*z*(176*z**2-11*iymx**2-48)/88.0d0
       end do
    case (433)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*sq15*z/21.0d0
          sqy(ig,2,2) = (-2.0d0)*ci*sq15*z/21.0d0
          sqy(ig,3,2) = (-2.0d0)*iymx*sq15/21.0d0
          sqy(ig,1,3) = 3.0d0*sq15*z*(35*z**2-21*iymx**2-15)/154.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*sq15*z*(35*z**2-21*iymx**2-15)/154.0d0
          sqy(ig,3,3) = (-3.0d0)*iymx*sq15*(105*z**2-7*iymx**2-15)/154.0d0
          sqy(ig,1,4) = 5.0d0*sq15*z*(330*z**4-297*iymx**2*z**2-300*z**2+81*iymx**2+50)/264.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*sq15*z*(330*z**4-297*iymx**2*z**2-300*z**2+81*iymx**2+50)/264.0d0
          sqy(ig,3,4) = (-5.0d0)*iymx*sq15*(1650*z**4-297*iymx**2*z**2-900*z**2+27*iymx**2+50)/264.0d0
       end do
    case (434)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 6.0d0*iymx/7.0d0
          sqy(ig,2,2) = (-6.0d0)*ci*iymx/7.0d0
          sqy(ig,3,2) = 16.0d0*z/7.0d0
          sqy(ig,1,3) = 45.0d0*iymx*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = (-45.0d0)*ci*iymx*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = 45.0d0*z*(28*z**2-7*iymx**2-12)/77.0d0
          sqy(ig,1,4) = 75.0d0*iymx*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,2,4) = (-75.0d0)*ci*iymx*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,3,4) = 25.0d0*z*(264*z**4-99*iymx**2*z**2-240*z**2+27*iymx**2+40)/44.0d0
       end do
    case (435)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-4.0d0)*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-2.0d0)*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = (-45.0d0)*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-135.0d0)*(iypx-iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/22.0d0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-125.0d0)*(iypx-iymx)*(33*z**4-18*z**2+1)/44.0d0
       end do
    case (436)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq15*(5*z**2-1)/4.0d0
          sqy(ig,2,1) = ci*sq15*(5*z**2-1)/4.0d0
          sqy(ig,3,1) = 5.0d0*iymx*sq15*z/2.0d0
       end do
    case (437)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -iymx*sq15*z
          sqy(ig,2,1) = ci*iymx*sq15*z
          sqy(ig,3,1) = iymx**2*sq15/2.0d0
       end do
    case (438)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-2.0d0)*sq15*z/7.0d0
          sqy(ig,2,1) = 2.0d0*ci*sq15*z/7.0d0
          sqy(ig,3,1) = 2.0d0*iymx*sq15/7.0d0
          sqy(ig,1,2) = -sq15*z*(35*z**2+42*iymx**2-15)/28.0d0
          sqy(ig,2,2) = ci*sq15*z*(35*z**2+42*iymx**2-15)/28.0d0
          sqy(ig,3,2) = iymx*sq15*(105*z**2+14*iymx**2-15)/28.0d0
       end do
    case (439)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iymx*sq15/7.0d0
          sqy(ig,2,1) = -ci*iymx*sq15/7.0d0
          sqy(ig,3,1) = 6.0d0*sq15*z/7.0d0
          sqy(ig,1,2) = iymx*sq15*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = -ci*iymx*sq15*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = -sq15*z*(35*z**2+7*iymx**2-15)/7.0d0
       end do
    case (440)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*iymx*sq5/(7.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci*iymx*sq5/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 15.0d0*iymx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,2) = (-15.0d0)*ci*iymx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,2) = (-15.0d0)*iymx**2*sq5*z/(2.0d0*sq2)
       end do
    case (441)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-2.0d0)*sq30*z/7.0d0
          sqy(ig,2,1) = 2.0d0*ci*sq30*z/7.0d0
          sqy(ig,3,1) = 2.0d0*iymx*sq30/7.0d0
          sqy(ig,1,2) = -sq15*z*(35*z**2-21*iymx**2-15)/sq2/14.0d0
          sqy(ig,2,2) = ci*sq15*z*(35*z**2-21*iymx**2-15)/sq2/14.0d0
          sqy(ig,3,2) = iymx*sq15*(105*z**2-7*iymx**2-15)/sq2/14.0d0
       end do
    case (442)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -iymx*sq30/7.0d0
          sqy(ig,2,1) = ci*iymx*sq30/7.0d0
          sqy(ig,3,1) = 3.0d0*sq30*z/7.0d0
          sqy(ig,1,2) = -iymx*sq30*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = ci*iymx*sq30*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = -sq15*z*(35*z**2-14*iymx**2-15)/sq2/7.0d0
       end do
    case (443)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq10*z/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq10*z/7.0d0
          sqy(ig,3,1) = 3.0d0*iymx*sq10/7.0d0
          sqy(ig,1,2) = 15.0d0*z*(7*z**2-3)/(14.0d0*sq10)
          sqy(ig,2,2) = (-15.0d0)*ci*z*(7*z**2-3)/(14.0d0*sq10)
          sqy(ig,3,2) = (-45.0d0)*iymx*(7*z**2-1)/(14.0d0*sq10)
       end do
    case (444)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq5*z/sq2
          sqy(ig,2,2) = -ci*iymx*sq5*z/sq2
          sqy(ig,3,2) = -iymx**2*sq5/sq2/2.0d0
          sqy(ig,1,3) = iymx*sq5*z*(15*z**2+12*iymx**2-5)/sq2/2.0d0
          sqy(ig,2,3) = -ci*iymx*sq5*z*(15*z**2+12*iymx**2-5)/sq2/2.0d0
          sqy(ig,3,3) = -iymx**2*sq5*(45*z**2+6*iymx**2-5)/sq2/4.0d0
       end do
    case (445)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq6/(7.0d0*sq5)
          sqy(ig,2,1) = 3.0d0*ci*sq6/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*(5*z**2+5*iymx**2-1)/sq10/2.0d0
          sqy(ig,2,2) = ci*sq3*(5*z**2+5*iymx**2-1)/sq10/2.0d0
          sqy(ig,3,2) = iymx*sq30*z/2.0d0
          sqy(ig,1,3) = -sq30*(105*z**4+126*iymx**2*z**2-70*z**2-14*iymx**2+5)/56.0d0
          sqy(ig,2,3) = ci*sq30*(105*z**4+126*iymx**2*z**2-70*z**2-14*iymx**2+5)/56.0d0
          sqy(ig,3,3) = iymx*sq30*z*(15*z**2+3*iymx**2-5)/2.0d0
       end do
    case (446)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 6.0d0*sq6/(7.0d0*sq5)
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 3*(5*z**2-1)/sq30
          sqy(ig,1,3) = iymx*sq30*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = -ci*iymx*sq30*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = -sq30*(525*z**4+126*iymx**2*z**2-350*z**2-14*iymx**2+25)/56.0d0
       end do
    case (447)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*sq2/(7.0d0*sq5)
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*(5*z**2-1)/(2.0d0*sq10)
          sqy(ig,2,2) = (-5.0d0)*ci*(5*z**2-1)/(2.0d0*sq10)
          sqy(ig,3,2) = -(4*iypx+iymx)*sq10*z/2.0d0
          sqy(ig,1,3) = 3.0d0*sq5*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,2,3) = ci*sq5*(21*z**4-14*z**2+1)/sq2/4.0d0
          sqy(ig,3,3) = (5*iypx+2*iymx)*sq5*z*(3*z**2-1)/sq2
       end do
    case (448)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5.0d0*iymx**2/(2.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*ci*iymx**2/(2.0d0*sq2)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-25.0d0)*iymx**2*(3*z-1)*(3*z+1)/(8.0d0*sq2)
          sqy(ig,2,3) = 25.0d0*ci*iymx**2*(3*z-1)*(3*z+1)/(8.0d0*sq2)
          sqy(ig,3,3) = 75.0d0*iymx**3*z/(4.0d0*sq2)
       end do
    case (449)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq10*z
          sqy(ig,2,2) = -ci*iymx*sq10*z
          sqy(ig,3,2) = -iymx**2*sq5/sq2
          sqy(ig,1,3) = iymx*sq5*z*(15*z**2-3*iymx**2-5)/sq2
          sqy(ig,2,3) = -ci*iymx*sq5*z*(15*z**2-3*iymx**2-5)/sq2
          sqy(ig,3,3) = -iymx**2*sq5*(90*z**2-3*iymx**2-10)/sq2/4.0d0
       end do
    case (450)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)/(7.0d0*sq5)
          sqy(ig,2,1) = 9.0d0*ci/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(15*z**2-10*iymx**2-3)/sq5/4.0d0
          sqy(ig,2,2) = ci*(15*z**2-10*iymx**2-3)/sq5/4.0d0
          sqy(ig,3,2) = 3.0d0*iymx*sq5*z/2.0d0
          sqy(ig,1,3) = -sq5*(315*z**4-252*iymx**2*z**2-210*z**2+28*iymx**2+15)/56.0d0
          sqy(ig,2,3) = ci*sq5*(315*z**4-252*iymx**2*z**2-210*z**2+28*iymx**2+15)/56.0d0
          sqy(ig,3,3) = 3.0d0*iymx*sq5*z*(15*z**2-2*iymx**2-5)/2.0d0
       end do
    case (451)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 12.0d0/(7.0d0*sq5)
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (5*z**2-1)/sq5
          sqy(ig,1,3) = (-3.0d0)*iymx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = 3.0d0*ci*iymx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = -sq5*(525*z**4-189*iymx**2*z**2-350*z**2+21*iymx**2+25)/28.0d0
       end do
    case (452)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)/(7.0d0*sq2*sq5)
          sqy(ig,2,1) = 3.0d0*ci*sq5/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -2*(5*z**2-1)/sq10
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -(iypx-iymx)*sq10*z
          sqy(ig,1,3) = 13.0d0*sq5*(21*z**4-14*z**2+1)/(56.0d0*sq2)
          sqy(ig,2,3) = (-3.0d0)*ci*sq5*(21*z**4-14*z**2+1)/(56.0d0*sq2)
          sqy(ig,3,3) = (5*iypx-8*iymx)*sq5*z*(3*z**2-1)/sq2/2.0d0
       end do
    case (453)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*sq2/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -sq2*(5*z**2-1)
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 25.0d0*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (454)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*iymx**2*z/(22.0d0*sq2)
          sqy(ig,2,3) = 45.0d0*ci*iymx**2*z/(22.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*iymx**3/(22.0d0*sq2)
          sqy(ig,1,4) = (-75.0d0)*iymx**2*z*(33*z**2+22*iymx**2-9)/(88.0d0*sq2)
          sqy(ig,2,4) = 75.0d0*ci*iymx**2*z*(33*z**2+22*iymx**2-9)/(88.0d0*sq2)
          sqy(ig,3,4) = 15.0d0*iymx**3*(165*z**2+22*iymx**2-15)/(88.0d0*sq2)
       end do
    case (455)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*iymx*sq10/7.0d0
          sqy(ig,2,2) = (-2.0d0)*ci*iymx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*iymx*sq5*(14*z**2+7*iymx**2-2)/(77.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*ci*iymx*sq5*(14*z**2+7*iymx**2-2)/(77.0d0*sq2)
          sqy(ig,3,3) = (-15.0d0)*iymx**2*sq10*z/11.0d0
          sqy(ig,1,4) = 5.0d0*iymx*sq5*(165*z**4+132*iymx**2*z**2-90*z**2-12*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,2,4) = (-5.0d0)*ci*iymx*sq5*(165*z**4+132*iymx**2*z**2-90*z**2-12*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,3,4) = (-15.0d0)*iymx**2*sq5*z*(55*z**2+11*iymx**2-15)/(22.0d0*sq2)
       end do
    case (456)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq5*z/7.0d0
          sqy(ig,2,2) = ci*sq5*z/7.0d0
          sqy(ig,3,2) = iymx*sq5/7.0d0
          sqy(ig,1,3) = (-9.0d0)*sq5*z*(35*z**2+28*iymx**2-15)/308.0d0
          sqy(ig,2,3) = 9.0d0*ci*sq5*z*(35*z**2+28*iymx**2-15)/308.0d0
          sqy(ig,3,3) = 3.0d0*iymx*sq5*(315*z**2+28*iymx**2-45)/308.0d0
          sqy(ig,1,4) = (-5.0d0)*sq5*z*(165*z**4+198*iymx**2*z**2-150*z**2-54*iymx**2+25)/88.0d0
          sqy(ig,2,4) = 5.0d0*ci*sq5*z*(165*z**4+198*iymx**2*z**2-150*z**2-54*iymx**2+25)/88.0d0
          sqy(ig,3,4) = 5.0d0*iymx*sq5*(825*z**4+198*iymx**2*z**2-450*z**2-18*iymx**2+25)/88.0d0
       end do
    case (457)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*iymx*sq5/7.0d0
          sqy(ig,2,2) = 2.0d0*ci*iymx*sq5/7.0d0
          sqy(ig,3,2) = 6.0d0*sq5*z/7.0d0
          sqy(ig,1,3) = (-9.0d0)*iymx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,2,3) = 9.0d0*ci*iymx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,3,3) = 3.0d0*sq5*z*(70*z**2+21*iymx**2-30)/154.0d0
          sqy(ig,1,4) = 5.0d0*iymx*sq5*(33*z**4-18*z**2+1)/22.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*iymx*sq5*(33*z**4-18*z**2+1)/22.0d0
          sqy(ig,3,4) = (-15.0d0)*sq5*z*(165*z**4+44*iymx**2*z**2-150*z**2-12*iymx**2+25)/44.0d0
       end do
    case (458)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-15.0d0)*z/(7.0d0*sq10)
          sqy(ig,2,2) = -5*ci*z/sq10
          sqy(ig,3,2) = (-5.0d0)*(5*iypx+2*iymx)/(7.0d0*sq10)
          sqy(ig,1,3) = (-9.0d0)*sq10*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*sq10*z*(7*z**2-3)/11.0d0
          sqy(ig,3,3) = (-9.0d0)*(5*iypx+2*iymx)*sq10*(7*z**2-1)/77.0d0
          sqy(ig,1,4) = 75.0d0*z*(33*z**4-30*z**2+5)/(88.0d0*sq10)
          sqy(ig,2,4) = 175.0d0*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq10)
          sqy(ig,3,4) = 125.0d0*(5*iypx+2*iymx)*(33*z**4-18*z**2+1)/(88.0d0*sq10)
       end do
    case (459)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*iypx*sq2/7.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*iypx*sq2/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 135.0d0*iypx*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = 135.0d0*ci*iypx*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*z*(7*z**2+9*iypx**2-3)/(11.0d0*sq2)
          sqy(ig,1,4) = (-25.0d0)*iypx*(33*z**4-18*z**2+1)/(44.0d0*sq2)
          sqy(ig,2,4) = (-25.0d0)*ci*iypx*(33*z**4-18*z**2+1)/(44.0d0*sq2)
          sqy(ig,3,4) = (-15.0d0)*z*(33*z**4+55*iypx**2*z**2-30*z**2-15*iypx**2+5)/(22.0d0*sq2)
       end do
    case (460)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*iymx**3*sq21/22.0d0
          sqy(ig,2,3) = 15.0d0*ci*iymx**3*sq21/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 25.0d0*iymx**3*sq21*(11*z**2-1)/44.0d0
          sqy(ig,2,4) = (-25.0d0)*ci*iymx**3*sq21*(11*z**2-1)/44.0d0
          sqy(ig,3,4) = (-25.0d0)*iymx**4*sq21*z/8.0d0
       end do
    case (461)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*iymx**2*sq3*z/22.0d0
          sqy(ig,2,3) = 45.0d0*ci*iymx**2*sq3*z/22.0d0
          sqy(ig,3,3) = 15.0d0*iymx**3*sq3/22.0d0
          sqy(ig,1,4) = (-25.0d0)*iymx**2*sq3*z*(99*z**2-11*iymx**2-27)/88.0d0
          sqy(ig,2,4) = 25.0d0*ci*iymx**2*sq3*z*(99*z**2-11*iymx**2-27)/88.0d0
          sqy(ig,3,4) = 5.0d0*iymx**3*sq3*(495*z**2-11*iymx**2-45)/88.0d0
       end do
    case (462)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 10.0d0*iymx/7.0d0
          sqy(ig,2,2) = (-10.0d0)*ci*iymx/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*iymx*(35*z**2-7*iymx**2-5)/77.0d0
          sqy(ig,2,3) = (-15.0d0)*ci*iymx*(35*z**2-7*iymx**2-5)/77.0d0
          sqy(ig,3,3) = (-75.0d0)*iymx**2*z/11.0d0
          sqy(ig,1,4) = 5.0d0*iymx*(825*z**4-264*iymx**2*z**2-450*z**2+24*iymx**2+25)/88.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*iymx*(825*z**4-264*iymx**2*z**2-450*z**2+24*iymx**2+25)/88.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**2*z*(275*z**2-22*iymx**2-75)/44.0d0
       end do
    case (463)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*sq5*z/(7.0d0*sq3)
          sqy(ig,2,2) = 2.0d0*ci*sq5*z/(7.0d0*sq3)
          sqy(ig,3,2) = 2.0d0*iymx*sq5/(7.0d0*sq3)
          sqy(ig,1,3) = (-3.0d0)*sq15*z*(35*z**2-21*iymx**2-15)/154.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq15*z*(35*z**2-21*iymx**2-15)/154.0d0
          sqy(ig,3,3) = 3.0d0*iymx*sq15*(105*z**2-7*iymx**2-15)/154.0d0
          sqy(ig,1,4) = (-5.0d0)*sq5*z*(330*z**4-297*iymx**2*z**2-300*z**2+81*iymx**2+50)/(88.0d0*sq3)
          sqy(ig,2,4) = 5.0d0*ci*sq5*z*(330*z**4-297*iymx**2*z**2-300*z**2+81*iymx**2+50)/(88.0d0*sq3)
          sqy(ig,3,4) = 5.0d0*iymx*sq5*(1650*z**4-297*iymx**2*z**2-900*z**2+27*iymx**2+50)/(88.0d0*sq3)
       end do
    case (464)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*iymx*sq15/21.0d0
          sqy(ig,2,2) = (-4.0d0)*ci*iymx*sq15/21.0d0
          sqy(ig,3,2) = 3.0d0*sq15*z/7.0d0
          sqy(ig,1,3) = 3.0d0*iymx*sq15*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iymx*sq15*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = 3.0d0*sq15*z*(35*z**2-14*iymx**2-15)/154.0d0
          sqy(ig,1,4) = (-25.0d0)*iymx*(33*z**4-18*z**2+1)/(11.0d0*sq15)
          sqy(ig,2,4) = 25.0d0*ci*iymx*(33*z**4-18*z**2+1)/(11.0d0*sq15)
          sqy(ig,3,4) = (-5.0d0)*sq15*z*(495*z**4-176*iymx**2*z**2-450*z**2+48*iymx**2+75)/88.0d0
       end do
    case (465)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-10.0d0)*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-5.0d0)*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = (-60.0d0)*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-90.0d0)*(iypx-iymx)*(7*z**2-1)/77.0d0
          sqy(ig,1,4) = 25.0d0*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 125.0d0*(iypx-iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (466)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*iymx*sq5*z
          sqy(ig,2,1) = 3*ci*iymx*sq5*z
          sqy(ig,3,1) = 3.0d0*iymx**2*sq5/2.0d0
       end do
    case (467)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*iymx**2*sq5/4.0d0
          sqy(ig,2,1) = 3.0d0*ci*iymx**2*sq5/4.0d0
          sqy(ig,3,1) = 0
       end do
    case (468)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*iymx*sq5/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*iymx*sq5/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq5*(21*z**2+7*iymx**2-3)/7.0d0
          sqy(ig,2,2) = ci*iymx*sq5*(21*z**2+7*iymx**2-3)/7.0d0
          sqy(ig,3,2) = 3*iymx**2*sq5*z
       end do
    case (469)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-6.0d0)*sq5*z/7.0d0
          sqy(ig,2,1) = 6.0d0*ci*sq5*z/7.0d0
          sqy(ig,3,1) = 6.0d0*iymx*sq5/7.0d0
          sqy(ig,1,2) = 3.0d0*sq5*z*(14*z**2+7*iymx**2-6)/28.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq5*z*(14*z**2+7*iymx**2-6)/28.0d0
          sqy(ig,3,2) = -iymx*sq5*(126*z**2+7*iymx**2-18)/28.0d0
       end do
    case (470)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 45.0d0*iymx**2*sq3*z/(2.0d0*sq10)
          sqy(ig,2,2) = (-45.0d0)*ci*iymx**2*sq3*z/(2.0d0*sq10)
          sqy(ig,3,2) = (-15.0d0)*iymx**3*sq3/(2.0d0*sq10)
       end do
    case (471)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*iymx*sq10/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*iymx*sq10/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq5*(42*z**2-7*iymx**2-6)/sq2/7.0d0
          sqy(ig,2,2) = ci*iymx*sq5*(42*z**2-7*iymx**2-6)/sq2/7.0d0
          sqy(ig,3,2) = 3*iymx**2*sq10*z
       end do
    case (472)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq10*z/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq10*z/7.0d0
          sqy(ig,3,1) = 3.0d0*iymx*sq10/7.0d0
          sqy(ig,1,2) = 3.0d0*sq5*z*(7*z**2-7*iymx**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = (-3.0d0)*ci*sq5*z*(7*z**2-7*iymx**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = -iymx*sq5*(63*z**2-7*iymx**2-9)/sq2/14.0d0
       end do
    case (473)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*iymx*sq15/(7.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci*iymx*sq15/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq15*(7*z**2-1)/sq2/14.0d0
          sqy(ig,2,2) = -ci*iymx*sq15*(7*z**2-1)/sq2/14.0d0
          sqy(ig,3,2) = -iymx**2*sq15*z/sq2/2.0d0
       end do
    case (474)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx**2*sq15/sq2/2.0d0
          sqy(ig,2,2) = -ci*iymx**2*sq15/sq2/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = iymx**2*sq15*(18*z**2+5*iymx**2-2)/sq2/4.0d0
          sqy(ig,2,3) = -ci*iymx**2*sq15*(18*z**2+5*iymx**2-2)/sq2/4.0d0
          sqy(ig,3,3) = -3*iymx**3*sq15*z/sq2
       end do
    case (475)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -3*iymx*sq5*z*(3*z**2+iymx**2-1)/sq2
          sqy(ig,2,3) = 3*ci*iymx*sq5*z*(3*z**2+iymx**2-1)/sq2
          sqy(ig,3,3) = 3.0d0*iymx**2*sq5*(18*z**2+iymx**2-2)/(4.0d0*sq2)
       end do
    case (476)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-18.0d0)/(7.0d0*sq10)
          sqy(ig,2,1) = 18.0d0*ci/(7.0d0*sq10)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(15*z**2+5*iymx**2-3)/sq10/2.0d0
          sqy(ig,2,2) = ci*(15*z**2+5*iymx**2-3)/sq10/2.0d0
          sqy(ig,3,2) = 15*iymx*z/sq10
          sqy(ig,1,3) = sq5*(126*z**4+63*iymx**2*z**2-84*z**2-7*iymx**2+6)/sq2/28.0d0
          sqy(ig,2,3) = -ci*sq5*(126*z**4+63*iymx**2*z**2-84*z**2-7*iymx**2+6)/sq2/28.0d0
          sqy(ig,3,3) = (-3.0d0)*iymx*sq5*z*(12*z**2+iymx**2-4)/(2.0d0*sq2)
       end do
    case (477)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 36.0d0/(7.0d0*sq30)
          sqy(ig,1,2) = iymx*sq5*z/sq6
          sqy(ig,2,2) = -ci*iymx*sq5*z/sq6
          sqy(ig,3,2) = -sq5*(120*z**2+5*iymx**2-24)/sq6/10.0d0
          sqy(ig,1,3) = -iymx*sq5*z*(3*z**2-1)/sq6/2.0d0
          sqy(ig,2,3) = ci*iymx*sq5*z*(3*z**2-1)/sq6/2.0d0
          sqy(ig,3,3) = sq5*(630*z**4+63*iymx**2*z**2-420*z**2-7*iymx**2+30)/sq6/28.0d0
       end do
    case (478)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*iymx**3*sq6*z/2.0d0
          sqy(ig,2,3) = 15.0d0*ci*iymx**3*sq6*z/2.0d0
          sqy(ig,3,3) = 15.0d0*iymx**4*sq6/8.0d0
       end do
    case (479)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx**2*sq15/sq2
          sqy(ig,2,2) = -ci*iymx**2*sq15/sq2
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = iymx**2*sq15*(72*z**2-5*iymx**2-8)/sq2/8.0d0
          sqy(ig,2,3) = -ci*iymx**2*sq15*(72*z**2-5*iymx**2-8)/sq2/8.0d0
          sqy(ig,3,3) = -3*iymx**3*sq30*z
       end do
    case (480)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -iymx*sq15*z*(9*z**2-2*iymx**2-3)/2.0d0
          sqy(ig,2,3) = ci*iymx*sq15*z*(9*z**2-2*iymx**2-3)/2.0d0
          sqy(ig,3,3) = iymx**2*sq15*(27*z**2-iymx**2-3)/4.0d0
       end do
    case (481)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-18.0d0)/(7.0d0*sq15)
          sqy(ig,2,1) = 18.0d0*ci/(7.0d0*sq15)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*(10*z**2-5*iymx**2-2)/sq5/4.0d0
          sqy(ig,2,2) = ci*sq3*(10*z**2-5*iymx**2-2)/sq5/4.0d0
          sqy(ig,3,2) = iymx*sq15*z
          sqy(ig,1,3) = sq15*(84*z**4-63*iymx**2*z**2-56*z**2+7*iymx**2+4)/56.0d0
          sqy(ig,2,3) = -ci*sq15*(84*z**4-63*iymx**2*z**2-56*z**2+7*iymx**2+4)/56.0d0
          sqy(ig,3,3) = -iymx*sq15*z*(24*z**2-3*iymx**2-8)/4.0d0
       end do
    case (482)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 18.0d0/(7.0d0*sq30)
          sqy(ig,1,2) = -2*iymx*sq5*z/sq6
          sqy(ig,2,2) = 2*ci*iymx*sq5*z/sq6
          sqy(ig,3,2) = -sq5*(30*z**2-5*iymx**2-6)/sq6/5.0d0
          sqy(ig,1,3) = iymx*sq5*z*(3*z**2-1)/sq6
          sqy(ig,2,3) = -ci*iymx*sq5*z*(3*z**2-1)/sq6
          sqy(ig,3,3) = sq5*(315*z**4-126*iymx**2*z**2-210*z**2+14*iymx**2+15)/sq6/28.0d0
       end do
    case (483)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)/(7.0d0*sq6)
          sqy(ig,2,1) = 9.0d0*ci/(7.0d0*sq6)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2-1)/sq6/2.0d0
          sqy(ig,2,2) = -ci*(5*z**2-1)/sq6/2.0d0
          sqy(ig,3,2) = -5*iymx*z/sq6
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,2,3) = 5.0d0*ci*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,3,3) = 5.0d0*iymx*z*(3*z**2-1)/(2.0d0*sq6)
       end do
    case (484)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*iymx**3*sq6/22.0d0
          sqy(ig,2,3) = 15.0d0*ci*iymx**3*sq6/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-45.0d0)*iymx**3*(44*z**2+11*iymx**2-4)/(44.0d0*sq6)
          sqy(ig,2,4) = 45.0d0*ci*iymx**3*(44*z**2+11*iymx**2-4)/(44.0d0*sq6)
          sqy(ig,3,4) = 15.0d0*iymx**4*sq6*z/4.0d0
       end do
    case (485)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 45.0d0*iymx**2*sq3*z/(11.0d0*sq10)
          sqy(ig,2,3) = (-45.0d0)*ci*iymx**2*sq3*z/(11.0d0*sq10)
          sqy(ig,3,3) = (-15.0d0)*iymx**3*sq3/(11.0d0*sq10)
          sqy(ig,1,4) = 25.0d0*iymx**2*sq3*z*(198*z**2+55*iymx**2-54)/(88.0d0*sq10)
          sqy(ig,2,4) = (-25.0d0)*ci*iymx**2*sq3*z*(198*z**2+55*iymx**2-54)/(88.0d0*sq10)
          sqy(ig,3,4) = (-25.0d0)*iymx**3*sq3*(198*z**2+11*iymx**2-18)/(88.0d0*sq10)
       end do
    case (486)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*iymx*sq15/7.0d0
          sqy(ig,2,2) = (-2.0d0)*ci*iymx*sq15/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*iymx*sq15*(21*z**2+14*iymx**2-3)/154.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iymx*sq15*(21*z**2+14*iymx**2-3)/154.0d0
          sqy(ig,3,3) = (-9.0d0)*iymx**2*sq15*z/22.0d0
          sqy(ig,1,4) = (-5.0d0)*iymx*sq15*(33*z**4+11*iymx**2*z**2-18*z**2-iymx**2+1)/22.0d0
          sqy(ig,2,4) = 5.0d0*ci*iymx*sq15*(33*z**4+11*iymx**2*z**2-18*z**2-iymx**2+1)/22.0d0
          sqy(ig,3,4) = 5.0d0*iymx**2*sq15*z*(132*z**2+11*iymx**2-36)/44.0d0
       end do
    case (487)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*sq15*z/7.0d0
          sqy(ig,2,2) = 2.0d0*ci*sq15*z/7.0d0
          sqy(ig,3,2) = 2.0d0*iymx*sq15/7.0d0
          sqy(ig,1,3) = (-3.0d0)*sq15*z*(112*z**2+63*iymx**2-48)/308.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq15*z*(112*z**2+63*iymx**2-48)/308.0d0
          sqy(ig,3,3) = 9.0d0*iymx*sq15*(112*z**2+7*iymx**2-16)/308.0d0
          sqy(ig,1,4) = 5.0d0*sq15*z*(66*z**4+33*iymx**2*z**2-60*z**2-9*iymx**2+10)/88.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*sq15*z*(66*z**4+33*iymx**2*z**2-60*z**2-9*iymx**2+10)/88.0d0
          sqy(ig,3,4) = (-5.0d0)*iymx*sq15*(330*z**4+33*iymx**2*z**2-180*z**2-3*iymx**2+10)/88.0d0
       end do
    case (488)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*iymx*sq5/(7.0d0*sq6)
          sqy(ig,2,2) = 2.0d0*ci*iymx*sq5/(7.0d0*sq6)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iymx*sq15*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = (-9.0d0)*ci*iymx*sq15*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = (-3.0d0)*sq15*z*(35*z**2+3*iymx**2-15)/(11.0d0*sq2)
          sqy(ig,1,4) = (-5.0d0)*iymx*sq5*(33*z**4-18*z**2+1)/(44.0d0*sq6)
          sqy(ig,2,4) = 5.0d0*ci*iymx*sq5*(33*z**4-18*z**2+1)/(44.0d0*sq6)
          sqy(ig,3,4) = 15.0d0*sq5*z*(99*z**4+11*iymx**2*z**2-90*z**2-3*iymx**2+15)/(22.0d0*sq6)
       end do
    case (489)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-25.0d0)*z/(7.0d0*sq6)
          sqy(ig,2,2) = -5*ci*z/sq6
          sqy(ig,3,2) = (-5.0d0)*(6*iypx+iymx)/(7.0d0*sq6)
          sqy(ig,1,3) = 75.0d0*sq6*z*(7*z**2-3)/308.0d0
          sqy(ig,2,3) = 15.0d0*ci*sq6*z*(7*z**2-3)/44.0d0
          sqy(ig,3,3) = 45.0d0*(6*iypx+iymx)*sq6*(7*z**2-1)/308.0d0
          sqy(ig,1,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
          sqy(ig,2,4) = (-35.0d0)*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
          sqy(ig,3,4) = (-25.0d0)*(6*iypx+iymx)*(33*z**4-18*z**2+1)/(88.0d0*sq6)
       end do
    case (490)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 75.0d0*iymx**4*sq7*z/8.0d0
          sqy(ig,2,4) = (-75.0d0)*ci*iymx**4*sq7*z/8.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**5*sq7/8.0d0
       end do
    case (491)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*iymx**3/11.0d0
          sqy(ig,2,3) = 45.0d0*ci*iymx**3/11.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-15.0d0)*iymx**3*(264*z**2-11*iymx**2-24)/88.0d0
          sqy(ig,2,4) = 15.0d0*ci*iymx**3*(264*z**2-11*iymx**2-24)/88.0d0
          sqy(ig,3,4) = 45.0d0*iymx**4*z/2.0d0
       end do
    case (492)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 45.0d0*iymx**2*sq3*z/22.0d0
          sqy(ig,2,3) = (-45.0d0)*ci*iymx**2*sq3*z/22.0d0
          sqy(ig,3,3) = (-15.0d0)*iymx**3*sq3/22.0d0
          sqy(ig,1,4) = 25.0d0*iymx**2*sq3*z*(99*z**2-11*iymx**2-27)/88.0d0
          sqy(ig,2,4) = (-25.0d0)*ci*iymx**2*sq3*z*(99*z**2-11*iymx**2-27)/88.0d0
          sqy(ig,3,4) = (-5.0d0)*iymx**3*sq3*(495*z**2-11*iymx**2-45)/88.0d0
       end do
    case (493)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*iymx*sq5/7.0d0
          sqy(ig,2,2) = (-4.0d0)*ci*iymx*sq5/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iymx*sq5*(14*z**2-7*iymx**2-2)/154.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*iymx*sq5*(14*z**2-7*iymx**2-2)/154.0d0
          sqy(ig,3,3) = (-9.0d0)*iymx**2*sq5*z/11.0d0
          sqy(ig,1,4) = (-5.0d0)*iymx*sq5*(132*z**4-33*iymx**2*z**2-72*z**2+3*iymx**2+4)/44.0d0
          sqy(ig,2,4) = 5.0d0*ci*iymx*sq5*(132*z**4-33*iymx**2*z**2-72*z**2+3*iymx**2+4)/44.0d0
          sqy(ig,3,4) = 15.0d0*iymx**2*sq5*z*(176*z**2-11*iymx**2-48)/88.0d0
       end do
    case (494)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*sq5*z/7.0d0
          sqy(ig,2,2) = 3.0d0*ci*sq5*z/7.0d0
          sqy(ig,3,2) = 3.0d0*iymx*sq5/7.0d0
          sqy(ig,1,3) = (-9.0d0)*sq5*z*(28*z**2-21*iymx**2-12)/154.0d0
          sqy(ig,2,3) = 9.0d0*ci*sq5*z*(28*z**2-21*iymx**2-12)/154.0d0
          sqy(ig,3,3) = 9.0d0*iymx*sq5*(84*z**2-7*iymx**2-12)/154.0d0
          sqy(ig,1,4) = 15.0d0*sq5*z*(33*z**4-22*iymx**2*z**2-30*z**2+6*iymx**2+5)/88.0d0
          sqy(ig,2,4) = (-15.0d0)*ci*sq5*z*(33*z**4-22*iymx**2*z**2-30*z**2+6*iymx**2+5)/88.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx*sq5*(165*z**4-22*iymx**2*z**2-90*z**2+2*iymx**2+5)/88.0d0
       end do
    case (495)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5.0d0*iymx/(7.0d0*sq3)
          sqy(ig,2,2) = (-5.0d0)*ci*iymx/(7.0d0*sq3)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*iymx*sq3*(7*z**2-1)/154.0d0
          sqy(ig,2,3) = 45.0d0*ci*iymx*sq3*(7*z**2-1)/154.0d0
          sqy(ig,3,3) = (-15.0d0)*sq3*z*(14*z**2-3*iymx**2-6)/22.0d0
          sqy(ig,1,4) = 25.0d0*iymx*(33*z**4-18*z**2+1)/(88.0d0*sq3)
          sqy(ig,2,4) = (-25.0d0)*ci*iymx*(33*z**4-18*z**2+1)/(88.0d0*sq3)
          sqy(ig,3,4) = 5.0d0*sq3*z*(198*z**4-55*iymx**2*z**2-180*z**2+15*iymx**2+30)/44.0d0
       end do
    case (496)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-10.0d0)*z/7.0d0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-5.0d0)*(iypx-iymx)/7.0d0
          sqy(ig,1,3) = 45.0d0*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 135.0d0*(iypx-iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = (-5.0d0)*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-25.0d0)*(iypx-iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (497)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*iymx**2*sq35/4.0d0
          sqy(ig,2,1) = 3.0d0*ci*iymx**2*sq35/4.0d0
          sqy(ig,3,1) = 0
       end do
    case (498)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (499)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iymx**2*sq35*z/4.0d0
          sqy(ig,2,2) = 3.0d0*ci*iymx**2*sq35*z/4.0d0
          sqy(ig,3,2) = iymx**3*sq35/4.0d0
       end do
    case (500)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*iymx*sq5/sq7
          sqy(ig,2,1) = 3*ci*iymx*sq5/sq7
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq5*(7*z**2-1)/sq7/2.0d0
          sqy(ig,2,2) = -ci*iymx*sq5*(7*z**2-1)/sq7/2.0d0
          sqy(ig,3,2) = -iymx**2*sq35*z/2.0d0
       end do
    case (501)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx**3*sq105/sq2
          sqy(ig,2,2) = -ci*iymx**3*sq105/sq2
          sqy(ig,3,2) = 0
       end do
    case (502)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iymx**2*sq35*z/(2.0d0*sq2)
          sqy(ig,2,2) = 3.0d0*ci*iymx**2*sq35*z/(2.0d0*sq2)
          sqy(ig,3,2) = iymx**3*sq35/sq2/2.0d0
       end do
    case (503)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*iymx*sq5/sq14
          sqy(ig,2,1) = 3*ci*iymx*sq5/sq14
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq5*(7*z**2-1)/sq14/2.0d0
          sqy(ig,2,2) = -ci*iymx*sq5*(7*z**2-1)/sq14/2.0d0
          sqy(ig,3,2) = -iymx**2*sq70*z/4.0d0
       end do
    case (504)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (505)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = iymx**3*sq105*z/sq2
          sqy(ig,2,3) = -ci*iymx**3*sq105*z/sq2
          sqy(ig,3,3) = -iymx**4*sq105/sq2/4.0d0
       end do
    case (506)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx**2*sq35/sq2/2.0d0
          sqy(ig,2,2) = -ci*iymx**2*sq35/sq2/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -iymx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,2,3) = ci*iymx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,3,3) = 3.0d0*iymx**3*sq35*z/(2.0d0*sq2)
       end do
    case (507)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq35*z/sq2
          sqy(ig,2,2) = ci*iymx*sq35*z/sq2
          sqy(ig,3,2) = iymx**2*sq35/sq2/2.0d0
          sqy(ig,1,3) = iymx*sq35*z*(3*z**2-1)/sq2/2.0d0
          sqy(ig,2,3) = -ci*iymx*sq35*z*(3*z**2-1)/sq2/2.0d0
          sqy(ig,3,3) = -iymx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
       end do
    case (508)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*sq6/sq35
          sqy(ig,2,1) = 3*ci*sq6/sq35
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq7*(5*z**2-1)/sq30
          sqy(ig,2,2) = -ci*sq7*(5*z**2-1)/sq30
          sqy(ig,3,2) = -10*iymx*sq7*z/sq30
          sqy(ig,1,3) = -sq5*(21*z**4-14*z**2+1)/sq42/4.0d0
          sqy(ig,2,3) = ci*sq5*(21*z**4-14*z**2+1)/sq42/4.0d0
          sqy(ig,3,3) = 7*iymx*sq5*z*(3*z**2-1)/sq42
       end do
    case (509)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-25.0d0)*iymx**4*sq42/16.0d0
          sqy(ig,2,3) = 25.0d0*ci*iymx**4*sq42/16.0d0
          sqy(ig,3,3) = 0
       end do
    case (510)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = iymx**3*sq210*z
          sqy(ig,2,3) = -ci*iymx**3*sq210*z
          sqy(ig,3,3) = -iymx**4*sq105/sq2/2.0d0
       end do
    case (511)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx**2*sq105/4.0d0
          sqy(ig,2,2) = -ci*iymx**2*sq105/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -iymx**2*sq105*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,2,3) = ci*iymx**2*sq105*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,3,3) = 3.0d0*iymx**3*sq105*z/4.0d0
       end do
    case (512)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq35*z/sq3
          sqy(ig,2,2) = ci*iymx*sq35*z/sq3
          sqy(ig,3,2) = iymx**2*sq35/sq3/2.0d0
          sqy(ig,1,3) = iymx*sq35*z*(3*z**2-1)/sq3/2.0d0
          sqy(ig,2,3) = -ci*iymx*sq35*z*(3*z**2-1)/sq3/2.0d0
          sqy(ig,3,3) = -iymx**2*sq35*(3*z-1)*(3*z+1)/sq3/4.0d0
       end do
    case (513)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -9/sq210
          sqy(ig,2,1) = 9*ci/sq210
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq7*(5*z**2-1)/sq30/2.0d0
          sqy(ig,2,2) = -ci*sq7*(5*z**2-1)/sq30/2.0d0
          sqy(ig,3,2) = -5*iymx*sq7*z/sq30
          sqy(ig,1,3) = -sq5*(21*z**4-14*z**2+1)/sq42/8.0d0
          sqy(ig,2,3) = ci*sq5*(21*z**4-14*z**2+1)/sq42/8.0d0
          sqy(ig,3,3) = 7.0d0*iymx*sq5*z*(3*z**2-1)/(2.0d0*sq42)
       end do
    case (514)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
       end do
    case (515)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-25.0d0)*iymx**4*sq42*z/16.0d0
          sqy(ig,2,4) = 25.0d0*ci*iymx**4*sq42*z/16.0d0
          sqy(ig,3,4) = 5.0d0*iymx**5*sq42/16.0d0
       end do
    case (516)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*iymx**3*sq105/(11.0d0*sq2)
          sqy(ig,2,3) = 3.0d0*ci*iymx**3*sq105/(11.0d0*sq2)
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 5.0d0*iymx**3*sq105*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,2,4) = (-5.0d0)*ci*iymx**3*sq105*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,3,4) = (-5.0d0)*iymx**4*sq105*z/(4.0d0*sq2)
       end do
    case (517)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 27.0d0*iymx**2*sq105*z/44.0d0
          sqy(ig,2,3) = (-27.0d0)*ci*iymx**2*sq105*z/44.0d0
          sqy(ig,3,3) = (-9.0d0)*iymx**3*sq105/44.0d0
          sqy(ig,1,4) = (-15.0d0)*iymx**2*sq105*z*(11*z**2-3)/88.0d0
          sqy(ig,2,4) = 15.0d0*ci*iymx**2*sq105*z*(11*z**2-3)/88.0d0
          sqy(ig,3,4) = 15.0d0*iymx**3*sq105*(11*z**2-1)/88.0d0
       end do
    case (518)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2*iymx*sq5/sq21
          sqy(ig,2,2) = -2*ci*iymx*sq5/sq21
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*iymx*sq15*(7*z**2-1)/(11.0d0*sq7)
          sqy(ig,2,3) = 9.0d0*ci*iymx*sq15*(7*z**2-1)/(11.0d0*sq7)
          sqy(ig,3,3) = 9.0d0*iymx**2*sq105*z/11.0d0
          sqy(ig,1,4) = 5.0d0*iymx*sq35*(33*z**4-18*z**2+1)/(44.0d0*sq3)
          sqy(ig,2,4) = (-5.0d0)*ci*iymx*sq35*(33*z**4-18*z**2+1)/(44.0d0*sq3)
          sqy(ig,3,4) = (-5.0d0)*iymx**2*sq105*z*(11*z**2-3)/22.0d0
       end do
    case (519)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -25*z/sq210
          sqy(ig,2,2) = 25*ci*z/sq210
          sqy(ig,3,2) = 25*iymx/sq210
          sqy(ig,1,3) = 15.0d0*sq30*z*(7*z**2-3)/(44.0d0*sq7)
          sqy(ig,2,3) = (-15.0d0)*ci*sq30*z*(7*z**2-3)/(44.0d0*sq7)
          sqy(ig,3,3) = (-45.0d0)*iymx*sq30*(7*z**2-1)/(44.0d0*sq7)
          sqy(ig,1,4) = (-25.0d0)*sq7*z*(33*z**4-30*z**2+5)/(88.0d0*sq30)
          sqy(ig,2,4) = 25.0d0*ci*sq7*z*(33*z**4-30*z**2+5)/(88.0d0*sq30)
          sqy(ig,3,4) = 125.0d0*iymx*sq7*(33*z**4-18*z**2+1)/(88.0d0*sq30)
       end do
    case (520)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -30*z/sq42
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 45.0d0*sq6*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-105.0d0)*z*(33*z**4-30*z**2+5)/(44.0d0*sq42)
       end do
    case (521)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 105.0d0*iymx**5/8.0d0
          sqy(ig,2,4) = (-105.0d0)*ci*iymx**5/8.0d0
          sqy(ig,3,4) = 0
       end do
    case (522)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-75.0d0)*iymx**4*sq7*z/8.0d0
          sqy(ig,2,4) = 75.0d0*ci*iymx**4*sq7*z/8.0d0
          sqy(ig,3,4) = 15.0d0*iymx**5*sq7/8.0d0
       end do
    case (523)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*iymx**3*sq21/22.0d0
          sqy(ig,2,3) = 15.0d0*ci*iymx**3*sq21/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 25.0d0*iymx**3*sq21*(11*z**2-1)/44.0d0
          sqy(ig,2,4) = (-25.0d0)*ci*iymx**3*sq21*(11*z**2-1)/44.0d0
          sqy(ig,3,4) = (-25.0d0)*iymx**4*sq21*z/8.0d0
       end do
    case (524)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 27.0d0*iymx**2*sq35*z/22.0d0
          sqy(ig,2,3) = (-27.0d0)*ci*iymx**2*sq35*z/22.0d0
          sqy(ig,3,3) = (-9.0d0)*iymx**3*sq35/22.0d0
          sqy(ig,1,4) = (-15.0d0)*iymx**2*sq35*z*(11*z**2-3)/44.0d0
          sqy(ig,2,4) = 15.0d0*ci*iymx**2*sq35*z*(11*z**2-3)/44.0d0
          sqy(ig,3,4) = 15.0d0*iymx**3*sq35*(11*z**2-1)/44.0d0
       end do
    case (525)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq5/sq7
          sqy(ig,2,2) = -ci*iymx*sq5/sq7
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-27.0d0)*iymx*sq5*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,2,3) = 27.0d0*ci*iymx*sq5*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,3,3) = 27.0d0*iymx**2*sq35*z/22.0d0
          sqy(ig,1,4) = 5.0d0*iymx*sq35*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*iymx*sq35*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**2*sq35*z*(11*z**2-3)/44.0d0
       end do
    case (526)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -5*z/sq21
          sqy(ig,2,2) = 5*ci*z/sq21
          sqy(ig,3,2) = 5*iymx/sq21
          sqy(ig,1,3) = 45.0d0*z*(7*z**2-3)/(22.0d0*sq21)
          sqy(ig,2,3) = (-45.0d0)*ci*z*(7*z**2-3)/(22.0d0*sq21)
          sqy(ig,3,3) = (-135.0d0)*iymx*(7*z**2-1)/(22.0d0*sq21)
          sqy(ig,1,4) = (-5.0d0)*sq7*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,2,4) = 5.0d0*ci*sq7*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,3,4) = 25.0d0*iymx*sq7*(33*z**4-18*z**2+1)/(88.0d0*sq3)
       end do
    case (527)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -5*z/sq7
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 45.0d0*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-5.0d0)*sq7*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (528)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 0
       end do
    case default
       write(6,*) 'getsqy_two_x() invalid k3 = ', k3
       stop
    end select

    if (ik3.lt.0) then
       sqy = conjg(sqy)
    end if
    return
  end subroutine getsqy_two_x

  subroutine getsqy_two_y(sqy,ik3,gk,nl,nkc,mll3)
    implicit none
    integer,intent(in):: ik3,nl,nkc
    integer,intent(out):: mll3
    real(kind=8),intent(in):: gk(4,nkc)
    complex(kind=8):: sqy(nkc,3,nl)
    !
    real(kind=8),parameter:: eps = 1.0d-12
    real(kind=8),parameter:: ci = (0.0d0, 1.0d0)
    real(kind=8),parameter:: sq2 = sqrt(2.0d0), &
         sq3 = sqrt(3.0d0), sq5 = sqrt(5.0d0), &
         sq6 = sqrt(6.0d0), sq7 = sqrt(7.0d0), &
         sq8 = sqrt(8.0d0), sq10 = sqrt(10.0d0), &
         sq14 = sqrt(14.0d0), &
         sq15 = sqrt(15.0d0), sq21 = sqrt(21.0d0), &
         sq30 = sqrt(30.0d0), sq35 = sqrt(35.0d0), &
         sq42 = sqrt(42.0d0), sq70 = sqrt(70.0d0), &
         sq105 = sqrt(105.0d0), sq210 = sqrt(210.0d0)
    !
    integer:: k3
    integer:: ig,ist
    real(kind=8):: x,y,z,r
    complex(kind=8):: iypx, iymx
    !     
    k3 = abs(ik3)
    !
    ! FOR G=0
    if (gk(4,1).lt.eps) then
       sqy(1,:,1:nl) = 0.0d0
       ist=2
    else
       ist=1
    end if

    select case(k3)
    case (1)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (2)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (3)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (4)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci
          sqy(ig,2,1) = -1
          sqy(ig,3,1) = 0
       end do
    case (5)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = ci
       end do
    case (6)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = -2*z
          sqy(ig,3,2) = ci*(iypx+iymx)
       end do
    case (7)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = ci
       end do
    case (8)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci
          sqy(ig,2,1) = -1
          sqy(ig,3,1) = 0
       end do
    case (9)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -2*ci*iymx
          sqy(ig,2,2) = -2*iymx
          sqy(ig,3,2) = 2*ci*z
       end do
    case (10)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 2*z
          sqy(ig,3,2) = -ci*(iypx+iymx)
       end do
    case (11)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (12)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq3/sq2
          sqy(ig,2,1) = -sq3/sq2
          sqy(ig,3,1) = 0
       end do
    case (13)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = ci*sq6*z
       end do
    case (14)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq3*z/sq2
          sqy(ig,2,2) = sq3*z/sq2
          sqy(ig,3,2) = -ci*iypx*sq3/sq2
       end do
    case (15)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (16)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci/sq2
          sqy(ig,2,1) = 1/sq2
          sqy(ig,3,1) = 0
       end do
    case (17)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = ci*sq2
       end do
    case (18)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -3*ci*z/sq2
          sqy(ig,2,2) = -z/sq2
          sqy(ig,3,2) = -ci*(iypx-2*iymx)/sq2
       end do
    case (19)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iypx*sq2
          sqy(ig,2,2) = -iypx*sq2
          sqy(ig,3,2) = -2*ci*sq2*z
       end do
    case (20)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = ci*sq3*z
       end do
    case (21)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 2*z
          sqy(ig,3,2) = -ci*(iypx+iymx)
       end do
    case (22)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -ci*sq2
       end do
    case (23)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci/sq2
          sqy(ig,2,1) = -1/sq2
          sqy(ig,3,1) = 0
       end do
    case (24)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iymx*sq2
          sqy(ig,2,2) = -iymx*sq2
          sqy(ig,3,2) = -2*ci*sq2*z
       end do
    case (25)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3*ci*z/sq2
          sqy(ig,2,2) = -z/sq2
          sqy(ig,3,2) = ci*(2*iypx-iymx)/sq2
       end do
    case (26)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq3*z
          sqy(ig,2,2) = -sq3*z
          sqy(ig,3,2) = ci*iymx*sq3
       end do
    case (27)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iymx
          sqy(ig,2,2) = iymx
          sqy(ig,3,2) = -4*ci*z
       end do
    case (28)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = -2*z
          sqy(ig,3,2) = ci*(iypx+iymx)
       end do
    case (29)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq3/sq2
          sqy(ig,2,1) = sq3/sq2
          sqy(ig,3,1) = 0
       end do
    case (30)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (31)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq3*z/sq2
          sqy(ig,2,2) = sq3*z/sq2
          sqy(ig,3,2) = -ci*iymx*sq3/sq2
       end do
    case (32)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = ci*sq6*z
       end do
    case (33)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -3*ci*iymx
          sqy(ig,2,2) = -3*iymx
          sqy(ig,3,2) = 0
       end do
    case (34)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq3*z
          sqy(ig,2,2) = sq3*z
          sqy(ig,3,2) = -ci*iymx*sq3
       end do
    case (35)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = ci*sq3*z
       end do
    case (36)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (37)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*iypx*sq6
          sqy(ig,2,1) = -iypx*sq6
          sqy(ig,3,1) = 0
       end do
    case (38)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3*ci*z/sq6
          sqy(ig,2,1) = -3*z/sq6
          sqy(ig,3,1) = 3*ci*iypx/sq6
       end do
    case (39)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -ci*sq6/5.0d0
          sqy(ig,1,2) = ci*iypx*sq6*z
          sqy(ig,2,2) = -iypx*sq6*z
          sqy(ig,3,2) = 3.0d0*ci*sq2*(15*z**2+5*iypx**2-3)/(10.0d0*sq3)
       end do
    case (40)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*sq3/sq2/5.0d0
          sqy(ig,2,1) = sq3/sq2/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq3*(5*z**2+15*iypx**2-1)/sq2/5.0d0
          sqy(ig,2,2) = sq3*(5*z**2+15*iypx**2-1)/sq2/5.0d0
          sqy(ig,3,2) = -ci*iypx*sq6*z
       end do
    case (41)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*ci/5.0d0
          sqy(ig,2,1) = (-6)/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = 3.0d0*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -3*ci*iypx*z
       end do
    case (42)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = ci*sq3/5.0d0
          sqy(ig,1,2) = 2*ci*iypx*sq3*z
          sqy(ig,2,2) = -2*iypx*sq3*z
          sqy(ig,3,2) = -ci*sq3*(15*z**2-10*iypx**2-3)/10.0d0
       end do
    case (43)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq3/5.0d0
          sqy(ig,2,1) = -sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq3*(10*z**2-15*iypx**2-2)/10.0d0
          sqy(ig,2,2) = -sq3*(10*z**2-15*iypx**2-2)/10.0d0
          sqy(ig,3,2) = 2*ci*iypx*sq3*z
       end do
    case (44)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -3*ci*iypx*z
          sqy(ig,2,2) = 3*iypx*z
          sqy(ig,3,2) = (-3.0d0)*ci*iypx**2/2.0d0
       end do
    case (45)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = (-12.0d0)*z/7.0d0
          sqy(ig,3,2) = 6.0d0*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 3.0d0*z*(7*z**2-3)/7.0d0
          sqy(ig,3,3) = (-9.0d0)*ci*(iypx+iymx)*(7*z**2-1)/14.0d0
       end do
    case (46)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3*ci*z/sq2
          sqy(ig,2,1) = -3*z/sq2
          sqy(ig,3,1) = 3*ci*iypx/sq2
       end do
    case (47)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3*ci*sq2*z
       end do
    case (48)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci/sq2
          sqy(ig,2,1) = -1/sq2/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = (-3.0d0)*sq2*(5*z**2-1)/5.0d0
          sqy(ig,3,2) = 3*ci*(iypx+iymx)*sq2*z
       end do
    case (49)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-2.0d0)*ci*sq2/5.0d0
          sqy(ig,1,2) = -3*ci*iypx*sq2*z
          sqy(ig,2,2) = 3*iypx*sq2*z
          sqy(ig,3,2) = (-3.0d0)*ci*(15*z**2+5*iypx**2-3)/(5.0d0*sq2)
       end do
    case (50)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*ci*sq3/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-9.0d0)*ci*sq3*(5*z**2-1)/10.0d0
       end do
    case (51)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*ci/5.0d0
          sqy(ig,2,1) = (-4)/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 9.0d0*ci*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = (-3.0d0)*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = 3*ci*(2*iypx-iymx)*z
       end do
    case (52)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 4.0d0*ci/5.0d0
          sqy(ig,1,2) = -3*ci*iypx*z
          sqy(ig,2,2) = 3*iypx*z
          sqy(ig,3,2) = 3.0d0*ci*(30*z**2-5*iypx**2-6)/10.0d0
       end do
    case (53)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq3/5.0d0
          sqy(ig,2,1) = -sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*sq3*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = 3.0d0*sq3*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -3*ci*iypx*sq3*z
       end do
    case (54)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-4.0d0)*ci*iymx*sq3/7.0d0
          sqy(ig,2,2) = (-4.0d0)*iymx*sq3/7.0d0
          sqy(ig,3,2) = 3.0d0*ci*sq3*z/7.0d0
          sqy(ig,1,3) = 3.0d0*ci*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,2,3) = 3.0d0*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*sq3*z*(14*z**2+7*iymx**2-6)/7.0d0
       end do
    case (55)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = (-6.0d0)*z/7.0d0
          sqy(ig,3,2) = 3.0d0*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = (-9.0d0)*z*(7*z**2-3)/7.0d0
          sqy(ig,3,3) = 27.0d0*ci*(iypx+iymx)*(7*z**2-1)/14.0d0
       end do
    case (56)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3*ci*sq2*z
       end do
    case (57)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*ci*z/sq2
          sqy(ig,2,1) = -3*z/sq2
          sqy(ig,3,1) = 3*ci*iymx/sq2
       end do
    case (58)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 2.0d0*ci*sq2/5.0d0
          sqy(ig,1,2) = -3*ci*iymx*sq2*z
          sqy(ig,2,2) = -3*iymx*sq2*z
          sqy(ig,3,2) = 3.0d0*ci*(15*z**2+5*iymx**2-3)/(5.0d0*sq2)
       end do
    case (59)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci/sq2
          sqy(ig,2,1) = 1/sq2/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 3.0d0*sq2*(5*z**2-1)/5.0d0
          sqy(ig,3,2) = -3*ci*(iypx+iymx)*sq2*z
       end do
    case (60)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*sq3/5.0d0
          sqy(ig,2,1) = -sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*sq3*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = 3.0d0*sq3*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -3*ci*iymx*sq3*z
       end do
    case (61)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 4.0d0*ci/5.0d0
          sqy(ig,1,2) = 3*ci*iymx*z
          sqy(ig,2,2) = 3*iymx*z
          sqy(ig,3,2) = 3.0d0*ci*(30*z**2-5*iymx**2-6)/10.0d0
       end do
    case (62)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-2.0d0)*ci/5.0d0
          sqy(ig,2,1) = (-4)/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*ci*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = (-3.0d0)*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -3*ci*(iypx-2*iymx)*z
       end do
    case (63)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*ci*sq3/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-9.0d0)*ci*sq3*(5*z**2-1)/10.0d0
       end do
    case (64)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq3*z/7.0d0
          sqy(ig,2,2) = sq3*z/7.0d0
          sqy(ig,3,2) = -ci*iymx*sq3/7.0d0
          sqy(ig,1,3) = 3.0d0*ci*sq3*z*(7*z**2+21*iymx**2-3)/14.0d0
          sqy(ig,2,3) = 3.0d0*sq3*z*(7*z**2+21*iymx**2-3)/14.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*iymx*sq3*(21*z**2+7*iymx**2-3)/14.0d0
       end do
    case (65)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*ci*iymx/7.0d0
          sqy(ig,2,2) = (-9.0d0)*iymx/7.0d0
          sqy(ig,3,2) = 12.0d0*ci*z/7.0d0
          sqy(ig,1,3) = (-9.0d0)*ci*iymx*(7*z**2-1)/7.0d0
          sqy(ig,2,3) = (-9.0d0)*iymx*(7*z**2-1)/7.0d0
          sqy(ig,3,3) = 9.0d0*ci*z*(14*z**2+7*iymx**2-6)/7.0d0
       end do
    case (66)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 6.0d0*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 9.0d0*z*(7*z**2-3)/7.0d0
          sqy(ig,3,3) = (-27.0d0)*ci*(iypx+iymx)*(7*z**2-1)/14.0d0
       end do
    case (67)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*ci*z/sq6
          sqy(ig,2,1) = -3*z/sq6
          sqy(ig,3,1) = 3*ci*iymx/sq6
       end do
    case (68)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*iymx*sq6
          sqy(ig,2,1) = -iymx*sq6
          sqy(ig,3,1) = 0
       end do
    case (69)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci/(5.0d0*sq6)
          sqy(ig,2,1) = (-3.0d0)/(5.0d0*sq6)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq6*(5*z**2+15*iymx**2-1)/10.0d0
          sqy(ig,2,2) = -sq6*(5*z**2+15*iymx**2-1)/10.0d0
          sqy(ig,3,2) = ci*iymx*sq6*z
       end do
    case (70)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = ci*sq6/5.0d0
          sqy(ig,1,2) = ci*iymx*sq6*z
          sqy(ig,2,2) = iymx*sq6*z
          sqy(ig,3,2) = (-3.0d0)*ci*(15*z**2+5*iymx**2-3)/(5.0d0*sq6)
       end do
    case (71)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3*ci*iymx*z
          sqy(ig,2,2) = 3*iymx*z
          sqy(ig,3,2) = (-3.0d0)*ci*iymx**2/2.0d0
       end do
    case (72)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*sq3/5.0d0
          sqy(ig,2,1) = -sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq3*(10*z**2-15*iymx**2-2)/10.0d0
          sqy(ig,2,2) = -sq3*(10*z**2-15*iymx**2-2)/10.0d0
          sqy(ig,3,2) = 2*ci*iymx*sq3*z
       end do
    case (73)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = ci*sq3/5.0d0
          sqy(ig,1,2) = -2*ci*iymx*sq3*z
          sqy(ig,2,2) = -2*iymx*sq3*z
          sqy(ig,3,2) = -ci*sq3*(15*z**2-10*iymx**2-3)/10.0d0
       end do
    case (74)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-6.0d0)*ci/5.0d0
          sqy(ig,2,1) = (-6)/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = 3.0d0*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -3*ci*iymx*z
       end do
    case (75)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*iymx/7.0d0
          sqy(ig,2,2) = 3.0d0*iymx/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*ci*iymx*(7*z**2+14*iymx**2-1)/7.0d0
          sqy(ig,2,3) = 3.0d0*iymx*(7*z**2+14*iymx**2-1)/7.0d0
          sqy(ig,3,3) = -3*ci*iymx**2*z
       end do
    case (76)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq3*z/7.0d0
          sqy(ig,2,2) = -sq3*z/7.0d0
          sqy(ig,3,2) = ci*iymx*sq3/7.0d0
          sqy(ig,1,3) = (-3.0d0)*ci*sq3*z*(7*z**2+21*iymx**2-3)/14.0d0
          sqy(ig,2,3) = (-3.0d0)*sq3*z*(7*z**2+21*iymx**2-3)/14.0d0
          sqy(ig,3,3) = 3.0d0*ci*iymx*sq3*(21*z**2+7*iymx**2-3)/14.0d0
       end do
    case (77)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-4.0d0)*ci*iymx*sq3/7.0d0
          sqy(ig,2,2) = (-4.0d0)*iymx*sq3/7.0d0
          sqy(ig,3,2) = 3.0d0*ci*sq3*z/7.0d0
          sqy(ig,1,3) = 3.0d0*ci*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,2,3) = 3.0d0*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*sq3*z*(14*z**2+7*iymx**2-6)/7.0d0
       end do
    case (78)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 12.0d0*z/7.0d0
          sqy(ig,3,2) = (-6.0d0)*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = (-3.0d0)*z*(7*z**2-3)/7.0d0
          sqy(ig,3,3) = 9.0d0*ci*(iypx+iymx)*(7*z**2-1)/14.0d0
       end do
    case (79)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (80)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*iypx*sq30/2.0d0
          sqy(ig,2,1) = -iypx*sq30/2.0d0
          sqy(ig,3,1) = 0
       end do
    case (81)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*sq30/5.0d0
          sqy(ig,2,1) = sq30/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq30*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = -sq30*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = ci*iypx*sq30*z/2.0d0
       end do
    case (82)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -15*ci*iypx*z/sq30
          sqy(ig,2,2) = 15*iypx*z/sq30
          sqy(ig,3,2) = (-15.0d0)*ci*iypx**2/(2.0d0*sq30)
       end do
    case (83)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (84)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq15/5.0d0
          sqy(ig,2,1) = -sq15/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq15*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = sq15*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = -ci*iypx*sq15*z/2.0d0
       end do
    case (85)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iypx*sq15*z
          sqy(ig,2,2) = -iypx*sq15*z
          sqy(ig,3,2) = ci*iypx**2*sq15/2.0d0
       end do
    case (86)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*ci*iypx**2*sq5/4.0d0
          sqy(ig,2,2) = 9.0d0*iypx**2*sq5/4.0d0
          sqy(ig,3,2) = 0
       end do
    case (87)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 12.0d0*ci*sq5*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-3.0d0)*ci*sq5*z*(7*z**2-3)/7.0d0
       end do
    case (88)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*sq15*z/7.0d0
          sqy(ig,2,2) = 3.0d0*sq15*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*iypx*sq15/7.0d0
          sqy(ig,1,3) = 3.0d0*ci*sq15*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = (-3.0d0)*sq15*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = 9.0d0*ci*iypx*sq15*(7*z**2-1)/28.0d0
       end do
    case (89)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*ci*iypx*sq15/7.0d0
          sqy(ig,2,2) = (-2.0d0)*iypx*sq15/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*ci*iypx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,2,3) = 3.0d0*iypx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*iypx**2*sq15*z/2.0d0
       end do
    case (90)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*ci*iypx**2*sq5*z/4.0d0
          sqy(ig,2,3) = (-9.0d0)*iypx**2*sq5*z/4.0d0
          sqy(ig,3,3) = 3.0d0*ci*iypx**3*sq5/4.0d0
       end do
    case (91)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
       end do
    case (92)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*iypx*sq6/2.0d0
          sqy(ig,2,1) = iypx*sq6/2.0d0
          sqy(ig,3,1) = 0
       end do
    case (93)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq6*z
          sqy(ig,2,1) = -sq6*z
          sqy(ig,3,1) = ci*iypx*sq6
       end do
    case (94)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-2.0d0)*ci*sq6/5.0d0
          sqy(ig,1,2) = -3*ci*iypx*z/sq6
          sqy(ig,2,2) = 3*iypx*z/sq6
          sqy(ig,3,2) = 3.0d0*ci*(60*z**2-5*iypx**2-12)/(10.0d0*sq6)
       end do
    case (95)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*sq6/5.0d0
          sqy(ig,2,1) = sq6/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq6*(20*z**2-15*iypx**2-4)/20.0d0
          sqy(ig,2,2) = sq6*(20*z**2-15*iypx**2-4)/20.0d0
          sqy(ig,3,2) = -2*ci*iypx*sq6*z
       end do
    case (96)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci/5.0d0
          sqy(ig,2,1) = 3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = (-3.0d0)*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = 3.0d0*ci*iypx*z/2.0d0
       end do
    case (97)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 2.0d0*ci*sq3/5.0d0
          sqy(ig,1,2) = -ci*iypx*sq3*z
          sqy(ig,2,2) = iypx*sq3*z
          sqy(ig,3,2) = -ci*sq3*(30*z**2+5*iypx**2-6)/10.0d0
       end do
    case (98)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*ci*sq3/5.0d0
          sqy(ig,2,1) = (-2.0d0)*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq3*(40*z**2+15*iypx**2-8)/20.0d0
          sqy(ig,2,2) = -sq3*(40*z**2+15*iypx**2-8)/20.0d0
          sqy(ig,3,2) = 4*ci*iypx*sq3*z
       end do
    case (99)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -6*ci*iypx*z
          sqy(ig,2,2) = 6*iypx*z
          sqy(ig,3,2) = -3*ci*iypx**2
       end do
    case (100)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-15.0d0)*ci*z/7.0d0
          sqy(ig,2,2) = (-9.0d0)*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*(iypx-4*iymx)/7.0d0
          sqy(ig,1,3) = 15.0d0*ci*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = 9.0d0*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = 9.0d0*ci*(iypx-4*iymx)*(7*z**2-1)/28.0d0
       end do
    case (101)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*ci*iypx*sq3/7.0d0
          sqy(ig,2,2) = (-2.0d0)*iypx*sq3/7.0d0
          sqy(ig,3,2) = (-6.0d0)*ci*sq3*z/7.0d0
          sqy(ig,1,3) = (-3.0d0)*ci*iypx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,2,3) = 3.0d0*iypx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,3,3) = 3.0d0*ci*sq3*z*(56*z**2-7*iypx**2-24)/14.0d0
       end do
    case (102)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*ci*sq3*z/7.0d0
          sqy(ig,2,2) = 2.0d0*sq3*z/7.0d0
          sqy(ig,3,2) = (-2.0d0)*ci*iypx*sq3/7.0d0
          sqy(ig,1,3) = (-3.0d0)*ci*sq3*z*(28*z**2-21*iypx**2-12)/28.0d0
          sqy(ig,2,3) = 3.0d0*sq3*z*(28*z**2-21*iypx**2-12)/28.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*iypx*sq3*(84*z**2-7*iypx**2-12)/28.0d0
       end do
    case (103)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 6.0d0*ci*iypx/7.0d0
          sqy(ig,2,2) = (-6.0d0)*iypx/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*ci*iypx*(14*z**2-7*iypx**2-2)/7.0d0
          sqy(ig,2,3) = (-3.0d0)*iypx*(14*z**2-7*iypx**2-2)/7.0d0
          sqy(ig,3,3) = 6*ci*iypx**2*z
       end do
    case (104)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 6.0d0*ci*sq5*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-3.0d0)*ci*sq5*z*(7*z**2-3)/14.0d0
       end do
    case (105)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 12.0d0*z/7.0d0
          sqy(ig,3,2) = (-6.0d0)*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = (-3.0d0)*z*(7*z**2-3)/7.0d0
          sqy(ig,3,3) = 9.0d0*ci*(iypx+iymx)*(7*z**2-1)/14.0d0
       end do
    case (106)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*sq3*z
          sqy(ig,2,1) = sq3*z
          sqy(ig,3,1) = -ci*iypx*sq3
       end do
    case (107)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3*ci*sq3*z
       end do
    case (108)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 2.0d0*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq3*(5*z**2-1)/2.0d0
          sqy(ig,2,2) = -sq3*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -ci*(2*iypx-3*iymx)*sq3*z
       end do
    case (109)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-2.0d0)*ci*sq3/5.0d0
          sqy(ig,1,2) = 2*ci*iypx*sq3*z
          sqy(ig,2,2) = -2*iypx*sq3*z
          sqy(ig,3,2) = -ci*sq3*(45*z**2-10*iypx**2-9)/10.0d0
       end do
    case (110)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-3.0d0)*ci*sq2/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 9.0d0*ci*(5*z**2-1)/(5.0d0*sq2)
       end do
    case (111)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq3/(5.0d0*sq2)
          sqy(ig,2,1) = sq3/sq2/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq3*(5*z**2-1)/sq2/10.0d0
          sqy(ig,2,2) = 7.0d0*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = -ci*(4*iypx+3*iymx)*sq3*z/sq2
       end do
    case (112)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 2.0d0*ci*sq6/5.0d0
          sqy(ig,1,2) = ci*iypx*sq6*z
          sqy(ig,2,2) = -iypx*sq6*z
          sqy(ig,3,2) = ci*sq3*(45*z**2+5*iypx**2-9)/sq2/5.0d0
       end do
    case (113)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci/(5.0d0*sq2)
          sqy(ig,2,1) = (-3.0d0)/(5.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*ci*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = 9.0d0*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = -9*ci*iypx*z/sq2
       end do
    case (114)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-6.0d0)*ci*iymx*sq2/7.0d0
          sqy(ig,2,2) = (-6.0d0)*iymx*sq2/7.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*sq2*z/7.0d0
          sqy(ig,1,3) = 9.0d0*ci*iymx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,3) = 9.0d0*iymx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*ci*z*(28*z**2-21*iymx**2-12)/(7.0d0*sq2)
       end do
    case (115)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*ci*sq3*z/(7.0d0*sq2)
          sqy(ig,2,2) = -sq3*z/sq2/7.0d0
          sqy(ig,3,2) = -ci*(2*iypx-3*iymx)*sq3/sq2/7.0d0
          sqy(ig,1,3) = (-15.0d0)*ci*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,3) = (-3.0d0)*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,3) = (-9.0d0)*ci*(2*iypx-3*iymx)*sq3*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (116)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*iypx*sq6/7.0d0
          sqy(ig,2,2) = (-3.0d0)*iypx*sq6/7.0d0
          sqy(ig,3,2) = (-6.0d0)*ci*sq6*z/7.0d0
          sqy(ig,1,3) = 3.0d0*ci*iypx*sq6*(7*z**2-1)/7.0d0
          sqy(ig,2,3) = (-3.0d0)*iypx*sq6*(7*z**2-1)/7.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*sq6*z*(21*z**2-7*iypx**2-9)/7.0d0
       end do
    case (117)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*z/(7.0d0*sq2)
          sqy(ig,2,2) = (-3.0d0)*z/(7.0d0*sq2)
          sqy(ig,3,2) = 3.0d0*ci*iypx/(7.0d0*sq2)
          sqy(ig,1,3) = 9.0d0*ci*z*(7*z**2-14*iypx**2-3)/(14.0d0*sq2)
          sqy(ig,2,3) = (-9.0d0)*z*(7*z**2-14*iypx**2-3)/(14.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*ci*iypx*(63*z**2-14*iypx**2-9)/(14.0d0*sq2)
       end do
    case (118)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*sq10*z/7.0d0
          sqy(ig,2,2) = (-3.0d0)*sq10*z/7.0d0
          sqy(ig,3,2) = 3.0d0*ci*iymx*sq10/7.0d0
          sqy(ig,1,3) = 3.0d0*ci*sq10*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = 3.0d0*sq10*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = (-9.0d0)*ci*iymx*sq10*(7*z**2-1)/28.0d0
       end do
    case (119)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*iymx*sq2/7.0d0
          sqy(ig,2,2) = 3.0d0*iymx*sq2/7.0d0
          sqy(ig,3,2) = (-6.0d0)*ci*sq2*z/7.0d0
          sqy(ig,1,3) = (-9.0d0)*ci*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,3) = (-9.0d0)*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*ci*z*(112*z**2+21*iymx**2-48)/(14.0d0*sq2)
       end do
    case (120)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 6.0d0*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 9.0d0*z*(7*z**2-3)/7.0d0
          sqy(ig,3,3) = (-27.0d0)*ci*(iypx+iymx)*(7*z**2-1)/14.0d0
       end do
    case (121)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -3*ci*sq3*z
       end do
    case (122)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*sq3*z
          sqy(ig,2,1) = -sq3*z
          sqy(ig,3,1) = ci*iymx*sq3
       end do
    case (123)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-2.0d0)*ci*sq3/5.0d0
          sqy(ig,1,2) = -2*ci*iymx*sq3*z
          sqy(ig,2,2) = -2*iymx*sq3*z
          sqy(ig,3,2) = -ci*sq3*(45*z**2-10*iymx**2-9)/10.0d0
       end do
    case (124)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 2.0d0*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq3*(5*z**2-1)/2.0d0
          sqy(ig,2,2) = -sq3*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = ci*(3*iypx-2*iymx)*sq3*z
       end do
    case (125)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci/(5.0d0*sq2)
          sqy(ig,2,1) = 3.0d0/(5.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*ci*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = (-9.0d0)*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = 9*ci*iymx*z/sq2
       end do
    case (126)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-2.0d0)*ci*sq6/5.0d0
          sqy(ig,1,2) = ci*iymx*sq6*z
          sqy(ig,2,2) = iymx*sq6*z
          sqy(ig,3,2) = -ci*sq6*(45*z**2+5*iymx**2-9)/10.0d0
       end do
    case (127)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq3/(5.0d0*sq2)
          sqy(ig,2,1) = -sq3/sq2/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq3*(5*z**2-1)/sq2/10.0d0
          sqy(ig,2,2) = (-7.0d0)*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = ci*(3*iypx+4*iymx)*sq3*z/sq2
       end do
    case (128)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*ci*sq2/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-9.0d0)*ci*(5*z**2-1)/(5.0d0*sq2)
       end do
    case (129)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*z/(7.0d0*sq2)
          sqy(ig,2,2) = (-3.0d0)*z/(7.0d0*sq2)
          sqy(ig,3,2) = 3.0d0*ci*iymx/(7.0d0*sq2)
          sqy(ig,1,3) = (-9.0d0)*ci*z*(7*z**2-14*iymx**2-3)/(14.0d0*sq2)
          sqy(ig,2,3) = (-9.0d0)*z*(7*z**2-14*iymx**2-3)/(14.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*ci*iymx*(63*z**2-14*iymx**2-9)/(14.0d0*sq2)
       end do
    case (130)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*iymx*sq6/7.0d0
          sqy(ig,2,2) = (-3.0d0)*iymx*sq6/7.0d0
          sqy(ig,3,2) = (-6.0d0)*ci*sq6*z/7.0d0
          sqy(ig,1,3) = (-3.0d0)*ci*iymx*sq6*(7*z**2-1)/7.0d0
          sqy(ig,2,3) = (-3.0d0)*iymx*sq6*(7*z**2-1)/7.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*sq6*z*(21*z**2-7*iymx**2-9)/7.0d0
       end do
    case (131)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 15.0d0*ci*z/(7.0d0*sq6)
          sqy(ig,2,2) = (-3.0d0)*z/(7.0d0*sq6)
          sqy(ig,3,2) = 3.0d0*ci*(3*iypx-2*iymx)/(7.0d0*sq6)
          sqy(ig,1,3) = 15.0d0*ci*sq6*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = (-3.0d0)*sq6*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = 9.0d0*ci*(3*iypx-2*iymx)*sq6*(7*z**2-1)/28.0d0
       end do
    case (132)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 6.0d0*ci*iypx*sq2/7.0d0
          sqy(ig,2,2) = (-6.0d0)*iypx*sq2/7.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*sq2*z/7.0d0
          sqy(ig,1,3) = (-9.0d0)*ci*iypx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,3) = 9.0d0*iypx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*ci*z*(28*z**2-21*iypx**2-12)/(7.0d0*sq2)
       end do
    case (133)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*iymx*sq10/7.0d0
          sqy(ig,2,2) = (-3.0d0)*iymx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*ci*iymx*sq10*(7*z**2-1)/28.0d0
          sqy(ig,2,3) = 9.0d0*iymx*sq10*(7*z**2-1)/28.0d0
          sqy(ig,3,3) = (-9.0d0)*ci*iymx**2*sq10*z/4.0d0
       end do
    case (134)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*sq2*z/7.0d0
          sqy(ig,2,2) = (-3.0d0)*sq2*z/7.0d0
          sqy(ig,3,2) = 3.0d0*ci*iymx*sq2/7.0d0
          sqy(ig,1,3) = (-9.0d0)*ci*z*(14*z**2+7*iymx**2-6)/(14.0d0*sq2)
          sqy(ig,2,3) = (-9.0d0)*z*(14*z**2+7*iymx**2-6)/(14.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*ci*iymx*(126*z**2+7*iymx**2-18)/(14.0d0*sq2)
       end do
    case (135)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 6.0d0*ci*iymx/7.0d0
          sqy(ig,2,2) = 6.0d0*iymx/7.0d0
          sqy(ig,3,2) = (-18.0d0)*ci*z/7.0d0
          sqy(ig,1,3) = 6.0d0*ci*iymx*(7*z**2-1)/7.0d0
          sqy(ig,2,3) = 6.0d0*iymx*(7*z**2-1)/7.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*z*(63*z**2+14*iymx**2-27)/7.0d0
       end do
    case (136)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = (-6.0d0)*z/7.0d0
          sqy(ig,3,2) = 3.0d0*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = (-9.0d0)*z*(7*z**2-3)/7.0d0
          sqy(ig,3,3) = 27.0d0*ci*(iypx+iymx)*(7*z**2-1)/14.0d0
       end do
    case (137)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq6*z
          sqy(ig,2,1) = sq6*z
          sqy(ig,3,1) = -ci*iymx*sq6
       end do
    case (138)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*ci*iymx/sq6
          sqy(ig,2,1) = -3*iymx/sq6
          sqy(ig,3,1) = 0
       end do
    case (139)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq6/5.0d0
          sqy(ig,2,1) = sq6/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq6*(20*z**2-15*iymx**2-4)/20.0d0
          sqy(ig,2,2) = sq6*(20*z**2-15*iymx**2-4)/20.0d0
          sqy(ig,3,2) = -2*ci*iymx*sq6*z
       end do
    case (140)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-2.0d0)*ci*sq6/5.0d0
          sqy(ig,1,2) = 3*ci*iymx*z/sq6
          sqy(ig,2,2) = 3*iymx*z/sq6
          sqy(ig,3,2) = 3.0d0*ci*(60*z**2-5*iymx**2-12)/(10.0d0*sq6)
       end do
    case (141)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -6*ci*iymx*z
          sqy(ig,2,2) = -6*iymx*z
          sqy(ig,3,2) = 3*ci*iymx**2
       end do
    case (142)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*ci*sq3/5.0d0
          sqy(ig,2,1) = 2.0d0*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq3*(40*z**2+15*iymx**2-8)/20.0d0
          sqy(ig,2,2) = sq3*(40*z**2+15*iymx**2-8)/20.0d0
          sqy(ig,3,2) = -4*ci*iymx*sq3*z
       end do
    case (143)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-2.0d0)*ci*sq3/5.0d0
          sqy(ig,1,2) = -ci*iymx*sq3*z
          sqy(ig,2,2) = -iymx*sq3*z
          sqy(ig,3,2) = ci*sq3*(30*z**2+5*iymx**2-6)/10.0d0
       end do
    case (144)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci/5.0d0
          sqy(ig,2,1) = (-3)/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = 3.0d0*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*iymx*z/2.0d0
       end do
    case (145)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-6.0d0)*ci*iymx/7.0d0
          sqy(ig,2,2) = (-6.0d0)*iymx/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*ci*iymx*(14*z**2-7*iymx**2-2)/7.0d0
          sqy(ig,2,3) = (-3.0d0)*iymx*(14*z**2-7*iymx**2-2)/7.0d0
          sqy(ig,3,3) = 6*ci*iymx**2*z
       end do
    case (146)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*ci*sq3*z/7.0d0
          sqy(ig,2,2) = 2.0d0*sq3*z/7.0d0
          sqy(ig,3,2) = (-2.0d0)*ci*iymx*sq3/7.0d0
          sqy(ig,1,3) = 3.0d0*ci*sq3*z*(28*z**2-21*iymx**2-12)/28.0d0
          sqy(ig,2,3) = 3.0d0*sq3*z*(28*z**2-21*iymx**2-12)/28.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*iymx*sq3*(84*z**2-7*iymx**2-12)/28.0d0
       end do
    case (147)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*ci*iymx*sq3/7.0d0
          sqy(ig,2,2) = (-2.0d0)*iymx*sq3/7.0d0
          sqy(ig,3,2) = (-6.0d0)*ci*sq3*z/7.0d0
          sqy(ig,1,3) = 3.0d0*ci*iymx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,2,3) = 3.0d0*iymx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,3,3) = 3.0d0*ci*sq3*z*(56*z**2-7*iymx**2-24)/14.0d0
       end do
    case (148)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 15.0d0*ci*z/7.0d0
          sqy(ig,2,2) = (-9.0d0)*z/7.0d0
          sqy(ig,3,2) = 3.0d0*ci*(4*iypx-iymx)/7.0d0
          sqy(ig,1,3) = (-15.0d0)*ci*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = 9.0d0*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = (-9.0d0)*ci*(4*iypx-iymx)*(7*z**2-1)/28.0d0
       end do
    case (149)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*ci*iymx**2*sq5*z/2.0d0
          sqy(ig,2,3) = 9.0d0*iymx**2*sq5*z/2.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*iymx**3*sq5/2.0d0
       end do
    case (150)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-12.0d0)*ci*iymx/7.0d0
          sqy(ig,2,2) = (-12.0d0)*iymx/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*ci*iymx*(56*z**2+7*iymx**2-8)/14.0d0
          sqy(ig,2,3) = (-3.0d0)*iymx*(56*z**2+7*iymx**2-8)/14.0d0
          sqy(ig,3,3) = 12*ci*iymx**2*z
       end do
    case (151)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*sq2*z/7.0d0
          sqy(ig,2,2) = 3.0d0*sq2*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*iymx*sq2/7.0d0
          sqy(ig,1,3) = 9.0d0*ci*z*(14*z**2+7*iymx**2-6)/(14.0d0*sq2)
          sqy(ig,2,3) = 9.0d0*z*(14*z**2+7*iymx**2-6)/(14.0d0*sq2)
          sqy(ig,3,3) = (-3.0d0)*ci*iymx*(126*z**2+7*iymx**2-18)/(14.0d0*sq2)
       end do
    case (152)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*iymx*sq2/7.0d0
          sqy(ig,2,2) = 3.0d0*iymx*sq2/7.0d0
          sqy(ig,3,2) = (-6.0d0)*ci*sq2*z/7.0d0
          sqy(ig,1,3) = (-9.0d0)*ci*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,3) = (-9.0d0)*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*ci*z*(112*z**2+21*iymx**2-48)/(14.0d0*sq2)
       end do
    case (153)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = (-12.0d0)*z/7.0d0
          sqy(ig,3,2) = 6.0d0*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 3.0d0*z*(7*z**2-3)/7.0d0
          sqy(ig,3,3) = (-9.0d0)*ci*(iypx+iymx)*(7*z**2-1)/14.0d0
       end do
    case (154)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3*ci*iymx*sq5/sq6
          sqy(ig,2,1) = 3*iymx*sq5/sq6
          sqy(ig,3,1) = 0
       end do
    case (155)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (156)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3*ci*iymx*sq5*z/sq6
          sqy(ig,2,2) = 3*iymx*sq5*z/sq6
          sqy(ig,3,2) = (-3.0d0)*ci*iymx**2*sq5/(2.0d0*sq6)
       end do
    case (157)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq6/sq5
          sqy(ig,2,1) = sq6/sq5
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq6*(5*z**2-1)/sq5/4.0d0
          sqy(ig,2,2) = -sq6*(5*z**2-1)/sq5/4.0d0
          sqy(ig,3,2) = ci*iymx*sq30*z/2.0d0
       end do
    case (158)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*ci*iymx**2*sq5/4.0d0
          sqy(ig,2,2) = (-9.0d0)*iymx**2*sq5/4.0d0
          sqy(ig,3,2) = 0
       end do
    case (159)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iymx*sq15*z
          sqy(ig,2,2) = iymx*sq15*z
          sqy(ig,3,2) = -ci*iymx**2*sq15/2.0d0
       end do
    case (160)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3*ci/sq15
          sqy(ig,2,1) = 3/sq15
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*(5*z**2-1)/(4.0d0*sq15)
          sqy(ig,2,2) = (-3.0d0)*(5*z**2-1)/(4.0d0*sq15)
          sqy(ig,3,2) = ci*iymx*sq15*z/2.0d0
       end do
    case (161)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (162)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*ci*iymx**2*sq5*z/4.0d0
          sqy(ig,2,3) = (-9.0d0)*iymx**2*sq5*z/4.0d0
          sqy(ig,3,3) = 3.0d0*ci*iymx**3*sq5/4.0d0
       end do
    case (163)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*ci*iymx*sq15/7.0d0
          sqy(ig,2,2) = (-2.0d0)*iymx*sq15/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*ci*iymx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,2,3) = 3.0d0*iymx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*iymx**2*sq15*z/2.0d0
       end do
    case (164)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*sq15*z/7.0d0
          sqy(ig,2,2) = 3.0d0*sq15*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*iymx*sq15/7.0d0
          sqy(ig,1,3) = (-3.0d0)*ci*sq15*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = (-3.0d0)*sq15*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = 9.0d0*ci*iymx*sq15*(7*z**2-1)/28.0d0
       end do
    case (165)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 12.0d0*ci*sq5*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-3.0d0)*ci*sq5*z*(7*z**2-3)/7.0d0
       end do
    case (166)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*ci*iymx**3/2.0d0
          sqy(ig,2,3) = 15.0d0*iymx**3/2.0d0
          sqy(ig,3,3) = 0
       end do
    case (167)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*ci*iymx**2*sq5*z/2.0d0
          sqy(ig,2,3) = (-9.0d0)*iymx**2*sq5*z/2.0d0
          sqy(ig,3,3) = 3.0d0*ci*iymx**3*sq5/2.0d0
       end do
    case (168)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*iymx*sq10/7.0d0
          sqy(ig,2,2) = (-3.0d0)*iymx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*ci*iymx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,3) = 9.0d0*iymx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,3) = (-9.0d0)*ci*iymx**2*sq5*z/(2.0d0*sq2)
       end do
    case (169)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*sq10*z/7.0d0
          sqy(ig,2,2) = 3.0d0*sq10*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*iymx*sq10/7.0d0
          sqy(ig,1,3) = (-3.0d0)*ci*sq5*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,3) = (-3.0d0)*sq5*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,3) = 9.0d0*ci*iymx*sq5*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (170)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 6.0d0*ci*sq5*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-3.0d0)*ci*sq5*z*(7*z**2-3)/14.0d0
       end do
    case (171)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
       end do
    case (172)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*ci*iypx**2*sq5/(2.0d0*sq6)
          sqy(ig,2,1) = (-9.0d0)*iypx**2*sq5/(2.0d0*sq6)
          sqy(ig,3,1) = 0
       end do
    case (173)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*iypx*sq30*z/2.0d0
          sqy(ig,2,1) = -iypx*sq30*z/2.0d0
          sqy(ig,3,1) = ci*iypx**2*sq30/4.0d0
       end do
    case (174)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*sq30*z/7.0d0
          sqy(ig,2,1) = sq30*z/7.0d0
          sqy(ig,3,1) = -ci*iypx*sq30/7.0d0
          sqy(ig,1,2) = 3.0d0*ci*sq5*z*(7*z**2+21*iypx**2-3)/(14.0d0*sq6)
          sqy(ig,2,2) = (-3.0d0)*sq5*z*(7*z**2+21*iypx**2-3)/(14.0d0*sq6)
          sqy(ig,3,2) = 3.0d0*ci*iypx*sq5*(21*z**2+7*iypx**2-3)/(14.0d0*sq6)
       end do
    case (175)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*iypx*sq30/14.0d0
          sqy(ig,2,1) = iypx*sq30/14.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iypx*sq30*(7*z**2+14*iypx**2-1)/14.0d0
          sqy(ig,2,2) = iypx*sq30*(7*z**2+14*iypx**2-1)/14.0d0
          sqy(ig,3,2) = -ci*iypx**2*sq30*z/2.0d0
       end do
    case (176)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*ci*iypx*sq5/7.0d0
          sqy(ig,2,1) = (-9.0d0)*iypx*sq5/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*iypx*sq5*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = 3.0d0*iypx*sq5*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*iypx**2*sq5*z/2.0d0
       end do
    case (177)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq15*z/7.0d0
          sqy(ig,2,1) = -sq15*z/7.0d0
          sqy(ig,3,1) = ci*iypx*sq15/7.0d0
          sqy(ig,1,2) = -ci*sq15*z*(7*z**2-42*iypx**2-3)/28.0d0
          sqy(ig,2,2) = sq15*z*(7*z**2-42*iypx**2-3)/28.0d0
          sqy(ig,3,2) = -ci*iypx*sq15*(21*z**2-14*iypx**2-3)/28.0d0
       end do
    case (178)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*iypx*sq15/7.0d0
          sqy(ig,2,1) = -iypx*sq15/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iypx*sq15*(7*z**2-7*iypx**2-1)/7.0d0
          sqy(ig,2,2) = -iypx*sq15*(7*z**2-7*iypx**2-1)/7.0d0
          sqy(ig,3,2) = ci*iypx**2*sq15*z
       end do
    case (179)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*ci*iypx**2*sq5*z/4.0d0
          sqy(ig,2,2) = 9.0d0*iypx**2*sq5*z/4.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*iypx**3*sq5/4.0d0
       end do
    case (180)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-6.0d0)*ci/(7.0d0*sq5)
          sqy(ig,1,2) = ci*iypx*sq5*z
          sqy(ig,2,2) = -iypx*sq5*z
          sqy(ig,3,2) = ci*(20*z**2+5*iypx**2-4)/sq5/2.0d0
          sqy(ig,1,3) = -ci*iypx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = iypx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = -ci*sq5*(105*z**4+63*iypx**2*z**2-70*z**2-7*iypx**2+5)/28.0d0
       end do
    case (181)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq3/(7.0d0*sq5)
          sqy(ig,2,1) = 3.0d0*sq3/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq3*(5*z**2+10*iypx**2-1)/sq5/4.0d0
          sqy(ig,2,2) = sq3*(5*z**2+10*iypx**2-1)/sq5/4.0d0
          sqy(ig,3,2) = -ci*iypx*sq15*z/2.0d0
          sqy(ig,1,3) = ci*sq15*(21*z**4+63*iypx**2*z**2-14*z**2-7*iypx**2+1)/28.0d0
          sqy(ig,2,3) = -sq15*(21*z**4+63*iypx**2*z**2-14*z**2-7*iypx**2+1)/28.0d0
          sqy(ig,3,3) = ci*iypx*sq15*z*(6*z**2+3*iypx**2-2)/2.0d0
       end do
    case (182)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -ci*iypx*sq15*z*(3*z**2+6*iypx**2-1)/2.0d0
          sqy(ig,2,3) = iypx*sq15*z*(3*z**2+6*iypx**2-1)/2.0d0
          sqy(ig,3,3) = -ci*iypx**2*sq15*(9*z**2+3*iypx**2-1)/4.0d0
       end do
    case (183)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iypx**2*sq5/4.0d0
          sqy(ig,2,2) = -iypx**2*sq5/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = ci*iypx**2*sq5*(9*z**2+15*iypx**2-1)/4.0d0
          sqy(ig,2,3) = -iypx**2*sq5*(9*z**2+15*iypx**2-1)/4.0d0
          sqy(ig,3,3) = 3.0d0*ci*iypx**3*sq5*z/2.0d0
       end do
    case (184)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*ci/7.0d0
          sqy(ig,2,1) = (-9)/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*(5*z**2-1)/2.0d0
          sqy(ig,2,2) = (5*z**2-1)/2.0d0
          sqy(ig,3,2) = -5*ci*iypx*z
          sqy(ig,1,3) = 5.0d0*ci*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = (-5.0d0)*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = 5.0d0*ci*iypx*z*(3*z**2-1)/2.0d0
       end do
    case (185)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*ci/(7.0d0*sq5)
          sqy(ig,1,2) = 2*ci*iypx*sq5*z
          sqy(ig,2,2) = -2*iypx*sq5*z
          sqy(ig,3,2) = -ci*(5*z**2-5*iypx**2-1)/sq5
          sqy(ig,1,3) = -ci*iypx*sq5*z*(3*z**2-1)
          sqy(ig,2,3) = iypx*sq5*z*(3*z**2-1)
          sqy(ig,3,3) = ci*sq5*(105*z**4-252*iypx**2*z**2-70*z**2+28*iypx**2+5)/56.0d0
       end do
    case (186)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*sq2/(7.0d0*sq5)
          sqy(ig,2,1) = (-3.0d0)*sq2/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*(5*z**2-15*iypx**2-1)/sq10/2.0d0
          sqy(ig,2,2) = -(5*z**2-15*iypx**2-1)/sq10/2.0d0
          sqy(ig,3,2) = ci*iypx*sq5*z/sq2
          sqy(ig,1,3) = -ci*sq10*(42*z**4-189*iypx**2*z**2-28*z**2+21*iypx**2+2)/56.0d0
          sqy(ig,2,3) = sq10*(42*z**4-189*iypx**2*z**2-28*z**2+21*iypx**2+2)/56.0d0
          sqy(ig,3,3) = -ci*iypx*sq10*z*(12*z**2-9*iypx**2-4)/4.0d0
       end do
    case (187)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*ci*iypx*sq5*z*(3*z**2-4*iypx**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-3.0d0)*iypx*sq5*z*(3*z**2-4*iypx**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*ci*iypx**2*sq5*(9*z**2-2*iypx**2-1)/(4.0d0*sq2)
       end do
    case (188)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iypx**2*sq5/2.0d0
          sqy(ig,2,2) = iypx**2*sq5/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -ci*iypx**2*sq5*(36*z**2-15*iypx**2-4)/8.0d0
          sqy(ig,2,3) = iypx**2*sq5*(36*z**2-15*iypx**2-4)/8.0d0
          sqy(ig,3,3) = -3*ci*iypx**3*sq5*z
       end do
    case (189)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*ci*iypx**3*z/2.0d0
          sqy(ig,2,3) = (-15.0d0)*iypx**3*z/2.0d0
          sqy(ig,3,3) = 15.0d0*ci*iypx**4/8.0d0
       end do
    case (190)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = (-10.0d0)*z/7.0d0
          sqy(ig,3,2) = 5.0d0*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 45.0d0*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = (-135.0d0)*ci*(iypx+iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = (-5.0d0)*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,3,4) = 25.0d0*ci*(iypx+iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (191)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 5.0d0*ci*iypx*sq6*z/2.0d0
          sqy(ig,2,1) = (-5.0d0)*iypx*sq6*z/2.0d0
          sqy(ig,3,1) = 5.0d0*ci*iypx**2*sq6/4.0d0
       end do
    case (192)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq3*(5*z**2-1)/sq2/2.0d0
          sqy(ig,2,1) = -sq3*(5*z**2-1)/sq2/2.0d0
          sqy(ig,3,1) = 5*ci*iypx*sq3*z/sq2
       end do
    case (193)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 5.0d0*ci*iypx*sq6/14.0d0
          sqy(ig,2,1) = (-5.0d0)*iypx*sq6/14.0d0
          sqy(ig,3,1) = (-6.0d0)*ci*sq6*z/7.0d0
          sqy(ig,1,2) = 5.0d0*ci*iypx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*iypx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,2) = 5.0d0*ci*sq3*z*(14*z**2+7*iypx**2-6)/(7.0d0*sq2)
       end do
    case (194)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-2.0d0)*ci*sq6*z/7.0d0
          sqy(ig,2,1) = 2.0d0*sq6*z/7.0d0
          sqy(ig,3,1) = (-2.0d0)*ci*iypx*sq6/7.0d0
          sqy(ig,1,2) = (-5.0d0)*ci*sq3*z*(7*z**2+21*iypx**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = 5.0d0*sq3*z*(7*z**2+21*iypx**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = (-5.0d0)*ci*iypx*sq3*(21*z**2+7*iypx**2-3)/(14.0d0*sq2)
       end do
    case (195)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 15.0d0*ci*z/7.0d0
          sqy(ig,2,1) = (-15.0d0)*z/7.0d0
          sqy(ig,3,1) = 15.0d0*ci*iypx/7.0d0
          sqy(ig,1,2) = (-15.0d0)*ci*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = 15.0d0*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = (-45.0d0)*ci*iypx*(7*z**2-1)/28.0d0
       end do
    case (196)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 5.0d0*ci*iypx*sq3/7.0d0
          sqy(ig,2,1) = (-5.0d0)*iypx*sq3/7.0d0
          sqy(ig,3,1) = 6.0d0*ci*sq3*z/7.0d0
          sqy(ig,1,2) = 5.0d0*ci*iypx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = (-5.0d0)*iypx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = (-5.0d0)*ci*sq3*z*(7*z**2-7*iypx**2-3)/7.0d0
       end do
    case (197)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 4.0d0*ci*sq3*z/7.0d0
          sqy(ig,2,1) = (-4.0d0)*sq3*z/7.0d0
          sqy(ig,3,1) = 4.0d0*ci*iypx*sq3/7.0d0
          sqy(ig,1,2) = 5.0d0*ci*sq3*z*(14*z**2-21*iypx**2-6)/28.0d0
          sqy(ig,2,2) = (-5.0d0)*sq3*z*(14*z**2-21*iypx**2-6)/28.0d0
          sqy(ig,3,2) = 5.0d0*ci*iypx*sq3*(42*z**2-7*iypx**2-6)/28.0d0
       end do
    case (198)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*iypx/7.0d0
          sqy(ig,2,1) = (-3.0d0)*iypx/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-15.0d0)*ci*iypx*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = 15.0d0*iypx*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = (-15.0d0)*ci*iypx**2*z/2.0d0
       end do
    case (199)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci/5.0d0
          sqy(ig,2,1) = (-9)/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = (-13.0d0)*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = ci*(5*iypx+8*iymx)*z/2.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 5.0d0*(21*z**4-14*z**2+1)/14.0d0
          sqy(ig,3,3) = -5*ci*(iypx+iymx)*z*(3*z**2-1)
       end do
    case (200)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-12.0d0)*ci*sq3/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -ci*sq3*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = 5.0d0*ci*iypx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = (-5.0d0)*iypx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = 5.0d0*ci*sq3*(105*z**4+63*iypx**2*z**2-70*z**2-7*iypx**2+5)/28.0d0
       end do
    case (201)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-6.0d0)*ci*sq3/35.0d0
          sqy(ig,2,1) = 6.0d0*sq3/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq3*(10*z**2+25*iypx**2-2)/20.0d0
          sqy(ig,2,2) = sq3*(10*z**2+25*iypx**2-2)/20.0d0
          sqy(ig,3,2) = -ci*iypx*sq3*z
          sqy(ig,1,3) = (-5.0d0)*ci*sq3*(21*z**4+63*iypx**2*z**2-14*z**2-7*iypx**2+1)/28.0d0
          sqy(ig,2,3) = 5.0d0*sq3*(21*z**4+63*iypx**2*z**2-14*z**2-7*iypx**2+1)/28.0d0
          sqy(ig,3,3) = (-5.0d0)*ci*iypx*sq3*z*(6*z**2+3*iypx**2-2)/2.0d0
       end do
    case (202)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iypx*z
          sqy(ig,2,2) = -iypx*z
          sqy(ig,3,2) = ci*iypx**2/2.0d0
          sqy(ig,1,3) = 5.0d0*ci*iypx*z*(3*z**2+6*iypx**2-1)/2.0d0
          sqy(ig,2,3) = (-5.0d0)*iypx*z*(3*z**2+6*iypx**2-1)/2.0d0
          sqy(ig,3,3) = 5.0d0*ci*iypx**2*(9*z**2+3*iypx**2-1)/4.0d0
       end do
    case (203)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*ci*sq5/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -ci*sq5*(5*z**2-1)
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 25.0d0*ci*sq5*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (204)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 27.0d0*ci/35.0d0
          sqy(ig,2,1) = (-33)/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 7.0d0*ci*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = (-3.0d0)*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = ci*(5*iypx-2*iymx)*z
          sqy(ig,1,3) = (-25.0d0)*ci*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = 15.0d0*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = (-5.0d0)*ci*(4*iypx-iymx)*z*(3*z**2-1)/2.0d0
       end do
    case (205)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 12.0d0*ci*sq2/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = ci*sq2*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = 15.0d0*ci*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*ci*(210*z**4-189*iypx**2*z**2-140*z**2+21*iypx**2+10)/(28.0d0*sq2)
       end do
    case (206)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*ci*sq2/35.0d0
          sqy(ig,2,1) = (-9.0d0)*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*(15*z**2-25*iypx**2-3)/sq2/10.0d0
          sqy(ig,2,2) = -(15*z**2-25*iypx**2-3)/sq2/10.0d0
          sqy(ig,3,2) = 3*ci*iypx*z/sq2
          sqy(ig,1,3) = 5.0d0*ci*(63*z**4-126*iypx**2*z**2-42*z**2+14*iypx**2+3)/(28.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*(63*z**4-126*iypx**2*z**2-42*z**2+14*iypx**2+3)/(28.0d0*sq2)
          sqy(ig,3,3) = 15*ci*iypx*z*(3*z**2-iypx**2-1)/sq2
       end do
    case (207)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -2*ci*iypx*z
          sqy(ig,2,2) = 2*iypx*z
          sqy(ig,3,2) = -ci*iypx**2
          sqy(ig,1,3) = (-5.0d0)*ci*iypx*z*(6*z**2-3*iypx**2-2)/2.0d0
          sqy(ig,2,3) = 5.0d0*iypx*z*(6*z**2-3*iypx**2-2)/2.0d0
          sqy(ig,3,3) = (-5.0d0)*ci*iypx**2*(36*z**2-3*iypx**2-4)/8.0d0
       end do
    case (208)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iypx**2*sq5/2.0d0
          sqy(ig,2,2) = iypx**2*sq5/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 5.0d0*ci*iypx**2*sq5*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,2,3) = (-5.0d0)*iypx**2*sq5*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,3,3) = 15.0d0*ci*iypx**3*sq5*z/4.0d0
       end do
    case (209)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*ci*iymx*sq5/7.0d0
          sqy(ig,2,2) = (-2.0d0)*iymx*sq5/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 27.0d0*ci*iymx*sq5*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = 27.0d0*iymx*sq5*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*sq5*z*(35*z**2+18*iymx**2-15)/22.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*iymx*sq5*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,2,4) = (-5.0d0)*iymx*sq5*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,3,4) = 15.0d0*ci*sq5*z*(33*z**4+22*iymx**2*z**2-30*z**2-6*iymx**2+5)/44.0d0
       end do
    case (210)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = (-10.0d0)*z/7.0d0
          sqy(ig,3,2) = 5.0d0*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = (-60.0d0)*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = 90.0d0*ci*(iypx+iymx)*(7*z**2-1)/77.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 25.0d0*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,3,4) = (-125.0d0)*ci*(iypx+iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (211)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq3*(5*z**2-1)/2.0d0
          sqy(ig,2,1) = -sq3*(5*z**2-1)/2.0d0
          sqy(ig,3,1) = 5*ci*iypx*sq3*z
       end do
    case (212)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*ci*sq3*(5*z**2-1)/2.0d0
       end do
    case (213)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq3*z
          sqy(ig,2,1) = -sq3*z/7.0d0
          sqy(ig,3,1) = ci*(4*iypx-3*iymx)*sq3/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = (-5.0d0)*sq3*z*(7*z**2-3)/7.0d0
          sqy(ig,3,2) = 15.0d0*ci*(iypx+iymx)*sq3*(7*z**2-1)/14.0d0
       end do
    case (214)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*ci*iypx*sq3/7.0d0
          sqy(ig,2,1) = (-2.0d0)*iypx*sq3/7.0d0
          sqy(ig,3,1) = (-9.0d0)*ci*sq3*z/7.0d0
          sqy(ig,1,2) = (-5.0d0)*ci*iypx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = 5.0d0*iypx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = (-5.0d0)*ci*sq3*z*(14*z**2+7*iypx**2-6)/7.0d0
       end do
    case (215)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 18.0d0*ci*sq2*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-15.0d0)*ci*sq2*z*(7*z**2-3)/7.0d0
       end do
    case (216)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 5.0d0*ci*sq3*z/(7.0d0*sq2)
          sqy(ig,2,1) = (-11.0d0)*sq3*z/(7.0d0*sq2)
          sqy(ig,3,1) = ci*(8*iypx+3*iymx)*sq3/sq2/7.0d0
          sqy(ig,1,2) = 15.0d0*ci*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = 15.0d0*ci*(2*iypx-iymx)*sq3*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (217)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*iypx*sq6/7.0d0
          sqy(ig,2,1) = -iypx*sq6/7.0d0
          sqy(ig,3,1) = 9.0d0*ci*sq6*z/7.0d0
          sqy(ig,1,2) = (-5.0d0)*ci*iypx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,2) = 5.0d0*iypx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,2) = 5.0d0*ci*sq3*z*(28*z**2-7*iypx**2-12)/(7.0d0*sq2)
       end do
    case (218)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*ci*z/(7.0d0*sq2)
          sqy(ig,2,1) = (-9.0d0)*z/(7.0d0*sq2)
          sqy(ig,3,1) = 9.0d0*ci*iypx/(7.0d0*sq2)
          sqy(ig,1,2) = (-15.0d0)*ci*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = 15.0d0*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = (-45.0d0)*ci*iypx*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (219)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 12.0d0*ci*sq2/35.0d0
          sqy(ig,1,2) = -2*ci*iymx*sq2*z
          sqy(ig,2,2) = -2*iymx*sq2*z
          sqy(ig,3,2) = ci*sq2*(5*z**2+5*iymx**2-1)/5.0d0
          sqy(ig,1,3) = 5*ci*iymx*z*(3*z**2-1)/sq2
          sqy(ig,2,3) = 5*iymx*z*(3*z**2-1)/sq2
          sqy(ig,3,3) = (-5.0d0)*ci*(105*z**4+63*iymx**2*z**2-70*z**2-7*iymx**2+5)/(14.0d0*sq2)
       end do
    case (220)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*sq3/(5.0d0*sq2)
          sqy(ig,2,1) = (-3.0d0)*sq3/(35.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq3*(5*z**2-1)/sq2/10.0d0
          sqy(ig,2,2) = (-3.0d0)*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = ci*(2*iypx+iymx)*sq3*z/sq2
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = (-5.0d0)*sq3*(21*z**4-14*z**2+1)/(7.0d0*sq2)
          sqy(ig,3,3) = 5*ci*(iypx+iymx)*sq6*z*(3*z**2-1)
       end do
    case (221)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-9.0d0)*ci*sq6/35.0d0
          sqy(ig,1,2) = -ci*iypx*sq6*z
          sqy(ig,2,2) = iypx*sq6*z
          sqy(ig,3,2) = -ci*sq3*(20*z**2+5*iypx**2-4)/sq2/5.0d0
          sqy(ig,1,3) = -5*ci*iypx*sq3*z*(3*z**2-1)/sq2
          sqy(ig,2,3) = 5*iypx*sq3*z*(3*z**2-1)/sq2
          sqy(ig,3,3) = (-5.0d0)*ci*sq3*(105*z**4+63*iypx**2*z**2-70*z**2-7*iypx**2+5)/(14.0d0*sq2)
       end do
    case (222)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*ci/(35.0d0*sq2)
          sqy(ig,2,1) = 9.0d0/(35.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*(5*z**2-20*iypx**2-1)/sq2/10.0d0
          sqy(ig,2,2) = -(5*z**2-20*iypx**2-1)/sq2/10.0d0
          sqy(ig,3,2) = ci*iypx*z/sq2
          sqy(ig,1,3) = 5.0d0*ci*(21*z**4+63*iypx**2*z**2-14*z**2-7*iypx**2+1)/(14.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*(21*z**4+63*iypx**2*z**2-14*z**2-7*iypx**2+1)/(14.0d0*sq2)
          sqy(ig,3,3) = 5*ci*iypx*z*(6*z**2+3*iypx**2-2)/sq2
       end do
    case (223)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq10/35.0d0
          sqy(ig,2,1) = (-3.0d0)*sq10/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2*ci*(5*z**2-1)/sq10
          sqy(ig,2,2) = 2*(5*z**2-1)/sq10
          sqy(ig,3,2) = -2*ci*iymx*sq10*z
          sqy(ig,1,3) = (-5.0d0)*ci*sq10*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = (-5.0d0)*sq10*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = 5.0d0*ci*iymx*sq10*z*(3*z**2-1)/2.0d0
       end do
    case (224)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 24.0d0*ci*sq2/35.0d0
          sqy(ig,1,2) = ci*iymx*sq2*z
          sqy(ig,2,2) = iymx*sq2*z
          sqy(ig,3,2) = ci*(20*z**2-5*iymx**2-4)/sq2/5.0d0
          sqy(ig,1,3) = (-5.0d0)*ci*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*ci*(420*z**4-63*iymx**2*z**2-280*z**2+7*iymx**2+20)/(28.0d0*sq2)
       end do
    case (225)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*ci/35.0d0
          sqy(ig,2,1) = (-27)/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*ci*(5*z**2-1)/5.0d0
          sqy(ig,2,2) = -(5*z**2-1)/5.0d0
          sqy(ig,3,2) = ci*(3*iypx-iymx)*z
          sqy(ig,1,3) = 25.0d0*ci*(21*z**4-14*z**2+1)/28.0d0
          sqy(ig,2,3) = (-5.0d0)*(21*z**4-14*z**2+1)/28.0d0
          sqy(ig,3,3) = 5*ci*(3*iypx-2*iymx)*z*(3*z**2-1)
       end do
    case (226)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 27.0d0*ci/35.0d0
          sqy(ig,1,2) = -2*ci*iypx*z
          sqy(ig,2,2) = 2*iypx*z
          sqy(ig,3,2) = ci*(30*z**2-5*iypx**2-6)/5.0d0
          sqy(ig,1,3) = -5*ci*iypx*z*(3*z**2-1)
          sqy(ig,2,3) = 5*iypx*z*(3*z**2-1)
          sqy(ig,3,3) = 5.0d0*ci*(315*z**4-126*iypx**2*z**2-210*z**2+14*iypx**2+15)/28.0d0
       end do
    case (227)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*ci*sq2/35.0d0
          sqy(ig,2,1) = (-9.0d0)*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*(5*z**2+5*iypx**2-1)/sq2/5.0d0
          sqy(ig,2,2) = (5*z**2+5*iypx**2-1)/sq2/5.0d0
          sqy(ig,3,2) = -ci*iypx*sq2*z
          sqy(ig,1,3) = (-5.0d0)*ci*(84*z**4-63*iypx**2*z**2-56*z**2+7*iypx**2+4)/(28.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*(84*z**4-63*iypx**2*z**2-56*z**2+7*iypx**2+4)/(28.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*ci*iypx*z*(24*z**2-3*iypx**2-8)/(2.0d0*sq2)
       end do
    case (228)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iypx*sq10*z
          sqy(ig,2,2) = iypx*sq10*z
          sqy(ig,3,2) = -ci*iypx**2*sq5/sq2
          sqy(ig,1,3) = 5.0d0*ci*iypx*sq5*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*iypx*sq5*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = 5.0d0*ci*iypx**2*sq5*(3*z-1)*(3*z+1)/(4.0d0*sq2)
       end do
    case (229)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq10*z/7.0d0
          sqy(ig,2,2) = sq10*z/7.0d0
          sqy(ig,3,2) = -ci*iymx*sq10/7.0d0
          sqy(ig,1,3) = 3.0d0*ci*sq10*z*(56*z**2+189*iymx**2-24)/308.0d0
          sqy(ig,2,3) = 3.0d0*sq10*z*(56*z**2+189*iymx**2-24)/308.0d0
          sqy(ig,3,3) = (-9.0d0)*ci*iymx*sq10*(56*z**2+21*iymx**2-8)/308.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*sq10*z*(33*z**4+99*iymx**2*z**2-30*z**2-27*iymx**2+5)/88.0d0
          sqy(ig,2,4) = (-5.0d0)*sq10*z*(33*z**4+99*iymx**2*z**2-30*z**2-27*iymx**2+5)/88.0d0
          sqy(ig,3,4) = 5.0d0*ci*iymx*sq10*(165*z**4+99*iymx**2*z**2-90*z**2-9*iymx**2+5)/88.0d0
       end do
    case (230)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*ci*iymx*sq2/7.0d0
          sqy(ig,2,2) = (-5.0d0)*iymx*sq2/7.0d0
          sqy(ig,3,2) = 6.0d0*ci*sq2*z/7.0d0
          sqy(ig,1,3) = (-45.0d0)*ci*iymx*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,2,3) = (-45.0d0)*iymx*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*ci*z*(28*z**2+21*iymx**2-12)/(154.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*ci*iymx*(33*z**4-18*z**2+1)/(22.0d0*sq2)
          sqy(ig,2,4) = 25.0d0*iymx*(33*z**4-18*z**2+1)/(22.0d0*sq2)
          sqy(ig,3,4) = (-75.0d0)*ci*z*(33*z**4+22*iymx**2*z**2-30*z**2-6*iymx**2+5)/(22.0d0*sq2)
       end do
    case (231)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = (-4.0d0)*z/7.0d0
          sqy(ig,3,2) = 2.0d0*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = (-45.0d0)*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = 135.0d0*ci*(iypx+iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/22.0d0
          sqy(ig,3,4) = 125.0d0*ci*(iypx+iymx)*(33*z**4-18*z**2+1)/44.0d0
       end do
    case (232)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*ci*sq3*(5*z**2-1)/2.0d0
       end do
    case (233)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*sq3*(5*z**2-1)/2.0d0
          sqy(ig,2,1) = -sq3*(5*z**2-1)/2.0d0
          sqy(ig,3,1) = 5*ci*iymx*sq3*z
       end do
    case (234)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*ci*iymx*sq3/7.0d0
          sqy(ig,2,1) = 2.0d0*iymx*sq3/7.0d0
          sqy(ig,3,1) = 9.0d0*ci*sq3*z/7.0d0
          sqy(ig,1,2) = (-5.0d0)*ci*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = (-5.0d0)*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = 5.0d0*ci*sq3*z*(14*z**2+7*iymx**2-6)/7.0d0
       end do
    case (235)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq3*z
          sqy(ig,2,1) = sq3*z/7.0d0
          sqy(ig,3,1) = ci*(3*iypx-4*iymx)*sq3/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 5.0d0*sq3*z*(7*z**2-3)/7.0d0
          sqy(ig,3,2) = (-15.0d0)*ci*(iypx+iymx)*sq3*(7*z**2-1)/14.0d0
       end do
    case (236)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*ci*z/(7.0d0*sq2)
          sqy(ig,2,1) = (-9.0d0)*z/(7.0d0*sq2)
          sqy(ig,3,1) = 9.0d0*ci*iymx/(7.0d0*sq2)
          sqy(ig,1,2) = 15.0d0*ci*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = 15.0d0*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = (-45.0d0)*ci*iymx*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (237)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*iymx*sq6/7.0d0
          sqy(ig,2,1) = -iymx*sq6/7.0d0
          sqy(ig,3,1) = 9.0d0*ci*sq6*z/7.0d0
          sqy(ig,1,2) = 5.0d0*ci*iymx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,2) = 5.0d0*iymx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,2) = 5.0d0*ci*sq3*z*(28*z**2-7*iymx**2-12)/(7.0d0*sq2)
       end do
    case (238)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-5.0d0)*ci*sq3*z/(7.0d0*sq2)
          sqy(ig,2,1) = (-11.0d0)*sq3*z/(7.0d0*sq2)
          sqy(ig,3,1) = ci*(3*iypx+8*iymx)*sq3/sq2/7.0d0
          sqy(ig,1,2) = (-15.0d0)*ci*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = (-15.0d0)*ci*(iypx-2*iymx)*sq3*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (239)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 18.0d0*ci*sq2*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-15.0d0)*ci*sq2*z*(7*z**2-3)/7.0d0
       end do
    case (240)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*ci/(35.0d0*sq2)
          sqy(ig,2,1) = (-9.0d0)/(35.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*(5*z**2-20*iymx**2-1)/sq2/10.0d0
          sqy(ig,2,2) = (5*z**2-20*iymx**2-1)/sq2/10.0d0
          sqy(ig,3,2) = -ci*iymx*z/sq2
          sqy(ig,1,3) = 5.0d0*ci*(21*z**4+63*iymx**2*z**2-14*z**2-7*iymx**2+1)/(14.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*(21*z**4+63*iymx**2*z**2-14*z**2-7*iymx**2+1)/(14.0d0*sq2)
          sqy(ig,3,3) = -5*ci*iymx*z*(6*z**2+3*iymx**2-2)/sq2
       end do
    case (241)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 9.0d0*ci*sq6/35.0d0
          sqy(ig,1,2) = -ci*iymx*sq6*z
          sqy(ig,2,2) = -iymx*sq6*z
          sqy(ig,3,2) = ci*sq3*(20*z**2+5*iymx**2-4)/sq2/5.0d0
          sqy(ig,1,3) = -5*ci*iymx*sq3*z*(3*z**2-1)/sq2
          sqy(ig,2,3) = -5*iymx*sq3*z*(3*z**2-1)/sq2
          sqy(ig,3,3) = 5.0d0*ci*sq3*(105*z**4+63*iymx**2*z**2-70*z**2-7*iymx**2+5)/(14.0d0*sq2)
       end do
    case (242)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*ci/(5.0d0*sq6)
          sqy(ig,2,1) = 9.0d0/(35.0d0*sq6)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq3*(5*z**2-1)/sq2/10.0d0
          sqy(ig,2,2) = 3.0d0*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = -ci*(iypx+2*iymx)*sq3*z/sq2
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 5.0d0*sq3*(21*z**4-14*z**2+1)/(7.0d0*sq2)
          sqy(ig,3,3) = -5*ci*(iypx+iymx)*sq6*z*(3*z**2-1)
       end do
    case (243)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-12.0d0)*ci*sq2/35.0d0
          sqy(ig,1,2) = -2*ci*iypx*sq2*z
          sqy(ig,2,2) = 2*iypx*sq2*z
          sqy(ig,3,2) = -ci*sq2*(5*z**2+5*iypx**2-1)/5.0d0
          sqy(ig,1,3) = 5*ci*iypx*z*(3*z**2-1)/sq2
          sqy(ig,2,3) = -5*iypx*z*(3*z**2-1)/sq2
          sqy(ig,3,3) = 5.0d0*ci*(105*z**4+63*iypx**2*z**2-70*z**2-7*iypx**2+5)/(14.0d0*sq2)
       end do
    case (244)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iymx*sq10*z
          sqy(ig,2,2) = iymx*sq10*z
          sqy(ig,3,2) = -ci*iymx**2*sq10/2.0d0
          sqy(ig,1,3) = (-5.0d0)*ci*iymx*sq10*z*(3*z**2-1)/4.0d0
          sqy(ig,2,3) = (-5.0d0)*iymx*sq10*z*(3*z**2-1)/4.0d0
          sqy(ig,3,3) = 5.0d0*ci*iymx**2*sq10*(3*z-1)*(3*z+1)/8.0d0
       end do
    case (245)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*ci*sq2/35.0d0
          sqy(ig,2,1) = (-9.0d0)*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*(5*z**2+5*iymx**2-1)/sq2/5.0d0
          sqy(ig,2,2) = (5*z**2+5*iymx**2-1)/sq2/5.0d0
          sqy(ig,3,2) = -ci*iymx*sq2*z
          sqy(ig,1,3) = 5.0d0*ci*(84*z**4-63*iymx**2*z**2-56*z**2+7*iymx**2+4)/(28.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*(84*z**4-63*iymx**2*z**2-56*z**2+7*iymx**2+4)/(28.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*ci*iymx*z*(24*z**2-3*iymx**2-8)/(2.0d0*sq2)
       end do
    case (246)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 27.0d0*ci/35.0d0
          sqy(ig,1,2) = 2*ci*iymx*z
          sqy(ig,2,2) = 2*iymx*z
          sqy(ig,3,2) = ci*(30*z**2-5*iymx**2-6)/5.0d0
          sqy(ig,1,3) = 5*ci*iymx*z*(3*z**2-1)
          sqy(ig,2,3) = 5*iymx*z*(3*z**2-1)
          sqy(ig,3,3) = 5.0d0*ci*(315*z**4-126*iymx**2*z**2-210*z**2+14*iymx**2+15)/28.0d0
       end do
    case (247)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*ci/35.0d0
          sqy(ig,2,1) = (-27)/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*ci*(5*z**2-1)/5.0d0
          sqy(ig,2,2) = -(5*z**2-1)/5.0d0
          sqy(ig,3,2) = -ci*(iypx-3*iymx)*z
          sqy(ig,1,3) = (-25.0d0)*ci*(21*z**4-14*z**2+1)/28.0d0
          sqy(ig,2,3) = (-5.0d0)*(21*z**4-14*z**2+1)/28.0d0
          sqy(ig,3,3) = -5*ci*(2*iypx-3*iymx)*z*(3*z**2-1)
       end do
    case (248)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 24.0d0*ci*sq2/35.0d0
          sqy(ig,1,2) = -ci*iypx*sq2*z
          sqy(ig,2,2) = iypx*sq2*z
          sqy(ig,3,2) = ci*(20*z**2-5*iypx**2-4)/sq2/5.0d0
          sqy(ig,1,3) = 5.0d0*ci*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*ci*(420*z**4-63*iypx**2*z**2-280*z**2+7*iypx**2+20)/(28.0d0*sq2)
       end do
    case (249)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*ci/(7.0d0*sq10)
          sqy(ig,2,1) = (-6.0d0)/(7.0d0*sq10)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -2*ci*(5*z**2-1)/sq10
          sqy(ig,2,2) = 2*(5*z**2-1)/sq10
          sqy(ig,3,2) = -2*ci*iypx*sq10*z
          sqy(ig,1,3) = 5.0d0*ci*sq5*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*sq5*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,3,3) = 5*ci*iypx*sq5*z*(3*z**2-1)/sq2
       end do
    case (250)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iymx*sq10/7.0d0
          sqy(ig,2,2) = iymx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*ci*iymx*sq10*(7*z**2+28*iymx**2-1)/308.0d0
          sqy(ig,2,3) = 9.0d0*iymx*sq10*(7*z**2+28*iymx**2-1)/308.0d0
          sqy(ig,3,3) = (-9.0d0)*ci*iymx**2*sq10*z/44.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*iymx*sq10*(33*z**4+66*iymx**2*z**2-18*z**2-6*iymx**2+1)/44.0d0
          sqy(ig,2,4) = (-5.0d0)*iymx*sq10*(33*z**4+66*iymx**2*z**2-18*z**2-6*iymx**2+1)/44.0d0
          sqy(ig,3,4) = 15.0d0*ci*iymx**2*sq10*z*(22*z**2+11*iymx**2-6)/44.0d0
       end do
    case (251)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq2*z/7.0d0
          sqy(ig,2,2) = sq2*z/7.0d0
          sqy(ig,3,2) = -ci*iymx*sq2/7.0d0
          sqy(ig,1,3) = 45.0d0*ci*z*(7*z**2+14*iymx**2-3)/(154.0d0*sq2)
          sqy(ig,2,3) = 45.0d0*z*(7*z**2+14*iymx**2-3)/(154.0d0*sq2)
          sqy(ig,3,3) = (-15.0d0)*ci*iymx*(63*z**2+14*iymx**2-9)/(154.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*ci*z*(33*z**4+99*iymx**2*z**2-30*z**2-27*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,2,4) = 25.0d0*z*(33*z**4+99*iymx**2*z**2-30*z**2-27*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,3,4) = (-25.0d0)*ci*iymx*(165*z**4+99*iymx**2*z**2-90*z**2-9*iymx**2+5)/(44.0d0*sq2)
       end do
    case (252)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-8.0d0)*ci*iymx/7.0d0
          sqy(ig,2,2) = (-8.0d0)*iymx/7.0d0
          sqy(ig,3,2) = 12.0d0*ci*z/7.0d0
          sqy(ig,1,3) = (-60.0d0)*ci*iymx*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = (-60.0d0)*iymx*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = 15.0d0*ci*z*(63*z**2+28*iymx**2-27)/77.0d0
          sqy(ig,1,4) = (-25.0d0)*ci*iymx*(33*z**4-18*z**2+1)/22.0d0
          sqy(ig,2,4) = (-25.0d0)*iymx*(33*z**4-18*z**2+1)/22.0d0
          sqy(ig,3,4) = 75.0d0*ci*z*(33*z**4+22*iymx**2*z**2-30*z**2-6*iymx**2+5)/22.0d0
       end do
    case (253)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 4.0d0*z/7.0d0
          sqy(ig,3,2) = (-2.0d0)*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 45.0d0*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = (-135.0d0)*ci*(iypx+iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 25.0d0*z*(33*z**4-30*z**2+5)/22.0d0
          sqy(ig,3,4) = (-125.0d0)*ci*(iypx+iymx)*(33*z**4-18*z**2+1)/44.0d0
       end do
    case (254)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*sq3*(5*z**2-1)/sq2/2.0d0
          sqy(ig,2,1) = -sq3*(5*z**2-1)/sq2/2.0d0
          sqy(ig,3,1) = 5*ci*iymx*sq3*z/sq2
       end do
    case (255)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -15*ci*iymx*z/sq6
          sqy(ig,2,1) = -15*iymx*z/sq6
          sqy(ig,3,1) = 15.0d0*ci*iymx**2/(2.0d0*sq6)
       end do
    case (256)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-2.0d0)*ci*sq6*z/7.0d0
          sqy(ig,2,1) = (-2.0d0)*sq6*z/7.0d0
          sqy(ig,3,1) = 2.0d0*ci*iymx*sq6/7.0d0
          sqy(ig,1,2) = (-5.0d0)*ci*sq3*z*(7*z**2+21*iymx**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*sq3*z*(7*z**2+21*iymx**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = 5.0d0*ci*iymx*sq3*(21*z**2+7*iymx**2-3)/(14.0d0*sq2)
       end do
    case (257)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 5.0d0*ci*iymx*sq6/14.0d0
          sqy(ig,2,1) = 5.0d0*iymx*sq6/14.0d0
          sqy(ig,3,1) = 6.0d0*ci*sq6*z/7.0d0
          sqy(ig,1,2) = 5.0d0*ci*iymx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,2) = 5.0d0*iymx*sq3*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,2) = (-5.0d0)*ci*sq3*z*(14*z**2+7*iymx**2-6)/(7.0d0*sq2)
       end do
    case (258)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*iymx/7.0d0
          sqy(ig,2,1) = (-3.0d0)*iymx/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 15.0d0*ci*iymx*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = 15.0d0*iymx*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = (-15.0d0)*ci*iymx**2*z/2.0d0
       end do
    case (259)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-4.0d0)*ci*sq3*z/7.0d0
          sqy(ig,2,1) = (-4.0d0)*sq3*z/7.0d0
          sqy(ig,3,1) = 4.0d0*ci*iymx*sq3/7.0d0
          sqy(ig,1,2) = (-5.0d0)*ci*sq3*z*(14*z**2-21*iymx**2-6)/28.0d0
          sqy(ig,2,2) = (-5.0d0)*sq3*z*(14*z**2-21*iymx**2-6)/28.0d0
          sqy(ig,3,2) = 5.0d0*ci*iymx*sq3*(42*z**2-7*iymx**2-6)/28.0d0
       end do
    case (260)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-5.0d0)*ci*iymx*sq3/7.0d0
          sqy(ig,2,1) = (-5.0d0)*iymx*sq3/7.0d0
          sqy(ig,3,1) = 6.0d0*ci*sq3*z/7.0d0
          sqy(ig,1,2) = (-5.0d0)*ci*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = (-5.0d0)*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = (-5.0d0)*ci*sq3*z*(7*z**2-7*iymx**2-3)/7.0d0
       end do
    case (261)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-15.0d0)*ci*z/7.0d0
          sqy(ig,2,1) = (-15.0d0)*z/7.0d0
          sqy(ig,3,1) = 15.0d0*ci*iymx/7.0d0
          sqy(ig,1,2) = 15.0d0*ci*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = 15.0d0*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = (-45.0d0)*ci*iymx*(7*z**2-1)/28.0d0
       end do
    case (262)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iymx*z
          sqy(ig,2,2) = iymx*z
          sqy(ig,3,2) = -ci*iymx**2/2.0d0
          sqy(ig,1,3) = 5.0d0*ci*iymx*z*(3*z**2+6*iymx**2-1)/2.0d0
          sqy(ig,2,3) = 5.0d0*iymx*z*(3*z**2+6*iymx**2-1)/2.0d0
          sqy(ig,3,3) = (-5.0d0)*ci*iymx**2*(9*z**2+3*iymx**2-1)/4.0d0
       end do
    case (263)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-6.0d0)*ci*sq3/35.0d0
          sqy(ig,2,1) = (-6.0d0)*sq3/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq3*(10*z**2+25*iymx**2-2)/20.0d0
          sqy(ig,2,2) = -sq3*(10*z**2+25*iymx**2-2)/20.0d0
          sqy(ig,3,2) = ci*iymx*sq3*z
          sqy(ig,1,3) = (-5.0d0)*ci*sq3*(21*z**4+63*iymx**2*z**2-14*z**2-7*iymx**2+1)/28.0d0
          sqy(ig,2,3) = (-5.0d0)*sq3*(21*z**4+63*iymx**2*z**2-14*z**2-7*iymx**2+1)/28.0d0
          sqy(ig,3,3) = 5.0d0*ci*iymx*sq3*z*(6*z**2+3*iymx**2-2)/2.0d0
       end do
    case (264)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 12.0d0*ci*sq3/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = ci*sq3*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = 5.0d0*ci*iymx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = 5.0d0*iymx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = (-5.0d0)*ci*sq3*(105*z**4+63*iymx**2*z**2-70*z**2-7*iymx**2+5)/28.0d0
       end do
    case (265)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci/5.0d0
          sqy(ig,2,1) = 9/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = 13.0d0*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = -ci*(8*iypx+5*iymx)*z/2.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = (-5.0d0)*(21*z**4-14*z**2+1)/14.0d0
          sqy(ig,3,3) = 5*ci*(iypx+iymx)*z*(3*z**2-1)
       end do
    case (266)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iymx**2*sq5/2.0d0
          sqy(ig,2,2) = iymx**2*sq5/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-5.0d0)*ci*iymx**2*sq5*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,2,3) = (-5.0d0)*iymx**2*sq5*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,3,3) = 15.0d0*ci*iymx**3*sq5*z/4.0d0
       end do
    case (267)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2*ci*iymx*z
          sqy(ig,2,2) = 2*iymx*z
          sqy(ig,3,2) = -ci*iymx**2
          sqy(ig,1,3) = 5.0d0*ci*iymx*z*(6*z**2-3*iymx**2-2)/2.0d0
          sqy(ig,2,3) = 5.0d0*iymx*z*(6*z**2-3*iymx**2-2)/2.0d0
          sqy(ig,3,3) = (-5.0d0)*ci*iymx**2*(36*z**2-3*iymx**2-4)/8.0d0
       end do
    case (268)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*ci*sq2/35.0d0
          sqy(ig,2,1) = (-9.0d0)*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*(15*z**2-25*iymx**2-3)/sq2/10.0d0
          sqy(ig,2,2) = -(15*z**2-25*iymx**2-3)/sq2/10.0d0
          sqy(ig,3,2) = 3*ci*iymx*z/sq2
          sqy(ig,1,3) = (-5.0d0)*ci*(63*z**4-126*iymx**2*z**2-42*z**2+14*iymx**2+3)/(28.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*(63*z**4-126*iymx**2*z**2-42*z**2+14*iymx**2+3)/(28.0d0*sq2)
          sqy(ig,3,3) = 15*ci*iymx*z*(3*z**2-iymx**2-1)/sq2
       end do
    case (269)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 12.0d0*ci*sq2/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = ci*sq2*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = (-15.0d0)*ci*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*ci*(210*z**4-189*iymx**2*z**2-140*z**2+21*iymx**2+10)/(28.0d0*sq2)
       end do
    case (270)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-27.0d0)*ci/35.0d0
          sqy(ig,2,1) = (-33)/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-7.0d0)*ci*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = (-3.0d0)*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -ci*(2*iypx-5*iymx)*z
          sqy(ig,1,3) = 25.0d0*ci*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = 15.0d0*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = 5.0d0*ci*(iypx-4*iymx)*z*(3*z**2-1)/2.0d0
       end do
    case (271)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*ci*sq5/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -ci*sq5*(5*z**2-1)
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 25.0d0*ci*sq5*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (272)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*ci*iymx**2*sq5*z/22.0d0
          sqy(ig,2,3) = (-9.0d0)*iymx**2*sq5*z/22.0d0
          sqy(ig,3,3) = 3.0d0*ci*iymx**3*sq5/22.0d0
          sqy(ig,1,4) = (-15.0d0)*ci*iymx**2*sq5*z*(33*z**2+55*iymx**2-9)/88.0d0
          sqy(ig,2,4) = (-15.0d0)*iymx**2*sq5*z*(33*z**2+55*iymx**2-9)/88.0d0
          sqy(ig,3,4) = 15.0d0*ci*iymx**3*sq5*(33*z**2+11*iymx**2-3)/88.0d0
       end do
    case (273)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*ci*iymx/7.0d0
          sqy(ig,2,2) = 4.0d0*iymx/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*ci*iymx*(28*z**2+35*iymx**2-4)/154.0d0
          sqy(ig,2,3) = 15.0d0*iymx*(28*z**2+35*iymx**2-4)/154.0d0
          sqy(ig,3,3) = (-30.0d0)*ci*iymx**2*z/11.0d0
          sqy(ig,1,4) = 25.0d0*ci*iymx*(33*z**4+66*iymx**2*z**2-18*z**2-6*iymx**2+1)/44.0d0
          sqy(ig,2,4) = 25.0d0*iymx*(33*z**4+66*iymx**2*z**2-18*z**2-6*iymx**2+1)/44.0d0
          sqy(ig,3,4) = (-75.0d0)*ci*iymx**2*z*(22*z**2+11*iymx**2-6)/44.0d0
       end do
    case (274)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq2*z/7.0d0
          sqy(ig,2,2) = -sq2*z/7.0d0
          sqy(ig,3,2) = ci*iymx*sq2/7.0d0
          sqy(ig,1,3) = (-45.0d0)*ci*z*(7*z**2+14*iymx**2-3)/(154.0d0*sq2)
          sqy(ig,2,3) = (-45.0d0)*z*(7*z**2+14*iymx**2-3)/(154.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*ci*iymx*(63*z**2+14*iymx**2-9)/(154.0d0*sq2)
          sqy(ig,1,4) = (-25.0d0)*ci*z*(33*z**4+99*iymx**2*z**2-30*z**2-27*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,2,4) = (-25.0d0)*z*(33*z**4+99*iymx**2*z**2-30*z**2-27*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,3,4) = 25.0d0*ci*iymx*(165*z**4+99*iymx**2*z**2-90*z**2-9*iymx**2+5)/(44.0d0*sq2)
       end do
    case (275)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*ci*iymx*sq2/7.0d0
          sqy(ig,2,2) = (-5.0d0)*iymx*sq2/7.0d0
          sqy(ig,3,2) = 6.0d0*ci*sq2*z/7.0d0
          sqy(ig,1,3) = (-45.0d0)*ci*iymx*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,2,3) = (-45.0d0)*iymx*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*ci*z*(28*z**2+21*iymx**2-12)/(154.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*ci*iymx*(33*z**4-18*z**2+1)/(22.0d0*sq2)
          sqy(ig,2,4) = 25.0d0*iymx*(33*z**4-18*z**2+1)/(22.0d0*sq2)
          sqy(ig,3,4) = (-75.0d0)*ci*z*(33*z**4+22*iymx**2*z**2-30*z**2-6*iymx**2+5)/(22.0d0*sq2)
       end do
    case (276)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 10.0d0*z/7.0d0
          sqy(ig,3,2) = (-5.0d0)*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 60.0d0*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = (-90.0d0)*ci*(iypx+iymx)*(7*z**2-1)/77.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,3,4) = 125.0d0*ci*(iypx+iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (277)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -15*ci*iymx*z/sq30
          sqy(ig,2,1) = -15*iymx*z/sq30
          sqy(ig,3,1) = 15.0d0*ci*iymx**2/(2.0d0*sq30)
       end do
    case (278)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*ci*iymx**2*sq5/(2.0d0*sq6)
          sqy(ig,2,1) = (-9.0d0)*iymx**2*sq5/(2.0d0*sq6)
          sqy(ig,3,1) = 0
       end do
    case (279)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*iymx*sq30/14.0d0
          sqy(ig,2,1) = -iymx*sq30/14.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*iymx*sq5*(7*z**2+14*iymx**2-1)/(7.0d0*sq6)
          sqy(ig,2,2) = (-3.0d0)*iymx*sq5*(7*z**2+14*iymx**2-1)/(7.0d0*sq6)
          sqy(ig,3,2) = 15*ci*iymx**2*z/sq30
       end do
    case (280)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*sq30*z/7.0d0
          sqy(ig,2,1) = -sq30*z/7.0d0
          sqy(ig,3,1) = ci*iymx*sq30/7.0d0
          sqy(ig,1,2) = 3.0d0*ci*sq5*z*(7*z**2+21*iymx**2-3)/(14.0d0*sq6)
          sqy(ig,2,2) = 3.0d0*sq5*z*(7*z**2+21*iymx**2-3)/(14.0d0*sq6)
          sqy(ig,3,2) = (-3.0d0)*ci*iymx*sq5*(21*z**2+7*iymx**2-3)/(14.0d0*sq6)
       end do
    case (281)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 9.0d0*ci*iymx**2*sq5*z/4.0d0
          sqy(ig,2,2) = 9.0d0*iymx**2*sq5*z/4.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*iymx**3*sq5/4.0d0
       end do
    case (282)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*iymx*sq15/7.0d0
          sqy(ig,2,1) = -iymx*sq15/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iymx*sq15*(7*z**2-7*iymx**2-1)/7.0d0
          sqy(ig,2,2) = -iymx*sq15*(7*z**2-7*iymx**2-1)/7.0d0
          sqy(ig,3,2) = ci*iymx**2*sq15*z
       end do
    case (283)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*sq15*z/7.0d0
          sqy(ig,2,1) = -sq15*z/7.0d0
          sqy(ig,3,1) = ci*iymx*sq15/7.0d0
          sqy(ig,1,2) = ci*sq15*z*(7*z**2-42*iymx**2-3)/28.0d0
          sqy(ig,2,2) = sq15*z*(7*z**2-42*iymx**2-3)/28.0d0
          sqy(ig,3,2) = -ci*iymx*sq15*(21*z**2-14*iymx**2-3)/28.0d0
       end do
    case (284)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*ci*iymx*sq5/7.0d0
          sqy(ig,2,1) = (-9.0d0)*iymx*sq5/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*iymx*sq5*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = 3.0d0*iymx*sq5*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*iymx**2*sq5*z/2.0d0
       end do
    case (285)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iymx**2*sq5/4.0d0
          sqy(ig,2,2) = iymx**2*sq5/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = ci*iymx**2*sq5*(9*z**2+15*iymx**2-1)/4.0d0
          sqy(ig,2,3) = iymx**2*sq5*(9*z**2+15*iymx**2-1)/4.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*iymx**3*sq5*z/2.0d0
       end do
    case (286)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -ci*iymx*sq15*z*(3*z**2+6*iymx**2-1)/2.0d0
          sqy(ig,2,3) = -iymx*sq15*z*(3*z**2+6*iymx**2-1)/2.0d0
          sqy(ig,3,3) = ci*iymx**2*sq15*(9*z**2+3*iymx**2-1)/4.0d0
       end do
    case (287)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq3/(7.0d0*sq5)
          sqy(ig,2,1) = (-3.0d0)*sq3/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq3*(5*z**2+10*iymx**2-1)/sq5/4.0d0
          sqy(ig,2,2) = -sq3*(5*z**2+10*iymx**2-1)/sq5/4.0d0
          sqy(ig,3,2) = ci*iymx*sq15*z/2.0d0
          sqy(ig,1,3) = ci*sq15*(21*z**4+63*iymx**2*z**2-14*z**2-7*iymx**2+1)/28.0d0
          sqy(ig,2,3) = sq15*(21*z**4+63*iymx**2*z**2-14*z**2-7*iymx**2+1)/28.0d0
          sqy(ig,3,3) = -ci*iymx*sq15*z*(6*z**2+3*iymx**2-2)/2.0d0
       end do
    case (288)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 6.0d0*ci/(7.0d0*sq5)
          sqy(ig,1,2) = ci*iymx*sq5*z
          sqy(ig,2,2) = iymx*sq5*z
          sqy(ig,3,2) = -ci*(20*z**2+5*iymx**2-4)/sq5/2.0d0
          sqy(ig,1,3) = -ci*iymx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = -iymx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = ci*sq5*(105*z**4+63*iymx**2*z**2-70*z**2-7*iymx**2+5)/28.0d0
       end do
    case (289)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*ci*iymx**3*z/2.0d0
          sqy(ig,2,3) = (-15.0d0)*iymx**3*z/2.0d0
          sqy(ig,3,3) = 15.0d0*ci*iymx**4/8.0d0
       end do
    case (290)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iymx**2*sq5/2.0d0
          sqy(ig,2,2) = iymx**2*sq5/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = ci*iymx**2*sq5*(36*z**2-15*iymx**2-4)/8.0d0
          sqy(ig,2,3) = iymx**2*sq5*(36*z**2-15*iymx**2-4)/8.0d0
          sqy(ig,3,3) = -3*ci*iymx**3*sq5*z
       end do
    case (291)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*ci*iymx*z*(3*z**2-4*iymx**2-1)/(2.0d0*sq10)
          sqy(ig,2,3) = (-15.0d0)*iymx*z*(3*z**2-4*iymx**2-1)/(2.0d0*sq10)
          sqy(ig,3,3) = 15.0d0*ci*iymx**2*(9*z**2-2*iymx**2-1)/(4.0d0*sq10)
       end do
    case (292)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq2/(7.0d0*sq5)
          sqy(ig,2,1) = (-3.0d0)*sq2/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*(5*z**2-15*iymx**2-1)/sq10/2.0d0
          sqy(ig,2,2) = -(5*z**2-15*iymx**2-1)/sq10/2.0d0
          sqy(ig,3,2) = 5*ci*iymx*z/sq10
          sqy(ig,1,3) = ci*sq5*(42*z**4-189*iymx**2*z**2-28*z**2+21*iymx**2+2)/sq2/28.0d0
          sqy(ig,2,3) = sq5*(42*z**4-189*iymx**2*z**2-28*z**2+21*iymx**2+2)/sq2/28.0d0
          sqy(ig,3,3) = -ci*iymx*sq5*z*(12*z**2-9*iymx**2-4)/sq2/2.0d0
       end do
    case (293)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*ci/(7.0d0*sq5)
          sqy(ig,1,2) = -2*ci*iymx*sq5*z
          sqy(ig,2,2) = -2*iymx*sq5*z
          sqy(ig,3,2) = -ci*(5*z**2-5*iymx**2-1)/sq5
          sqy(ig,1,3) = ci*iymx*sq5*z*(3*z**2-1)
          sqy(ig,2,3) = iymx*sq5*z*(3*z**2-1)
          sqy(ig,3,3) = ci*sq5*(105*z**4-252*iymx**2*z**2-70*z**2+28*iymx**2+5)/56.0d0
       end do
    case (294)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*ci/7.0d0
          sqy(ig,2,1) = (-9)/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*(5*z**2-1)/2.0d0
          sqy(ig,2,2) = (5*z**2-1)/2.0d0
          sqy(ig,3,2) = -5*ci*iymx*z
          sqy(ig,1,3) = (-5.0d0)*ci*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = (-5.0d0)*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = 5.0d0*ci*iymx*z*(3*z**2-1)/2.0d0
       end do
    case (295)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*ci*iymx**3/22.0d0
          sqy(ig,2,3) = (-15.0d0)*iymx**3/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-15.0d0)*ci*iymx**3*(22*z**2+33*iymx**2-2)/44.0d0
          sqy(ig,2,4) = (-15.0d0)*iymx**3*(22*z**2+33*iymx**2-2)/44.0d0
          sqy(ig,3,4) = 15.0d0*ci*iymx**4*z/4.0d0
       end do
    case (296)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*ci*iymx**2*sq5*z/22.0d0
          sqy(ig,2,3) = 9.0d0*iymx**2*sq5*z/22.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*iymx**3*sq5/22.0d0
          sqy(ig,1,4) = 15.0d0*ci*iymx**2*sq5*z*(33*z**2+55*iymx**2-9)/88.0d0
          sqy(ig,2,4) = 15.0d0*iymx**2*sq5*z*(33*z**2+55*iymx**2-9)/88.0d0
          sqy(ig,3,4) = (-15.0d0)*ci*iymx**3*sq5*(33*z**2+11*iymx**2-3)/88.0d0
       end do
    case (297)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iymx*sq10/7.0d0
          sqy(ig,2,2) = iymx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 45.0d0*ci*iymx*(7*z**2+28*iymx**2-1)/(154.0d0*sq10)
          sqy(ig,2,3) = 45.0d0*iymx*(7*z**2+28*iymx**2-1)/(154.0d0*sq10)
          sqy(ig,3,3) = (-45.0d0)*ci*iymx**2*z/(22.0d0*sq10)
          sqy(ig,1,4) = (-5.0d0)*ci*iymx*sq5*(33*z**4+66*iymx**2*z**2-18*z**2-6*iymx**2+1)/(22.0d0*sq2)
          sqy(ig,2,4) = (-5.0d0)*iymx*sq5*(33*z**4+66*iymx**2*z**2-18*z**2-6*iymx**2+1)/(22.0d0*sq2)
          sqy(ig,3,4) = 15.0d0*ci*iymx**2*sq5*z*(22*z**2+11*iymx**2-6)/(22.0d0*sq2)
       end do
    case (298)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq10*z/7.0d0
          sqy(ig,2,2) = -sq10*z/7.0d0
          sqy(ig,3,2) = ci*iymx*sq10/7.0d0
          sqy(ig,1,3) = (-3.0d0)*ci*sq5*z*(56*z**2+189*iymx**2-24)/(154.0d0*sq2)
          sqy(ig,2,3) = (-3.0d0)*sq5*z*(56*z**2+189*iymx**2-24)/(154.0d0*sq2)
          sqy(ig,3,3) = 9.0d0*ci*iymx*sq5*(56*z**2+21*iymx**2-8)/(154.0d0*sq2)
          sqy(ig,1,4) = 5.0d0*ci*sq5*z*(33*z**4+99*iymx**2*z**2-30*z**2-27*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,2,4) = 5.0d0*sq5*z*(33*z**4+99*iymx**2*z**2-30*z**2-27*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,3,4) = (-5.0d0)*ci*iymx*sq5*(165*z**4+99*iymx**2*z**2-90*z**2-9*iymx**2+5)/(44.0d0*sq2)
       end do
    case (299)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*ci*iymx*sq5/7.0d0
          sqy(ig,2,2) = (-2.0d0)*iymx*sq5/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 27.0d0*ci*iymx*sq5*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = 27.0d0*iymx*sq5*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*sq5*z*(35*z**2+18*iymx**2-15)/22.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*iymx*sq5*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,2,4) = (-5.0d0)*iymx*sq5*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,3,4) = 15.0d0*ci*sq5*z*(33*z**4+22*iymx**2*z**2-30*z**2-6*iymx**2+5)/44.0d0
       end do
    case (300)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 10.0d0*z/7.0d0
          sqy(ig,3,2) = (-5.0d0)*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = (-45.0d0)*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = 135.0d0*ci*(iypx+iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 5.0d0*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,3,4) = (-25.0d0)*ci*(iypx+iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (301)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (302)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*iypx**2*sq35/4.0d0
          sqy(ig,2,1) = (-3.0d0)*iypx**2*sq35/4.0d0
          sqy(ig,3,1) = 0
       end do
    case (303)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*iypx*sq35/7.0d0
          sqy(ig,2,1) = 3.0d0*iypx*sq35/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iypx*sq35*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = -iypx*sq35*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = ci*iypx**2*sq35*z/2.0d0
       end do
    case (304)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*iypx**2*sq35*z/4.0d0
          sqy(ig,2,2) = 3.0d0*iypx**2*sq35*z/4.0d0
          sqy(ig,3,2) = -ci*iypx**3*sq35/4.0d0
       end do
    case (305)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (306)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*iypx*sq35/(7.0d0*sq2)
          sqy(ig,2,1) = (-3.0d0)*iypx*sq35/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iypx*sq35*(7*z**2-1)/sq2/14.0d0
          sqy(ig,2,2) = iypx*sq35*(7*z**2-1)/sq2/14.0d0
          sqy(ig,3,2) = -ci*iypx**2*sq35*z/sq2/2.0d0
       end do
    case (307)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*iypx**2*sq35*z/(2.0d0*sq2)
          sqy(ig,2,2) = (-3.0d0)*iypx**2*sq35*z/(2.0d0*sq2)
          sqy(ig,3,2) = ci*iypx**3*sq35/sq2/2.0d0
       end do
    case (308)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iypx**3*sq105/sq2
          sqy(ig,2,2) = iypx**3*sq105/sq2
          sqy(ig,3,2) = 0
       end do
    case (309)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq42/(7.0d0*sq5)
          sqy(ig,2,1) = 3.0d0*sq42/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq42*(5*z**2-1)/sq5/6.0d0
          sqy(ig,2,2) = -sq42*(5*z**2-1)/sq5/6.0d0
          sqy(ig,3,2) = ci*iypx*sq210*z/3.0d0
          sqy(ig,1,3) = -ci*sq35*(21*z**4-14*z**2+1)/sq6/28.0d0
          sqy(ig,2,3) = sq35*(21*z**4-14*z**2+1)/sq6/28.0d0
          sqy(ig,3,3) = -ci*iypx*sq35*z*(3*z**2-1)/sq6
       end do
    case (310)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iypx*sq35*z/sq2
          sqy(ig,2,2) = iypx*sq35*z/sq2
          sqy(ig,3,2) = -ci*iypx**2*sq35/sq2/2.0d0
          sqy(ig,1,3) = ci*iypx*sq35*z*(3*z**2-1)/sq2/2.0d0
          sqy(ig,2,3) = -iypx*sq35*z*(3*z**2-1)/sq2/2.0d0
          sqy(ig,3,3) = ci*iypx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
       end do
    case (311)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iypx**2*sq35/sq2/2.0d0
          sqy(ig,2,2) = -iypx**2*sq35/sq2/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -ci*iypx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,2,3) = iypx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*iypx**3*sq35*z/(2.0d0*sq2)
       end do
    case (312)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3*ci*iypx**3*sq35*z/sq6
          sqy(ig,2,3) = -3*iypx**3*sq35*z/sq6
          sqy(ig,3,3) = 3.0d0*ci*iypx**4*sq35/(4.0d0*sq6)
       end do
    case (313)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
       end do
    case (314)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*sq42/(14.0d0*sq5)
          sqy(ig,2,1) = (-3.0d0)*sq42/(14.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq42*(5*z**2-1)/sq5/12.0d0
          sqy(ig,2,2) = sq42*(5*z**2-1)/sq5/12.0d0
          sqy(ig,3,2) = -ci*iypx*sq210*z/6.0d0
          sqy(ig,1,3) = ci*sq35*(21*z**4-14*z**2+1)/sq6/56.0d0
          sqy(ig,2,3) = -sq35*(21*z**4-14*z**2+1)/sq6/56.0d0
          sqy(ig,3,3) = ci*iypx*sq35*z*(3*z**2-1)/sq6/2.0d0
       end do
    case (315)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iypx*sq105*z/3.0d0
          sqy(ig,2,2) = -iypx*sq105*z/3.0d0
          sqy(ig,3,2) = ci*iypx**2*sq105/6.0d0
          sqy(ig,1,3) = -ci*iypx*sq105*z*(3*z**2-1)/6.0d0
          sqy(ig,2,3) = iypx*sq105*z*(3*z**2-1)/6.0d0
          sqy(ig,3,3) = -ci*iypx**2*sq105*(3*z-1)*(3*z+1)/12.0d0
       end do
    case (316)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iypx**2*sq105/4.0d0
          sqy(ig,2,2) = iypx**2*sq105/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = ci*iypx**2*sq105*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,2,3) = -iypx**2*sq105*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,3,3) = 3.0d0*ci*iypx**3*sq105*z/4.0d0
       end do
    case (317)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -ci*iypx**3*sq210*z
          sqy(ig,2,3) = iypx**3*sq210*z
          sqy(ig,3,3) = (-3.0d0)*ci*iypx**4*sq35/(2.0d0*sq6)
       end do
    case (318)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 75.0d0*ci*iypx**4*sq7/(8.0d0*sq6)
          sqy(ig,2,3) = (-75.0d0)*iypx**4*sq7/(8.0d0*sq6)
          sqy(ig,3,3) = 0
       end do
    case (319)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 30*ci*z/sq42
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-45.0d0)*ci*sq6*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 105.0d0*ci*z*(33*z**4-30*z**2+5)/(44.0d0*sq42)
       end do
    case (320)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*ci*sq30*z/(6.0d0*sq7)
          sqy(ig,2,2) = 5.0d0*sq30*z/(6.0d0*sq7)
          sqy(ig,3,2) = (-5.0d0)*ci*iypx*sq30/(6.0d0*sq7)
          sqy(ig,1,3) = 15.0d0*ci*sq30*z*(7*z**2-3)/(44.0d0*sq7)
          sqy(ig,2,3) = (-15.0d0)*sq30*z*(7*z**2-3)/(44.0d0*sq7)
          sqy(ig,3,3) = 45.0d0*ci*iypx*sq30*(7*z**2-1)/(44.0d0*sq7)
          sqy(ig,1,4) = (-5.0d0)*ci*sq210*z*(33*z**4-30*z**2+5)/528.0d0
          sqy(ig,2,4) = 5.0d0*sq210*z*(33*z**4-30*z**2+5)/528.0d0
          sqy(ig,3,4) = (-25.0d0)*ci*iypx*sq210*(33*z**4-18*z**2+1)/528.0d0
       end do
    case (321)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*ci*iypx*sq15/(3.0d0*sq7)
          sqy(ig,2,2) = (-2.0d0)*iypx*sq15/(3.0d0*sq7)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*ci*iypx*sq15*(7*z**2-1)/(11.0d0*sq7)
          sqy(ig,2,3) = 9.0d0*iypx*sq15*(7*z**2-1)/(11.0d0*sq7)
          sqy(ig,3,3) = (-9.0d0)*ci*iypx**2*sq105*z/11.0d0
          sqy(ig,1,4) = 5.0d0*ci*iypx*sq105*(33*z**4-18*z**2+1)/132.0d0
          sqy(ig,2,4) = (-5.0d0)*iypx*sq105*(33*z**4-18*z**2+1)/132.0d0
          sqy(ig,3,4) = 5.0d0*ci*iypx**2*sq105*z*(11*z**2-3)/22.0d0
       end do
    case (322)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 27.0d0*ci*iypx**2*sq105*z/44.0d0
          sqy(ig,2,3) = (-27.0d0)*iypx**2*sq105*z/44.0d0
          sqy(ig,3,3) = 9.0d0*ci*iypx**3*sq105/44.0d0
          sqy(ig,1,4) = (-15.0d0)*ci*iypx**2*sq105*z*(11*z**2-3)/88.0d0
          sqy(ig,2,4) = 15.0d0*iypx**2*sq105*z*(11*z**2-3)/88.0d0
          sqy(ig,3,4) = (-15.0d0)*ci*iypx**3*sq105*(11*z**2-1)/88.0d0
       end do
    case (323)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*ci*iypx**3*sq105/(11.0d0*sq2)
          sqy(ig,2,3) = 3.0d0*iypx**3*sq105/(11.0d0*sq2)
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 5.0d0*ci*iypx**3*sq105*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,2,4) = (-5.0d0)*iypx**3*sq105*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,3,4) = 5.0d0*ci*iypx**4*sq105*z/(4.0d0*sq2)
       end do
    case (324)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-75.0d0)*ci*iypx**4*sq7*z/(8.0d0*sq6)
          sqy(ig,2,4) = 75.0d0*iypx**4*sq7*z/(8.0d0*sq6)
          sqy(ig,3,4) = (-15.0d0)*ci*iypx**5*sq7/(8.0d0*sq6)
       end do
    case (325)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 0
       end do
    case (326)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*iypx**2*sq5/4.0d0
          sqy(ig,2,1) = 3.0d0*iypx**2*sq5/4.0d0
          sqy(ig,3,1) = 0
       end do
    case (327)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3*ci*iypx*sq5*z
          sqy(ig,2,1) = -3*iypx*sq5*z
          sqy(ig,3,1) = 3.0d0*ci*iypx**2*sq5/2.0d0
       end do
    case (328)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-6.0d0)*ci*sq5*z/7.0d0
          sqy(ig,2,1) = 6.0d0*sq5*z/7.0d0
          sqy(ig,3,1) = (-6.0d0)*ci*iypx*sq5/7.0d0
          sqy(ig,1,2) = 3.0d0*ci*sq5*z*(14*z**2-7*iypx**2-6)/28.0d0
          sqy(ig,2,2) = (-3.0d0)*sq5*z*(14*z**2-7*iypx**2-6)/28.0d0
          sqy(ig,3,2) = ci*iypx*sq5*(126*z**2-7*iypx**2-18)/28.0d0
       end do
    case (329)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*iypx*sq5/7.0d0
          sqy(ig,2,1) = 3.0d0*iypx*sq5/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iypx*sq5*(21*z**2-7*iypx**2-3)/7.0d0
          sqy(ig,2,2) = iypx*sq5*(21*z**2-7*iypx**2-3)/7.0d0
          sqy(ig,3,2) = -3*ci*iypx**2*sq5*z
       end do
    case (330)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*iypx*sq15/(7.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*iypx*sq15/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iypx*sq15*(7*z**2-1)/sq2/14.0d0
          sqy(ig,2,2) = -iypx*sq15*(7*z**2-1)/sq2/14.0d0
          sqy(ig,3,2) = ci*iypx**2*sq15*z/sq2/2.0d0
       end do
    case (331)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*sq10*z/7.0d0
          sqy(ig,2,1) = (-3.0d0)*sq10*z/7.0d0
          sqy(ig,3,1) = 3.0d0*ci*iypx*sq10/7.0d0
          sqy(ig,1,2) = (-3.0d0)*ci*sq5*z*(7*z**2+7*iypx**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = 3.0d0*sq5*z*(7*z**2+7*iypx**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = -ci*iypx*sq5*(63*z**2+7*iypx**2-9)/sq2/14.0d0
       end do
    case (332)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*iypx*sq10/7.0d0
          sqy(ig,2,1) = (-3.0d0)*iypx*sq10/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iypx*sq5*(42*z**2+7*iypx**2-6)/sq2/7.0d0
          sqy(ig,2,2) = -iypx*sq5*(42*z**2+7*iypx**2-6)/sq2/7.0d0
          sqy(ig,3,2) = 3*ci*iypx**2*sq10*z
       end do
    case (333)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*ci*iypx**2*sq15*z/(2.0d0*sq2)
          sqy(ig,2,2) = 9.0d0*iypx**2*sq15*z/(2.0d0*sq2)
          sqy(ig,3,2) = (-3.0d0)*ci*iypx**3*sq15/(2.0d0*sq2)
       end do
    case (334)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-6.0d0)*ci*sq6/(7.0d0*sq5)
          sqy(ig,1,2) = -ci*iypx*sq15*z/sq2/3.0d0
          sqy(ig,2,2) = iypx*sq15*z/sq2/3.0d0
          sqy(ig,3,2) = ci*sq3*(120*z**2-5*iypx**2-24)/sq10/6.0d0
          sqy(ig,1,3) = ci*iypx*sq10*z*(3*z**2-1)/sq3/4.0d0
          sqy(ig,2,3) = -iypx*sq10*z*(3*z**2-1)/sq3/4.0d0
          sqy(ig,3,3) = -ci*sq10*(630*z**4-63*iypx**2*z**2-420*z**2+7*iypx**2+30)/sq3/56.0d0
       end do
    case (335)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*ci*sq2/(7.0d0*sq5)
          sqy(ig,2,1) = 9.0d0*sq2/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*(15*z**2-5*iypx**2-3)/sq10/2.0d0
          sqy(ig,2,2) = (15*z**2-5*iypx**2-3)/sq10/2.0d0
          sqy(ig,3,2) = -15*ci*iypx*z/sq10
          sqy(ig,1,3) = ci*sq5*(126*z**4-63*iypx**2*z**2-84*z**2+7*iypx**2+6)/sq2/28.0d0
          sqy(ig,2,3) = -sq5*(126*z**4-63*iypx**2*z**2-84*z**2+7*iypx**2+6)/sq2/28.0d0
          sqy(ig,3,3) = 3.0d0*ci*iypx*sq5*z*(12*z**2-iypx**2-4)/(2.0d0*sq2)
       end do
    case (336)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -3*ci*iypx*sq5*z*(3*z**2-iypx**2-1)/sq2
          sqy(ig,2,3) = 3*iypx*sq5*z*(3*z**2-iypx**2-1)/sq2
          sqy(ig,3,3) = (-3.0d0)*ci*iypx**2*sq5*(18*z**2-iypx**2-2)/(4.0d0*sq2)
       end do
    case (337)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iypx**2*sq30/4.0d0
          sqy(ig,2,2) = -iypx**2*sq30/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*ci*iypx**2*(18*z**2-5*iypx**2-2)/(4.0d0*sq30)
          sqy(ig,2,3) = (-15.0d0)*iypx**2*(18*z**2-5*iypx**2-2)/(4.0d0*sq30)
          sqy(ig,3,3) = 45*ci*iypx**3*z/sq30
       end do
    case (338)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq6/14.0d0
          sqy(ig,2,1) = 3.0d0*sq6/14.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*(5*z**2-1)/sq6/2.0d0
          sqy(ig,2,2) = -(5*z**2-1)/sq6/2.0d0
          sqy(ig,3,2) = 5*ci*iypx*z/sq6
          sqy(ig,1,3) = (-5.0d0)*ci*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,2,3) = 5.0d0*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,3,3) = (-5.0d0)*ci*iypx*z*(3*z**2-1)/(2.0d0*sq6)
       end do
    case (339)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*ci*sq6/(7.0d0*sq5)
          sqy(ig,1,2) = -ci*iypx*sq30*z/3.0d0
          sqy(ig,2,2) = iypx*sq30*z/3.0d0
          sqy(ig,3,2) = -ci*sq3*(30*z**2+5*iypx**2-6)/sq10/3.0d0
          sqy(ig,1,3) = ci*iypx*sq10*z*(3*z**2-1)/sq3/2.0d0
          sqy(ig,2,3) = -iypx*sq10*z*(3*z**2-1)/sq3/2.0d0
          sqy(ig,3,3) = ci*sq10*(315*z**4+126*iypx**2*z**2-210*z**2-14*iypx**2+15)/sq3/56.0d0
       end do
    case (340)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*ci*sq3/(7.0d0*sq5)
          sqy(ig,2,1) = (-6.0d0)*sq3/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq3*(10*z**2+5*iypx**2-2)/sq5/4.0d0
          sqy(ig,2,2) = -sq3*(10*z**2+5*iypx**2-2)/sq5/4.0d0
          sqy(ig,3,2) = ci*iypx*sq15*z
          sqy(ig,1,3) = -ci*sq15*(84*z**4+63*iypx**2*z**2-56*z**2-7*iypx**2+4)/56.0d0
          sqy(ig,2,3) = sq15*(84*z**4+63*iypx**2*z**2-56*z**2-7*iypx**2+4)/56.0d0
          sqy(ig,3,3) = -ci*iypx*sq15*z*(24*z**2+3*iypx**2-8)/4.0d0
       end do
    case (341)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = ci*iypx*sq15*z*(9*z**2+2*iypx**2-3)/2.0d0
          sqy(ig,2,3) = -iypx*sq15*z*(9*z**2+2*iypx**2-3)/2.0d0
          sqy(ig,3,3) = ci*iypx**2*sq15*(27*z**2+iypx**2-3)/4.0d0
       end do
    case (342)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iypx**2*sq30/2.0d0
          sqy(ig,2,2) = iypx**2*sq30/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*ci*iypx**2*(72*z**2+5*iypx**2-8)/(8.0d0*sq30)
          sqy(ig,2,3) = 15.0d0*iypx**2*(72*z**2+5*iypx**2-8)/(8.0d0*sq30)
          sqy(ig,3,3) = -3*ci*iypx**3*sq30*z
       end do
    case (343)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*ci*iypx**3*sq6*z/2.0d0
          sqy(ig,2,3) = (-15.0d0)*iypx**3*sq6*z/2.0d0
          sqy(ig,3,3) = 15.0d0*ci*iypx**4*sq6/8.0d0
       end do
    case (344)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -5*ci*z/sq6
          sqy(ig,2,2) = (-25.0d0)*z/(7.0d0*sq6)
          sqy(ig,3,2) = (-5.0d0)*ci*(iypx-6*iymx)/(7.0d0*sq6)
          sqy(ig,1,3) = 15.0d0*ci*sq6*z*(7*z**2-3)/44.0d0
          sqy(ig,2,3) = 75.0d0*sq6*z*(7*z**2-3)/308.0d0
          sqy(ig,3,3) = 45.0d0*ci*(iypx-6*iymx)*sq6*(7*z**2-1)/308.0d0
          sqy(ig,1,4) = (-35.0d0)*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
          sqy(ig,2,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
          sqy(ig,3,4) = (-25.0d0)*ci*(iypx-6*iymx)*(33*z**4-18*z**2+1)/(88.0d0*sq6)
       end do
    case (345)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*ci*iypx*sq5/(7.0d0*sq6)
          sqy(ig,2,2) = (-2.0d0)*iypx*sq5/(7.0d0*sq6)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*ci*iypx*sq15*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = 9.0d0*iypx*sq15*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*ci*sq15*z*(35*z**2-3*iypx**2-15)/(11.0d0*sq2)
          sqy(ig,1,4) = 5.0d0*ci*iypx*sq5*(33*z**4-18*z**2+1)/(44.0d0*sq6)
          sqy(ig,2,4) = (-5.0d0)*iypx*sq5*(33*z**4-18*z**2+1)/(44.0d0*sq6)
          sqy(ig,3,4) = (-15.0d0)*ci*sq5*z*(99*z**4-11*iypx**2*z**2-90*z**2+3*iypx**2+15)/(22.0d0*sq6)
       end do
    case (346)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*ci*sq15*z/7.0d0
          sqy(ig,2,2) = 2.0d0*sq15*z/7.0d0
          sqy(ig,3,2) = (-2.0d0)*ci*iypx*sq15/7.0d0
          sqy(ig,1,3) = (-3.0d0)*ci*sq15*z*(112*z**2-63*iypx**2-48)/308.0d0
          sqy(ig,2,3) = 3.0d0*sq15*z*(112*z**2-63*iypx**2-48)/308.0d0
          sqy(ig,3,3) = (-9.0d0)*ci*iypx*sq15*(112*z**2-7*iypx**2-16)/308.0d0
          sqy(ig,1,4) = 5.0d0*ci*sq15*z*(66*z**4-33*iypx**2*z**2-60*z**2+9*iypx**2+10)/88.0d0
          sqy(ig,2,4) = (-5.0d0)*sq15*z*(66*z**4-33*iypx**2*z**2-60*z**2+9*iypx**2+10)/88.0d0
          sqy(ig,3,4) = 5.0d0*ci*iypx*sq15*(330*z**4-33*iypx**2*z**2-180*z**2+3*iypx**2+10)/88.0d0
       end do
    case (347)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*ci*iypx*sq15/7.0d0
          sqy(ig,2,2) = (-2.0d0)*iypx*sq15/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*ci*iypx*sq15*(21*z**2-14*iypx**2-3)/154.0d0
          sqy(ig,2,3) = (-3.0d0)*iypx*sq15*(21*z**2-14*iypx**2-3)/154.0d0
          sqy(ig,3,3) = 9.0d0*ci*iypx**2*sq15*z/22.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*iypx*sq15*(33*z**4-11*iypx**2*z**2-18*z**2+iypx**2+1)/22.0d0
          sqy(ig,2,4) = 5.0d0*iypx*sq15*(33*z**4-11*iypx**2*z**2-18*z**2+iypx**2+1)/22.0d0
          sqy(ig,3,4) = (-5.0d0)*ci*iypx**2*sq15*z*(132*z**2-11*iypx**2-36)/44.0d0
       end do
    case (348)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*ci*iypx**2*sq15*z/(11.0d0*sq2)
          sqy(ig,2,3) = (-9.0d0)*iypx**2*sq15*z/(11.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*ci*iypx**3*sq15/(11.0d0*sq2)
          sqy(ig,1,4) = 15.0d0*ci*iypx**2*sq5*z*(198*z**2-55*iypx**2-54)/(88.0d0*sq6)
          sqy(ig,2,4) = (-15.0d0)*iypx**2*sq5*z*(198*z**2-55*iypx**2-54)/(88.0d0*sq6)
          sqy(ig,3,4) = 5.0d0*ci*iypx**3*sq15*sq2*(198*z**2-11*iypx**2-18)/176.0d0
       end do
    case (349)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*ci*iypx**3*sq6/22.0d0
          sqy(ig,2,3) = 15.0d0*iypx**3*sq6/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-15.0d0)*ci*iypx**3*sq6*(44*z**2-11*iypx**2-4)/88.0d0
          sqy(ig,2,4) = 15.0d0*iypx**3*sq6*(44*z**2-11*iypx**2-4)/88.0d0
          sqy(ig,3,4) = (-15.0d0)*ci*iypx**4*sq6*z/4.0d0
       end do
    case (350)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 5*ci*z/sq7
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-45.0d0)*ci*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 5.0d0*ci*sq7*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (351)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 10.0d0*z/7.0d0
          sqy(ig,3,2) = (-5.0d0)*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = (-45.0d0)*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = 135.0d0*ci*(iypx+iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 5.0d0*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,3,4) = (-25.0d0)*ci*(iypx+iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (352)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*iypx*sq15*z
          sqy(ig,2,1) = iypx*sq15*z
          sqy(ig,3,1) = -ci*iypx**2*sq15/2.0d0
       end do
    case (353)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq15*(5*z**2-1)/4.0d0
          sqy(ig,2,1) = -sq15*(5*z**2-1)/4.0d0
          sqy(ig,3,1) = 5.0d0*ci*iypx*sq15*z/2.0d0
       end do
    case (354)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*iypx*sq15/7.0d0
          sqy(ig,2,1) = iypx*sq15/7.0d0
          sqy(ig,3,1) = (-6.0d0)*ci*sq15*z/7.0d0
          sqy(ig,1,2) = -ci*iypx*sq15*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = iypx*sq15*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = ci*sq15*z*(35*z**2-7*iypx**2-15)/7.0d0
       end do
    case (355)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-2.0d0)*ci*sq15*z/7.0d0
          sqy(ig,2,1) = 2.0d0*sq15*z/7.0d0
          sqy(ig,3,1) = (-2.0d0)*ci*iypx*sq15/7.0d0
          sqy(ig,1,2) = -ci*sq15*z*(35*z**2-42*iypx**2-15)/28.0d0
          sqy(ig,2,2) = sq15*z*(35*z**2-42*iypx**2-15)/28.0d0
          sqy(ig,3,2) = -ci*iypx*sq15*(105*z**2-14*iypx**2-15)/28.0d0
       end do
    case (356)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq10*z/7.0d0
          sqy(ig,2,1) = 3.0d0*sq10*z/7.0d0
          sqy(ig,3,1) = (-3.0d0)*ci*iypx*sq10/7.0d0
          sqy(ig,1,2) = 3.0d0*ci*sq10*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = (-3.0d0)*sq10*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = 9.0d0*ci*iypx*sq10*(7*z**2-1)/28.0d0
       end do
    case (357)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*iypx*sq30/7.0d0
          sqy(ig,2,1) = iypx*sq30/7.0d0
          sqy(ig,3,1) = 3.0d0*ci*sq30*z/7.0d0
          sqy(ig,1,2) = -ci*iypx*sq30*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = iypx*sq30*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = -ci*sq15*z*(35*z**2+14*iypx**2-15)/sq2/7.0d0
       end do
    case (358)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*ci*sq30*z/7.0d0
          sqy(ig,2,1) = (-2.0d0)*sq30*z/7.0d0
          sqy(ig,3,1) = 2.0d0*ci*iypx*sq30/7.0d0
          sqy(ig,1,2) = ci*sq15*z*(35*z**2+21*iypx**2-15)/sq2/14.0d0
          sqy(ig,2,2) = -sq15*z*(35*z**2+21*iypx**2-15)/sq2/14.0d0
          sqy(ig,3,2) = ci*iypx*sq15*(105*z**2+7*iypx**2-15)/sq2/14.0d0
       end do
    case (359)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*iypx*sq5/(7.0d0*sq2)
          sqy(ig,2,1) = (-3.0d0)*iypx*sq5/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-15.0d0)*ci*iypx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,2) = 15.0d0*iypx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,2) = (-15.0d0)*ci*iypx**2*sq5*z/(2.0d0*sq2)
       end do
    case (360)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 6.0d0*sq2/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*ci*(5*z**2-1)/(2.0d0*sq10)
          sqy(ig,2,2) = (-3.0d0)*(5*z**2-1)/(2.0d0*sq10)
          sqy(ig,3,2) = -ci*(iypx-4*iymx)*sq10*z/2.0d0
          sqy(ig,1,3) = ci*sq10*(21*z**4-14*z**2+1)/8.0d0
          sqy(ig,2,3) = 3.0d0*sq10*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = ci*(2*iypx-5*iymx)*sq10*z*(3*z**2-1)/2.0d0
       end do
    case (361)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-6.0d0)*ci*sq30/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -ci*sq6*(5*z**2-1)/sq5/2.0d0
          sqy(ig,1,3) = -ci*iypx*sq30*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = iypx*sq30*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = ci*sq30*(525*z**4-126*iypx**2*z**2-350*z**2+14*iypx**2+25)/56.0d0
       end do
    case (362)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq6/(7.0d0*sq5)
          sqy(ig,2,1) = 3.0d0*sq6/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq3*(5*z**2-5*iypx**2-1)/sq10/2.0d0
          sqy(ig,2,2) = sq3*(5*z**2-5*iypx**2-1)/sq10/2.0d0
          sqy(ig,3,2) = -ci*iypx*sq30*z/2.0d0
          sqy(ig,1,3) = -ci*sq30*(105*z**4-126*iypx**2*z**2-70*z**2+14*iypx**2+5)/56.0d0
          sqy(ig,2,3) = sq30*(105*z**4-126*iypx**2*z**2-70*z**2+14*iypx**2+5)/56.0d0
          sqy(ig,3,3) = -ci*iypx*sq30*z*(15*z**2-3*iypx**2-5)/2.0d0
       end do
    case (363)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iypx*sq5*z/sq2
          sqy(ig,2,2) = -iypx*sq5*z/sq2
          sqy(ig,3,2) = ci*iypx**2*sq5/sq2/2.0d0
          sqy(ig,1,3) = ci*iypx*sq5*z*(15*z**2-12*iypx**2-5)/sq2/2.0d0
          sqy(ig,2,3) = -iypx*sq5*z*(15*z**2-12*iypx**2-5)/sq2/2.0d0
          sqy(ig,3,3) = ci*iypx**2*sq5*(45*z**2-6*iypx**2-5)/sq2/4.0d0
       end do
    case (364)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-3.0d0)*ci*sq2/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = ci*sq2*(5*z**2-1)
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-25.0d0)*ci*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (365)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq5/(7.0d0*sq2)
          sqy(ig,2,1) = 9.0d0/(7.0d0*sq2*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 2*(5*z**2-1)/sq10
          sqy(ig,3,2) = -ci*(iypx+iymx)*sq10*z
          sqy(ig,1,3) = 3.0d0*ci*sq10*(21*z**4-14*z**2+1)/112.0d0
          sqy(ig,2,3) = (-13.0d0)*sq10*(21*z**4-14*z**2+1)/112.0d0
          sqy(ig,3,3) = ci*(8*iypx+5*iymx)*sq10*z*(3*z**2-1)/4.0d0
       end do
    case (366)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 12.0d0*ci/(7.0d0*sq5)
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = ci*(5*z**2-1)/sq5
          sqy(ig,1,3) = (-3.0d0)*ci*iypx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = 3.0d0*iypx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = -ci*sq5*(525*z**4+189*iypx**2*z**2-350*z**2-21*iypx**2+25)/28.0d0
       end do
    case (367)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*ci/(7.0d0*sq5)
          sqy(ig,2,1) = (-9.0d0)/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*(15*z**2+10*iypx**2-3)/sq5/4.0d0
          sqy(ig,2,2) = -(15*z**2+10*iypx**2-3)/sq5/4.0d0
          sqy(ig,3,2) = 3.0d0*ci*iypx*sq5*z/2.0d0
          sqy(ig,1,3) = ci*sq5*(315*z**4+252*iypx**2*z**2-210*z**2-28*iypx**2+15)/56.0d0
          sqy(ig,2,3) = -sq5*(315*z**4+252*iypx**2*z**2-210*z**2-28*iypx**2+15)/56.0d0
          sqy(ig,3,3) = 3.0d0*ci*iypx*sq5*z*(15*z**2+2*iypx**2-5)/2.0d0
       end do
    case (368)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iypx*sq10*z
          sqy(ig,2,2) = iypx*sq10*z
          sqy(ig,3,2) = -ci*iypx**2*sq5/sq2
          sqy(ig,1,3) = -ci*iypx*sq5*z*(15*z**2+3*iypx**2-5)/sq2
          sqy(ig,2,3) = iypx*sq5*z*(15*z**2+3*iypx**2-5)/sq2
          sqy(ig,3,3) = -ci*iypx**2*sq5*(90*z**2+3*iypx**2-10)/sq2/4.0d0
       end do
    case (369)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*ci*iypx**2/(2.0d0*sq2)
          sqy(ig,2,2) = 5.0d0*iypx**2/(2.0d0*sq2)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 25.0d0*ci*iypx**2*(3*z-1)*(3*z+1)/(8.0d0*sq2)
          sqy(ig,2,3) = (-25.0d0)*iypx**2*(3*z-1)*(3*z+1)/(8.0d0*sq2)
          sqy(ig,3,3) = 75.0d0*ci*iypx**3*z/(4.0d0*sq2)
       end do
    case (370)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*ci*iymx*sq2/7.0d0
          sqy(ig,2,2) = (-5.0d0)*iymx*sq2/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 135.0d0*ci*iymx*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = 135.0d0*iymx*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*ci*z*(7*z**2-9*iymx**2-3)/(11.0d0*sq2)
          sqy(ig,1,4) = (-25.0d0)*ci*iymx*(33*z**4-18*z**2+1)/(44.0d0*sq2)
          sqy(ig,2,4) = (-25.0d0)*iymx*(33*z**4-18*z**2+1)/(44.0d0*sq2)
          sqy(ig,3,4) = (-15.0d0)*ci*z*(33*z**4-55*iymx**2*z**2-30*z**2+15*iymx**2+5)/(22.0d0*sq2)
       end do
    case (371)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq10*z/2.0d0
          sqy(ig,2,2) = (-3.0d0)*sq10*z/14.0d0
          sqy(ig,3,2) = -ci*(2*iypx-5*iymx)*sq10/14.0d0
          sqy(ig,1,3) = (-3.0d0)*ci*sq10*z*(7*z**2-3)/11.0d0
          sqy(ig,2,3) = (-9.0d0)*sq10*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = (-9.0d0)*ci*(2*iypx-5*iymx)*sq10*(7*z**2-1)/77.0d0
          sqy(ig,1,4) = 35.0d0*ci*sq10*z*(33*z**4-30*z**2+5)/176.0d0
          sqy(ig,2,4) = 15.0d0*sq10*z*(33*z**4-30*z**2+5)/176.0d0
          sqy(ig,3,4) = 25.0d0*ci*(2*iypx-5*iymx)*sq10*(33*z**4-18*z**2+1)/176.0d0
       end do
    case (372)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*ci*iypx*sq5/7.0d0
          sqy(ig,2,2) = (-2.0d0)*iypx*sq5/7.0d0
          sqy(ig,3,2) = (-6.0d0)*ci*sq5*z/7.0d0
          sqy(ig,1,3) = 9.0d0*ci*iypx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,2,3) = (-9.0d0)*iypx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*sq5*z*(70*z**2-21*iypx**2-30)/154.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*iypx*sq5*(33*z**4-18*z**2+1)/22.0d0
          sqy(ig,2,4) = 5.0d0*iypx*sq5*(33*z**4-18*z**2+1)/22.0d0
          sqy(ig,3,4) = 15.0d0*ci*sq5*z*(165*z**4-44*iypx**2*z**2-150*z**2+12*iypx**2+25)/44.0d0
       end do
    case (373)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq5*z/7.0d0
          sqy(ig,2,2) = sq5*z/7.0d0
          sqy(ig,3,2) = -ci*iypx*sq5/7.0d0
          sqy(ig,1,3) = (-9.0d0)*ci*sq5*z*(35*z**2-28*iypx**2-15)/308.0d0
          sqy(ig,2,3) = 9.0d0*sq5*z*(35*z**2-28*iypx**2-15)/308.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*iypx*sq5*(315*z**2-28*iypx**2-45)/308.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*sq5*z*(165*z**4-198*iypx**2*z**2-150*z**2+54*iypx**2+25)/88.0d0
          sqy(ig,2,4) = 5.0d0*sq5*z*(165*z**4-198*iypx**2*z**2-150*z**2+54*iypx**2+25)/88.0d0
          sqy(ig,3,4) = (-5.0d0)*ci*iypx*sq5*(825*z**4-198*iypx**2*z**2-450*z**2+18*iypx**2+25)/88.0d0
       end do
    case (374)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*ci*iypx*sq10/7.0d0
          sqy(ig,2,2) = (-2.0d0)*iypx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*ci*iypx*sq5*(14*z**2-7*iypx**2-2)/(77.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*iypx*sq5*(14*z**2-7*iypx**2-2)/(77.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*ci*iypx**2*sq10*z/11.0d0
          sqy(ig,1,4) = 5.0d0*ci*iypx*sq5*(165*z**4-132*iypx**2*z**2-90*z**2+12*iypx**2+5)/(44.0d0*sq2)
          sqy(ig,2,4) = (-5.0d0)*iypx*sq5*(165*z**4-132*iypx**2*z**2-90*z**2+12*iypx**2+5)/(44.0d0*sq2)
          sqy(ig,3,4) = 15.0d0*ci*iypx**2*sq5*z*(55*z**2-11*iypx**2-15)/(22.0d0*sq2)
       end do
    case (375)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*ci*iypx**2*z/(22.0d0*sq2)
          sqy(ig,2,3) = 45.0d0*iypx**2*z/(22.0d0*sq2)
          sqy(ig,3,3) = (-15.0d0)*ci*iypx**3/(22.0d0*sq2)
          sqy(ig,1,4) = (-75.0d0)*ci*iypx**2*z*(33*z**2-22*iypx**2-9)/(88.0d0*sq2)
          sqy(ig,2,4) = 75.0d0*iypx**2*z*(33*z**2-22*iypx**2-9)/(88.0d0*sq2)
          sqy(ig,3,4) = (-15.0d0)*ci*iypx**3*(165*z**2-22*iypx**2-15)/(88.0d0*sq2)
       end do
    case (376)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -5*ci*z/sq21
          sqy(ig,2,2) = -5*z/sq21
          sqy(ig,3,2) = 5*ci*iymx/sq21
          sqy(ig,1,3) = 15.0d0*ci*sq3*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,2,3) = 15.0d0*sq3*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,3,3) = (-45.0d0)*ci*iymx*sq3*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,1,4) = (-5.0d0)*ci*sq21*z*(33*z**4-30*z**2+5)/264.0d0
          sqy(ig,2,4) = (-5.0d0)*sq21*z*(33*z**4-30*z**2+5)/264.0d0
          sqy(ig,3,4) = 25.0d0*ci*iymx*sq21*(33*z**4-18*z**2+1)/264.0d0
       end do
    case (377)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5.0d0*ci*iymx/(7.0d0*sq3)
          sqy(ig,2,2) = 5.0d0*iymx/(7.0d0*sq3)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*ci*iymx*sq3*(7*z**2-1)/154.0d0
          sqy(ig,2,3) = (-45.0d0)*iymx*sq3*(7*z**2-1)/154.0d0
          sqy(ig,3,3) = 15.0d0*ci*sq3*z*(14*z**2+3*iymx**2-6)/22.0d0
          sqy(ig,1,4) = 25.0d0*ci*iymx*(33*z**4-18*z**2+1)/(88.0d0*sq3)
          sqy(ig,2,4) = 25.0d0*iymx*(33*z**4-18*z**2+1)/(88.0d0*sq3)
          sqy(ig,3,4) = (-5.0d0)*ci*sq3*z*(198*z**4+55*iymx**2*z**2-180*z**2-15*iymx**2+30)/44.0d0
       end do
    case (378)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 10.0d0*z/7.0d0
          sqy(ig,3,2) = (-5.0d0)*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 60.0d0*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = (-90.0d0)*ci*(iypx+iymx)*(7*z**2-1)/77.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,3,4) = 125.0d0*ci*(iypx+iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (379)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*(5*z**2-1)/4.0d0
          sqy(ig,2,1) = 3.0d0*(5*z**2-1)/4.0d0
          sqy(ig,3,1) = (-15.0d0)*ci*iypx*z/2.0d0
       end do
    case (380)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3*ci*(5*z**2-1)
       end do
    case (381)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 12.0d0*z/7.0d0
          sqy(ig,3,1) = (-6.0d0)*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,2) = (-5.0d0)*ci*z*(7*z**2-3)/4.0d0
          sqy(ig,2,2) = (-5.0d0)*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = (-15.0d0)*ci*(3*iypx-4*iymx)*(7*z**2-1)/28.0d0
       end do
    case (382)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*iypx/7.0d0
          sqy(ig,2,1) = 3.0d0*iypx/7.0d0
          sqy(ig,3,1) = (-18.0d0)*ci*z/7.0d0
          sqy(ig,1,2) = 15.0d0*ci*iypx*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = (-15.0d0)*iypx*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = (-5.0d0)*ci*z*(56*z**2-21*iypx**2-24)/14.0d0
       end do
    case (383)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-9.0d0)*ci*sq6*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 15.0d0*ci*sq3*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (384)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*ci*sq2*z/7.0d0
          sqy(ig,2,1) = 3.0d0*sq2*z/7.0d0
          sqy(ig,3,1) = (-3.0d0)*ci*(2*iypx-iymx)*sq2/7.0d0
          sqy(ig,1,2) = (-5.0d0)*ci*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = 25.0d0*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = (-15.0d0)*ci*(3*iypx+2*iymx)*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (385)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*iypx/(7.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*iypx/(7.0d0*sq2)
          sqy(ig,3,1) = 18.0d0*ci*sq2*z/7.0d0
          sqy(ig,1,2) = 15.0d0*ci*iypx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,2) = (-15.0d0)*iypx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,2) = 5.0d0*ci*z*(112*z**2+21*iypx**2-48)/(14.0d0*sq2)
       end do
    case (386)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*sq6*z/7.0d0
          sqy(ig,2,1) = (-3.0d0)*sq6*z/7.0d0
          sqy(ig,3,1) = 3.0d0*ci*iypx*sq6/7.0d0
          sqy(ig,1,2) = (-5.0d0)*ci*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,2,2) = 5.0d0*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,3,2) = (-15.0d0)*ci*iypx*sq3*(7*z**2-1)/(7.0d0*sq2)
       end do
    case (387)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-6.0d0)*ci*sq6/35.0d0
          sqy(ig,1,2) = -8*ci*iymx*z/sq6
          sqy(ig,2,2) = -8*iymx*z/sq6
          sqy(ig,3,2) = -ci*(15*z**2-20*iymx**2-3)/sq6/5.0d0
          sqy(ig,1,3) = 10*ci*iymx*z*(3*z**2-1)/sq6
          sqy(ig,2,3) = 10*iymx*z*(3*z**2-1)/sq6
          sqy(ig,3,3) = 5.0d0*ci*(315*z**4-252*iymx**2*z**2-210*z**2+28*iymx**2+15)/(28.0d0*sq6)
       end do
    case (388)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 18.0d0*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*(5*z**2-1)/sq2/2.0d0
          sqy(ig,2,2) = (5*z**2-1)/sq2/10.0d0
          sqy(ig,3,2) = -ci*(3*iypx-2*iymx)*z/sq2
          sqy(ig,1,3) = (-5.0d0)*ci*(21*z**4-14*z**2+1)/(4.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,3,3) = -5*ci*(3*iypx-4*iymx)*z*(3*z**2-1)/sq2
       end do
    case (389)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-18.0d0)*ci*sq2/35.0d0
          sqy(ig,1,2) = 3*ci*iypx*z/sq2
          sqy(ig,2,2) = -3*iypx*z/sq2
          sqy(ig,3,2) = -ci*(80*z**2-15*iypx**2-16)/sq2/10.0d0
          sqy(ig,1,3) = 15.0d0*ci*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*ci*(420*z**4-189*iypx**2*z**2-280*z**2+21*iypx**2+20)/(28.0d0*sq2)
       end do
    case (390)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq6/35.0d0
          sqy(ig,2,1) = 3.0d0*sq6/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*(5*z**2+15*iypx**2-1)/sq6/5.0d0
          sqy(ig,2,2) = -(5*z**2+15*iypx**2-1)/sq6/5.0d0
          sqy(ig,3,2) = 2*ci*iypx*z/sq6
          sqy(ig,1,3) = 5.0d0*ci*(84*z**4-189*iypx**2*z**2-56*z**2+21*iypx**2+4)/(28.0d0*sq6)
          sqy(ig,2,3) = (-5.0d0)*(84*z**4-189*iypx**2*z**2-56*z**2+21*iypx**2+4)/(28.0d0*sq6)
          sqy(ig,3,3) = 5.0d0*ci*iypx*z*(24*z**2-9*iypx**2-8)/(2.0d0*sq6)
       end do
    case (391)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*sq30/70.0d0
          sqy(ig,2,1) = 3.0d0*sq30/70.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq30*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = -sq30*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = ci*iymx*sq30*z
          sqy(ig,1,3) = 5.0d0*ci*sq30*(21*z**4-14*z**2+1)/112.0d0
          sqy(ig,2,3) = 5.0d0*sq30*(21*z**4-14*z**2+1)/112.0d0
          sqy(ig,3,3) = (-5.0d0)*ci*iymx*sq30*z*(3*z**2-1)/4.0d0
       end do
    case (392)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-12.0d0)*ci*sq6/35.0d0
          sqy(ig,1,2) = 2.0d0*ci*iymx*sq6*z/3.0d0
          sqy(ig,2,2) = 2.0d0*iymx*sq6*z/3.0d0
          sqy(ig,3,2) = -ci*sq2*(15*z**2+5*iymx**2-3)/sq3/5.0d0
          sqy(ig,1,3) = -5*ci*iymx*z*(3*z**2-1)/sq6
          sqy(ig,2,3) = -5*iymx*z*(3*z**2-1)/sq6
          sqy(ig,3,3) = 5.0d0*ci*(315*z**4+63*iymx**2*z**2-210*z**2-7*iymx**2+15)/(14.0d0*sq6)
       end do
    case (393)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq3/7.0d0
          sqy(ig,2,1) = 3.0d0*sq3/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*(5*z**2-1)/sq3/4.0d0
          sqy(ig,2,2) = 13.0d0*(5*z**2-1)/(20.0d0*sq3)
          sqy(ig,3,2) = -ci*(9*iypx+4*iymx)*z/sq3/2.0d0
          sqy(ig,1,3) = (-5.0d0)*ci*(21*z**4-14*z**2+1)/(56.0d0*sq3)
          sqy(ig,2,3) = 85.0d0*(21*z**4-14*z**2+1)/(56.0d0*sq3)
          sqy(ig,3,3) = (-5.0d0)*ci*(9*iypx+8*iymx)*z*(3*z**2-1)/(2.0d0*sq3)
       end do
    case (394)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 18.0d0*ci*sq3/35.0d0
          sqy(ig,1,2) = ci*iypx*sq3*z
          sqy(ig,2,2) = -iypx*sq3*z
          sqy(ig,3,2) = ci*sq3*(40*z**2+5*iypx**2-8)/10.0d0
          sqy(ig,1,3) = 5.0d0*ci*iypx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = (-5.0d0)*iypx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = 5.0d0*ci*sq3*(210*z**4+63*iypx**2*z**2-140*z**2-7*iypx**2+10)/28.0d0
       end do
    case (395)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*ci*sq6/35.0d0
          sqy(ig,2,1) = (-6.0d0)*sq6/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*(20*z**2-15*iypx**2-4)/sq6/10.0d0
          sqy(ig,2,2) = (20*z**2-15*iypx**2-4)/sq6/10.0d0
          sqy(ig,3,2) = -4*ci*iypx*z/sq6
          sqy(ig,1,3) = (-5.0d0)*ci*(336*z**4+189*iypx**2*z**2-224*z**2-21*iypx**2+16)/(56.0d0*sq6)
          sqy(ig,2,3) = 5.0d0*(336*z**4+189*iypx**2*z**2-224*z**2-21*iypx**2+16)/(56.0d0*sq6)
          sqy(ig,3,3) = (-5.0d0)*ci*iypx*z*(96*z**2+9*iypx**2-32)/(4.0d0*sq6)
       end do
    case (396)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -4*ci*iypx*sq5*z/sq6
          sqy(ig,2,2) = 4*iypx*sq5*z/sq6
          sqy(ig,3,2) = -2*ci*iypx**2*sq5/sq6
          sqy(ig,1,3) = 5*ci*iypx*sq5*z*(3*z**2-1)/sq6
          sqy(ig,2,3) = -5*iypx*sq5*z*(3*z**2-1)/sq6
          sqy(ig,3,3) = 5.0d0*ci*iypx**2*sq5*(3*z-1)*(3*z+1)/(2.0d0*sq6)
       end do
    case (397)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq30*z/14.0d0
          sqy(ig,2,2) = -sq30*z/14.0d0
          sqy(ig,3,2) = ci*iymx*sq30/14.0d0
          sqy(ig,1,3) = (-3.0d0)*ci*sq30*z*(14*z**2-63*iymx**2-6)/154.0d0
          sqy(ig,2,3) = (-3.0d0)*sq30*z*(14*z**2-63*iymx**2-6)/154.0d0
          sqy(ig,3,3) = 9.0d0*ci*iymx*sq30*(14*z**2-7*iymx**2-2)/154.0d0
          sqy(ig,1,4) = 5.0d0*ci*sq30*z*(33*z**4-132*iymx**2*z**2-30*z**2+36*iymx**2+5)/176.0d0
          sqy(ig,2,4) = 5.0d0*sq30*z*(33*z**4-132*iymx**2*z**2-30*z**2+36*iymx**2+5)/176.0d0
          sqy(ig,3,4) = (-5.0d0)*ci*iymx*sq30*(165*z**4-132*iymx**2*z**2-90*z**2+12*iymx**2+5)/176.0d0
       end do
    case (398)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-10.0d0)*ci*iymx*sq6/21.0d0
          sqy(ig,2,2) = (-10.0d0)*iymx*sq6/21.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*sq6*z/7.0d0
          sqy(ig,1,3) = (-15.0d0)*ci*iymx*sq3*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*iymx*sq3*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = (-15.0d0)*ci*sq3*z*(7*z**2-7*iymx**2-3)/(77.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*ci*iymx*(33*z**4-18*z**2+1)/(11.0d0*sq6)
          sqy(ig,2,4) = 25.0d0*iymx*(33*z**4-18*z**2+1)/(11.0d0*sq6)
          sqy(ig,3,4) = 25.0d0*ci*sq3*z*(99*z**4-88*iymx**2*z**2-90*z**2+24*iymx**2+15)/(44.0d0*sq2)
       end do
    case (399)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*z/sq3
          sqy(ig,2,2) = -z/sq3/7.0d0
          sqy(ig,3,2) = -ci*(3*iypx-4*iymx)/sq3/7.0d0
          sqy(ig,1,3) = (-15.0d0)*ci*sq3*z*(7*z**2-3)/44.0d0
          sqy(ig,2,3) = (-15.0d0)*sq3*z*(7*z**2-3)/308.0d0
          sqy(ig,3,3) = (-45.0d0)*ci*(3*iypx-4*iymx)*sq3*(7*z**2-1)/308.0d0
          sqy(ig,1,4) = (-175.0d0)*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,2,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,3,4) = (-125.0d0)*ci*(3*iypx-4*iymx)*(33*z**4-18*z**2+1)/(88.0d0*sq3)
       end do
    case (400)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*ci*iypx*sq3/7.0d0
          sqy(ig,2,2) = (-4.0d0)*iypx*sq3/7.0d0
          sqy(ig,3,2) = (-8.0d0)*ci*sq3*z/7.0d0
          sqy(ig,1,3) = 30.0d0*ci*iypx*sq3*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = (-30.0d0)*iypx*sq3*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = (-30.0d0)*ci*sq3*z*(21*z**2-7*iypx**2-9)/77.0d0
          sqy(ig,1,4) = 25.0d0*ci*iypx*sq3*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,2,4) = (-25.0d0)*iypx*sq3*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,3,4) = (-25.0d0)*ci*sq3*z*(66*z**4-33*iypx**2*z**2-60*z**2+9*iypx**2+10)/22.0d0
       end do
    case (401)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*ci*sq2*z/(7.0d0*sq3)
          sqy(ig,2,2) = (-2.0d0)*sq2*z/(7.0d0*sq3)
          sqy(ig,3,2) = 2.0d0*ci*iypx*sq2/(7.0d0*sq3)
          sqy(ig,1,3) = 15.0d0*ci*sq3*z*(14*z**2-21*iypx**2-6)/(154.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*sq3*z*(14*z**2-21*iypx**2-6)/(154.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*ci*iypx*sq3*(42*z**2-7*iypx**2-6)/(154.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*ci*z*(132*z**4-297*iypx**2*z**2-120*z**2+81*iypx**2+20)/(88.0d0*sq6)
          sqy(ig,2,4) = (-25.0d0)*z*(132*z**4-297*iypx**2*z**2-120*z**2+81*iypx**2+20)/(88.0d0*sq6)
          sqy(ig,3,4) = 25.0d0*ci*iypx*(660*z**4-297*iypx**2*z**2-360*z**2+27*iypx**2+20)/(88.0d0*sq6)
       end do
    case (402)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 20.0d0*ci*iypx/(7.0d0*sq30)
          sqy(ig,2,2) = (-20.0d0)*iypx/(7.0d0*sq30)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*ci*iypx*sq15*(7*z**2-21*iypx**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = (-3.0d0)*iypx*sq15*(7*z**2-21*iypx**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = 45.0d0*ci*iypx**2*z/(11.0d0*sq30)
          sqy(ig,1,4) = (-5.0d0)*ci*iypx*sq15*(66*z**4-99*iypx**2*z**2-36*z**2+9*iypx**2+2)/(66.0d0*sq2)
          sqy(ig,2,4) = 5.0d0*iypx*sq15*(66*z**4-99*iypx**2*z**2-36*z**2+9*iypx**2+2)/(66.0d0*sq2)
          sqy(ig,3,4) = (-5.0d0)*ci*iypx**2*sq15*z*(88*z**2-33*iypx**2-24)/(44.0d0*sq2)
       end do
    case (403)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iymx*sq5/sq7
          sqy(ig,2,2) = -iymx*sq5/sq7
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 27.0d0*ci*iymx*sq5*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,2,3) = 27.0d0*iymx*sq5*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,3,3) = (-27.0d0)*ci*iymx**2*sq35*z/22.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*iymx*sq35*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,2,4) = (-5.0d0)*iymx*sq35*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,3,4) = 15.0d0*ci*iymx**2*sq35*z*(11*z**2-3)/44.0d0
       end do
    case (404)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*ci*sq5*z/7.0d0
          sqy(ig,2,2) = (-3.0d0)*sq5*z/7.0d0
          sqy(ig,3,2) = 3.0d0*ci*iymx*sq5/7.0d0
          sqy(ig,1,3) = (-9.0d0)*ci*sq5*z*(28*z**2+21*iymx**2-12)/154.0d0
          sqy(ig,2,3) = (-9.0d0)*sq5*z*(28*z**2+21*iymx**2-12)/154.0d0
          sqy(ig,3,3) = 9.0d0*ci*iymx*sq5*(84*z**2+7*iymx**2-12)/154.0d0
          sqy(ig,1,4) = 15.0d0*ci*sq5*z*(33*z**4+22*iymx**2*z**2-30*z**2-6*iymx**2+5)/88.0d0
          sqy(ig,2,4) = 15.0d0*sq5*z*(33*z**4+22*iymx**2*z**2-30*z**2-6*iymx**2+5)/88.0d0
          sqy(ig,3,4) = (-15.0d0)*ci*iymx*sq5*(165*z**4+22*iymx**2*z**2-90*z**2-2*iymx**2+5)/88.0d0
       end do
    case (405)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*ci*iymx*sq15/21.0d0
          sqy(ig,2,2) = 4.0d0*iymx*sq15/21.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*sq15*z/7.0d0
          sqy(ig,1,3) = 3.0d0*ci*iymx*sq15*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = 3.0d0*iymx*sq15*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*sq15*z*(35*z**2+14*iymx**2-15)/154.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*iymx*sq15*(33*z**4-18*z**2+1)/33.0d0
          sqy(ig,2,4) = (-5.0d0)*iymx*sq15*(33*z**4-18*z**2+1)/33.0d0
          sqy(ig,3,4) = 5.0d0*ci*sq15*z*(495*z**4+176*iymx**2*z**2-450*z**2-48*iymx**2+75)/88.0d0
       end do
    case (406)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 4.0d0*z/7.0d0
          sqy(ig,3,2) = (-2.0d0)*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 45.0d0*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = (-135.0d0)*ci*(iypx+iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 25.0d0*z*(33*z**4-30*z**2+5)/22.0d0
          sqy(ig,3,4) = (-125.0d0)*ci*(iypx+iymx)*(33*z**4-18*z**2+1)/44.0d0
       end do
    case (407)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -3*ci*(5*z**2-1)
       end do
    case (408)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*(5*z**2-1)/4.0d0
          sqy(ig,2,1) = (-3.0d0)*(5*z**2-1)/4.0d0
          sqy(ig,3,1) = 15.0d0*ci*iymx*z/2.0d0
       end do
    case (409)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*iymx/7.0d0
          sqy(ig,2,1) = 3.0d0*iymx/7.0d0
          sqy(ig,3,1) = (-18.0d0)*ci*z/7.0d0
          sqy(ig,1,2) = (-15.0d0)*ci*iymx*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = (-15.0d0)*iymx*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = (-5.0d0)*ci*z*(56*z**2-21*iymx**2-24)/14.0d0
       end do
    case (410)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 12.0d0*z/7.0d0
          sqy(ig,3,1) = (-6.0d0)*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,2) = 5.0d0*ci*z*(7*z**2-3)/4.0d0
          sqy(ig,2,2) = (-5.0d0)*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = 15.0d0*ci*(4*iypx-3*iymx)*(7*z**2-1)/28.0d0
       end do
    case (411)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*sq6*z/7.0d0
          sqy(ig,2,1) = 3.0d0*sq6*z/7.0d0
          sqy(ig,3,1) = (-3.0d0)*ci*iymx*sq6/7.0d0
          sqy(ig,1,2) = (-5.0d0)*ci*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,3,2) = 15.0d0*ci*iymx*sq3*(7*z**2-1)/(7.0d0*sq2)
       end do
    case (412)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*iymx/(7.0d0*sq2)
          sqy(ig,2,1) = (-3.0d0)*iymx/(7.0d0*sq2)
          sqy(ig,3,1) = (-18.0d0)*ci*sq2*z/7.0d0
          sqy(ig,1,2) = 15.0d0*ci*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,2) = 15.0d0*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,2) = (-5.0d0)*ci*z*(112*z**2+21*iymx**2-48)/(14.0d0*sq2)
       end do
    case (413)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*ci*sq2*z/7.0d0
          sqy(ig,2,1) = (-3.0d0)*sq2*z/7.0d0
          sqy(ig,3,1) = (-3.0d0)*ci*(iypx-2*iymx)*sq2/7.0d0
          sqy(ig,1,2) = (-5.0d0)*ci*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = (-25.0d0)*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = 15.0d0*ci*(2*iypx+3*iymx)*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (414)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 9.0d0*ci*sq6*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-15.0d0)*ci*sq3*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (415)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*sq6/35.0d0
          sqy(ig,2,1) = 3.0d0*sq6/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*(5*z**2+15*iymx**2-1)/sq6/5.0d0
          sqy(ig,2,2) = -(5*z**2+15*iymx**2-1)/sq6/5.0d0
          sqy(ig,3,2) = ci*iymx*sq2*z/sq3
          sqy(ig,1,3) = (-5.0d0)*ci*(84*z**4-189*iymx**2*z**2-56*z**2+21*iymx**2+4)/(28.0d0*sq6)
          sqy(ig,2,3) = (-5.0d0)*(84*z**4-189*iymx**2*z**2-56*z**2+21*iymx**2+4)/(28.0d0*sq6)
          sqy(ig,3,3) = 5.0d0*ci*iymx*z*(24*z**2-9*iymx**2-8)/(2.0d0*sq6)
       end do
    case (416)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-18.0d0)*ci*sq2/35.0d0
          sqy(ig,1,2) = -3*ci*iymx*z/sq2
          sqy(ig,2,2) = -3*iymx*z/sq2
          sqy(ig,3,2) = -ci*(80*z**2-15*iymx**2-16)/sq2/10.0d0
          sqy(ig,1,3) = (-15.0d0)*ci*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*ci*(420*z**4-189*iymx**2*z**2-280*z**2+21*iymx**2+20)/(28.0d0*sq2)
       end do
    case (417)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 18.0d0*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*(5*z**2-1)/sq2/2.0d0
          sqy(ig,2,2) = (5*z**2-1)/sq2/10.0d0
          sqy(ig,3,2) = ci*(2*iypx-3*iymx)*z/sq2
          sqy(ig,1,3) = 5.0d0*ci*(21*z**4-14*z**2+1)/(4.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,3,3) = 5*ci*(4*iypx-3*iymx)*z*(3*z**2-1)/sq2
       end do
    case (418)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-6.0d0)*ci*sq6/35.0d0
          sqy(ig,1,2) = 8*ci*iypx*z/sq6
          sqy(ig,2,2) = -8*iypx*z/sq6
          sqy(ig,3,2) = -ci*(15*z**2-20*iypx**2-3)/sq6/5.0d0
          sqy(ig,1,3) = -10*ci*iypx*z*(3*z**2-1)/sq6
          sqy(ig,2,3) = 10*iypx*z*(3*z**2-1)/sq6
          sqy(ig,3,3) = 5.0d0*ci*(315*z**4-252*iypx**2*z**2-210*z**2+28*iypx**2+15)/(28.0d0*sq6)
       end do
    case (419)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -20*ci*iymx*z/sq30
          sqy(ig,2,2) = -20*iymx*z/sq30
          sqy(ig,3,2) = 10*ci*iymx**2/sq30
          sqy(ig,1,3) = 5.0d0*ci*iymx*sq30*z*(3*z**2-1)/6.0d0
          sqy(ig,2,3) = 5.0d0*iymx*sq30*z*(3*z**2-1)/6.0d0
          sqy(ig,3,3) = (-5.0d0)*ci*iymx**2*sq30*(3*z-1)*(3*z+1)/12.0d0
       end do
    case (420)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*ci*sq6/35.0d0
          sqy(ig,2,1) = 6.0d0*sq6/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*(20*z**2-15*iymx**2-4)/sq6/10.0d0
          sqy(ig,2,2) = -(20*z**2-15*iymx**2-4)/sq6/10.0d0
          sqy(ig,3,2) = 4*ci*iymx*z/sq6
          sqy(ig,1,3) = (-5.0d0)*ci*(336*z**4+189*iymx**2*z**2-224*z**2-21*iymx**2+16)/(56.0d0*sq6)
          sqy(ig,2,3) = (-5.0d0)*(336*z**4+189*iymx**2*z**2-224*z**2-21*iymx**2+16)/(56.0d0*sq6)
          sqy(ig,3,3) = 5.0d0*ci*iymx*z*(96*z**2+9*iymx**2-32)/(4.0d0*sq6)
       end do
    case (421)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-18.0d0)*ci*sq3/35.0d0
          sqy(ig,1,2) = ci*iymx*sq3*z
          sqy(ig,2,2) = iymx*sq3*z
          sqy(ig,3,2) = -ci*sq3*(40*z**2+5*iymx**2-8)/10.0d0
          sqy(ig,1,3) = 5.0d0*ci*iymx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = 5.0d0*iymx*sq3*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = (-5.0d0)*ci*sq3*(210*z**4+63*iymx**2*z**2-140*z**2-7*iymx**2+10)/28.0d0
       end do
    case (422)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq3/7.0d0
          sqy(ig,2,1) = (-3.0d0)*sq3/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*(5*z**2-1)/sq3/4.0d0
          sqy(ig,2,2) = (-13.0d0)*(5*z**2-1)/(20.0d0*sq3)
          sqy(ig,3,2) = ci*(4*iypx+9*iymx)*z/sq3/2.0d0
          sqy(ig,1,3) = (-5.0d0)*ci*(21*z**4-14*z**2+1)/(56.0d0*sq3)
          sqy(ig,2,3) = (-85.0d0)*(21*z**4-14*z**2+1)/(56.0d0*sq3)
          sqy(ig,3,3) = 5.0d0*ci*(8*iypx+9*iymx)*z*(3*z**2-1)/(2.0d0*sq3)
       end do
    case (423)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 12.0d0*ci*sq6/35.0d0
          sqy(ig,1,2) = 4*ci*iypx*z/sq6
          sqy(ig,2,2) = -4*iypx*z/sq6
          sqy(ig,3,2) = 2.0d0*ci*(15*z**2+5*iypx**2-3)/(5.0d0*sq6)
          sqy(ig,1,3) = -5*ci*iypx*z*(3*z**2-1)/sq6
          sqy(ig,2,3) = 5*iypx*z*(3*z**2-1)/sq6
          sqy(ig,3,3) = (-5.0d0)*ci*(315*z**4+63*iypx**2*z**2-210*z**2-7*iypx**2+15)/(14.0d0*sq6)
       end do
    case (424)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*ci/(7.0d0*sq30)
          sqy(ig,2,1) = (-9.0d0)/(7.0d0*sq30)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq6*(5*z**2-1)/sq5/2.0d0
          sqy(ig,2,2) = sq6*(5*z**2-1)/sq5/2.0d0
          sqy(ig,3,2) = -ci*iypx*sq30*z
          sqy(ig,1,3) = 15.0d0*ci*sq5*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,2,3) = (-15.0d0)*sq5*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,3,3) = 15.0d0*ci*iypx*sq5*z*(3*z**2-1)/(2.0d0*sq6)
       end do
    case (425)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*ci*iymx*sq30/21.0d0
          sqy(ig,2,2) = (-2.0d0)*iymx*sq30/21.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*ci*iymx*sq30*(7*z**2-21*iymx**2-1)/154.0d0
          sqy(ig,2,3) = (-3.0d0)*iymx*sq30*(7*z**2-21*iymx**2-1)/154.0d0
          sqy(ig,3,3) = 3.0d0*ci*iymx**2*sq30*z/22.0d0
          sqy(ig,1,4) = 5.0d0*ci*iymx*sq30*(66*z**4-99*iymx**2*z**2-36*z**2+9*iymx**2+2)/132.0d0
          sqy(ig,2,4) = 5.0d0*iymx*sq30*(66*z**4-99*iymx**2*z**2-36*z**2+9*iymx**2+2)/132.0d0
          sqy(ig,3,4) = (-5.0d0)*ci*iymx**2*sq30*z*(88*z**2-33*iymx**2-24)/88.0d0
       end do
    case (426)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*ci*sq6*z/21.0d0
          sqy(ig,2,2) = (-2.0d0)*sq6*z/21.0d0
          sqy(ig,3,2) = 2.0d0*ci*iymx*sq6/21.0d0
          sqy(ig,1,3) = (-15.0d0)*ci*sq3*z*(14*z**2-21*iymx**2-6)/(154.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*sq3*z*(14*z**2-21*iymx**2-6)/(154.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*ci*iymx*sq3*(42*z**2-7*iymx**2-6)/(154.0d0*sq2)
          sqy(ig,1,4) = (-25.0d0)*ci*z*(132*z**4-297*iymx**2*z**2-120*z**2+81*iymx**2+20)/(88.0d0*sq6)
          sqy(ig,2,4) = (-25.0d0)*z*(132*z**4-297*iymx**2*z**2-120*z**2+81*iymx**2+20)/(88.0d0*sq6)
          sqy(ig,3,4) = 25.0d0*ci*iymx*(660*z**4-297*iymx**2*z**2-360*z**2+27*iymx**2+20)/(88.0d0*sq6)
       end do
    case (427)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-4.0d0)*ci*iymx*sq3/7.0d0
          sqy(ig,2,2) = (-4.0d0)*iymx*sq3/7.0d0
          sqy(ig,3,2) = (-8.0d0)*ci*sq3*z/7.0d0
          sqy(ig,1,3) = (-30.0d0)*ci*iymx*sq3*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = (-30.0d0)*iymx*sq3*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = (-30.0d0)*ci*sq3*z*(21*z**2-7*iymx**2-9)/77.0d0
          sqy(ig,1,4) = (-25.0d0)*ci*iymx*sq3*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,2,4) = (-25.0d0)*iymx*sq3*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,3,4) = (-25.0d0)*ci*sq3*z*(66*z**4-33*iymx**2*z**2-60*z**2+9*iymx**2+10)/22.0d0
       end do
    case (428)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*z/sq3
          sqy(ig,2,2) = -z/sq3/7.0d0
          sqy(ig,3,2) = ci*(4*iypx-3*iymx)/sq3/7.0d0
          sqy(ig,1,3) = 15.0d0*ci*sq3*z*(7*z**2-3)/44.0d0
          sqy(ig,2,3) = (-15.0d0)*sq3*z*(7*z**2-3)/308.0d0
          sqy(ig,3,3) = 45.0d0*ci*(4*iypx-3*iymx)*sq3*(7*z**2-1)/308.0d0
          sqy(ig,1,4) = 175.0d0*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,2,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,3,4) = 125.0d0*ci*(4*iypx-3*iymx)*(33*z**4-18*z**2+1)/(88.0d0*sq3)
       end do
    case (429)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 20.0d0*ci*iypx/(7.0d0*sq6)
          sqy(ig,2,2) = (-20.0d0)*iypx/(7.0d0*sq6)
          sqy(ig,3,2) = (-3.0d0)*ci*sq6*z/7.0d0
          sqy(ig,1,3) = 15.0d0*ci*iypx*sq3*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*iypx*sq3*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = (-15.0d0)*ci*sq3*z*(7*z**2-7*iypx**2-3)/(77.0d0*sq2)
          sqy(ig,1,4) = (-25.0d0)*ci*iypx*(33*z**4-18*z**2+1)/(11.0d0*sq6)
          sqy(ig,2,4) = 25.0d0*iypx*(33*z**4-18*z**2+1)/(11.0d0*sq6)
          sqy(ig,3,4) = 25.0d0*ci*sq3*z*(99*z**4-88*iypx**2*z**2-90*z**2+24*iypx**2+15)/(44.0d0*sq2)
       end do
    case (430)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 15.0d0*ci*z/(7.0d0*sq30)
          sqy(ig,2,2) = (-15.0d0)*z/(7.0d0*sq30)
          sqy(ig,3,2) = 15.0d0*ci*iypx/(7.0d0*sq30)
          sqy(ig,1,3) = 3.0d0*ci*sq30*z*(14*z**2-63*iypx**2-6)/154.0d0
          sqy(ig,2,3) = (-3.0d0)*sq30*z*(14*z**2-63*iypx**2-6)/154.0d0
          sqy(ig,3,3) = 9.0d0*ci*iypx*sq30*(14*z**2-7*iypx**2-2)/154.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*sq30*z*(33*z**4-132*iypx**2*z**2-30*z**2+36*iypx**2+5)/176.0d0
          sqy(ig,2,4) = 5.0d0*sq30*z*(33*z**4-132*iypx**2*z**2-30*z**2+36*iypx**2+5)/176.0d0
          sqy(ig,3,4) = (-5.0d0)*ci*iypx*sq30*(165*z**4-132*iypx**2*z**2-90*z**2+12*iypx**2+5)/176.0d0
       end do
    case (431)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 27.0d0*ci*iymx**2*sq35*z/22.0d0
          sqy(ig,2,3) = 27.0d0*iymx**2*sq35*z/22.0d0
          sqy(ig,3,3) = (-9.0d0)*ci*iymx**3*sq35/22.0d0
          sqy(ig,1,4) = (-15.0d0)*ci*iymx**2*sq35*z*(11*z**2-3)/44.0d0
          sqy(ig,2,4) = (-15.0d0)*iymx**2*sq35*z*(11*z**2-3)/44.0d0
          sqy(ig,3,4) = 15.0d0*ci*iymx**3*sq35*(11*z**2-1)/44.0d0
       end do
    case (432)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-4.0d0)*ci*iymx*sq5/7.0d0
          sqy(ig,2,2) = (-4.0d0)*iymx*sq5/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*ci*iymx*sq5*(14*z**2+7*iymx**2-2)/154.0d0
          sqy(ig,2,3) = (-9.0d0)*iymx*sq5*(14*z**2+7*iymx**2-2)/154.0d0
          sqy(ig,3,3) = 9.0d0*ci*iymx**2*sq5*z/11.0d0
          sqy(ig,1,4) = 5.0d0*ci*iymx*sq5*(132*z**4+33*iymx**2*z**2-72*z**2-3*iymx**2+4)/44.0d0
          sqy(ig,2,4) = 5.0d0*iymx*sq5*(132*z**4+33*iymx**2*z**2-72*z**2-3*iymx**2+4)/44.0d0
          sqy(ig,3,4) = (-15.0d0)*ci*iymx**2*sq5*z*(176*z**2+11*iymx**2-48)/88.0d0
       end do
    case (433)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*ci*sq15*z/21.0d0
          sqy(ig,2,2) = (-2.0d0)*sq15*z/21.0d0
          sqy(ig,3,2) = 2.0d0*ci*iymx*sq15/21.0d0
          sqy(ig,1,3) = (-3.0d0)*ci*sq15*z*(35*z**2+21*iymx**2-15)/154.0d0
          sqy(ig,2,3) = (-3.0d0)*sq15*z*(35*z**2+21*iymx**2-15)/154.0d0
          sqy(ig,3,3) = 3.0d0*ci*iymx*sq15*(105*z**2+7*iymx**2-15)/154.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*sq15*z*(330*z**4+297*iymx**2*z**2-300*z**2-81*iymx**2+50)/264.0d0
          sqy(ig,2,4) = (-5.0d0)*sq15*z*(330*z**4+297*iymx**2*z**2-300*z**2-81*iymx**2+50)/264.0d0
          sqy(ig,3,4) = 5.0d0*ci*iymx*sq15*(1650*z**4+297*iymx**2*z**2-900*z**2-27*iymx**2+50)/264.0d0
       end do
    case (434)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 6.0d0*ci*iymx/7.0d0
          sqy(ig,2,2) = 6.0d0*iymx/7.0d0
          sqy(ig,3,2) = (-16.0d0)*ci*z/7.0d0
          sqy(ig,1,3) = 45.0d0*ci*iymx*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = 45.0d0*iymx*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = (-45.0d0)*ci*z*(28*z**2+7*iymx**2-12)/77.0d0
          sqy(ig,1,4) = 75.0d0*ci*iymx*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,2,4) = 75.0d0*iymx*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,3,4) = (-25.0d0)*ci*z*(264*z**4+99*iymx**2*z**2-240*z**2-27*iymx**2+40)/44.0d0
       end do
    case (435)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = (-4.0d0)*z/7.0d0
          sqy(ig,3,2) = 2.0d0*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = (-45.0d0)*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = 135.0d0*ci*(iypx+iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/22.0d0
          sqy(ig,3,4) = 125.0d0*ci*(iypx+iymx)*(33*z**4-18*z**2+1)/44.0d0
       end do
    case (436)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*sq15*(5*z**2-1)/4.0d0
          sqy(ig,2,1) = sq15*(5*z**2-1)/4.0d0
          sqy(ig,3,1) = (-5.0d0)*ci*iymx*sq15*z/2.0d0
       end do
    case (437)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*iymx*sq15*z
          sqy(ig,2,1) = -iymx*sq15*z
          sqy(ig,3,1) = ci*iymx**2*sq15/2.0d0
       end do
    case (438)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*ci*sq15*z/7.0d0
          sqy(ig,2,1) = 2.0d0*sq15*z/7.0d0
          sqy(ig,3,1) = (-2.0d0)*ci*iymx*sq15/7.0d0
          sqy(ig,1,2) = ci*sq15*z*(35*z**2-42*iymx**2-15)/28.0d0
          sqy(ig,2,2) = sq15*z*(35*z**2-42*iymx**2-15)/28.0d0
          sqy(ig,3,2) = -ci*iymx*sq15*(105*z**2-14*iymx**2-15)/28.0d0
       end do
    case (439)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = ci*iymx*sq15/7.0d0
          sqy(ig,2,1) = iymx*sq15/7.0d0
          sqy(ig,3,1) = (-6.0d0)*ci*sq15*z/7.0d0
          sqy(ig,1,2) = ci*iymx*sq15*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = iymx*sq15*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = ci*sq15*z*(35*z**2-7*iymx**2-15)/7.0d0
       end do
    case (440)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*iymx*sq5/(7.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*iymx*sq5/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-15.0d0)*ci*iymx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,2) = (-15.0d0)*iymx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,2) = 15.0d0*ci*iymx**2*sq5*z/(2.0d0*sq2)
       end do
    case (441)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*ci*sq30*z/7.0d0
          sqy(ig,2,1) = 2.0d0*sq30*z/7.0d0
          sqy(ig,3,1) = (-2.0d0)*ci*iymx*sq30/7.0d0
          sqy(ig,1,2) = ci*sq15*z*(35*z**2+21*iymx**2-15)/sq2/14.0d0
          sqy(ig,2,2) = sq15*z*(35*z**2+21*iymx**2-15)/sq2/14.0d0
          sqy(ig,3,2) = -ci*iymx*sq15*(105*z**2+7*iymx**2-15)/sq2/14.0d0
       end do
    case (442)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -ci*iymx*sq30/7.0d0
          sqy(ig,2,1) = -iymx*sq30/7.0d0
          sqy(ig,3,1) = (-3.0d0)*ci*sq30*z/7.0d0
          sqy(ig,1,2) = -ci*iymx*sq30*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = -iymx*sq30*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = ci*sq15*z*(35*z**2+14*iymx**2-15)/sq2/7.0d0
       end do
    case (443)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq10*z/7.0d0
          sqy(ig,2,1) = (-3.0d0)*sq10*z/7.0d0
          sqy(ig,3,1) = 3.0d0*ci*iymx*sq10/7.0d0
          sqy(ig,1,2) = 15.0d0*ci*z*(7*z**2-3)/(14.0d0*sq10)
          sqy(ig,2,2) = 15.0d0*z*(7*z**2-3)/(14.0d0*sq10)
          sqy(ig,3,2) = (-45.0d0)*ci*iymx*(7*z**2-1)/(14.0d0*sq10)
       end do
    case (444)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iymx*sq5*z/sq2
          sqy(ig,2,2) = -iymx*sq5*z/sq2
          sqy(ig,3,2) = ci*iymx**2*sq5/sq2/2.0d0
          sqy(ig,1,3) = -ci*iymx*sq5*z*(15*z**2-12*iymx**2-5)/sq2/2.0d0
          sqy(ig,2,3) = -iymx*sq5*z*(15*z**2-12*iymx**2-5)/sq2/2.0d0
          sqy(ig,3,3) = ci*iymx**2*sq5*(45*z**2-6*iymx**2-5)/sq2/4.0d0
       end do
    case (445)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*sq6/(7.0d0*sq5)
          sqy(ig,2,1) = 3.0d0*sq6/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq3*(5*z**2-5*iymx**2-1)/sq10/2.0d0
          sqy(ig,2,2) = sq3*(5*z**2-5*iymx**2-1)/sq10/2.0d0
          sqy(ig,3,2) = -ci*iymx*sq30*z/2.0d0
          sqy(ig,1,3) = ci*sq30*(105*z**4-126*iymx**2*z**2-70*z**2+14*iymx**2+5)/56.0d0
          sqy(ig,2,3) = sq30*(105*z**4-126*iymx**2*z**2-70*z**2+14*iymx**2+5)/56.0d0
          sqy(ig,3,3) = -ci*iymx*sq30*z*(15*z**2-3*iymx**2-5)/2.0d0
       end do
    case (446)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-6.0d0)*ci*sq6/(7.0d0*sq5)
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -3*ci*(5*z**2-1)/sq30
          sqy(ig,1,3) = ci*iymx*sq30*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = iymx*sq30*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = ci*sq30*(525*z**4-126*iymx**2*z**2-350*z**2+14*iymx**2+25)/56.0d0
       end do
    case (447)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 6.0d0*sq2/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5.0d0*ci*(5*z**2-1)/(2.0d0*sq10)
          sqy(ig,2,2) = (-3.0d0)*(5*z**2-1)/(2.0d0*sq10)
          sqy(ig,3,2) = ci*(4*iypx-iymx)*sq10*z/2.0d0
          sqy(ig,1,3) = -ci*sq5*(21*z**4-14*z**2+1)/sq2/4.0d0
          sqy(ig,2,3) = 3.0d0*sq5*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,3,3) = -ci*(5*iypx-2*iymx)*sq5*z*(3*z**2-1)/sq2
       end do
    case (448)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*ci*iymx**2/(2.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*iymx**2/(2.0d0*sq2)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 25.0d0*ci*iymx**2*(3*z-1)*(3*z+1)/(8.0d0*sq2)
          sqy(ig,2,3) = 25.0d0*iymx**2*(3*z-1)*(3*z+1)/(8.0d0*sq2)
          sqy(ig,3,3) = (-75.0d0)*ci*iymx**3*z/(4.0d0*sq2)
       end do
    case (449)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iymx*sq10*z
          sqy(ig,2,2) = -iymx*sq10*z
          sqy(ig,3,2) = ci*iymx**2*sq5/sq2
          sqy(ig,1,3) = -ci*iymx*sq5*z*(15*z**2+3*iymx**2-5)/sq2
          sqy(ig,2,3) = -iymx*sq5*z*(15*z**2+3*iymx**2-5)/sq2
          sqy(ig,3,3) = ci*iymx**2*sq5*(90*z**2+3*iymx**2-10)/sq2/4.0d0
       end do
    case (450)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*ci/(7.0d0*sq5)
          sqy(ig,2,1) = 9.0d0/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*(15*z**2+10*iymx**2-3)/sq5/4.0d0
          sqy(ig,2,2) = (15*z**2+10*iymx**2-3)/sq5/4.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*iymx*sq5*z/2.0d0
          sqy(ig,1,3) = ci*sq5*(315*z**4+252*iymx**2*z**2-210*z**2-28*iymx**2+15)/56.0d0
          sqy(ig,2,3) = sq5*(315*z**4+252*iymx**2*z**2-210*z**2-28*iymx**2+15)/56.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*iymx*sq5*z*(15*z**2+2*iymx**2-5)/2.0d0
       end do
    case (451)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-12.0d0)*ci/(7.0d0*sq5)
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -ci*(5*z**2-1)/sq5
          sqy(ig,1,3) = (-3.0d0)*ci*iymx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,2,3) = (-3.0d0)*iymx*sq5*z*(3*z**2-1)/2.0d0
          sqy(ig,3,3) = ci*sq5*(525*z**4+189*iymx**2*z**2-350*z**2-21*iymx**2+25)/28.0d0
       end do
    case (452)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*sq5/(7.0d0*sq2)
          sqy(ig,2,1) = (-9.0d0)/(7.0d0*sq2*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = -2*(5*z**2-1)/sq10
          sqy(ig,3,2) = ci*(iypx+iymx)*sq10*z
          sqy(ig,1,3) = 3.0d0*ci*sq5*(21*z**4-14*z**2+1)/(56.0d0*sq2)
          sqy(ig,2,3) = 13.0d0*sq5*(21*z**4-14*z**2+1)/(56.0d0*sq2)
          sqy(ig,3,3) = -ci*(5*iypx+8*iymx)*sq5*z*(3*z**2-1)/sq2/2.0d0
       end do
    case (453)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*ci*sq2/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -ci*sq2*(5*z**2-1)
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 25.0d0*ci*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (454)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 45.0d0*ci*iymx**2*z/(22.0d0*sq2)
          sqy(ig,2,3) = 45.0d0*iymx**2*z/(22.0d0*sq2)
          sqy(ig,3,3) = (-15.0d0)*ci*iymx**3/(22.0d0*sq2)
          sqy(ig,1,4) = 75.0d0*ci*iymx**2*z*(33*z**2-22*iymx**2-9)/(88.0d0*sq2)
          sqy(ig,2,4) = 75.0d0*iymx**2*z*(33*z**2-22*iymx**2-9)/(88.0d0*sq2)
          sqy(ig,3,4) = (-15.0d0)*ci*iymx**3*(165*z**2-22*iymx**2-15)/(88.0d0*sq2)
       end do
    case (455)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*ci*iymx*sq10/7.0d0
          sqy(ig,2,2) = (-2.0d0)*iymx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*ci*iymx*sq5*(14*z**2-7*iymx**2-2)/(77.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*iymx*sq5*(14*z**2-7*iymx**2-2)/(77.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*ci*iymx**2*sq10*z/11.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*iymx*sq5*(165*z**4-132*iymx**2*z**2-90*z**2+12*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,2,4) = (-5.0d0)*iymx*sq5*(165*z**4-132*iymx**2*z**2-90*z**2+12*iymx**2+5)/(44.0d0*sq2)
          sqy(ig,3,4) = 15.0d0*ci*iymx**2*sq5*z*(55*z**2-11*iymx**2-15)/(22.0d0*sq2)
       end do
    case (456)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq5*z/7.0d0
          sqy(ig,2,2) = sq5*z/7.0d0
          sqy(ig,3,2) = -ci*iymx*sq5/7.0d0
          sqy(ig,1,3) = 9.0d0*ci*sq5*z*(35*z**2-28*iymx**2-15)/308.0d0
          sqy(ig,2,3) = 9.0d0*sq5*z*(35*z**2-28*iymx**2-15)/308.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*iymx*sq5*(315*z**2-28*iymx**2-45)/308.0d0
          sqy(ig,1,4) = 5.0d0*ci*sq5*z*(165*z**4-198*iymx**2*z**2-150*z**2+54*iymx**2+25)/88.0d0
          sqy(ig,2,4) = 5.0d0*sq5*z*(165*z**4-198*iymx**2*z**2-150*z**2+54*iymx**2+25)/88.0d0
          sqy(ig,3,4) = (-5.0d0)*ci*iymx*sq5*(825*z**4-198*iymx**2*z**2-450*z**2+18*iymx**2+25)/88.0d0
       end do
    case (457)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*ci*iymx*sq5/7.0d0
          sqy(ig,2,2) = (-2.0d0)*iymx*sq5/7.0d0
          sqy(ig,3,2) = (-6.0d0)*ci*sq5*z/7.0d0
          sqy(ig,1,3) = (-9.0d0)*ci*iymx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,2,3) = (-9.0d0)*iymx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*sq5*z*(70*z**2-21*iymx**2-30)/154.0d0
          sqy(ig,1,4) = 5.0d0*ci*iymx*sq5*(33*z**4-18*z**2+1)/22.0d0
          sqy(ig,2,4) = 5.0d0*iymx*sq5*(33*z**4-18*z**2+1)/22.0d0
          sqy(ig,3,4) = 15.0d0*ci*sq5*z*(165*z**4-44*iymx**2*z**2-150*z**2+12*iymx**2+25)/44.0d0
       end do
    case (458)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5*ci*z/sq10
          sqy(ig,2,2) = (-15.0d0)*z/(7.0d0*sq10)
          sqy(ig,3,2) = 5.0d0*ci*(5*iypx-2*iymx)/(7.0d0*sq10)
          sqy(ig,1,3) = 3.0d0*ci*sq10*z*(7*z**2-3)/11.0d0
          sqy(ig,2,3) = (-9.0d0)*sq10*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = 9.0d0*ci*(5*iypx-2*iymx)*sq10*(7*z**2-1)/77.0d0
          sqy(ig,1,4) = (-175.0d0)*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq10)
          sqy(ig,2,4) = 75.0d0*z*(33*z**4-30*z**2+5)/(88.0d0*sq10)
          sqy(ig,3,4) = (-125.0d0)*ci*(5*iypx-2*iymx)*(33*z**4-18*z**2+1)/(88.0d0*sq10)
       end do
    case (459)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5.0d0*ci*iypx*sq2/7.0d0
          sqy(ig,2,2) = (-5.0d0)*iypx*sq2/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-135.0d0)*ci*iypx*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = 135.0d0*iypx*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*ci*z*(7*z**2-9*iypx**2-3)/(11.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*ci*iypx*(33*z**4-18*z**2+1)/(44.0d0*sq2)
          sqy(ig,2,4) = (-25.0d0)*iypx*(33*z**4-18*z**2+1)/(44.0d0*sq2)
          sqy(ig,3,4) = (-15.0d0)*ci*z*(33*z**4-55*iypx**2*z**2-30*z**2+15*iypx**2+5)/(22.0d0*sq2)
       end do
    case (460)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*ci*iymx**3*sq21/22.0d0
          sqy(ig,2,3) = 15.0d0*iymx**3*sq21/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-25.0d0)*ci*iymx**3*sq21*(11*z**2-1)/44.0d0
          sqy(ig,2,4) = (-25.0d0)*iymx**3*sq21*(11*z**2-1)/44.0d0
          sqy(ig,3,4) = 25.0d0*ci*iymx**4*sq21*z/8.0d0
       end do
    case (461)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 45.0d0*ci*iymx**2*sq3*z/22.0d0
          sqy(ig,2,3) = 45.0d0*iymx**2*sq3*z/22.0d0
          sqy(ig,3,3) = (-15.0d0)*ci*iymx**3*sq3/22.0d0
          sqy(ig,1,4) = 25.0d0*ci*iymx**2*sq3*z*(99*z**2+11*iymx**2-27)/88.0d0
          sqy(ig,2,4) = 25.0d0*iymx**2*sq3*z*(99*z**2+11*iymx**2-27)/88.0d0
          sqy(ig,3,4) = (-5.0d0)*ci*iymx**3*sq3*(495*z**2+11*iymx**2-45)/88.0d0
       end do
    case (462)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-10.0d0)*ci*iymx/7.0d0
          sqy(ig,2,2) = (-10.0d0)*iymx/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*ci*iymx*(35*z**2+7*iymx**2-5)/77.0d0
          sqy(ig,2,3) = (-15.0d0)*iymx*(35*z**2+7*iymx**2-5)/77.0d0
          sqy(ig,3,3) = 75.0d0*ci*iymx**2*z/11.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*iymx*(825*z**4+264*iymx**2*z**2-450*z**2-24*iymx**2+25)/88.0d0
          sqy(ig,2,4) = (-5.0d0)*iymx*(825*z**4+264*iymx**2*z**2-450*z**2-24*iymx**2+25)/88.0d0
          sqy(ig,3,4) = 15.0d0*ci*iymx**2*z*(275*z**2+22*iymx**2-75)/44.0d0
       end do
    case (463)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*ci*sq5*z/(7.0d0*sq3)
          sqy(ig,2,2) = 2.0d0*sq5*z/(7.0d0*sq3)
          sqy(ig,3,2) = (-2.0d0)*ci*iymx*sq5/(7.0d0*sq3)
          sqy(ig,1,3) = 3.0d0*ci*sq15*z*(35*z**2+21*iymx**2-15)/154.0d0
          sqy(ig,2,3) = 3.0d0*sq15*z*(35*z**2+21*iymx**2-15)/154.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*iymx*sq15*(105*z**2+7*iymx**2-15)/154.0d0
          sqy(ig,1,4) = 5.0d0*ci*sq5*z*(330*z**4+297*iymx**2*z**2-300*z**2-81*iymx**2+50)/(88.0d0*sq3)
          sqy(ig,2,4) = 5.0d0*sq5*z*(330*z**4+297*iymx**2*z**2-300*z**2-81*iymx**2+50)/(88.0d0*sq3)
          sqy(ig,3,4) = (-5.0d0)*ci*iymx*sq5*(1650*z**4+297*iymx**2*z**2-900*z**2-27*iymx**2+50)/(88.0d0*sq3)
       end do
    case (464)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*ci*iymx*sq15/21.0d0
          sqy(ig,2,2) = 4.0d0*iymx*sq15/21.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*sq15*z/7.0d0
          sqy(ig,1,3) = 3.0d0*ci*iymx*sq15*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = 3.0d0*iymx*sq15*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*sq15*z*(35*z**2+14*iymx**2-15)/154.0d0
          sqy(ig,1,4) = (-25.0d0)*ci*iymx*(33*z**4-18*z**2+1)/(11.0d0*sq15)
          sqy(ig,2,4) = (-25.0d0)*iymx*(33*z**4-18*z**2+1)/(11.0d0*sq15)
          sqy(ig,3,4) = 5.0d0*ci*sq15*z*(495*z**4+176*iymx**2*z**2-450*z**2-48*iymx**2+75)/88.0d0
       end do
    case (465)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = (-10.0d0)*z/7.0d0
          sqy(ig,3,2) = 5.0d0*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = (-60.0d0)*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = 90.0d0*ci*(iypx+iymx)*(7*z**2-1)/77.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 25.0d0*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,3,4) = (-125.0d0)*ci*(iypx+iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (466)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3*ci*iymx*sq5*z
          sqy(ig,2,1) = 3*iymx*sq5*z
          sqy(ig,3,1) = (-3.0d0)*ci*iymx**2*sq5/2.0d0
       end do
    case (467)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*iymx**2*sq5/4.0d0
          sqy(ig,2,1) = (-3.0d0)*iymx**2*sq5/4.0d0
          sqy(ig,3,1) = 0
       end do
    case (468)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*iymx*sq5/7.0d0
          sqy(ig,2,1) = 3.0d0*iymx*sq5/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iymx*sq5*(21*z**2-7*iymx**2-3)/7.0d0
          sqy(ig,2,2) = iymx*sq5*(21*z**2-7*iymx**2-3)/7.0d0
          sqy(ig,3,2) = -3*ci*iymx**2*sq5*z
       end do
    case (469)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*ci*sq5*z/7.0d0
          sqy(ig,2,1) = 6.0d0*sq5*z/7.0d0
          sqy(ig,3,1) = (-6.0d0)*ci*iymx*sq5/7.0d0
          sqy(ig,1,2) = (-3.0d0)*ci*sq5*z*(14*z**2-7*iymx**2-6)/28.0d0
          sqy(ig,2,2) = (-3.0d0)*sq5*z*(14*z**2-7*iymx**2-6)/28.0d0
          sqy(ig,3,2) = ci*iymx*sq5*(126*z**2-7*iymx**2-18)/28.0d0
       end do
    case (470)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-45.0d0)*ci*iymx**2*sq3*z/(2.0d0*sq10)
          sqy(ig,2,2) = (-45.0d0)*iymx**2*sq3*z/(2.0d0*sq10)
          sqy(ig,3,2) = 15.0d0*ci*iymx**3*sq3/(2.0d0*sq10)
       end do
    case (471)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*iymx*sq10/7.0d0
          sqy(ig,2,1) = 3.0d0*iymx*sq10/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iymx*sq5*(42*z**2+7*iymx**2-6)/sq2/7.0d0
          sqy(ig,2,2) = iymx*sq5*(42*z**2+7*iymx**2-6)/sq2/7.0d0
          sqy(ig,3,2) = -3*ci*iymx**2*sq10*z
       end do
    case (472)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*sq10*z/7.0d0
          sqy(ig,2,1) = 3.0d0*sq10*z/7.0d0
          sqy(ig,3,1) = (-3.0d0)*ci*iymx*sq10/7.0d0
          sqy(ig,1,2) = (-3.0d0)*ci*sq5*z*(7*z**2+7*iymx**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = (-3.0d0)*sq5*z*(7*z**2+7*iymx**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = ci*iymx*sq5*(63*z**2+7*iymx**2-9)/sq2/14.0d0
       end do
    case (473)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*ci*iymx*sq15/(7.0d0*sq2)
          sqy(ig,2,1) = (-3.0d0)*iymx*sq15/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iymx*sq15*(7*z**2-1)/sq2/14.0d0
          sqy(ig,2,2) = iymx*sq15*(7*z**2-1)/sq2/14.0d0
          sqy(ig,3,2) = -ci*iymx**2*sq15*z/sq2/2.0d0
       end do
    case (474)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iymx**2*sq15/sq2/2.0d0
          sqy(ig,2,2) = -iymx**2*sq15/sq2/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -ci*iymx**2*sq15*(18*z**2-5*iymx**2-2)/sq2/4.0d0
          sqy(ig,2,3) = -iymx**2*sq15*(18*z**2-5*iymx**2-2)/sq2/4.0d0
          sqy(ig,3,3) = 3*ci*iymx**3*sq15*z/sq2
       end do
    case (475)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3*ci*iymx*sq5*z*(3*z**2-iymx**2-1)/sq2
          sqy(ig,2,3) = 3*iymx*sq5*z*(3*z**2-iymx**2-1)/sq2
          sqy(ig,3,3) = (-3.0d0)*ci*iymx**2*sq5*(18*z**2-iymx**2-2)/(4.0d0*sq2)
       end do
    case (476)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 18.0d0*ci/(7.0d0*sq10)
          sqy(ig,2,1) = 18.0d0/(7.0d0*sq10)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*(15*z**2-5*iymx**2-3)/sq10/2.0d0
          sqy(ig,2,2) = (15*z**2-5*iymx**2-3)/sq10/2.0d0
          sqy(ig,3,2) = -15*ci*iymx*z/sq10
          sqy(ig,1,3) = -ci*sq5*(126*z**4-63*iymx**2*z**2-84*z**2+7*iymx**2+6)/sq2/28.0d0
          sqy(ig,2,3) = -sq5*(126*z**4-63*iymx**2*z**2-84*z**2+7*iymx**2+6)/sq2/28.0d0
          sqy(ig,3,3) = 3.0d0*ci*iymx*sq5*z*(12*z**2-iymx**2-4)/(2.0d0*sq2)
       end do
    case (477)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-36.0d0)*ci/(7.0d0*sq30)
          sqy(ig,1,2) = ci*iymx*sq5*z/sq6
          sqy(ig,2,2) = iymx*sq5*z/sq6
          sqy(ig,3,2) = ci*sq5*(120*z**2-5*iymx**2-24)/sq6/10.0d0
          sqy(ig,1,3) = -ci*iymx*sq5*z*(3*z**2-1)/sq6/2.0d0
          sqy(ig,2,3) = -iymx*sq5*z*(3*z**2-1)/sq6/2.0d0
          sqy(ig,3,3) = -ci*sq5*(630*z**4-63*iymx**2*z**2-420*z**2+7*iymx**2+30)/sq6/28.0d0
       end do
    case (478)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*ci*iymx**3*sq6*z/2.0d0
          sqy(ig,2,3) = 15.0d0*iymx**3*sq6*z/2.0d0
          sqy(ig,3,3) = (-15.0d0)*ci*iymx**4*sq6/8.0d0
       end do
    case (479)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iymx**2*sq15/sq2
          sqy(ig,2,2) = -iymx**2*sq15/sq2
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -ci*iymx**2*sq15*(72*z**2+5*iymx**2-8)/sq2/8.0d0
          sqy(ig,2,3) = -iymx**2*sq15*(72*z**2+5*iymx**2-8)/sq2/8.0d0
          sqy(ig,3,3) = 3*ci*iymx**3*sq30*z
       end do
    case (480)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = ci*iymx*sq15*z*(9*z**2+2*iymx**2-3)/2.0d0
          sqy(ig,2,3) = iymx*sq15*z*(9*z**2+2*iymx**2-3)/2.0d0
          sqy(ig,3,3) = -ci*iymx**2*sq15*(27*z**2+iymx**2-3)/4.0d0
       end do
    case (481)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 18.0d0*ci/(7.0d0*sq15)
          sqy(ig,2,1) = 18.0d0/(7.0d0*sq15)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*sq3*(10*z**2+5*iymx**2-2)/sq5/4.0d0
          sqy(ig,2,2) = sq3*(10*z**2+5*iymx**2-2)/sq5/4.0d0
          sqy(ig,3,2) = -ci*iymx*sq15*z
          sqy(ig,1,3) = -ci*sq15*(84*z**4+63*iymx**2*z**2-56*z**2-7*iymx**2+4)/56.0d0
          sqy(ig,2,3) = -sq15*(84*z**4+63*iymx**2*z**2-56*z**2-7*iymx**2+4)/56.0d0
          sqy(ig,3,3) = ci*iymx*sq15*z*(24*z**2+3*iymx**2-8)/4.0d0
       end do
    case (482)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-18.0d0)*ci/(7.0d0*sq30)
          sqy(ig,1,2) = -2*ci*iymx*sq5*z/sq6
          sqy(ig,2,2) = -2*iymx*sq5*z/sq6
          sqy(ig,3,2) = ci*sq5*(30*z**2+5*iymx**2-6)/sq6/5.0d0
          sqy(ig,1,3) = ci*iymx*sq5*z*(3*z**2-1)/sq6
          sqy(ig,2,3) = iymx*sq5*z*(3*z**2-1)/sq6
          sqy(ig,3,3) = -ci*sq5*(315*z**4+126*iymx**2*z**2-210*z**2-14*iymx**2+15)/sq6/28.0d0
       end do
    case (483)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*ci/(7.0d0*sq6)
          sqy(ig,2,1) = (-9.0d0)/(7.0d0*sq6)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*(5*z**2-1)/sq6/2.0d0
          sqy(ig,2,2) = (5*z**2-1)/sq6/2.0d0
          sqy(ig,3,2) = -5*ci*iymx*z/sq6
          sqy(ig,1,3) = (-5.0d0)*ci*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,2,3) = (-5.0d0)*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,3,3) = 5.0d0*ci*iymx*z*(3*z**2-1)/(2.0d0*sq6)
       end do
    case (484)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*ci*iymx**3*sq6/22.0d0
          sqy(ig,2,3) = 15.0d0*iymx**3*sq6/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 45.0d0*ci*iymx**3*(44*z**2-11*iymx**2-4)/(44.0d0*sq6)
          sqy(ig,2,4) = 45.0d0*iymx**3*(44*z**2-11*iymx**2-4)/(44.0d0*sq6)
          sqy(ig,3,4) = (-15.0d0)*ci*iymx**4*sq6*z/4.0d0
       end do
    case (485)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*ci*iymx**2*sq3*z/(11.0d0*sq10)
          sqy(ig,2,3) = (-45.0d0)*iymx**2*sq3*z/(11.0d0*sq10)
          sqy(ig,3,3) = 15.0d0*ci*iymx**3*sq3/(11.0d0*sq10)
          sqy(ig,1,4) = (-25.0d0)*ci*iymx**2*sq3*z*(198*z**2-55*iymx**2-54)/(88.0d0*sq10)
          sqy(ig,2,4) = (-25.0d0)*iymx**2*sq3*z*(198*z**2-55*iymx**2-54)/(88.0d0*sq10)
          sqy(ig,3,4) = 25.0d0*ci*iymx**3*sq3*(198*z**2-11*iymx**2-18)/(88.0d0*sq10)
       end do
    case (486)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*ci*iymx*sq15/7.0d0
          sqy(ig,2,2) = (-2.0d0)*iymx*sq15/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*ci*iymx*sq15*(21*z**2-14*iymx**2-3)/154.0d0
          sqy(ig,2,3) = (-3.0d0)*iymx*sq15*(21*z**2-14*iymx**2-3)/154.0d0
          sqy(ig,3,3) = 9.0d0*ci*iymx**2*sq15*z/22.0d0
          sqy(ig,1,4) = 5.0d0*ci*iymx*sq15*(33*z**4-11*iymx**2*z**2-18*z**2+iymx**2+1)/22.0d0
          sqy(ig,2,4) = 5.0d0*iymx*sq15*(33*z**4-11*iymx**2*z**2-18*z**2+iymx**2+1)/22.0d0
          sqy(ig,3,4) = (-5.0d0)*ci*iymx**2*sq15*z*(132*z**2-11*iymx**2-36)/44.0d0
       end do
    case (487)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*ci*sq15*z/7.0d0
          sqy(ig,2,2) = 2.0d0*sq15*z/7.0d0
          sqy(ig,3,2) = (-2.0d0)*ci*iymx*sq15/7.0d0
          sqy(ig,1,3) = 3.0d0*ci*sq15*z*(112*z**2-63*iymx**2-48)/308.0d0
          sqy(ig,2,3) = 3.0d0*sq15*z*(112*z**2-63*iymx**2-48)/308.0d0
          sqy(ig,3,3) = (-9.0d0)*ci*iymx*sq15*(112*z**2-7*iymx**2-16)/308.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*sq15*z*(66*z**4-33*iymx**2*z**2-60*z**2+9*iymx**2+10)/88.0d0
          sqy(ig,2,4) = (-5.0d0)*sq15*z*(66*z**4-33*iymx**2*z**2-60*z**2+9*iymx**2+10)/88.0d0
          sqy(ig,3,4) = 5.0d0*ci*iymx*sq15*(330*z**4-33*iymx**2*z**2-180*z**2+3*iymx**2+10)/88.0d0
       end do
    case (488)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*ci*iymx*sq5/(7.0d0*sq6)
          sqy(ig,2,2) = (-2.0d0)*iymx*sq5/(7.0d0*sq6)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*ci*iymx*sq15*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = 9.0d0*iymx*sq15*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*ci*sq15*z*(35*z**2-3*iymx**2-15)/(11.0d0*sq2)
          sqy(ig,1,4) = (-5.0d0)*ci*iymx*sq5*(33*z**4-18*z**2+1)/(44.0d0*sq6)
          sqy(ig,2,4) = (-5.0d0)*iymx*sq5*(33*z**4-18*z**2+1)/(44.0d0*sq6)
          sqy(ig,3,4) = (-15.0d0)*ci*sq5*z*(99*z**4-11*iymx**2*z**2-90*z**2+3*iymx**2+15)/(22.0d0*sq6)
       end do
    case (489)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5*ci*z/sq6
          sqy(ig,2,2) = (-25.0d0)*z/(7.0d0*sq6)
          sqy(ig,3,2) = 5.0d0*ci*(6*iypx-iymx)/(7.0d0*sq6)
          sqy(ig,1,3) = (-15.0d0)*ci*sq6*z*(7*z**2-3)/44.0d0
          sqy(ig,2,3) = 75.0d0*sq6*z*(7*z**2-3)/308.0d0
          sqy(ig,3,3) = (-45.0d0)*ci*(6*iypx-iymx)*sq6*(7*z**2-1)/308.0d0
          sqy(ig,1,4) = 35.0d0*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
          sqy(ig,2,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
          sqy(ig,3,4) = 25.0d0*ci*(6*iypx-iymx)*(33*z**4-18*z**2+1)/(88.0d0*sq6)
       end do
    case (490)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-75.0d0)*ci*iymx**4*sq7*z/8.0d0
          sqy(ig,2,4) = (-75.0d0)*iymx**4*sq7*z/8.0d0
          sqy(ig,3,4) = 15.0d0*ci*iymx**5*sq7/8.0d0
       end do
    case (491)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 45.0d0*ci*iymx**3/11.0d0
          sqy(ig,2,3) = 45.0d0*iymx**3/11.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 15.0d0*ci*iymx**3*(264*z**2+11*iymx**2-24)/88.0d0
          sqy(ig,2,4) = 15.0d0*iymx**3*(264*z**2+11*iymx**2-24)/88.0d0
          sqy(ig,3,4) = (-45.0d0)*ci*iymx**4*z/2.0d0
       end do
    case (492)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*ci*iymx**2*sq3*z/22.0d0
          sqy(ig,2,3) = (-45.0d0)*iymx**2*sq3*z/22.0d0
          sqy(ig,3,3) = 15.0d0*ci*iymx**3*sq3/22.0d0
          sqy(ig,1,4) = (-25.0d0)*ci*iymx**2*sq3*z*(99*z**2+11*iymx**2-27)/88.0d0
          sqy(ig,2,4) = (-25.0d0)*iymx**2*sq3*z*(99*z**2+11*iymx**2-27)/88.0d0
          sqy(ig,3,4) = 5.0d0*ci*iymx**3*sq3*(495*z**2+11*iymx**2-45)/88.0d0
       end do
    case (493)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-4.0d0)*ci*iymx*sq5/7.0d0
          sqy(ig,2,2) = (-4.0d0)*iymx*sq5/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*ci*iymx*sq5*(14*z**2+7*iymx**2-2)/154.0d0
          sqy(ig,2,3) = (-9.0d0)*iymx*sq5*(14*z**2+7*iymx**2-2)/154.0d0
          sqy(ig,3,3) = 9.0d0*ci*iymx**2*sq5*z/11.0d0
          sqy(ig,1,4) = 5.0d0*ci*iymx*sq5*(132*z**4+33*iymx**2*z**2-72*z**2-3*iymx**2+4)/44.0d0
          sqy(ig,2,4) = 5.0d0*iymx*sq5*(132*z**4+33*iymx**2*z**2-72*z**2-3*iymx**2+4)/44.0d0
          sqy(ig,3,4) = (-15.0d0)*ci*iymx**2*sq5*z*(176*z**2+11*iymx**2-48)/88.0d0
       end do
    case (494)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*sq5*z/7.0d0
          sqy(ig,2,2) = 3.0d0*sq5*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*ci*iymx*sq5/7.0d0
          sqy(ig,1,3) = 9.0d0*ci*sq5*z*(28*z**2+21*iymx**2-12)/154.0d0
          sqy(ig,2,3) = 9.0d0*sq5*z*(28*z**2+21*iymx**2-12)/154.0d0
          sqy(ig,3,3) = (-9.0d0)*ci*iymx*sq5*(84*z**2+7*iymx**2-12)/154.0d0
          sqy(ig,1,4) = (-15.0d0)*ci*sq5*z*(33*z**4+22*iymx**2*z**2-30*z**2-6*iymx**2+5)/88.0d0
          sqy(ig,2,4) = (-15.0d0)*sq5*z*(33*z**4+22*iymx**2*z**2-30*z**2-6*iymx**2+5)/88.0d0
          sqy(ig,3,4) = 15.0d0*ci*iymx*sq5*(165*z**4+22*iymx**2*z**2-90*z**2-2*iymx**2+5)/88.0d0
       end do
    case (495)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5.0d0*ci*iymx/(7.0d0*sq3)
          sqy(ig,2,2) = 5.0d0*iymx/(7.0d0*sq3)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*ci*iymx*sq3*(7*z**2-1)/154.0d0
          sqy(ig,2,3) = (-45.0d0)*iymx*sq3*(7*z**2-1)/154.0d0
          sqy(ig,3,3) = 15.0d0*ci*sq3*z*(14*z**2+3*iymx**2-6)/22.0d0
          sqy(ig,1,4) = 25.0d0*ci*iymx*(33*z**4-18*z**2+1)/(88.0d0*sq3)
          sqy(ig,2,4) = 25.0d0*iymx*(33*z**4-18*z**2+1)/(88.0d0*sq3)
          sqy(ig,3,4) = (-5.0d0)*ci*sq3*z*(198*z**4+55*iymx**2*z**2-180*z**2-15*iymx**2+30)/44.0d0
       end do
    case (496)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = (-10.0d0)*z/7.0d0
          sqy(ig,3,2) = 5.0d0*ci*(iypx+iymx)/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 45.0d0*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = (-135.0d0)*ci*(iypx+iymx)*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = (-5.0d0)*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,3,4) = 25.0d0*ci*(iypx+iymx)*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (497)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*ci*iymx**2*sq35/4.0d0
          sqy(ig,2,1) = 3.0d0*iymx**2*sq35/4.0d0
          sqy(ig,3,1) = 0
       end do
    case (498)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (499)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*iymx**2*sq35*z/4.0d0
          sqy(ig,2,2) = 3.0d0*iymx**2*sq35*z/4.0d0
          sqy(ig,3,2) = -ci*iymx**3*sq35/4.0d0
       end do
    case (500)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3*ci*iymx*sq5/sq7
          sqy(ig,2,1) = 3*iymx*sq5/sq7
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iymx*sq5*(7*z**2-1)/sq7/2.0d0
          sqy(ig,2,2) = -iymx*sq5*(7*z**2-1)/sq7/2.0d0
          sqy(ig,3,2) = ci*iymx**2*sq35*z/2.0d0
       end do
    case (501)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iymx**3*sq105/sq2
          sqy(ig,2,2) = -iymx**3*sq105/sq2
          sqy(ig,3,2) = 0
       end do
    case (502)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*ci*iymx**2*sq35*z/(2.0d0*sq2)
          sqy(ig,2,2) = 3.0d0*iymx**2*sq35*z/(2.0d0*sq2)
          sqy(ig,3,2) = -ci*iymx**3*sq35/sq2/2.0d0
       end do
    case (503)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3*ci*iymx*sq5/sq14
          sqy(ig,2,1) = 3*iymx*sq5/sq14
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iymx*sq5*(7*z**2-1)/sq14/2.0d0
          sqy(ig,2,2) = -iymx*sq5*(7*z**2-1)/sq14/2.0d0
          sqy(ig,3,2) = ci*iymx**2*sq70*z/4.0d0
       end do
    case (504)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (505)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -ci*iymx**3*sq105*z/sq2
          sqy(ig,2,3) = -iymx**3*sq105*z/sq2
          sqy(ig,3,3) = ci*iymx**4*sq105/sq2/4.0d0
       end do
    case (506)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iymx**2*sq35/sq2/2.0d0
          sqy(ig,2,2) = -iymx**2*sq35/sq2/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = ci*iymx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,2,3) = iymx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*iymx**3*sq35*z/(2.0d0*sq2)
       end do
    case (507)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iymx*sq35*z/sq2
          sqy(ig,2,2) = iymx*sq35*z/sq2
          sqy(ig,3,2) = -ci*iymx**2*sq35/sq2/2.0d0
          sqy(ig,1,3) = -ci*iymx*sq35*z*(3*z**2-1)/sq2/2.0d0
          sqy(ig,2,3) = -iymx*sq35*z*(3*z**2-1)/sq2/2.0d0
          sqy(ig,3,3) = ci*iymx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
       end do
    case (508)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3*ci*sq6/sq35
          sqy(ig,2,1) = 3*sq6/sq35
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq7*(5*z**2-1)/sq30
          sqy(ig,2,2) = -sq7*(5*z**2-1)/sq30
          sqy(ig,3,2) = 10*ci*iymx*sq7*z/sq30
          sqy(ig,1,3) = ci*sq5*(21*z**4-14*z**2+1)/sq42/4.0d0
          sqy(ig,2,3) = sq5*(21*z**4-14*z**2+1)/sq42/4.0d0
          sqy(ig,3,3) = -7*ci*iymx*sq5*z*(3*z**2-1)/sq42
       end do
    case (509)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 25.0d0*ci*iymx**4*sq42/16.0d0
          sqy(ig,2,3) = 25.0d0*iymx**4*sq42/16.0d0
          sqy(ig,3,3) = 0
       end do
    case (510)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -ci*iymx**3*sq210*z
          sqy(ig,2,3) = -iymx**3*sq210*z
          sqy(ig,3,3) = ci*iymx**4*sq105/sq2/2.0d0
       end do
    case (511)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iymx**2*sq105/4.0d0
          sqy(ig,2,2) = -iymx**2*sq105/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = ci*iymx**2*sq105*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,2,3) = iymx**2*sq105*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,3,3) = (-3.0d0)*ci*iymx**3*sq105*z/4.0d0
       end do
    case (512)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = ci*iymx*sq35*z/sq3
          sqy(ig,2,2) = iymx*sq35*z/sq3
          sqy(ig,3,2) = -ci*iymx**2*sq35/sq3/2.0d0
          sqy(ig,1,3) = -ci*iymx*sq35*z*(3*z**2-1)/sq3/2.0d0
          sqy(ig,2,3) = -iymx*sq35*z*(3*z**2-1)/sq3/2.0d0
          sqy(ig,3,3) = ci*iymx**2*sq35*(3*z-1)*(3*z+1)/sq3/4.0d0
       end do
    case (513)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9*ci/sq210
          sqy(ig,2,1) = 9/sq210
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*sq7*(5*z**2-1)/sq30/2.0d0
          sqy(ig,2,2) = -sq7*(5*z**2-1)/sq30/2.0d0
          sqy(ig,3,2) = 5*ci*iymx*sq7*z/sq30
          sqy(ig,1,3) = ci*sq5*(21*z**4-14*z**2+1)/sq42/8.0d0
          sqy(ig,2,3) = sq5*(21*z**4-14*z**2+1)/sq42/8.0d0
          sqy(ig,3,3) = (-7.0d0)*ci*iymx*sq5*z*(3*z**2-1)/(2.0d0*sq42)
       end do
    case (514)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
       end do
    case (515)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 25.0d0*ci*iymx**4*sq42*z/16.0d0
          sqy(ig,2,4) = 25.0d0*iymx**4*sq42*z/16.0d0
          sqy(ig,3,4) = (-5.0d0)*ci*iymx**5*sq42/16.0d0
       end do
    case (516)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*ci*iymx**3*sq105/(11.0d0*sq2)
          sqy(ig,2,3) = 3.0d0*iymx**3*sq105/(11.0d0*sq2)
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-5.0d0)*ci*iymx**3*sq105*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,2,4) = (-5.0d0)*iymx**3*sq105*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,3,4) = 5.0d0*ci*iymx**4*sq105*z/(4.0d0*sq2)
       end do
    case (517)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-27.0d0)*ci*iymx**2*sq105*z/44.0d0
          sqy(ig,2,3) = (-27.0d0)*iymx**2*sq105*z/44.0d0
          sqy(ig,3,3) = 9.0d0*ci*iymx**3*sq105/44.0d0
          sqy(ig,1,4) = 15.0d0*ci*iymx**2*sq105*z*(11*z**2-3)/88.0d0
          sqy(ig,2,4) = 15.0d0*iymx**2*sq105*z*(11*z**2-3)/88.0d0
          sqy(ig,3,4) = (-15.0d0)*ci*iymx**3*sq105*(11*z**2-1)/88.0d0
       end do
    case (518)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -2*ci*iymx*sq5/sq21
          sqy(ig,2,2) = -2*iymx*sq5/sq21
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*ci*iymx*sq15*(7*z**2-1)/(11.0d0*sq7)
          sqy(ig,2,3) = 9.0d0*iymx*sq15*(7*z**2-1)/(11.0d0*sq7)
          sqy(ig,3,3) = (-9.0d0)*ci*iymx**2*sq105*z/11.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*iymx*sq35*(33*z**4-18*z**2+1)/(44.0d0*sq3)
          sqy(ig,2,4) = (-5.0d0)*iymx*sq35*(33*z**4-18*z**2+1)/(44.0d0*sq3)
          sqy(ig,3,4) = 5.0d0*ci*iymx**2*sq105*z*(11*z**2-3)/22.0d0
       end do
    case (519)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 25*ci*z/sq210
          sqy(ig,2,2) = 25*z/sq210
          sqy(ig,3,2) = -25*ci*iymx/sq210
          sqy(ig,1,3) = (-15.0d0)*ci*sq30*z*(7*z**2-3)/(44.0d0*sq7)
          sqy(ig,2,3) = (-15.0d0)*sq30*z*(7*z**2-3)/(44.0d0*sq7)
          sqy(ig,3,3) = 45.0d0*ci*iymx*sq30*(7*z**2-1)/(44.0d0*sq7)
          sqy(ig,1,4) = 25.0d0*ci*sq7*z*(33*z**4-30*z**2+5)/(88.0d0*sq30)
          sqy(ig,2,4) = 25.0d0*sq7*z*(33*z**4-30*z**2+5)/(88.0d0*sq30)
          sqy(ig,3,4) = (-125.0d0)*ci*iymx*sq7*(33*z**4-18*z**2+1)/(88.0d0*sq30)
       end do
    case (520)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 30*ci*z/sq42
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-45.0d0)*ci*sq6*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 105.0d0*ci*z*(33*z**4-30*z**2+5)/(44.0d0*sq42)
       end do
    case (521)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-105.0d0)*ci*iymx**5/8.0d0
          sqy(ig,2,4) = (-105.0d0)*iymx**5/8.0d0
          sqy(ig,3,4) = 0
       end do
    case (522)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 75.0d0*ci*iymx**4*sq7*z/8.0d0
          sqy(ig,2,4) = 75.0d0*iymx**4*sq7*z/8.0d0
          sqy(ig,3,4) = (-15.0d0)*ci*iymx**5*sq7/8.0d0
       end do
    case (523)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*ci*iymx**3*sq21/22.0d0
          sqy(ig,2,3) = 15.0d0*iymx**3*sq21/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-25.0d0)*ci*iymx**3*sq21*(11*z**2-1)/44.0d0
          sqy(ig,2,4) = (-25.0d0)*iymx**3*sq21*(11*z**2-1)/44.0d0
          sqy(ig,3,4) = 25.0d0*ci*iymx**4*sq21*z/8.0d0
       end do
    case (524)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-27.0d0)*ci*iymx**2*sq35*z/22.0d0
          sqy(ig,2,3) = (-27.0d0)*iymx**2*sq35*z/22.0d0
          sqy(ig,3,3) = 9.0d0*ci*iymx**3*sq35/22.0d0
          sqy(ig,1,4) = 15.0d0*ci*iymx**2*sq35*z*(11*z**2-3)/44.0d0
          sqy(ig,2,4) = 15.0d0*iymx**2*sq35*z*(11*z**2-3)/44.0d0
          sqy(ig,3,4) = (-15.0d0)*ci*iymx**3*sq35*(11*z**2-1)/44.0d0
       end do
    case (525)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -ci*iymx*sq5/sq7
          sqy(ig,2,2) = -iymx*sq5/sq7
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 27.0d0*ci*iymx*sq5*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,2,3) = 27.0d0*iymx*sq5*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,3,3) = (-27.0d0)*ci*iymx**2*sq35*z/22.0d0
          sqy(ig,1,4) = (-5.0d0)*ci*iymx*sq35*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,2,4) = (-5.0d0)*iymx*sq35*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,3,4) = 15.0d0*ci*iymx**2*sq35*z*(11*z**2-3)/44.0d0
       end do
    case (526)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5*ci*z/sq21
          sqy(ig,2,2) = 5*z/sq21
          sqy(ig,3,2) = -5*ci*iymx/sq21
          sqy(ig,1,3) = (-45.0d0)*ci*z*(7*z**2-3)/(22.0d0*sq21)
          sqy(ig,2,3) = (-45.0d0)*z*(7*z**2-3)/(22.0d0*sq21)
          sqy(ig,3,3) = 135.0d0*ci*iymx*(7*z**2-1)/(22.0d0*sq21)
          sqy(ig,1,4) = 5.0d0*ci*sq7*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,2,4) = 5.0d0*sq7*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,3,4) = (-25.0d0)*ci*iymx*sq7*(33*z**4-18*z**2+1)/(88.0d0*sq3)
       end do
    case (527)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 5*ci*z/sq7
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-45.0d0)*ci*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 5.0d0*ci*sq7*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (528)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 0
       end do
    case default
       write(6,*) 'getsqy_two() invalid k3 = ', k3
       stop
    end select

    if (ik3.lt.0) then
       sqy = conjg(sqy)
    end if
    return
  end subroutine getsqy_two_y

  subroutine getsqy_two_z(sqy,ik3,gk,nl,nkc,mll3)
    implicit none
    integer,intent(in):: ik3,nl,nkc
    integer,intent(out):: mll3
    real(kind=8),intent(in):: gk(4,nkc)
    complex(kind=8):: sqy(nkc,3,nl)
    !
    real(kind=8),parameter:: eps = 1.0d-12
    real(kind=8),parameter:: ci = (0.0d0, 1.0d0)
    real(kind=8),parameter:: sq2 = sqrt(2.0d0), &
         sq3 = sqrt(3.0d0), sq5 = sqrt(5.0d0), &
         sq6 = sqrt(6.0d0), sq7 = sqrt(7.0d0), &
         sq8 = sqrt(8.0d0), sq10 = sqrt(10.0d0), &
         sq14 = sqrt(14.0d0), &
         sq15 = sqrt(15.0d0), sq21 = sqrt(21.0d0), &
         sq30 = sqrt(30.0d0), sq35 = sqrt(35.0d0), &
         sq42 = sqrt(42.0d0), sq105 = sqrt(105.0d0), &
         sq210 = sqrt(210.0d0)
    !
    integer:: k3
    integer:: ig,ist
    real(kind=8):: x,y,z,r
    complex(kind=8):: iypx, iymx
    !     
    k3 = abs(ik3)
    !
    ! FOR G=0
    if (gk(4,1).lt.eps) then
       sqy(1,:,1:nl) = 0.0d0
       ist=2
    else
       ist=1
    end if

    select case(k3)
    case (1)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (2)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (3)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (4)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -1
       end do
    case (5)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -1
          sqy(ig,2,1) = -ci
          sqy(ig,3,1) = 0
       end do
    case (6)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -4*z
       end do
    case (7)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 1
          sqy(ig,2,1) = -ci
          sqy(ig,3,1) = 0
       end do
    case (8)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -1
       end do
    case (9)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2*z
          sqy(ig,2,2) = -2*ci*z
          sqy(ig,3,2) = -2*iymx
       end do
    case (10)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 4*z
       end do
    case (11)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq3/sq2
          sqy(ig,2,1) = -ci*sq3/sq2
          sqy(ig,3,1) = 0
       end do
    case (12)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (13)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*z/sq2
          sqy(ig,2,2) = -ci*sq3*z/sq2
          sqy(ig,3,2) = -iypx*sq3/sq2
       end do
    case (14)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq6
          sqy(ig,2,2) = ci*iypx*sq6
          sqy(ig,3,2) = 0
       end do
    case (15)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 3*z
       end do
    case (16)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -sq2
       end do
    case (17)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 1/sq2
          sqy(ig,2,1) = ci/sq2
          sqy(ig,3,1) = 0
       end do
    case (18)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -sq2*z
       end do
    case (19)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = z/sq2
          sqy(ig,2,2) = ci*z/sq2
          sqy(ig,3,2) = iypx/sq2
       end do
    case (20)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*z
          sqy(ig,2,2) = ci*sq3*z
          sqy(ig,3,2) = iymx*sq3
       end do
    case (21)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -5*z
       end do
    case (22)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 1/sq2
          sqy(ig,2,1) = -ci/sq2
          sqy(ig,3,1) = 0
       end do
    case (23)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = sq2
       end do
    case (24)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -z/sq2
          sqy(ig,2,2) = ci*z/sq2
          sqy(ig,3,2) = iymx/sq2
       end do
    case (25)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -sq2*z
       end do
    case (26)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq3
          sqy(ig,2,2) = ci*iymx*sq3
          sqy(ig,3,2) = 0
       end do
    case (27)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2*z
          sqy(ig,2,2) = -2*ci*z
          sqy(ig,3,2) = -2*iymx
       end do
    case (28)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 5*z
       end do
    case (29)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (30)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq3/sq2
          sqy(ig,2,1) = ci*sq3/sq2
          sqy(ig,3,1) = 0
       end do
    case (31)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq6
          sqy(ig,2,2) = ci*iymx*sq6
          sqy(ig,3,2) = 0
       end do
    case (32)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq3*z/sq2
          sqy(ig,2,2) = -ci*sq3*z/sq2
          sqy(ig,3,2) = -iymx*sq3/sq2
       end do
    case (33)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (34)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq3
          sqy(ig,2,2) = -ci*iymx*sq3
          sqy(ig,3,2) = 0
       end do
    case (35)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*z
          sqy(ig,2,2) = ci*sq3*z
          sqy(ig,3,2) = iymx*sq3
       end do
    case (36)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -3*z
       end do
    case (37)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*z/sq6
          sqy(ig,2,1) = -3*ci*z/sq6
          sqy(ig,3,1) = -3*iypx/sq6
       end do
    case (38)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -iypx*sq6
          sqy(ig,2,1) = -ci*iypx*sq6
          sqy(ig,3,1) = 0
       end do
    case (39)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq3/(5.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci*sq3/(5.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq6*(5*z**2-1)/5.0d0
          sqy(ig,2,2) = -ci*sq6*(5*z**2-1)/5.0d0
          sqy(ig,3,2) = -2*iypx*sq6*z
       end do
    case (40)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2*iypx*sq6*z
          sqy(ig,2,2) = 2*ci*iypx*sq6*z
          sqy(ig,3,2) = iypx**2*sq6
       end do
    case (41)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-3)/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 9.0d0*(5*z**2-1)/10.0d0
       end do
    case (42)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq3/5.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = -ci*sq3*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -iypx*sq3*z
       end do
    case (43)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq3*z
          sqy(ig,2,2) = -ci*iypx*sq3*z
          sqy(ig,3,2) = -iypx**2*sq3/2.0d0
       end do
    case (44)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 9.0d0*iypx**2/2.0d0
          sqy(ig,2,2) = 9.0d0*ci*iypx**2/2.0d0
          sqy(ig,3,2) = 0
       end do
    case (45)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-27.0d0)*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 12.0d0*z*(7*z**2-3)/7.0d0
       end do
    case (46)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -3*sq2*z
       end do
    case (47)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*z/sq2
          sqy(ig,2,1) = -3*ci*z/sq2
          sqy(ig,3,1) = -3*iypx/sq2
       end do
    case (48)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = sq2/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-9.0d0)*sq2*(5*z**2-1)/5.0d0
       end do
    case (49)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 1/sq2/5.0d0
          sqy(ig,2,1) = ci/sq2/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*sq2*(5*z**2-1)/5.0d0
          sqy(ig,2,2) = 3.0d0*ci*sq2*(5*z**2-1)/5.0d0
          sqy(ig,3,2) = 6*iypx*sq2*z
       end do
    case (50)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3/5.0d0
          sqy(ig,2,1) = -ci*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*sq3*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = 3.0d0*ci*sq3*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = 3*iymx*sq3*z
       end do
    case (51)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-7)/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-9.0d0)*(5*z**2-1)/10.0d0
       end do
    case (52)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-4)/5.0d0
          sqy(ig,2,1) = (-4.0d0)*ci/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -3*iypx*z
       end do
    case (53)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3*iypx*sq3*z
          sqy(ig,2,2) = 3*ci*iypx*sq3*z
          sqy(ig,3,2) = 3.0d0*iypx**2*sq3/2.0d0
       end do
    case (54)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5.0d0*sq3*z/7.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z/7.0d0
          sqy(ig,3,2) = (-5.0d0)*iymx*sq3/7.0d0
          sqy(ig,1,3) = (-3.0d0)*sq3*z*(7*z**2-3)/7.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq3*z*(7*z**2-3)/7.0d0
          sqy(ig,3,3) = 9.0d0*iymx*sq3*(7*z**2-1)/7.0d0
       end do
    case (55)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-3.0d0)*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-36.0d0)*z*(7*z**2-3)/7.0d0
       end do
    case (56)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3*z/sq2
          sqy(ig,2,1) = -3*ci*z/sq2
          sqy(ig,3,1) = -3*iymx/sq2
       end do
    case (57)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -3*sq2*z
       end do
    case (58)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 1/sq2/5.0d0
          sqy(ig,2,1) = -ci/sq2/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*sq2*(5*z**2-1)/5.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq2*(5*z**2-1)/5.0d0
          sqy(ig,3,2) = -6*iymx*sq2*z
       end do
    case (59)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -sq2/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 9.0d0*sq2*(5*z**2-1)/5.0d0
       end do
    case (60)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -3*iymx*sq3*z
          sqy(ig,2,2) = 3*ci*iymx*sq3*z
          sqy(ig,3,2) = 3.0d0*iymx**2*sq3/2.0d0
       end do
    case (61)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 4/5.0d0
          sqy(ig,2,1) = (-4.0d0)*ci/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -3*iymx*z
       end do
    case (62)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-7)/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-9.0d0)*(5*z**2-1)/10.0d0
       end do
    case (63)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq3/5.0d0
          sqy(ig,2,1) = -ci*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*sq3*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = 3.0d0*ci*sq3*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = 3*iypx*sq3*z
       end do
    case (64)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq3/7.0d0
          sqy(ig,2,2) = -ci*iymx*sq3/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-6.0d0)*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,2,3) = 6.0d0*ci*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,3,3) = 6*iymx**2*sq3*z
       end do
    case (65)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 6.0d0*z/7.0d0
          sqy(ig,2,2) = (-6.0d0)*ci*z/7.0d0
          sqy(ig,3,2) = (-6.0d0)*iymx/7.0d0
          sqy(ig,1,3) = 9.0d0*z*(7*z**2-3)/7.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*z*(7*z**2-3)/7.0d0
          sqy(ig,3,3) = (-27.0d0)*iymx*(7*z**2-1)/7.0d0
       end do
    case (66)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 3.0d0*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 36.0d0*z*(7*z**2-3)/7.0d0
       end do
    case (67)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iymx*sq6
          sqy(ig,2,1) = -ci*iymx*sq6
          sqy(ig,3,1) = 0
       end do
    case (68)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3*z/sq6
          sqy(ig,2,1) = -3*ci*z/sq6
          sqy(ig,3,1) = -3*iymx/sq6
       end do
    case (69)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2*iymx*sq6*z
          sqy(ig,2,2) = -2*ci*iymx*sq6*z
          sqy(ig,3,2) = -iymx**2*sq6
       end do
    case (70)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0/(5.0d0*sq6)
          sqy(ig,2,1) = (-9.0d0)*ci/(5.0d0*sq6)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq6*(5*z**2-1)/5.0d0
          sqy(ig,2,2) = ci*sq6*(5*z**2-1)/5.0d0
          sqy(ig,3,2) = 2*iymx*sq6*z
       end do
    case (71)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*iymx**2/2.0d0
          sqy(ig,2,2) = 9.0d0*ci*iymx**2/2.0d0
          sqy(ig,3,2) = 0
       end do
    case (72)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq3*z
          sqy(ig,2,2) = -ci*iymx*sq3*z
          sqy(ig,3,2) = -iymx**2*sq3/2.0d0
       end do
    case (73)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq3/5.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq3*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = -ci*sq3*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = -iymx*sq3*z
       end do
    case (74)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-3)/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 9.0d0*(5*z**2-1)/10.0d0
       end do
    case (75)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -9*iymx**2*z
          sqy(ig,2,3) = 9*ci*iymx**2*z
          sqy(ig,3,3) = 3*iymx**3
       end do
    case (76)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq3/7.0d0
          sqy(ig,2,2) = ci*iymx*sq3/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 6.0d0*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,2,3) = (-6.0d0)*ci*iymx*sq3*(7*z**2-1)/7.0d0
          sqy(ig,3,3) = -6*iymx**2*sq3*z
       end do
    case (77)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5.0d0*sq3*z/7.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z/7.0d0
          sqy(ig,3,2) = (-5.0d0)*iymx*sq3/7.0d0
          sqy(ig,1,3) = (-3.0d0)*sq3*z*(7*z**2-3)/7.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq3*z*(7*z**2-3)/7.0d0
          sqy(ig,3,3) = 9.0d0*iymx*sq3*(7*z**2-1)/7.0d0
       end do
    case (78)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 27.0d0*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-12.0d0)*z*(7*z**2-3)/7.0d0
       end do
    case (79)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -iypx*sq30/2.0d0
          sqy(ig,2,1) = -ci*iypx*sq30/2.0d0
          sqy(ig,3,1) = 0
       end do
    case (80)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (81)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -15*iypx*z/sq30
          sqy(ig,2,2) = -15*ci*iypx*z/sq30
          sqy(ig,3,2) = (-15.0d0)*iypx**2/(2.0d0*sq30)
       end do
    case (82)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iypx**2*sq30/4.0d0
          sqy(ig,2,2) = 3.0d0*ci*iypx**2*sq30/4.0d0
          sqy(ig,3,2) = 0
       end do
    case (83)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3/sq5
          sqy(ig,2,1) = -3*ci/sq5
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*(5*z**2-1)/(4.0d0*sq5)
          sqy(ig,2,2) = 3.0d0*ci*(5*z**2-1)/(4.0d0*sq5)
          sqy(ig,3,2) = 3.0d0*iypx*sq5*z/2.0d0
       end do
    case (84)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq15*z
          sqy(ig,2,2) = -ci*iypx*sq15*z
          sqy(ig,3,2) = -iypx**2*sq15/2.0d0
       end do
    case (85)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iypx**2*sq15/4.0d0
          sqy(ig,2,2) = 3.0d0*ci*iypx**2*sq15/4.0d0
          sqy(ig,3,2) = 0
       end do
    case (86)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (87)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*sq5*z/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq5*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*iypx*sq5/7.0d0
          sqy(ig,1,3) = 3.0d0*sq5*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq5*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = 9.0d0*iypx*sq5*(7*z**2-1)/28.0d0
       end do
    case (88)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*iypx*sq15/7.0d0
          sqy(ig,2,2) = 2.0d0*ci*iypx*sq15/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*iypx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iypx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,3,3) = (-3.0d0)*iypx**2*sq15*z/2.0d0
       end do
    case (89)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iypx**2*sq15*z/4.0d0
          sqy(ig,2,3) = 9.0d0*ci*iypx**2*sq15*z/4.0d0
          sqy(ig,3,3) = 3.0d0*iypx**3*sq15/4.0d0
       end do
    case (90)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -3*iypx**3*sq5
          sqy(ig,2,3) = -3*ci*iypx**3*sq5
          sqy(ig,3,3) = 0
       end do
    case (91)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 30.0d0*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-15.0d0)*z*(7*z**2-3)/14.0d0
       end do
    case (92)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq6*z
          sqy(ig,2,1) = -ci*sq6*z
          sqy(ig,3,1) = -iypx*sq6
       end do
    case (93)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iypx*sq6/2.0d0
          sqy(ig,2,1) = ci*iypx*sq6/2.0d0
          sqy(ig,3,1) = 0
       end do
    case (94)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-2.0d0)*sq6/5.0d0
          sqy(ig,2,1) = (-2.0d0)*ci*sq6/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*sq6*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq6*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = (-3.0d0)*iypx*sq6*z/2.0d0
       end do
    case (95)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 9*iypx*z/sq6
          sqy(ig,2,2) = 9*ci*iypx*z/sq6
          sqy(ig,3,2) = 9.0d0*iypx**2/(2.0d0*sq6)
       end do
    case (96)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-6)/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 9.0d0*(5*z**2-1)/5.0d0
       end do
    case (97)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq3/5.0d0
          sqy(ig,2,1) = -ci*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*sq3*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = (-9.0d0)*ci*sq3*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = (-9.0d0)*iypx*sq3*z/2.0d0
       end do
    case (98)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3*iypx*sq3*z
          sqy(ig,2,2) = 3*ci*iypx*sq3*z
          sqy(ig,3,2) = 3.0d0*iypx**2*sq3/2.0d0
       end do
    case (99)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*iypx**2/4.0d0
          sqy(ig,2,2) = (-9.0d0)*ci*iypx**2/4.0d0
          sqy(ig,3,2) = 0
       end do
    case (100)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 6.0d0*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 9.0d0*z*(7*z**2-3)/7.0d0
       end do
    case (101)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*sq3*z/7.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z/7.0d0
          sqy(ig,3,2) = (-5.0d0)*iypx*sq3/7.0d0
          sqy(ig,1,3) = (-9.0d0)*sq3*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*sq3*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = (-27.0d0)*iypx*sq3*(7*z**2-1)/28.0d0
       end do
    case (102)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 8.0d0*iypx*sq3/7.0d0
          sqy(ig,2,2) = 8.0d0*ci*iypx*sq3/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iypx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,2,3) = 9.0d0*ci*iypx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,3,3) = 9.0d0*iypx**2*sq3*z/2.0d0
       end do
    case (103)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-27.0d0)*iypx**2*z/4.0d0
          sqy(ig,2,3) = (-27.0d0)*ci*iypx**2*z/4.0d0
          sqy(ig,3,3) = (-9.0d0)*iypx**3/4.0d0
       end do
    case (104)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-6.0d0)*sq5*z/7.0d0
          sqy(ig,2,2) = 6.0d0*ci*sq5*z/7.0d0
          sqy(ig,3,2) = 6.0d0*iymx*sq5/7.0d0
          sqy(ig,1,3) = 3.0d0*sq5*z*(7*z**2-3)/14.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*sq5*z*(7*z**2-3)/14.0d0
          sqy(ig,3,3) = (-9.0d0)*iymx*sq5*(7*z**2-1)/14.0d0
       end do
    case (105)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-18.0d0)*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 51.0d0*z*(7*z**2-3)/14.0d0
       end do
    case (106)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -3*sq3*z
       end do
    case (107)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3*z
          sqy(ig,2,1) = ci*sq3*z
          sqy(ig,3,1) = iypx*sq3
       end do
    case (108)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-4.0d0)*sq3/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-3.0d0)*sq3*(5*z**2-1)/10.0d0
       end do
    case (109)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-2.0d0)*sq3/5.0d0
          sqy(ig,2,1) = (-2.0d0)*ci*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq3*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = ci*sq3*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = iypx*sq3*z
       end do
    case (110)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0/(5.0d0*sq2)
          sqy(ig,2,1) = (-3.0d0)*ci/(5.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = 9.0d0*ci*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = 9*iymx*z/sq2
       end do
    case (111)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -sq6/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-6.0d0)*sq6*(5*z**2-1)/5.0d0
       end do
    case (112)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3/sq2/5.0d0
          sqy(ig,2,1) = ci*sq3/sq2/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 7.0d0*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = 7.0d0*ci*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = 7*iypx*sq3*z/sq2
       end do
    case (113)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -3*iypx*sq2*z
          sqy(ig,2,2) = -3*ci*iypx*sq2*z
          sqy(ig,3,2) = -3*iypx**2/sq2
       end do
    case (114)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-15.0d0)*z/(7.0d0*sq2)
          sqy(ig,2,2) = 15.0d0*ci*z/(7.0d0*sq2)
          sqy(ig,3,2) = 15.0d0*iymx/(7.0d0*sq2)
          sqy(ig,1,3) = (-3.0d0)*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,3) = 3.0d0*ci*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,3) = 9.0d0*iymx*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (115)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-9.0d0)*sq6*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-3.0d0)*sq6*z*(7*z**2-3)/7.0d0
       end do
    case (116)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*z/(7.0d0*sq6)
          sqy(ig,2,2) = 3.0d0*ci*z/(7.0d0*sq6)
          sqy(ig,3,2) = 3.0d0*iypx/(7.0d0*sq6)
          sqy(ig,1,3) = 3.0d0*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,3) = 3.0d0*ci*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,3) = 9.0d0*iypx*sq3*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (117)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 9.0d0*iypx*sq2/7.0d0
          sqy(ig,2,2) = 9.0d0*ci*iypx*sq2/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*iypx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,3) = (-3.0d0)*ci*iypx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,3) = -3*iypx**2*z/sq2
       end do
    case (118)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iymx*sq10/7.0d0
          sqy(ig,2,2) = 3.0d0*ci*iymx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iymx*sq10*(7*z**2-1)/28.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*iymx*sq10*(7*z**2-1)/28.0d0
          sqy(ig,3,3) = (-9.0d0)*iymx**2*sq10*z/4.0d0
       end do
    case (119)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*z*(7*z**2-3)/(2.0d0*sq2)
          sqy(ig,2,3) = 3.0d0*ci*z*(7*z**2-3)/(2.0d0*sq2)
          sqy(ig,3,3) = 9.0d0*iymx*(7*z**2-1)/(2.0d0*sq2)
       end do
    case (120)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-12.0d0)*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-39.0d0)*z*(7*z**2-3)/7.0d0
       end do
    case (121)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3*z
          sqy(ig,2,1) = -ci*sq3*z
          sqy(ig,3,1) = -iymx*sq3
       end do
    case (122)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3*sq3*z
       end do
    case (123)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*sq3/5.0d0
          sqy(ig,2,1) = (-2.0d0)*ci*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*(5*z**2-1)/10.0d0
          sqy(ig,2,2) = ci*sq3*(5*z**2-1)/10.0d0
          sqy(ig,3,2) = iymx*sq3*z
       end do
    case (124)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-4.0d0)*sq3/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-3.0d0)*sq3*(5*z**2-1)/10.0d0
       end do
    case (125)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -3*iymx*sq2*z
          sqy(ig,2,2) = 3*ci*iymx*sq2*z
          sqy(ig,3,2) = 3*iymx**2/sq2
       end do
    case (126)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3/sq2/5.0d0
          sqy(ig,2,1) = -ci*sq3/sq2/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 7.0d0*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = (-7.0d0)*ci*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = -7*iymx*sq3*z/sq2
       end do
    case (127)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = sq6/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 6.0d0*sq6*(5*z**2-1)/5.0d0
       end do
    case (128)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0/(5.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci/(5.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = (-9.0d0)*ci*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = -9*iypx*z/sq2
       end do
    case (129)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*iymx*sq2/7.0d0
          sqy(ig,2,2) = 9.0d0*ci*iymx*sq2/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*iymx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,3) = (-3.0d0)*ci*iymx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,3) = -3*iymx**2*z/sq2
       end do
    case (130)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq3*z/sq2/7.0d0
          sqy(ig,2,2) = ci*sq3*z/sq2/7.0d0
          sqy(ig,3,2) = iymx*sq3/sq2/7.0d0
          sqy(ig,1,3) = (-3.0d0)*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,3) = 3.0d0*ci*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,3) = 9.0d0*iymx*sq3*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (131)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-9.0d0)*sq6*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-3.0d0)*sq6*z*(7*z**2-3)/7.0d0
       end do
    case (132)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 15.0d0*z/(7.0d0*sq2)
          sqy(ig,2,2) = 15.0d0*ci*z/(7.0d0*sq2)
          sqy(ig,3,2) = 15.0d0*iypx/(7.0d0*sq2)
          sqy(ig,1,3) = 3.0d0*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,3) = 3.0d0*ci*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,3) = 9.0d0*iypx*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (133)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iymx**2*sq5*z/(2.0d0*sq2)
          sqy(ig,2,3) = (-9.0d0)*ci*iymx**2*sq5*z/(2.0d0*sq2)
          sqy(ig,3,3) = (-3.0d0)*iymx**3*sq5/(2.0d0*sq2)
       end do
    case (134)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iymx*sq2/7.0d0
          sqy(ig,2,2) = 3.0d0*ci*iymx*sq2/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-33.0d0)*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,3) = 33.0d0*ci*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,3) = 33.0d0*iymx**2*z/(2.0d0*sq2)
       end do
    case (135)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 6.0d0*z/7.0d0
          sqy(ig,2,2) = (-6.0d0)*ci*z/7.0d0
          sqy(ig,3,2) = (-6.0d0)*iymx/7.0d0
          sqy(ig,1,3) = 9.0d0*z*(7*z**2-3)/7.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*z*(7*z**2-3)/7.0d0
          sqy(ig,3,3) = (-27.0d0)*iymx*(7*z**2-1)/7.0d0
       end do
    case (136)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 12.0d0*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 39.0d0*z*(7*z**2-3)/7.0d0
       end do
    case (137)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3*iymx/sq6
          sqy(ig,2,1) = -3*ci*iymx/sq6
          sqy(ig,3,1) = 0
       end do
    case (138)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq6*z
          sqy(ig,2,1) = ci*sq6*z
          sqy(ig,3,1) = iymx*sq6
       end do
    case (139)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -9*iymx*z/sq6
          sqy(ig,2,2) = 9*ci*iymx*z/sq6
          sqy(ig,3,2) = 9.0d0*iymx**2/(2.0d0*sq6)
       end do
    case (140)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*sq6/5.0d0
          sqy(ig,2,1) = (-2.0d0)*ci*sq6/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*sq6*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq6*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = (-3.0d0)*iymx*sq6*z/2.0d0
       end do
    case (141)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*iymx**2/4.0d0
          sqy(ig,2,2) = 9.0d0*ci*iymx**2/4.0d0
          sqy(ig,3,2) = 0
       end do
    case (142)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3*iymx*sq3*z
          sqy(ig,2,2) = -3*ci*iymx*sq3*z
          sqy(ig,3,2) = (-3.0d0)*iymx**2*sq3/2.0d0
       end do
    case (143)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq3/5.0d0
          sqy(ig,2,1) = ci*sq3/5.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*sq3*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = 9.0d0*ci*sq3*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = 9.0d0*iymx*sq3*z/2.0d0
       end do
    case (144)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 6/5.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-9.0d0)*(5*z**2-1)/5.0d0
       end do
    case (145)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 27.0d0*iymx**2*z/4.0d0
          sqy(ig,2,3) = (-27.0d0)*ci*iymx**2*z/4.0d0
          sqy(ig,3,3) = (-9.0d0)*iymx**3/4.0d0
       end do
    case (146)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-8.0d0)*iymx*sq3/7.0d0
          sqy(ig,2,2) = 8.0d0*ci*iymx*sq3/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*iymx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,2,3) = 9.0d0*ci*iymx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,3,3) = 9.0d0*iymx**2*sq3*z/2.0d0
       end do
    case (147)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5.0d0*sq3*z/7.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z/7.0d0
          sqy(ig,3,2) = (-5.0d0)*iymx*sq3/7.0d0
          sqy(ig,1,3) = 9.0d0*sq3*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*sq3*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = (-27.0d0)*iymx*sq3*(7*z**2-1)/28.0d0
       end do
    case (148)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 6.0d0*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 9.0d0*z*(7*z**2-3)/7.0d0
       end do
    case (149)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*iymx**3*sq5/2.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iymx**3*sq5/2.0d0
          sqy(ig,3,3) = 0
       end do
    case (150)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -9*iymx**2*z
          sqy(ig,2,3) = 9*ci*iymx**2*z
          sqy(ig,3,3) = 3*iymx**3
       end do
    case (151)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iymx*sq2/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iymx*sq2/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 33.0d0*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,3) = (-33.0d0)*ci*iymx*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,3) = (-33.0d0)*iymx**2*z/(2.0d0*sq2)
       end do
    case (152)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*z*(7*z**2-3)/(2.0d0*sq2)
          sqy(ig,2,3) = 3.0d0*ci*z*(7*z**2-3)/(2.0d0*sq2)
          sqy(ig,3,3) = 9.0d0*iymx*(7*z**2-1)/(2.0d0*sq2)
       end do
    case (153)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 18.0d0*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-51.0d0)*z*(7*z**2-3)/14.0d0
       end do
    case (154)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (155)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*iymx*sq5/sq6
          sqy(ig,2,1) = 3*ci*iymx*sq5/sq6
          sqy(ig,3,1) = 0
       end do
    case (156)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iymx**2*sq30/4.0d0
          sqy(ig,2,2) = 3.0d0*ci*iymx**2*sq30/4.0d0
          sqy(ig,3,2) = 0
       end do
    case (157)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3*iymx*sq5*z/sq6
          sqy(ig,2,2) = -3*ci*iymx*sq5*z/sq6
          sqy(ig,3,2) = (-3.0d0)*iymx**2*sq5/(2.0d0*sq6)
       end do
    case (158)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (159)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iymx**2*sq15/4.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iymx**2*sq15/4.0d0
          sqy(ig,3,2) = 0
       end do
    case (160)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq15*z
          sqy(ig,2,2) = ci*iymx*sq15*z
          sqy(ig,3,2) = iymx**2*sq15/2.0d0
       end do
    case (161)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3/sq5
          sqy(ig,2,1) = 3*ci/sq5
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*(5*z**2-1)/(4.0d0*sq5)
          sqy(ig,2,2) = (-3.0d0)*ci*(5*z**2-1)/(4.0d0*sq5)
          sqy(ig,3,2) = (-3.0d0)*iymx*sq5*z/2.0d0
       end do
    case (162)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3*iymx**3*sq5
          sqy(ig,2,3) = -3*ci*iymx**3*sq5
          sqy(ig,3,3) = 0
       end do
    case (163)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*iymx**2*sq15*z/4.0d0
          sqy(ig,2,3) = 9.0d0*ci*iymx**2*sq15*z/4.0d0
          sqy(ig,3,3) = 3.0d0*iymx**3*sq15/4.0d0
       end do
    case (164)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*iymx*sq15/7.0d0
          sqy(ig,2,2) = 2.0d0*ci*iymx*sq15/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*iymx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iymx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,3,3) = (-3.0d0)*iymx**2*sq15*z/2.0d0
       end do
    case (165)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*sq5*z/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq5*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*iymx*sq5/7.0d0
          sqy(ig,1,3) = (-3.0d0)*sq5*z*(7*z**2-3)/28.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq5*z*(7*z**2-3)/28.0d0
          sqy(ig,3,3) = 9.0d0*iymx*sq5*(7*z**2-1)/28.0d0
       end do
    case (166)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
       end do
    case (167)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*iymx**3*sq5/2.0d0
          sqy(ig,2,3) = 3.0d0*ci*iymx**3*sq5/2.0d0
          sqy(ig,3,3) = 0
       end do
    case (168)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iymx**2*sq10*z/4.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*iymx**2*sq10*z/4.0d0
          sqy(ig,3,3) = (-3.0d0)*iymx**3*sq10/4.0d0
       end do
    case (169)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iymx*sq10/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iymx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*iymx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,3) = 9.0d0*ci*iymx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,3) = 9.0d0*iymx**2*sq5*z/(2.0d0*sq2)
       end do
    case (170)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-6.0d0)*sq5*z/7.0d0
          sqy(ig,2,2) = 6.0d0*ci*sq5*z/7.0d0
          sqy(ig,3,2) = 6.0d0*iymx*sq5/7.0d0
          sqy(ig,1,3) = 3.0d0*sq5*z*(7*z**2-3)/14.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*sq5*z*(7*z**2-3)/14.0d0
          sqy(ig,3,3) = (-9.0d0)*iymx*sq5*(7*z**2-1)/14.0d0
       end do
    case (171)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-30.0d0)*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 15.0d0*z*(7*z**2-3)/14.0d0
       end do
    case (172)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -iypx*sq30*z/2.0d0
          sqy(ig,2,1) = -ci*iypx*sq30*z/2.0d0
          sqy(ig,3,1) = -iypx**2*sq30/4.0d0
       end do
    case (173)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*iypx**2*sq5/(2.0d0*sq6)
          sqy(ig,2,1) = (-9.0d0)*ci*iypx**2*sq5/(2.0d0*sq6)
          sqy(ig,3,1) = 0
       end do
    case (174)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 5.0d0*iypx*sq30/14.0d0
          sqy(ig,2,1) = 5.0d0*ci*iypx*sq30/14.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq30*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = -ci*iypx*sq30*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = -iypx**2*sq30*z
       end do
    case (175)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iypx**2*sq30*z/2.0d0
          sqy(ig,2,2) = 3.0d0*ci*iypx**2*sq30*z/2.0d0
          sqy(ig,3,2) = iypx**3*sq30/2.0d0
       end do
    case (176)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq5*z/7.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*sq5*z/7.0d0
          sqy(ig,3,1) = (-3.0d0)*iypx*sq5/7.0d0
          sqy(ig,1,2) = 3.0d0*sq5*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = 3.0d0*ci*sq5*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = 9.0d0*iypx*sq5*(7*z**2-1)/28.0d0
       end do
    case (177)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-4.0d0)*iypx*sq15/7.0d0
          sqy(ig,2,1) = (-4.0d0)*ci*iypx*sq15/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = -ci*iypx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = -iypx**2*sq15*z/2.0d0
       end do
    case (178)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iypx**2*sq15*z/4.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iypx**2*sq15*z/4.0d0
          sqy(ig,3,2) = -iypx**3*sq15/4.0d0
       end do
    case (179)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3*iypx**3*sq5
          sqy(ig,2,2) = 3*ci*iypx**3*sq5
          sqy(ig,3,2) = 0
       end do
    case (180)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq5/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq5/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq5*(5*z**2-1)/4.0d0
          sqy(ig,2,2) = -ci*sq5*(5*z**2-1)/4.0d0
          sqy(ig,3,2) = (-5.0d0)*iypx*sq5*z/2.0d0
          sqy(ig,1,3) = sq5*(21*z**4-14*z**2+1)/14.0d0
          sqy(ig,2,3) = ci*sq5*(21*z**4-14*z**2+1)/14.0d0
          sqy(ig,3,3) = 2*iypx*sq5*z*(3*z**2-1)
       end do
    case (181)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq15*z
          sqy(ig,2,2) = ci*iypx*sq15*z
          sqy(ig,3,2) = iypx**2*sq15/2.0d0
          sqy(ig,1,3) = -iypx*sq15*z*(3*z**2-1)
          sqy(ig,2,3) = -ci*iypx*sq15*z*(3*z**2-1)
          sqy(ig,3,3) = -iypx**2*sq15*(3*z-1)*(3*z+1)/2.0d0
       end do
    case (182)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx**2*sq15/4.0d0
          sqy(ig,2,2) = -ci*iypx**2*sq15/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = iypx**2*sq15*(3*z-1)*(3*z+1)/2.0d0
          sqy(ig,2,3) = ci*iypx**2*sq15*(3*z-1)*(3*z+1)/2.0d0
          sqy(ig,3,3) = 3*iypx**3*sq15*z
       end do
    case (183)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -6*iypx**3*sq5*z
          sqy(ig,2,3) = -6*ci*iypx**3*sq5*z
          sqy(ig,3,3) = (-3.0d0)*iypx**4*sq5/2.0d0
       end do
    case (184)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-3)/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 5*z**2-1
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-25.0d0)*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (185)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq5/7.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*sq5/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*sq5*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq5*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = 3.0d0*iypx*sq5*z*(3*z**2-1)/2.0d0
       end do
    case (186)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq10*z
          sqy(ig,2,2) = -ci*iypx*sq10*z
          sqy(ig,3,2) = -iypx**2*sq5/sq2
          sqy(ig,1,3) = -iypx*sq5*z*(3*z**2-1)/sq2/2.0d0
          sqy(ig,2,3) = -ci*iypx*sq5*z*(3*z**2-1)/sq2/2.0d0
          sqy(ig,3,3) = -iypx**2*sq5*(3*z-1)*(3*z+1)/sq2/4.0d0
       end do
    case (187)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx**2*sq10
          sqy(ig,2,2) = ci*iypx**2*sq10
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -iypx**2*sq5*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,2,3) = -ci*iypx**2*sq5*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,3,3) = (-3.0d0)*iypx**3*sq5*z/(2.0d0*sq2)
       end do
    case (188)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iypx**3*sq5*z/2.0d0
          sqy(ig,2,3) = 9.0d0*ci*iypx**3*sq5*z/2.0d0
          sqy(ig,3,3) = 9.0d0*iypx**4*sq5/8.0d0
       end do
    case (189)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-75.0d0)*iypx**4/8.0d0
          sqy(ig,2,3) = (-75.0d0)*ci*iypx**4/8.0d0
          sqy(ig,3,3) = 0
       end do
    case (190)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-30.0d0)*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 375.0d0*z*(7*z**2-3)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-15.0d0)*z*(33*z**4-30*z**2+5)/22.0d0
       end do
    case (191)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq3*(5*z**2-1)/sq2/2.0d0
          sqy(ig,2,1) = -ci*sq3*(5*z**2-1)/sq2/2.0d0
          sqy(ig,3,1) = -5*iypx*sq3*z/sq2
       end do
    case (192)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-5.0d0)*iypx*sq6*z/2.0d0
          sqy(ig,2,1) = (-5.0d0)*ci*iypx*sq6*z/2.0d0
          sqy(ig,3,1) = (-5.0d0)*iypx**2*sq6/4.0d0
       end do
    case (193)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq6*z/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq6*z/7.0d0
          sqy(ig,3,1) = 3.0d0*iypx*sq6/7.0d0
          sqy(ig,1,2) = (-5.0d0)*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,3,2) = (-15.0d0)*iypx*sq3*(7*z**2-1)/(7.0d0*sq2)
       end do
    case (194)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iypx*sq3/(7.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci*iypx*sq3/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5.0d0*iypx*sq6*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = 5.0d0*ci*iypx*sq6*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = 5*iypx**2*sq6*z
       end do
    case (195)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-18.0d0)*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 15.0d0*z*(7*z**2-3)/7.0d0
       end do
    case (196)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*sq3*z/7.0d0
          sqy(ig,2,1) = (-9.0d0)*ci*sq3*z/7.0d0
          sqy(ig,3,1) = (-9.0d0)*iypx*sq3/7.0d0
          sqy(ig,1,2) = (-5.0d0)*sq3*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = (-15.0d0)*iypx*sq3*(7*z**2-1)/28.0d0
       end do
    case (197)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-6.0d0)*iypx*sq3/7.0d0
          sqy(ig,2,1) = (-6.0d0)*ci*iypx*sq3/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*iypx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*iypx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = (-5.0d0)*iypx**2*sq3*z/2.0d0
       end do
    case (198)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 45.0d0*iypx**2*z/4.0d0
          sqy(ig,2,2) = 45.0d0*ci*iypx**2*z/4.0d0
          sqy(ig,3,2) = 15.0d0*iypx**3/4.0d0
       end do
    case (199)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 18/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-11.0d0)*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 25.0d0*(21*z**4-14*z**2+1)/14.0d0
       end do
    case (200)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*sq3/35.0d0
          sqy(ig,2,1) = 9.0d0*ci*sq3/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*sq3*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = 3.0d0*ci*sq3*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = 3.0d0*iypx*sq3*z/2.0d0
          sqy(ig,1,3) = (-5.0d0)*sq3*(21*z**4-14*z**2+1)/14.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*sq3*(21*z**4-14*z**2+1)/14.0d0
          sqy(ig,3,3) = -10*iypx*sq3*z*(3*z**2-1)
       end do
    case (201)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq3*z
          sqy(ig,2,2) = ci*iypx*sq3*z
          sqy(ig,3,2) = iypx**2*sq3/2.0d0
          sqy(ig,1,3) = 5*iypx*sq3*z*(3*z**2-1)
          sqy(ig,2,3) = 5*ci*iypx*sq3*z*(3*z**2-1)
          sqy(ig,3,3) = 5.0d0*iypx**2*sq3*(3*z-1)*(3*z+1)/2.0d0
       end do
    case (202)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx**2/4.0d0
          sqy(ig,2,2) = -ci*iypx**2/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-5.0d0)*iypx**2*(3*z-1)*(3*z+1)/2.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*iypx**2*(3*z-1)*(3*z+1)/2.0d0
          sqy(ig,3,3) = -15*iypx**3*z
       end do
    case (203)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0/(7.0d0*sq5)
          sqy(ig,2,1) = (-3.0d0)*ci/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(5*z**2-1)/sq5
          sqy(ig,2,2) = ci*(5*z**2-1)/sq5
          sqy(ig,3,2) = 2*iymx*sq5*z
          sqy(ig,1,3) = 5.0d0*sq5*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*sq5*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = (-5.0d0)*iymx*sq5*z*(3*z**2-1)/2.0d0
       end do
    case (204)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-39)/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 3.0d0*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 75.0d0*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (205)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-24.0d0)*sq2/35.0d0
          sqy(ig,2,1) = (-24.0d0)*ci*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*sq2*(5*z**2-1)/5.0d0
          sqy(ig,2,2) = (-2.0d0)*ci*sq2*(5*z**2-1)/5.0d0
          sqy(ig,3,2) = -4*iypx*sq2*z
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*ci*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,3,3) = -5*iypx*z*(3*z**2-1)/sq2
       end do
    case (206)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq2*z
          sqy(ig,2,2) = ci*iypx*sq2*z
          sqy(ig,3,2) = iypx**2/sq2
          sqy(ig,1,3) = (-5.0d0)*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*ci*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*iypx**2*(3*z-1)*(3*z+1)/(4.0d0*sq2)
       end do
    case (207)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3*iypx**2
          sqy(ig,2,2) = 3*ci*iypx**2
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*iypx**2*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,2,3) = 15.0d0*ci*iypx**2*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,3,3) = 45.0d0*iypx**3*z/4.0d0
       end do
    case (208)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*iypx**3*sq5*z/2.0d0
          sqy(ig,2,3) = (-15.0d0)*ci*iypx**3*sq5*z/2.0d0
          sqy(ig,3,3) = (-15.0d0)*iypx**4*sq5/8.0d0
       end do
    case (209)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*sq5*z/7.0d0
          sqy(ig,2,2) = (-4.0d0)*ci*sq5*z/7.0d0
          sqy(ig,3,2) = (-4.0d0)*iymx*sq5/7.0d0
          sqy(ig,1,3) = (-57.0d0)*sq5*z*(7*z**2-3)/154.0d0
          sqy(ig,2,3) = 57.0d0*ci*sq5*z*(7*z**2-3)/154.0d0
          sqy(ig,3,3) = 171.0d0*iymx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 5.0d0*sq5*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*sq5*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,3,4) = (-25.0d0)*iymx*sq5*(33*z**4-18*z**2+1)/44.0d0
       end do
    case (210)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-6.0d0)*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-555.0d0)*z*(7*z**2-3)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 75.0d0*z*(33*z**4-30*z**2+5)/22.0d0
       end do
    case (211)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-3.0d0)*sq3*(5*z**2-1)/2.0d0
       end do
    case (212)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq3*(5*z**2-1)/2.0d0
          sqy(ig,2,1) = -ci*sq3*(5*z**2-1)/2.0d0
          sqy(ig,3,1) = -5*iypx*sq3*z
       end do
    case (213)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*sq3*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-20.0d0)*sq3*z*(7*z**2-3)/7.0d0
       end do
    case (214)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3*z/7.0d0
          sqy(ig,2,1) = ci*sq3*z/7.0d0
          sqy(ig,3,1) = iypx*sq3/7.0d0
          sqy(ig,1,2) = 5.0d0*sq3*z*(7*z**2-3)/7.0d0
          sqy(ig,2,2) = 5.0d0*ci*sq3*z*(7*z**2-3)/7.0d0
          sqy(ig,3,2) = 15.0d0*iypx*sq3*(7*z**2-1)/7.0d0
       end do
    case (215)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*z/(7.0d0*sq2)
          sqy(ig,2,1) = (-9.0d0)*ci*z/(7.0d0*sq2)
          sqy(ig,3,1) = (-9.0d0)*iymx/(7.0d0*sq2)
          sqy(ig,1,2) = (-15.0d0)*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = 15.0d0*ci*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = 45.0d0*iymx*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (216)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-15.0d0)*sq6*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-5.0d0)*sq6*z*(7*z**2-3)/7.0d0
       end do
    case (217)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-11.0d0)*sq3*z/(7.0d0*sq2)
          sqy(ig,2,1) = (-11.0d0)*ci*sq3*z/(7.0d0*sq2)
          sqy(ig,3,1) = (-11.0d0)*iypx*sq3/(7.0d0*sq2)
          sqy(ig,1,2) = (-5.0d0)*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = (-15.0d0)*iypx*sq3*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (218)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*iypx*sq2/7.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*iypx*sq2/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 15.0d0*iypx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,2) = 15.0d0*ci*iypx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,2) = 15*iypx**2*z/sq2
       end do
    case (219)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)/(35.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci/(35.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 7.0d0*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = (-7.0d0)*ci*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = -7*iymx*z/sq2
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/(7.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*ci*(21*z**4-14*z**2+1)/(7.0d0*sq2)
          sqy(ig,3,3) = 10*iymx*sq2*z*(3*z**2-1)
       end do
    case (220)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*sq6/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -sq6*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-75.0d0)*(21*z**4-14*z**2+1)/(7.0d0*sq6)
       end do
    case (221)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0/(35.0d0*sq6)
          sqy(ig,2,1) = 9.0d0*ci/(35.0d0*sq6)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = 3.0d0*ci*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = 3*iypx*sq3*z/sq2
          sqy(ig,1,3) = 5.0d0*sq3*(21*z**4-14*z**2+1)/(7.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*ci*sq3*(21*z**4-14*z**2+1)/(7.0d0*sq2)
          sqy(ig,3,3) = 10*iypx*sq6*z*(3*z**2-1)
       end do
    case (222)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq2*z
          sqy(ig,2,2) = ci*iypx*sq2*z
          sqy(ig,3,2) = iypx**2/sq2
          sqy(ig,1,3) = -5*iypx*sq2*z*(3*z**2-1)
          sqy(ig,2,3) = -5*ci*iypx*sq2*z*(3*z**2-1)
          sqy(ig,3,3) = -5*iypx**2*(3*z-1)*(3*z+1)/sq2
       end do
    case (223)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq10*z
          sqy(ig,2,2) = ci*iymx*sq10*z
          sqy(ig,3,2) = iymx**2*sq10/2.0d0
          sqy(ig,1,3) = 5.0d0*iymx*sq10*z*(3*z**2-1)/4.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*iymx*sq10*z*(3*z**2-1)/4.0d0
          sqy(ig,3,3) = (-5.0d0)*iymx**2*sq10*(3*z-1)*(3*z+1)/8.0d0
       end do
    case (224)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 12.0d0*sq2/35.0d0
          sqy(ig,2,1) = (-12.0d0)*ci*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*(5*z**2-1)/(5.0d0*sq2)
          sqy(ig,2,2) = 3.0d0*ci*(5*z**2-1)/(5.0d0*sq2)
          sqy(ig,3,2) = 3*iymx*sq2*z
          sqy(ig,1,3) = (-15.0d0)*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,2,3) = 15.0d0*ci*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,3,3) = 15*iymx*z*(3*z**2-1)/sq2
       end do
    case (225)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-51)/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-8.0d0)*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-25.0d0)*(21*z**4-14*z**2+1)/28.0d0
       end do
    case (226)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-27)/35.0d0
          sqy(ig,2,1) = (-27.0d0)*ci/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(5*z**2-1)/5.0d0
          sqy(ig,2,2) = -ci*(5*z**2-1)/5.0d0
          sqy(ig,3,2) = -2*iypx*z
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/28.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*(21*z**4-14*z**2+1)/28.0d0
          sqy(ig,3,3) = -5*iypx*z*(3*z**2-1)
       end do
    case (227)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3*iypx*sq2*z
          sqy(ig,2,2) = 3*ci*iypx*sq2*z
          sqy(ig,3,2) = 3*iypx**2/sq2
          sqy(ig,1,3) = 15.0d0*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = 15.0d0*ci*iypx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*iypx**2*(3*z-1)*(3*z+1)/(4.0d0*sq2)
       end do
    case (228)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx**2*sq5/sq2
          sqy(ig,2,2) = ci*iypx**2*sq5/sq2
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-5.0d0)*iypx**2*sq5*(3*z-1)*(3*z+1)/(4.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*ci*iypx**2*sq5*(3*z-1)*(3*z+1)/(4.0d0*sq2)
          sqy(ig,3,3) = (-15.0d0)*iypx**3*sq5*z/(2.0d0*sq2)
       end do
    case (229)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq10/7.0d0
          sqy(ig,2,2) = -ci*iymx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-117.0d0)*iymx*sq5*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,2,3) = 117.0d0*ci*iymx*sq5*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,3,3) = 117.0d0*iymx**2*sq5*z/(22.0d0*sq2)
          sqy(ig,1,4) = 5.0d0*iymx*sq10*(33*z**4-18*z**2+1)/22.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*iymx*sq10*(33*z**4-18*z**2+1)/22.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**2*sq10*z*(11*z**2-3)/11.0d0
       end do
    case (230)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*sq2*z/7.0d0
          sqy(ig,2,2) = (-4.0d0)*ci*sq2*z/7.0d0
          sqy(ig,3,2) = (-4.0d0)*iymx*sq2/7.0d0
          sqy(ig,1,3) = 75.0d0*z*(7*z**2-3)/(154.0d0*sq2)
          sqy(ig,2,3) = (-75.0d0)*ci*z*(7*z**2-3)/(154.0d0*sq2)
          sqy(ig,3,3) = (-225.0d0)*iymx*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,1,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/(22.0d0*sq2)
          sqy(ig,2,4) = 25.0d0*ci*z*(33*z**4-30*z**2+5)/(22.0d0*sq2)
          sqy(ig,3,4) = 125.0d0*iymx*(33*z**4-18*z**2+1)/(22.0d0*sq2)
       end do
    case (231)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-15.0d0)*z*(7*z**2-3)/11.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-75.0d0)*z*(33*z**4-30*z**2+5)/11.0d0
       end do
    case (232)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3*(5*z**2-1)/2.0d0
          sqy(ig,2,1) = -ci*sq3*(5*z**2-1)/2.0d0
          sqy(ig,3,1) = -5*iymx*sq3*z
       end do
    case (233)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-3.0d0)*sq3*(5*z**2-1)/2.0d0
       end do
    case (234)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3*z/7.0d0
          sqy(ig,2,1) = -ci*sq3*z/7.0d0
          sqy(ig,3,1) = -iymx*sq3/7.0d0
          sqy(ig,1,2) = 5.0d0*sq3*z*(7*z**2-3)/7.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z*(7*z**2-3)/7.0d0
          sqy(ig,3,2) = (-15.0d0)*iymx*sq3*(7*z**2-1)/7.0d0
       end do
    case (235)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-3.0d0)*sq3*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 20.0d0*sq3*z*(7*z**2-3)/7.0d0
       end do
    case (236)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iymx*sq2/7.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*iymx*sq2/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-15.0d0)*iymx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,2,2) = 15.0d0*ci*iymx*(7*z**2-1)/(7.0d0*sq2)
          sqy(ig,3,2) = 15*iymx**2*z/sq2
       end do
    case (237)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 11.0d0*sq3*z/(7.0d0*sq2)
          sqy(ig,2,1) = (-11.0d0)*ci*sq3*z/(7.0d0*sq2)
          sqy(ig,3,1) = (-11.0d0)*iymx*sq3/(7.0d0*sq2)
          sqy(ig,1,2) = 5.0d0*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = (-15.0d0)*iymx*sq3*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (238)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-15.0d0)*sq6*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-5.0d0)*sq6*z*(7*z**2-3)/7.0d0
       end do
    case (239)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*z/(7.0d0*sq2)
          sqy(ig,2,1) = (-9.0d0)*ci*z/(7.0d0*sq2)
          sqy(ig,3,1) = (-9.0d0)*iypx/(7.0d0*sq2)
          sqy(ig,1,2) = 15.0d0*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = 15.0d0*ci*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = 45.0d0*iypx*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (240)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq2*z
          sqy(ig,2,2) = -ci*iymx*sq2*z
          sqy(ig,3,2) = -iymx**2/sq2
          sqy(ig,1,3) = -5*iymx*sq2*z*(3*z**2-1)
          sqy(ig,2,3) = 5*ci*iymx*sq2*z*(3*z**2-1)
          sqy(ig,3,3) = 5*iymx**2*(3*z-1)*(3*z+1)/sq2
       end do
    case (241)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq3/(35.0d0*sq2)
          sqy(ig,2,1) = (-3.0d0)*ci*sq3/(35.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = (-3.0d0)*ci*sq3*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = -3*iymx*sq3*z/sq2
          sqy(ig,1,3) = 5.0d0*sq3*(21*z**4-14*z**2+1)/(7.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*ci*sq3*(21*z**4-14*z**2+1)/(7.0d0*sq2)
          sqy(ig,3,3) = -10*iymx*sq6*z*(3*z**2-1)
       end do
    case (242)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-3.0d0)*sq6/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = sq6*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 75.0d0*(21*z**4-14*z**2+1)/(7.0d0*sq6)
       end do
    case (243)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)/(35.0d0*sq2)
          sqy(ig,2,1) = (-3.0d0)*ci/(35.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 7.0d0*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,2,2) = 7.0d0*ci*(5*z**2-1)/(10.0d0*sq2)
          sqy(ig,3,2) = 7*iypx*z/sq2
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/(7.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*ci*(21*z**4-14*z**2+1)/(7.0d0*sq2)
          sqy(ig,3,3) = -10*iypx*sq2*z*(3*z**2-1)
       end do
    case (244)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx**2*sq10/2.0d0
          sqy(ig,2,2) = ci*iymx**2*sq10/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 5.0d0*iymx**2*sq10*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*iymx**2*sq10*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,3,3) = (-15.0d0)*iymx**3*sq10*z/4.0d0
       end do
    case (245)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -3*iymx*sq2*z
          sqy(ig,2,2) = 3*ci*iymx*sq2*z
          sqy(ig,3,2) = 3*iymx**2/sq2
          sqy(ig,1,3) = (-15.0d0)*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = 15.0d0*ci*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*iymx**2*(3*z-1)*(3*z+1)/(4.0d0*sq2)
       end do
    case (246)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 27/35.0d0
          sqy(ig,2,1) = (-27.0d0)*ci/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2-1)/5.0d0
          sqy(ig,2,2) = -ci*(5*z**2-1)/5.0d0
          sqy(ig,3,2) = -2*iymx*z
          sqy(ig,1,3) = 5.0d0*(21*z**4-14*z**2+1)/28.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*(21*z**4-14*z**2+1)/28.0d0
          sqy(ig,3,3) = -5*iymx*z*(3*z**2-1)
       end do
    case (247)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-51)/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-8.0d0)*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-25.0d0)*(21*z**4-14*z**2+1)/28.0d0
       end do
    case (248)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-12.0d0)*sq2/35.0d0
          sqy(ig,2,1) = (-12.0d0)*ci*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*(5*z**2-1)/(5.0d0*sq2)
          sqy(ig,2,2) = 3.0d0*ci*(5*z**2-1)/(5.0d0*sq2)
          sqy(ig,3,2) = 3*iypx*sq2*z
          sqy(ig,1,3) = 15.0d0*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,2,3) = 15.0d0*ci*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,3,3) = 15*iypx*z*(3*z**2-1)/sq2
       end do
    case (249)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq10*z
          sqy(ig,2,2) = ci*iypx*sq10*z
          sqy(ig,3,2) = iypx**2*sq5/sq2
          sqy(ig,1,3) = (-5.0d0)*iypx*sq5*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*ci*iypx*sq5*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*iypx**2*sq5*(3*z-1)*(3*z+1)/(4.0d0*sq2)
       end do
    case (250)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-63.0d0)*iymx**2*sq10*z/44.0d0
          sqy(ig,2,3) = 63.0d0*ci*iymx**2*sq10*z/44.0d0
          sqy(ig,3,3) = 21.0d0*iymx**3*sq10/44.0d0
          sqy(ig,1,4) = 45.0d0*iymx**2*sq10*z*(11*z**2-3)/44.0d0
          sqy(ig,2,4) = (-45.0d0)*ci*iymx**2*sq10*z*(11*z**2-3)/44.0d0
          sqy(ig,3,4) = (-45.0d0)*iymx**3*sq10*(11*z**2-1)/44.0d0
       end do
    case (251)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq2/7.0d0
          sqy(ig,2,2) = -ci*iymx*sq2/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-75.0d0)*iymx*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,2,3) = 75.0d0*ci*iymx*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,3,3) = 75.0d0*iymx**2*z/(22.0d0*sq2)
          sqy(ig,1,4) = (-25.0d0)*iymx*(33*z**4-18*z**2+1)/(11.0d0*sq2)
          sqy(ig,2,4) = 25.0d0*ci*iymx*(33*z**4-18*z**2+1)/(11.0d0*sq2)
          sqy(ig,3,4) = 75.0d0*iymx**2*sq2*z*(11*z**2-3)/11.0d0
       end do
    case (252)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*z/7.0d0
          sqy(ig,2,2) = (-4.0d0)*ci*z/7.0d0
          sqy(ig,3,2) = (-4.0d0)*iymx/7.0d0
          sqy(ig,1,3) = 45.0d0*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = (-45.0d0)*ci*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = (-135.0d0)*iymx*(7*z**2-1)/77.0d0
          sqy(ig,1,4) = 25.0d0*z*(33*z**4-30*z**2+5)/22.0d0
          sqy(ig,2,4) = (-25.0d0)*ci*z*(33*z**4-30*z**2+5)/22.0d0
          sqy(ig,3,4) = (-125.0d0)*iymx*(33*z**4-18*z**2+1)/22.0d0
       end do
    case (253)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 15.0d0*z*(7*z**2-3)/11.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 75.0d0*z*(33*z**4-30*z**2+5)/11.0d0
       end do
    case (254)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 15*iymx*z/sq6
          sqy(ig,2,1) = -15*ci*iymx*z/sq6
          sqy(ig,3,1) = (-15.0d0)*iymx**2/(2.0d0*sq6)
       end do
    case (255)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = sq3*(5*z**2-1)/sq2/2.0d0
          sqy(ig,2,1) = -ci*sq3*(5*z**2-1)/sq2/2.0d0
          sqy(ig,3,1) = -5*iymx*sq3*z/sq2
       end do
    case (256)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iymx*sq3/(7.0d0*sq2)
          sqy(ig,2,1) = (-3.0d0)*ci*iymx*sq3/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5.0d0*iymx*sq6*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*iymx*sq6*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = -5*iymx**2*sq6*z
       end do
    case (257)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq6*z/7.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*sq6*z/7.0d0
          sqy(ig,3,1) = (-3.0d0)*iymx*sq6/7.0d0
          sqy(ig,1,2) = (-5.0d0)*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,2,2) = 5.0d0*ci*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,3,2) = 15.0d0*iymx*sq3*(7*z**2-1)/(7.0d0*sq2)
       end do
    case (258)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-45.0d0)*iymx**2*z/4.0d0
          sqy(ig,2,2) = 45.0d0*ci*iymx**2*z/4.0d0
          sqy(ig,3,2) = 15.0d0*iymx**3/4.0d0
       end do
    case (259)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*iymx*sq3/7.0d0
          sqy(ig,2,1) = (-6.0d0)*ci*iymx*sq3/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5.0d0*iymx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*iymx*sq3*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = (-5.0d0)*iymx**2*sq3*z/2.0d0
       end do
    case (260)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*sq3*z/7.0d0
          sqy(ig,2,1) = (-9.0d0)*ci*sq3*z/7.0d0
          sqy(ig,3,1) = (-9.0d0)*iymx*sq3/7.0d0
          sqy(ig,1,2) = 5.0d0*sq3*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = (-15.0d0)*iymx*sq3*(7*z**2-1)/28.0d0
       end do
    case (261)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-18.0d0)*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 15.0d0*z*(7*z**2-3)/7.0d0
       end do
    case (262)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx**2/4.0d0
          sqy(ig,2,2) = ci*iymx**2/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-5.0d0)*iymx**2*(3*z-1)*(3*z+1)/2.0d0
          sqy(ig,2,3) = 5.0d0*ci*iymx**2*(3*z-1)*(3*z+1)/2.0d0
          sqy(ig,3,3) = 15*iymx**3*z
       end do
    case (263)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq3*z
          sqy(ig,2,2) = -ci*iymx*sq3*z
          sqy(ig,3,2) = -iymx**2*sq3/2.0d0
          sqy(ig,1,3) = 5*iymx*sq3*z*(3*z**2-1)
          sqy(ig,2,3) = -5*ci*iymx*sq3*z*(3*z**2-1)
          sqy(ig,3,3) = (-5.0d0)*iymx**2*sq3*(3*z-1)*(3*z+1)/2.0d0
       end do
    case (264)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*sq3/35.0d0
          sqy(ig,2,1) = (-9.0d0)*ci*sq3/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*sq3*(5*z**2-1)/20.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq3*(5*z**2-1)/20.0d0
          sqy(ig,3,2) = (-3.0d0)*iymx*sq3*z/2.0d0
          sqy(ig,1,3) = (-5.0d0)*sq3*(21*z**4-14*z**2+1)/14.0d0
          sqy(ig,2,3) = 5.0d0*ci*sq3*(21*z**4-14*z**2+1)/14.0d0
          sqy(ig,3,3) = 10*iymx*sq3*z*(3*z**2-1)
       end do
    case (265)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-18)/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 11.0d0*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-25.0d0)*(21*z**4-14*z**2+1)/14.0d0
       end do
    case (266)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*iymx**3*sq5*z/2.0d0
          sqy(ig,2,3) = (-15.0d0)*ci*iymx**3*sq5*z/2.0d0
          sqy(ig,3,3) = (-15.0d0)*iymx**4*sq5/8.0d0
       end do
    case (267)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -3*iymx**2
          sqy(ig,2,2) = 3*ci*iymx**2
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*iymx**2*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,2,3) = 15.0d0*ci*iymx**2*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,3,3) = 45.0d0*iymx**3*z/4.0d0
       end do
    case (268)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq2*z
          sqy(ig,2,2) = ci*iymx*sq2*z
          sqy(ig,3,2) = iymx**2/sq2
          sqy(ig,1,3) = 5.0d0*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*ci*iymx*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*iymx**2*(3*z-1)*(3*z+1)/(4.0d0*sq2)
       end do
    case (269)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 24.0d0*sq2/35.0d0
          sqy(ig,2,1) = (-24.0d0)*ci*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*sq2*(5*z**2-1)/5.0d0
          sqy(ig,2,2) = (-2.0d0)*ci*sq2*(5*z**2-1)/5.0d0
          sqy(ig,3,2) = -4*iymx*sq2*z
          sqy(ig,1,3) = 5.0d0*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*ci*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,3,3) = -5*iymx*z*(3*z**2-1)/sq2
       end do
    case (270)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-39)/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 3.0d0*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 75.0d0*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (271)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)/(7.0d0*sq5)
          sqy(ig,2,1) = (-3.0d0)*ci/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2-1)/sq5
          sqy(ig,2,2) = ci*(5*z**2-1)/sq5
          sqy(ig,3,2) = 2*iypx*sq5*z
          sqy(ig,1,3) = (-5.0d0)*sq5*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*sq5*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = (-5.0d0)*iypx*sq5*z*(3*z**2-1)/2.0d0
       end do
    case (272)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*iymx**3*sq5/22.0d0
          sqy(ig,2,3) = 3.0d0*ci*iymx**3*sq5/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 15.0d0*iymx**3*sq5*(11*z**2-1)/11.0d0
          sqy(ig,2,4) = (-15.0d0)*ci*iymx**3*sq5*(11*z**2-1)/11.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**4*sq5*z/2.0d0
       end do
    case (273)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*iymx**2*z/11.0d0
          sqy(ig,2,3) = 45.0d0*ci*iymx**2*z/11.0d0
          sqy(ig,3,3) = 15.0d0*iymx**3/11.0d0
          sqy(ig,1,4) = (-225.0d0)*iymx**2*z*(11*z**2-3)/44.0d0
          sqy(ig,2,4) = 225.0d0*ci*iymx**2*z*(11*z**2-3)/44.0d0
          sqy(ig,3,4) = 225.0d0*iymx**3*(11*z**2-1)/44.0d0
       end do
    case (274)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq2/7.0d0
          sqy(ig,2,2) = ci*iymx*sq2/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 75.0d0*iymx*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,2,3) = (-75.0d0)*ci*iymx*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,3,3) = (-75.0d0)*iymx**2*z/(22.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*iymx*(33*z**4-18*z**2+1)/(11.0d0*sq2)
          sqy(ig,2,4) = (-25.0d0)*ci*iymx*(33*z**4-18*z**2+1)/(11.0d0*sq2)
          sqy(ig,3,4) = (-75.0d0)*iymx**2*sq2*z*(11*z**2-3)/11.0d0
       end do
    case (275)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*sq2*z/7.0d0
          sqy(ig,2,2) = (-4.0d0)*ci*sq2*z/7.0d0
          sqy(ig,3,2) = (-4.0d0)*iymx*sq2/7.0d0
          sqy(ig,1,3) = 75.0d0*z*(7*z**2-3)/(154.0d0*sq2)
          sqy(ig,2,3) = (-75.0d0)*ci*z*(7*z**2-3)/(154.0d0*sq2)
          sqy(ig,3,3) = (-225.0d0)*iymx*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,1,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/(22.0d0*sq2)
          sqy(ig,2,4) = 25.0d0*ci*z*(33*z**4-30*z**2+5)/(22.0d0*sq2)
          sqy(ig,3,4) = 125.0d0*iymx*(33*z**4-18*z**2+1)/(22.0d0*sq2)
       end do
    case (276)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 6.0d0*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 555.0d0*z*(7*z**2-3)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-75.0d0)*z*(33*z**4-30*z**2+5)/22.0d0
       end do
    case (277)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*iymx**2*sq5/(2.0d0*sq6)
          sqy(ig,2,1) = (-9.0d0)*ci*iymx**2*sq5/(2.0d0*sq6)
          sqy(ig,3,1) = 0
       end do
    case (278)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 15*iymx*z/sq30
          sqy(ig,2,1) = -15*ci*iymx*z/sq30
          sqy(ig,3,1) = (-15.0d0)*iymx**2/(2.0d0*sq30)
       end do
    case (279)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iymx**2*sq30*z/2.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iymx**2*sq30*z/2.0d0
          sqy(ig,3,2) = -iymx**3*sq30/2.0d0
       end do
    case (280)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 5.0d0*iymx*sq30/14.0d0
          sqy(ig,2,1) = (-5.0d0)*ci*iymx*sq30/14.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq30*(7*z**2-1)/7.0d0
          sqy(ig,2,2) = ci*iymx*sq30*(7*z**2-1)/7.0d0
          sqy(ig,3,2) = iymx**2*sq30*z
       end do
    case (281)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -3*iymx**3*sq5
          sqy(ig,2,2) = 3*ci*iymx**3*sq5
          sqy(ig,3,2) = 0
       end do
    case (282)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iymx**2*sq15*z/4.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iymx**2*sq15*z/4.0d0
          sqy(ig,3,2) = -iymx**3*sq15/4.0d0
       end do
    case (283)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 4.0d0*iymx*sq15/7.0d0
          sqy(ig,2,1) = (-4.0d0)*ci*iymx*sq15/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = -ci*iymx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = -iymx**2*sq15*z/2.0d0
       end do
    case (284)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq5*z/7.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*sq5*z/7.0d0
          sqy(ig,3,1) = (-3.0d0)*iymx*sq5/7.0d0
          sqy(ig,1,2) = (-3.0d0)*sq5*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = 3.0d0*ci*sq5*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = 9.0d0*iymx*sq5*(7*z**2-1)/28.0d0
       end do
    case (285)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -6*iymx**3*sq5*z
          sqy(ig,2,3) = 6*ci*iymx**3*sq5*z
          sqy(ig,3,3) = 3.0d0*iymx**4*sq5/2.0d0
       end do
    case (286)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx**2*sq15/4.0d0
          sqy(ig,2,2) = ci*iymx**2*sq15/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = iymx**2*sq15*(3*z-1)*(3*z+1)/2.0d0
          sqy(ig,2,3) = -ci*iymx**2*sq15*(3*z-1)*(3*z+1)/2.0d0
          sqy(ig,3,3) = -3*iymx**3*sq15*z
       end do
    case (287)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq15*z
          sqy(ig,2,2) = -ci*iymx*sq15*z
          sqy(ig,3,2) = -iymx**2*sq15/2.0d0
          sqy(ig,1,3) = -iymx*sq15*z*(3*z**2-1)
          sqy(ig,2,3) = ci*iymx*sq15*z*(3*z**2-1)
          sqy(ig,3,3) = iymx**2*sq15*(3*z-1)*(3*z+1)/2.0d0
       end do
    case (288)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq5/7.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*sq5/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq5*(5*z**2-1)/4.0d0
          sqy(ig,2,2) = ci*sq5*(5*z**2-1)/4.0d0
          sqy(ig,3,2) = 5.0d0*iymx*sq5*z/2.0d0
          sqy(ig,1,3) = sq5*(21*z**4-14*z**2+1)/14.0d0
          sqy(ig,2,3) = -ci*sq5*(21*z**4-14*z**2+1)/14.0d0
          sqy(ig,3,3) = -2*iymx*sq5*z*(3*z**2-1)
       end do
    case (289)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 75.0d0*iymx**4/8.0d0
          sqy(ig,2,3) = (-75.0d0)*ci*iymx**4/8.0d0
          sqy(ig,3,3) = 0
       end do
    case (290)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*iymx**3*sq5*z/2.0d0
          sqy(ig,2,3) = 9.0d0*ci*iymx**3*sq5*z/2.0d0
          sqy(ig,3,3) = 9.0d0*iymx**4*sq5/8.0d0
       end do
    case (291)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx**2*sq10
          sqy(ig,2,2) = ci*iymx**2*sq10
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = iymx**2*sq5*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,2,3) = -ci*iymx**2*sq5*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,3,3) = (-3.0d0)*iymx**3*sq5*z/(2.0d0*sq2)
       end do
    case (292)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq10*z
          sqy(ig,2,2) = -ci*iymx*sq10*z
          sqy(ig,3,2) = -iymx**2*sq5/sq2
          sqy(ig,1,3) = iymx*sq5*z*(3*z**2-1)/sq2/2.0d0
          sqy(ig,2,3) = -ci*iymx*sq5*z*(3*z**2-1)/sq2/2.0d0
          sqy(ig,3,3) = -iymx**2*sq5*(3*z-1)*(3*z+1)/sq2/4.0d0
       end do
    case (293)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq5/7.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*sq5/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*sq5*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq5*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = 3.0d0*iymx*sq5*z*(3*z**2-1)/2.0d0
       end do
    case (294)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-3)/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 5*z**2-1
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-25.0d0)*(21*z**4-14*z**2+1)/56.0d0
       end do
    case (295)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 75.0d0*iymx**4*z/4.0d0
          sqy(ig,2,4) = (-75.0d0)*ci*iymx**4*z/4.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**5/4.0d0
       end do
    case (296)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*iymx**3*sq5/22.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iymx**3*sq5/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-15.0d0)*iymx**3*sq5*(11*z**2-1)/11.0d0
          sqy(ig,2,4) = 15.0d0*ci*iymx**3*sq5*(11*z**2-1)/11.0d0
          sqy(ig,3,4) = 15.0d0*iymx**4*sq5*z/2.0d0
       end do
    case (297)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-63.0d0)*iymx**2*sq5*z/(22.0d0*sq2)
          sqy(ig,2,3) = 63.0d0*ci*iymx**2*sq5*z/(22.0d0*sq2)
          sqy(ig,3,3) = 21.0d0*iymx**3*sq5/(22.0d0*sq2)
          sqy(ig,1,4) = 45.0d0*iymx**2*sq5*z*(11*z**2-3)/(22.0d0*sq2)
          sqy(ig,2,4) = (-45.0d0)*ci*iymx**2*sq5*z*(11*z**2-3)/(22.0d0*sq2)
          sqy(ig,3,4) = (-45.0d0)*iymx**3*sq5*(11*z**2-1)/(22.0d0*sq2)
       end do
    case (298)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq10/7.0d0
          sqy(ig,2,2) = ci*iymx*sq10/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 117.0d0*iymx*sq5*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,2,3) = (-117.0d0)*ci*iymx*sq5*(7*z**2-1)/(154.0d0*sq2)
          sqy(ig,3,3) = (-117.0d0)*iymx**2*sq5*z/(22.0d0*sq2)
          sqy(ig,1,4) = (-5.0d0)*iymx*sq5*(33*z**4-18*z**2+1)/(11.0d0*sq2)
          sqy(ig,2,4) = 5.0d0*ci*iymx*sq5*(33*z**4-18*z**2+1)/(11.0d0*sq2)
          sqy(ig,3,4) = 15.0d0*iymx**2*sq10*z*(11*z**2-3)/11.0d0
       end do
    case (299)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*sq5*z/7.0d0
          sqy(ig,2,2) = (-4.0d0)*ci*sq5*z/7.0d0
          sqy(ig,3,2) = (-4.0d0)*iymx*sq5/7.0d0
          sqy(ig,1,3) = (-57.0d0)*sq5*z*(7*z**2-3)/154.0d0
          sqy(ig,2,3) = 57.0d0*ci*sq5*z*(7*z**2-3)/154.0d0
          sqy(ig,3,3) = 171.0d0*iymx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 5.0d0*sq5*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*sq5*z*(33*z**4-30*z**2+5)/44.0d0
          sqy(ig,3,4) = (-25.0d0)*iymx*sq5*(33*z**4-18*z**2+1)/44.0d0
       end do
    case (300)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 30.0d0*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-375.0d0)*z*(7*z**2-3)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 15.0d0*z*(33*z**4-30*z**2+5)/22.0d0
       end do
    case (301)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*iypx**2*sq35/4.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*iypx**2*sq35/4.0d0
          sqy(ig,3,1) = 0
       end do
    case (302)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (303)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iypx**2*sq35*z/4.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iypx**2*sq35*z/4.0d0
          sqy(ig,3,2) = -iypx**3*sq35/4.0d0
       end do
    case (304)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx**3*sq35
          sqy(ig,2,2) = ci*iypx**3*sq35
          sqy(ig,3,2) = 0
       end do
    case (305)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*iypx*sq105/(7.0d0*sq2)
          sqy(ig,2,1) = (-3.0d0)*ci*iypx*sq105/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq105*(7*z**2-1)/sq2/14.0d0
          sqy(ig,2,2) = ci*iypx*sq105*(7*z**2-1)/sq2/14.0d0
          sqy(ig,3,2) = iypx**2*sq105*z/sq2/2.0d0
       end do
    case (306)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iypx**2*sq35*z/(2.0d0*sq2)
          sqy(ig,2,2) = (-3.0d0)*ci*iypx**2*sq35*z/(2.0d0*sq2)
          sqy(ig,3,2) = -iypx**3*sq35/sq2/2.0d0
       end do
    case (307)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx**3*sq35/sq2
          sqy(ig,2,2) = ci*iypx**3*sq35/sq2
          sqy(ig,3,2) = 0
       end do
    case (308)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (309)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq105*z/sq2/3.0d0
          sqy(ig,2,2) = -ci*iypx*sq105*z/sq2/3.0d0
          sqy(ig,3,2) = -iypx**2*sq105/sq2/6.0d0
          sqy(ig,1,3) = iypx*sq105*z*(3*z**2-1)/sq2/6.0d0
          sqy(ig,2,3) = ci*iypx*sq105*z*(3*z**2-1)/sq2/6.0d0
          sqy(ig,3,3) = iypx**2*sq105*(3*z-1)*(3*z+1)/sq2/12.0d0
       end do
    case (310)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx**2*sq35/sq2/2.0d0
          sqy(ig,2,2) = ci*iypx**2*sq35/sq2/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -iypx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,2,3) = -ci*iypx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,3,3) = (-3.0d0)*iypx**3*sq35*z/(2.0d0*sq2)
       end do
    case (311)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3*iypx**3*sq35*z/sq2
          sqy(ig,2,3) = 3*ci*iypx**3*sq35*z/sq2
          sqy(ig,3,3) = 3.0d0*iypx**4*sq35/(4.0d0*sq2)
       end do
    case (312)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*iypx**4*sq35/(4.0d0*sq6)
          sqy(ig,2,3) = (-15.0d0)*ci*iypx**4*sq35/(4.0d0*sq6)
          sqy(ig,3,3) = 0
       end do
    case (313)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq6/(2.0d0*sq7)
          sqy(ig,2,1) = (-3.0d0)*ci*sq6/(2.0d0*sq7)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq7*(5*z**2-1)/sq6/2.0d0
          sqy(ig,2,2) = ci*sq7*(5*z**2-1)/sq6/2.0d0
          sqy(ig,3,2) = 5*iypx*sq7*z/sq6
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/(8.0d0*sq42)
          sqy(ig,2,3) = (-5.0d0)*ci*(21*z**4-14*z**2+1)/(8.0d0*sq42)
          sqy(ig,3,3) = (-35.0d0)*iypx*z*(3*z**2-1)/(2.0d0*sq42)
       end do
    case (314)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq210*z/3.0d0
          sqy(ig,2,2) = -ci*iypx*sq210*z/3.0d0
          sqy(ig,3,2) = -iypx**2*sq105/sq2/3.0d0
          sqy(ig,1,3) = iypx*sq105*z*(3*z**2-1)/sq2/3.0d0
          sqy(ig,2,3) = ci*iypx*sq105*z*(3*z**2-1)/sq2/3.0d0
          sqy(ig,3,3) = iypx**2*sq105*(3*z-1)*(3*z+1)/sq2/6.0d0
       end do
    case (315)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx**2*sq105/4.0d0
          sqy(ig,2,2) = ci*iypx**2*sq105/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -iypx**2*sq105*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,2,3) = -ci*iypx**2*sq105*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,3,3) = (-3.0d0)*iypx**3*sq105*z/4.0d0
       end do
    case (316)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = iypx**3*sq105*z
          sqy(ig,2,3) = ci*iypx**3*sq105*z
          sqy(ig,3,3) = iypx**4*sq105/4.0d0
       end do
    case (317)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*iypx**4*sq35/(8.0d0*sq6)
          sqy(ig,2,3) = (-15.0d0)*ci*iypx**4*sq35/(8.0d0*sq6)
          sqy(ig,3,3) = 0
       end do
    case (318)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
       end do
    case (319)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -5*z/sq42
          sqy(ig,2,2) = -5*ci*z/sq42
          sqy(ig,3,2) = -5*iypx/sq42
          sqy(ig,1,3) = 15.0d0*sq6*z*(7*z**2-3)/(44.0d0*sq7)
          sqy(ig,2,3) = 15.0d0*ci*sq6*z*(7*z**2-3)/(44.0d0*sq7)
          sqy(ig,3,3) = 45.0d0*iypx*sq6*(7*z**2-1)/(44.0d0*sq7)
          sqy(ig,1,4) = (-5.0d0)*sq42*z*(33*z**4-30*z**2+5)/528.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*sq42*z*(33*z**4-30*z**2+5)/528.0d0
          sqy(ig,3,4) = (-25.0d0)*iypx*sq42*(33*z**4-18*z**2+1)/528.0d0
       end do
    case (320)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*iypx*sq15/(3.0d0*sq14)
          sqy(ig,2,2) = 2.0d0*ci*iypx*sq15/(3.0d0*sq14)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*iypx*sq15*(7*z**2-1)/(11.0d0*sq14)
          sqy(ig,2,3) = (-9.0d0)*ci*iypx*sq15*(7*z**2-1)/(11.0d0*sq14)
          sqy(ig,3,3) = (-9.0d0)*iypx**2*sq210*z/22.0d0
          sqy(ig,1,4) = 5.0d0*iypx*sq105*(33*z**4-18*z**2+1)/(132.0d0*sq2)
          sqy(ig,2,4) = 5.0d0*ci*iypx*sq105*(33*z**4-18*z**2+1)/(132.0d0*sq2)
          sqy(ig,3,4) = 5.0d0*iypx**2*sq105*z*(11*z**2-3)/(22.0d0*sq2)
       end do
    case (321)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 27.0d0*iypx**2*sq105*z/44.0d0
          sqy(ig,2,3) = 27.0d0*ci*iypx**2*sq105*z/44.0d0
          sqy(ig,3,3) = 9.0d0*iypx**3*sq105/44.0d0
          sqy(ig,1,4) = (-15.0d0)*iypx**2*sq105*z*(11*z**2-3)/88.0d0
          sqy(ig,2,4) = (-15.0d0)*ci*iypx**2*sq105*z*(11*z**2-3)/88.0d0
          sqy(ig,3,4) = (-15.0d0)*iypx**3*sq105*(11*z**2-1)/88.0d0
       end do
    case (322)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*iypx**3*sq105/11.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iypx**3*sq105/11.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 5.0d0*iypx**3*sq105*(11*z**2-1)/22.0d0
          sqy(ig,2,4) = 5.0d0*ci*iypx**3*sq105*(11*z**2-1)/22.0d0
          sqy(ig,3,4) = 5.0d0*iypx**4*sq105*z/4.0d0
       end do
    case (323)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-75.0d0)*iypx**4*sq35*z/(8.0d0*sq6)
          sqy(ig,2,4) = (-75.0d0)*ci*iypx**4*sq35*z/(8.0d0*sq6)
          sqy(ig,3,4) = (-15.0d0)*iypx**5*sq35/(8.0d0*sq6)
       end do
    case (324)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 15.0d0*iypx**5*sq42/8.0d0
          sqy(ig,2,4) = 15.0d0*ci*iypx**5*sq42/8.0d0
          sqy(ig,3,4) = 0
       end do
    case (325)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 5*z
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-45.0d0)*z*(7*z**2-3)/22.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 35.0d0*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (326)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*iypx*sq5*z
          sqy(ig,2,1) = -3*ci*iypx*sq5*z
          sqy(ig,3,1) = (-3.0d0)*iypx**2*sq5/2.0d0
       end do
    case (327)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iypx**2*sq5/4.0d0
          sqy(ig,2,1) = 3.0d0*ci*iypx**2*sq5/4.0d0
          sqy(ig,3,1) = 0
       end do
    case (328)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-6.0d0)*iypx*sq5/7.0d0
          sqy(ig,2,1) = (-6.0d0)*ci*iypx*sq5/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*iypx*sq5*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*iypx*sq5*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = (-5.0d0)*iypx**2*sq5*z/2.0d0
       end do
    case (329)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 15.0d0*iypx**2*sq5*z/4.0d0
          sqy(ig,2,2) = 15.0d0*ci*iypx**2*sq5*z/4.0d0
          sqy(ig,3,2) = 5.0d0*iypx**3*sq5/4.0d0
       end do
    case (330)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq30*z/7.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*sq30*z/7.0d0
          sqy(ig,3,1) = (-3.0d0)*iypx*sq30/7.0d0
          sqy(ig,1,2) = 3.0d0*sq15*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = 3.0d0*ci*sq15*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = 9.0d0*iypx*sq15*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (331)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*iypx*sq5/(7.0d0*sq2)
          sqy(ig,2,1) = (-3.0d0)*ci*iypx*sq5/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-13.0d0)*iypx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,2) = (-13.0d0)*ci*iypx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,2) = (-13.0d0)*iypx**2*sq5*z/(2.0d0*sq2)
       end do
    case (332)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3*iypx**2*sq10*z
          sqy(ig,2,2) = 3*ci*iypx**2*sq10*z
          sqy(ig,3,2) = iypx**3*sq10
       end do
    case (333)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx**3*sq15/sq2
          sqy(ig,2,2) = -ci*iypx**3*sq15/sq2
          sqy(ig,3,2) = 0
       end do
    case (334)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-6.0d0)*sq6/(7.0d0*sq5)
          sqy(ig,2,1) = (-6.0d0)*ci*sq6/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(5*z**2-1)/sq30/2.0d0
          sqy(ig,2,2) = -ci*(5*z**2-1)/sq30/2.0d0
          sqy(ig,3,2) = -iypx*sq10*z/sq3/2.0d0
          sqy(ig,1,3) = 5.0d0*sq10*(21*z**4-14*z**2+1)/(56.0d0*sq3)
          sqy(ig,2,3) = 5.0d0*ci*sq10*(21*z**4-14*z**2+1)/(56.0d0*sq3)
          sqy(ig,3,3) = 5.0d0*iypx*sq10*z*(3*z**2-1)/(2.0d0*sq3)
       end do
    case (335)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq5*z/sq2
          sqy(ig,2,2) = -ci*iypx*sq5*z/sq2
          sqy(ig,3,2) = -iypx**2*sq5/sq2/2.0d0
          sqy(ig,1,3) = (-5.0d0)*iypx*sq5*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*ci*iypx*sq5*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*iypx**2*sq5*(3*z-1)*(3*z+1)/(4.0d0*sq2)
       end do
    case (336)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx**2*sq10
          sqy(ig,2,2) = ci*iypx**2*sq10
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 5.0d0*iypx**2*sq5*(3*z-1)*(3*z+1)/(4.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*ci*iypx**2*sq5*(3*z-1)*(3*z+1)/(4.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*iypx**3*sq5*z/(2.0d0*sq2)
       end do
    case (337)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -15*iypx**3*sq5*z/sq6
          sqy(ig,2,3) = -15*ci*iypx**3*sq5*z/sq6
          sqy(ig,3,3) = (-15.0d0)*iypx**4*sq5/(4.0d0*sq6)
       end do
    case (338)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-3.0d0)*sq6/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = sq6*(5*z**2-1)
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-75.0d0)*(21*z**4-14*z**2+1)/(28.0d0*sq6)
       end do
    case (339)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-9.0d0)*sq6/(14.0d0*sq5)
          sqy(ig,2,1) = (-9.0d0)*ci*sq6/(14.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-7.0d0)*(5*z**2-1)/(2.0d0*sq30)
          sqy(ig,2,2) = (-7.0d0)*ci*(5*z**2-1)/(2.0d0*sq30)
          sqy(ig,3,2) = (-7.0d0)*iypx*sq10*z/(2.0d0*sq3)
          sqy(ig,1,3) = 25.0d0*sq10*(21*z**4-14*z**2+1)/(112.0d0*sq3)
          sqy(ig,2,3) = 25.0d0*ci*sq10*(21*z**4-14*z**2+1)/(112.0d0*sq3)
          sqy(ig,3,3) = 25.0d0*iypx*sq10*z*(3*z**2-1)/(4.0d0*sq3)
       end do
    case (340)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq15*z/3.0d0
          sqy(ig,2,2) = ci*iypx*sq15*z/3.0d0
          sqy(ig,3,2) = iypx**2*sq15/6.0d0
          sqy(ig,1,3) = (-5.0d0)*iypx*sq15*z*(3*z**2-1)/3.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*iypx*sq15*z*(3*z**2-1)/3.0d0
          sqy(ig,3,3) = (-5.0d0)*iypx**2*sq15*(3*z-1)*(3*z+1)/6.0d0
       end do
    case (341)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx**2*sq15/4.0d0
          sqy(ig,2,2) = ci*iypx**2*sq15/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 5.0d0*iypx**2*sq15*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,2,3) = 5.0d0*ci*iypx**2*sq15*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,3,3) = 15.0d0*iypx**3*sq15*z/4.0d0
       end do
    case (342)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -15*iypx**3*sq5*z/sq6
          sqy(ig,2,3) = -15*ci*iypx**3*sq5*z/sq6
          sqy(ig,3,3) = (-15.0d0)*iypx**4*sq5/(4.0d0*sq6)
       end do
    case (343)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 75.0d0*iypx**4/(8.0d0*sq6)
          sqy(ig,2,3) = 75.0d0*ci*iypx**4/(8.0d0*sq6)
          sqy(ig,3,3) = 0
       end do
    case (344)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 5.0d0*sq6*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 30.0d0*sq6*z*(7*z**2-3)/77.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-75.0d0)*z*(33*z**4-30*z**2+5)/(44.0d0*sq6)
       end do
    case (345)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-11.0d0)*sq30*z/42.0d0
          sqy(ig,2,2) = (-11.0d0)*ci*sq30*z/42.0d0
          sqy(ig,3,2) = (-11.0d0)*iypx*sq30/42.0d0
          sqy(ig,1,3) = (-9.0d0)*sq30*z*(7*z**2-3)/308.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*sq30*z*(7*z**2-3)/308.0d0
          sqy(ig,3,3) = (-27.0d0)*iypx*sq30*(7*z**2-1)/308.0d0
          sqy(ig,1,4) = 25.0d0*sq15*z*(33*z**4-30*z**2+5)/(264.0d0*sq2)
          sqy(ig,2,4) = 25.0d0*ci*sq15*z*(33*z**4-30*z**2+5)/(264.0d0*sq2)
          sqy(ig,3,4) = 125.0d0*iypx*sq15*(33*z**4-18*z**2+1)/(264.0d0*sq2)
       end do
    case (346)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 8.0d0*iypx*sq5/(7.0d0*sq3)
          sqy(ig,2,2) = 8.0d0*ci*iypx*sq5/(7.0d0*sq3)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*iypx*sq15*(7*z**2-1)/154.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*iypx*sq15*(7*z**2-1)/154.0d0
          sqy(ig,3,3) = (-9.0d0)*iypx**2*sq15*z/22.0d0
          sqy(ig,1,4) = (-25.0d0)*iypx*sq5*(33*z**4-18*z**2+1)/(44.0d0*sq3)
          sqy(ig,2,4) = (-25.0d0)*ci*iypx*sq5*(33*z**4-18*z**2+1)/(44.0d0*sq3)
          sqy(ig,3,4) = (-25.0d0)*iypx**2*sq15*z*(11*z**2-3)/22.0d0
       end do
    case (347)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 63.0d0*iypx**2*sq15*z/44.0d0
          sqy(ig,2,3) = 63.0d0*ci*iypx**2*sq15*z/44.0d0
          sqy(ig,3,3) = 21.0d0*iypx**3*sq15/44.0d0
          sqy(ig,1,4) = 75.0d0*iypx**2*sq15*z*(11*z**2-3)/88.0d0
          sqy(ig,2,4) = 75.0d0*ci*iypx**2*sq15*z*(11*z**2-3)/88.0d0
          sqy(ig,3,4) = 75.0d0*iypx**3*sq15*(11*z**2-1)/88.0d0
       end do
    case (348)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*iypx**3*sq30/11.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*iypx**3*sq30/11.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-25.0d0)*iypx**3*sq15*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,2,4) = (-25.0d0)*ci*iypx**3*sq15*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,3,4) = (-25.0d0)*iypx**4*sq15*z/(4.0d0*sq2)
       end do
    case (349)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 375.0d0*iypx**4*z/(8.0d0*sq6)
          sqy(ig,2,4) = 375.0d0*ci*iypx**4*z/(8.0d0*sq6)
          sqy(ig,3,4) = 75.0d0*iypx**5/(8.0d0*sq6)
       end do
    case (350)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -5*z/sq7
          sqy(ig,2,2) = 5*ci*z/sq7
          sqy(ig,3,2) = 5*iymx/sq7
          sqy(ig,1,3) = 45.0d0*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,2,3) = (-45.0d0)*ci*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,3,3) = (-135.0d0)*iymx*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,1,4) = (-5.0d0)*sq7*z*(33*z**4-30*z**2+5)/88.0d0
          sqy(ig,2,4) = 5.0d0*ci*sq7*z*(33*z**4-30*z**2+5)/88.0d0
          sqy(ig,3,4) = 25.0d0*iymx*sq7*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (351)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-5.0d0)*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 675.0d0*z*(7*z**2-3)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-185.0d0)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (352)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq15*(5*z**2-1)/4.0d0
          sqy(ig,2,1) = -ci*sq15*(5*z**2-1)/4.0d0
          sqy(ig,3,1) = (-5.0d0)*iypx*sq15*z/2.0d0
       end do
    case (353)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iypx*sq15*z
          sqy(ig,2,1) = ci*iypx*sq15*z
          sqy(ig,3,1) = iypx**2*sq15/2.0d0
       end do
    case (354)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-4.0d0)*sq15*z/7.0d0
          sqy(ig,2,1) = (-4.0d0)*ci*sq15*z/7.0d0
          sqy(ig,3,1) = (-4.0d0)*iypx*sq15/7.0d0
          sqy(ig,1,2) = (-3.0d0)*sq15*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq15*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = (-9.0d0)*iypx*sq15*(7*z**2-1)/28.0d0
       end do
    case (355)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-2.0d0)*iypx*sq15/7.0d0
          sqy(ig,2,1) = (-2.0d0)*ci*iypx*sq15/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iypx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = 3.0d0*ci*iypx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = 3.0d0*iypx**2*sq15*z/2.0d0
       end do
    case (356)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-9.0d0)*sq10*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 15.0d0*sq5*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (357)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq30*z/7.0d0
          sqy(ig,2,1) = -ci*sq30*z/7.0d0
          sqy(ig,3,1) = -iypx*sq30/7.0d0
          sqy(ig,1,2) = (-3.0d0)*sq15*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,2,2) = (-3.0d0)*ci*sq15*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,3,2) = (-9.0d0)*iypx*sq15*(7*z**2-1)/(7.0d0*sq2)
       end do
    case (358)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iypx*sq15/sq2/7.0d0
          sqy(ig,2,1) = ci*iypx*sq15/sq2/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 9.0d0*iypx*sq15*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,2) = 9.0d0*ci*iypx*sq15*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,2) = 9.0d0*iypx**2*sq15*z/(2.0d0*sq2)
       end do
    case (359)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-9.0d0)*iypx**2*sq10*z/4.0d0
          sqy(ig,2,2) = (-9.0d0)*ci*iypx**2*sq10*z/4.0d0
          sqy(ig,3,2) = (-3.0d0)*iypx**3*sq10/4.0d0
       end do
    case (360)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-12.0d0)*sq2/(7.0d0*sq5)
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 3*(5*z**2-1)/sq10
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 15.0d0*sq5*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (361)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-6.0d0)*sq6/(7.0d0*sq5)
          sqy(ig,2,1) = (-6.0d0)*ci*sq6/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -sq15*(5*z**2-1)/sq2/5.0d0
          sqy(ig,2,2) = -ci*sq15*(5*z**2-1)/sq2/5.0d0
          sqy(ig,3,2) = -iypx*sq30*z
          sqy(ig,1,3) = (-3.0d0)*sq15*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,2,3) = (-3.0d0)*ci*sq15*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,3,3) = -3*iypx*sq15*z*(3*z**2-1)/sq2
       end do
    case (362)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq15*z/sq2
          sqy(ig,2,2) = ci*iypx*sq15*z/sq2
          sqy(ig,3,2) = iypx**2*sq15/sq2/2.0d0
          sqy(ig,1,3) = 3.0d0*iypx*sq15*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = 3.0d0*ci*iypx*sq15*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*iypx**2*sq15*(3*z-1)*(3*z+1)/(4.0d0*sq2)
       end do
    case (363)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iypx**2*sq5/(2.0d0*sq2)
          sqy(ig,2,2) = 3.0d0*ci*iypx**2*sq5/(2.0d0*sq2)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-3.0d0)*iypx**2*sq5*(3*z-1)*(3*z+1)/(4.0d0*sq2)
          sqy(ig,2,3) = (-3.0d0)*ci*iypx**2*sq5*(3*z-1)*(3*z+1)/(4.0d0*sq2)
          sqy(ig,3,3) = (-9.0d0)*iypx**3*sq5*z/(2.0d0*sq2)
       end do
    case (364)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0/(7.0d0*sq2)
          sqy(ig,2,1) = (-3.0d0)*ci/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(5*z**2-1)/sq2
          sqy(ig,2,2) = ci*(5*z**2-1)/sq2
          sqy(ig,3,2) = 5*iymx*sq2*z
          sqy(ig,1,3) = 25.0d0*(21*z**4-14*z**2+1)/(56.0d0*sq2)
          sqy(ig,2,3) = (-25.0d0)*ci*(21*z**4-14*z**2+1)/(56.0d0*sq2)
          sqy(ig,3,3) = (-25.0d0)*iymx*z*(3*z**2-1)/(2.0d0*sq2)
       end do
    case (365)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-9.0d0)*sq2/(7.0d0*sq5)
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -2*sq2*(5*z**2-1)/sq5
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 55.0d0*sq5*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (366)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)/(7.0d0*sq5)
          sqy(ig,2,1) = (-3.0d0)*ci/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(5*z**2-1)/sq5/4.0d0
          sqy(ig,2,2) = -ci*(5*z**2-1)/sq5/4.0d0
          sqy(ig,3,2) = -iypx*sq5*z/2.0d0
          sqy(ig,1,3) = (-19.0d0)*sq5*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = (-19.0d0)*ci*sq5*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = (-19.0d0)*iypx*sq5*z*(3*z**2-1)/2.0d0
       end do
    case (367)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iypx*sq5*z
          sqy(ig,2,2) = ci*iypx*sq5*z
          sqy(ig,3,2) = iypx**2*sq5/2.0d0
          sqy(ig,1,3) = 4*iypx*sq5*z*(3*z**2-1)
          sqy(ig,2,3) = 4*ci*iypx*sq5*z*(3*z**2-1)
          sqy(ig,3,3) = 2*iypx**2*sq5*(3*z-1)*(3*z+1)
       end do
    case (368)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx**2*sq5/sq2/2.0d0
          sqy(ig,2,2) = -ci*iypx**2*sq5/sq2/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-13.0d0)*iypx**2*sq5*(3*z-1)*(3*z+1)/(8.0d0*sq2)
          sqy(ig,2,3) = (-13.0d0)*ci*iypx**2*sq5*(3*z-1)*(3*z+1)/(8.0d0*sq2)
          sqy(ig,3,3) = (-39.0d0)*iypx**3*sq5*z/(4.0d0*sq2)
       end do
    case (369)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15*iypx**3*z/sq2
          sqy(ig,2,3) = 15*ci*iypx**3*z/sq2
          sqy(ig,3,3) = 15.0d0*iypx**4/(4.0d0*sq2)
       end do
    case (370)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-15.0d0)*z/(7.0d0*sq2)
          sqy(ig,2,2) = 15.0d0*ci*z/(7.0d0*sq2)
          sqy(ig,3,2) = 15.0d0*iymx/(7.0d0*sq2)
          sqy(ig,1,3) = 15.0d0*z*(7*z**2-3)/(77.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*ci*z*(7*z**2-3)/(77.0d0*sq2)
          sqy(ig,3,3) = (-45.0d0)*iymx*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,1,4) = 15.0d0*z*(33*z**4-30*z**2+5)/(88.0d0*sq2)
          sqy(ig,2,4) = (-15.0d0)*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq2)
          sqy(ig,3,4) = (-75.0d0)*iymx*(33*z**4-18*z**2+1)/(88.0d0*sq2)
       end do
    case (371)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-3.0d0)*sq10*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 45.0d0*sq10*z*(7*z**2-3)/77.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 45.0d0*sq5*z*(33*z**4-30*z**2+5)/(44.0d0*sq2)
       end do
    case (372)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*sq5*z/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq5*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*iypx*sq5/7.0d0
          sqy(ig,1,3) = (-93.0d0)*sq5*z*(7*z**2-3)/308.0d0
          sqy(ig,2,3) = (-93.0d0)*ci*sq5*z*(7*z**2-3)/308.0d0
          sqy(ig,3,3) = (-279.0d0)*iypx*sq5*(7*z**2-1)/308.0d0
          sqy(ig,1,4) = (-15.0d0)*sq5*z*(33*z**4-30*z**2+5)/88.0d0
          sqy(ig,2,4) = (-15.0d0)*ci*sq5*z*(33*z**4-30*z**2+5)/88.0d0
          sqy(ig,3,4) = (-75.0d0)*iypx*sq5*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (373)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 6.0d0*iypx*sq5/7.0d0
          sqy(ig,2,2) = 6.0d0*ci*iypx*sq5/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 69.0d0*iypx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,2,3) = 69.0d0*ci*iypx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,3,3) = 69.0d0*iypx**2*sq5*z/22.0d0
          sqy(ig,1,4) = 15.0d0*iypx*sq5*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,2,4) = 15.0d0*ci*iypx*sq5*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,3,4) = 45.0d0*iypx**2*sq5*z*(11*z**2-3)/22.0d0
       end do
    case (374)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-135.0d0)*iypx**2*z/(22.0d0*sq10)
          sqy(ig,2,3) = (-135.0d0)*ci*iypx**2*z/(22.0d0*sq10)
          sqy(ig,3,3) = (-45.0d0)*iypx**3/(22.0d0*sq10)
          sqy(ig,1,4) = (-135.0d0)*iypx**2*sq10*z*(11*z**2-3)/176.0d0
          sqy(ig,2,4) = (-135.0d0)*ci*iypx**2*sq10*z*(11*z**2-3)/176.0d0
          sqy(ig,3,4) = (-135.0d0)*iypx**3*sq10*(11*z**2-1)/176.0d0
       end do
    case (375)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-30.0d0)*iypx**3*sq2/11.0d0
          sqy(ig,2,3) = (-30.0d0)*ci*iypx**3*sq2/11.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 45.0d0*iypx**3*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,2,4) = 45.0d0*ci*iypx**3*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,3,4) = 45.0d0*iypx**4*z/(4.0d0*sq2)
       end do
    case (376)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -5*iymx/sq21
          sqy(ig,2,2) = 5*ci*iymx/sq21
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 45.0d0*iymx*sq3*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,2,3) = (-45.0d0)*ci*iymx*sq3*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,3,3) = (-45.0d0)*iymx**2*sq21*z/22.0d0
          sqy(ig,1,4) = (-25.0d0)*iymx*sq21*(33*z**4-18*z**2+1)/264.0d0
          sqy(ig,2,4) = 25.0d0*ci*iymx*sq21*(33*z**4-18*z**2+1)/264.0d0
          sqy(ig,3,4) = 25.0d0*iymx**2*sq21*z*(11*z**2-3)/44.0d0
       end do
    case (377)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-10.0d0)*z/(7.0d0*sq3)
          sqy(ig,2,2) = 10.0d0*ci*z/(7.0d0*sq3)
          sqy(ig,3,2) = 10.0d0*iymx/(7.0d0*sq3)
          sqy(ig,1,3) = (-75.0d0)*sq3*z*(7*z**2-3)/154.0d0
          sqy(ig,2,3) = 75.0d0*ci*sq3*z*(7*z**2-3)/154.0d0
          sqy(ig,3,3) = 225.0d0*iymx*sq3*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 10.0d0*z*(33*z**4-30*z**2+5)/(11.0d0*sq3)
          sqy(ig,2,4) = (-10.0d0)*ci*z*(33*z**4-30*z**2+5)/(11.0d0*sq3)
          sqy(ig,3,4) = (-50.0d0)*iymx*(33*z**4-18*z**2+1)/(11.0d0*sq3)
       end do
    case (378)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-15.0d0)*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-285.0d0)*z*(7*z**2-3)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 435.0d0*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (379)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = -3*(5*z**2-1)
       end do
    case (380)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*(5*z**2-1)/4.0d0
          sqy(ig,2,1) = 3.0d0*ci*(5*z**2-1)/4.0d0
          sqy(ig,3,1) = 15.0d0*iypx*z/2.0d0
       end do
    case (381)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-36.0d0)*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-5.0d0)*z*(7*z**2-3)/7.0d0
       end do
    case (382)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-12.0d0)*z/7.0d0
          sqy(ig,2,1) = (-12.0d0)*ci*z/7.0d0
          sqy(ig,3,1) = (-12.0d0)*iypx/7.0d0
          sqy(ig,1,2) = 5.0d0*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = 5.0d0*ci*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = 15.0d0*iypx*(7*z**2-1)/28.0d0
       end do
    case (383)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq6*z/7.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*sq6*z/7.0d0
          sqy(ig,3,1) = (-3.0d0)*iymx*sq6/7.0d0
          sqy(ig,1,2) = (-5.0d0)*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,2,2) = 5.0d0*ci*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,3,2) = 15.0d0*iymx*sq3*(7*z**2-1)/(7.0d0*sq2)
       end do
    case (384)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-9.0d0)*sq2*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-55.0d0)*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (385)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq2*z/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq2*z/7.0d0
          sqy(ig,3,1) = 3.0d0*iypx*sq2/7.0d0
          sqy(ig,1,2) = 25.0d0*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = 25.0d0*ci*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = 75.0d0*iypx*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (386)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iypx*sq3/(7.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci*iypx*sq3/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-15.0d0)*iypx*sq3*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,2) = (-15.0d0)*ci*iypx*sq3*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,2) = (-15.0d0)*iypx**2*sq3*z/(2.0d0*sq2)
       end do
    case (387)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*sq6/35.0d0
          sqy(ig,2,1) = (-6.0d0)*ci*sq6/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-7.0d0)*(5*z**2-1)/(5.0d0*sq6)
          sqy(ig,2,2) = 7.0d0*ci*(5*z**2-1)/(5.0d0*sq6)
          sqy(ig,3,2) = 7*iymx*sq2*z/sq3
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/(28.0d0*sq6)
          sqy(ig,2,3) = 5.0d0*ci*(21*z**4-14*z**2+1)/(28.0d0*sq6)
          sqy(ig,3,3) = 5*iymx*z*(3*z**2-1)/sq6
       end do
    case (388)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-36.0d0)*sq2/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-11.0d0)*(5*z**2-1)/(5.0d0*sq2)
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-25.0d0)*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (389)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-18.0d0)*sq2/35.0d0
          sqy(ig,2,1) = (-18.0d0)*ci*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(5*z**2-1)/sq2/10.0d0
          sqy(ig,2,2) = -ci*(5*z**2-1)/sq2/10.0d0
          sqy(ig,3,2) = -iypx*z/sq2
          sqy(ig,1,3) = 5.0d0*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*ci*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,3,3) = 5*iypx*z*(3*z**2-1)/sq2
       end do
    case (390)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 11*iypx*z/sq6
          sqy(ig,2,2) = 11*ci*iypx*z/sq6
          sqy(ig,3,2) = 11.0d0*iypx**2/(2.0d0*sq6)
          sqy(ig,1,3) = (-5.0d0)*iypx*z*(3*z**2-1)/(2.0d0*sq6)
          sqy(ig,2,3) = (-5.0d0)*ci*iypx*z*(3*z**2-1)/(2.0d0*sq6)
          sqy(ig,3,3) = (-5.0d0)*iypx**2*(3*z-1)*(3*z+1)/(4.0d0*sq6)
       end do
    case (391)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -20*iymx*z/sq30
          sqy(ig,2,2) = 20*ci*iymx*z/sq30
          sqy(ig,3,2) = 10*iymx**2/sq30
          sqy(ig,1,3) = 5.0d0*iymx*sq30*z*(3*z**2-1)/6.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*iymx*sq30*z*(3*z**2-1)/6.0d0
          sqy(ig,3,3) = (-5.0d0)*iymx**2*sq30*(3*z-1)*(3*z+1)/12.0d0
       end do
    case (392)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 9.0d0*sq6/70.0d0
          sqy(ig,2,1) = (-9.0d0)*ci*sq6/70.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2-1)/sq6/5.0d0
          sqy(ig,2,2) = -ci*(5*z**2-1)/sq6/5.0d0
          sqy(ig,3,2) = -2*iymx*z/sq6
          sqy(ig,1,3) = (-95.0d0)*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,2,3) = 95.0d0*ci*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,3,3) = 95.0d0*iymx*z*(3*z**2-1)/(2.0d0*sq6)
       end do
    case (393)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-6.0d0)*sq3/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-3.0d0)*sq3*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-75.0d0)*sq3*(21*z**4-14*z**2+1)/28.0d0
       end do
    case (394)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq3/35.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq3/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 13.0d0*(5*z**2-1)/(20.0d0*sq3)
          sqy(ig,2,2) = 13.0d0*ci*(5*z**2-1)/(20.0d0*sq3)
          sqy(ig,3,2) = 13.0d0*iypx*z/(2.0d0*sq3)
          sqy(ig,1,3) = 85.0d0*(21*z**4-14*z**2+1)/(56.0d0*sq3)
          sqy(ig,2,3) = 85.0d0*ci*(21*z**4-14*z**2+1)/(56.0d0*sq3)
          sqy(ig,3,3) = 85.0d0*iypx*z*(3*z**2-1)/(2.0d0*sq3)
       end do
    case (395)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iypx*sq2*z/sq3
          sqy(ig,2,2) = -ci*iypx*sq2*z/sq3
          sqy(ig,3,2) = -iypx**2/sq6
          sqy(ig,1,3) = -10*iypx*sq2*z*(3*z**2-1)/sq3
          sqy(ig,2,3) = -10*ci*iypx*sq2*z*(3*z**2-1)/sq3
          sqy(ig,3,3) = -5*iypx**2*sq2*(3*z-1)*(3*z+1)/sq3
       end do
    case (396)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iypx**2*sq5/(2.0d0*sq6)
          sqy(ig,2,2) = (-3.0d0)*ci*iypx**2*sq5/(2.0d0*sq6)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*iypx**2*sq5*(3*z-1)*(3*z+1)/(8.0d0*sq6)
          sqy(ig,2,3) = 15.0d0*ci*iypx**2*sq5*(3*z-1)*(3*z+1)/(8.0d0*sq6)
          sqy(ig,3,3) = 45.0d0*iypx**3*sq5*z/(4.0d0*sq6)
       end do
    case (397)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-5.0d0)*iymx*sq30/21.0d0
          sqy(ig,2,2) = 5.0d0*ci*iymx*sq30/21.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 12.0d0*iymx*sq30*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = (-12.0d0)*ci*iymx*sq30*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = (-12.0d0)*iymx**2*sq30*z/11.0d0
          sqy(ig,1,4) = 5.0d0*iymx*sq30*(33*z**4-18*z**2+1)/264.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*iymx*sq30*(33*z**4-18*z**2+1)/264.0d0
          sqy(ig,3,4) = (-5.0d0)*iymx**2*sq30*z*(11*z**2-3)/44.0d0
       end do
    case (398)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-19.0d0)*z/(7.0d0*sq6)
          sqy(ig,2,2) = 19.0d0*ci*z/(7.0d0*sq6)
          sqy(ig,3,2) = 19.0d0*iymx/(7.0d0*sq6)
          sqy(ig,1,3) = (-45.0d0)*sq3*z*(7*z**2-3)/(77.0d0*sq2)
          sqy(ig,2,3) = 45.0d0*ci*sq3*z*(7*z**2-3)/(77.0d0*sq2)
          sqy(ig,3,3) = 135.0d0*iymx*sq3*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,1,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
          sqy(ig,2,4) = 25.0d0*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
          sqy(ig,3,4) = 125.0d0*iymx*(33*z**4-18*z**2+1)/(88.0d0*sq6)
       end do
    case (399)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -2*sq3*z
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-15.0d0)*sq3*z*(7*z**2-3)/11.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-25.0d0)*sq3*z*(33*z**4-30*z**2+5)/44.0d0
       end do
    case (400)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = z/sq3/7.0d0
          sqy(ig,2,2) = ci*z/sq3/7.0d0
          sqy(ig,3,2) = iypx/sq3/7.0d0
          sqy(ig,1,3) = 15.0d0*sq3*z*(7*z**2-3)/308.0d0
          sqy(ig,2,3) = 15.0d0*ci*sq3*z*(7*z**2-3)/308.0d0
          sqy(ig,3,3) = 45.0d0*iypx*sq3*(7*z**2-1)/308.0d0
          sqy(ig,1,4) = 25.0d0*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,2,4) = 25.0d0*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,3,4) = 125.0d0*iypx*(33*z**4-18*z**2+1)/(88.0d0*sq3)
       end do
    case (401)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 32.0d0*iypx/(7.0d0*sq6)
          sqy(ig,2,2) = 32.0d0*ci*iypx/(7.0d0*sq6)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 45.0d0*iypx*sq3*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = 45.0d0*ci*iypx*sq3*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = 45.0d0*iypx**2*sq3*z/(11.0d0*sq2)
          sqy(ig,1,4) = (-25.0d0)*iypx*(33*z**4-18*z**2+1)/(44.0d0*sq6)
          sqy(ig,2,4) = (-25.0d0)*ci*iypx*(33*z**4-18*z**2+1)/(44.0d0*sq6)
          sqy(ig,3,4) = (-25.0d0)*iypx**2*sq3*z*(11*z**2-3)/(22.0d0*sq2)
       end do
    case (402)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-315.0d0)*iypx**2*sq3*z/(22.0d0*sq10)
          sqy(ig,2,3) = (-315.0d0)*ci*iypx**2*sq3*z/(22.0d0*sq10)
          sqy(ig,3,3) = (-105.0d0)*iypx**3*sq3/(22.0d0*sq10)
          sqy(ig,1,4) = 75.0d0*iypx**2*sq3*z*(11*z**2-3)/(88.0d0*sq10)
          sqy(ig,2,4) = 75.0d0*ci*iypx**2*sq3*z*(11*z**2-3)/(88.0d0*sq10)
          sqy(ig,3,4) = 75.0d0*iypx**3*sq3*(11*z**2-1)/(88.0d0*sq10)
       end do
    case (403)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 27.0d0*iymx**2*sq35*z/22.0d0
          sqy(ig,2,3) = (-27.0d0)*ci*iymx**2*sq35*z/22.0d0
          sqy(ig,3,3) = (-9.0d0)*iymx**3*sq35/22.0d0
          sqy(ig,1,4) = (-15.0d0)*iymx**2*sq35*z*(11*z**2-3)/44.0d0
          sqy(ig,2,4) = 15.0d0*ci*iymx**2*sq35*z*(11*z**2-3)/44.0d0
          sqy(ig,3,4) = 15.0d0*iymx**3*sq35*(11*z**2-1)/44.0d0
       end do
    case (404)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iymx*sq5/7.0d0
          sqy(ig,2,2) = 3.0d0*ci*iymx*sq5/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*iymx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,2,3) = 45.0d0*ci*iymx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,3,3) = 45.0d0*iymx**2*sq5*z/22.0d0
          sqy(ig,1,4) = 45.0d0*iymx*sq5*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,2,4) = (-45.0d0)*ci*iymx*sq5*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,3,4) = (-135.0d0)*iymx**2*sq5*z*(11*z**2-3)/44.0d0
       end do
    case (405)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq15*z/21.0d0
          sqy(ig,2,2) = -ci*sq15*z/21.0d0
          sqy(ig,3,2) = -iymx*sq15/21.0d0
          sqy(ig,1,3) = (-3.0d0)*sq15*z*(7*z**2-3)/154.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq15*z*(7*z**2-3)/154.0d0
          sqy(ig,3,3) = 9.0d0*iymx*sq15*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = (-65.0d0)*sq15*z*(33*z**4-30*z**2+5)/264.0d0
          sqy(ig,2,4) = 65.0d0*ci*sq15*z*(33*z**4-30*z**2+5)/264.0d0
          sqy(ig,3,4) = 325.0d0*iymx*sq15*(33*z**4-18*z**2+1)/264.0d0
       end do
    case (406)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -z
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-45.0d0)*z*(7*z**2-3)/22.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-625.0d0)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (407)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*(5*z**2-1)/4.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*(5*z**2-1)/4.0d0
          sqy(ig,3,1) = (-15.0d0)*iymx*z/2.0d0
       end do
    case (408)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3*(5*z**2-1)
       end do
    case (409)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 12.0d0*z/7.0d0
          sqy(ig,2,1) = (-12.0d0)*ci*z/7.0d0
          sqy(ig,3,1) = (-12.0d0)*iymx/7.0d0
          sqy(ig,1,2) = (-5.0d0)*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = 5.0d0*ci*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = 15.0d0*iymx*(7*z**2-1)/28.0d0
       end do
    case (410)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-36.0d0)*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-5.0d0)*z*(7*z**2-3)/7.0d0
       end do
    case (411)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iymx*sq3/(7.0d0*sq2)
          sqy(ig,2,1) = (-3.0d0)*ci*iymx*sq3/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-15.0d0)*iymx*sq3*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,2) = 15.0d0*ci*iymx*sq3*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,2) = 15.0d0*iymx**2*sq3*z/(2.0d0*sq2)
       end do
    case (412)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq2*z/7.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*sq2*z/7.0d0
          sqy(ig,3,1) = (-3.0d0)*iymx*sq2/7.0d0
          sqy(ig,1,2) = 25.0d0*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,2,2) = (-25.0d0)*ci*z*(7*z**2-3)/(14.0d0*sq2)
          sqy(ig,3,2) = (-75.0d0)*iymx*(7*z**2-1)/(14.0d0*sq2)
       end do
    case (413)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 9.0d0*sq2*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 55.0d0*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (414)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq6*z/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq6*z/7.0d0
          sqy(ig,3,1) = 3.0d0*iypx*sq6/7.0d0
          sqy(ig,1,2) = (-5.0d0)*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,2,2) = (-5.0d0)*ci*sq3*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,3,2) = (-15.0d0)*iypx*sq3*(7*z**2-1)/(7.0d0*sq2)
       end do
    case (415)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -11*iymx*z/sq6
          sqy(ig,2,2) = 11*ci*iymx*z/sq6
          sqy(ig,3,2) = 11.0d0*iymx**2/(2.0d0*sq6)
          sqy(ig,1,3) = 5.0d0*iymx*z*(3*z**2-1)/(2.0d0*sq6)
          sqy(ig,2,3) = (-5.0d0)*ci*iymx*z*(3*z**2-1)/(2.0d0*sq6)
          sqy(ig,3,3) = (-5.0d0)*iymx**2*(3*z-1)*(3*z+1)/(4.0d0*sq6)
       end do
    case (416)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 18.0d0*sq2/35.0d0
          sqy(ig,2,1) = (-18.0d0)*ci*sq2/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2-1)/sq2/10.0d0
          sqy(ig,2,2) = -ci*(5*z**2-1)/sq2/10.0d0
          sqy(ig,3,2) = -iymx*z/sq2
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*ci*(21*z**4-14*z**2+1)/(28.0d0*sq2)
          sqy(ig,3,3) = 5*iymx*z*(3*z**2-1)/sq2
       end do
    case (417)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-36.0d0)*sq2/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-11.0d0)*(5*z**2-1)/(5.0d0*sq2)
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-25.0d0)*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (418)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-6.0d0)*sq6/35.0d0
          sqy(ig,2,1) = (-6.0d0)*ci*sq6/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 7.0d0*(5*z**2-1)/(5.0d0*sq6)
          sqy(ig,2,2) = 7.0d0*ci*(5*z**2-1)/(5.0d0*sq6)
          sqy(ig,3,2) = 14*iypx*z/sq6
          sqy(ig,1,3) = 5.0d0*(21*z**4-14*z**2+1)/(28.0d0*sq6)
          sqy(ig,2,3) = 5.0d0*ci*(21*z**4-14*z**2+1)/(28.0d0*sq6)
          sqy(ig,3,3) = 5*iypx*z*(3*z**2-1)/sq6
       end do
    case (419)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx**2*sq30/4.0d0
          sqy(ig,2,2) = ci*iymx**2*sq30/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 5.0d0*iymx**2*sq30*(3*z-1)*(3*z+1)/16.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*iymx**2*sq30*(3*z-1)*(3*z+1)/16.0d0
          sqy(ig,3,3) = (-15.0d0)*iymx**3*sq30*z/8.0d0
       end do
    case (420)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq2*z/sq3
          sqy(ig,2,2) = ci*iymx*sq2*z/sq3
          sqy(ig,3,2) = iymx**2/sq6
          sqy(ig,1,3) = -10*iymx*sq2*z*(3*z**2-1)/sq3
          sqy(ig,2,3) = 10*ci*iymx*sq2*z*(3*z**2-1)/sq3
          sqy(ig,3,3) = 5*iymx**2*sq2*(3*z-1)*(3*z+1)/sq3
       end do
    case (421)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*sq3/35.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*sq3/35.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 13.0d0*(5*z**2-1)/(20.0d0*sq3)
          sqy(ig,2,2) = (-13.0d0)*ci*(5*z**2-1)/(20.0d0*sq3)
          sqy(ig,3,2) = (-13.0d0)*iymx*z/(2.0d0*sq3)
          sqy(ig,1,3) = 85.0d0*(21*z**4-14*z**2+1)/(56.0d0*sq3)
          sqy(ig,2,3) = (-85.0d0)*ci*(21*z**4-14*z**2+1)/(56.0d0*sq3)
          sqy(ig,3,3) = (-85.0d0)*iymx*z*(3*z**2-1)/(2.0d0*sq3)
       end do
    case (422)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 6.0d0*sq3/35.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 3.0d0*sq3*(5*z**2-1)/5.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 75.0d0*sq3*(21*z**4-14*z**2+1)/28.0d0
       end do
    case (423)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 27.0d0/(35.0d0*sq6)
          sqy(ig,2,1) = 27.0d0*ci/(35.0d0*sq6)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2-1)/sq6/5.0d0
          sqy(ig,2,2) = ci*(5*z**2-1)/sq6/5.0d0
          sqy(ig,3,2) = 2*iypx*z/sq6
          sqy(ig,1,3) = (-95.0d0)*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,2,3) = (-95.0d0)*ci*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,3,3) = (-95.0d0)*iypx*z*(3*z**2-1)/(2.0d0*sq6)
       end do
    case (424)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -4*iypx*sq5*z/sq6
          sqy(ig,2,2) = -4*ci*iypx*sq5*z/sq6
          sqy(ig,3,2) = -2*iypx**2*sq5/sq6
          sqy(ig,1,3) = 5*iypx*sq5*z*(3*z**2-1)/sq6
          sqy(ig,2,3) = 5*ci*iypx*sq5*z*(3*z**2-1)/sq6
          sqy(ig,3,3) = 5.0d0*iypx**2*sq5*(3*z-1)*(3*z+1)/(2.0d0*sq6)
       end do
    case (425)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 63.0d0*iymx**2*sq30*z/44.0d0
          sqy(ig,2,3) = (-63.0d0)*ci*iymx**2*sq30*z/44.0d0
          sqy(ig,3,3) = (-21.0d0)*iymx**3*sq30/44.0d0
          sqy(ig,1,4) = (-15.0d0)*iymx**2*sq30*z*(11*z**2-3)/176.0d0
          sqy(ig,2,4) = 15.0d0*ci*iymx**2*sq30*z*(11*z**2-3)/176.0d0
          sqy(ig,3,4) = 15.0d0*iymx**3*sq30*(11*z**2-1)/176.0d0
       end do
    case (426)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-16.0d0)*iymx*sq6/21.0d0
          sqy(ig,2,2) = 16.0d0*ci*iymx*sq6/21.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*iymx*sq3*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,2,3) = 45.0d0*ci*iymx*sq3*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,3,3) = 45.0d0*iymx**2*sq3*z/(11.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*iymx*(33*z**4-18*z**2+1)/(44.0d0*sq6)
          sqy(ig,2,4) = (-25.0d0)*ci*iymx*(33*z**4-18*z**2+1)/(44.0d0*sq6)
          sqy(ig,3,4) = (-25.0d0)*iymx**2*sq3*z*(11*z**2-3)/(22.0d0*sq2)
       end do
    case (427)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -z/sq3/7.0d0
          sqy(ig,2,2) = ci*z/sq3/7.0d0
          sqy(ig,3,2) = iymx/sq3/7.0d0
          sqy(ig,1,3) = (-15.0d0)*sq3*z*(7*z**2-3)/308.0d0
          sqy(ig,2,3) = 15.0d0*ci*sq3*z*(7*z**2-3)/308.0d0
          sqy(ig,3,3) = 45.0d0*iymx*sq3*(7*z**2-1)/308.0d0
          sqy(ig,1,4) = (-25.0d0)*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,2,4) = 25.0d0*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,3,4) = 125.0d0*iymx*(33*z**4-18*z**2+1)/(88.0d0*sq3)
       end do
    case (428)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -2*sq3*z
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-15.0d0)*sq3*z*(7*z**2-3)/11.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-25.0d0)*sq3*z*(33*z**4-30*z**2+5)/44.0d0
       end do
    case (429)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 19.0d0*z/(7.0d0*sq6)
          sqy(ig,2,2) = 19.0d0*ci*z/(7.0d0*sq6)
          sqy(ig,3,2) = 19.0d0*iypx/(7.0d0*sq6)
          sqy(ig,1,3) = 45.0d0*sq3*z*(7*z**2-3)/(77.0d0*sq2)
          sqy(ig,2,3) = 45.0d0*ci*sq3*z*(7*z**2-3)/(77.0d0*sq2)
          sqy(ig,3,3) = 135.0d0*iypx*sq3*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,1,4) = 25.0d0*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
          sqy(ig,2,4) = 25.0d0*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
          sqy(ig,3,4) = 125.0d0*iypx*(33*z**4-18*z**2+1)/(88.0d0*sq6)
       end do
    case (430)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 10.0d0*iypx*sq5/(7.0d0*sq6)
          sqy(ig,2,2) = 10.0d0*ci*iypx*sq5/(7.0d0*sq6)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-12.0d0)*iypx*sq30*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = (-12.0d0)*ci*iypx*sq30*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = (-12.0d0)*iypx**2*sq30*z/11.0d0
          sqy(ig,1,4) = (-5.0d0)*iypx*sq30*(33*z**4-18*z**2+1)/264.0d0
          sqy(ig,2,4) = (-5.0d0)*ci*iypx*sq30*(33*z**4-18*z**2+1)/264.0d0
          sqy(ig,3,4) = (-5.0d0)*iypx**2*sq30*z*(11*z**2-3)/44.0d0
       end do
    case (431)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iymx**3*sq35/22.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*iymx**3*sq35/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-15.0d0)*iymx**3*sq35*(11*z**2-1)/44.0d0
          sqy(ig,2,4) = 15.0d0*ci*iymx**3*sq35*(11*z**2-1)/44.0d0
          sqy(ig,3,4) = 15.0d0*iymx**4*sq35*z/8.0d0
       end do
    case (432)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 15.0d0*iymx**2*sq5*z*(11*z**2-3)/8.0d0
          sqy(ig,2,4) = (-15.0d0)*ci*iymx**2*sq5*z*(11*z**2-3)/8.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**3*sq5*(11*z**2-1)/8.0d0
       end do
    case (433)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-2.0d0)*iymx*sq15/21.0d0
          sqy(ig,2,2) = 2.0d0*ci*iymx*sq15/21.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-12.0d0)*iymx*sq15*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = 12.0d0*ci*iymx*sq15*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = 12.0d0*iymx**2*sq15*z/11.0d0
          sqy(ig,1,4) = (-115.0d0)*iymx*sq15*(33*z**4-18*z**2+1)/264.0d0
          sqy(ig,2,4) = 115.0d0*ci*iymx*sq15*(33*z**4-18*z**2+1)/264.0d0
          sqy(ig,3,4) = 115.0d0*iymx**2*sq15*z*(11*z**2-3)/44.0d0
       end do
    case (434)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 4.0d0*z/7.0d0
          sqy(ig,2,2) = (-4.0d0)*ci*z/7.0d0
          sqy(ig,3,2) = (-4.0d0)*iymx/7.0d0
          sqy(ig,1,3) = 45.0d0*z*(7*z**2-3)/77.0d0
          sqy(ig,2,3) = (-45.0d0)*ci*z*(7*z**2-3)/77.0d0
          sqy(ig,3,3) = (-135.0d0)*iymx*(7*z**2-1)/77.0d0
          sqy(ig,1,4) = 25.0d0*z*(33*z**4-30*z**2+5)/22.0d0
          sqy(ig,2,4) = (-25.0d0)*ci*z*(33*z**4-30*z**2+5)/22.0d0
          sqy(ig,3,4) = (-125.0d0)*iymx*(33*z**4-18*z**2+1)/22.0d0
       end do
    case (435)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = z
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 45.0d0*z*(7*z**2-3)/22.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 625.0d0*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (436)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iymx*sq15*z
          sqy(ig,2,1) = -ci*iymx*sq15*z
          sqy(ig,3,1) = -iymx**2*sq15/2.0d0
       end do
    case (437)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq15*(5*z**2-1)/4.0d0
          sqy(ig,2,1) = ci*sq15*(5*z**2-1)/4.0d0
          sqy(ig,3,1) = 5.0d0*iymx*sq15*z/2.0d0
       end do
    case (438)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 2.0d0*iymx*sq15/7.0d0
          sqy(ig,2,1) = (-2.0d0)*ci*iymx*sq15/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iymx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = 3.0d0*ci*iymx*sq15*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = 3.0d0*iymx**2*sq15*z/2.0d0
       end do
    case (439)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 4.0d0*sq15*z/7.0d0
          sqy(ig,2,1) = (-4.0d0)*ci*sq15*z/7.0d0
          sqy(ig,3,1) = (-4.0d0)*iymx*sq15/7.0d0
          sqy(ig,1,2) = 3.0d0*sq15*z*(7*z**2-3)/28.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq15*z*(7*z**2-3)/28.0d0
          sqy(ig,3,2) = (-9.0d0)*iymx*sq15*(7*z**2-1)/28.0d0
       end do
    case (440)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-45.0d0)*iymx**2*z/(2.0d0*sq10)
          sqy(ig,2,2) = 45.0d0*ci*iymx**2*z/(2.0d0*sq10)
          sqy(ig,3,2) = 15.0d0*iymx**3/(2.0d0*sq10)
       end do
    case (441)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = iymx*sq15/sq2/7.0d0
          sqy(ig,2,1) = -ci*iymx*sq15/sq2/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 9.0d0*iymx*sq15*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,2) = (-9.0d0)*ci*iymx*sq15*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,2) = (-9.0d0)*iymx**2*sq15*z/(2.0d0*sq2)
       end do
    case (442)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -sq30*z/7.0d0
          sqy(ig,2,1) = ci*sq30*z/7.0d0
          sqy(ig,3,1) = iymx*sq30/7.0d0
          sqy(ig,1,2) = (-3.0d0)*sq15*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,2,2) = 3.0d0*ci*sq15*z*(7*z**2-3)/(7.0d0*sq2)
          sqy(ig,3,2) = 9.0d0*iymx*sq15*(7*z**2-1)/(7.0d0*sq2)
       end do
    case (443)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 9.0d0*sq10*z/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-15.0d0)*sq5*z*(7*z**2-3)/(7.0d0*sq2)
       end do
    case (444)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iymx**2*sq5/(2.0d0*sq2)
          sqy(ig,2,2) = 3.0d0*ci*iymx**2*sq5/(2.0d0*sq2)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*iymx**2*sq5*(3*z-1)*(3*z+1)/(4.0d0*sq2)
          sqy(ig,2,3) = (-3.0d0)*ci*iymx**2*sq5*(3*z-1)*(3*z+1)/(4.0d0*sq2)
          sqy(ig,3,3) = (-9.0d0)*iymx**3*sq5*z/(2.0d0*sq2)
       end do
    case (445)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx*sq15*z/sq2
          sqy(ig,2,2) = ci*iymx*sq15*z/sq2
          sqy(ig,3,2) = iymx**2*sq15/sq2/2.0d0
          sqy(ig,1,3) = (-3.0d0)*iymx*sq15*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = 3.0d0*ci*iymx*sq15*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = 3.0d0*iymx**2*sq15*(3*z-1)*(3*z+1)/(4.0d0*sq2)
       end do
    case (446)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*sq6/(7.0d0*sq5)
          sqy(ig,2,1) = (-6.0d0)*ci*sq6/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq3*(5*z**2-1)/sq10
          sqy(ig,2,2) = -ci*sq3*(5*z**2-1)/sq10
          sqy(ig,3,2) = -iymx*sq30*z
          sqy(ig,1,3) = 3.0d0*sq30*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*sq30*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = (-3.0d0)*iymx*sq30*z*(3*z**2-1)/2.0d0
       end do
    case (447)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = (-12.0d0)*sq2/(7.0d0*sq5)
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 3*(5*z**2-1)/sq10
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 15.0d0*sq5*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (448)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15*iymx**3*z/sq2
          sqy(ig,2,3) = -15*ci*iymx**3*z/sq2
          sqy(ig,3,3) = (-15.0d0)*iymx**4/(4.0d0*sq2)
       end do
    case (449)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx**2*sq5/sq2/2.0d0
          sqy(ig,2,2) = ci*iymx**2*sq5/sq2/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-13.0d0)*iymx**2*sq5*(3*z-1)*(3*z+1)/(8.0d0*sq2)
          sqy(ig,2,3) = 13.0d0*ci*iymx**2*sq5*(3*z-1)*(3*z+1)/(8.0d0*sq2)
          sqy(ig,3,3) = 39.0d0*iymx**3*sq5*z/(4.0d0*sq2)
       end do
    case (450)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq5*z
          sqy(ig,2,2) = -ci*iymx*sq5*z
          sqy(ig,3,2) = -iymx**2*sq5/2.0d0
          sqy(ig,1,3) = 4*iymx*sq5*z*(3*z**2-1)
          sqy(ig,2,3) = -4*ci*iymx*sq5*z*(3*z**2-1)
          sqy(ig,3,3) = -2*iymx**2*sq5*(3*z-1)*(3*z+1)
       end do
    case (451)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)/(7.0d0*sq5)
          sqy(ig,2,1) = 3.0d0*ci/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(5*z**2-1)/sq5/4.0d0
          sqy(ig,2,2) = ci*(5*z**2-1)/sq5/4.0d0
          sqy(ig,3,2) = iymx*sq5*z/2.0d0
          sqy(ig,1,3) = (-19.0d0)*sq5*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,2,3) = 19.0d0*ci*sq5*(21*z**4-14*z**2+1)/56.0d0
          sqy(ig,3,3) = 19.0d0*iymx*sq5*z*(3*z**2-1)/2.0d0
       end do
    case (452)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 9.0d0*sq2/(7.0d0*sq5)
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 2*sq2*(5*z**2-1)/sq5
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-55.0d0)*sq5*(21*z**4-14*z**2+1)/(28.0d0*sq2)
       end do
    case (453)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0/(7.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -(5*z**2-1)/sq2
          sqy(ig,2,2) = -ci*(5*z**2-1)/sq2
          sqy(ig,3,2) = -5*iypx*sq2*z
          sqy(ig,1,3) = 25.0d0*(21*z**4-14*z**2+1)/(56.0d0*sq2)
          sqy(ig,2,3) = 25.0d0*ci*(21*z**4-14*z**2+1)/(56.0d0*sq2)
          sqy(ig,3,3) = 25.0d0*iypx*z*(3*z**2-1)/(2.0d0*sq2)
       end do
    case (454)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 30.0d0*iymx**3*sq2/11.0d0
          sqy(ig,2,3) = (-30.0d0)*ci*iymx**3*sq2/11.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-45.0d0)*iymx**3*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,2,4) = 45.0d0*ci*iymx**3*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,3,4) = 45.0d0*iymx**4*z/(4.0d0*sq2)
       end do
    case (455)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 135.0d0*iymx**2*z/(22.0d0*sq10)
          sqy(ig,2,3) = (-135.0d0)*ci*iymx**2*z/(22.0d0*sq10)
          sqy(ig,3,3) = (-45.0d0)*iymx**3/(22.0d0*sq10)
          sqy(ig,1,4) = 135.0d0*iymx**2*sq10*z*(11*z**2-3)/176.0d0
          sqy(ig,2,4) = (-135.0d0)*ci*iymx**2*sq10*z*(11*z**2-3)/176.0d0
          sqy(ig,3,4) = (-135.0d0)*iymx**3*sq10*(11*z**2-1)/176.0d0
       end do
    case (456)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-6.0d0)*iymx*sq5/7.0d0
          sqy(ig,2,2) = 6.0d0*ci*iymx*sq5/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-69.0d0)*iymx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,2,3) = 69.0d0*ci*iymx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,3,3) = 69.0d0*iymx**2*sq5*z/22.0d0
          sqy(ig,1,4) = (-15.0d0)*iymx*sq5*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,2,4) = 15.0d0*ci*iymx*sq5*(33*z**4-18*z**2+1)/44.0d0
          sqy(ig,3,4) = 45.0d0*iymx**2*sq5*z*(11*z**2-3)/22.0d0
       end do
    case (457)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*sq5*z/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*sq5*z/7.0d0
          sqy(ig,3,2) = (-3.0d0)*iymx*sq5/7.0d0
          sqy(ig,1,3) = 93.0d0*sq5*z*(7*z**2-3)/308.0d0
          sqy(ig,2,3) = (-93.0d0)*ci*sq5*z*(7*z**2-3)/308.0d0
          sqy(ig,3,3) = (-279.0d0)*iymx*sq5*(7*z**2-1)/308.0d0
          sqy(ig,1,4) = 15.0d0*sq5*z*(33*z**4-30*z**2+5)/88.0d0
          sqy(ig,2,4) = (-15.0d0)*ci*sq5*z*(33*z**4-30*z**2+5)/88.0d0
          sqy(ig,3,4) = (-75.0d0)*iymx*sq5*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (458)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = (-3.0d0)*sq10*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 45.0d0*sq10*z*(7*z**2-3)/77.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 45.0d0*sq5*z*(33*z**4-30*z**2+5)/(44.0d0*sq2)
       end do
    case (459)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 15.0d0*z/(7.0d0*sq2)
          sqy(ig,2,2) = 15.0d0*ci*z/(7.0d0*sq2)
          sqy(ig,3,2) = 15.0d0*iypx/(7.0d0*sq2)
          sqy(ig,1,3) = (-15.0d0)*z*(7*z**2-3)/(77.0d0*sq2)
          sqy(ig,2,3) = (-15.0d0)*ci*z*(7*z**2-3)/(77.0d0*sq2)
          sqy(ig,3,3) = (-45.0d0)*iypx*(7*z**2-1)/(77.0d0*sq2)
          sqy(ig,1,4) = (-15.0d0)*z*(33*z**4-30*z**2+5)/(88.0d0*sq2)
          sqy(ig,2,4) = (-15.0d0)*ci*z*(33*z**4-30*z**2+5)/(88.0d0*sq2)
          sqy(ig,3,4) = (-75.0d0)*iypx*(33*z**4-18*z**2+1)/(88.0d0*sq2)
       end do
    case (460)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-25.0d0)*iymx**4*sq21*z/8.0d0
          sqy(ig,2,4) = 25.0d0*ci*iymx**4*sq21*z/8.0d0
          sqy(ig,3,4) = 5.0d0*iymx**5*sq21/8.0d0
       end do
    case (461)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 15.0d0*iymx**3*sq3/22.0d0
          sqy(ig,2,3) = (-15.0d0)*ci*iymx**3*sq3/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 85.0d0*iymx**3*sq3*(11*z**2-1)/44.0d0
          sqy(ig,2,4) = (-85.0d0)*ci*iymx**3*sq3*(11*z**2-1)/44.0d0
          sqy(ig,3,4) = (-85.0d0)*iymx**4*sq3*z/8.0d0
       end do
    case (462)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*iymx**2*z/11.0d0
          sqy(ig,2,3) = 45.0d0*ci*iymx**2*z/11.0d0
          sqy(ig,3,3) = 15.0d0*iymx**3/11.0d0
          sqy(ig,1,4) = (-225.0d0)*iymx**2*z*(11*z**2-3)/44.0d0
          sqy(ig,2,4) = 225.0d0*ci*iymx**2*z*(11*z**2-3)/44.0d0
          sqy(ig,3,4) = 225.0d0*iymx**3*(11*z**2-1)/44.0d0
       end do
    case (463)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 2.0d0*iymx*sq15/21.0d0
          sqy(ig,2,2) = (-2.0d0)*ci*iymx*sq15/21.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 12.0d0*iymx*sq15*(7*z**2-1)/77.0d0
          sqy(ig,2,3) = (-12.0d0)*ci*iymx*sq15*(7*z**2-1)/77.0d0
          sqy(ig,3,3) = (-12.0d0)*iymx**2*sq15*z/11.0d0
          sqy(ig,1,4) = 575.0d0*iymx*(33*z**4-18*z**2+1)/(88.0d0*sq15)
          sqy(ig,2,4) = (-575.0d0)*ci*iymx*(33*z**4-18*z**2+1)/(88.0d0*sq15)
          sqy(ig,3,4) = (-115.0d0)*iymx**2*sq15*z*(11*z**2-3)/44.0d0
       end do
    case (464)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq5*z/sq3/7.0d0
          sqy(ig,2,2) = -ci*sq5*z/sq3/7.0d0
          sqy(ig,3,2) = -iymx*sq5/sq3/7.0d0
          sqy(ig,1,3) = (-3.0d0)*sq15*z*(7*z**2-3)/154.0d0
          sqy(ig,2,3) = 3.0d0*ci*sq15*z*(7*z**2-3)/154.0d0
          sqy(ig,3,3) = 9.0d0*iymx*sq15*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = (-65.0d0)*sq5*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,2,4) = 65.0d0*ci*sq5*z*(33*z**4-30*z**2+5)/(88.0d0*sq3)
          sqy(ig,3,4) = 325.0d0*iymx*sq5*(33*z**4-18*z**2+1)/(88.0d0*sq3)
       end do
    case (465)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 15.0d0*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 285.0d0*z*(7*z**2-3)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-435.0d0)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (466)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 3.0d0*iymx**2*sq5/4.0d0
          sqy(ig,2,1) = (-3.0d0)*ci*iymx**2*sq5/4.0d0
          sqy(ig,3,1) = 0
       end do
    case (467)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*iymx*sq5*z
          sqy(ig,2,1) = 3*ci*iymx*sq5*z
          sqy(ig,3,1) = 3.0d0*iymx**2*sq5/2.0d0
       end do
    case (468)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-15.0d0)*iymx**2*sq5*z/4.0d0
          sqy(ig,2,2) = 15.0d0*ci*iymx**2*sq5*z/4.0d0
          sqy(ig,3,2) = 5.0d0*iymx**3*sq5/4.0d0
       end do
    case (469)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*iymx*sq5/7.0d0
          sqy(ig,2,1) = (-6.0d0)*ci*iymx*sq5/7.0d0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5.0d0*iymx*sq5*(7*z**2-1)/14.0d0
          sqy(ig,2,2) = (-5.0d0)*ci*iymx*sq5*(7*z**2-1)/14.0d0
          sqy(ig,3,2) = (-5.0d0)*iymx**2*sq5*z/2.0d0
       end do
    case (470)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx**3*sq15/sq2
          sqy(ig,2,2) = ci*iymx**3*sq15/sq2
          sqy(ig,3,2) = 0
       end do
    case (471)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3*iymx**2*sq10*z
          sqy(ig,2,2) = -3*ci*iymx**2*sq10*z
          sqy(ig,3,2) = -iymx**3*sq10
       end do
    case (472)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*iymx*sq5/(7.0d0*sq2)
          sqy(ig,2,1) = 3.0d0*ci*iymx*sq5/(7.0d0*sq2)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-13.0d0)*iymx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,2,2) = 13.0d0*ci*iymx*sq5*(7*z**2-1)/(14.0d0*sq2)
          sqy(ig,3,2) = 13.0d0*iymx**2*sq5*z/(2.0d0*sq2)
       end do
    case (473)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*sq30*z/7.0d0
          sqy(ig,2,1) = 3.0d0*ci*sq30*z/7.0d0
          sqy(ig,3,1) = 3.0d0*iymx*sq30/7.0d0
          sqy(ig,1,2) = 15.0d0*sq3*z*(7*z**2-3)/(14.0d0*sq10)
          sqy(ig,2,2) = (-15.0d0)*ci*sq3*z*(7*z**2-3)/(14.0d0*sq10)
          sqy(ig,3,2) = (-45.0d0)*iymx*sq3*(7*z**2-1)/(14.0d0*sq10)
       end do
    case (474)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 5*iymx**3*sq15*z/sq2
          sqy(ig,2,3) = -5*ci*iymx**3*sq15*z/sq2
          sqy(ig,3,3) = (-5.0d0)*iymx**4*sq15/(4.0d0*sq2)
       end do
    case (475)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx**2*sq10
          sqy(ig,2,2) = ci*iymx**2*sq10
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-5.0d0)*iymx**2*sq5*(3*z-1)*(3*z+1)/(4.0d0*sq2)
          sqy(ig,2,3) = 5.0d0*ci*iymx**2*sq5*(3*z-1)*(3*z+1)/(4.0d0*sq2)
          sqy(ig,3,3) = 15.0d0*iymx**3*sq5*z/(2.0d0*sq2)
       end do
    case (476)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq5*z/sq2
          sqy(ig,2,2) = -ci*iymx*sq5*z/sq2
          sqy(ig,3,2) = -iymx**2*sq5/sq2/2.0d0
          sqy(ig,1,3) = 5.0d0*iymx*sq5*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,2,3) = (-5.0d0)*ci*iymx*sq5*z*(3*z**2-1)/(2.0d0*sq2)
          sqy(ig,3,3) = (-5.0d0)*iymx**2*sq5*(3*z-1)*(3*z+1)/(4.0d0*sq2)
       end do
    case (477)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 6.0d0*sq6/(7.0d0*sq5)
          sqy(ig,2,1) = (-6.0d0)*ci*sq6/(7.0d0*sq5)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (5*z**2-1)/sq30/2.0d0
          sqy(ig,2,2) = -ci*(5*z**2-1)/sq30/2.0d0
          sqy(ig,3,2) = -5*iymx*z/sq30
          sqy(ig,1,3) = (-5.0d0)*sq5*(21*z**4-14*z**2+1)/(28.0d0*sq6)
          sqy(ig,2,3) = 5.0d0*ci*sq5*(21*z**4-14*z**2+1)/(28.0d0*sq6)
          sqy(ig,3,3) = 5*iymx*sq5*z*(3*z**2-1)/sq6
       end do
    case (478)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 25.0d0*iymx**4*sq6/16.0d0
          sqy(ig,2,3) = (-25.0d0)*ci*iymx**4*sq6/16.0d0
          sqy(ig,3,3) = 0
       end do
    case (479)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-5.0d0)*iymx**3*sq30*z/2.0d0
          sqy(ig,2,3) = 5.0d0*ci*iymx**3*sq30*z/2.0d0
          sqy(ig,3,3) = 5.0d0*iymx**4*sq30/8.0d0
       end do
    case (480)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx**2*sq15/4.0d0
          sqy(ig,2,2) = -ci*iymx**2*sq15/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 5.0d0*iymx**2*sq15*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*iymx**2*sq15*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,3,3) = (-15.0d0)*iymx**3*sq15*z/4.0d0
       end do
    case (481)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq5*z/sq3
          sqy(ig,2,2) = -ci*iymx*sq5*z/sq3
          sqy(ig,3,2) = -iymx**2*sq5/sq3/2.0d0
          sqy(ig,1,3) = -5*iymx*sq5*z*(3*z**2-1)/sq3
          sqy(ig,2,3) = 5*ci*iymx*sq5*z*(3*z**2-1)/sq3
          sqy(ig,3,3) = 5.0d0*iymx**2*sq5*(3*z-1)*(3*z+1)/(2.0d0*sq3)
       end do
    case (482)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-27.0d0)/(7.0d0*sq30)
          sqy(ig,2,1) = 27.0d0*ci/(7.0d0*sq30)
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-7.0d0)*(5*z**2-1)/(2.0d0*sq30)
          sqy(ig,2,2) = 7.0d0*ci*(5*z**2-1)/(2.0d0*sq30)
          sqy(ig,3,2) = 35*iymx*z/sq30
          sqy(ig,1,3) = 25.0d0*sq5*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,2,3) = (-25.0d0)*ci*sq5*(21*z**4-14*z**2+1)/(56.0d0*sq6)
          sqy(ig,3,3) = (-25.0d0)*iymx*sq5*z*(3*z**2-1)/(2.0d0*sq6)
       end do
    case (483)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 3.0d0*sq6/7.0d0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -sq6*(5*z**2-1)
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 75.0d0*(21*z**4-14*z**2+1)/(28.0d0*sq6)
       end do
    case (484)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-125.0d0)*iymx**4*sq6*z/16.0d0
          sqy(ig,2,4) = 125.0d0*ci*iymx**4*sq6*z/16.0d0
          sqy(ig,3,4) = 25.0d0*iymx**5*sq6/16.0d0
       end do
    case (485)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iymx**3*sq30/11.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*iymx**3*sq30/11.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 25.0d0*iymx**3*sq15*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,2,4) = (-25.0d0)*ci*iymx**3*sq15*(11*z**2-1)/(22.0d0*sq2)
          sqy(ig,3,4) = (-25.0d0)*iymx**4*sq15*z/(4.0d0*sq2)
       end do
    case (486)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-63.0d0)*iymx**2*sq15*z/44.0d0
          sqy(ig,2,3) = 63.0d0*ci*iymx**2*sq15*z/44.0d0
          sqy(ig,3,3) = 21.0d0*iymx**3*sq15/44.0d0
          sqy(ig,1,4) = (-75.0d0)*iymx**2*sq15*z*(11*z**2-3)/88.0d0
          sqy(ig,2,4) = 75.0d0*ci*iymx**2*sq15*z*(11*z**2-3)/88.0d0
          sqy(ig,3,4) = 75.0d0*iymx**3*sq15*(11*z**2-1)/88.0d0
       end do
    case (487)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-8.0d0)*iymx*sq5/(7.0d0*sq3)
          sqy(ig,2,2) = 8.0d0*ci*iymx*sq5/(7.0d0*sq3)
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iymx*sq15*(7*z**2-1)/154.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*iymx*sq15*(7*z**2-1)/154.0d0
          sqy(ig,3,3) = (-9.0d0)*iymx**2*sq15*z/22.0d0
          sqy(ig,1,4) = 25.0d0*iymx*sq5*(33*z**4-18*z**2+1)/(44.0d0*sq3)
          sqy(ig,2,4) = (-25.0d0)*ci*iymx*sq5*(33*z**4-18*z**2+1)/(44.0d0*sq3)
          sqy(ig,3,4) = (-25.0d0)*iymx**2*sq15*z*(11*z**2-3)/22.0d0
       end do
    case (488)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 55.0d0*z/(7.0d0*sq30)
          sqy(ig,2,2) = (-55.0d0)*ci*z/(7.0d0*sq30)
          sqy(ig,3,2) = (-55.0d0)*iymx/(7.0d0*sq30)
          sqy(ig,1,3) = 9.0d0*sq30*z*(7*z**2-3)/308.0d0
          sqy(ig,2,3) = (-9.0d0)*ci*sq30*z*(7*z**2-3)/308.0d0
          sqy(ig,3,3) = (-27.0d0)*iymx*sq30*(7*z**2-1)/308.0d0
          sqy(ig,1,4) = (-25.0d0)*sq10*z*(33*z**4-30*z**2+5)/(176.0d0*sq3)
          sqy(ig,2,4) = 25.0d0*ci*sq10*z*(33*z**4-30*z**2+5)/(176.0d0*sq3)
          sqy(ig,3,4) = 125.0d0*iymx*sq10*(33*z**4-18*z**2+1)/(176.0d0*sq3)
       end do
    case (489)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 5.0d0*sq6*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 30.0d0*sq6*z*(7*z**2-3)/77.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-75.0d0)*z*(33*z**4-30*z**2+5)/(44.0d0*sq6)
       end do
    case (490)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-15.0d0)*iymx**5*sq7/8.0d0
          sqy(ig,2,4) = 15.0d0*ci*iymx**5*sq7/8.0d0
          sqy(ig,3,4) = 0
       end do
    case (491)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 75.0d0*iymx**4*z/4.0d0
          sqy(ig,2,4) = (-75.0d0)*ci*iymx**4*z/4.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**5/4.0d0
       end do
    case (492)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-15.0d0)*iymx**3*sq3/22.0d0
          sqy(ig,2,3) = 15.0d0*ci*iymx**3*sq3/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-85.0d0)*iymx**3*sq3*(11*z**2-1)/44.0d0
          sqy(ig,2,4) = 85.0d0*ci*iymx**3*sq3*(11*z**2-1)/44.0d0
          sqy(ig,3,4) = 85.0d0*iymx**4*sq3*z/8.0d0
       end do
    case (493)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 15.0d0*iymx**2*sq5*z*(11*z**2-3)/8.0d0
          sqy(ig,2,4) = (-15.0d0)*ci*iymx**2*sq5*z*(11*z**2-3)/8.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**3*sq5*(11*z**2-1)/8.0d0
       end do
    case (494)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iymx*sq5/7.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iymx*sq5/7.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 45.0d0*iymx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,2,3) = (-45.0d0)*ci*iymx*sq5*(7*z**2-1)/154.0d0
          sqy(ig,3,3) = (-45.0d0)*iymx**2*sq5*z/22.0d0
          sqy(ig,1,4) = (-45.0d0)*iymx*sq5*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,2,4) = 45.0d0*ci*iymx*sq5*(33*z**4-18*z**2+1)/88.0d0
          sqy(ig,3,4) = 135.0d0*iymx**2*sq5*z*(11*z**2-3)/44.0d0
       end do
    case (495)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-10.0d0)*z/(7.0d0*sq3)
          sqy(ig,2,2) = 10.0d0*ci*z/(7.0d0*sq3)
          sqy(ig,3,2) = 10.0d0*iymx/(7.0d0*sq3)
          sqy(ig,1,3) = (-75.0d0)*sq3*z*(7*z**2-3)/154.0d0
          sqy(ig,2,3) = 75.0d0*ci*sq3*z*(7*z**2-3)/154.0d0
          sqy(ig,3,3) = 225.0d0*iymx*sq3*(7*z**2-1)/154.0d0
          sqy(ig,1,4) = 10.0d0*z*(33*z**4-30*z**2+5)/(11.0d0*sq3)
          sqy(ig,2,4) = (-10.0d0)*ci*z*(33*z**4-30*z**2+5)/(11.0d0*sq3)
          sqy(ig,3,4) = (-50.0d0)*iymx*(33*z**4-18*z**2+1)/(11.0d0*sq3)
       end do
    case (496)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 5.0d0*z/7.0d0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = (-675.0d0)*z*(7*z**2-3)/154.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 185.0d0*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case (497)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
       end do
    case (498)
       mll3 = 1
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = (-3.0d0)*iymx**2*sq35/4.0d0
          sqy(ig,2,1) = 3.0d0*ci*iymx**2*sq35/4.0d0
          sqy(ig,3,1) = 0
       end do
    case (499)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx**3*sq35
          sqy(ig,2,2) = ci*iymx**3*sq35
          sqy(ig,3,2) = 0
       end do
    case (500)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 3.0d0*iymx**2*sq35*z/4.0d0
          sqy(ig,2,2) = (-3.0d0)*ci*iymx**2*sq35*z/4.0d0
          sqy(ig,3,2) = -iymx**3*sq35/4.0d0
       end do
    case (501)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
       end do
    case (502)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx**3*sq35/sq2
          sqy(ig,2,2) = -ci*iymx**3*sq35/sq2
          sqy(ig,3,2) = 0
       end do
    case (503)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = (-3.0d0)*iymx**2*sq35*z/(2.0d0*sq2)
          sqy(ig,2,2) = 3.0d0*ci*iymx**2*sq35*z/(2.0d0*sq2)
          sqy(ig,3,2) = iymx**3*sq35/sq2/2.0d0
       end do
    case (504)
       mll3 = 2
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -3*iymx*sq15/sq14
          sqy(ig,2,1) = 3*ci*iymx*sq15/sq14
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq15*(7*z**2-1)/sq14/2.0d0
          sqy(ig,2,2) = -ci*iymx*sq15*(7*z**2-1)/sq14/2.0d0
          sqy(ig,3,2) = -iymx**2*sq210*z/4.0d0
       end do
    case (505)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 5.0d0*iymx**4*sq210/8.0d0
          sqy(ig,2,3) = (-5.0d0)*ci*iymx**4*sq210/8.0d0
          sqy(ig,3,3) = 0
       end do
    case (506)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -3*iymx**3*sq35*z/sq2
          sqy(ig,2,3) = 3*ci*iymx**3*sq35*z/sq2
          sqy(ig,3,3) = 3.0d0*iymx**4*sq35/(4.0d0*sq2)
       end do
    case (507)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -iymx**2*sq35/sq2/2.0d0
          sqy(ig,2,2) = ci*iymx**2*sq35/sq2/2.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = iymx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,2,3) = -ci*iymx**2*sq35*(3*z-1)*(3*z+1)/sq2/4.0d0
          sqy(ig,3,3) = (-3.0d0)*iymx**3*sq35*z/(2.0d0*sq2)
       end do
    case (508)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx*sq35*z/sq6
          sqy(ig,2,2) = -ci*iymx*sq35*z/sq6
          sqy(ig,3,2) = -iymx**2*sq35/sq6/2.0d0
          sqy(ig,1,3) = -iymx*sq35*z*(3*z**2-1)/sq6/2.0d0
          sqy(ig,2,3) = ci*iymx*sq35*z*(3*z**2-1)/sq6/2.0d0
          sqy(ig,3,3) = iymx**2*sq35*(3*z-1)*(3*z+1)/sq6/4.0d0
       end do
    case (509)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
       end do
    case (510)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-5.0d0)*iymx**4*sq210/16.0d0
          sqy(ig,2,3) = 5.0d0*ci*iymx**4*sq210/16.0d0
          sqy(ig,3,3) = 0
       end do
    case (511)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = iymx**3*sq105*z
          sqy(ig,2,3) = -ci*iymx**3*sq105*z
          sqy(ig,3,3) = -iymx**4*sq105/4.0d0
       end do
    case (512)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = iymx**2*sq105/4.0d0
          sqy(ig,2,2) = -ci*iymx**2*sq105/4.0d0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = -iymx**2*sq105*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,2,3) = ci*iymx**2*sq105*(3*z-1)*(3*z+1)/8.0d0
          sqy(ig,3,3) = 3.0d0*iymx**3*sq105*z/4.0d0
       end do
    case (513)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -2*iymx*sq35*z/sq6
          sqy(ig,2,2) = 2*ci*iymx*sq35*z/sq6
          sqy(ig,3,2) = iymx**2*sq35/sq6
          sqy(ig,1,3) = iymx*sq35*z*(3*z**2-1)/sq6
          sqy(ig,2,3) = -ci*iymx*sq35*z*(3*z**2-1)/sq6
          sqy(ig,3,3) = -iymx**2*sq35*(3*z-1)*(3*z+1)/sq6/2.0d0
       end do
    case (514)
       mll3 = 3
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = -9/sq42
          sqy(ig,2,1) = 9*ci/sq42
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = sq7*(5*z**2-1)/sq6/2.0d0
          sqy(ig,2,2) = -ci*sq7*(5*z**2-1)/sq6/2.0d0
          sqy(ig,3,2) = -5*iymx*sq7*z/sq6
          sqy(ig,1,3) = (-5.0d0)*(21*z**4-14*z**2+1)/(8.0d0*sq42)
          sqy(ig,2,3) = 5.0d0*ci*(21*z**4-14*z**2+1)/(8.0d0*sq42)
          sqy(ig,3,3) = 35.0d0*iymx*z*(3*z**2-1)/(2.0d0*sq42)
       end do
    case (515)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-15.0d0)*iymx**5*sq42/8.0d0
          sqy(ig,2,4) = 15.0d0*ci*iymx**5*sq42/8.0d0
          sqy(ig,3,4) = 0
       end do
    case (516)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 25.0d0*iymx**4*sq210*z/16.0d0
          sqy(ig,2,4) = (-25.0d0)*ci*iymx**4*sq210*z/16.0d0
          sqy(ig,3,4) = (-5.0d0)*iymx**5*sq210/16.0d0
       end do
    case (517)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 3.0d0*iymx**3*sq105/11.0d0
          sqy(ig,2,3) = (-3.0d0)*ci*iymx**3*sq105/11.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-5.0d0)*iymx**3*sq105*(11*z**2-1)/22.0d0
          sqy(ig,2,4) = 5.0d0*ci*iymx**3*sq105*(11*z**2-1)/22.0d0
          sqy(ig,3,4) = 5.0d0*iymx**4*sq105*z/4.0d0
       end do
    case (518)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-27.0d0)*iymx**2*sq105*z/44.0d0
          sqy(ig,2,3) = 27.0d0*ci*iymx**2*sq105*z/44.0d0
          sqy(ig,3,3) = 9.0d0*iymx**3*sq105/44.0d0
          sqy(ig,1,4) = 15.0d0*iymx**2*sq105*z*(11*z**2-3)/88.0d0
          sqy(ig,2,4) = (-15.0d0)*ci*iymx**2*sq105*z*(11*z**2-3)/88.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**3*sq105*(11*z**2-1)/88.0d0
       end do
    case (519)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -2*iymx*sq5/sq42
          sqy(ig,2,2) = 2*ci*iymx*sq5/sq42
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 9.0d0*iymx*sq15*(7*z**2-1)/(11.0d0*sq14)
          sqy(ig,2,3) = (-9.0d0)*ci*iymx*sq15*(7*z**2-1)/(11.0d0*sq14)
          sqy(ig,3,3) = (-9.0d0)*iymx**2*sq210*z/22.0d0
          sqy(ig,1,4) = (-5.0d0)*iymx*sq35*(33*z**4-18*z**2+1)/(44.0d0*sq6)
          sqy(ig,2,4) = 5.0d0*ci*iymx*sq35*(33*z**4-18*z**2+1)/(44.0d0*sq6)
          sqy(ig,3,4) = 15.0d0*iymx**2*sq35*z*(11*z**2-3)/(22.0d0*sq6)
       end do
    case (520)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5*z/sq42
          sqy(ig,2,2) = -5*ci*z/sq42
          sqy(ig,3,2) = -5*iymx/sq42
          sqy(ig,1,3) = (-15.0d0)*sq6*z*(7*z**2-3)/(44.0d0*sq7)
          sqy(ig,2,3) = 15.0d0*ci*sq6*z*(7*z**2-3)/(44.0d0*sq7)
          sqy(ig,3,3) = 45.0d0*iymx*sq6*(7*z**2-1)/(44.0d0*sq7)
          sqy(ig,1,4) = 5.0d0*sq7*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
          sqy(ig,2,4) = (-5.0d0)*ci*sq7*z*(33*z**4-30*z**2+5)/(88.0d0*sq6)
          sqy(ig,3,4) = (-25.0d0)*iymx*sq7*(33*z**4-18*z**2+1)/(88.0d0*sq6)
       end do
    case (521)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = 0
       end do
    case (522)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 15.0d0*iymx**5*sq7/8.0d0
          sqy(ig,2,4) = (-15.0d0)*ci*iymx**5*sq7/8.0d0
          sqy(ig,3,4) = 0
       end do
    case (523)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = (-25.0d0)*iymx**4*sq21*z/8.0d0
          sqy(ig,2,4) = 25.0d0*ci*iymx**4*sq21*z/8.0d0
          sqy(ig,3,4) = 5.0d0*iymx**5*sq21/8.0d0
       end do
    case (524)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-9.0d0)*iymx**3*sq35/22.0d0
          sqy(ig,2,3) = 9.0d0*ci*iymx**3*sq35/22.0d0
          sqy(ig,3,3) = 0
          sqy(ig,1,4) = 15.0d0*iymx**3*sq35*(11*z**2-1)/44.0d0
          sqy(ig,2,4) = (-15.0d0)*ci*iymx**3*sq35*(11*z**2-1)/44.0d0
          sqy(ig,3,4) = (-15.0d0)*iymx**4*sq35*z/8.0d0
       end do
    case (525)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = 27.0d0*iymx**2*sq35*z/22.0d0
          sqy(ig,2,3) = (-27.0d0)*ci*iymx**2*sq35*z/22.0d0
          sqy(ig,3,3) = (-9.0d0)*iymx**3*sq35/22.0d0
          sqy(ig,1,4) = (-15.0d0)*iymx**2*sq35*z*(11*z**2-3)/44.0d0
          sqy(ig,2,4) = 15.0d0*ci*iymx**2*sq35*z*(11*z**2-3)/44.0d0
          sqy(ig,3,4) = 15.0d0*iymx**3*sq35*(11*z**2-1)/44.0d0
       end do
    case (526)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 5*iymx/sq21
          sqy(ig,2,2) = -5*ci*iymx/sq21
          sqy(ig,3,2) = 0
          sqy(ig,1,3) = (-45.0d0)*iymx*sq3*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,2,3) = 45.0d0*ci*iymx*sq3*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,3,3) = 45.0d0*iymx**2*sq21*z/22.0d0
          sqy(ig,1,4) = 25.0d0*iymx*sq7*(33*z**4-18*z**2+1)/(88.0d0*sq3)
          sqy(ig,2,4) = (-25.0d0)*ci*iymx*sq7*(33*z**4-18*z**2+1)/(88.0d0*sq3)
          sqy(ig,3,4) = (-25.0d0)*iymx**2*sq21*z*(11*z**2-3)/44.0d0
       end do
    case (527)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = -5*z/sq7
          sqy(ig,2,2) = 5*ci*z/sq7
          sqy(ig,3,2) = 5*iymx/sq7
          sqy(ig,1,3) = 45.0d0*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,2,3) = (-45.0d0)*ci*z*(7*z**2-3)/(22.0d0*sq7)
          sqy(ig,3,3) = (-135.0d0)*iymx*(7*z**2-1)/(22.0d0*sq7)
          sqy(ig,1,4) = (-5.0d0)*sq7*z*(33*z**4-30*z**2+5)/88.0d0
          sqy(ig,2,4) = 5.0d0*ci*sq7*z*(33*z**4-30*z**2+5)/88.0d0
          sqy(ig,3,4) = 25.0d0*iymx*sq7*(33*z**4-18*z**2+1)/88.0d0
       end do
    case (528)
       mll3 = 4
       do ig=ist,nkc
          x=gk(1,ig)
          y=gk(2,ig)
          z=gk(3,ig)
          r=gk(4,ig)
          x=x/r
          y=y/r
          z=z/r
          iypx=dcmplx(x,y)
          iymx=dcmplx(-x,y)
          sqy(ig,1,1) = 0
          sqy(ig,2,1) = 0
          sqy(ig,3,1) = 0
          sqy(ig,1,2) = 0
          sqy(ig,2,2) = 0
          sqy(ig,3,2) = -5*z
          sqy(ig,1,3) = 0
          sqy(ig,2,3) = 0
          sqy(ig,3,3) = 45.0d0*z*(7*z**2-3)/22.0d0
          sqy(ig,1,4) = 0
          sqy(ig,2,4) = 0
          sqy(ig,3,4) = (-35.0d0)*z*(33*z**4-30*z**2+5)/88.0d0
       end do
    case default
       write(6,*) 'getsqy_two() invalid k3 = ', k3
       stop
    end select

    if (ik3.lt.0) then
       sqy = conjg(sqy)
    end if
    return
  end subroutine getsqy_two_z

end module uspp_getqy
